# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTIBILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
# General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program. If not, see <http://www.gnu.org/licenses/>.

bl_info = {
    "name" : "SKLX creator",
    "author" : "sklx#1882", 
    "description" : "Addon importer for Illusion Games",
    "blender" : (3, 0, 0),
    "version" : (0, 5, 5),
    "location" : "",
    "warning" : "don't get horny",
    "doc_url": "", 
    "tracker_url": "", 
    "category" : "3D View" 
}


import bpy
import bpy.utils.previews
import os
import io
from pathlib import Path
import zipfile
from os import system
import datetime


addon_keymaps = {}
_icons = None


def sna_update_sna_render_select_8C133(self, context):
    sna_updated_prop = self.sna_render_select
    if sna_updated_prop:
        bpy.ops.object.select_by_type(type='MESH')
        for o in bpy.context.selected_objects:
            for m in o.modifiers:
                if(m.type == "SOLIDIFY"):
                    m.show_viewport = True
                    m.show_render = True
        bpy.ops.object.select_all(action='DESELECT')
        for scene in bpy.data.scenes:
            scene.render.engine = 'BLENDER_EEVEE'
    else:
        bpy.ops.object.select_by_type(type='MESH')
        for o in bpy.context.selected_objects:
            for m in o.modifiers:
                if(m.type == "SOLIDIFY"):
                    m.show_viewport = False
                    m.show_render = False
        bpy.ops.object.select_all(action='DESELECT')
        for scene in bpy.data.scenes:
            scene.render.engine = 'CYCLES'


_item_map = dict()


def make_enum_item(_id, name, descr, preview_id, uid):
    lookup = str(_id)+"\0"+str(name)+"\0"+str(descr)+"\0"+str(preview_id)+"\0"+str(uid)
    if not lookup in _item_map:
        _item_map[lookup] = (_id, name, descr, preview_id, uid)
    return _item_map[lookup]


def property_exists(prop_path, glob, loc):
    try:
        eval(prop_path, glob, loc)
        return True
    except:
        return False


def sna_update_sna_imporths_5A34A(self, context):
    sna_updated_prop = self.sna_imporths


class SNA_OT_Aisappenddata_E9553(bpy.types.Operator):
    bl_idname = "sna.aisappenddata_e9553"
    bl_label = "ais-append-data"
    bl_description = "Set the shaders to the ai shoujo character"
    bl_options = {"REGISTER", "UNDO"}

    @classmethod
    def poll(cls, context):
        return not False

    def execute(self, context):
        return {"FINISHED"}

    def invoke(self, context, event):
        return self.execute(context)


class SNA_OT_Animswapper_60950(bpy.types.Operator):
    bl_idname = "sna.animswapper_60950"
    bl_label = "anim-swapper"
    bl_description = ""
    bl_options = {"REGISTER", "UNDO"}

    @classmethod
    def poll(cls, context):
        return not False

    def execute(self, context):
        bpyobj = bpy.data.objects
        exec('')
        exec('')
        armature = '' + eval("bpy.data.scenes['Scene'].sna_charaselect.name") + ''
        animation_armature = '' + eval("bpy.data.scenes['Scene'].sna_animselect.name") + ''
        print(bpyobj[armature].name)
        print(bpyobj[animation_armature].name)
        skylar = bpyobj[armature].name
        vox = bpyobj[animation_armature].name
        character = bpy.data.objects[skylar]
        chara_anim = bpy.data.objects[vox]

        def set_animation():
            #this script will copy the animation data from the active Object to the selected object:
        #    armature = bpy.data.objects['Armature']
        #    animation_armature = bpy.data.objects['Armature.001']
            properties = [p.identifier for p in chara_anim.animation_data.bl_rna.properties if not p.is_readonly]
            if character.animation_data == None :
                character.animation_data_create()
            for prop in properties:
                setattr(character.animation_data, prop, getattr(chara_anim.animation_data, prop))
        set_animation()
        return {"FINISHED"}

    def invoke(self, context, event):
        return self.execute(context)


def sna_animationswapper_B5A72(layout_function, ):
    col_A5254 = layout_function.column(heading='', align=False)
    col_A5254.alert = False
    col_A5254.enabled = True
    col_A5254.active = True
    col_A5254.use_property_split = False
    col_A5254.use_property_decorate = False
    col_A5254.scale_x = 1.0
    col_A5254.scale_y = 1.0
    col_A5254.alignment = 'Expand'.upper()
    col_A5254.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
    row_0FE73 = col_A5254.row(heading='', align=True)
    row_0FE73.alert = False
    row_0FE73.enabled = True
    row_0FE73.active = True
    row_0FE73.use_property_split = False
    row_0FE73.use_property_decorate = False
    row_0FE73.scale_x = 1.0
    row_0FE73.scale_y = 1.0
    row_0FE73.alignment = 'Expand'.upper()
    row_0FE73.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
    row_0FE73.label(text='Character', icon_value=0)
    row_3113B = row_0FE73.row(heading='', align=False)
    row_3113B.alert = False
    row_3113B.enabled = True
    row_3113B.active = True
    row_3113B.use_property_split = False
    row_3113B.use_property_decorate = False
    row_3113B.scale_x = 1.0
    row_3113B.scale_y = 1.0
    row_3113B.alignment = 'Expand'.upper()
    row_3113B.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
    row_3113B.prop(bpy.context.scene, 'sna_charaselect', text='', icon_value=172, emboss=True)
    row_C8AF9 = col_A5254.row(heading='', align=True)
    row_C8AF9.alert = False
    row_C8AF9.enabled = True
    row_C8AF9.active = True
    row_C8AF9.use_property_split = False
    row_C8AF9.use_property_decorate = False
    row_C8AF9.scale_x = 1.0
    row_C8AF9.scale_y = 1.0
    row_C8AF9.alignment = 'Expand'.upper()
    row_C8AF9.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
    row_C8AF9.label(text='Animation', icon_value=0)
    row_44A3B = row_C8AF9.row(heading='', align=False)
    row_44A3B.alert = False
    row_44A3B.enabled = True
    row_44A3B.active = True
    row_44A3B.use_property_split = False
    row_44A3B.use_property_decorate = False
    row_44A3B.scale_x = 1.0
    row_44A3B.scale_y = 1.0
    row_44A3B.alignment = 'Expand'.upper()
    row_44A3B.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
    row_44A3B.prop(bpy.context.scene, 'sna_animselect', text='', icon_value=241, emboss=True)
    row_906F9 = col_A5254.row(heading='', align=True)
    row_906F9.alert = False
    row_906F9.enabled = True
    row_906F9.active = True
    row_906F9.use_property_split = False
    row_906F9.use_property_decorate = False
    row_906F9.scale_x = 1.0
    row_906F9.scale_y = 1.0
    row_906F9.alignment = 'Expand'.upper()
    row_906F9.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
    row_906F9.label(text='Set Animation', icon_value=0)
    op = row_906F9.operator('sna.animswapper_60950', text='SET', icon_value=0, emboss=True, depress=False)


class SNA_OT_Ecdataappend_E5571(bpy.types.Operator):
    bl_idname = "sna.ecdataappend_e5571"
    bl_label = "ec-data-append"
    bl_description = "Set the shaders to the emotion creator character"
    bl_options = {"REGISTER", "UNDO"}

    @classmethod
    def poll(cls, context):
        return not False

    def execute(self, context):
        return {"FINISHED"}

    def invoke(self, context, event):
        return self.execute(context)


class SNA_OT_Hdriworld_A4D8C(bpy.types.Operator):
    bl_idname = "sna.hdriworld_a4d8c"
    bl_label = "HDRI-WORLD"
    bl_description = "set a cool anime background to your scenes"
    bl_options = {"REGISTER", "UNDO"}

    @classmethod
    def poll(cls, context):
        return not False

    def execute(self, context):
        if (property_exists("bpy.data.images['sklx_HDRI_select_01.hdr']", globals(), locals()) or property_exists("bpy.data.images['sklx_HDRI_select_02.hdr']", globals(), locals()) or property_exists("bpy.data.images['sklx_HDRI_select_03.hdr']", globals(), locals()) or property_exists("bpy.data.images['sklx_HDRI_select_04.hdr']", globals(), locals()) or property_exists("bpy.data.images['sklx_HDRI_select_05.hdr']", globals(), locals()) or property_exists("bpy.data.images['sklx_HDRI_select_06.hdr']", globals(), locals()) or property_exists("bpy.data.images['sklx_HDRI_select_07.hdr']", globals(), locals()) or property_exists("bpy.data.images['sklx_HDRI_select_08.hdr']", globals(), locals()) or property_exists("bpy.data.images['sklx_HDRI_select_09.hdr']", globals(), locals()) or property_exists("bpy.data.images['sklx_HDRI_select_10.hdr']", globals(), locals())):
            pass
        else:
            before_data = list(bpy.data.images)
            bpy.ops.wm.append(directory=os.path.join(os.path.dirname(__file__), 'assets', 'resources.blend') + r'\Image', filename='sklx_HDRI_select_01.hdr', link=False)
            new_data = list(filter(lambda d: not d in before_data, list(bpy.data.images)))
            appended_3CC8E = None if not new_data else new_data[0]
            before_data = list(bpy.data.images)
            bpy.ops.wm.append(directory=os.path.join(os.path.dirname(__file__), 'assets', 'resources.blend') + r'\Image', filename='sklx_HDRI_select_02.hdr', link=False)
            new_data = list(filter(lambda d: not d in before_data, list(bpy.data.images)))
            appended_6CFA2 = None if not new_data else new_data[0]
            before_data = list(bpy.data.images)
            bpy.ops.wm.append(directory=os.path.join(os.path.dirname(__file__), 'assets', 'resources.blend') + r'\Image', filename='sklx_HDRI_select_03.hdr', link=False)
            new_data = list(filter(lambda d: not d in before_data, list(bpy.data.images)))
            appended_E6B5E = None if not new_data else new_data[0]
            before_data = list(bpy.data.images)
            bpy.ops.wm.append(directory=os.path.join(os.path.dirname(__file__), 'assets', 'resources.blend') + r'\Image', filename='sklx_HDRI_select_04.hdr', link=False)
            new_data = list(filter(lambda d: not d in before_data, list(bpy.data.images)))
            appended_BB9E1 = None if not new_data else new_data[0]
            before_data = list(bpy.data.images)
            bpy.ops.wm.append(directory=os.path.join(os.path.dirname(__file__), 'assets', 'resources.blend') + r'\Image', filename='sklx_HDRI_select_05.hdr', link=False)
            new_data = list(filter(lambda d: not d in before_data, list(bpy.data.images)))
            appended_C26B5 = None if not new_data else new_data[0]
            before_data = list(bpy.data.images)
            bpy.ops.wm.append(directory=os.path.join(os.path.dirname(__file__), 'assets', 'resources.blend') + r'\Image', filename='sklx_HDRI_select_06.hdr', link=False)
            new_data = list(filter(lambda d: not d in before_data, list(bpy.data.images)))
            appended_4BC0C = None if not new_data else new_data[0]
            before_data = list(bpy.data.images)
            bpy.ops.wm.append(directory=os.path.join(os.path.dirname(__file__), 'assets', 'resources.blend') + r'\Image', filename='sklx_HDRI_select_07.hdr', link=False)
            new_data = list(filter(lambda d: not d in before_data, list(bpy.data.images)))
            appended_93322 = None if not new_data else new_data[0]
            before_data = list(bpy.data.images)
            bpy.ops.wm.append(directory=os.path.join(os.path.dirname(__file__), 'assets', 'resources.blend') + r'\Image', filename='sklx_HDRI_select_08.hdr', link=False)
            new_data = list(filter(lambda d: not d in before_data, list(bpy.data.images)))
            appended_83BFC = None if not new_data else new_data[0]
            before_data = list(bpy.data.images)
            bpy.ops.wm.append(directory=os.path.join(os.path.dirname(__file__), 'assets', 'resources.blend') + r'\Image', filename='sklx_HDRI_select_09.hdr', link=False)
            new_data = list(filter(lambda d: not d in before_data, list(bpy.data.images)))
            appended_38981 = None if not new_data else new_data[0]
            before_data = list(bpy.data.images)
            bpy.ops.wm.append(directory=os.path.join(os.path.dirname(__file__), 'assets', 'resources.blend') + r'\Image', filename='sklx_HDRI_select_10.hdr', link=False)
            new_data = list(filter(lambda d: not d in before_data, list(bpy.data.images)))
            appended_4693E = None if not new_data else new_data[0]
        bpy.context.scene.world.use_nodes = True
        C = bpy.context
        scn = C.scene
        # Get the environment node tree of the current scene
        node_tree = scn.world.node_tree
        tree_nodes = node_tree.nodes
        # Clear all nodes
        tree_nodes.clear()
        # map range
        node_map_range = tree_nodes.new("ShaderNodeMapRange")
        bpy.data.worlds['World'].node_tree.nodes['Map Range'].inputs[2].default_value = 360
        bpy.data.worlds['World'].node_tree.nodes['Map Range'].inputs[4].default_value = 360
        node_map_range.location = -1700,250
        # add math node
        node_math = tree_nodes.new("ShaderNodeMath")
        bpy.data.worlds["World"].node_tree.nodes["Math"].operation = 'MULTIPLY'
        bpy.data.worlds["World"].node_tree.nodes["Math"].inputs[1].default_value = 6.2831853072
        node_math.location = -1400,250
        node_xyz = tree_nodes.new("ShaderNodeCombineXYZ")
        node_xyz.location = -1000,0
        node_xyz_light = tree_nodes.new("ShaderNodeCombineXYZ")
        node_xyz_light.location = -1000,400
        # Add Light Path
        node_light_path = tree_nodes.new("ShaderNodeLightPath")
        node_light_path.location = 0,900
        # Add Background node
        node_background = tree_nodes.new(type='ShaderNodeBackground')
        node_background_light = tree_nodes.new(type='ShaderNodeBackground')
        # power value
        HDRI1 = 1
        HDRI2 = 1.1
        HDRI3 = 10
        HDRI4 = 6.5
        HDRI5 = 2.6
        HDRI6 = 5.7
        HDRI7 = 0.48
        HDRI8 = 0.42
        HDRI9 = -1
        HDRI10 = 0.46
        exec('bpy.data.worlds["World"].node_tree.nodes["Background.001"].inputs[1].default_value =' + bpy.context.scene.sna_hdriselect)
        node_background_light.location = 0,500
        node_shader_mix = tree_nodes.new("ShaderNodeMixShader")
        node_shader_mix.location = 200,0
        #add tex_cord
        node_texcord = tree_nodes.new("ShaderNodeTexCoord")
        node_texcord.location = -700,0
        #add tex_cord_light
        node_texcord_light = tree_nodes.new("ShaderNodeTexCoord")
        node_texcord_light.location = -700,500
        #add mapping node
        node_mapping = tree_nodes.new(type="ShaderNodeMapping")
        node_mapping.location = -500,0
        #add mapping node light
        node_mapping_light = tree_nodes.new("ShaderNodeMapping")
        node_mapping_light.location = -500,500
        HDRI1 = 0.1
        HDRI2 = 1
        HDRI3 = 1
        HDRI4 = 1
        HDRI5 = 0.7
        HDRI6 = 1
        HDRI7 = -1
        HDRI8 = -0.36
        HDRI9 = 1.02
        HDRI10 = 0.36
        exec('bpy.data.worlds["World"].node_tree.nodes["Mapping.001"].inputs[3].default_value[2] =' + bpy.context.scene.sna_hdriselect)
        # Add Environment Texture node
        node_environment = tree_nodes.new('ShaderNodeTexEnvironment')
        # Load and assign the image to the node property
        HDRI1 = bpy.data.images.get("sklx_HDRI_select_01.hdr")
        HDRI2 = bpy.data.images.get("sklx_HDRI_select_02.hdr")
        HDRI3 = bpy.data.images.get("sklx_HDRI_select_03.hdr")
        HDRI4 = bpy.data.images.get("sklx_HDRI_select_04.hdr")
        HDRI5 = bpy.data.images.get("sklx_HDRI_select_05.hdr")
        HDRI6 = bpy.data.images.get("sklx_HDRI_select_06.hdr")
        HDRI7 = bpy.data.images.get("sklx_HDRI_select_07.hdr")
        HDRI8 = bpy.data.images.get("sklx_HDRI_select_08.hdr")
        HDRI9 = bpy.data.images.get("sklx_HDRI_select_09.hdr")
        HDRI10 = bpy.data.images.get("sklx_HDRI_select_10.hdr")
        exec('node_environment.image =' + bpy.context.scene.sna_hdriselect)
        node_environment.location = -300,0
        # Add Environment Texture node LIGHT
        node_environment_light = tree_nodes.new('ShaderNodeTexEnvironment')
        # Load and assign the image to the node property
        HDRI1 = bpy.data.images.get("sklx_HDRI_select_01.hdr")
        HDRI2 = bpy.data.images.get("sklx_HDRI_select_02.hdr")
        HDRI3 = bpy.data.images.get("sklx_HDRI_select_03.hdr")
        HDRI4 = bpy.data.images.get("sklx_HDRI_select_04.hdr")
        HDRI5 = bpy.data.images.get("sklx_HDRI_select_05.hdr")
        HDRI6 = bpy.data.images.get("sklx_HDRI_select_06.hdr")
        HDRI7 = bpy.data.images.get("sklx_HDRI_select_07.hdr")
        HDRI8 = bpy.data.images.get("sklx_HDRI_select_08.hdr")
        HDRI9 = bpy.data.images.get("sklx_HDRI_select_09.hdr")
        HDRI10 = bpy.data.images.get("sklx_HDRI_select_10.hdr")
        exec('node_environment_light.image =' + bpy.context.scene.sna_hdriselect)
        node_environment_light.location = -300,500
        # Add Output node
        node_output = tree_nodes.new(type='ShaderNodeOutputWorld')   
        node_output.location = 400,0
        # Link all nodes
        links = node_tree.links
        link = links.new(node_map_range.outputs["Result"], node_math.inputs[0])
        link = links.new(node_math.outputs["Value"], node_xyz.inputs[2])
        link = links.new(node_math.outputs["Value"], node_xyz_light.inputs[2])
        link = links.new(node_xyz.outputs["Vector"], node_mapping.inputs[2])
        link = links.new(node_xyz_light.outputs["Vector"], node_mapping_light.inputs[2])
        link = links.new(node_texcord.outputs["Generated"], node_mapping.inputs["Vector"])
        link = links.new(node_texcord_light.outputs["Generated"], node_mapping_light.inputs["Vector"])
        link = links.new(node_mapping.outputs["Vector"], node_environment.inputs["Vector"])
        link = links.new(node_mapping_light.outputs["Vector"], node_environment_light.inputs["Vector"])
        link = links.new(node_environment.outputs["Color"], node_background.inputs["Color"])
        link = links.new(node_environment_light.outputs["Color"], node_background_light.inputs["Color"])
        link = links.new(node_background.outputs["Background"], node_shader_mix.inputs[2])
        link = links.new(node_background_light.outputs["Background"], node_shader_mix.inputs[1])
        link = links.new(node_light_path.outputs[0], node_shader_mix.inputs[0])
        link = links.new(node_shader_mix.outputs[0], node_output.inputs[0])
        return {"FINISHED"}

    def invoke(self, context, event):
        return self.execute(context)


class SNA_OT_Hdrinon_3Ade4(bpy.types.Operator):
    bl_idname = "sna.hdrinon_3ade4"
    bl_label = "hdri-non"
    bl_description = "default world light"
    bl_options = {"REGISTER", "UNDO"}

    @classmethod
    def poll(cls, context):
        return not False

    def execute(self, context):
        bpy.context.scene.world.use_nodes = False
        C = bpy.context
        scn = C.scene
        # Get the environment node tree of the current scene
        node_tree = scn.world.node_tree
        tree_nodes = node_tree.nodes
        # Clear all nodes
        tree_nodes.clear()
        ## Add Background node
        #node_background = tree_nodes.new(type='ShaderNodeBackground')
        #bpy.data.worlds["World"].node_tree.nodes["Background"].inputs[1].default_value = 1
        #node_background.location = 0,0
        ## Add Output node
        #node_output = tree_nodes.new(type='ShaderNodeOutputWorld')   
        #node_output.location = 400,0
        ## Link all nodes
        #links = node_tree.links
        #link = links.new(node_background.outputs["Background"], node_output.inputs[0])
        return {"FINISHED"}

    def invoke(self, context, event):
        return self.execute(context)


class SNA_OT_Setilight_Cb95F(bpy.types.Operator):
    bl_idname = "sna.setilight_cb95f"
    bl_label = "set-i-light"
    bl_description = "add indirect light(only for mix bewteen cycles shader to eevee shader)"
    bl_options = {"REGISTER", "UNDO"}

    @classmethod
    def poll(cls, context):
        return not False

    def execute(self, context):
        bpy.ops.object.lightprobe_add(type='GRID', radius=1, enter_editmode=False, align='WORLD', location=(0, 0, 1), scale=(1, 1, 1))
        bpy.data.lightprobes['IrradianceVolume'].grid_resolution_x = 6
        bpy.data.lightprobes['IrradianceVolume'].grid_resolution_y = 6
        bpy.data.lightprobes['IrradianceVolume'].grid_resolution_z = 6
        bpy.data.lightprobes['IrradianceVolume'].influence_distance = 1
        bpy.context.scene.eevee.gi_cubemap_resolution = '2048'
        bpy.context.scene.eevee.gi_visibility_resolution = '64'
        bpy.ops.scene.light_cache_bake()
        return {"FINISHED"}

    def invoke(self, context, event):
        return self.execute(context)


class SNA_OT_Ibaker_Db364(bpy.types.Operator):
    bl_idname = "sna.ibaker_db364"
    bl_label = "i-baker"
    bl_description = "bake indirect light"
    bl_options = {"REGISTER", "UNDO"}

    @classmethod
    def poll(cls, context):
        return not False

    def execute(self, context):
        bpy.context.scene.eevee.gi_cubemap_resolution = '2048'
        bpy.context.scene.eevee.gi_visibility_resolution = '64'
        bpy.ops.scene.light_cache_bake()
        return {"FINISHED"}

    def invoke(self, context, event):
        return self.execute(context)


class SNA_OT_Unbaker_Eefe0(bpy.types.Operator):
    bl_idname = "sna.unbaker_eefe0"
    bl_label = "unbaker"
    bl_description = "clean indirect light data"
    bl_options = {"REGISTER", "UNDO"}

    @classmethod
    def poll(cls, context):
        return not False

    def execute(self, context):
        bpy.ops.scene.light_cache_free(True)
        return {"FINISHED"}

    def invoke(self, context, event):
        return self.execute(context)


class SNA_OT_Hsappenddata_E2120(bpy.types.Operator):
    bl_idname = "sna.hsappenddata_e2120"
    bl_label = "hs-append-data"
    bl_description = "Set the shaders to the honey select character"
    bl_options = {"REGISTER", "UNDO"}

    @classmethod
    def poll(cls, context):
        return not False

    def execute(self, context):
        #--- Eliminate Material Duplicates

        def eliminate_materials():
            print("\nEliminate Material Duplicates:")
            #--- Search for mat. slots in all objects
            mats = bpy.data.materials
            for obj in bpy.data.objects:
                for slot in obj.material_slots:
                    # Get the material name as 3-tuple (base, separator, extension)
                    (base, sep, ext) = slot.name.rpartition('.')
                    # Replace the numbered duplicate with the original if found
                    if ext.isnumeric():
                        if base in mats:
                            print("  For object '%s' replace '%s' with '%s'" % (obj.name, slot.name, base))
                            slot.material = mats.get(base)
        #--- Execute
        eliminate_materials()
        before_data = list(bpy.data.node_groups)
        bpy.ops.wm.append(directory=os.path.join(os.path.dirname(__file__), 'assets', 'HS1_Template_Shader.blend') + r'\NodeTree', filename='HS1-Template Face', link=False)
        new_data = list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
        appended_25688 = None if not new_data else new_data[0]
        before_data = list(bpy.data.node_groups)
        bpy.ops.wm.append(directory=os.path.join(os.path.dirname(__file__), 'assets', 'HS1_Template_Shader.blend') + r'\NodeTree', filename='HS1-Template Body', link=False)
        new_data = list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
        appended_EA2EE = None if not new_data else new_data[0]
        before_data = list(bpy.data.node_groups)
        bpy.ops.wm.append(directory=os.path.join(os.path.dirname(__file__), 'assets', 'HS1_Template_Shader.blend') + r'\NodeTree', filename='HS1-Template UnderHair', link=False)
        new_data = list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
        appended_1FC51 = None if not new_data else new_data[0]
        before_data = list(bpy.data.node_groups)
        bpy.ops.wm.append(directory=os.path.join(os.path.dirname(__file__), 'assets', 'HS1_Template_Shader.blend') + r'\NodeTree', filename='HS1-Template Front Hair', link=False)
        new_data = list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
        appended_5247F = None if not new_data else new_data[0]
        before_data = list(bpy.data.node_groups)
        bpy.ops.wm.append(directory=os.path.join(os.path.dirname(__file__), 'assets', 'HS1_Template_Shader.blend') + r'\NodeTree', filename='HS1-Template Back Hair', link=False)
        new_data = list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
        appended_F3418 = None if not new_data else new_data[0]
        before_data = list(bpy.data.node_groups)
        bpy.ops.wm.append(directory=os.path.join(os.path.dirname(__file__), 'assets', 'HS1_Template_Shader.blend') + r'\NodeTree', filename='HS1-Template Eyebrows', link=False)
        new_data = list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
        appended_4A609 = None if not new_data else new_data[0]
        before_data = list(bpy.data.node_groups)
        bpy.ops.wm.append(directory=os.path.join(os.path.dirname(__file__), 'assets', 'HS1_Template_Shader.blend') + r'\NodeTree', filename='HS1-Template Eyelashes', link=False)
        new_data = list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
        appended_22FE8 = None if not new_data else new_data[0]
        before_data = list(bpy.data.node_groups)
        bpy.ops.wm.append(directory=os.path.join(os.path.dirname(__file__), 'assets', 'HS1_Template_Shader.blend') + r'\NodeTree', filename='HS1-Template HL', link=False)
        new_data = list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
        appended_1773F = None if not new_data else new_data[0]
        before_data = list(bpy.data.node_groups)
        bpy.ops.wm.append(directory=os.path.join(os.path.dirname(__file__), 'assets', 'HS1_Template_Shader.blend') + r'\NodeTree', filename='HS1-Template White Eye', link=False)
        new_data = list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
        appended_7EAC3 = None if not new_data else new_data[0]
        before_data = list(bpy.data.node_groups)
        bpy.ops.wm.append(directory=os.path.join(os.path.dirname(__file__), 'assets', 'HS1_Template_Shader.blend') + r'\NodeTree', filename='HS1-Template Pupil', link=False)
        new_data = list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
        appended_A18ED = None if not new_data else new_data[0]
        before_data = list(bpy.data.node_groups)
        bpy.ops.wm.append(directory=os.path.join(os.path.dirname(__file__), 'assets', 'HS1_Template_Shader.blend') + r'\NodeTree', filename='HS1-Template Kage', link=False)
        new_data = list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
        appended_7C76D = None if not new_data else new_data[0]
        before_data = list(bpy.data.node_groups)
        bpy.ops.wm.append(directory=os.path.join(os.path.dirname(__file__), 'assets', 'HS1_Template_Shader.blend') + r'\NodeTree', filename='HS1-Template Tooth', link=False)
        new_data = list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
        appended_3FF33 = None if not new_data else new_data[0]
        before_data = list(bpy.data.node_groups)
        bpy.ops.wm.append(directory=os.path.join(os.path.dirname(__file__), 'assets', 'HS1_Template_Shader.blend') + r'\NodeTree', filename='HS1-Template Tang', link=False)
        new_data = list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
        appended_DB1C4 = None if not new_data else new_data[0]
        before_data = list(bpy.data.node_groups)
        bpy.ops.wm.append(directory=os.path.join(os.path.dirname(__file__), 'assets', 'HS1_Template_Shader.blend') + r'\NodeTree', filename='HS1-Template Top', link=False)
        new_data = list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
        appended_32AF8 = None if not new_data else new_data[0]
        before_data = list(bpy.data.node_groups)
        bpy.ops.wm.append(directory=os.path.join(os.path.dirname(__file__), 'assets', 'HS1_Template_Shader.blend') + r'\NodeTree', filename='HS1-Template Pants', link=False)
        new_data = list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
        appended_E001C = None if not new_data else new_data[0]
        before_data = list(bpy.data.node_groups)
        bpy.ops.wm.append(directory=os.path.join(os.path.dirname(__file__), 'assets', 'HS1_Template_Shader.blend') + r'\NodeTree', filename='HS1-Template Fit', link=False)
        new_data = list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
        appended_CFD0A = None if not new_data else new_data[0]
        before_data = list(bpy.data.node_groups)
        bpy.ops.wm.append(directory=os.path.join(os.path.dirname(__file__), 'assets', 'HS1_Template_Shader.blend') + r'\NodeTree', filename='HS1-Template Shoes', link=False)
        new_data = list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
        appended_B01D9 = None if not new_data else new_data[0]
        before_data = list(bpy.data.node_groups)
        bpy.ops.wm.append(directory=os.path.join(os.path.dirname(__file__), 'assets', 'HS1_Template_Shader.blend') + r'\NodeTree', filename='HS1-Template Socks', link=False)
        new_data = list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
        appended_B3B68 = None if not new_data else new_data[0]
        before_data = list(bpy.data.node_groups)
        bpy.ops.wm.append(directory=os.path.join(os.path.dirname(__file__), 'assets', 'HS1_Template_Shader.blend') + r'\NodeTree', filename='HS1-Template Bra', link=False)
        new_data = list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
        appended_A7FA6 = None if not new_data else new_data[0]
        before_data = list(bpy.data.node_groups)
        bpy.ops.wm.append(directory=os.path.join(os.path.dirname(__file__), 'assets', 'HS1_Template_Shader.blend') + r'\NodeTree', filename='HS1-Template Short', link=False)
        new_data = list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
        appended_D1888 = None if not new_data else new_data[0]
        before_data = list(bpy.data.node_groups)
        bpy.ops.wm.append(directory=os.path.join(os.path.dirname(__file__), 'assets', 'HS1_Template_Shader.blend') + r'\NodeTree', filename='HS1-Template Gloves', link=False)
        new_data = list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
        appended_D6798 = None if not new_data else new_data[0]
        before_data = list(bpy.data.node_groups)
        bpy.ops.wm.append(directory=os.path.join(os.path.dirname(__file__), 'assets', 'HS1_Template_Shader.blend') + r'\NodeTree', filename='HS1-Template Scarf', link=False)
        new_data = list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
        appended_7445C = None if not new_data else new_data[0]
        before_data = list(bpy.data.node_groups)
        bpy.ops.wm.append(directory=os.path.join(os.path.dirname(__file__), 'assets', 'HS1_Template_Shader.blend') + r'\NodeTree', filename='HS1-Template Hat', link=False)
        new_data = list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
        appended_C2C90 = None if not new_data else new_data[0]
        before_data = list(bpy.data.node_groups)
        bpy.ops.wm.append(directory=os.path.join(os.path.dirname(__file__), 'assets', 'HS1_Template_Shader.blend') + r'\NodeTree', filename='HS1-Template Glass', link=False)
        new_data = list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
        appended_38F73 = None if not new_data else new_data[0]
        before_data = list(bpy.data.node_groups)
        bpy.ops.wm.append(directory=os.path.join(os.path.dirname(__file__), 'assets', 'HS1_Template_Shader.blend') + r'\NodeTree', filename='HS1-Template Lens', link=False)
        new_data = list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
        appended_28796 = None if not new_data else new_data[0]
        before_data = list(bpy.data.node_groups)
        bpy.ops.wm.append(directory=os.path.join(os.path.dirname(__file__), 'assets', 'HS1_Template_Shader.blend') + r'\NodeTree', filename='HS1-Template Nip', link=False)
        new_data = list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
        appended_0030B = None if not new_data else new_data[0]
        # for easily use of the addon and implementation of variety of name meshes
        # this is a list created for add more names
        #mods added:
        # Body names: #full koikatsu
        body1 = 'o_body_a'
        body2 = 'o_body_b'
        body3 = 'O_body_a'
        body4 = 'O_body_b'
        body5 = 'cf_O_body_00'
        body6 = 'cf_o_d_body_AP_new'
        body7 = 'cf_O_n_body_AP_new'
        body8 = 'cf_O_body_kimonoY'
        body9 = 'cf_O_body_kimonoY_nuge'
        body10 = 'cf_O_body_kimonogos'
        body11 = 'cf_O_body_kimonoGOS_N'
        body12 = 'cf_O_body_loose_burausu'
        body13 = 'cf_O_body_nuge_loose_burausu'
        body14 = 'cf_O_body_nuge_loose_burausu1'
        body15 = 'cf_O_body_loose_burausu_bura'
        body16 = 'cf_O_body_nuge_loose_burausu_bra'
        body17 = 'cf_O_body_loose_burausu_bra'
        body18 = 'cf_O_body_nuge_loose_burausu1_bra'
        body19 = 'o_body_b_maid'
        body20 = 'cf_O_body_pajama_d'
        body21 = 'cf_O_body_pajama_n'
        body22 = 'cf_O_body_RetroW'
        body23 = 'cf_O_body_RW_n'
        body24 = 'cf_O_body_waitress_N'
        body25 = 'cf_O_top_body_waitress'
        body26 = 'cf_O_body_wedding_d_03'
        body27 = 'cf_O_body_wedding_n3'
        body28 = 'o_ki_body_a'
        body29 = 'o_bodymiko1_a'
        body30 = 'o_bodymiko1_b'
        body31 = 'o_body_miko2_a'
        body32 = 'o_body_miko2_b'
        body33 = 'cf_O_body_gos'
        body34 = 'cf_O_body_gos_n'
        body35 = 'cf_O_body_wedding_d_03'
        body36 = 'cf_O_body_wedding_n3'
        body37 = 'o_sis1_body_a'
        body38 = 'o_sis1_body_b'
        body39 = 'cf_O_body_sailor_oneP_d'
        body40 = 'cf_O_body_sailor_oneP_n'
        body41 = 'o_body_idol1_a'
        body42 = 'o_body_idol1_b'
        body43 = 'o_body_kuno1_a'
        body44 = 'o_body_kuno1_b'
        body45 = 'cf_O_body_LA'
        body46 = 'cf_O_body_LA_n'
        body47 = 'o_body_robe1_a'
        body48 = 'o_body_robe1_b'
        body49 = 'o_robe2_body_a'
        body50 = 'o_robe2_body_b'
        body51 = 'o_body_tasuki_a'
        body52 = 'o_body_tasuki_b'
        body53 = 'o_yayoi_body'
        body54 = 'o_yayoi_body_b'
        body55 = 'cf_O_body_d_PN'
        body56 = 'cf_O_body_pn_n'
        body57 = 'cf_O_body_HM'
        body58 = 'cf_O_body_HM_n'
        body59 = 'cf_O_unc_a.01'
        body60 = 'cf_O_unc_a.02'
        body61 = 'cf_O_unc_B.01'
        body62 = 'cf_O_unc_B.02'
        body63 = 'O_body'
        body64 = 'O_mnpk'
        body65 = 'cm_mannequin'
        # Face names: #full koikatsu
        face1 = 'cf_O_head'
        face2 = 'cf_O_face'
        face3 = 'cf_mannequin_head'
        face4 = 'cf_O_face4'
        face5 = 'cf_O_face5'
        # Front Hair
        fronth1 = 'cf_O_hairfront04_00'
        fronth2 = 'cf_O_hairfront04_00_deprecated'
        fronth3 = 'cf_O_hairfront04_01'
        fronth4 = 'cf_O_hairfront04_01_deprecated'
        fronth5 = 'cf_O_hairfront07_02'
        fronth6 = 'cf_O_hairfront_17_00'
        fronth7 = 'cf_O_hairfront_17_00_deprecated'
        fronth8 = 'cf_O_hairfront_17_01'
        fronth9 = 'cf_O_hairfront_17_01_deprecated'
        fronth10 = 'cf_O_hairfront_17_02'
        fronth11 = 'cf_O_hairfront_17_02_deprecated'
        fronth12 = 'cf_O_hairfL_26_00'
        fronth13 = 'cf_O_hairfL_26_00_deprecated'
        fronth14 = 'cf_O_hairfL_26_01'
        fronth15 = 'cf_O_hairfL_26_01_deprecated'
        fronth16 = 'cf_O_hairfL_26_02'
        fronth17 = 'cf_O_hairfL_26_02_deprecated'
        fronth18 = 'cf_O_hairfR_26_00'
        fronth19 = 'cf_O_hairfR_26_00_deprecated'
        fronth20 = 'cf_O_hairfR_26_01'
        fronth21 = 'cf_O_hairfR_26_01_deprecated'
        fronth22 = 'cf_O_hairfR_26_02'
        fronth23 = 'cf_O_hairfR_26_02_deprecated'
        fronth24 = 'cf_O_hairfR_26_03'
        fronth25 = 'cf_O_hairfR_26_03_deprecated'
        fronth26 = 'A003_O_hairkiwa00'
        fronth27 = 'cf_O_hairfront_82_00'
        fronth28 = 'cf_O_hairfront_82_00_deprecated'
        fronth29 = 'cf_O_hairfront_82_01'
        fronth30 = 'cf_O_hairfront_82_01_deprecated'
        fronth31 = 'cf_O_hairfront_82_02'
        fronth32 = 'cf_O_hairfront_82_03'
        fronth33 = 'cf_O_hairfront_82_03_deprecated'
        fronth34 = 'cf_O_hairfront_82_04'
        fronth35 = 'cf_O_hairfront_82_04_deprecated'
        fronth36 = 'cf_O_hairfront_82_05'
        fronth37 = 'cf_O_hairfront_82_05_deprecated'
        fronth38 = 'O_hs_cf_hair_89_f_00'
        fronth39 = 'O_hs_cf_hair_89_f_00_deprecated'
        fronth40 = 'O_hs_cf_hair_89_f_01'
        fronth41 = 'O_hs_cf_hair_89_f_01_deprecated'
        fronth42 = 'O_hs_cf_hair_89_f_02'
        fronth43 = 'O_hs_cf_hair_89_f_02_deprecated'
        fronth44 = 'O_hs_cf_hair_89_f_03'
        fronth45 = 'O_hs_cf_hair_89_f_03_deprecated'
        fronth46 = 'O_hs_cf_hair_89_f_04'
        fronth47 = 'O_hs_cf_hair_89_f_04_deprecated'
        fronth48 = 'O_hs_cf_hair_89_f_05'
        fronth49 = 'O_hs_cf_hair_89_f_05_deprecated'
        fronth50 = 'O_hs_cf_hair_89_f_06'
        fronth51 = 'O_hs_cf_hair_89_f_06_deprecated'
        fronth52 = 'O_hs_cf_hair_89_f_07'
        fronth53 = 'O_hs_cf_hair_89_f_07_deprecated'
        fronth54 = 'cf_O_hairf_93_01'
        fronth55 = 'cf_O_hairf_93_01_deprecated'
        fronth56 = 'cf_O_hairf_93_02'
        fronth57 = 'cf_O_hairf_93_02_deprecated'
        fronth58 = 'cf_O_hairf_93_03'
        fronth59 = 'cf_O_hairf_93_03_deprecated'
        fronth60 = 'o_hair_0'
        fronth61 = 'o_hair_1'
        fronth62 = 'o_hair_2'
        fronth63 = 'o_hair_3'
        fronth64 = 'o_hair_4'
        fronth65 = 'o_u_hair_1'
        fronth66 = 'o_u_hair_2'
        fronth67 = 'o_u_hair_3'
        fronth68 = 'o_u_hair_4'
        fronth69 = 'o_hairF_0'
        fronth70 = 'o_hairF_01'
        fronth71 = 'o_hairF_1'
        fronth72 = 'o_hairF_2'
        fronth73 = 'o_hairF_3'
        fronth74 = 'o_hairF_8'
        fronth75 = 'o_hairF_9'
        fronth76 = 'o_u_hairF_0'
        fronth77 = 'o_u_hairF_01'
        fronth78 = 'o_u_hairF_1'
        fronth79 = 'o_u_hairF_2'
        fronth80 = 'o_u_hairF_3'
        fronth81 = 'o_u_hairF_8'
        fronth82 = 'o_u_hairF_9'
        fronth83 = 'cf_O_hairfront_97_00'
        fronth84 = 'cf_O_hairfront_97_00_deprecated'
        fronth85 = 'cf_O_hairfront_97_01'
        fronth86 = 'cf_O_hairfront_97_01_deprecated'
        fronth87 = 'cf_O_hairfront_97_02'
        fronth88 = 'cf_O_hairfront_97_02_deprecated'
        fronth89 = 'cf_O_hairfront_97_03'
        fronth90 = 'cf_O_hairfront_97_03_deprecated'
        fronth91 = 'cf_O_hairfront_97_04'
        fronth92 = 'cf_O_hairfront_97_04_deprecated'
        fronth93 = 'cf_O_hairfront_97_05'
        fronth94 = 'cf_O_hairfront_97_05_deprecated'
        fronth95 = 'cf_O_hairfront_97_06'
        fronth96 = 'cf_O_hairfront_97_06_deprecated'
        fronth97 = 'cf_O_hairfront_97_07'
        fronth98 = 'cf_O_hairfront_97_07_deprecated'
        fronth99 = 'cf_O_hairfront_97_08'
        fronth100 = 'cf_O_hairfront_97_08_deprecated'
        fronth101 = 'cf_O_hairfront_97_09'
        fronth102 = 'cf_O_hairfront_97_09_deprecated'
        fronth103 = 'cf_O_hairfront_97_10'
        fronth104 = 'cf_O_hairfront_97_10_deprecated'
        fronth105 = 'cf_O_hairfront_97_11'
        fronth106 = 'cf_O_hairfront_97_11_deprecated'
        fronth107 = 'cf_O_hairfront00'
        fronth108 = 'cf_O_hairfront00_deprecated'
        fronth109 = 'cf_O_hairfront01_00'
        fronth110 = 'cf_O_hairfront01_00_deprecated'
        fronth111 = 'cf_O_hairfront03_00'
        fronth112 = 'cf_O_hairfront03_00_deprecated'
        fronth113 = 'cf_O_hairfront05_00'
        fronth114 = 'cf_O_hairfront05_01'
        fronth115 = 'cf_O_hair_f06_00'
        fronth116 = 'cf_O_hair_s06_00'
        fronth117 = 'cf_O_hair_s06_00_deprecated'
        fronth118 = 'cf_O_hair_s06_01'
        fronth119 = 'cf_O_hair_s06_01_deprecated'
        fronth120 = 'cf_O_hair_s06_02'
        fronth121 = 'cf_O_hair_s06_02_deprecated'
        fronth122 = 'cf_O_hair_s06_03'
        fronth123 = 'cf_O_hair_s06_03_deprecated'
        fronth124 = 'cf_O_hairfront_08_00'
        fronth125 = 'cf_O_hairfront_08_00_deprecated'
        fronth126 = 'cf_O_hairfront_08_01'
        fronth127 = 'cf_O_hairfront_08_01_deprecated'
        fronth128 = 'cf_O_hairfront_09_00'
        fronth129 = 'cf_O_hairfront_09_00_deprecated'
        fronth130 = 'cf_O_hairfront_09_01'
        fronth131 = 'cf_O_hairfront_09_01_deprecated'
        fronth132 = 'cf_O_hairfront10_00'
        fronth133 = 'cf_O_hairfront10_00_deprecated'
        fronth134 = 'cf_O_hairfront10_01'
        fronth135 = 'cf_O_hairfront_11_00'
        fronth136 = 'cf_O_hairfront_11_00_deprecated'
        fronth137 = 'cf_O_hairfront_11_01'
        fronth138 = 'cf_O_hairfront_11_01_deprecated'
        fronth139 = 'cf_O_hairfront_11_02'
        fronth140 = 'cf_O_hairfront_11_02_deprecated'
        fronth141 = 'cf_O_hairfront_11_03'
        fronth142 = 'cf_O_hairfront_11_03_deprecated'
        fronth143 = 'cf_O_hairfront_11_04'
        fronth144 = 'cf_O_hairfront_11_04_deprecated'
        fronth145 = 'cf_O_hairfront_11_05'
        fronth146 = 'cf_O_hairfront_11_05_deprecated'
        fronth147 = 'cf_O_hairfront_11_06'
        fronth148 = 'cf_O_hairfront_11_06_deprecated'
        fronth149 = 'cf_O_hairfront_11_07'
        fronth150 = 'cf_O_hairfront_11_07_deprecated'
        fronth151 = 'cf_O_hairfront_11_08'
        fronth152 = 'cf_O_hairfront_11_08_deprecated'
        fronth153 = 'cf_O_hairfront_12_00'
        fronth154 = 'cf_O_hairfront_12_00_deprecated'
        fronth155 = 'cf_O_hairfront_12_01'
        fronth156 = 'cf_O_hairfront_12_01_deprecated'
        fronth157 = 'cf_O_hairfront_12_02'
        fronth158 = 'cf_O_hairfront_12_02_deprecated'
        fronth159 = 'cf_O_hairfront_13_00'
        fronth160 = 'cf_O_hairfront_13_00_deprecated'
        fronth161 = 'cf_O_hairfront_14_00'
        fronth162 = 'cf_O_hairfront_14_00_deprecated'
        fronth163 = 'cf_O_hairfront_15_00'
        fronth164 = 'cf_O_hairfront_15_00_deprecated'
        fronth165 = 'cf_O_hairfront_16_00'
        fronth166 = 'cf_O_hairfront_16_00_deprecated'
        fronth167 = 'cf_O_hairfront_18_00'
        fronth168 = 'cf_O_hairfront_18_00_deprecated'
        fronth169 = 'cf_O_hairfront_18_01'
        fronth170 = 'cf_O_hairfront_18_01_deprecated'
        fronth171 = 'cf_O_hairfront_20_01'
        fronth172 = 'cf_O_hairfront_20_01_deprecated'
        fronth173 = 'cf_O_hairfront_20_02'
        fronth174 = 'cf_O_hairfront_20_02_deprecated'
        fronth175 = 'cf_O_hairfront_20_03'
        fronth176 = 'cf_O_hairfront_20_03_deprecated'
        fronth177 = 'cf_O_hairfront_21_01'
        fronth178 = 'cf_O_hairfront_21_01_deprecated'
        fronth179 = 'cf_O_hairfront_21_02'
        fronth180 = 'cf_O_hairfront_21_02_deprecated'
        fronth181 = 'cf_O_hairfront_21_03'
        fronth182 = 'cf_O_hairfront_21_03_deprecated'
        fronth183 = 'cf_O_hairfront_21_04'
        fronth184 = 'cf_O_hairfront_21_04_deprecated'
        fronth185 = 'cf_O_hairfront_21_05'
        fronth186 = 'cf_O_hairfront_21_05_deprecated'
        fronth187 = 'cf_O_hairfront_21_06'
        fronth188 = 'cf_O_hairfront_21_06_deprecated'
        fronth189 = 'cf_O_hairfront_21_07'
        fronth190 = 'cf_O_hairfront_21_07_deprecated'
        fronth191 = 'cf_O_hairfront_22_01'
        fronth192 = 'cf_O_hairfront_22_01_deprecated'
        fronth193 = 'cf_O_hairfront_22_02'
        fronth194 = 'cf_O_hairfront_22_02_deprecated'
        fronth195 = 'cf_O_hairfront_22_03'
        fronth196 = 'cf_O_hairfront_22_03_deprecated'
        fronth197 = 'cf_O_hairfront_22_04'
        fronth198 = 'cf_O_hairfront_22_04_deprecated'
        fronth199 = 'hair24_f_L_01'
        fronth200 = 'hair24_f_L_01_deprecated'
        fronth201 = 'hair24_f_L_02'
        fronth202 = 'hair24_f_L_02_deprecated'
        fronth203 = 'hair24_f_L_03'
        fronth204 = 'hair24_f_L_03_deprecated'
        fronth205 = 'hair24_f_L_04'
        fronth206 = 'hair24_f_L_04_deprecated'
        fronth207 = 'hair24_f_L_05'
        fronth208 = 'hair24_f_L_05_deprecated'
        fronth209 = 'hair24_f_L_06'
        fronth210 = 'hair24_f_L_06_deprecated'
        fronth211 = 'hair24_f_R_01'
        fronth212 = 'hair24_f_R_01_deprecated'
        fronth213 = 'hair24_f_R_02'
        fronth214 = 'hair24_f_R_02_deprecated'
        fronth215 = 'hair24_f_R_03'
        fronth216 = 'hair24_f_R_03_deprecated'
        fronth217 = 'hair24_f_R_04'
        fronth218 = 'hair24_f_R_04_deprecated'
        fronth219 = 'hair24_f_R_05'
        fronth220 = 'hair24_f_R_05_deprecated'
        fronth221 = 'hair24_f_R_06'
        fronth222 = 'hair24_f_R_06_deprecated'
        fronth223 = 'cf_O_hairfront_25_00'
        fronth224 = 'cf_O_hairfront_25_00_deprecated'
        fronth225 = 'cf_O_hairfront_25_01'
        fronth226 = 'cf_O_hairfront_25_01_deprecated'
        fronth227 = 'cf_O_hairfront_25_02'
        fronth228 = 'cf_O_hairfront_25_02_deprecated'
        fronth229 = 'cf_O_hairfront_25_03'
        fronth230 = 'cf_O_hairfront_25_03_deprecated'
        fronth231 = 'cf_O_hairfront_25_04'
        fronth232 = 'cf_O_hairfront_25_04_deprecated'
        fronth233 = 'cf_O_hairfront_25_05'
        fronth234 = 'cf_O_hairfront_25_05_deprecated'
        fronth235 = 'cf_O_hairfront_28_00'
        fronth236 = 'cf_O_hairfront_28_00_deprecated'
        fronth237 = 'cf_O_hairfront_28_01'
        fronth238 = 'cf_O_hairfront_28_01_deprecated'
        fronth239 = 'cf_O_hairfront_28_02'
        fronth240 = 'cf_O_hairfront_28_02_deprecated'
        fronth241 = 'cf_O_hairfront_28_03'
        fronth242 = 'cf_O_hairfront_28_03_deprecated'
        fronth243 = 'cf_O_hairfront_28_04'
        fronth244 = 'cf_O_hairfront_28_04_deprecated'
        fronth245 = 'cf_O_hairfront_28_05'
        fronth246 = 'cf_O_hairfront_28_05_deprecated'
        fronth247 = 'cf_O_hairfront_28_06'
        fronth248 = 'cf_O_hairfront_28_06_deprecated'
        fronth249 = 'cf_O_hairfront_29_00'
        fronth250 = 'cf_O_hairfront_29_00_deprecated'
        fronth251 = 'cf_O_hairfront_30_00'
        fronth252 = 'cf_O_hairfront_30_00_deprecated'
        fronth253 = 'cf_O_hairfront_30_01'
        fronth254 = 'cf_O_hairfront_30_01_deprecated'
        fronth255 = 'cf_O_hairfront_30_02'
        fronth256 = 'cf_O_hairfront_30_02_deprecated'
        fronth257 = 'cf_O_hairfront_30_03'
        fronth258 = 'cf_O_hairfront_30_03_deprecated'
        fronth259 = 'cf_O_hairfront_30_04'
        fronth260 = 'cf_O_hairfront_30_04_deprecated'
        fronth261 = 'FK06_O_00'
        fronth262 = 'FK10_O_00'
        fronth263 = 'A017_O_hairF00'
        fronth264 = 'A017_O_hairF01'
        fronth265 = 'A017_O_hairF02'
        fronth266 = 'A017_O_hairF03'
        fronth267 = 'A017_O_hairFL00'
        fronth268 = 'A017_O_hairFR00'
        fronth269 = 'A019_O_hairF00'
        fronth270 = 'A019_O_hairFL00'
        fronth271 = 'A019_O_hairFR00'
        fronth272 = 'A019_O_hairFR01'
        fronth273 = 'cf_O_hairfront_83_00'
        fronth274 = 'cf_O_hairfront_83_00_deprecated'
        fronth275 = 'cf_O_hairfront_83_01'
        fronth276 = 'cf_O_hairfront_83_01_deprecated'
        fronth277 = 'cf_O_hairfront_83_02'
        fronth278 = 'cf_O_hairfront_83_02_deprecated'
        fronth279 = 'cf_O_hairfront_83_03'
        fronth280 = 'cf_O_hairfront_83_03_deprecated'
        fronth281 = 'cf_O_hairfront_83_04'
        fronth282 = 'cf_O_hairfront_83_04_deprecated'
        fronth283 = 'cf_O_hairfront_83_05'
        fronth284 = 'cf_O_hairfront_83_05_deprecated'
        fronth285 = 'cf_O_hairfront_83_06'
        fronth286 = 'cf_O_hairfront_83_06_deprecated'
        fronth287 = 'cf_O_hairfront_83_07'
        fronth288 = 'cf_O_hairfront_83_07_deprecated'
        fronth289 = 'cf_O_hairfront_83_08'
        fronth290 = 'cf_O_hairfront_83_08_deprecated'
        fronth291 = 'cf_O_hairfront_83_09'
        fronth292 = 'cf_O_hairfront_83_09_deprecated'
        fronth293 = 'cf_O_hairfront_83_10'
        fronth294 = 'cf_O_hairfront_83_10_deprecated'
        fronth295 = 'cf_O_hairfront_83_11'
        fronth296 = 'cf_O_hairfront_83_11_deprecated'
        fronth297 = 'cf_O_hairfront_83_12'
        fronth298 = 'cf_O_hairfront_83_12_deprecated'
        fronth299 = 'O_hs_cf_hair_84_f_00'
        fronth300 = 'O_hs_cf_hair_84_f_00_deprecated'
        fronth301 = 'O_hs_cf_hair_84_f_01'
        fronth302 = 'O_hs_cf_hair_84_f_01_deprecated'
        fronth303 = 'O_hs_cf_hair_84_f_02'
        fronth304 = 'O_hs_cf_hair_84_f_02_deprecated'
        fronth305 = 'O_hs_cf_hair_84_f_03'
        fronth306 = 'O_hs_cf_hair_84_f_03_deprecated'
        fronth307 = 'O_hs_cf_hair_84_f_04'
        fronth308 = 'O_hs_cf_hair_84_f_04_deprecated'
        fronth309 = 'O_hs_cf_hair_84_f_05'
        fronth310 = 'O_hs_cf_hair_84_f_05_deprecated'
        fronth311 = 'O_hs_cf_hair_84_f_06'
        fronth312 = 'O_hs_cf_hair_84_f_06_deprecated'
        fronth313 = 'O_hs_cf_hair_84_f_07'
        fronth314 = 'O_hs_cf_hair_84_f_07_deprecated'
        fronth315 = 'O_hs_cf_hair_84_f_08'
        fronth316 = 'O_hs_cf_hair_84_f_08_deprecated'
        fronth317 = 'O_hs_cf_hair_84_f_09'
        fronth318 = 'O_hs_cf_hair_84_f_09_deprecated'
        fronth319 = 'O_hs_cf_hair_84_f_10'
        fronth320 = 'O_hs_cf_hair_84_f_10_deprecated'
        fronth321 = 'O_hs_cf_hair_85_f_00'
        fronth322 = 'O_hs_cf_hair_85_f_00_deprecated'
        fronth323 = 'O_hs_cf_hair_85_f_01'
        fronth324 = 'O_hs_cf_hair_85_f_01_deprecated'
        fronth325 = 'O_hs_cf_hair_85_f_03'
        fronth326 = 'O_hs_cf_hair_85_f_03_deprecated'
        fronth327 = 'O_hs_cf_hair_85_f_04'
        fronth328 = 'O_hs_cf_hair_85_f_04_deprecated'
        fronth329 = 'O_hs_cf_hair_85_f_09'
        fronth330 = 'O_hs_cf_hair_85_f_09_deprecated'
        fronth331 = 'O_hs_cf_hair_85_f_10'
        fronth332 = 'O_hs_cf_hair_85_f_10_deprecated'
        fronth333 = 'O_hs_cf_hair_85_f_11'
        fronth334 = 'O_hs_cf_hair_85_f_11_deprecated'
        fronth335 = 'O_hs_cf_hair_85_f_12'
        fronth336 = 'O_hs_cf_hair_85_f_12_deprecated'
        fronth337 = 'O_hs_cf_hair_85_f_13'
        fronth338 = 'O_hs_cf_hair_85_f_13_deprecated'
        fronth339 = 'O_hs_cf_hair_85_f_14'
        fronth340 = 'O_hs_cf_hair_85_f_14_deprecated'
        fronth341 = 'O_hs_cf_hair_85_f_15'
        fronth342 = 'O_hs_cf_hair_85_f_15_deprecated'
        fronth343 = 'cf_O_hairfront_25_00'
        fronth344 = 'cf_O_hairfront_25_00_deprecated'
        fronth345 = 'cf_O_hairfront_25_01'
        fronth346 = 'cf_O_hairfront_25_01_deprecated'
        fronth347 = 'cf_O_hairfront_25_02'
        fronth348 = 'cf_O_hairfront_25_02_deprecated'
        fronth349 = 'cf_O_hairfront_25_03'
        fronth350 = 'cf_O_hairfront_25_03_deprecated'
        fronth351 = 'cf_O_hairfront_25_04'
        fronth352 = 'cf_O_hairfront_25_04_deprecated'
        fronth353 = 'cf_O_hairfront_25_05'
        fronth354 = 'cf_O_hairfront_25_05_deprecated'
        fronth355 = 'cf_O_hairfront_25_06'
        fronth356 = 'cf_O_hairfront_25_06_deprecated'
        fronth357 = 'cf_O_hairfront_25_07'
        fronth358 = 'cf_O_hairfront_25_07_deprecated'
        fronth359 = 'cf_O_hairfront_25_08'
        fronth360 = 'cf_O_hairfront_25_08_deprecated'
        fronth361 = 'cf_O_hairfront_25_09'
        fronth362 = 'cf_O_hairfront_25_09_deprecated'
        fronth363 = 'cf_O_hairfront_25_10'
        fronth364 = 'cf_O_hairfront_25_10_deprecated'
        fronth365 = 'cf_O_hairfront_25_11'
        fronth366 = 'cf_O_hairfront_25_11_deprecated'
        fronth367 = 'cf_O_hairfront_89_01'
        fronth368 = 'cf_O_hairfront_89_01_deprecated'
        fronth369 = 'cf_O_hairfront_89_02'
        fronth370 = 'cf_O_hairfront_89_02_deprecated'
        fronth371 = 'cf_O_hairfront_89_03'
        fronth372 = 'cf_O_hairfront_89_03_deprecated'
        fronth373 = 'cf_O_hairfront_89_04'
        fronth374 = 'cf_O_hairfront_89_04_deprecated'
        fronth375 = 'cf_O_hairfront_89_05'
        fronth376 = 'cf_O_hairfront_89_05_deprecated'
        fronth377 = 'cf_O_hairfront_89_06'
        fronth378 = 'cf_O_hairfront_89_06_deprecated'
        fronth379 = 'cf_O_hairfront_89_07'
        fronth380 = 'cf_O_hairfront_89_07_deprecated'
        fronth381 = 'cf_O_hairfront_89_08'
        fronth382 = 'cf_O_hairfront_89_08_deprecated'
        fronth383 = 'cf_O_hairfront_89_09'
        fronth384 = 'cf_O_hairfront_89_09_deprecated'
        fronth385 = 'cf_O_hairfront_89_10'
        fronth386 = 'cf_O_hairfront_89_10_deprecated'
        fronth387 = 'cf_O_hairfront_89_11'
        fronth388 = 'cf_O_hairfront_89_11_deprecated'
        fronth389 = 'cf_O_hairfront_89_12'
        fronth390 = 'cf_O_hairfront_89_12_deprecated'
        fronth391 = 'cf_O_hairfront_91_01'
        fronth392 = 'cf_O_hairfront_91_01_deprecated'
        fronth393 = 'cf_O_hairfront_91_02'
        fronth394 = 'cf_O_hairfront_91_02_deprecated'
        fronth395 = 'cf_O_hairfront_91_03'
        fronth396 = 'cf_O_hairfront_91_03_deprecated'
        fronth397 = 'cf_O_hairfront_91_04'
        fronth398 = 'cf_O_hairfront_91_04_deprecated'
        fronth399 = 'cf_O_hairfront_91_05'
        fronth400 = 'cf_O_hairfront_91_05_deprecated'
        fronth401 = 'cf_O_hairfront_91_06'
        fronth402 = 'cf_O_hairfront_91_06_deprecated'
        fronth403 = 'cf_O_hairfront_91_07'
        fronth404 = 'cf_O_hairfront_91_07_deprecated'
        fronth405 = 'cf_O_hairfront_91_08'
        fronth406 = 'cf_O_hairfront_91_08_deprecated'
        fronth407 = 'cf_O_hairfront_91_09'
        fronth408 = 'cf_O_hairfront_91_09_deprecated'
        fronth409 = 'cf_O_hairfront_91_10'
        fronth410 = 'cf_O_hairfront_91_10_deprecated'
        fronth411 = 'cf_O_hairfront_91_11'
        fronth412 = 'cf_O_hairfront_91_11_deprecated'
        fronth413 = 'cf_O_hairfront_91_12'
        fronth414 = 'cf_O_hairfront_91_12_deprecated'
        fronth415 = 'cf_O_hairfront_91_13'
        fronth416 = 'cf_O_hairfront_91_13_deprecated'
        fronth417 = 'cf_O_hairfront_91_14'
        fronth418 = 'cf_O_hairfront_91_14_deprecated'
        fronth419 = 'cf_O_hairfront_91_15'
        fronth420 = 'cf_O_hairfront_91_15_deprecated'
        fronth421 = 'cf_O_hairfront_91_16'
        fronth422 = 'cf_O_hairfront_91_16_deprecated'
        fronth423 = 'cf_O_hairfront_92_01'
        fronth424 = 'cf_O_hairfront_92_01_deprecated'
        fronth425 = 'cf_O_hairfront_92_02'
        fronth426 = 'cf_O_hairfront_92_02_deprecated'
        fronth427 = 'cf_O_hairfront_92_03'
        fronth428 = 'cf_O_hairfront_92_03_deprecated'
        fronth429 = 'cf_O_hairfront_92_04'
        fronth430 = 'cf_O_hairfront_92_04_deprecated'
        fronth431 = 'cf_O_hairfront_92_05'
        fronth432 = 'cf_O_hairfront_92_05_deprecated'
        fronth433 = 'cf_O_hairfront_92_06'
        fronth434 = 'cf_O_hairfront_92_06_deprecated'
        fronth435 = 'cf_O_hairfront_92_07'
        fronth436 = 'cf_O_hairfront_92_07_deprecated'
        fronth437 = 'cf_O_hairfront_92_08'
        fronth438 = 'cf_O_hairfront_92_08_deprecated'
        fronth439 = 'cf_O_hairfront_92_09'
        fronth440 = 'cf_O_hairfront_92_09_deprecated'
        fronth441 = 'cf_O_hairfront_92_010'
        fronth442 = 'cf_O_hairfront_92_010_deprecated'
        fronth443 = 'cf_O_hairfront_92_011'
        fronth444 = 'cf_O_hairfront_92_011_deprecated'
        fronth445 = 'cf_O_hairfront_92_012'
        fronth446 = 'cf_O_hairfront_92_012_deprecated'
        fronth447 = 'cf_O_hairfront_94_00'
        fronth448 = 'cf_O_hairfront_94_00_deprecated'
        fronth449 = 'cf_O_hairfront_94_01'
        fronth450 = 'cf_O_hairfront_94_01_deprecated'
        fronth451 = 'cf_O_hairfront_94_02'
        fronth452 = 'cf_O_hairfront_94_02_deprecated'
        fronth453 = 'cf_O_hairfront_94_03'
        fronth454 = 'cf_O_hairfront_94_03_deprecated'
        fronth455 = 'cf_O_hairfront_94_04'
        fronth456 = 'cf_O_hairfront_94_04_deprecated'
        fronth457 = 'cf_O_hairfront_94_05'
        fronth458 = 'cf_O_hairfront_94_05_deprecated'
        fronth459 = 'cf_O_hairfront_94_06'
        fronth460 = 'cf_O_hairfront_94_06_deprecated'
        fronth461 = 'cf_O_hairfront_100_00'
        fronth462 = 'cf_O_hairfront_100_00_deprecated'
        fronth463 = 'cf_O_hairfront_100_01'
        fronth464 = 'cf_O_hairfront_100_01_deprecated'
        fronth465 = 'cf_O_hairfront_100_02'
        fronth466 = 'cf_O_hairfront_100_02_deprecated'
        fronth467 = 'cf_O_hairfront_100_03'
        fronth468 = 'cf_O_hairfront_100_03_deprecated'
        fronth469 = 'cf_O_hairfront_100_04'
        fronth470 = 'cf_O_hairfront_100_04_deprecated'
        fronth471 = 'cf_O_hairfront_100_05'
        fronth472 = 'cf_O_hairfront_100_05_deprecated'
        fronth473 = 'cf_O_hairfront_100_06'
        fronth474 = 'cf_O_hairfront_100_06_deprecated'
        fronth475 = 'cf_O_hairfront_100_07'
        fronth476 = 'cf_O_hairfront_100_07_deprecated'
        fronth477 = 'cf_O_hairfront_100_08'
        fronth478 = 'cf_O_hairfront_100_08_deprecated'
        fronth479 = 'cf_O_hairfront_100_09'
        fronth480 = 'cf_O_hairfront_100_09_deprecated'
        fronth481 = 'cf_O_hairfront_100_10'
        fronth482 = 'cf_O_hairfront_100_10_deprecated'
        fronth483 = 'cf_O_hairfront_100_11'
        fronth484 = 'cf_O_hairfront_100_11_deprecated'
        fronth485 = 'cf_O_hairfront_100_12'
        fronth486 = 'cf_O_hairfront_100_12_deprecated'
        fronth487 = 'cf_O_hairfront_100_13'
        fronth488 = 'cf_O_hairfront_100_13_deprecated'
        fronth489 = 'cf_O_hairfront_100_14'
        fronth490 = 'cf_O_hairfront_100_14_deprecated'
        fronth491 = 'cf_O_hairfront_100_15'
        fronth492 = 'cf_O_hairfront_100_15_deprecated'
        fronth493 = 'cf_O_hairfront_100_16'
        fronth494 = 'cf_O_hairfront_100_16_deprecated'
        fronth495 = 'cf_O_hairfront_100_17'
        fronth496 = 'cf_O_hairfront_100_17_deprecated'
        fronth497 = 'cf_O_hairfront_94_00'
        fronth498 = 'cf_O_hairfront_94_00_deprecated'
        fronth499 = 'cf_O_hairfront_94_01'
        fronth500 = 'cf_O_hairfront_94_01_deprecated'
        fronth501 = 'cf_O_hairfront_94_02'
        fronth502 = 'cf_O_hairfront_94_02_deprecated'
        fronth503 = 'cf_O_hairfront_94_03'
        fronth504 = 'cf_O_hairfront_94_03_deprecated'
        fronth505 = 'cf_O_hairfront_94_04'
        fronth506 = 'cf_O_hairfront_94_04_deprecated'
        fronth507 = 'cf_O_hairfront_94_05'
        fronth508 = 'cf_O_hairfront_94_05_deprecated'
        fronth509 = 'cf_O_hairfront_94_06'
        fronth510 = 'cf_O_hairfront_94_06_deprecated'
        fronth511 = 'cf_O_hairfront_94_07'
        fronth512 = 'cf_O_hairfront_94_07_deprecated'
        fronth513 = 'cf_O_hairfront_94_08'
        fronth514 = 'cf_O_hairfront_94_08_deprecated'
        fronth515 = 'cf_O_hairfront_94_09'
        fronth516 = 'cf_O_hairfront_94_09_deprecated'
        fronth517 = 'cf_O_hairfront_94_10'
        fronth518 = 'cf_O_hairfront_94_10_deprecated'
        fronth519 = 'cf_O_hairfront_94_11'
        fronth520 = 'cf_O_hairfront_94_11_deprecated'
        fronth521 = 'cf_O_hairfront_94_12'
        fronth522 = 'cf_O_hairfront_94_12_deprecated'
        fronth523 = 'cf_O_hairfront_94_13'
        fronth524 = 'cf_O_hairfront_94_13_deprecated'
        fronth525 = 'cf_O_hairside_94_00'
        fronth526 = 'cf_O_hairside_94_01'
        fronth527 = 'cf_O_hairside_94_02'
        fronth528 = 'cf_O_hairside_94_02_deprecated'
        fronth529 = 'cf_O_hairside_94_03'
        fronth530 = 'cf_O_hairside_94_03_deprecated'
        fronth531 = 'cf_O_hairfront_97_00'
        fronth532 = 'cf_O_hairfront_97_00_deprecated'
        fronth533 = 'cf_O_hairfront_97_01'
        fronth534 = 'cf_O_hairfront_97_01_deprecated'
        fronth535 = 'cf_O_hairfront_97_02'
        fronth536 = 'cf_O_hairfront_97_02_deprecated'
        fronth537 = 'cf_O_hairfront_97_03'
        fronth538 = 'cf_O_hairfront_97_03_deprecated'
        fronth539 = 'cf_O_hairfront_97_04'
        fronth540 = 'cf_O_hairfront_97_04_deprecated'
        fronth541 = 'cf_O_hairfront_97_05'
        fronth542 = 'cf_O_hairfront_97_05_deprecated'
        fronth543 = 'cf_O_hairfront_97_06'
        fronth544 = 'cf_O_hairfront_97_06_deprecated'
        fronth545 = 'cf_O_hairfront_97_07'
        fronth546 = 'cf_O_hairfront_97_07_deprecated'
        fronth547 = 'cf_O_hairfront_97_08'
        fronth548 = 'cf_O_hairfront_97_08_deprecated'
        fronth549 = 'cf_O_hairfront_97_09'
        fronth550 = 'cf_O_hairfront_97_09_deprecated'
        fronth551 = 'cf_O_hairfront_98_00'
        fronth552 = 'cf_O_hairfront_98_00_deprecated'
        fronth553 = 'cf_O_hairfront_98_01'
        fronth554 = 'cf_O_hairfront_98_01_deprecated'
        fronth555 = 'cf_O_hairfront_98_02'
        fronth556 = 'cf_O_hairfront_98_02_deprecated'
        fronth557 = 'cf_O_hairfront_98_03'
        fronth558 = 'cf_O_hairfront_98_03_deprecated'
        fronth559 = 'cf_O_hairfront_98_04'
        fronth560 = 'cf_O_hairfront_98_04_deprecated'
        fronth561 = 'cf_O_hairfront_98_05'
        fronth562 = 'cf_O_hairfront_98_05_deprecated'
        fronth563 = 'cf_O_hairfront_98_06'
        fronth564 = 'cf_O_hairfront_98_06_deprecated'
        fronth565 = 'cf_O_hairfront_98_07'
        fronth566 = 'cf_O_hairfront_98_07_deprecated'
        fronth567 = 'cf_O_hairfront_98_08'
        fronth568 = 'cf_O_hairfront_98_08_deprecated'
        fronth569 = 'cf_O_hairfront_98_09'
        fronth570 = 'cf_O_hairfront_98_09_deprecated'
        fronth571 = 'cf_O_hairfront_98_10'
        fronth572 = 'cf_O_hairfront_98_10_deprecated'
        fronth573 = 'cf_O_hairfront_98_11'
        fronth574 = 'cf_O_hairfront_98_11_deprecated'
        fronth575 = 'cf_O_hairfront_98_12'
        fronth576 = 'cf_O_hairfront_98_12_deprecated'
        fronth577 = 'cf_O_hairfront_98_13'
        fronth578 = 'cf_O_hairfront_98_13_deprecated'
        fronth579 = 'cf_O_hairfront_98_14'
        fronth580 = 'cf_O_hairfront_98_14_deprecated'
        fronth581 = 'cf_O_hairfront_99_00'
        fronth582 = 'cf_O_hairfront_99_00_deprecated'
        fronth583 = 'cf_O_hairfront_99_01'
        fronth584 = 'cf_O_hairfront_99_01_deprecated'
        fronth585 = 'cf_O_hairfront_99_02'
        fronth586 = 'cf_O_hairfront_99_02_deprecated'
        fronth587 = 'cf_O_hairfront_99_03'
        fronth588 = 'cf_O_hairfront_99_03_deprecated'
        fronth589 = 'cf_O_hairfront_99_04'
        fronth590 = 'cf_O_hairfront_99_04_deprecated'
        fronth591 = 'cf_O_hairfront_99_05'
        fronth592 = 'cf_O_hairfront_99_05_deprecated'
        fronth593 = 'cf_O_hairfront_99_06'
        fronth594 = 'cf_O_hairfront_99_06_deprecated'
        fronth595 = 'cf_O_hairfront_99_07'
        fronth596 = 'cf_O_hairfront_99_07_deprecated'
        fronth597 = 'cf_O_hairfront_99_08'
        fronth598 = 'cf_O_hairfront_99_08_deprecated'
        fronth599 = 'cf_O_hairfront_99_09'
        fronth600 = 'cf_O_hairfront_99_09_deprecated'
        fronth601 = 'cf_O_hairside_08_00'
        fronth602 = 'cf_O_hairside_08_00_deprecated'
        fronth603 = 'cf_O_hairside_12_00'
        fronth604 = 'cf_O_hairside_12_00_deprecated'
        fronth605 = 'cf_O_hairside_13_00'
        fronth606 = 'cf_O_hairside_13_00_deprecated'
        fronth607 = 'cf_O_hairside_14_00'
        fronth608 = 'cf_O_hairside_15_00'
        fronth609 = 'cf_O_hairside_15_00_deprecated'
        fronth610 = 'cf_O_hairside_16_00'
        fronth611 = 'cf_O_hairside_16_00_deprecated'
        fronth612 = 'bp_hair_00_00_L'
        fronth613 = 'bp_hair_00_00_R'
        fronth614 = 'bp_hair_00_01_L'
        fronth615 = 'bp_hair_00_01_R'
        # Back Hair
        backh1 = 'cf_O_hairback00'
        backh2 = 'cf_O_hairback00_deprecated'
        backh3 = 'cf_O_hairkiwa00'
        backh4 = 'cf_O_hairkiwa00_deprecated'
        backh5 = 'cf_O_hairback01_00'
        backh6 = 'cf_O_hairpony01_00'
        backh7 = 'cf_O_hairpony01_00_deprecated'
        backh8 = 'cf_O_hairpony01_01'
        backh9 = 'cf_O_hairpony01_01_deprecated'
        backh10 = 'cf_O_hairpony01_010'
        backh11 = 'cf_O_hairpony01_010_deprecated'
        backh12 = 'cf_O_hairpony01_010'
        backh13 = 'cf_O_hairpony01_010_deprecated'
        backh14 = 'cf_O_hairpony01_011'
        backh15 = 'cf_O_hairpony01_011_deprecated'
        backh16 = 'cf_O_hairpony01_012'
        backh17 = 'cf_O_hairpony01_012_deprecated'
        backh18 = 'cf_O_hairpony01_02'
        backh19 = 'cf_O_hairpony01_02_deprecated'
        backh20 = 'cf_O_hairpony01_03'
        backh21 = 'cf_O_hairpony01_03_deprecated'
        backh22 = 'cf_O_hairpony01_04'
        backh23 = 'cf_O_hairpony01_04_deprecated'
        backh24 = 'cf_O_hairpony01_05'
        backh25 = 'cf_O_hairpony01_05_deprecated'
        backh26 = 'cf_O_hairpony01_06'
        backh27 = 'cf_O_hairpony01_06_deprecated'
        backh28 = 'cf_O_hairpony01_07'
        backh29 = 'cf_O_hairpony01_07_deprecated'
        backh30 = 'cf_O_hairpony01_08'
        backh31 = 'cf_O_hairpony01_08_deprecated'
        backh32 = 'cf_O_hairpony01_09'
        backh33 = 'cf_O_hairpony01_09_deprecated'
        backh34 = 'cf_O_hairback02_00'
        backh35 = 'cf_O_hairpony02_00'
        backh36 = 'cf_O_hairpony02_00_deprecated'
        backh37 = 'cf_O_hairpony02_01'
        backh38 = 'cf_O_hairpony02_01_deprecated'
        backh39 = 'cf_O_hairpony02_010'
        backh40 = 'cf_O_hairpony02_010_deprecated'
        backh41 = 'cf_O_hairpony02_011'
        backh42 = 'cf_O_hairpony02_011_deprecated'
        backh43 = 'cf_O_hairpony02_012'
        backh44 = 'cf_O_hairpony02_012_deprecated'
        backh45 = 'cf_O_hairpony02_013'
        backh46 = 'cf_O_hairpony02_013_deprecated'
        backh47 = 'cf_O_hairpony02_02'
        backh48 = 'cf_O_hairpony02_02_deprecated'
        backh49 = 'cf_O_hairpony02_03'
        backh50 = 'cf_O_hairpony02_03_deprecated'
        backh51 = 'cf_O_hairpony02_04'
        backh52 = 'cf_O_hairpony02_04_deprecated'
        backh53 = 'cf_O_hairpony02_05'
        backh54 = 'cf_O_hairpony02_05_deprecated'
        backh55 = 'cf_O_hairpony02_06'
        backh56 = 'cf_O_hairpony02_06_deprecated'
        backh57 = 'cf_O_hairpony02_07'
        backh58 = 'cf_O_hairpony02_07_deprecated'
        backh59 = 'cf_O_hairpony02_08'
        backh60 = 'cf_O_hairpony02_08_deprecated'
        backh61 = 'cf_O_hairpony02_09'
        backh62 = 'cf_O_hairpony02_09_deprecated'
        backh63 = 'cf_O_hairback_kiwa03_00'
        backh64 = 'cf_O_hairback_kiwa03_00_deprecated'
        backh65 = 'cf_O_hairback_kiwa03_01'
        backh66 = 'cf_O_hairback03_00'
        backh67 = 'cf_O_hairback03_00_deprecated'
        backh68 = 'cf_O_hairback_kiwa04_00'
        backh69 = 'cf_O_hairback_kiwa04_00_deprecated'
        backh70 = 'cf_O_hairback04_00'
        backh71 = 'cf_O_hairback04_00_deprecated'
        backh72 = 'cf_O_hairback04_01'
        backh73 = 'cf_O_hairback04_01_deprecated'
        backh74 = 'cf_O_hairback04_02'
        backh75 = 'cf_O_hairback04_02_deprecated'
        backh76 = 'cf_O_hairback04_03'
        backh77 = 'cf_O_hairback04_03_deprecated'
        backh78 = 'cf_O_hairback05_00'
        backh79 = 'cf_O_hairback05_01'
        backh80 = 'cf_O_hairback05_02'
        backh81 = 'cf_O_hairback05_03'
        backh82 = 'cf_O_hairback05_04'
        backh83 = 'cf_O_hair_b06_00'
        backh84 = 'cf_O_hair_b06_00_deprecated'
        backh85 = 'cf_O_hair_b06_01'
        backh86 = 'cf_O_hair_b06_02'
        backh87 = 'cf_O_hair_b06_03'
        backh88 = 'cf_O_hairkiwa_b06_00'
        backh89 = 'cf_O_hairkiwa_b06_00_deprecated'
        backh90 = 'cf_O_hairback07_01'
        backh91 = 'cf_O_hairback07_01_deprecated'
        backh92 = 'cf_O_hairback07_02'
        backh93 = 'cf_O_hairback07_02_deprecated'
        backh94 = 'cf_O_hairkiwa07_00'
        backh95 = 'cf_O_hairkiwa07_00_deprecated'
        backh96 = 'cf_O_hairkiwa07_01'
        backh97 = 'cf_O_hairkiwa07_01_deprecated'
        backh98 = 'cf_O_hairback_08_00'
        backh99 = 'cf_O_hairback_08_01'
        backh100 = 'cf_O_hairback_08_02'
        backh101 = 'cf_O_hairback_08_03'
        backh102 = 'cf_O_hairback_08_04'
        backh103 = 'cf_O_hairtail_08_00'
        backh104 = 'cf_O_hairtail_08_01'
        backh105 = 'cf_O_hairtail_08_02'
        backh106 = 'cf_O_hairback_09_00'
        backh107 = 'cf_O_hairback_09_00_deprecated'
        backh108 = 'cf_O_hairback_09_01'
        backh109 = 'cf_O_hairback_09_01_deprecated'
        backh110 = 'cf_O_hairback_09_02'
        backh111 = 'cf_O_hairback_09_03'
        backh112 = 'cf_O_hairback_09_04'
        backh113 = 'cf_O_hairbackkiwa_09_00'
        backh114 = 'cf_O_hairbackkiwa_09_00_deprecated'
        backh115 = 'cf_O_hairback10_00'
        backh116 = 'cf_O_hairback10_01'
        backh117 = 'cf_O_hairback10_02'
        backh118 = 'cf_O_hairback_11_00'
        backh119 = 'cf_O_hairback_11_00_deprecated'
        backh120 = 'cf_O_hairback_11_01'
        backh121 = 'cf_O_hairback_11_01_deprecated'
        backh122 = 'cf_O_hairback_11_02'
        backh123 = 'cf_O_hairback_11_02_deprecated'
        backh124 = 'cf_O_hairbackkiwa_11_00'
        backh125 = 'cf_O_hairbackkiwa_11_00_deprecated'
        backh126 = 'cf_O_hairbackkiwa_11_01'
        backh127 = 'cf_O_hairside_11_00'
        backh128 = 'cf_O_hairback_12_00'
        backh129 = 'cf_O_hairback_12_01'
        backh130 = 'cf_O_hairback_12_02'
        backh131 = 'cf_O_hairback_12_03'
        backh132 = 'cf_O_hairback_12_04'
        backh133 = 'cf_O_hairtail_12_00'
        backh134 = 'cf_O_hairtail_12_00_deprecated'
        backh135 = 'cf_O_hairtail_12_01'
        backh136 = 'cf_O_hairtail_12_01_deprecated'
        backh137 = 'cf_O_hairback_13_00'
        backh138 = 'cf_O_hairback_13_00_deprecated'
        backh139 = 'cf_O_hairback_13_01'
        backh140 = 'cf_O_hairkiwa_b13_00'
        backh141 = 'cf_O_hairkiwa_b13_00_deprecated'
        backh142 = 'cf_O_hairkiwa_b13_01'
        backh143 = 'cf_O_hairback_14_00'
        backh144 = 'cf_O_hairback_14_01'
        backh145 = 'cf_O_hairback_14_02'
        backh146 = 'cf_O_hairback_14_03'
        backh147 = 'cf_O_hairback_14_04'
        backh148 = 'cf_O_hairback_15_00'
        backh149 = 'cf_O_hairback_15_01'
        backh150 = 'cf_O_hairback_15_02'
        backh151 = 'cf_O_hairback_15_03'
        backh152 = 'cf_O_hairback_15_04'
        backh153 = 'cf_O_hairtail_15_00'
        backh154 = 'cf_O_hairtail_15_01'
        backh155 = 'cf_O_hairback_16_00'
        backh156 = 'cf_O_hairback_16_01'
        backh157 = 'cf_O_hairback_16_02'
        backh158 = 'cf_O_hairback_16_03'
        backh159 = 'cf_O_hairback_16_04'
        backh160 = 'cf_O_hairtail_16_00'
        backh161 = 'cf_O_hairtail_16_01'
        backh162 = 'cf_O_hairback_17_00'
        backh163 = 'cf_O_hairtail_17_00'
        backh164 = 'cf_O_hairtail_17_01'
        backh165 = 'cf_O_hairtail_17_01_deprecated'
        backh166 = 'cf_O_hairback_18_00'
        backh167 = 'cf_O_hairtail_18_00'
        backh168 = 'cf_O_hairtail_18_01'
        backh169 = 'A007_O_hairBC00'
        backh170 = 'A007_O_hairBC01'
        backh171 = 'cf_O_hairback_20_01'
        backh172 = 'cf_O_hairback_20_01_deprecated'
        backh173 = 'cf_O_hairback_20_02'
        backh174 = 'cf_O_hairback_20_02_deprecated'
        backh175 = 'cf_O_hairback_20_03'
        backh176 = 'cf_O_hairback_20_03_deprecated'
        backh177 = 'cf_O_hairback_20_04'
        backh178 = 'cf_O_hairback_20_04_deprecated'
        backh179 = 'cf_O_hairback_20_05'
        backh180 = 'cf_O_hairback_20_05_deprecated'
        backh181 = 'cf_O_hairback_20_06'
        backh182 = 'cf_O_hairback_20_06_deprecated'
        backh183 = 'cf_O_hairback_20_07'
        backh184 = 'cf_O_hairback_20_08'
        backh185 = 'cf_O_hairback_20_09'
        backh186 = 'cf_O_hairbackkiwa_20_00'
        backh187 = 'cf_O_hairbackkiwa_20_00_deprecated'
        backh188 = 'cf_O_hairback21_00'
        backh189 = 'cf_O_hairpony21_00'
        backh190 = 'cf_O_hairpony21_00_deprecated'
        backh191 = 'cf_O_hairpony21_01'
        backh192 = 'cf_O_hairpony21_01_deprecated'
        backh193 = 'cf_O_hairpony21_010'
        backh194 = 'cf_O_hairpony21_010_deprecated'
        backh195 = 'cf_O_hairpony21_011'
        backh196 = 'cf_O_hairpony21_011_deprecated'
        backh197 = 'cf_O_hairpony21_012'
        backh198 = 'cf_O_hairpony21_012_deprecated'
        backh199 = 'cf_O_hairpony21_013'
        backh200 = 'cf_O_hairpony21_013_deprecated'
        backh201 = 'cf_O_hairpony21_02'
        backh202 = 'cf_O_hairpony21_02_deprecated'
        backh203 = 'cf_O_hairpony21_03'
        backh204 = 'cf_O_hairpony21_03_deprecated'
        backh205 = 'cf_O_hairpony21_04'
        backh206 = 'cf_O_hairpony21_04_deprecated'
        backh207 = 'cf_O_hairpony21_05'
        backh208 = 'cf_O_hairpony21_05_deprecated'
        backh209 = 'cf_O_hairpony21_06'
        backh210 = 'cf_O_hairpony21_06_deprecated'
        backh211 = 'cf_O_hairpony21_07'
        backh212 = 'cf_O_hairpony21_07_deprecated'
        backh213 = 'cf_O_hairpony21_08'
        backh214 = 'cf_O_hairpony21_08_deprecated'
        backh215 = 'cf_O_hairpony21_09'
        backh216 = 'cf_O_hairpony21_09_deprecated'
        backh217 = 'cf_O_hairback_22_01'
        backh218 = 'cf_O_hairback_22_01_deprecated'
        backh219 = 'cf_O_hairback_22_02'
        backh220 = 'cf_O_hairback_22_02_deprecated'
        backh221 = 'cf_O_hairback_22_03'
        backh222 = 'cf_O_hairkiwa_b13_01'
        backh223 = 'cf_O_hairkiwa_b22_01'
        backh224 = 'cf_O_hairkiwa_b22_01_deprecated'
        backh225 = 'cf_O_hairback_23_00'
        backh226 = 'cf_O_hairback_23_01'
        backh227 = 'cf_O_hairback_23_02'
        backh228 = 'cf_O_hairback_23_03'
        backh229 = 'cf_O_hairback_23_04'
        backh230 = 'cf_O_hairtail_23_00'
        backh231 = 'cf_O_hairtail_23_00_deprecated'
        backh232 = 'cf_O_hairtail_23_01'
        backh233 = 'cf_O_hairtail_23_01_deprecated'
        backh234 = 'cf_O_hairback_25_01'
        backh235 = 'cf_O_hairback_25_01_deprecated'
        backh236 = 'cf_O_hairback_25_02'
        backh237 = 'cf_O_hairback_25_03'
        backh238 = 'cf_O_hairback_25_04'
        backh239 = 'cf_O_hairback_26_00'
        backh240 = 'cf_O_hairback_26_00_deprecated'
        backh241 = 'cf_O_hairback_26_01'
        backh242 = 'cf_O_hairback_26_01_deprecated'
        backh243 = 'cf_O_hairback_26_02'
        backh244 = 'cf_O_hairback_26_02_deprecated'
        backh245 = 'cf_O_hairback_26_03'
        backh246 = 'cf_O_hairback_26_03_deprecated'
        backh247 = 'cf_O_hairpon_26_00'
        backh248 = 'cf_O_hairpon_26_01'
        backh249 = 'cf_O_hairpon_26_01_deprecated'
        backh250 = 'cf_O_hairpon_26_02'
        backh251 = 'cf_O_hairpon_26_02_deprecated'
        backh252 = 'cf_O_hairpon_26_03'
        backh253 = 'cf_O_hairpon_26_03_deprecated'
        backh254 = 'cf_O_hairpon_26_04'
        backh255 = 'cf_O_hairpon_26_04_deprecated'
        backh256 = 'cf_O_hairpon_26_05'
        backh257 = 'cf_O_hairpon_26_05_deprecated'
        backh258 = 'cf_O_hairpon_26_06'
        backh259 = 'cf_O_hairpon_26_06_deprecated'
        backh260 = 'cf_O_hairpon_26_07'
        backh261 = 'cf_O_hairpon_26_07_deprecated'
        backh262 = 'cf_O_hairback_27_00'
        backh263 = 'cf_O_hairback_27_00_deprecated'
        backh264 = 'cf_O_hairback_27_01'
        backh265 = 'cf_O_hairback_27_01_deprecated'
        backh266 = 'cf_O_hairback_27_02'
        backh267 = 'cf_O_hairback_27_02_deprecated'
        backh268 = 'cf_O_hairback_27_03'
        backh269 = 'cf_O_hairback_27_03_deprecated'
        backh270 = 'cf_O_hairback_27_04'
        backh271 = 'cf_O_hairback_27_04_deprecated'
        backh272 = 'cf_O_hairback_27_05'
        backh273 = 'cf_O_hairback_27_05_deprecated'
        backh274 = 'cf_O_hairback_27_06'
        backh275 = 'cf_O_hairback_27_06_deprecated'
        backh276 = 'cf_O_hairback_28_00'
        backh277 = 'cf_O_hairback_28_01'
        backh278 = 'cf_O_hairback_28_02'
        backh279 = 'cf_O_hairback_28_03'
        backh280 = 'cf_O_hairback_28_03_deprecated'
        backh281 = 'cf_O_hairback_29_00'
        backh282 = 'cf_O_hairback_29_00_deprecated'
        backh283 = 'cf_O_hairback_29_01'
        backh284 = 'cf_O_hairback_29_01_deprecated'
        backh285 = 'cf_O_hairback_29_02'
        backh286 = 'cf_O_hairback_29_02_deprecated'
        backh287 = 'cf_O_hairback_29_03'
        backh288 = 'cf_O_hairback_29_03_deprecated'
        backh289 = 'cf_O_hairback_30_00'
        backh290 = 'cf_O_hairback_30_00_deprecated'
        backh291 = 'cf_O_hairback_30_01'
        backh292 = 'cf_O_hairback_30_02'
        backh293 = 'cf_O_hairbL_30_00'
        backh294 = 'cf_O_hairbL_30_00_deprecated'
        backh295 = 'cf_O_hairbL_30_01'
        backh296 = 'cf_O_hairbL_30_01_deprecated'
        backh297 = 'cf_O_hairbL_30_02'
        backh298 = 'cf_O_hairbL_30_02_deprecated'
        backh299 = 'cf_O_hairbL_30_03'
        backh300 = 'cf_O_hairbL_30_03_deprecated'
        backh301 = 'cf_O_hairbR_30_00'
        backh302 = 'cf_O_hairbR_30_00_deprecated'
        backh303 = 'cf_O_hairbR_30_01'
        backh304 = 'cf_O_hairbR_30_01_deprecated'
        backh305 = 'cf_O_hairbR_30_02'
        backh306 = 'cf_O_hairbR_30_02_deprecated'
        backh307 = 'cf_O_hairbR_30_03'
        backh308 = 'cf_O_hairbR_30_03_deprecated'
        backh309 = 'A003_O_hairBCL00'
        backh310 = 'A003_O_hairBCL00_deprecated'
        backh311 = 'A003_O_hairBCR00'
        backh312 = 'A003_O_hairBCR00_deprecated'
        backh313 = 'A003_O_hairBL00'
        backh314 = 'A003_O_hairBL00_deprecated'
        backh315 = 'A003_O_hairBR00'
        backh316 = 'A003_O_hairBR00_deprecated'
        backh317 = 'A015_O_hairBC00'
        backh318 = 'A015_O_hairBC01'
        backh319 = 'A015_O_hairBC01 1'
        backh320 = 'A006_O_hairBC00'
        backh321 = 'A006_O_hairBC00_deprecated'
        backh322 = 'A006_O_hairBC01'
        backh323 = 'A006_O_hairBC02'
        backh324 = 'A006_O_hairBL00'
        backh325 = 'A006_O_hairBL00_deprecated'
        backh326 = 'A006_O_hairBR00'
        backh327 = 'A006_O_hairBR00_deprecated'
        backh328 = 'A025_O_hairBC00'
        backh329 = 'A025_O_hairBC00_deprecated'
        backh330 = 'A025_O_hairBC01'
        backh331 = 'A025_O_hairBC02'
        backh332 = 'A025_O_hairBL00'
        backh333 = 'A025_O_hairBL00_deprecated'
        backh334 = 'A025_O_hairBR00'
        backh335 = 'A025_O_hairBR00_deprecated'
        backh336 = 'A016_O_hairBC00'
        backh337 = 'A016_O_hairBC01'
        backh338 = 'A016_O_hairBC02'
        backh339 = 'A016_O_hairBRL00'
        backh340 = 'A016_O_hairBRL01'
        backh341 = 'A032_O_hairBC00'
        backh342 = 'A032_O_hairBC01'
        backh343 = 'A032_O_hairBC02'
        backh344 = 'A032_O_hairBRL00'
        backh345 = 'cf_O_hairback_82_00'
        backh346 = 'cf_O_hairback_82_01'
        backh347 = 'cf_O_hairback_82_01_deprecated'
        backh348 = 'cf_O_hairback_82_02'
        backh349 = 'cf_O_hairback_82_02_deprecated'
        backh350 = 'cf_O_hairback_82_03'
        backh351 = 'cf_O_hairback_82_03_deprecated'
        backh352 = 'cf_O_hairback_82_04'
        backh353 = 'cf_O_hairback_82_04_deprecated'
        backh354 = 'cf_O_hairback_82_05'
        backh355 = 'cf_O_hairback_82_05_deprecated'
        backh356 = 'cf_O_hairback_82_06'
        backh357 = 'cf_O_hairback_82_06_deprecated'
        backh358 = 'cf_O_hairback_82_07'
        backh359 = 'cf_O_hairback_82_07_deprecated'
        backh360 = 'cf_O_hairback_83_00'
        backh361 = 'cf_O_hairback_83_01'
        backh362 = 'cf_O_hairback_83_02'
        backh363 = 'cf_O_hairback_83_02_deprecated'
        backh364 = 'cf_O_hairback_83_03'
        backh365 = 'cf_O_hairback_83_03_deprecated'
        backh366 = 'cf_O_hairback_83_04'
        backh367 = 'cf_O_hairback_83_04_deprecated'
        backh368 = 'cf_O_hairback_83_05'
        backh369 = 'cf_O_hairback_83_05_deprecated'
        backh370 = 'cf_O_hairback_83_06'
        backh371 = 'cf_O_hairback_83_06_deprecated'
        backh372 = 'cf_O_hairback_83_07'
        backh373 = 'cf_O_hairback_83_07_deprecated'
        backh374 = 'cf_O_hairback_83_08'
        backh375 = 'cf_O_hairback_83_08_deprecated'
        backh376 = 'cf_O_hairback_83_09'
        backh377 = 'cf_O_hairback_83_09_deprecated'
        backh378 = 'cf_O_hairback_83_10'
        backh379 = 'cf_O_hairback_83_10_deprecated'
        backh380 = 'cf_O_hairback_83_11'
        backh381 = 'cf_O_hairback_83_11_deprecated'
        backh382 = 'cf_O_hairback_83_12'
        backh383 = 'cf_O_hairback_83_12_deprecated'
        backh384 = 'cf_O_hairback_83_13'
        backh385 = 'cf_O_hairback_83_13_deprecated'
        backh386 = 'cf_O_hairback_83_14'
        backh387 = 'cf_O_hairback_83_14_deprecated'
        backh388 = 'cf_O_hairback_83_15'
        backh389 = 'cf_O_hairback_83_15_deprecated'
        backh390 = 'cf_O_hairback_83_16'
        backh391 = 'cf_O_hairback_83_16_deprecated'
        backh392 = 'cf_O_hairback_83_17'
        backh393 = 'cf_O_hairback_83_17_deprecated'
        backh394 = 'cf_O_hairback_83_18'
        backh395 = 'cf_O_hairback_83_18_deprecated'
        backh396 = 'cf_O_hairback_83_19'
        backh397 = 'cf_O_hairback_83_19_deprecated'
        backh398 = 'cf_O_hairback_83_21'
        backh399 = 'cf_O_hairback_83_21_deprecated'
        backh400 = 'cf_O_hairback_83_22'
        backh401 = 'O_hs_cf_hair_84_b_00'
        backh402 = 'O_hs_cf_hair_84_b_00_deprecated'
        backh403 = 'O_hs_cf_hair_84_b_02'
        backh404 = 'O_hs_cf_hair_84_b_02_deprecated'
        backh405 = 'O_hs_cf_hair_84_b_03'
        backh406 = 'O_hs_cf_hair_84_b_03_deprecated'
        backh407 = 'O_hs_cf_hair_84_b_04'
        backh408 = 'O_hs_cf_hair_84_b_04_deprecated'
        backh409 = 'O_hs_cf_hair_84_b_05'
        backh410 = 'O_hs_cf_hair_84_b_05_deprecated'
        backh411 = 'O_hs_cf_hair_84_b_06'
        backh412 = 'O_hs_cf_hair_84_b_06_deprecated'
        backh413 = 'O_hs_cf_hair_84_b_07'
        backh414 = 'O_hs_cf_hair_84_b_07_deprecated'
        backh415 = 'O_hs_cf_hair_84_b_08'
        backh416 = 'O_hs_cf_hair_84_b_08_deprecated'
        backh417 = 'O_hs_cf_hair_84_b_09'
        backh418 = 'O_hs_cf_hair_84_b_09_deprecated'
        backh419 = 'O_hs_cf_hair_84_b_10'
        backh420 = 'O_hs_cf_hair_84_b_10_deprecated'
        backh421 = 'O_hs_cf_hair_84_b_11'
        backh422 = 'O_hs_cf_hair_84_b_11_deprecated'
        backh423 = 'O_hs_cf_hair_84_b_12'
        backh424 = 'O_hs_cf_hair_84_b_12_deprecated'
        backh425 = 'O_hs_cf_hair_84_b_13'
        backh426 = 'O_hs_cf_hair_84_b_13_deprecated'
        backh427 = 'O_hs_cf_hair_84_b_14'
        backh428 = 'O_hs_cf_hair_84_b_14_deprecated'
        backh429 = 'O_hs_cf_hair_84_b_15'
        backh430 = 'O_hs_cf_hair_84_b_15_deprecated'
        backh431 = 'O_hs_cf_hair_84_b_16'
        backh432 = 'O_hs_cf_hair_84_b_16_deprecated'
        backh433 = 'O_hs_cf_hair_84_b_17'
        backh434 = 'O_hs_cf_hair_84_b_17_deprecated'
        backh435 = 'O_hs_cf_hair_84_b_18'
        backh436 = 'O_hs_cf_hair_84_b_18_deprecated'
        backh437 = 'O_hs_cf_hair_84_b_19'
        backh438 = 'O_hs_cf_hair_84_b_19_deprecated'
        backh439 = 'O_hs_cf_hair_84_b_20'
        backh440 = 'O_hs_cf_hair_84_b_20_deprecated'
        backh441 = 'O_hs_cf_hair_84_b_21'
        backh442 = 'O_hs_cf_hair_84_b_21_deprecated'
        backh443 = 'O_hs_cf_hair_85_b_00'
        backh444 = 'O_hs_cf_hair_85_b_00_deprecated'
        backh445 = 'O_hs_cf_hair_85_b_02'
        backh446 = 'O_hs_cf_hair_85_b_02_deprecated'
        backh447 = 'O_hs_cf_hair_85_b_03'
        backh448 = 'O_hs_cf_hair_85_b_03_deprecated'
        backh449 = 'O_hs_cf_hair_85_b_04'
        backh450 = 'O_hs_cf_hair_85_b_04_deprecated'
        backh451 = 'O_hs_cf_hair_85_b_05'
        backh452 = 'O_hs_cf_hair_85_b_05_deprecated'
        backh453 = 'O_hs_cf_hair_85_b_06'
        backh454 = 'O_hs_cf_hair_85_b_06_deprecated'
        backh455 = 'O_hs_cf_hair_85_b_07'
        backh456 = 'O_hs_cf_hair_85_b_07_deprecated'
        backh457 = 'O_hs_cf_hair_85_b_08'
        backh458 = 'O_hs_cf_hair_85_b_08_deprecated'
        backh459 = 'O_hs_cf_hair_85_b_09'
        backh460 = 'O_hs_cf_hair_85_b_09_deprecated'
        backh461 = 'O_hs_cf_hair_85_b_10'
        backh462 = 'O_hs_cf_hair_85_b_10_deprecated'
        backh463 = 'O_hs_cf_hair_85_b_11'
        backh464 = 'O_hs_cf_hair_85_b_11_deprecated'
        backh465 = 'O_hs_cf_hair_85_b_12'
        backh466 = 'O_hs_cf_hair_85_b_12_deprecated'
        backh467 = 'O_hs_cf_hair_85_b_13'
        backh468 = 'O_hs_cf_hair_85_b_13_deprecated'
        backh469 = 'O_hs_cf_hair_85_b_14'
        backh470 = 'O_hs_cf_hair_85_b_14_deprecated'
        backh471 = 'O_hs_cf_hair_85_b_15'
        backh472 = 'O_hs_cf_hair_85_b_15_deprecated'
        backh473 = 'O_hs_cf_hair_85_b_16'
        backh474 = 'O_hs_cf_hair_85_b_16_deprecated'
        backh475 = 'O_hs_cf_hair_85_b_17'
        backh476 = 'O_hs_cf_hair_85_b_17_deprecated'
        backh477 = 'O_hs_cf_hair_85_b_18'
        backh478 = 'O_hs_cf_hair_85_b_18_deprecated'
        backh479 = 'O_hs_cf_hair_85_b_19'
        backh480 = 'O_hs_cf_hair_85_b_19_deprecated'
        backh481 = 'O_hs_cf_hair_85_b_20'
        backh482 = 'O_hs_cf_hair_85_b_20_deprecated'
        backh483 = 'O_hs_cf_hair_85_b_21'
        backh484 = 'O_hs_cf_hair_85_b_21_deprecated'
        backh485 = 'cf_O_hairback_86_01'
        backh486 = 'cf_O_hairback_86_01_deprecated'
        backh487 = 'cf_O_hairback_86_eri'
        backh488 = 'cf_O_hairback_86_eri_deprecated'
        backh489 = 'cf_O_hairback_86_kiwa'
        backh490 = 'cf_O_hairback_86_kiwa_deprecated'
        backh491 = 'cf_O_hairback_86_L'
        backh492 = 'cf_O_hairback_86_L_02'
        backh493 = 'cf_O_hairback_86_L_02_deprecated'
        backh494 = 'cf_O_hairback_86_L_03'
        backh495 = 'cf_O_hairback_86_L_03_deprecated'
        backh496 = 'cf_O_hairback_86_L_deprecated'
        backh497 = 'cf_O_hairback_86_mom_L'
        backh498 = 'cf_O_hairback_86_mom_L_deprecated'
        backh499 = 'cf_O_hairback_86_mom_R'
        backh500 = 'cf_O_hairback_86_mom_R_deprecated'
        backh501 = 'cf_O_hairback_86_R'
        backh502 = 'cf_O_hairback_86_R_02'
        backh503 = 'cf_O_hairback_86_R_02_deprecated'
        backh504 = 'cf_O_hairback_86_R_03'
        backh505 = 'cf_O_hairback_86_R_03_deprecated'
        backh506 = 'cf_O_hairback_86_R_deprecated'
        backh507 = 'O_hs_cf_hair_88_b_00'
        backh508 = 'O_hs_cf_hair_88_b_00_deprecated'
        backh509 = 'O_hs_cf_hair_88_b_01'
        backh510 = 'O_hs_cf_hair_88_b_01_deprecated'
        backh511 = 'O_hs_cf_hair_88_b_02'
        backh512 = 'O_hs_cf_hair_88_b_02_deprecated'
        backh513 = 'O_hs_cf_hair_88_b_03'
        backh514 = 'O_hs_cf_hair_88_b_03_deprecated'
        backh515 = 'O_hs_cf_hair_88_b_05'
        backh516 = 'O_hs_cf_hair_88_b_05_deprecated'
        backh517 = 'O_hs_cf_hair_88_b_06'
        backh518 = 'O_hs_cf_hair_88_b_06_deprecated'
        backh519 = 'O_hs_cf_hair_88_b_07'
        backh520 = 'O_hs_cf_hair_88_b_07_deprecated'
        backh521 = 'O_hs_cf_hair_88_b_08'
        backh522 = 'O_hs_cf_hair_88_b_08_deprecated'
        backh523 = 'O_hs_cf_hair_88_b_09'
        backh524 = 'O_hs_cf_hair_88_b_09_deprecated'
        backh525 = 'O_hs_cf_hair_88_b_10'
        backh526 = 'O_hs_cf_hair_88_b_10_deprecated'
        backh527 = 'O_hs_cf_hair_88_b_11'
        backh528 = 'O_hs_cf_hair_88_b_11_deprecated'
        backh529 = 'O_hs_cf_hair_88_b_12'
        backh530 = 'O_hs_cf_hair_88_b_12_deprecated'
        backh531 = 'O_hs_cf_hair_88_b_13'
        backh532 = 'O_hs_cf_hair_88_b_13_deprecated'
        backh533 = 'cf_O_hairback_89_01'
        backh534 = 'cf_O_hairback_89_01_deprecated'
        backh535 = 'cf_O_hairback_89_02'
        backh536 = 'cf_O_hairback_89_02_deprecated'
        backh537 = 'cf_O_hairback_89_03'
        backh538 = 'cf_O_hairback_89_03_deprecated'
        backh539 = 'cf_O_hairpony_89_01'
        backh540 = 'cf_O_hairpony_89_02'
        backh541 = 'cf_O_hairpony_89_02_deprecated'
        backh542 = 'cf_O_hairpony_89_03'
        backh543 = 'cf_O_hairpony_89_03_deprecated'
        backh544 = 'cf_O_hairpony_89_04'
        backh545 = 'cf_O_hairpony_89_04_deprecated'
        backh546 = 'cf_O_hairpony_89_05'
        backh547 = 'cf_O_hairpony_89_05_deprecated'
        backh548 = 'cf_O_hairpony_89_06'
        backh549 = 'cf_O_hairpony_89_06_deprecated'
        backh550 = 'cf_O_hairpony_89_07'
        backh551 = 'cf_O_hairpony_89_07_deprecated'
        backh552 = 'cf_O_hairpony_89_08'
        backh553 = 'cf_O_hairpony_89_08_deprecated'
        backh554 = 'cf_O_hairpony_89_09'
        backh555 = 'cf_O_hairpony_89_09_deprecated'
        backh556 = 'cf_O_hairpony_89_10'
        backh557 = 'cf_O_hairpony_89_10_deprecated'
        backh558 = 'cf_O_hairpony_89_11'
        backh559 = 'cf_O_hairpony_89_11_deprecated'
        backh560 = 'cf_O_hairpony_89_12'
        backh561 = 'cf_O_hairpony_89_12_deprecated'
        backh562 = 'cf_O_hairpony_89_13'
        backh563 = 'cf_O_hairpony_89_13_deprecated'
        backh564 = 'cf_O_hairpony_89_14'
        backh565 = 'cf_O_hairpony_89_14_deprecated'
        backh566 = 'cf_O_hairpony_89_15'
        backh567 = 'cf_O_hairpony_89_15_deprecated'
        backh568 = 'cf_O_hairpony_89_16'
        backh569 = 'cf_O_hairpony_89_16_deprecated'
        backh570 = 'cf_O_hairpony_89_17'
        backh571 = 'cf_O_hairpony_89_17_deprecated'
        backh572 = 'cf_O_hairpony_89_18'
        backh573 = 'cf_O_hairpony_89_18_deprecated'
        backh574 = 'cf_O_hairpony_89_19'
        backh575 = 'cf_O_hairpony_89_19_deprecated'
        backh576 = 'cf_O_hairpony_89_20'
        backh577 = 'cf_O_hairpony_89_20_deprecated'
        backh578 = 'cf_O_hairpony_89_21'
        backh579 = 'cf_O_hairpony_89_21_deprecated'
        backh580 = 'cf_O_hairpony_89_22'
        backh581 = 'cf_O_hairpony_89_22_deprecated'
        backh582 = 'cf_O_hairbase'
        backh583 = 'cf_O_hairback_91_01'
        backh584 = 'cf_O_hairback_91_01_deprecated'
        backh585 = 'cf_O_hairback_91_02'
        backh586 = 'cf_O_hairback_91_02_deprecated'
        backh587 = 'cf_O_hairback_91_03'
        backh588 = 'cf_O_hairback_91_03_deprecated'
        backh589 = 'cf_O_hairback_91_04'
        backh590 = 'cf_O_hairback_91_05'
        backh591 = 'cf_O_hairback_91_06'
        backh592 = 'cf_O_hairback_91_07'
        backh593 = 'cf_O_hairback_92_01'
        backh594 = 'cf_O_hairback_92_01_deprecated'
        backh595 = 'cf_O_hairback_92_02'
        backh596 = 'cf_O_hairback_92_02_deprecated'
        backh597 = 'cf_O_hairback_92_03'
        backh598 = 'cf_O_hairback_92_03_deprecated'
        backh599 = 'cf_O_hairback_92_04'
        backh600 = 'cf_O_hairback_92_04_deprecated'
        backh601 = 'cf_O_hairback_92_05'
        backh602 = 'cf_O_hairback_92_05_deprecated'
        backh603 = 'cf_O_hairback_92_06'
        backh604 = 'cf_O_hairback_92_06_deprecated'
        backh605 = 'cf_O_hairback_92_07'
        backh606 = 'cf_O_hairback_92_07_deprecated'
        backh607 = 'cf_O_hairback_92_08'
        backh608 = 'cf_O_hairback_92_08_deprecated'
        backh609 = 'cf_O_hairback_92_tail_L'
        backh610 = 'cf_O_hairback_92_tail_R'
        backh611 = 'cf_O_hairback_93_01'
        backh612 = 'cf_O_hairback_93_01_deprecated'
        backh613 = 'cf_O_hairback_93_02'
        backh614 = 'cf_O_hairback_93_02_deprecated'
        backh615 = 'cf_O_hairbL_93_01'
        backh616 = 'cf_O_hairbL_93_01_deprecated'
        backh617 = 'cf_O_hairbL_93_010'
        backh618 = 'cf_O_hairbL_93_010_deprecated'
        backh619 = 'cf_O_hairbL_93_02'
        backh620 = 'cf_O_hairbL_93_02_deprecated'
        backh621 = 'cf_O_hairbL_93_03'
        backh622 = 'cf_O_hairbL_93_03_deprecated'
        backh623 = 'cf_O_hairbL_93_04'
        backh624 = 'cf_O_hairbL_93_04_deprecated'
        backh625 = 'cf_O_hairbL_93_05'
        backh626 = 'cf_O_hairbL_93_05_deprecated'
        backh627 = 'cf_O_hairbL_93_06'
        backh628 = 'cf_O_hairbL_93_06_deprecated'
        backh629 = 'cf_O_hairbL_93_07'
        backh630 = 'cf_O_hairbL_93_07_deprecated'
        backh631 = 'cf_O_hairbL_93_08'
        backh632 = 'cf_O_hairbL_93_08_deprecated'
        backh633 = 'cf_O_hairbL_93_09'
        backh634 = 'cf_O_hairbL_93_09_deprecated'
        backh635 = 'cf_O_hairbR_93_01'
        backh636 = 'cf_O_hairbR_93_01_deprecated'
        backh637 = 'cf_O_hairbR_93_02'
        backh638 = 'cf_O_hairbR_93_02_deprecated'
        backh639 = 'cf_O_hairbR_93_03'
        backh640 = 'cf_O_hairbR_93_03_deprecated'
        backh641 = 'cf_O_hairbR_93_04'
        backh642 = 'cf_O_hairbR_93_04_deprecated'
        backh643 = 'cf_O_hairbR_93_05'
        backh644 = 'cf_O_hairbR_93_05_deprecated'
        backh645 = 'cf_O_hairbR_93_06'
        backh646 = 'cf_O_hairbR_93_06_deprecated'
        backh647 = 'cf_O_hairbR_93_07'
        backh648 = 'cf_O_hairbR_93_07_deprecated'
        backh649 = 'cf_O_hairback_95_01'
        backh650 = 'cf_O_hairback_95_01_deprecated'
        backh651 = 'cf_O_hairback_95_02'
        backh652 = 'cf_O_hairback_95_02_deprecated'
        backh653 = 'cf_O_hairback_95_03'
        backh654 = 'cf_O_hairback_95_03_deprecated'
        backh655 = 'cf_O_hairback_95_04'
        backh656 = 'cf_O_hairback_95_05'
        backh657 = 'cf_O_hairback_95_06'
        backh658 = 'cf_O_hairback_95_07'
        backh659 = 'o_hairB_0'
        backh660 = 'o_hairB_1'
        backh661 = 'o_hairB_2'
        backh662 = 'o_hairB_6'
        backh663 = 'o_hairB_7'
        backh664 = 'o_hairB_8'
        backh665 = 'o_hairB_t_1'
        backh666 = 'o_hairB_t_2'
        backh667 = 'o_hairB_t_3'
        backh668 = 'o_hairB_t_4'
        backh669 = 'o_hairB_t_5'
        backh670 = 'o_u_hairB_1'
        backh671 = 'o_u_hairB_2'
        backh672 = 'o_u_hairB_6'
        backh673 = 'o_u_hairB_7'
        backh674 = 'o_u_hairB_8'
        backh675 = 'o_u_hairB_t_1'
        backh676 = 'o_u_hairB_t_2'
        backh677 = 'o_u_hairB_t_3'
        backh678 = 'o_u_hairB_t_4'
        backh679 = 'o_u_hairB_t_5'
        backh680 = 'cf_O_dango_01'
        backh681 = 'cf_O_dango_02'
        backh682 = 'cf_O_dango_02_deprecated'
        backh683 = 'cf_O_dango_03'
        backh684 = 'cf_O_dango_03_deprecated'
        backh685 = 'cf_O_dango_04'
        backh686 = 'cf_O_dango_04u'
        backh687 = 'cf_O_dango_05'
        backh688 = 'cf_O_dango_05_deprecated'
        backh689 = 'cf_O_hairback_100_00'
        backh690 = 'cf_O_hairback_100_00_deprecated'
        backh691 = 'cf_O_hairback_100_01'
        backh692 = 'cf_O_hairback_100_01_deprecated'
        backh693 = 'cf_O_hairback_100_02'
        backh694 = 'cf_O_hairback_100_02_deprecated'
        backh695 = 'cf_O_himosaki_L_01'
        backh696 = 'cf_O_himosaki_L_01_deprecated'
        backh697 = 'cf_O_himosaki_L_02'
        backh698 = 'cf_O_himosaki_L_02_deprecated'
        backh699 = 'cf_O_himosaki_L_03'
        backh700 = 'cf_O_himosaki_L_03_deprecated'
        backh701 = 'cf_O_himosaki_L_04'
        backh702 = 'cf_O_himosaki_L_04_deprecated'
        backh703 = 'cf_O_himosaki_R_01'
        backh704 = 'cf_O_himosaki_R_01_deprecated'
        backh705 = 'cf_O_himosaki_R_02'
        backh706 = 'cf_O_himosaki_R_02_deprecated'
        backh707 = 'cf_O_himosaki_R_03'
        backh708 = 'cf_O_himosaki_R_03_deprecated'
        backh709 = 'cf_O_himosaki_R_04'
        backh710 = 'cf_O_himosaki_R_04_deprecated'
        backh711 = 'cf_O_hairback_96_01'
        backh712 = 'cf_O_hairback_96_01_deprecated'
        backh713 = 'cf_O_hairback_96_02'
        backh714 = 'cf_O_hairback_96_02_deprecated'
        backh715 = 'cf_O_hairback_96_03'
        backh716 = 'cf_O_hairback_96_03_deprecated'
        backh717 = 'cf_O_hairpo_96_01'
        backh718 = 'cf_O_hairpo_96_01_deprecated'
        backh719 = 'cf_O_hairpo_96_02'
        backh720 = 'cf_O_hairpo_96_02_deprecated'
        backh721 = 'cf_O_hairpo_96_03'
        backh722 = 'cf_O_hairpo_96_03_deprecated'
        backh723 = 'cf_O_hairpo_96_04'
        backh724 = 'cf_O_hairpo_96_04_deprecated'
        backh725 = 'cf_O_hairpo_96_05'
        backh726 = 'cf_O_hairpo_96_05_deprecated'
        backh727 = 'cf_O_hairpo_96_06'
        backh728 = 'cf_O_hairpo_96_06_deprecated'
        backh729 = 'cf_O_hairpo_96_07'
        backh730 = 'cf_O_hairpo_96_07_deprecated'
        backh731 = 'cf_O_hairback_98_00'
        backh732 = 'cf_O_hairback_98_00_deprecated'
        backh733 = 'cf_O_hairback_98_01'
        backh734 = 'cf_O_hairback_98_02'
        backh735 = 'cf_O_hairback_98_03'
        backh736 = 'cf_O_hairback_98_04'
        backh737 = 'cf_O_hairback_98_05'
        backh738 = 'cf_O_hairback_98_05_deprecated'
        backh739 = 'cf_O_hairback_98_06'
        backh740 = 'cf_O_hairback_98_06_deprecated'
        backh741 = 'cf_O_hairback_98_07'
        backh742 = 'cf_O_hairback_98_07_deprecated'
        backh743 = 'cf_O_hairback_98_08'
        backh744 = 'cf_O_hairback_98_08_deprecated'
        backh745 = 'cf_O_hairback_98_09'
        backh746 = 'cf_O_hairback_98_09_deprecated'
        backh747 = 'cf_O_hairback_98_10'
        backh748 = 'cf_O_hairback_98_10_deprecated'
        backh749 = 'cf_O_hairback_98_11'
        backh750 = 'cf_O_hairback_98_11_deprecated'
        backh751 = 'cf_O_hairback_98_12'
        backh752 = 'cf_O_hairback_98_12_deprecated'
        backh753 = 'cf_O_hairback_99_00'
        backh754 = 'cf_O_hairback_99_00_deprecated'
        backh755 = 'cf_O_hairback_99_01'
        backh756 = 'cf_O_hairback_99_02'
        backh757 = 'cf_O_hairback_99_03'
        backh758 = 'cf_O_hairback_99_04'
        backh759 = 'cf_O_hairback_99_04_deprecated'
        backh760 = 'cf_O_hairback_99_05'
        backh761 = 'cf_O_hairback_99_05_deprecated'
        backh762 = 'cf_O_hairback_99_06'
        backh763 = 'cf_O_hairback_99_07'
        backh764 = 'cf_O_hairback_99_07_deprecated'
        backh765 = 'cf_O_hairback_99_08'
        backh766 = 'cf_O_hairback_99_08_deprecated'
        backh767 = 'cf_O_hairback_99_09'
        backh768 = 'cf_O_hairback_99_09_deprecated'
        backh769 = 'cf_O_hairback_99_10'
        backh770 = 'cf_O_hairback_99_10_deprecated'
        backh771 = 'cf_O_hairback_99_11'
        backh772 = 'cf_O_hairback_99_11_deprecated'
        backh773 = 'cf_O_hairback_99_12'
        backh774 = 'cf_O_hairback_99_12_deprecated'
        backh775 = 'cf_O_hairback_99_13'
        backh776 = 'cf_O_hairback_99_13_deprecated'
        backh777 = 'cf_O_hairback_99_14'
        backh778 = 'cf_O_hairback_99_14_deprecated'
        backh779 = 'cf_O_hairback_99_15'
        backh780 = 'cf_O_hairback_99_15_deprecated'
        backh781 = 'osageB_001'
        backh782 = 'osageB_002'
        backh783 = 'osageB_003'
        backh784 = 'osageB_004'
        backh785 = 'osageB_005'
        backh786 = 'osageB_006'
        backh787 = 'osageB_007'
        backh788 = 'osageB_008'
        backh789 = 'osageB_009'
        backh790 = 'osageB_base'
        backh791 = 'osageB_front'
        backh792 = 'osageB_front_deprecated'
        backh793 = 'osageB_inside'
        backh794 = 'osageB_inside2'
        backh795 = 'osageB_osage'
        backh796 = 'osageB_osageB'
        # Top names:
        #top
        top1 = 'o_top_a'
        top2 = 'o_top_b'
        top3 = 'O_top_a'
        top4 = 'O_top01_00'
        top5 = 'O_top01_a'
        top6 = 'O_top01_a_u'
        top7 = 'O_top01_b'
        top8 = 'O_top01_b_u'
        top9 = 'O_top00_a'
        top10 = 'O_top00_a_u'
        top11 = 'O_top00_b'
        top12 = 'O_top00_b_u'
        top13 = 'O_topfri_a'
        top14 = 'O_topfri_b'
        top15 = 'O_top00_a'
        top16 = 'O_top00_b'
        top17 = 'O_top02_a'
        top18 = 'O_top02_b'
        top19 = 'cf_o_AP_d_top'
        top20 = 'cf_o_AP_n_top'
        top21 = 'cf_o_AP_d_eri'
        top22 = 'cf_o_AP_n_eri'
        top23 = 'cf_o_top_kimoG_huriruA'
        top24 = 'cf_o_top_kimoG_huriruA_U'
        top25 = 'cf_o_top_kimoG_huriruB'
        top26 = 'cf_o_top_kimoG_huriruB_U'
        top27 = 'cf_o_top_kimono_gos_friru1'
        top28 = 'cf_o_top_kimono_gos_friru1_U'
        top29 = 'cf_o_top_kimono_gos_friru2'
        top30 = 'cf_o_top_kimono_gos_friru2_U'
        top31 = 'cf_o_top_kimonoGOS_D_03'
        top32 = 'cf_o_top_kimonoGOS_D_U'
        top33 = 'cf_o_top_kimonoGOS_N'
        top34 = 'cf_o_top_kimonoGOS_N_U'
        top35 = 'cf_o_top_kimonoGOS_sode_kuchi'
        top36 = 'cf_o_top_kimonoGOS_sode_N_kuchi'
        top37 = 'cf_top_kimoGS_ude_ribon'
        top38 = 'cf_top_kimoGS_ude_ribon_U'
        top39 = 'cf_top_kimoGS_ude_ribonN'
        top40 = 'cf_top_kimoGS_ude_ribonN_U'
        top41 = 'cf_top_kimonoGOS_N_waist__ribon'
        top42 = 'cf_top_kimonoGOS_N_waist__ribonU'
        top43 = 'cf_top_kimonoGOS_ude__huriru'
        top44 = 'cf_top_kimonoGOS_ude_huriru_N'
        top45 = 'cf_top_kimonoGOS_waist__ribon'
        top46 = 'cf_top_kimonoGOS_waist__ribonU'
        top47 = 'cf_o_top_kimono_D_base_00'
        top48 = 'cf_o_top_kimono_D_obi'
        top49 = 'cf_o_top_kimono_N_base_O'
        top50 = 'cf_o_top_kimono_N_obi'
        top51 = 'cf_o_top_kimono_N_U'
        top52 = 'cf_o_top_kimoG_huriruA'
        top53 = 'cf_o_top_kimoG_huriruA_U'
        top54 = 'cf_o_top_kimoG_huriruB'
        top55 = 'cf_o_top_kimoG_huriruB_U'
        top56 = 'cf_o_top_kimono_gos_friru1'
        top57 = 'cf_o_top_kimono_gos_friru1_U'
        top58 = 'cf_o_top_kimono_gos_friru2'
        top59 = 'cf_o_top_kimono_gos_friru2_U'
        top60 = 'cf_o_top_kimonoGOS_D_03'
        top61 = 'cf_o_top_kimonoGOS_D_U'
        top62 = 'cf_o_top_kimonoGOS_N'
        top63 = 'cf_o_top_kimonoGOS_N_U'
        top64 = 'cf_o_top_kimonoGOS_sode_kuchi'
        top65 = 'cf_o_top_kimonoGOS_sode_N_kuchi'
        top66 = 'cf_top_kimoGS_ude_ribon'
        top67 = 'cf_top_kimoGS_ude_ribon_U'
        top68 = 'cf_top_kimoGS_ude_ribonN'
        top69 = 'cf_top_kimoGS_ude_ribonN_U'
        top70 = 'cf_top_kimonoGOS_N_waist_ribon'
        top71 = 'cf_top_kimonoGOS_N_waist_ribonU'
        top72 = 'cf_top_kimonoGOS_ude_huriru'
        top73 = 'cf_top_kimonoGOS_ude_huriru_N'
        top74 = 'cf_top_kimonoGOS_waist_ribon'
        top75 = 'cf_top_kimonoGOS_waist_ribonU'
        top76 = 'cf_o_top_kimono_D_base_00'
        top77 = 'cf_o_top_kimono_D_obi'
        top78 = 'cf_o_top_kimono_N_base_O'
        top79 = 'cf_o_top_kimono_N_obi'
        top80 = 'cf_o_top_kimono_N_U'
        top81 = 'cf_O_top_looseburaus_D_00_O'
        top82 = 'cf_O_top_looseburaus_D_00_U'
        top83 = 'cf_O_top_looseburausu_eri'
        top84 = 'cf_O_top_looseburausu_N_botan'
        top85 = 'cf_O_top_looseburausu_N_eri1'
        top86 = 'cf_O_top_looseburausu_N_O'
        top87 = 'cf_O_top_looseburausu_N_U'
        top88 = 'O_top_looseburaus_D_botan'
        top89 = 'cf_O_looseB_bra_n'
        top90 = 'cf_O_looseB_bra_o'
        top91 = 'cf_O_looseB_bra_u'
        top92 = 'cf_O_top_looseburaus_D_00_O_bra'
        top93 = 'cf_O_top_looseburaus_D_00_U_bra'
        top94 = 'cf_O_top_looseburausu_eri_bra'
        top95 = 'cf_O_top_looseburausu_N_botan_bra'
        top96 = 'cf_O_top_looseburausu_N_eri1_bra'
        top97 = 'cf_O_top_looseburausu_N_O_bra'
        top98 = 'cf_O_top_looseburausu_N_U_bra'
        top99 = 'O_top_looseburaus_D_botan_bra'
        top100 = 'cf_O_looseBlong_bra_n'
        top101 = 'cf_O_looseBlong_bra_o'
        top102 = 'cf_O_looseBlong_bra_u'
        top103 = 'cf_O_top_looseburaus_N_00_O_bra'
        top104 = 'cf_O_top_looseburausu_N_eri2_bra'
        top105 = 'cf_O_top_looseburausulong_N_botan_bra'
        top106 = 'cf_O_top_looseburaus_D_00_010'
        top107 = 'cf_O_top_looseburaus_D_00_04'
        top108 = 'cf_O_top_looseburaus_D_00_U'
        top109 = 'cf_O_top_looseburausu_eri'
        top110 = '▸cf_O_top_looseburausu_N_eri2'
        top111 = 'cf_O_top_looseburausu_N_U'
        top112 = 'cf_O_top_looseburausulong_N_botan'
        top113 = 'O_top_looseburaus_D_botan'
        top114 = 'o_maid_top_a'
        top115 = 'o_maid_top_b'
        top116 = 'cf_o_top_pajama_d_00'
        top117 = 'cf_o_top_pajama_d_00_U'
        top118 = 'cf_o_top_pajama_d_botan'
        top119 = 'cf_o_top_pajama_d_eri'
        top120 = 'cf_o_top_pajama_d_eri1'
        top121 = 'cf_o_top_pajama_n_00'
        top122 = 'cf_o_top_pajama_n_000'
        top123 = 'cf_o_top_pajama_n_000 1'
        top124 = 'cf_o_top_pajama_n_botan'
        top125 = 'cf_o_top_pajama_n_sita_u'
        top126 = 'cf_o_top_pajama_n_ue_u'
        top127 = 'cf_O_topRW_botan'
        top128 = 'cf_O_topRW_brausu_O'
        top129 = 'cf_O_topRW_brausu_U'
        top130 = 'cf_O_topRW_eri2'
        top131 = 'cf_O_topRW_eri4'
        top132 = 'cf_O_topRW_n_botan'
        top133 = 'cf_O_topRW_n_brausu_O'
        top134 = 'cf_O_topRW_n_brausu_U'
        top135 = 'cf_O_topRW_n_eri_sita2'
        top136 = 'cf_O_topRW_n_eri_ue1'
        top137 = 'cf_O_topRW_n_sode'
        top138 = 'cf_O_topRW_sode'
        top139 = 'cf_o_top_waitress_botan'
        top140 = 'cf_O_top_waitress_D_00'
        top141 = 'cf_O_top_waitress_epu_ribon'
        top142 = 'cf_o_top_waitress_epuron_O'
        top143 = 'cf_o_top_waitress_epuron_O 1'
        top144 = 'cf_o_top_waitress_epuron_U'
        top145 = 'cf_o_top_waitress_epuron_U 1'
        top146 = 'cf_O_top_waitress_furiru_D_00'
        top147 = 'cf_O_top_waitress_furiru_D_U'
        top148 = 'cf_O_top_waitress_N_00_O'
        top149 = 'cf_O_top_waitress_N_00_U'
        top150 = 'cf_o_top_waitress_N_botan'
        top151 = 'cf_O_top_waitress_N_epu'
        top152 = 'cf_O_top_waitress_N_epu_ribon_O'
        top153 = 'cf_O_top_waitress_N_furiru_N_O'
        top154 = 'cf_O_top_waitress_N_furiru_N_O1'
        top155 = 'cf_o_waitress_skirt_N_under_O'
        top156 = 'cf_o_waitress_skirt_N_under_U'
        top157 = 'cf_o_waitress_skirt_N_up_O'
        top158 = 'cf_o_waitress_skirt_N_up_U'
        top159 = 'cf_o_waitress_skirt_under_O'
        top160 = 'cf_o_waitress_skirt_under_U'
        top161 = 'cf_o_waitress_skirt_up_O'
        top162 = 'cf_o_waitress_skirt_up_U'
        top163 = 'cf_o_top_wedding_base_d_01'
        top164 = 'cf_o_top_wedding_base_n_u5'
        top165 = 'cf_o_top_wedding_base_n3'
        top166 = 'cf_o_top_wedding_ribon_d_00'
        top167 = 'cf_o_top_wedding_ribon_d_01'
        top168 = 'o_kimono_top_a'
        top169 = 'o_kimono_top_b'
        top170 = 'o_top_miko1_a'
        top171 = 'o_top_miko1_b'
        top172 = 'o_top_miko2_a'
        top173 = 'o_top_miko2_b'
        top174 = 'cf_O_top_gos_base_kosi_n_O'
        top175 = 'cf_O_top_gos_base_kosi_n_U'
        top176 = 'cf_O_top_gos_base_kosi_O'
        top177 = 'cf_O_top_gos_base_kosi_U'
        top178 = 'cf_O_top_gos_base_n_nuge'
        top179 = 'cf_O_top_gos_base_n_U'
        top180 = 'cf_O_top_gos_base_nuge_himo_O'
        top181 = 'cf_O_top_gos_base_nuge_himo_U'
        top182 = 'cf_O_top_gos_base_nuge_O'
        top183 = 'cf_O_top_gos_base_nuge_U'
        top184 = 'cf_O_top_gos_base_O'
        top185 = 'cf_O_top_gos_base_U'
        top186 = 'cf_O_top_gos_eri_base'
        top187 = 'cf_O_top_gos_eri_base_iro'
        top188 = 'cf_O_top_gos_eri_base_iro_n_O'
        top189 = 'cf_O_top_gos_eri_base_iro_n_U'
        top190 = 'cf_O_top_gos_eri_base_iro1'
        top191 = 'cf_O_top_gos_eri_base_n_O'
        top192 = 'cf_O_top_gos_eri_base_n_U'
        top193 = 'cf_O_top_gos_eri_base1'
        top194 = 'cf_O_top_gos_iro_n_U'
        top195 = 'cf_O_top_gos_iro_ribon_00'
        top196 = 'cf_O_top_gos_iro_ribon_01'
        top197 = 'cf_O_top_gos_iro_ribon_02'
        top198 = 'cf_O_top_gos_iro_ribon_03'
        top199 = 'cf_O_top_gos_iro_ribon_04'
        top200 = 'cf_O_top_gos_iro_ribon_mune_O'
        top201 = 'cf_O_top_gos_iro_ribon_mune_U'
        top202 = 'cf_O_top_gos_iro_ribon_n_00'
        top203 = 'cf_O_top_gos_iro_ribon_n_01_O'
        top204 = 'cf_O_top_gos_iro_ribon_n_01_U'
        top205 = 'cf_O_top_gos_iro_ribon_n_02'
        top206 = 'cf_O_top_gos_iro_ribon_n_02_U'
        top207 = 'cf_O_top_gos_kubihimo'
        top208 = 'cf_O_top_gos_kubihimo_n'
        top209 = 'cf_o_top_gos_lace_F'
        top210 = 'cf_o_top_gos_lace_F_n'
        top211 = 'cf_O_top_gos_lace_up'
        top212 = 'cf_O_top_gos_sode_hira_n_O'
        top213 = 'cf_O_top_gos_sode_hira_n_U'
        top214 = 'cf_O_top_gos_sode_hira_O'
        top215 = 'cf_O_top_gos_sode_hira_U'
        top216 = 'cf_o_top_wedding_base_d_01'
        top217 = 'cf_o_top_wedding_base_n_u5'
        top218 = 'cf_o_top_wedding_base_n3'
        top219 = 'cf_o_top_wedding_ribon_d_00'
        top220 = 'cf_o_top_wedding_ribon_d_01'
        top221 = 'o_sis1_top_a'
        top222 = 'o_sis1_top_b'
        top223 = 'cf_O_top_sailoroneP_d_00'
        top224 = 'cf_O_top_sailoroneP_d_O'
        top225 = 'cf_O_top_sailorone P_d_U'
        top226 = 'cf_O_top_sailoroneP_eri_d'
        top227 = 'cf_O_top_sailoroneP_eri_d_U'
        top228 = 'cf_O_top_sailoroneP_eri_n'
        top229 = 'cf_O_top_sailoroneP_eri_n_U'
        top230 = 'cf_O_top_sailoroneP_n'
        top231 = 'cf_O_top_sailoroneP_n_O'
        top232 = 'cf_O_top_sailorone P_n_U'
        top233 = 'cf_O_top_sailoroneP_sode_d_O'
        top234 = 'cf_O_top_sailoroneP_sode_d_U'
        top235 = 'cf_O_top_sailoroneP_sode_n_O'
        top236 = 'cf_O_top_sailoroneP_sode_n_U'
        top237 = 'cf_O_top_sailoroneP_tie_01'
        top238 = 'cf_O_top_sailoroneP_tie_01_U'
        top239 = 'cf_O_top_sailoroneP_tie_02'
        top240 = 'cf_O_top_sailoroneP_tie_02_U'
        top241 = 'cf_O_top_sailoroneP_tie_n_O'
        top242 = 'cf_O_top_sailoroneP_tie_n_U'
        top243 = 'cf_O_top_sailoroneP_tie_tome'
        top244 = 'o_top_idol1_a'
        top245 = 'o_top_idol1_b'
        top246 = 'O_top01_00'
        top247 = 'O_top01_01'
        top248 = 'O_top01_01_b'
        top249 = 'O_top01_01_b_u'
        top250 = 'O_top01_01_u'
        top251 = 'O_top01_b'
        top252 = 'o_top_kuno1_b_a'
        top253 = 'o_top_kuno1_b_a_u'
        top254 = 'o_top_kuno1_b_b'
        top255 = 'o_top_kuno1_b_b_u'
        top256 = 'o_top_kuno1_t_a'
        top257 = 'o_top_kuno1_t_a_u'
        top258 = 'o_top_kuno1_t_b'
        top259 = 'o_top_kuno1_t_b_u'
        top260 = 'cf_o_LA_chunic_d_00'
        top261 = 'cf_o_LA_chunic_d_kosi'
        top262 = 'cf_o_LA_chunic_d_mune'
        top263 = 'cf_o_LA_chunic_d_neck'
        top264 = 'cf_o_LA_chunic_d_ribon'
        top265 = 'cf_o_LA_chunic_d_ribon_u'
        top266 = 'cf_o_LA_chunic_n_00'
        top267 = 'cf_o_LA_chunic_n_00_U'
        top268 = 'cf_o_LA_chunic_n_kosi'
        top269 = 'cf_o_LA_chunic_n_neck'
        top270 = 'cf_o_LA_chunic_n_ribon_O'
        top271 = 'cf_o_LA_chunic_n_ribon_U'
        top272 = 'cf_o_leather_aromor_d_ura'
        top273 = 'cf_o_leather_aromor_d_00'
        top274 = 'cf_o_leather_aromor_d_himo'
        top275 = 'cf_o_leather_aromor_d_kanagu'
        top276 = 'cf_o_leather_aromor_n_00'
        top277 = 'cf_o_leather_aromor_n_00_u'
        top278 = 'cf_o_leather_aromor_n_himo'
        top279 = 'cf_o_leather_aromor_n_kanagu'
        top280 = 'cf_o_leather_aromor_n_ura'
        top281 = 'o_top_robe1_top_a'
        top282 = 'o_top_robe1_top_b'
        top283 = 'o_top_robe2_a_wap'
        top284 = 'o_top_robe2_b_wap'
        top285 = 'o_top_robe2_top_a'
        top286 = 'o_top_robe2_top_b'
        top287 = 'o_top_tasuki_bot_a'
        top288 = 'o_top_tasuki_bot_b'
        top289 = 'o_top_tasuki_top_a'
        top290 = 'o_top_tasuki_top_b'
        top291 = 'o_yayoi_top_2_a'
        top292 = 'o_yayoi_top_a'
        top293 = 'o_yayoi_top_b'
        top294 = 'o_top_robe1_bot_a'
        top295 = 'o_top_robe1_bot_b'
        top296 = 'o_top_robe2_bot_a'
        top297 = 'o_top_robe2_bot_b'
        top298 = 'cf_o_top_PN_bro_L'
        top299 = 'cf_o_top_PN_bro_R'
        top300 = 'cf_O_top_PN_d_00'
        top301 = 'cf_O_top_PN_d_00_k'
        top302 = 'cf_O_top_PN_n_00'
        top303 = 'cf_O_top_PN_n_00_in'
        top304 = 'cf_O_top_PN_n_00_kubi'
        top305 = 'cf_O_top_PN_n_00_u'
        top306 = 'cf_O_top_PN_sode_d_00'
        top307 = 'cf_O_top_PN_sode_d_00 1'
        top308 = 'cf_O_top_PN_sode_d_03'
        top309 = 'cf_O_top_PN_sode_d_03 1'
        top310 = 'cf_O_top_PN_sode_d_ribon_O'
        top311 = 'cf_O_top_PN_sode_d_ribon_O 1'
        top312 = 'cf_O_top_PN_sode_d_ribon_U'
        top313 = 'cf_O_top_PN_sode_d_ribon_U 1'
        top314 = 'cf_O_top_PN_sode_fu_d_00'
        top315 = 'cf_O_top_PN_sode_fu_d_00 1'
        top316 = 'cf_O_top_PN_sode_fu_d_01'
        top317 = 'cf_O_top_PN_sode_fu_d_01 1'
        top318 = 'cf_O_top_PN_sode_in_d_02'
        top319 = 'cf_O_top_PN_sode_in_d_02 1'
        top320 = 'cf_o_top_PN_tare'
        top321 = 'cf_o_top_PN_tare_n'
        top322 = 'cf_o_top_PN_tare_n_U'
        top323 = 'cf_o_top_PN_tare_U'
        top324 = 'cf_o_top_HM_belt'
        top325 = 'cf_o_top_HM_beruto_n'
        top326 = 'cf_o_top_HM_d_O'
        top327 = 'cf_o_top_HM_d_U'
        top328 = 'cf_o_top_HM_kanagu'
        top329 = 'cf_o_top_HM_kanagu_n'
        top330 = 'cf_o_top_HM_kosi_himo_sita_O'
        top331 = 'cf_o_top_HM_kosi_himo_sita_O_n'
        top332 = 'cf_o_top_HM_kosi_himo_sita_U'
        top333 = 'cf_o_top_HM_kosi_himo_sita_U_n'
        top334 = 'cf_o_top_HM_kosi_himo_ue_O'
        top335 = 'cf_o_top_HM_kosi_himo_ue_O_n'
        top336 = 'cf_o_top_HM_kosi_himo_ue_U'
        top337 = 'cf_o_top_HM_kosi_himo_ue_U_n'
        top338 = 'cf_o_top_HM_n_O'
        top339 = 'cf_o_top_HM_n_ska_O'
        top340 = 'cf_o_top_HM_n_ska_u'
        top341 = 'cf_o_top_HM_n_u'
        top342 = 'cf_o_top_HM_naka'
        top343 = 'cf_o_top_HM_naka_n'
        top344 = 'cf_o_top_HM_ska_n_naka_U'
        top345 = 'cf_o_top_HM_ska_O_U'
        top346 = 'cf_o_top_HM_ska_O3'
        top347 = 'O_top01_01'
        top348 = 'O_top01_01_b'
        top349 = 'O_top01_01_b_u'
        top350 = 'O_top01_01_u'
        top351 = 'cf_O_ovtop_Enurse3'
        top352 = 'cf_O_ovtop_Enurse4'
        top353 = 'cf_O_ovtop_Enurse_botam_06'
        # bot names:
        bot1 = 'O_bot00'
        bot2 = 'O_bot00 1'
        bot3 = 'O_bot01_d'
        bot4 = 'O_bot01_d_u'
        bot5 = 'O_bot01_n'
        bot6 = 'O_bot01_n_u'
        bot7 = 'O_bot00_d'
        bot8 = 'O_bot00_d_u'
        bot9 = 'O_bot00_n'
        bot10 = 'O_bot03_d'
        bot11 = 'O_bot03_n'
        bot12 = 'O_bot02_d'
        bot13 = 'O_bot_d'
        bot14 = 'O_bot_n'
        bot15 = 'o_bot_n'
        bot16 = 'cf_O_bot_shortP_d_00'
        bot17 = 'cf_O_bot_shortP_d_00_U'
        bot18 = 'cf_O_bot_shortP_n_00'
        bot19 = 'cf_O_bot_shortP_n_00 1'
        bot20 = 'cf_O_bot_shortPC_d_00'
        bot21 = 'cf_O_bot_shortPC_d_00_U'
        bot22 = 'cf_O_bot_shortPC_d_01_sode_L'
        bot23 = 'cf_O_bot_shortPC_d_01_sode_L 1'
        bot24 = 'cf_O_bot_shortPC_d_01_sode_R'
        bot25 = 'cf_O_bot_shortPC_d_01_sode_R 1'
        bot26 = 'cf_O_bot_shortPC_d_swerter'
        bot27 = 'cf_O_bot_shortPC_d_swerter_U'
        bot28 = 'cf_O_bot_shortPC_n_00'
        bot29 = 'cf_O_bot_shortPC_n_00_U'
        bot30 = 'cf_O_bot_shortPC_n_sweater'
        bot31 = 'cf_O_bot_shortPC_n_sweater 1'
        bot32 = 'cf_o_bot_pajama_d_01'
        bot33 = 'cf_O_botRW_skirt'
        bot34 = 'cf_O_botRW_skirt_n'
        bot35 = 'cf_O_botRW_epuron'
        bot36 = 'cf_O_botRW_epuron_n'
        bot37 = 'cf_O_bot_gos_iro_ribon_ska'
        bot38 = 'cf_O_bot_gos_iro_ribon_ska_U'
        bot39 = 'cf_O_bot_gos_ska_base_line_O'
        bot40 = 'cf_O_bot_gos_ska_furiru_iro_O'
        bot41 = 'cf_O_bot_gos_ska_furiru_iro_O1'
        bot42 = 'cf_O_bot_gos_ska_furiru_O'
        bot43 = 'cf_O_bot_gos_ska_furiru_U'
        bot44 = 'cf_O_bot_gos_ska_iro_lace_mini'
        bot45 = 'cf_O_bot_gos_ska_iro_O'
        bot46 = 'cf_O_bot_gos_ska_iro_U'
        bot47 = 'cf_O_bot_gos_ska_Lace_iro_O'
        bot48 = 'cf_O_bot_gos_ska_ue_O'
        bot49 = 'cf_O_bot_gos_ska_ue_O1'
        bot50 = 'cf_O_bot_ska_base_iro_n_O'
        bot51 = 'cf_O_bot_ska_base_iro_n_U'
        bot52 = 'cf_O_bot_ska_base_line_n_O'
        bot53 = 'cf_O_bot_ska_huriru_jro_n_O'
        bot54 = 'cf_O_bot_ska_huriru_iro_n_U'
        bot55 = 'cf_O_bot_ska_lace_n'
        bot56 = 'cf_O_bot_ska_n_huriru_O'
        bot57 = 'cf_O_bot_ska_n_huriru_U'
        bot58 = 'cf_O_bot_ska_n_ue_O'
        bot59 = 'cf_O_bot_ska_n_ue_U'
        bot60 = 'cf_O_bot_ska_ribon_n_O'
        bot61 = 'cf_O_bot_ska_ribon_n_U'
        bot62 = 'cf_0_bot_GOS_ribon_side_iro_N_O'
        bot63 = 'cf_0_bot_GOS_ribon_side_iro_N_U'
        bot64 = 'cf_0_bot_GOS_ribon_side_iro_O'
        bot65 = 'cf_0_bot_GOS_ribon_side_iro_U'
        bot66 = 'cf_o_bot_GOS_Z_poke_huriru_iro_N_O'
        bot67 = 'cf_o_bot_GOS_Z_poke_huriru_iro_N_U'
        bot68 = 'cf_o_bot_GOS_Z_poke_huriru_iro_O'
        bot69 = 'cf_o_bot_GOS_Z_poke_huriru_iro_U'
        bot70 = 'cf_o_bot_GOS_zubon_base_d'
        bot71 = 'cf_o_bot_GOS_zubon_base_n_O'
        bot72 = 'cf_o_bot_GOS_zubon_base_n_suso_U'
        bot73 = 'cf_o_bot_GOS_zubon_base_n_U'
        bot74 = 'cf_o_bot_GOS_zubon_base_u'
        bot75 = 'cf_o_bot_GOS_zubon_huriru_d'
        bot76 = 'cf_o_bot_GOS_zubon_huriru_d_U'
        bot77 = 'cf_o_bot_GOS_zubon_huriru_d_U 1'
        bot78 = 'cf_o_bot_GOS_zubon_huriru_n_iro_O'
        bot79 = 'cf_o_bot_GOS_zubon_iro_d'
        bot80 = 'cf_o_bot_GOS_zubon_iro_d_U'
        bot81 = 'cf_o_bot_GOS_zubon_iro_n'
        bot82 = 'cf_o_bot_GOS_zubon_iro_n_U'
        bot83 = 'cf_o_bot_GOS_zubon_lase_iro'
        bot84 = 'cf_o_bot_GOS_zubon_lase_iro_n'
        bot85 = 'cf_o_bot_GOS_zubon_line_iro_n_U'
        bot86 = 'cf_o_bot_GOS_zubon_ribon_iro'
        bot87 = 'cf_o_bot_GOS_zubon_ribon_iro_N_O'
        bot88 = 'cf_o_bot_GOS_zubon_ribon_iro_N_U'
        bot89 = 'cf_o_bot_GOS_zubon_ribon_iro_U'
        bot90 = 'cf_o_bot_n_wedding_kosi'
        bot91 = 'cf_o_bot_weding_skirt_n_o'
        bot92 = 'cf_o_bot_weding_skirt_n_u'
        bot93 = 'cf_o_bot_weding_skirt_o'
        bot94 = 'cf_o_bot_weding_skirt_u'
        bot95 = 'cf_o_botd__wedding_kosi'
        bot96 = 'o_bot_idol_d'
        bot97 = 'o_bot_idol_n'
        bot98 = 'o_bot_robe2_a'
        bot99 = 'o_bot_robe2_a_u'
        bot100 = 'o_bot_robe2_b'
        bot101 = 'o_bot_robe2_b_u'
        bot102 = 'o_tightpants_a'
        bot103 = 'o_tightpants_b'
        bot104 = 'cf_O_bot_shortP_d_tare'
        bot105 = 'cf_O_bot_shortP_d_tare_U'
        bot106 = 'cf_O_bot_shortP_n_tare'
        bot107 = 'cf_O_bot_shortP_n_tare_u'
        bot108 = 'cf_o_LA_skirt_d_00'
        bot109 = 'cf_o_LA_skirt_d_beruto_d_01'
        bot110 = 'cf_o_LA_skirt_d_kanagu'
        bot111 = 'cf_o_LA_skirt_d_kosi'
        bot112 = 'cf_o_LA_skirt_d_kosi_U'
        bot113 = 'cf_o_LA_skirt_d_lace_O1'
        bot114 = 'cf_o_LA_skirt_d_lace_U'
        bot115 = 'cf_o_LA_skirt_d_pouch'
        bot116 = 'cf_o_LA_skirt_n_00'
        bot117 = 'cf_o_LA_skirt_n_00_u'
        bot118 = 'cf_o_LA_skirt_n_kanagu'
        bot119 = 'cf_o_LA_skirt_n_kosi'
        bot120 = 'cf_o_LA_skirt_n_lace_O'
        bot121 = 'cf_o_LA_skirt_n_lace_U'
        bot122 = 'cf_o_LA_skirt_u_00'
        bot123 = 'o_yayoi_bot_a'
        bot124 = 'o_yayoi_bot_n'
        bot125 = 'cf_o_bot_furiru_PN_01'
        bot126 = 'cf_o_bot_furiru_PN_01_U'
        bot127 = 'cf_o_bot_furiru_PN_02'
        bot128 = 'cf_o_bot_furiru_PN_02_U'
        bot129 = 'cf_o_bot_furiru_PN_03'
        bot130 = 'cf_o_bot_furiru_PN_03_U'
        bot131 = 'cf_o_bot_ska_PN_himo'
        bot132 = 'cf_o_bot_ska_PN_himo_n'
        bot133 = 'cf_o_bot_ska_PN_himo_n_u'
        bot134 = 'cf_o_bot_ska_PN_himo_U'
        bot135 = 'cf_o_bot_ska_PN_N_O'
        bot136 = 'cf_o_bot_ska_PN_N_U'
        bot137 = 'cf_o_bot_ska_PN_und'
        bot138 = 'cf_o_bot_ska_PN_und_U'
        bot139 = 'cf_o_bot_ska_PN_up'
        bot140 = 'cf_o_bot_ska_PN_up_U'
        bot141 = 'cf_o_bot_skaRIbon_PN_01'
        bot142 = 'cf_o_bot_skaRIbon_PN_01_U'
        bot143 = 'cf_o_bot_skaRIbon_PN_02'
        bot144 = 'cf_o_bot_skaRIbon_PN_02_U'
        bot145 = 'cf_o_bot_skaRIbon_PN_03'
        bot146 = 'cf_o_bot_skaRIbon_PN_03_U'
        bot147 = 'cf_o_bot_zb_PN_d'
        bot148 = 'cf_o_bot_zb_PN_d_ribon'
        bot149 = 'cf_o_bot_zb_PN_d_ribon 1'
        bot150 = 'cf_o_bot_zb_PN_d_ribon_u'
        bot151 = 'cf_o_bot_zb_PN_d4'
        bot152 = 'cf_o_bot_zb_PN_d4 1'
        bot153 = 'cf_o_bot_zb_PN_d5'
        bot154 = 'cf_o_bot_zb_PN_n_ribon_u'
        bot155 = 'O_bot00_a'
        bot156 = 'O_bot00_b'
        bot157 = 'o_bot_a'
        bot158 = 'o_bot_b'
        bot159 = 'cf_o_AP_n_bot'
        bot160 = 'cf_o_AP_n_bot_u'
        bot161 = 'cf_o_AP_d_bot'
        bot162 = 'cf_o_AP_d_bot_u'
        bot163 = 'cf_o_bot_kimono_D_O'
        bot164 = 'cf_o_bot_kimono_D_U'
        bot165 = 'cf_o_bot_kimono_N_O'
        bot166 = 'cf_o_bot_kimono_N_O1'
        bot167 = 'cf_o_bot_kimonoGOS_D_01'
        bot168 = 'cf_o_bot_kimonoGOS_D_02'
        bot169 = 'cf_o_bot_kimonoGOS_D_huriru'
        bot170 = 'cf_o_bot_kimonoGOS_D_huriru_nuki'
        bot171 = 'cf_o_bot_kimonoGOS_D_huriru_U'
        bot172 = 'cf_o_bot_kimonoGOS_N'
        bot173 = 'cf_o_bot_kimonoGOS_N_huriru'
        bot174 = 'cf_o_bot_kimonoGOS_N_huriru_U'
        bot175 = 'cf_o_bot_kimonoGOS_N_race'
        bot176 = 'cf_o_bot_kimonoGOS_N_U'
        bot177 = 'cf_bot_kimonoGOS_ska_ribon'
        bot178 = 'cf_bot_kimonoGOS_ska_ribonN'
        bot179 = 'cf_bot_kimonoGOS_ska_ribonN_U'
        bot180 = 'cf_bot_kimonoGOS_ska_ribonU'
        bot181 = 'cf_o_bot_splitska_D_00'
        bot182 = 'cf_o_bot_splitska_D_00_U'
        bot183 = 'cf_o_bot_splitska_D_furiru'
        bot184 = 'cf_o_bot_splitska_D_race'
        bot185 = 'cf_o_bot_splitska_D_ribon'
        bot186 = 'cf_o_bot_splitska_D_ribon_U'
        bot187 = 'cf_o_bot_splitska_N_00'
        bot188 = 'cf_o_bot_splitska_N_00_U'
        bot189 = 'cf_o_bot_splitska_N_furiru'
        bot190 = 'cf_o_bot_splitska_N_race'
        bot191 = 'cf_o_bot_splitska_N_ribon'
        bot192 = 'cf_o_bot_splitska_N_ribonU'
        bot193 = 'cf_o_bot_kimono_D_O'
        bot194 = 'cf_o_bot_kimono_D_U'
        bot195 = 'cf_o_bot_kimono_N_O'
        bot196 = 'cf_o_bot_kimono_N_O1'
        bot197 = 'o_bot_a'
        bot198 = 'o_bot_n'
        bot199 = 'o_fri1'
        bot200 = 'o_fri2'
        bot201 = 'o_maid_bot_d'
        bot202 = 'o_maid_bot_n'
        bot203 = 'cf_o_waitress_skirt_N_under_O'
        bot204 = 'cf_o_waitress_skirt_N_under_U'
        bot205 = 'cf_o_waitress_skirt_N_up_O'
        bot206 = 'cf_o_waitress_skirt_N_up_U'
        bot207 = 'cf_o_waitress_skirt_under_O'
        bot208 = 'cf_o_waitress_skirt_under_U'
        bot209 = 'cf_o_waitress_skirt_up_O'
        bot210 = 'cf_o_waitress_skirt_up_U'
        bot211 = 'o_kimono_bot_a'
        bot212 = 'o_kimono_bot_b'
        bot213 = 'o_kimono_obi_a'
        bot214 = 'o_bot_miko1_a'
        bot215 = 'o_bot_miko1_b'
        bot216 = 'o_bot_miko2_2_a'
        bot217 = 'o_bot_miko2_a'
        bot218 = 'o_bot_miko2_b'
        bot219 = 'o_sis1_bot_d'
        bot220 = 'o_sis1_bot_n'
        bot221 = 'cf_O_ovbot_Enurse_aka_d'
        bot222 = 'cf_O_ovbot_Enurse_base_d_O'
        bot223 = 'cf_O_ovbot_Enurse_base_d_U'
        bot224 = 'cf_O_ovbot_Enurse_heartB'
        bot225 = 'o_bot_d'
        # shoes names:
        shoes1 = 'cf_O_shoes_01'
        shoes2 = 'cf_O_shoes_02'
        shoes3 = 'cf_O_shoes_03'
        shoes4 = 'cf_O_shoes_04'
        shoes5 = 'cf_O_shoes_05'
        shoes6 = 'cf_O_shoes_06'
        shoes7 = 'cf_O_shoes_07'
        shoes8 = 'cf_O_shoes_08'
        shoes9 = 'cf_O_shoes_09'
        shoes10 = 'cf_O_shoes_10'
        shoes11 = 'cf_O_shoes_11'
        shoes12 = 'cf_O_shoes_12'
        shoes13 = 'cf_O_shoes_13'
        shoes14 = 'cf_O_shoes_14'
        shoes15 = 'cf_O_shoes_15'
        shoes16 = 'cf_O_shoes_16'
        shoes17 = 'cf_O_shoes_16_02'
        shoes18 = 'cf_O_shoes_17'
        shoes19 = 'cf_O_shoes_17_02'
        shoes20 = 'cf_O_shoes_18'
        shoes21 = 'cf_O_shoes_19'
        shoes22 = 'O_shoes_20'
        shoes23 = 'O_shoes_21'
        shoes24 = 'o_shoes_con'
        shoes25 = 'cf_o_shoes_aplong'
        shoes26 = 'cf_o_shoes_apshort'
        shoes27 = 'cf_O_shoes_ballet_base'
        shoes28 = 'cf_O_shoes_ballet_soko'
        shoes29 = 'o_shoes_china_00'
        shoes30 = 'cf_O_shoes_china'
        shoes31 = 'O_shoes_gla01'
        shoes32 = 'cf_o_shoes_glass_O'
        shoes33 = 'cf_o_shoes_glass_U'
        shoes34 = 'cf_O_shoes_kaigara'
        shoes35 = 'cf_O_shoes_loose_R'
        shoes36 = 'o_magic_shoes'
        shoes37 = 'cf_o_shoes_plant_L'
        shoes38 = 'cf_O_shoes_plant_S'
        shoes39 = 'cf_O_shoes_RW_01'
        shoes40 = 'cf_O_shoes_RW_02'
        shoes41 = 'cf_O_shoes_sweet'
        shoes42 = 'cf_O_shoes_uwabaki_ao'
        shoes43 = 'cf_o_shoes_waitress_00'
        shoes44 = 'cf_O_shoes_weastern'
        shoes45 = 'cf_o_shoes_wedding_base'
        shoes46 = 'cf_o_shoes_Xmas'
        shoes47 = 'cf_O_shoes_zouri_00'
        shoes48 = 'cf_O_shoes_zouri_00_base'
        shoes49 = 'cf_O_shoes_zouri_B'
        shoes50 = 'cf_O_shoes_zouri_B_iro'
        shoes51 = 'cf_O_shoes_zouri_R'
        shoes52 = 'cf_O_shoes_zouri_R_iro'
        shoes53 = 'o_zouri'
        shoes54 = 'o_shoes_miko1'
        shoes55 = 'cf_o_shoes_gos_base'
        shoes56 = 'cf_o_shoes_GOS_boots_base'
        shoes57 = 'o_shoes_sis1'
        shoes58 = 'o_shoes_sis1_r'
        shoes59 = 'o_bond1_shoes_1'
        shoes60 = 'o_bond1_shoes_himo_1'
        shoes61 = 'o_camp1_shoes'
        shoes62 = 'cf_o_shoes_Emagi'
        shoes63 = 'o_idol1_shoes'
        shoes64 = 'cf_o_shoes_Xmas_iro'
        shoes65 = 'o_armor1_shoes'
        shoes66 = 'cf_O_shoes_sandal_asikubi'
        shoes67 = 'cf_O_shoes_sandal_asikubi_U'
        shoes68 = 'cf_O_shoes_sandal_kin'
        shoes69 = 'cf_O_shoes_sandal_kin_huchi'
        shoes70 = 'cf_O_shoes_sandal_kin_huchi_U'
        shoes71 = 'cf_O_shoes_sandal_nuno'
        shoes72 = 'cf_O_shoes_sandal_nuno_U'
        shoes73 = 'cf_O_shoes_sandal_soko'
        shoes74 = 'o_shoes_hood1'
        shoes75 = 'o_shoes_hood1_far'
        shoes76 = 'o_shoes_kuno1'
        shoes77 = 'cf_O_shoes_Lboots_base'
        shoes78 = 'cf_O_shoes_Lboots_base_U'
        shoes79 = 'cf_O_shoes_Lboots_kanagu'
        shoes80 = 'cf_O_shoes_Lboots_nuno'
        shoes81 = 'cf_O_shoes_Lboots_nuno_U'
        shoes82 = 'cf_O_shoes_Lboots_ue'
        shoes83 = 'cf_O_shoes_Lboots_ue_U'
        shoes84 = 'o_shoes_robe1'
        shoes85 = 'o_robe2_shoes'
        shoes86 = 'o_shoes_bikiarm1'
        shoes87 = 'battleboots_mesh'
        shoes88 = 'o_yayoi_shoes'
        shoes89 = 'cf_o_shoes_PN_00'
        shoes90 = 'cf_o_shoes_PN_hane'
        shoes91 = 'cf_o_shoes_PN_hiza'
        shoes92 = 'cf_o_shoes_PN_hiza_u'
        shoes93 = 'cf_o_shoes_PN_ura'
        shoes94 = 'cf_o_shoes_HM'
        shoes95 = 'cf_o_shoes_HM_u'
        shoes96 = 'muma_shoes'
        # short names:
        short1 = 'cf_O_shorts_d'
        short2 = 'cf_O_shorts_d_u'
        short3 = 'cf_O_shorts_n'
        short4 = 'cf_O_shorts_n_u'
        # bra names:
        bra1 = 'cf_O_bra_d'
        bra2 = 'cf_O_bra_n'
        bra3 = 'cf_O_bra_n1'
        bra4 = 'cf_O_bra_n2'
        bra5 = 'cf_O_bra_n3'
        # socks names:
        socks1 = 'cf_O_socks01'
        socks2 = 'cf_O_socks02'
        socks3 = 'cf_O_socks03'
        socks4 = 'cf_O_socks04'
        socks5 = 'cf_O_socks05'
        socks6 = 'cf_O_socks05_02'
        socks7 = 'cf_O_socks06'
        socks8 = 'cf_O_socks07'
        socks9 = 'cf_O_socks08'
        socks10 = 'cf_O_socks09_00'
        socks11 = 'cf_O_socks09_01'
        socks12 = 'cf_O_socks_ballet'
        socks13 = 'O_socks_boro01'
        socks14 = 'cf_O_socks_china'
        socks15 = 'cf_O_socks_china_U'
        socks16 = 'cf_o_socks_halloween'
        socks17 = 'cf_o_socks_kaigara'
        socks18 = 'cf_o_socks_kaigara_line'
        socks19 = 'cf_o_socks_kaigara_line_U'
        socks20 = 'cf_o_socks_kaigara_ribon'
        socks21 = 'cf_o_socks_kaigara_siro'
        socks22 = 'cf_o_socks_kaigara_siro_U'
        socks23 = 'cf_o_socks_ivy'
        socks24 = 'cf_o_socks_ivy_leaf'
        socks25 = 'cf_O_socks_sweet'
        socks26 = 'cf_O_socks_sweet_ribon'
        socks27 = 'cf_O_socks_sweetS'
        socks28 = 'cf_O_socks_sweetS_ribon'
        socks29 = 'cf_O_socks_tabi'
        socks30 = 'cf_O_socks_waitress_00'
        socks31 = 'cf_O_socks_waitress_01_O'
        socks32 = 'cf_O_socks_waitress_01_U'
        socks33 = 'cf_O_socks_wedding'
        socks34 = 'o_socks_leopord'
        socks35 = 'o_socks_miko2'
        socks36 = 'o_camp1_socks'
        socks37 = 'cf_O_socks_Emagi'
        socks38 = 'cf_O_socks_Xmas_CC'
        socks39 = 'cf_O_socks_Xmas_CC_ke_00'
        socks40 = 'cf_O_socks_Xmas_CC_ke_00_U'
        socks41 = 'cf_O_socks_Xmas_CC_ke_01'
        socks42 = 'cf_O_socks_Xmas_CC_ke_01_U'
        socks43 = 'cf_O_socks_Xmas_CC_ke_02'
        socks44 = 'cf_O_socks_Xmas_CC_ke_02_U'
        socks45 = 'cf_O_socks_Xmas_CC_ke_03'
        socks46 = 'cf_O_socks_Xmas_CC_ke_03_U'
        socks47 = 'cf_o_socks_dancer_amidown'
        socks48 = 'cf_o_socks_dancer_amidown_U'
        socks49 = 'cf_o_socks_dancer_amiup'
        socks50 = 'cf_o_socks_dancer_amiup_U'
        socks51 = 'cf_o_socks_dancer_base'
        socks52 = 'cf_o_socks_dancer_base_U'
        socks53 = 'cf_o_socks_dancer_kin'
        socks54 = 'cf_o_socks_dancer_lace'
        socks55 = 'cf_o_socks_dancer_lace_U'
        socks56 = 'o_socks_hood1'
        socks57 = 'o_socks_hood1_u'
        socks58 = 'o_socks_kuno1'
        socks59 = 'cf_O_socks_Larmor'
        socks60 = 'cf_o_socks_paerlB_00'
        socks61 = 'cf_o_socks_paerlB_00_U'
        socks62 = 'cf_o_socks_paerlB_lace'
        socks63 = 'cf_o_socks_paerlB_lace_u'
        socks64 = 'cf_o_socks_paerlB_pearl'
        socks65 = 'cf_o_socks_paerlB_ribon'
        socks66 = 'cf_o_socks_paerlB_ribon_u'
        socks67 = 'cf_o_socks_Hunder_00_O'
        socks68 = 'cf_o_socks_Hunder_00_U'
        socks69 = 'o_yayoi_socks'
        socks70 = 'cf_o_socks_CF'
        socks71 = 'cf_o_socks_CF_flower_O'
        socks72 = 'cf_o_socks_CF_flower_U'
        socks73 = 'cf_O_socks_CF_frill_O'
        socks74 = 'cf_O_socks_CF_frill_U'
        socks75 = 'cf_o_socks_CF_ribon_O'
        socks76 = 'cf_o_socks_CF_ribon_U'
        # gloves names:
        glove1 = 'cf_O_glove01'
        glove2 = 'cf_O_glove02'
        glove3 = 'cf_O_glove03'
        glove4 = 'cf_O_glove04'
        glove5 = 'cf_O_glove05'
        glove6 = 'cf_O_glove05_02'
        glove7 = 'cf_O_glove06'
        glove8 = 'cf_O_glove06_02'
        glove9 = 'cf_O_glove07'
        glove10 = 'cf_O_glove07_01'
        glove11 = 'cf_O_glove08_01'
        glove12 = 'cf_O_glove08_02'
        glove13 = 'O_glove06'
        glove14 = 'O_glove_spy'
        glove15 = 'cf_O_glove_sweet'
        glove16 = 'cf_O_glove_sweet_01'
        glove17 = 'cf_o_glove_sweet_ribon'
        glove18 = 'o_glove_con'
        glove19 = 'cf_O_glove_china'
        glove20 = 'cf_O_glove_china_U'
        glove21 = 'cf_O_glove_cow'
        glove22 = 'cf_O_glove_cow_hira_O'
        glove23 = 'cf_O_glove_cow_hira_U'
        glove24 = 'cf_O_glove_halloween'
        glove25 = 'cf_o_glove_kaigara'
        glove26 = 'cf_o_glove_kaigara_line'
        glove27 = 'cf_o_glove_kaigara_line_U'
        glove28 = 'cf_o_glove_kaigara_ribon'
        glove29 = 'cf_o_glove_kaigara_siro'
        glove30 = 'cf_o_glove_kaigara_siro_U'
        glove31 = 'o_magic_glove'
        glove32 = 'cf_o_glove_ivy'
        glove33 = 'cf_o_glove_ivy_leaf'
        glove34 = 'cf_o_glove_waitress_O'
        glove35 = 'cf_o_glove_waitress_U'
        glove36 = 'cf_O_glove_wedding_long'
        glove37 = 'cf_O_glove_wedding_long_race'
        glove38 = 'cf_O_glove_wedding_long_ribon'
        glove39 = 'cf_O_glove_wedding_short'
        glove40 = 'cf_O_glove_wedding_short_race'
        glove41 = 'cf_O_glove_wedding_short_ribon'
        glove42 = 'cf_O_glove_Xmas'
        glove43 = 'cf_O_glove_neglace_O'
        glove44 = 'cf_o_glove_neglace_ribon_O'
        glove45 = 'cf_o_glove_neglace_ribon_U'
        glove46 = 'cf_O_glove_neglace_U'
        glove47 = 'o_bond1_glove_1'
        glove48 = 'o_bond1_glove_himo_1'
        glove49 = 'cf_O_glove_Xmas_CC_iro'
        glove50 = 'cf_O_glove_Xmas_CC_siro'
        glove51 = 'cf_o_glove_dancer'
        glove52 = 'cf_o_glove_dancer_kin'
        glove53 = 'cf_o_glove_dancer_naka'
        glove54 = 'cf_o_glove_dancer_naka_kin'
        glove55 = 'cf_o_glove_dancer_U'
        glove56 = 'cf_O_glove_LG_iro_L'
        glove57 = 'cf_O_glove_LG_L'
        glove58 = 'cf_O_glove_LG_L_U'
        glove59 = 'cf_O_glove_LG_lace_L'
        glove60 = 'cf_O_glove_LG_lace_L_U'
        glove61 = 'cf_O_glove_LG_lanagu'
        glove62 = 'cf_O_glove_LG_iro_M'
        glove63 = 'cf_O_glove_LG_iro_M_u'
        glove64 = 'cf_O_glove_LG_lace_M'
        glove65 = 'cf_O_glove_LG_lace_M_u'
        glove66 = 'cf_O_glove_LG_lanagu_M'
        glove67 = 'cf_O_glove_LG_M'
        glove68 = 'cf_O_glove_LG_M_U'
        glove69 = 'o_glove_armor1'
        glove70 = 'o_gloves_hood1'
        glove71 = 'o_gloves_kuno1'
        glove72 = 'o_gloves_kuno1_2'
        glove73 = 'o_gloves_robe1'
        glove74 = 'cf_o_glove_paerlB_00'
        glove75 = 'cf_o_glove_paerlB_00_lace'
        glove76 = 'cf_o_glove_paerlB_00_lace_u'
        glove77 = 'cf_o_glove_paerlB_00_u'
        glove78 = 'cf_o_glove_paerlB_pearl'
        glove79 = 'cf_o_glove_paerlB_ribon'
        glove80 = 'cf_o_glove_paerlB_ribon_u'
        glove81 = 'o_yayoi_arm'
        glove82 = 'o_yayoi_gloves'
        glove83 = 'cf_o_glove_PN_O'
        glove84 = 'cf_o_glove_PN_U'
        glove85 = 'cf_O_glove_HM_00'
        glove86 = 'cf_O_glove_HM_00_u'
        glove87 = 'cf_O_glove_HM_himo'
        glove88 = 'cf_O_glove_HM_himo_u'
        glove89 = 'cf_O_glove_HM_ribon'
        glove90 = 'cf_O_glove_HM_ribon_u'
        glove91 = 'cf_O_glove_CF'
        glove92 = 'cf_o_glove_CF_flower_O'
        glove93 = 'cf_o_glove_CF_flower_u'
        glove94 = 'cf_o_glove_CF_in'
        glove95 = 'cf_o_glove_CF_ribon_O'
        glove96 = 'cf_o_glove_CF_ribon_u'
        glove97 = 'cf_O_glove_CF_u'
        glove98 = 'muma_gloves'
        # nip names:
        nip1 = 'cf_O_tikubiL_00'
        nip2 = 'cf_O_tikubiR_00'
        nip3 = 'cf_O_tikubiL_01'
        nip4 = 'cf_O_tikubiR_01'
        # tongue names:
        tong1 = 'cf_O_sita'
        tong2 = 'cf_O_sita1'
        tong3 = 'cf_O_sita2'
        tong4 = 'cf_O_sita3'
        tong5 = 'cf_O_sita4'
        # tooth names:
        tooth1 = 'cf_O_ha'
        tooth2 = 'cf_O_ha1'
        tooth3 = 'cf_O_ha2'
        tooth4 = 'cf_O_ha3'
        tooth5 = 'cf_O_ha4'
        # mayu names:
        mayu1 = 'cf_O_mayuge'
        mayu2 = 'cf_O_mayuge1'
        mayu3 = 'cf_O_mayuge2'
        mayu4 = 'cf_O_mayuge3'
        mayu5 = 'cf_O_mayuge4'
        # eyeline names:
        eline1 = 'cf_O_matuge'
        eline2 = 'cf_O_matuge1'
        eline3 = 'cf_O_matuge2'
        eline4 = 'cf_O_matuge3'
        eline5 = 'cf_O_matuge4'
        # eyeL names:
        eyeL1 = 'cf_O_eye_L'
        eyeL2 = 'cf_O_eye_L1'
        eyeL3 = 'cf_O_eye_L2'
        eyeL4 = 'cf_O_eye_L3'
        eyeL5 = 'cf_O_eye_L4'
        # eyeR names:
        eyeR1 = 'cf_O_eye_R'
        eyeR2 = 'cf_O_eye_R1'
        eyeR3 = 'cf_O_eye_R2'
        eyeR4 = 'cf_O_eye_R3'
        eyeR5 = 'cf_O_eye_R4'
        # eheHikR names:
        eyehikL1 = 'cf_O_eyehikari_L'
        eyehikL2 = 'cf_O_eyehikari_L1'
        eyehikL3 = 'cf_O_eyehikari_L2'
        eyehikL4 = 'cf_O_eyehikari_L3'
        eyehikL5 = 'cf_O_eyehikari_L4'
        # eheHikR names:
        eyehikR1 = 'cf_O_eyehikari_R'
        eyehikR2 = 'cf_O_eyehikari_R1'
        eyehikR3 = 'cf_O_eyehikari_R2'
        eyehikR4 = 'cf_O_eyehikari_R3'
        eyehikR5 = 'cf_O_eyehikari_R4'
        # pupilL names:
        pupilL1 = 'cf_O_eyewhite_L'
        pupilL2 = 'cf_O_eyewhite_L1'
        pupilL3 = 'cf_O_eyewhite_L2'
        pupilL4 = 'cf_O_eyewhite_L3'
        pupilL5 = 'cf_O_eyewhite_L4'
        # pupilR names:
        pupilR1 = 'cf_O_eyewhite_R'
        pupilR2 = 'cf_O_eyewhite_R1'
        pupilR3 = 'cf_O_eyewhite_R2'
        pupilR4 = 'cf_O_eyewhite_R3'
        pupilR5 = 'cf_O_eyewhite_R4'
        # kage names:
        kage1 = 'cf_O_eyekage'
        kage2 = 'cf_O_eyekage1'
        kage3 = 'cf_O_eyekage2'
        kage4 = 'cf_O_eyekage3'
        kage5 = 'cf_O_eyekage4'
        # underhair names:
        underh1 = 'cf_O_mnpk'
        underh2 = 'cf_O_mnpk1'
        underh3 = 'cf_O_mnpk2'
        underh4 = 'cf_O_mnpk3'
        underh5 = 'cf_O_mnpk4'
        #Dont edit this#
        bpy.ops.object.select_all(action='DESELECT') # Deselecciona todo en la escena
        for o in ("cf_O_eyeline_low", "Highlight_cf_O_face_rend", "Highlight_o_body_a_rend", "o_shadowcaster"):
            obj = bpy.context.scene.objects.get(o)
            #if obj: obj.hide_viewport = False
            if obj is not None:
                obj.hide_set(True)
                obj.hide_render = True
        bpy.ops.object.select_all(action='DESELECT') # Deselecciona todo en la escena
        #############################################################################
        mesh = [m for m in bpy.context.scene.objects if m.type == 'MESH']
        for obj in bpy.data.objects:
            if obj.name.endswith("_u") or obj.name.endswith("_U") is not obj.name.startswith("cf_hair_sklx"):
                obj.select_set(state=True)
                obj.hide_set(True)
                obj.hide_render = True
            continue
        w = bpy.data.objects.get
        bpimg = bpy.data.images.get
        #####################################BODY####################################
        bpy.ops.object.select_all(action='DESELECT') # Deselecciona todo en la escena
        # Get body object
        bodies = (w(body1), w(body2), w(body3), w(body4), w(body5), w(body6), w(body7), w(body8), w(body9), w(body10), w(body11), w(body12), w(body13), w(body14), w(body15), w(body16), w(body17), w(body18), w(body19), w(body20), w(body21), w(body22), w(body23), w(body24), w(body25), w(body26), w(body27), w(body28), w(body29), w(body30), w(body31), w(body32), w(body33), w(body34), w(body35), w(body36), w(body37), w(body38), w(body39), w(body40), w(body41), w(body42), w(body43), w(body44), w(body45), w(body46), w(body47), w(body48), w(body49), w(body50), w(body51), w(body52), w(body53), w(body54), w(body55), w(body56), w(body57), w(body58), w(body59), w(body60), w(body61), w(body62), w(body63), w(body64), w(body65))
        for x in bodies:
            if x is not None:
                #if bpy.data.objects.get(body1) is not None:
                op = (x.name)
                bpy.data.objects.get(op).select_set(True)
                outline_body = bpy.data.objects.get(op)
                bpy.context.view_layer.objects.active = outline_body
                ob = bpy.context.selected_objects
                material_set = set()
                for object in bpy.context.selected_objects:
                    for material in object.material_slots:
                        material_set.add(material)
                for material in material_set:
                #    print(material.name)
                    Tex = material.name
                    bpy.data.scenes['Scene'].sna_color01 = bpy.data.materials[Tex].node_tree.nodes['Principled BSDF'].inputs[0].default_value
                    bpy.data.node_groups['HS1-Template Body'].nodes['Color-Value'].outputs[0].default_value = bpy.data.scenes['Scene'].sna_color01
                    TexMain = Tex+'_MainTex.png'
                    TexOcclusionM = Tex+'_OcclusionMap.png'
                    TexSpecGM = Tex+'_SpecGlossMap.png'
                    TexBump = Tex+'_BumpMap.png'
                    TexNormalDetail = Tex+'_DetailNormalMap.png'
                    TexBlendNormalM = Tex+'_BlendNormalMap.png'
                    TexThickness = Tex+'_Thickness.png'
                mat = bpy.data.materials[Tex]
                #Get the node in its node tree (replace the name below)
                node_to_delete =  mat.node_tree.nodes['Principled BSDF']
                node_to_delete2 =  mat.node_tree.nodes['Material Output']
                #Remove it
                mat.node_tree.nodes.remove( node_to_delete )
                mat.node_tree.nodes.remove( node_to_delete2 )
                bpy.data.images['cf_m_body_MainTex.png'].name = TexMain 
                bpy.data.images['cf_m_body_OcclusionMap.png'].name = TexOcclusionM
                bpy.data.images['cf_m_body_SpecGlossMap.png'].name = TexSpecGM
                bpy.data.images['cf_m_body_BumpMap.png'].name = TexBump
                bpy.data.images['cf_m_body_DetailNormalMap.png'].name = TexNormalDetail
                bpy.data.images['cf_m_body_BlendNormalMap.png'].name = TexBlendNormalM
                bpy.data.images['cf_m_body_Thickness.png'].name = TexThickness
                bpy.data.images[TexMain].filepath = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexMain
                bpy.data.images[TexMain].filepath_raw = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexMain
                bpy.data.images[TexOcclusionM].filepath = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexOcclusionM
                bpy.data.images[TexOcclusionM].filepath_raw = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexOcclusionM
                bpy.data.images[TexSpecGM].filepath = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexSpecGM
                bpy.data.images[TexSpecGM].filepath_raw = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexSpecGM
                bpy.data.images[TexBump].filepath = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexBump
                bpy.data.images[TexBump].filepath_raw = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexBump
                bpy.data.images[TexNormalDetail].filepath = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexNormalDetail
                bpy.data.images[TexNormalDetail].filepath_raw = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexNormalDetail
                bpy.data.images[TexBlendNormalM].filepath = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexBlendNormalM
                bpy.data.images[TexBlendNormalM].filepath_raw = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexBlendNormalM
                bpy.data.images[TexThickness].filepath = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexThickness
                bpy.data.images[TexThickness].filepath_raw = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexThickness
                C = bpy.context

                def instantiate_group(nodes, data_block_name):
                    group = nodes.new(type='ShaderNodeGroup')
                    group.node_tree = bpy.data.node_groups['HS1-Template Body']
                    return group
                instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
                bpy.context.object.active_material.blend_method = 'CLIP'
                bpy.context.object.active_material.shadow_method = 'CLIP'
                my_mat = bpy.data.materials.get(Tex)
                bpy.data.node_groups['HS1-Template Body'].name = 'HS1-Template Body '+Tex
                node = bpy.data.node_groups['HS1-Template Body '+Tex]
                nodes = my_mat.node_tree.nodes
                for node in nodes:
                    node.select = False
                    node.select = True
                    nodes.active = node
                try:
                    initial_area_type = bpy.context.area.type
                    bpy.context.area.type = 'NODE_EDITOR'
                    bpy.context.area.ui_type = 'ShaderNodeTree'
                    bpy.ops.wm.redraw_timer(type='DRAW_WIN', iterations=1)
                    bpy.ops.node.group_ungroup()
                    bpy.ops.node.group_edit(exit=True)
                except Exception as e:
                    print(e)
                finally:
                    bpy.context.area.type = initial_area_type
                break
        bpy.ops.object.select_all(action='DESELECT') # Deselecciona todo en la escena
        ####################################FACE#####################################
        bpy.ops.object.select_all(action='DESELECT') # Deselecciona todo en la escena
        # Get face object
        faces = (w(face1),w(face2),w(face3),w(face4),w(face5))
        for x in faces:
            if x is not None:
                #if bpy.data.objects.get(face1) is not None:
                op = (x.name)
                bpy.data.objects.get(op).select_set(True)
                outline_face = bpy.data.objects.get(op)
                bpy.context.view_layer.objects.active = outline_face
                o  = bpy.context.object
                ms = o.material_slots
                n_to_remove = 1 # Change this number to decide how many material slots to remove
                for i in range( len(ms) - 1, len(ms) - n_to_remove - 1, -1):
                    o.active_material_index = i
                    bpy.ops.object.material_slot_remove()
                ob = bpy.context.selected_objects
                material_set = set()
                for object in bpy.context.selected_objects:
                    for material in object.material_slots:
                        material_set.add(material)
                for material in material_set:
                #    print(material.name)
                    Tex = material.name
                    bpy.data.scenes['Scene'].sna_color02 = bpy.data.materials[Tex].node_tree.nodes['Principled BSDF'].inputs[0].default_value
                    bpy.data.node_groups['HS1-Template Face'].nodes['Color-Value'].outputs[0].default_value = bpy.data.scenes['Scene'].sna_color02
                    TexMain = Tex+'_MainTex.png'
                    TexOcclusionM = Tex+'_OcclusionMap.png'
                    TexSpecGM = Tex+'_SpecGlossMap.png'
                    TexBump = Tex+'_BumpMap.png'
                    TexNormalDetail = Tex+'_DetailNormalMap.png'
                    TexBlendNormalM = Tex+'_BlendNormalMap.png'
                    TexThickness = Tex+'_Thickness.png'
                mat = bpy.data.materials[Tex]
                #Get the node in its node tree (replace the name below)
                node_to_delete =  mat.node_tree.nodes['Principled BSDF']
                node_to_delete2 =  mat.node_tree.nodes['Material Output']
                #Remove it
                mat.node_tree.nodes.remove(node_to_delete)
                mat.node_tree.nodes.remove(node_to_delete2)
                bpy.data.images['cf_m_face_02_MainTex.png'].name = TexMain 
                bpy.data.images['cf_m_face_02_OcclusionMap.png'].name = TexOcclusionM
                bpy.data.images['cf_m_face_02_SpecGlossMap.png'].name = TexSpecGM
                bpy.data.images['cf_m_face_02_BumpMap.png'].name = TexBump
                bpy.data.images['cf_m_face_02_DetailNormalMap.png'].name = TexNormalDetail
                bpy.data.images['cf_m_face_02_BlendNormalMap.png'].name = TexBlendNormalM
                bpy.data.images['cf_m_face_01_Thickness.png'].name = TexThickness
                bpy.data.images[TexMain].filepath = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexMain
                bpy.data.images[TexMain].filepath_raw = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexMain
                bpy.data.images[TexOcclusionM].filepath = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexOcclusionM
                bpy.data.images[TexOcclusionM].filepath_raw = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexOcclusionM
                bpy.data.images[TexSpecGM].filepath = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexSpecGM
                bpy.data.images[TexSpecGM].filepath_raw = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexSpecGM
                bpy.data.images[TexBump].filepath = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexBump
                bpy.data.images[TexBump].filepath_raw = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexBump
                bpy.data.images[TexNormalDetail].filepath = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexNormalDetail
                bpy.data.images[TexNormalDetail].filepath_raw = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexNormalDetail
                bpy.data.images[TexBlendNormalM].filepath = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexBlendNormalM
                bpy.data.images[TexBlendNormalM].filepath_raw = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexBlendNormalM
                bpy.data.images[TexThickness].filepath = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexThickness
                bpy.data.images[TexThickness].filepath_raw = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexThickness
                C = bpy.context

                def instantiate_group(nodes, data_block_name):
                    group = nodes.new(type='ShaderNodeGroup')
                    group.node_tree = bpy.data.node_groups['HS1-Template Face']
                    return group
                instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
                #Disable Auto-Smooth to get a correct head visualization
                if 'cf_O_head' in bpy.data.meshes:
                    bpy.data.meshes['cf_O_head'].use_auto_smooth = 0
                my_mat = bpy.data.materials.get(Tex)
                bpy.data.node_groups['HS1-Template Face'].name = 'HS1-Template Face '+Tex
                node = bpy.data.node_groups['HS1-Template Face '+Tex]
                #node.extension = 'CLIP'
                #node.image = bpy.data.images[bakefinal.name]
                nodes = my_mat.node_tree.nodes
                for node in nodes:
                    node.select = False
                    node.select = True
                    nodes.active = node
                try:
                    initial_area_type = bpy.context.area.type
                    bpy.context.area.type = 'NODE_EDITOR'
                    bpy.context.area.ui_type = 'ShaderNodeTree'
                    bpy.ops.wm.redraw_timer(type='DRAW_WIN', iterations=1)
                    bpy.ops.node.group_ungroup()
                    bpy.ops.node.group_edit(exit=True)
                except Exception as e:
                    print(e)
                finally:
                    bpy.context.area.type = initial_area_type
                break
        bpy.ops.object.select_all(action='DESELECT') # Deselecciona todo en la escena
        #################################NIPPLES#####################################
        bpy.ops.object.select_all(action='DESELECT') # Deselecciona todo en la escena
        # Get shoes object
        nipplescoll = ( w(nip1), w(nip2), w(nip3), w(nip4))
        for x in nipplescoll:
            if x is not None:
                #if bpy.data.objects.get(body1) is not None:
                op = (x.name)
                bpy.data.objects.get(op).select_set(True)
                outline_nipples = bpy.data.objects.get(op)
                bpy.context.view_layer.objects.active = outline_nipples
                ob = bpy.context.selected_objects
                material_set = set()
                for object in bpy.context.selected_objects:
                    for material in object.material_slots:
                        material_set.add(material)
                for material in material_set:
                #    print(material.name)
                    Tex = material.name
                    #if bpimg(Tex+"_MainTex.png") is None:
                    #print(Tex+'_MainTex.png')
                    TexMain = Tex+'_MainTex.png'
                    TexSpecGM = Tex+'_SpecGlossMap.png'
                    TexBump = Tex+'_BumpMap.png'
                    mat = bpy.data.materials[Tex]
                    #Get the node in its node tree (replace the name below)
                    node_to_delete =  mat.node_tree.nodes['Principled BSDF']
                    node_to_delete2 =  mat.node_tree.nodes['Material Output']
                    #Remove it
                    mat.node_tree.nodes.remove(node_to_delete)
                    mat.node_tree.nodes.remove(node_to_delete2)
                    imgsocks = ( bpimg('cf_m_nip_00_00_00_MainTex.png'), bpimg('amaterasu'))
                    for x in imgsocks:
                        if x is not None:
                            bpy.data.images['cf_m_nip_00_00_00_MainTex.png'].name = TexMain
                            bpy.data.images['cf_m_nip_00_00_00_SpecGlossMap.png'].name = TexSpecGM
                            bpy.data.images['cf_m_nip_00_00_00_BumpMap.png'].name = TexBump
                            bpy.data.images[TexMain].filepath = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexMain
                            bpy.data.images[TexMain].filepath_raw = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexMain
                            bpy.data.images[TexSpecGM].filepath = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexSpecGM
                            bpy.data.images[TexSpecGM].filepath_raw = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexSpecGM
                            bpy.data.images[TexBump].filepath = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexBump
                            bpy.data.images[TexBump].filepath_raw = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexBump
                    C = bpy.context

                    def instantiate_group(nodes, data_block_name):
                        group = nodes.new(type='ShaderNodeGroup')
                        group.node_tree = bpy.data.node_groups['HS1-Template Nip']
                        return group
                    instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
                    bpy.context.object.active_material.blend_method = 'HASHED'
                    bpy.context.object.active_material.shadow_method = 'HASHED'
                    my_mat = bpy.data.materials.get(Tex)
                    bpy.data.node_groups['HS1-Template Nip'].name = 'HS1-Template Nip '+Tex
                    node = bpy.data.node_groups['HS1-Template Nip '+Tex]
                    #node.extension = 'CLIP'
                    #node.image = bpy.data.images[bakefinal.name]
                    nodes = my_mat.node_tree.nodes
                    for node in nodes:
                        node.select = False
                        node.select = True
                        nodes.active = node
                    try:
                        initial_area_type = bpy.context.area.type
                        bpy.context.area.type = 'NODE_EDITOR'
                        bpy.context.area.ui_type = 'ShaderNodeTree'
                        bpy.ops.wm.redraw_timer(type='DRAW_WIN', iterations=1)
                        bpy.ops.node.group_ungroup()
                        bpy.ops.node.group_edit(exit=True)
                    except Exception as e:
                        print(e)
                    finally:
                        bpy.context.area.type = initial_area_type
                    break
                else:
                    continue
        bpy.ops.object.select_all(action='DESELECT') # Deselecciona todo en la escena
        ##################################FRONT HAIR#################################
        bpy.ops.object.select_all(action='DESELECT') # Deselecciona todo en la escena
        # Get hairf object
        hairfronts = ( w(fronth1), w(fronth2), w(fronth3), w(fronth4), w(fronth5), w(fronth6), w(fronth7), w(fronth8), w(fronth9), w(fronth10), w(fronth11), w(fronth12), w(fronth13), w(fronth14), w(fronth15), w(fronth16), w(fronth17), w(fronth18), w(fronth19), w(fronth20), w(fronth21), w(fronth22), w(fronth23), w(fronth24), w(fronth25), w(fronth26), w(fronth27), w(fronth28), w(fronth29), w(fronth30), w(fronth31), w(fronth32), w(fronth33), w(fronth34), w(fronth35), w(fronth36), w(fronth37), w(fronth38), w(fronth39), w(fronth40), w(fronth41), w(fronth42), w(fronth43), w(fronth44), w(fronth45), w(fronth46), w(fronth47), w(fronth48), w(fronth49), w(fronth50), w(fronth51), w(fronth52), w(fronth53), w(fronth54), w(fronth55), w(fronth56), w(fronth57), w(fronth58), w(fronth59), w(fronth60), w(fronth61), w(fronth62), w(fronth63), w(fronth64), w(fronth65), w(fronth66), w(fronth67), w(fronth68), w(fronth69), w(fronth70), w(fronth71), w(fronth72), w(fronth73), w(fronth74), w(fronth75), w(fronth76), w(fronth77), w(fronth78), w(fronth79), w(fronth80), w(fronth81), w(fronth82), w(fronth83), w(fronth84), w(fronth85), w(fronth86), w(fronth87), w(fronth88), w(fronth89), w(fronth90), w(fronth91), w(fronth92), w(fronth93), w(fronth94), w(fronth95), w(fronth96), w(fronth97), w(fronth98), w(fronth99), w(fronth100), w(fronth101), w(fronth102), w(fronth103), w(fronth104), w(fronth105), w(fronth106), w(fronth107), w(fronth108), w(fronth109), w(fronth110), w(fronth111), w(fronth112), w(fronth113), w(fronth114), w(fronth115), w(fronth116), w(fronth117), w(fronth118), w(fronth119), w(fronth120), w(fronth121), w(fronth122), w(fronth123), w(fronth124), w(fronth125), w(fronth126), w(fronth127), w(fronth128), w(fronth129), w(fronth130), w(fronth131), w(fronth132), w(fronth133), w(fronth134), w(fronth135), w(fronth136), w(fronth137), w(fronth138), w(fronth139), w(fronth140), w(fronth141), w(fronth142), w(fronth143), w(fronth144), w(fronth145), w(fronth146), w(fronth147), w(fronth148), w(fronth149), w(fronth150), w(fronth151), w(fronth152), w(fronth153), w(fronth154), w(fronth155), w(fronth156), w(fronth157), w(fronth158), w(fronth159), w(fronth160), w(fronth161), w(fronth162), w(fronth163), w(fronth164), w(fronth165), w(fronth166), w(fronth167), w(fronth168), w(fronth169), w(fronth170), w(fronth171), w(fronth172), w(fronth173), w(fronth174), w(fronth175), w(fronth176), w(fronth177), w(fronth178), w(fronth179), w(fronth180), w(fronth181), w(fronth182), w(fronth183), w(fronth184), w(fronth185), w(fronth186), w(fronth187), w(fronth188), w(fronth189), w(fronth190), w(fronth191), w(fronth192), w(fronth193), w(fronth194), w(fronth195), w(fronth196), w(fronth197), w(fronth198), w(fronth199), w(fronth200), w(fronth201), w(fronth202), w(fronth203), w(fronth204), w(fronth205), w(fronth206), w(fronth207), w(fronth208), w(fronth209), w(fronth210), w(fronth211), w(fronth212), w(fronth213), w(fronth214), w(fronth215), w(fronth216), w(fronth217), w(fronth218), w(fronth219), w(fronth220), w(fronth221), w(fronth222), w(fronth223), w(fronth224), w(fronth225), w(fronth226), w(fronth227), w(fronth228), w(fronth229), w(fronth230), w(fronth231), w(fronth232), w(fronth233), w(fronth234), w(fronth235), w(fronth236), w(fronth237), w(fronth238), w(fronth239), w(fronth240), w(fronth241), w(fronth242), w(fronth243), w(fronth244), w(fronth245), w(fronth246), w(fronth247), w(fronth248), w(fronth249), w(fronth250), w(fronth251), w(fronth252), w(fronth253), w(fronth254), w(fronth255), w(fronth256), w(fronth257), w(fronth258), w(fronth259), w(fronth260), w(fronth261), w(fronth262), w(fronth263), w(fronth264), w(fronth265), w(fronth266), w(fronth267), w(fronth268), w(fronth269), w(fronth270), w(fronth271), w(fronth272), w(fronth273), w(fronth274), w(fronth275), w(fronth276), w(fronth277), w(fronth278), w(fronth279), w(fronth280), w(fronth281), w(fronth282), w(fronth283), w(fronth284), w(fronth285), w(fronth286), w(fronth287), w(fronth288), w(fronth289), w(fronth290), w(fronth291), w(fronth292), w(fronth293), w(fronth294), w(fronth295), w(fronth296), w(fronth297), w(fronth298), w(fronth299), w(fronth300), w(fronth301), w(fronth302), w(fronth303), w(fronth304), w(fronth305), w(fronth306), w(fronth307), w(fronth308), w(fronth309), w(fronth310), w(fronth311), w(fronth312), w(fronth313), w(fronth314), w(fronth315), w(fronth316), w(fronth317), w(fronth318), w(fronth319), w(fronth320), w(fronth321), w(fronth322), w(fronth323), w(fronth324), w(fronth325), w(fronth326), w(fronth327), w(fronth328), w(fronth329), w(fronth330), w(fronth331), w(fronth332), w(fronth333), w(fronth334), w(fronth335), w(fronth336), w(fronth337), w(fronth338), w(fronth339), w(fronth340), w(fronth341), w(fronth342), w(fronth343), w(fronth344), w(fronth345), w(fronth346), w(fronth347), w(fronth348), w(fronth349), w(fronth350), w(fronth351), w(fronth352), w(fronth353), w(fronth354), w(fronth355), w(fronth356), w(fronth357), w(fronth358), w(fronth359), w(fronth360), w(fronth361), w(fronth362), w(fronth363), w(fronth364), w(fronth365), w(fronth366), w(fronth367), w(fronth368), w(fronth369), w(fronth370), w(fronth371), w(fronth372), w(fronth373), w(fronth374), w(fronth375), w(fronth376), w(fronth377), w(fronth378), w(fronth379), w(fronth380), w(fronth381), w(fronth382), w(fronth383), w(fronth384), w(fronth385), w(fronth386), w(fronth387), w(fronth388), w(fronth389), w(fronth390), w(fronth391), w(fronth392), w(fronth393), w(fronth394), w(fronth395), w(fronth396), w(fronth397), w(fronth398), w(fronth399), w(fronth400), w(fronth401), w(fronth402), w(fronth403), w(fronth404), w(fronth405), w(fronth406), w(fronth407), w(fronth408), w(fronth409), w(fronth410), w(fronth411), w(fronth412), w(fronth413), w(fronth414), w(fronth415), w(fronth416), w(fronth417), w(fronth418), w(fronth419), w(fronth420), w(fronth421), w(fronth422), w(fronth423), w(fronth424), w(fronth425), w(fronth426), w(fronth427), w(fronth428), w(fronth429), w(fronth430), w(fronth431), w(fronth432), w(fronth433), w(fronth434), w(fronth435), w(fronth436), w(fronth437), w(fronth438), w(fronth439), w(fronth440), w(fronth441), w(fronth442), w(fronth443), w(fronth444), w(fronth445), w(fronth446), w(fronth447), w(fronth448), w(fronth449), w(fronth450), w(fronth451), w(fronth452), w(fronth453), w(fronth454), w(fronth455), w(fronth456), w(fronth457), w(fronth458), w(fronth459), w(fronth460), w(fronth461), w(fronth462), w(fronth463), w(fronth464), w(fronth465), w(fronth466), w(fronth467), w(fronth468), w(fronth469), w(fronth470), w(fronth471), w(fronth472), w(fronth473), w(fronth474), w(fronth475), w(fronth476), w(fronth477), w(fronth478), w(fronth479), w(fronth480), w(fronth481), w(fronth482), w(fronth483), w(fronth484), w(fronth485), w(fronth486), w(fronth487), w(fronth488), w(fronth489), w(fronth490), w(fronth491), w(fronth492), w(fronth493), w(fronth494), w(fronth495), w(fronth496), w(fronth497), w(fronth498), w(fronth499), w(fronth500), w(fronth501), w(fronth502), w(fronth503), w(fronth504), w(fronth505), w(fronth506), w(fronth507), w(fronth508), w(fronth509), w(fronth510), w(fronth511), w(fronth512), w(fronth513), w(fronth514), w(fronth515), w(fronth516), w(fronth517), w(fronth518), w(fronth519), w(fronth520), w(fronth521), w(fronth522), w(fronth523), w(fronth524), w(fronth525), w(fronth526), w(fronth527), w(fronth528), w(fronth529), w(fronth530), w(fronth531), w(fronth532), w(fronth533), w(fronth534), w(fronth535), w(fronth536), w(fronth537), w(fronth538), w(fronth539), w(fronth540), w(fronth541), w(fronth542), w(fronth543), w(fronth544), w(fronth545), w(fronth546), w(fronth547), w(fronth548), w(fronth549), w(fronth550), w(fronth551), w(fronth552), w(fronth553), w(fronth554), w(fronth555), w(fronth556), w(fronth557), w(fronth558), w(fronth559), w(fronth560), w(fronth561), w(fronth562), w(fronth563), w(fronth564), w(fronth565), w(fronth566), w(fronth567), w(fronth568), w(fronth569), w(fronth570), w(fronth571), w(fronth572), w(fronth573), w(fronth574), w(fronth575), w(fronth576), w(fronth577), w(fronth578), w(fronth579), w(fronth580), w(fronth581), w(fronth582), w(fronth583), w(fronth584), w(fronth585), w(fronth586), w(fronth587), w(fronth588), w(fronth589), w(fronth590), w(fronth591), w(fronth592), w(fronth593), w(fronth594), w(fronth595), w(fronth596), w(fronth597), w(fronth598), w(fronth599), w(fronth600), w(fronth601), w(fronth602), w(fronth603), w(fronth604), w(fronth605), w(fronth606), w(fronth607), w(fronth608), w(fronth609), w(fronth610), w(fronth611), w(fronth612), w(fronth613), w(fronth614), w(fronth615))
        for x in hairfronts:
            if x is not None:
                #if bpy.data.objects.get(body1) is not None:
                op = (x.name)
                bpy.data.objects.get(op).select_set(True)
                outline_hfront = bpy.data.objects.get(op)
                bpy.context.view_layer.objects.active = outline_hfront
                ob = bpy.context.selected_objects
                material_set = set()
                for object in bpy.context.selected_objects:
                    for material in object.material_slots:
                        material_set.add(material)
                for material in material_set:
                #    print(material.name)
                    Tex = material.name
                if bpimg(Tex+"_MainTex.png") is None:
                    TexMain = Tex+'_MainTex.png'
                    TexOcclusionM = Tex+'_OcclusionMap.png'
                    TexSpecGM = Tex+'_SpecGlossMap.png'
                    TexBump = Tex+'_BumpMap.png'
                    bpy.data.scenes['Scene'].sna_color03 = bpy.data.materials[Tex].node_tree.nodes['Principled BSDF'].inputs[0].default_value
                    bpy.data.node_groups['HS1-Template Front Hair'].nodes['HF-Color-Value'].outputs[0].default_value = bpy.data.scenes['Scene'].sna_color03
                    imghairf = ( bpimg('cf_M_hairbackk_88_01_MainTex.png'), bpimg('tenseigan'))
                    for x in imghairf:
                        if x is not None:
                            bpy.data.images['cf_M_hairbackk_88_01_MainTex.png'].name = TexMain 
                            bpy.data.images['cf_M_hairbackk_88_01_OcclusionMap.png'].name = TexOcclusionM
                            bpy.data.images['cf_M_hairbackk_88_01_SpecGlossMap.png'].name = TexSpecGM
                            bpy.data.images['cf_M_hairbackk_88_01_BumpMap.png'].name = TexBump
                            bpy.data.images[TexMain].filepath = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexMain
                            bpy.data.images[TexMain].filepath_raw = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexMain
                            bpy.data.images[TexOcclusionM].filepath = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexOcclusionM
                            bpy.data.images[TexOcclusionM].filepath_raw = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexOcclusionM
                            bpy.data.images[TexSpecGM].filepath = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexSpecGM
                            bpy.data.images[TexSpecGM].filepath_raw = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexSpecGM
                            bpy.data.images[TexBump].filepath = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexBump
                            bpy.data.images[TexBump].filepath_raw = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexBump
                    mat = bpy.data.materials[Tex]
                    #Get the node in its node tree (replace the name below)
                    node_to_delete =  mat.node_tree.nodes['Principled BSDF']
                    node_to_delete2 =  mat.node_tree.nodes['Material Output']
                    #Remove it
                    mat.node_tree.nodes.remove(node_to_delete)
                    mat.node_tree.nodes.remove(node_to_delete2)
                    C = bpy.context

                    def instantiate_group(nodes, data_block_name):
                        group = nodes.new(type='ShaderNodeGroup')
                        group.node_tree = bpy.data.node_groups['HS1-Template Front Hair']
                        return group
                    instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
                    bpy.context.object.active_material.blend_method = 'HASHED'
                    bpy.context.object.active_material.shadow_method = 'HASHED'
                    my_mat = bpy.data.materials.get(Tex)
                    bpy.data.node_groups['HS1-Template Front Hair'].name = 'HS1-Template FH '+Tex
                    node = bpy.data.node_groups['HS1-Template FH '+Tex]
                    #node.extension = 'CLIP'
                    #node.image = bpy.data.images[bakefinal.name]
                    nodes = my_mat.node_tree.nodes
                    for node in nodes:
                        node.select = False
                        node.select = True
                        nodes.active = node
                    try:
                        initial_area_type = bpy.context.area.type
                        bpy.context.area.type = 'NODE_EDITOR'
                        bpy.context.area.ui_type = 'ShaderNodeTree'
                        bpy.ops.wm.redraw_timer(type='DRAW_WIN', iterations=1)
                        bpy.ops.node.group_ungroup()
                        bpy.ops.node.group_edit(exit=True)
                    except Exception as e:
                        print(e)
                    finally:
                        bpy.context.area.type = initial_area_type
                    break
                else:
                    continue
        bpy.ops.object.select_all(action='DESELECT') # Deselecciona todo en la escena
        ##################################BACK HAIR##################################
        bpy.ops.object.select_all(action='DESELECT') # Deselecciona todo en la escena
        # Get hairb object
        hairbacks = ( w(backh1), w(backh2), w(backh3), w(backh4), w(backh5), w(backh6), w(backh7), w(backh8), w(backh9), w(backh10), w(backh11), w(backh12), w(backh13), w(backh14), w(backh15), w(backh16), w(backh17), w(backh18), w(backh19), w(backh20), w(backh21), w(backh22), w(backh23), w(backh24), w(backh25), w(backh26), w(backh27), w(backh28), w(backh29), w(backh30), w(backh31), w(backh32), w(backh33), w(backh34), w(backh35), w(backh36), w(backh37), w(backh38), w(backh39), w(backh40), w(backh41), w(backh42), w(backh43), w(backh44), w(backh45), w(backh46), w(backh47), w(backh48), w(backh49), w(backh50), w(backh51), w(backh52), w(backh53), w(backh54), w(backh55), w(backh56), w(backh57), w(backh58), w(backh59), w(backh60), w(backh61), w(backh62), w(backh63), w(backh64), w(backh65), w(backh66), w(backh67), w(backh68), w(backh69), w(backh70), w(backh71), w(backh72), w(backh73), w(backh74), w(backh75), w(backh76), w(backh77), w(backh78), w(backh79), w(backh80), w(backh81), w(backh82), w(backh83), w(backh84), w(backh85), w(backh86), w(backh87), w(backh88), w(backh89), w(backh90), w(backh91), w(backh92), w(backh93), w(backh94), w(backh95), w(backh96), w(backh97), w(backh98), w(backh99), w(backh100), w(backh101), w(backh102), w(backh103), w(backh104), w(backh105), w(backh106), w(backh107), w(backh108), w(backh109), w(backh110), w(backh111), w(backh112), w(backh113), w(backh114), w(backh115), w(backh116), w(backh117), w(backh118), w(backh119), w(backh120), w(backh121), w(backh122), w(backh123), w(backh124), w(backh125), w(backh126), w(backh127), w(backh128), w(backh129), w(backh130), w(backh131), w(backh132), w(backh133), w(backh134), w(backh135), w(backh136), w(backh137), w(backh138), w(backh139), w(backh140), w(backh141), w(backh142), w(backh143), w(backh144), w(backh145), w(backh146), w(backh147), w(backh148), w(backh149), w(backh150), w(backh151), w(backh152), w(backh153), w(backh154), w(backh155), w(backh156), w(backh157), w(backh158), w(backh159), w(backh160), w(backh161), w(backh162), w(backh163), w(backh164), w(backh165), w(backh166), w(backh167), w(backh168), w(backh169), w(backh170), w(backh171), w(backh172), w(backh173), w(backh174), w(backh175), w(backh176), w(backh177), w(backh178), w(backh179), w(backh180), w(backh181), w(backh182), w(backh183), w(backh184), w(backh185), w(backh186), w(backh187), w(backh188), w(backh189), w(backh190), w(backh191), w(backh192), w(backh193), w(backh194), w(backh195), w(backh196), w(backh197), w(backh198), w(backh199), w(backh200), w(backh201), w(backh202), w(backh203), w(backh204), w(backh205), w(backh206), w(backh207), w(backh208), w(backh209), w(backh210), w(backh211), w(backh212), w(backh213), w(backh214), w(backh215), w(backh216), w(backh217), w(backh218), w(backh219), w(backh220), w(backh221), w(backh222), w(backh223), w(backh224), w(backh225), w(backh226), w(backh227), w(backh228), w(backh229), w(backh230), w(backh231), w(backh232), w(backh233), w(backh234), w(backh235), w(backh236), w(backh237), w(backh238), w(backh239), w(backh240), w(backh241), w(backh242), w(backh243), w(backh244), w(backh245), w(backh246), w(backh247), w(backh248), w(backh249), w(backh250), w(backh251), w(backh252), w(backh253), w(backh254), w(backh255), w(backh256), w(backh257), w(backh258), w(backh259), w(backh260), w(backh261), w(backh262), w(backh263), w(backh264), w(backh265), w(backh266), w(backh267), w(backh268), w(backh269), w(backh270), w(backh271), w(backh272), w(backh273), w(backh274), w(backh275), w(backh276), w(backh277), w(backh278), w(backh279), w(backh280), w(backh281), w(backh282), w(backh283), w(backh284), w(backh285), w(backh286), w(backh287), w(backh288), w(backh289), w(backh290), w(backh291), w(backh292), w(backh293), w(backh294), w(backh295), w(backh296), w(backh297), w(backh298), w(backh299), w(backh300), w(backh301), w(backh302), w(backh303), w(backh304), w(backh305), w(backh306), w(backh307), w(backh308), w(backh309), w(backh310), w(backh311), w(backh312), w(backh313), w(backh314), w(backh315), w(backh316), w(backh317), w(backh318), w(backh319), w(backh320), w(backh321), w(backh322), w(backh323), w(backh324), w(backh325), w(backh326), w(backh327), w(backh328), w(backh329), w(backh330), w(backh331), w(backh332), w(backh333), w(backh334), w(backh335), w(backh336), w(backh337), w(backh338), w(backh339), w(backh340), w(backh341), w(backh342), w(backh343), w(backh344), w(backh345), w(backh346), w(backh347), w(backh348), w(backh349), w(backh350), w(backh351), w(backh352), w(backh353), w(backh354), w(backh355), w(backh356), w(backh357), w(backh358), w(backh359), w(backh360), w(backh361), w(backh362), w(backh363), w(backh364), w(backh365), w(backh366), w(backh367), w(backh368), w(backh369), w(backh370), w(backh371), w(backh372), w(backh373), w(backh374), w(backh375), w(backh376), w(backh377), w(backh378), w(backh379), w(backh380), w(backh381), w(backh382), w(backh383), w(backh384), w(backh385), w(backh386), w(backh387), w(backh388), w(backh389), w(backh390), w(backh391), w(backh392), w(backh393), w(backh394), w(backh395), w(backh396), w(backh397), w(backh398), w(backh399), w(backh400), w(backh401), w(backh402), w(backh403), w(backh404), w(backh405), w(backh406), w(backh407), w(backh408), w(backh409), w(backh410), w(backh411), w(backh412), w(backh413), w(backh414), w(backh415), w(backh416), w(backh417), w(backh418), w(backh419), w(backh420), w(backh421), w(backh422), w(backh423), w(backh424), w(backh425), w(backh426), w(backh427), w(backh428), w(backh429), w(backh430), w(backh431), w(backh432), w(backh433), w(backh434), w(backh435), w(backh436), w(backh437), w(backh438), w(backh439), w(backh440), w(backh441), w(backh442), w(backh443), w(backh444), w(backh445), w(backh446), w(backh447), w(backh448), w(backh449), w(backh450), w(backh451), w(backh452), w(backh453), w(backh454), w(backh455), w(backh456), w(backh457), w(backh458), w(backh459), w(backh460), w(backh461), w(backh462), w(backh463), w(backh464), w(backh465), w(backh466), w(backh467), w(backh468), w(backh469), w(backh470), w(backh471), w(backh472), w(backh473), w(backh474), w(backh475), w(backh476), w(backh477), w(backh478), w(backh479), w(backh480), w(backh481), w(backh482), w(backh483), w(backh484), w(backh485), w(backh486), w(backh487), w(backh488), w(backh489), w(backh490), w(backh491), w(backh492), w(backh493), w(backh494), w(backh495), w(backh496), w(backh497), w(backh498), w(backh499), w(backh500), w(backh501), w(backh502), w(backh503), w(backh504), w(backh505), w(backh506), w(backh507), w(backh508), w(backh509), w(backh510), w(backh511), w(backh512), w(backh513), w(backh514), w(backh515), w(backh516), w(backh517), w(backh518), w(backh519), w(backh520), w(backh521), w(backh522), w(backh523), w(backh524), w(backh525), w(backh526), w(backh527), w(backh528), w(backh529), w(backh530), w(backh531), w(backh532), w(backh533), w(backh534), w(backh535), w(backh536), w(backh537), w(backh538), w(backh539), w(backh540), w(backh541), w(backh542), w(backh543), w(backh544), w(backh545), w(backh546), w(backh547), w(backh548), w(backh549), w(backh550), w(backh551), w(backh552), w(backh553), w(backh554), w(backh555), w(backh556), w(backh557), w(backh558), w(backh559), w(backh560), w(backh561), w(backh562), w(backh563), w(backh564), w(backh565), w(backh566), w(backh567), w(backh568), w(backh569), w(backh570), w(backh571), w(backh572), w(backh573), w(backh574), w(backh575), w(backh576), w(backh577), w(backh578), w(backh579), w(backh580), w(backh581), w(backh582), w(backh583), w(backh584), w(backh585), w(backh586), w(backh587), w(backh588), w(backh589), w(backh590), w(backh591), w(backh592), w(backh593), w(backh594), w(backh595), w(backh596), w(backh597), w(backh598), w(backh599), w(backh600), w(backh601), w(backh602), w(backh603), w(backh604), w(backh605), w(backh606), w(backh607), w(backh608), w(backh609), w(backh610), w(backh611), w(backh612), w(backh613), w(backh614), w(backh615), w(backh616), w(backh617), w(backh618), w(backh619), w(backh620), w(backh621), w(backh622), w(backh623), w(backh624), w(backh625), w(backh626), w(backh627), w(backh628), w(backh629), w(backh630), w(backh631), w(backh632), w(backh633), w(backh634), w(backh635), w(backh636), w(backh637), w(backh638), w(backh639), w(backh640), w(backh641), w(backh642), w(backh643), w(backh644), w(backh645), w(backh646), w(backh647), w(backh648), w(backh649), w(backh650), w(backh651), w(backh652), w(backh653), w(backh654), w(backh655), w(backh656), w(backh657), w(backh658), w(backh659), w(backh660), w(backh661), w(backh662), w(backh663), w(backh664), w(backh665), w(backh666), w(backh667), w(backh668), w(backh669), w(backh670), w(backh671), w(backh672), w(backh673), w(backh674), w(backh675), w(backh676), w(backh677), w(backh678), w(backh679), w(backh680), w(backh681), w(backh682), w(backh683), w(backh684), w(backh685), w(backh686), w(backh687), w(backh688), w(backh689), w(backh690), w(backh691), w(backh692), w(backh693), w(backh694), w(backh695), w(backh696), w(backh697), w(backh698), w(backh699), w(backh700), w(backh701), w(backh702), w(backh703), w(backh704), w(backh705), w(backh706), w(backh707), w(backh708), w(backh709), w(backh710), w(backh711), w(backh712), w(backh713), w(backh714), w(backh715), w(backh716), w(backh717), w(backh718), w(backh719), w(backh720), w(backh721), w(backh722), w(backh723), w(backh724), w(backh725), w(backh726), w(backh727), w(backh728), w(backh729), w(backh730), w(backh731), w(backh732), w(backh733), w(backh734), w(backh735), w(backh736), w(backh737), w(backh738), w(backh739), w(backh740), w(backh741), w(backh742), w(backh743), w(backh744), w(backh745), w(backh746), w(backh747), w(backh748), w(backh749), w(backh750), w(backh751), w(backh752), w(backh753), w(backh754), w(backh755), w(backh756), w(backh757), w(backh758), w(backh759), w(backh760), w(backh761), w(backh762), w(backh763), w(backh764), w(backh765), w(backh766), w(backh767), w(backh768), w(backh769), w(backh770), w(backh771), w(backh772), w(backh773), w(backh774), w(backh775), w(backh776), w(backh777), w(backh778), w(backh779), w(backh780), w(backh781), w(backh782), w(backh783), w(backh784), w(backh785), w(backh786), w(backh787), w(backh788), w(backh789), w(backh790), w(backh791), w(backh792), w(backh793), w(backh794), w(backh795), w(backh796))
        for x in hairbacks:
            if x is not None:
                #if bpy.data.objects.get(body1) is not None:
                op = (x.name)
                bpy.data.objects.get(op).select_set(True)
                outline_hback = bpy.data.objects.get(op)
                bpy.context.view_layer.objects.active = outline_hback
                ob = bpy.context.selected_objects
                material_set = set()
                for object in bpy.context.selected_objects:
                    for material in object.material_slots:
                        material_set.add(material)
                for material in material_set:
                #    print(material.name)
                    Tex = material.name
                #  print(Tex+'_MainTex.png')
                if bpimg(Tex+"_MainTex.png") is None:
                    TexMain = Tex+'_MainTex.png'
                    TexOcclusionM = Tex+'_OcclusionMap.png'
                    TexSpecGM = Tex+'_SpecGlossMap.png'
                    TexBump = Tex+'_BumpMap.png'
                    bpy.data.scenes['Scene'].sna_color03 = bpy.data.materials[Tex].node_tree.nodes['Principled BSDF'].inputs[0].default_value
                    bpy.data.node_groups['HS1-Template Back Hair'].nodes['HB-Color-Value'].outputs[0].default_value = bpy.data.scenes['Scene'].sna_color03
                    imghairb = ( bpimg('cf_M_hairbackk_88_00_MainTex.png'), bpimg('roshi'))
                    for x in imghairb:
                        if x is not None:
                            bpy.data.images['cf_M_hairbackk_88_00_MainTex.png'].name = TexMain 
                            bpy.data.images['cf_M_hairbackk_88_00_OcclusionMap.png'].name = TexOcclusionM
                            bpy.data.images['cf_M_hairbackk_88_00_SpecGlossMap.png'].name = TexSpecGM
                            bpy.data.images['cf_M_hairbackk_88_00_BumpMap.png'].name = TexBump
                            bpy.data.images[TexMain].filepath = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexMain
                            bpy.data.images[TexMain].filepath_raw = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexMain
                            bpy.data.images[TexOcclusionM].filepath = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexOcclusionM
                            bpy.data.images[TexOcclusionM].filepath_raw = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexOcclusionM
                            bpy.data.images[TexSpecGM].filepath = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexSpecGM
                            bpy.data.images[TexSpecGM].filepath_raw = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexSpecGM
                            bpy.data.images[TexBump].filepath = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexBump
                            bpy.data.images[TexBump].filepath_raw = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexBump
                    mat = bpy.data.materials[Tex]
                    #Get the node in its node tree (replace the name below)
                    node_to_delete =  mat.node_tree.nodes['Principled BSDF']
                    node_to_delete2 =  mat.node_tree.nodes['Material Output']
                    #Remove it
                    mat.node_tree.nodes.remove(node_to_delete)
                    mat.node_tree.nodes.remove(node_to_delete2)
                    C = bpy.context

                    def instantiate_group(nodes, data_block_name):
                        group = nodes.new(type='ShaderNodeGroup')
                        group.node_tree = bpy.data.node_groups['HS1-Template Back Hair']
                        return group
                    instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
                    bpy.context.object.active_material.blend_method = 'HASHED'
                    bpy.context.object.active_material.shadow_method = 'HASHED'
                    my_mat = bpy.data.materials.get(Tex)
                    bpy.data.node_groups['HS1-Template Back Hair'].name = 'HS1-Template BH '+Tex
                    node = bpy.data.node_groups['HS1-Template BH '+Tex]
                    #node.extension = 'CLIP'
                    #node.image = bpy.data.images[bakefinal.name]
                    nodes = my_mat.node_tree.nodes
                    for node in nodes:
                        node.select = False
                        node.select = True
                        nodes.active = node
                    try:
                        initial_area_type = bpy.context.area.type
                        bpy.context.area.type = 'NODE_EDITOR'
                        bpy.context.area.ui_type = 'ShaderNodeTree'
                        bpy.ops.wm.redraw_timer(type='DRAW_WIN', iterations=1)
                        bpy.ops.node.group_ungroup()
                        bpy.ops.node.group_edit(exit=True)
                    except Exception as e:
                        print(e)
                    finally:
                        bpy.context.area.type = initial_area_type
                    break
                else:
                    continue
        bpy.ops.object.select_all(action='DESELECT') # Deselecciona todo en la escena
        ########################################TOP##################################
        bpy.ops.object.select_all(action='DESELECT') # Deselecciona todo en la escena
        ropitas = (w(top1), w(top2), w(top3), w(top4), w(top5), w(top6), w(top7), w(top8), w(top9), w(top10), w(top11), w(top12), w(top13), w(top14), w(top15), w(top16), w(top17), w(top18), w(top19), w(top20), w(top21), w(top22), w(top23), w(top24), w(top25), w(top26), w(top27), w(top28), w(top29), w(top30), w(top31), w(top32), w(top33), w(top34), w(top35), w(top36), w(top37), w(top38), w(top39), w(top40), w(top41), w(top42), w(top43), w(top44), w(top45), w(top46), w(top47), w(top48), w(top49), w(top50), w(top51), w(top52), w(top53), w(top54), w(top55), w(top56), w(top57), w(top58), w(top59), w(top60), w(top61), w(top62), w(top63), w(top64), w(top65), w(top66), w(top67), w(top68), w(top69), w(top70), w(top71), w(top72), w(top73), w(top74), w(top75), w(top76), w(top77), w(top78), w(top79), w(top80), w(top81), w(top82), w(top83), w(top84), w(top85), w(top86), w(top87), w(top88), w(top89), w(top90), w(top91), w(top92), w(top93), w(top94), w(top95), w(top96), w(top97), w(top98), w(top99), w(top100), w(top101), w(top102), w(top103), w(top104), w(top105), w(top106), w(top107), w(top108), w(top109), w(top110), w(top111), w(top112), w(top113), w(top114), w(top115), w(top116), w(top117), w(top118), w(top119), w(top120), w(top121), w(top122), w(top123), w(top124), w(top125), w(top126), w(top127), w(top128), w(top129), w(top130), w(top131), w(top132), w(top133), w(top134), w(top135), w(top136), w(top137), w(top138), w(top139), w(top140), w(top141), w(top142), w(top143), w(top144), w(top145), w(top146), w(top147), w(top148), w(top149), w(top150), w(top151), w(top152), w(top153), w(top154), w(top155), w(top156), w(top157), w(top158), w(top159), w(top160), w(top161), w(top162), w(top163), w(top164), w(top165), w(top166), w(top167), w(top168), w(top169), w(top170), w(top171), w(top172), w(top173), w(top174), w(top175), w(top176), w(top177), w(top178), w(top179), w(top180), w(top181), w(top182), w(top183), w(top184), w(top185), w(top186), w(top187), w(top188), w(top189), w(top190), w(top191), w(top192), w(top193), w(top194), w(top195), w(top196), w(top197), w(top198), w(top199), w(top200), w(top201), w(top202), w(top203), w(top204), w(top205), w(top206), w(top207), w(top208), w(top209), w(top210), w(top211), w(top212), w(top213), w(top214), w(top215), w(top216), w(top217), w(top218), w(top219), w(top220), w(top221), w(top222), w(top223), w(top224), w(top225), w(top226), w(top227), w(top228), w(top229), w(top230), w(top231), w(top232), w(top233), w(top234), w(top235), w(top236), w(top237), w(top238), w(top239), w(top240), w(top241), w(top242), w(top243), w(top244), w(top245), w(top246), w(top247), w(top248), w(top249), w(top250), w(top251), w(top252), w(top253), w(top254), w(top255), w(top256), w(top257), w(top258), w(top259), w(top260), w(top261), w(top262), w(top263), w(top264), w(top265), w(top266), w(top267), w(top268), w(top269), w(top270), w(top271), w(top272), w(top273), w(top274), w(top275), w(top276), w(top277), w(top278), w(top279), w(top280), w(top281), w(top282), w(top283), w(top284), w(top285), w(top286), w(top287), w(top288), w(top289), w(top290), w(top291), w(top292), w(top293), w(top294), w(top295), w(top296), w(top297), w(top298), w(top299), w(top300), w(top301), w(top302), w(top303), w(top304), w(top305), w(top306), w(top307), w(top308), w(top309), w(top310), w(top311), w(top312), w(top313), w(top314), w(top315), w(top316), w(top317), w(top318), w(top319), w(top320), w(top321), w(top322), w(top323), w(top324), w(top325), w(top326), w(top327), w(top328), w(top329), w(top330), w(top331), w(top332), w(top333), w(top334), w(top335), w(top336), w(top337), w(top338), w(top339), w(top340), w(top341), w(top342), w(top343), w(top344), w(top345), w(top346), w(top347), w(top348), w(top349), w(top350), w(top351), w(top352), w(top353))
        for x in ropitas:
            if x is not None:
                #if bpy.data.objects.get(body1) is not None:
                op = (x.name)
                bpy.data.objects.get(op).select_set(True)
                bpy.context.view_layer.objects.active = bpy.data.objects.get(op)
                ob = bpy.context.selected_objects
                material_set = set()
                for object in bpy.context.selected_objects:
                    for material in object.material_slots:
                        material_set.add(material)
                for material in material_set:
                    Tex = material.name
                if bpimg(Tex+"_MainTex.png") is None:    
                    bpy.data.scenes['Scene'].sna_color04 = bpy.data.materials[Tex].node_tree.nodes['Principled BSDF'].inputs[0].default_value
                    bpy.data.node_groups['HS1-Template Top'].nodes['Color-Value'].outputs[0].default_value = bpy.data.scenes['Scene'].sna_color04
                    TexMain = Tex+'_MainTex.png'
                    TexOcclusionM = Tex+'_OcclusionMap.png'
                    TexMetallicGM = Tex+'_MetallicGlossMap.png'
                    TexBump = Tex+'_BumpMap.png'
                    TexDetailNormalM = Tex+'_DetailNormalMap.png'
                    imgcloths = ( bpimg('cf_m_top51_con_00_MainTex.png'), bpimg('chidori'))
                    for x in imgcloths:
                        if x is not None:
                            bpy.data.images['cf_m_top51_con_00_MainTex.png'].name = TexMain 
                            bpy.data.images['cf_m_top51_con_00_OcclusionMap.png'].name = TexOcclusionM
                            bpy.data.images['cf_m_top51_con_00_MetallicGlossMap.png'].name = TexMetallicGM
                            bpy.data.images['cf_m_top51_con_00_BumpMap.png'].name = TexBump
                            bpy.data.images['cf_m_top51_con_00_DetailNormalMap.png'].name = TexDetailNormalM
                            bpy.data.images[TexMain].filepath = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexMain
                            bpy.data.images[TexMain].filepath_raw = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexMain
                            bpy.data.images[TexOcclusionM].filepath = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexOcclusionM
                            bpy.data.images[TexOcclusionM].filepath_raw = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexOcclusionM
                            bpy.data.images[TexMetallicGM].filepath = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexMetallicGM
                            bpy.data.images[TexMetallicGM].filepath_raw = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexMetallicGM
                            bpy.data.images[TexBump].filepath = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexBump
                            bpy.data.images[TexBump].filepath_raw = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexBump
                            bpy.data.images[TexDetailNormalM].filepath = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexDetailNormalM
                            bpy.data.images[TexDetailNormalM].filepath_raw = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexDetailNormalM
                    mat = bpy.data.materials[Tex]
                    #Get the node in its node tree (replace the name below)
                    node_to_delete =  mat.node_tree.nodes['Principled BSDF']
                    node_to_delete2 =  mat.node_tree.nodes['Material Output']
                    #Remove it
                    mat.node_tree.nodes.remove(node_to_delete)
                    mat.node_tree.nodes.remove(node_to_delete2)
                    C = bpy.context

                    def instantiate_group(nodes, data_block_name):
                        group = nodes.new(type='ShaderNodeGroup')
                        group.node_tree = bpy.data.node_groups['HS1-Template Top']
                        return group
                    instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
                    my_mat = bpy.data.materials.get(Tex)
                    bpy.data.node_groups['HS1-Template Top'].name = 'HS1-Template Top '+Tex
                    node = bpy.data.node_groups['HS1-Template Top '+Tex]
                    #node.extension = 'CLIP'
                    #node.image = bpy.data.images[bakefinal.name]
                    nodes = my_mat.node_tree.nodes
                    for node in nodes:
                        node.select = False
                        node.select = True
                        nodes.active = node
                    try:
                        initial_area_type = bpy.context.area.type
                        bpy.context.area.type = 'NODE_EDITOR'
                        bpy.context.area.ui_type = 'ShaderNodeTree'
                        bpy.ops.wm.redraw_timer(type='DRAW_WIN', iterations=1)
                        bpy.ops.node.group_ungroup()
                        bpy.ops.node.group_edit(exit=True)
                    except Exception as e:
                        print(e)
                    finally:
                        bpy.context.area.type = initial_area_type
                    break
                else:
                    continue
        bpy.ops.object.select_all(action='DESELECT') # Deselecciona todo en la escena
        #####################################BOT#####################################
        bpy.ops.object.select_all(action='DESELECT') # Deselecciona todo en la escena
        # Get body object
        pantes = ( w(bot1), w(bot2), w(bot3), w(bot4), w(bot5), w(bot6), w(bot7), w(bot8), w(bot9), w(bot10), w(bot11), w(bot12), w(bot13), w(bot14), w(bot15), w(bot16), w(bot17), w(bot18), w(bot19), w(bot20), w(bot21), w(bot22), w(bot23), w(bot24), w(bot25), w(bot26), w(bot27), w(bot28), w(bot29), w(bot30), w(bot31), w(bot32), w(bot33), w(bot34), w(bot35), w(bot36), w(bot37), w(bot38), w(bot39), w(bot40), w(bot41), w(bot42), w(bot43), w(bot44), w(bot45), w(bot46), w(bot47), w(bot48), w(bot49), w(bot50), w(bot51), w(bot52), w(bot53), w(bot54), w(bot55), w(bot56), w(bot57), w(bot58), w(bot59), w(bot60), w(bot61), w(bot62), w(bot63), w(bot64), w(bot65), w(bot66), w(bot67), w(bot68), w(bot69), w(bot70), w(bot71), w(bot72), w(bot73), w(bot74), w(bot75), w(bot76), w(bot77), w(bot78), w(bot79), w(bot80), w(bot81), w(bot82), w(bot83), w(bot84), w(bot85), w(bot86), w(bot87), w(bot88), w(bot89), w(bot90), w(bot91), w(bot92), w(bot93), w(bot94), w(bot95), w(bot96), w(bot97), w(bot98), w(bot99), w(bot100), w(bot101), w(bot102), w(bot103), w(bot104), w(bot105), w(bot106), w(bot107), w(bot108), w(bot109), w(bot110), w(bot111), w(bot112), w(bot113), w(bot114), w(bot115), w(bot116), w(bot117), w(bot118), w(bot119), w(bot120), w(bot121), w(bot122), w(bot123), w(bot124), w(bot125), w(bot126), w(bot127), w(bot128), w(bot129), w(bot130), w(bot131), w(bot132), w(bot133), w(bot134), w(bot135), w(bot136), w(bot137), w(bot138), w(bot139), w(bot140), w(bot141), w(bot142), w(bot143), w(bot144), w(bot145), w(bot146), w(bot147), w(bot148), w(bot149), w(bot150), w(bot151), w(bot152), w(bot153), w(bot154), w(bot155), w(bot156), w(bot157), w(bot158), w(bot159), w(bot160), w(bot161), w(bot162), w(bot163), w(bot164), w(bot165), w(bot166), w(bot167), w(bot168), w(bot169), w(bot170), w(bot171), w(bot172), w(bot173), w(bot174), w(bot175), w(bot176), w(bot177), w(bot178), w(bot179), w(bot180), w(bot181), w(bot182), w(bot183), w(bot184), w(bot185), w(bot186), w(bot187), w(bot188), w(bot189), w(bot190), w(bot191), w(bot192), w(bot193), w(bot194), w(bot195), w(bot196), w(bot197), w(bot198), w(bot199), w(bot200), w(bot201), w(bot202), w(bot203), w(bot204), w(bot205), w(bot206), w(bot207), w(bot208), w(bot209), w(bot210), w(bot211), w(bot212), w(bot213), w(bot214), w(bot215), w(bot216), w(bot217), w(bot218), w(bot219), w(bot220), w(bot221), w(bot222), w(bot223), w(bot224), w(bot225))
        for x in pantes:
            if x is not None:
                #if bpy.data.objects.get(body1) is not None:
                op = (x.name)
                bpy.data.objects.get(op).select_set(True)
                outline_pants = bpy.data.objects.get(op)
                bpy.context.view_layer.objects.active = outline_pants
                #bpy.ops.object.join()
                #bpy.ops.object.origin_set(type='ORIGIN_CENTER_OF_VOLUME')
                ob = bpy.context.selected_objects
                material_set = set()
                for object in bpy.context.selected_objects:
                    for material in object.material_slots:
                        material_set.add(material)
                for material in material_set:
                #    print(material.name)
                    Tex = material.name
                if bpimg(Tex+"_MainTex.png") is None:
                    bpy.data.scenes['Scene'].sna_color05 = bpy.data.materials[Tex].node_tree.nodes['Principled BSDF'].inputs[0].default_value
                    bpy.data.node_groups['HS1-Template Pants'].nodes['Color-Value'].outputs[0].default_value = bpy.data.scenes['Scene'].sna_color05
                    TexMain = Tex+'_MainTex.png'
                    TexOcclusionM = Tex+'_OcclusionMap.png'
                    TexMetallicGM = Tex+'_MetallicGlossMap.png'
                    TexDetailM = Tex+'_DetailMask.png'
                    TexBump = Tex+'_BumpMap.png'
                    TexDetailNormalM = Tex+'_DetailNormalMap.png'
                    imgpants = ( bpimg('cf_m_bot51_con_00_MainTex.png'), bpimg('rasengan'))
                    for x in imgpants:
                        if x is not None:
                            bpy.data.images['cf_m_bot51_con_00_MainTex.png'].name = TexMain 
                            bpy.data.images['cf_m_bot51_con_00_OcclusionMap.png'].name = TexOcclusionM
                            bpy.data.images['cf_m_bot51_con_00_MetallicGlossMap.png'].name = TexMetallicGM
                            bpy.data.images['cf_m_bot51_con_00_DetailMask.png'].name = TexDetailM
                            bpy.data.images['cf_m_bot51_con_00_BumpMap.png'].name = TexBump
                            bpy.data.images['cf_m_bot51_con_00_DetailNormalMap.png'].name = TexDetailNormalM
                            bpy.data.images[TexMain].filepath = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexMain
                            bpy.data.images[TexMain].filepath_raw = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexMain
                            bpy.data.images[TexOcclusionM].filepath = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexOcclusionM
                            bpy.data.images[TexOcclusionM].filepath_raw = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexOcclusionM
                            bpy.data.images[TexMetallicGM].filepath = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexMetallicGM
                            bpy.data.images[TexMetallicGM].filepath_raw = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexMetallicGM
                            bpy.data.images[TexDetailM].filepath = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexDetailM
                            bpy.data.images[TexDetailM].filepath_raw = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexDetailM
                            bpy.data.images[TexBump].filepath = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexBump
                            bpy.data.images[TexBump].filepath_raw = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexBump
                            bpy.data.images[TexDetailNormalM].filepath = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexDetailNormalM
                            bpy.data.images[TexDetailNormalM].filepath_raw = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexDetailNormalM
                    mat = bpy.data.materials[Tex]
                    #Get the node in its node tree (replace the name below)
                    node_to_delete =  mat.node_tree.nodes['Principled BSDF']
                    node_to_delete2 =  mat.node_tree.nodes['Material Output']
                    #Remove it
                    mat.node_tree.nodes.remove(node_to_delete)
                    mat.node_tree.nodes.remove(node_to_delete2)
                    C = bpy.context

                    def instantiate_group(nodes, data_block_name):
                        group = nodes.new(type='ShaderNodeGroup')
                        group.node_tree = bpy.data.node_groups['HS1-Template Pants']
                        return group
                    instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
                    my_mat = bpy.data.materials.get(Tex)
                    bpy.data.node_groups['HS1-Template Pants'].name = 'HS1-Template Pants '+Tex
                    node = bpy.data.node_groups['HS1-Template Pants '+Tex]
                    #node.extension = 'CLIP'
                    #node.image = bpy.data.images[bakefinal.name]
                    nodes = my_mat.node_tree.nodes
                    for node in nodes:
                        node.select = False
                        node.select = True
                        nodes.active = node
                    try:
                        initial_area_type = bpy.context.area.type
                        bpy.context.area.type = 'NODE_EDITOR'
                        bpy.context.area.ui_type = 'ShaderNodeTree'
                        bpy.ops.wm.redraw_timer(type='DRAW_WIN', iterations=1)
                        bpy.ops.node.group_ungroup()
                        bpy.ops.node.group_edit(exit=True)
                    except Exception as e:
                        print(e)
                    finally:
                        bpy.context.area.type = initial_area_type
                    break
                else:
                    continue
        bpy.ops.object.select_all(action='DESELECT') # Deselecciona todo en la escena
        ###################################SHOES#####################################
        bpy.ops.object.select_all(action='DESELECT') # Deselecciona todo en la escena
        # Get shoes object
        shoeses = ( w(shoes1), w(shoes2), w(shoes3), w(shoes4), w(shoes5), w(shoes6), w(shoes7), w(shoes8), w(shoes9), w(shoes10), w(shoes11), w(shoes12), w(shoes13), w(shoes14), w(shoes15), w(shoes16), w(shoes17), w(shoes18), w(shoes19), w(shoes20), w(shoes21), w(shoes22), w(shoes23), w(shoes24), w(shoes25), w(shoes26), w(shoes27), w(shoes28), w(shoes29), w(shoes30), w(shoes31), w(shoes32), w(shoes33), w(shoes34), w(shoes35), w(shoes36), w(shoes37), w(shoes38), w(shoes39), w(shoes40), w(shoes41), w(shoes42), w(shoes43), w(shoes44), w(shoes45), w(shoes46), w(shoes47), w(shoes48), w(shoes49), w(shoes50), w(shoes51), w(shoes52), w(shoes53), w(shoes54), w(shoes55), w(shoes56), w(shoes57), w(shoes58), w(shoes59), w(shoes60), w(shoes61), w(shoes62), w(shoes63), w(shoes64), w(shoes65), w(shoes66), w(shoes67), w(shoes68), w(shoes69), w(shoes70), w(shoes71), w(shoes72), w(shoes73), w(shoes74), w(shoes75), w(shoes76), w(shoes77), w(shoes78), w(shoes79), w(shoes80), w(shoes81), w(shoes82), w(shoes83), w(shoes84), w(shoes85), w(shoes86), w(shoes87), w(shoes88), w(shoes89), w(shoes90), w(shoes91), w(shoes92), w(shoes93), w(shoes94), w(shoes95), w(shoes96))
        for x in shoeses:
            if x is not None:
                #if bpy.data.objects.get(body1) is not None:
                op = (x.name)
                bpy.data.objects.get(op).select_set(True)
                outline_shoes = bpy.data.objects.get(op)
                bpy.context.view_layer.objects.active = outline_shoes
                ob = bpy.context.selected_objects
                material_set = set()
                for object in bpy.context.selected_objects:
                    for material in object.material_slots:
                        material_set.add(material)
                for material in material_set:
                #    print(material.name)
                    Tex = material.name
                    bpy.data.scenes['Scene'].sna_color06 = bpy.data.materials[Tex].node_tree.nodes['Principled BSDF'].inputs[0].default_value
                    bpy.data.node_groups['HS1-Template Shoes'].nodes['Color-Value'].outputs[0].default_value = bpy.data.scenes['Scene'].sna_color06
                    TexMain = Tex+'_MainTex.png'
                    TexOcclusionM = Tex+'_OcclusionMap.png'
                    TexMetallicGM = Tex+'_MetallicGlossMap.png'
                    TexBump = Tex+'_BumpMap.png'
                    TexDetailNormalM = Tex+'_DetailNormalMap.png'
                imgshoes = ( bpimg('cf_m_shoes_con_00_MainTex.png'), bpimg('byakugan'))
                for x in imgshoes:
                    if x is not None:
                        bpy.data.images['cf_m_shoes_con_00_MainTex.png'].name = TexMain 
                        bpy.data.images['cf_m_shoes_con_00_OcclusionMap.png'].name = TexOcclusionM
                        bpy.data.images['cf_m_shoes_con_00_MetallicGlossMap.png'].name = TexMetallicGM
                        bpy.data.images['cf_m_shoes_con_00_BumpMap.png'].name = TexBump
                        bpy.data.images['cf_m_shoes_con_00_DetailNormalMap.png'].name = TexDetailNormalM
                        bpy.data.images[TexMain].filepath = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexMain
                        bpy.data.images[TexMain].filepath_raw = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexMain
                        bpy.data.images[TexOcclusionM].filepath = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexOcclusionM
                        bpy.data.images[TexOcclusionM].filepath_raw = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexOcclusionM
                        bpy.data.images[TexMetallicGM].filepath = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexMetallicGM
                        bpy.data.images[TexMetallicGM].filepath_raw = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexMetallicGM
                        bpy.data.images[TexBump].filepath = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexBump
                        bpy.data.images[TexBump].filepath_raw = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexBump
                        bpy.data.images[TexDetailNormalM].filepath = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexDetailNormalM
                        bpy.data.images[TexDetailNormalM].filepath_raw = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexDetailNormalM
                mat = bpy.data.materials[Tex]
                #Get the node in its node tree (replace the name below)
                node_to_delete =  mat.node_tree.nodes['Principled BSDF']
                node_to_delete2 =  mat.node_tree.nodes['Material Output']
                #Remove it
                mat.node_tree.nodes.remove(node_to_delete)
                mat.node_tree.nodes.remove(node_to_delete2)
                C = bpy.context

                def instantiate_group(nodes, data_block_name):
                    group = nodes.new(type='ShaderNodeGroup')
                    group.node_tree = bpy.data.node_groups['HS1-Template Shoes']
                    return group
                instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
                my_mat = bpy.data.materials.get(Tex)
                bpy.data.node_groups['HS1-Template Shoes'].name = 'HS1-Template Shoes '+Tex
                node = bpy.data.node_groups['HS1-Template Shoes '+Tex]
                #node.extension = 'CLIP'
                #node.image = bpy.data.images[bakefinal.name]
                nodes = my_mat.node_tree.nodes
                for node in nodes:
                    node.select = False
                    node.select = True
                    nodes.active = node
                try:
                    initial_area_type = bpy.context.area.type
                    bpy.context.area.type = 'NODE_EDITOR'
                    bpy.context.area.ui_type = 'ShaderNodeTree'
                    bpy.ops.wm.redraw_timer(type='DRAW_WIN', iterations=1)
                    bpy.ops.node.group_ungroup()
                    bpy.ops.node.group_edit(exit=True)
                except Exception as e:
                    print(e)
                finally:
                    bpy.context.area.type = initial_area_type
                break
        bpy.ops.object.select_all(action='DESELECT') # Deselecciona todo en la escena
        ###################################SOCKS#####################################
        bpy.ops.object.select_all(action='DESELECT') # Deselecciona todo en la escena
        # Get shoes object
        sockys = ( w(socks1), w(socks2), w(socks3), w(socks4), w(socks5), w(socks6), w(socks7), w(socks8), w(socks9), w(socks10), w(socks11), w(socks12), w(socks13), w(socks14), w(socks15), w(socks16), w(socks17), w(socks18), w(socks19), w(socks20), w(socks21), w(socks22), w(socks23), w(socks24), w(socks25), w(socks26), w(socks27), w(socks28), w(socks29), w(socks30), w(socks31), w(socks32), w(socks33), w(socks34), w(socks35), w(socks36), w(socks37), w(socks38), w(socks39), w(socks40), w(socks41), w(socks42), w(socks43), w(socks44), w(socks45), w(socks46), w(socks47), w(socks48), w(socks49), w(socks50), w(socks51), w(socks52), w(socks53), w(socks54), w(socks55), w(socks56), w(socks57), w(socks58), w(socks59), w(socks60), w(socks61), w(socks62), w(socks63), w(socks64), w(socks65), w(socks66), w(socks67), w(socks68), w(socks69), w(socks70), w(socks71), w(socks72), w(socks73), w(socks74), w(socks75), w(socks76))
        for x in sockys:
            if x is not None:
                #if bpy.data.objects.get(body1) is not None:
                op = (x.name)
                bpy.data.objects.get(op).select_set(True)
                outline_socks = bpy.data.objects.get(op)
                bpy.context.view_layer.objects.active = outline_socks
                ob = bpy.context.selected_objects
                material_set = set()
                for object in bpy.context.selected_objects:
                    for material in object.material_slots:
                        material_set.add(material)
                for material in material_set:
                #    print(material.name)
                    Tex = material.name
                    bpy.data.scenes['Scene'].sna_color09 = bpy.data.materials[Tex].node_tree.nodes['Principled BSDF'].inputs[0].default_value
                    bpy.data.node_groups['HS1-Template Socks'].nodes['Color-Value'].outputs[0].default_value = bpy.data.scenes['Scene'].sna_color09
                    TexMain = Tex+'_MainTex.png'
                    TexOcclusionM = Tex+'_OcclusionMap.png'
                    TexBump = Tex+'_BumpMap.png'
                imgsocks = ( bpimg('cf_M_socks_ballet_MainTex.png'), bpimg('amaterasu'))
                for x in imgsocks:
                    if x is not None:
                        bpy.data.images['cf_M_socks_ballet_MainTex.png'].name = TexMain
                        bpy.data.images['cf_M_socks_ballet_OcclusionMap.png'].name = TexOcclusionM
                        bpy.data.images['cf_M_socks_ballet_BumpMap.png'].name = TexBump
                        bpy.data.images[TexMain].filepath = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexMain
                        bpy.data.images[TexMain].filepath_raw = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexMain
                        bpy.data.images[TexOcclusionM].filepath = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexOcclusionM
                        bpy.data.images[TexOcclusionM].filepath_raw = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexOcclusionM
                        bpy.data.images[TexBump].filepath = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexBump
                        bpy.data.images[TexBump].filepath_raw = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexBump
                mat = bpy.data.materials[Tex]
                #Get the node in its node tree (replace the name below)
                node_to_delete =  mat.node_tree.nodes['Principled BSDF']
                node_to_delete2 =  mat.node_tree.nodes['Material Output']
                #Remove it
                mat.node_tree.nodes.remove(node_to_delete)
                mat.node_tree.nodes.remove(node_to_delete2)
                C = bpy.context

                def instantiate_group(nodes, data_block_name):
                    group = nodes.new(type='ShaderNodeGroup')
                    group.node_tree = bpy.data.node_groups['HS1-Template Socks']
                    return group
                instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
                bpy.context.object.active_material.blend_method = 'CLIP'
                bpy.context.object.active_material.shadow_method = 'CLIP'
                my_mat = bpy.data.materials.get(Tex)
                bpy.data.node_groups['HS1-Template Socks'].name = 'HS1-Template Socks '+Tex
                node = bpy.data.node_groups['HS1-Template Socks '+Tex]
                #node.extension = 'CLIP'
                #node.image = bpy.data.images[bakefinal.name]
                nodes = my_mat.node_tree.nodes
                for node in nodes:
                    node.select = False
                    node.select = True
                    nodes.active = node
                try:
                    initial_area_type = bpy.context.area.type
                    bpy.context.area.type = 'NODE_EDITOR'
                    bpy.context.area.ui_type = 'ShaderNodeTree'
                    bpy.ops.wm.redraw_timer(type='DRAW_WIN', iterations=1)
                    bpy.ops.node.group_ungroup()
                    bpy.ops.node.group_edit(exit=True)
                except Exception as e:
                    print(e)
                finally:
                    bpy.context.area.type = initial_area_type
                break
        bpy.ops.object.select_all(action='DESELECT') # Deselecciona todo en la escena
        ##################################GLOVES#####################################
        bpy.ops.object.select_all(action='DESELECT') # Deselecciona todo en la escena
        # Get shoes object
        glovescoll = ( w(glove1), w(glove2), w(glove3), w(glove4), w(glove5), w(glove6), w(glove7), w(glove8), w(glove9), w(glove10), w(glove11), w(glove12), w(glove13), w(glove14), w(glove15), w(glove16), w(glove17), w(glove18), w(glove19), w(glove20), w(glove21), w(glove22), w(glove23), w(glove24), w(glove25), w(glove26), w(glove27), w(glove28), w(glove29), w(glove30), w(glove31), w(glove32), w(glove33), w(glove34), w(glove35), w(glove36), w(glove37), w(glove38), w(glove39), w(glove40), w(glove41), w(glove42), w(glove43), w(glove44), w(glove45), w(glove46), w(glove47), w(glove48), w(glove49), w(glove50), w(glove51), w(glove52), w(glove53), w(glove54), w(glove55), w(glove56), w(glove57), w(glove58), w(glove59), w(glove60), w(glove61), w(glove62), w(glove63), w(glove64), w(glove65), w(glove66), w(glove67), w(glove68), w(glove69), w(glove70), w(glove71), w(glove72), w(glove73), w(glove74), w(glove75), w(glove76), w(glove77), w(glove78), w(glove79), w(glove80), w(glove81), w(glove82), w(glove83), w(glove84), w(glove85), w(glove86), w(glove87), w(glove88), w(glove89), w(glove90), w(glove91), w(glove92), w(glove93), w(glove94), w(glove95), w(glove96), w(glove97), w(glove98))
        for x in glovescoll:
            if x is not None:
                #if bpy.data.objects.get(body1) is not None:
                op = (x.name)
                bpy.data.objects.get(op).select_set(True)
                outline_gloves = bpy.data.objects.get(op)
                bpy.context.view_layer.objects.active = outline_gloves
                ob = bpy.context.selected_objects
                material_set = set()
                for object in bpy.context.selected_objects:
                    for material in object.material_slots:
                        material_set.add(material)
                for material in material_set:
                #    print(material.name)
                    Tex = material.name
                    bpy.data.scenes['Scene'].sna_color10 = bpy.data.materials[Tex].node_tree.nodes['Principled BSDF'].inputs[0].default_value
                    bpy.data.node_groups['HS1-Template Gloves'].nodes['Color-Value'].outputs[0].default_value = bpy.data.scenes['Scene'].sna_color10
                    TexMain = Tex+'_MainTex.png'
                    TexOcclusionM = Tex+'_OcclusionMap.png'
                    TexSpecGM = Tex+'_SpecGlossMap.png'
                    TexBump = Tex+'_BumpMap.png'
                    TexDetailNM = Tex+'_DetailNormalMap.png'
                imgsocks = ( bpimg('cf_m_glove_con_00_MainTex.png'), bpimg('amaterasu'))
                for x in imgsocks:
                    if x is not None:
                        bpy.data.images['cf_m_glove_con_00_MainTex.png'].name = TexMain
                        bpy.data.images['cf_m_glove_con_00_OcclusionMap.png'].name = TexOcclusionM
                        bpy.data.images['cf_m_glove_con_00_SpecGlossMap.png'].name = TexSpecGM
                        bpy.data.images['cf_m_glove_con_00_BumpMap.png'].name = TexBump
                        bpy.data.images['cf_m_glove_con_00_DetailNormalMap.png'].name = TexDetailNM
                        bpy.data.images[TexMain].filepath = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexMain
                        bpy.data.images[TexMain].filepath_raw = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexMain
                        bpy.data.images[TexOcclusionM].filepath = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexOcclusionM
                        bpy.data.images[TexOcclusionM].filepath_raw = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexOcclusionM
                        bpy.data.images[TexSpecGM].filepath = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexSpecGM
                        bpy.data.images[TexSpecGM].filepath_raw = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexSpecGM
                        bpy.data.images[TexBump].filepath = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexBump
                        bpy.data.images[TexBump].filepath_raw = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexBump
                        bpy.data.images[TexDetailNM].filepath = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexDetailNM
                        bpy.data.images[TexDetailNM].filepath_raw = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexDetailNM
                mat = bpy.data.materials[Tex]
                #Get the node in its node tree (replace the name below)
                node_to_delete =  mat.node_tree.nodes['Principled BSDF']
                node_to_delete2 =  mat.node_tree.nodes['Material Output']
                #Remove it
                mat.node_tree.nodes.remove(node_to_delete)
                mat.node_tree.nodes.remove(node_to_delete2)
                C = bpy.context

                def instantiate_group(nodes, data_block_name):
                    group = nodes.new(type='ShaderNodeGroup')
                    group.node_tree = bpy.data.node_groups['HS1-Template Gloves']
                    return group
                instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
                bpy.context.object.active_material.blend_method = 'CLIP'
                bpy.context.object.active_material.shadow_method = 'CLIP'
                my_mat = bpy.data.materials.get(Tex)
                bpy.data.node_groups['HS1-Template Gloves'].name = 'HS1-Template Gloves '+Tex
                node = bpy.data.node_groups['HS1-Template Gloves '+Tex]
                #node.extension = 'CLIP'
                #node.image = bpy.data.images[bakefinal.name]
                nodes = my_mat.node_tree.nodes
                for node in nodes:
                    node.select = False
                    node.select = True
                    nodes.active = node
                try:
                    initial_area_type = bpy.context.area.type
                    bpy.context.area.type = 'NODE_EDITOR'
                    bpy.context.area.ui_type = 'ShaderNodeTree'
                    bpy.ops.wm.redraw_timer(type='DRAW_WIN', iterations=1)
                    bpy.ops.node.group_ungroup()
                    bpy.ops.node.group_edit(exit=True)
                except Exception as e:
                    print(e)
                finally:
                    bpy.context.area.type = initial_area_type
                break
        bpy.ops.object.select_all(action='DESELECT') # Deselecciona todo en la escena
        #################################Brasier#####################################
        bpy.ops.object.select_all(action='DESELECT') # Deselecciona todo en la escena
        # Get shoes object
        bracoll = ( w(bra1), w(bra2), w(bra3), w(bra4), w(bra5))
        for x in bracoll:
            if x is not None:
                #if bpy.data.objects.get(body1) is not None:
                op = (x.name)
                bpy.data.objects.get(op).select_set(True)
                outline_bra = bpy.data.objects.get(op)
                bpy.context.view_layer.objects.active = outline_bra
                ob = bpy.context.selected_objects
                material_set = set()
                for object in bpy.context.selected_objects:
                    for material in object.material_slots:
                        material_set.add(material)
                for material in material_set:
                #    print(material.name)
                    Tex = material.name
                    bpy.data.scenes['Scene'].sna_color07 = bpy.data.materials[Tex].node_tree.nodes['Principled BSDF'].inputs[0].default_value
                    bpy.data.node_groups['HS1-Template Bra'].nodes['Color-Value'].outputs[0].default_value = bpy.data.scenes['Scene'].sna_color07
                    TexMain = Tex+'_MainTex.png'
                    TexOv = Tex+'_OverTex.png'
                    TexBump = Tex+'_BumpMap.png'
                    TexDetailNM = Tex+'_DetailNormalMap.png'
                imgsocks = ( bpimg('cf_M_bra_fan01_MainTex.png'), bpimg('amaterasu'))
                for x in imgsocks:
                    if x is not None:
                        bpy.data.images['cf_M_bra_fan01_MainTex.png'].name = TexMain
                        bpy.data.images['cf_M_bra_fan01_OverTex.png'].name = TexOv
                        bpy.data.images['cf_M_bra_fan01_BumpMap.png'].name = TexBump
                        bpy.data.images['cf_M_bra_fan01_DetailNormalMap.png'].name = TexDetailNM
                        bpy.data.images[TexMain].filepath = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexMain
                        bpy.data.images[TexMain].filepath_raw = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexMain
                        bpy.data.images[TexSpecGM].filepath = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexSpecGM
                        bpy.data.images[TexSpecGM].filepath_raw = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexSpecGM
                        bpy.data.images[TexBump].filepath = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexBump
                        bpy.data.images[TexBump].filepath_raw = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexBump
                        bpy.data.images[TexDetailNM].filepath = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexDetailNM
                        bpy.data.images[TexDetailNM].filepath_raw = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexDetailNM
                mat = bpy.data.materials[Tex]
                #Get the node in its node tree (replace the name below)
                node_to_delete =  mat.node_tree.nodes['Principled BSDF']
                node_to_delete2 =  mat.node_tree.nodes['Material Output']
                #Remove it
                mat.node_tree.nodes.remove(node_to_delete)
                mat.node_tree.nodes.remove(node_to_delete2)
                C = bpy.context

                def instantiate_group(nodes, data_block_name):
                    group = nodes.new(type='ShaderNodeGroup')
                    group.node_tree = bpy.data.node_groups['HS1-Template Bra']
                    return group
                instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
                bpy.context.object.active_material.blend_method = 'HASHED'
                bpy.context.object.active_material.shadow_method = 'HASHED'
                my_mat = bpy.data.materials.get(Tex)
                bpy.data.node_groups['HS1-Template Bra'].name = 'HS1-Template Bra '+Tex
                node = bpy.data.node_groups['HS1-Template Bra '+Tex]
                #node.extension = 'CLIP'
                #node.image = bpy.data.images[bakefinal.name]
                nodes = my_mat.node_tree.nodes
                for node in nodes:
                    node.select = False
                    node.select = True
                    nodes.active = node
                try:
                    initial_area_type = bpy.context.area.type
                    bpy.context.area.type = 'NODE_EDITOR'
                    bpy.context.area.ui_type = 'ShaderNodeTree'
                    bpy.ops.wm.redraw_timer(type='DRAW_WIN', iterations=1)
                    bpy.ops.node.group_ungroup()
                    bpy.ops.node.group_edit(exit=True)
                except Exception as e:
                    print(e)
                finally:
                    bpy.context.area.type = initial_area_type
                break
        bpy.ops.object.select_all(action='DESELECT') # Deselecciona todo en la escena
        ##################################PANTIES####################################
        bpy.ops.object.select_all(action='DESELECT') # Deselecciona todo en la escena
        # Get short object
        shortys = ( w(short1), w(short2), w(short3), w(short4))
        for x in shortys:
            if x is not None:
                #if bpy.data.objects.get(body1) is not None:
                op = (x.name)
                bpy.data.objects.get(op).select_set(True)
                outline_short = bpy.data.objects.get(op)
                bpy.context.view_layer.objects.active = outline_short
                ob = bpy.context.selected_objects
                material_set = set()
                for object in bpy.context.selected_objects:
                    for material in object.material_slots:
                        material_set.add(material)
                for material in material_set:
                #    print(material.name)
                    Tex = material.name
                    bpy.data.scenes['Scene'].sna_color08 = bpy.data.materials[Tex].node_tree.nodes['Principled BSDF'].inputs[0].default_value
                    bpy.data.node_groups['HS1-Template Short'].nodes['Color-Value'].outputs[0].default_value = bpy.data.scenes['Scene'].sna_color08
                    TexMain = Tex+'_MainTex.png'
                    TexOcclusionM = Tex+'_OcclusionMap.png'
                    TexBump = Tex+'_BumpMap.png'
                    TexDetailNormalM = Tex+'_DetailNormalMap.png'
                imgshort = ( bpimg('cf_M_shorts_08_00_MainTex.png'), bpimg('tenseigan'))
                for x in imgshort:
                    if x is not None:
                        bpy.data.images['cf_M_shorts_08_00_MainTex.png'].name = TexMain 
                        bpy.data.images['cf_M_shorts_08_00_OcclusionMap.png'].name = TexOcclusionM
                        bpy.data.images['cf_M_shorts_08_00_BumpMap.png'].name = TexBump
                        bpy.data.images['cf_M_shorts_08_00_DetailNormalMap.png'].name = TexDetailNormalM
                        bpy.data.images[TexMain].filepath = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexMain
                        bpy.data.images[TexMain].filepath_raw = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexMain
                        bpy.data.images[TexOcclusionM].filepath = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexOcclusionM
                        bpy.data.images[TexOcclusionM].filepath_raw = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexOcclusionM
                        bpy.data.images[TexBump].filepath = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexBump
                        bpy.data.images[TexBump].filepath_raw = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexBump
                        bpy.data.images[TexDetailNormalM].filepath = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexDetailNormalM
                        bpy.data.images[TexDetailNormalM].filepath_raw = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexDetailNormalM
                mat = bpy.data.materials[Tex]
                #Get the node in its node tree (replace the name below)
                node_to_delete =  mat.node_tree.nodes['Principled BSDF']
                node_to_delete2 =  mat.node_tree.nodes['Material Output']
                #Remove it
                mat.node_tree.nodes.remove(node_to_delete)
                mat.node_tree.nodes.remove(node_to_delete2)
                C = bpy.context

                def instantiate_group(nodes, data_block_name):
                    group = nodes.new(type='ShaderNodeGroup')
                    group.node_tree = bpy.data.node_groups['HS1-Template Short']
                    return group
                instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
                bpy.context.object.active_material.blend_method = 'CLIP'
                bpy.context.object.active_material.shadow_method = 'CLIP'
                my_mat = bpy.data.materials.get(Tex)
                bpy.data.node_groups['HS1-Template Short'].name = 'HS1-Template Short '+Tex
                node = bpy.data.node_groups['HS1-Template Short '+Tex]
                #node.extension = 'CLIP'
                #node.image = bpy.data.images[bakefinal.name]
                nodes = my_mat.node_tree.nodes
                for node in nodes:
                    node.select = False
                    node.select = True
                    nodes.active = node
                try:
                    initial_area_type = bpy.context.area.type
                    bpy.context.area.type = 'NODE_EDITOR'
                    bpy.context.area.ui_type = 'ShaderNodeTree'
                    bpy.ops.wm.redraw_timer(type='DRAW_WIN', iterations=1)
                    bpy.ops.node.group_ungroup()
                    bpy.ops.node.group_edit(exit=True)
                except Exception as e:
                    print(e)
                finally:
                    bpy.context.area.type = initial_area_type
                break
        bpy.ops.object.select_all(action='DESELECT') # Deselecciona todo en la escena
        #################################UNDERHAIR###################################
        bpy.ops.object.select_all(action='DESELECT') # Deselecciona todo en la escena
        # Get shoes object
        underhcoll = ( w(underh1), w(underh2), w(underh3), w(underh4), w(underh5))
        for x in underhcoll:
            if x is not None:
                #if bpy.data.objects.get(body1) is not None:
                op = (x.name)
                bpy.data.objects.get(op).select_set(True)
                outline_underh = bpy.data.objects.get(op)
                bpy.context.view_layer.objects.active = outline_underh
                ob = bpy.context.selected_objects
                material_set = set()
                for object in bpy.context.selected_objects:
                    for material in object.material_slots:
                        material_set.add(material)
                for material in material_set:
                #    print(material.name)
                    Tex = material.name
                #  print(Tex+'_MainTex.png')
                    TexMain = Tex+'_MainTex.png'
                    TexSpecGM = Tex+'_SpecGlossMap.png'
                    TexBump = Tex+'_BumpMap.png'
                imgsocks = ( bpimg('cf_m_underhair_00_00_00_MainTex.png'), bpimg('amaterasu'))
                for x in imgsocks:
                    if x is not None:
                        bpy.data.images['cf_m_underhair_00_00_00_MainTex.png'].name = TexMain
                        bpy.data.images['cf_m_underhair_00_00_00_SpecGlossMap.png'].name = TexSpecGM
                        bpy.data.images['cf_m_underhair_00_00_00_BumpMap.png'].name = TexBump
                        bpy.data.images[TexMain].filepath = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexMain
                        bpy.data.images[TexMain].filepath_raw = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexMain
                        bpy.data.images[TexSpecGM].filepath = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexSpecGM
                        bpy.data.images[TexSpecGM].filepath_raw = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexSpecGM
                        bpy.data.images[TexBump].filepath = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexBump
                        bpy.data.images[TexBump].filepath_raw = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexBump
                mat = bpy.data.materials[Tex]
                #Get the node in its node tree (replace the name below)
                node_to_delete =  mat.node_tree.nodes['Principled BSDF']
                node_to_delete2 =  mat.node_tree.nodes['Material Output']
                #Remove it
                mat.node_tree.nodes.remove(node_to_delete)
                mat.node_tree.nodes.remove(node_to_delete2)
                C = bpy.context

                def instantiate_group(nodes, data_block_name):
                    group = nodes.new(type='ShaderNodeGroup')
                    group.node_tree = bpy.data.node_groups['HS1-Template UnderHair']
                    return group
                instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
                bpy.context.object.active_material.blend_method = 'HASHED'
                bpy.context.object.active_material.shadow_method = 'HASHED'
                my_mat = bpy.data.materials.get(Tex)
                node = bpy.data.node_groups['HS1-Template UnderHair']
                #node.extension = 'CLIP'
                #node.image = bpy.data.images[bakefinal.name]
                nodes = my_mat.node_tree.nodes
                for node in nodes:
                    node.select = False
                    node.select = True
                    nodes.active = node
                try:
                    initial_area_type = bpy.context.area.type
                    bpy.context.area.type = 'NODE_EDITOR'
                    bpy.context.area.ui_type = 'ShaderNodeTree'
                    bpy.ops.wm.redraw_timer(type='DRAW_WIN', iterations=1)
                    bpy.ops.node.group_ungroup()
                    bpy.ops.node.group_edit(exit=True)
                except Exception as e:
                    print(e)
                finally:
                    bpy.context.area.type = initial_area_type
                break
        bpy.ops.object.select_all(action='DESELECT') # Deselecciona todo en la escena
        ###################################EYE L#####################################
        bpy.ops.object.select_all(action='DESELECT') # Deselecciona todo en la escena
        # Get eye object
        eyeses = (w(eyeL1),w(eyeL2),w(eyeL3),w(eyeL4),w(eyeL5))
        for x in eyeses:
            if x is not None:
                #if bpy.data.objects.get(body1) is not None:
                op = (x.name)
                bpy.data.objects.get(op).select_set(True)
                outline_eye = bpy.data.objects.get(op)
                bpy.context.view_layer.objects.active = outline_eye
                ob = bpy.context.selected_objects
                material_set = set()
                for object in bpy.context.selected_objects:
                    for material in object.material_slots:
                        material_set.add(material)
                for material in material_set:
                    #    print(material.name)
                    Tex = material.name
                    bpy.context.object.active_material.blend_method = 'BLEND'
                    bpy.context.object.active_material.shadow_method = 'HASHED'
                    #  print(Tex+'_MainTex.png')
                    TexMainWE = Tex+'_MainTex.png'
                    TexOcclusionWE = Tex+'_OcclusionMap.png'
                    TexSGMWE = Tex+'_SpecGlossMap.png'
                bpy.data.images['cf_m_eye_00_23_00_MainTex.png'].name = TexMainWE
                bpy.data.images['cf_m_eye_00_23_00_SpecGlossMap.png'].name = TexSGMWE
                bpy.data.images[TexMainWE].filepath = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexMainWE
                bpy.data.images[TexMainWE].filepath_raw = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexMainWE
                bpy.data.images[TexSGMWE].filepath = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexSGMWE
                bpy.data.images[TexSGMWE].filepath_raw = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexSGMWE
                mat = bpy.data.materials[Tex]
                #Get the node in its node tree (replace the name below)
                node_to_delete =  mat.node_tree.nodes['Principled BSDF']
                node_to_delete2 =  mat.node_tree.nodes['Material Output']
                #Remove it
                mat.node_tree.nodes.remove(node_to_delete)
                mat.node_tree.nodes.remove(node_to_delete2)
                C = bpy.context

                def instantiate_group(nodes, data_block_name):
                    group = nodes.new(type='ShaderNodeGroup')
                    group.node_tree = bpy.data.node_groups['HS1-Template White Eye']
                    return group
                instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
                my_mat = bpy.data.materials.get(Tex)
                #bpy.data.node_groups['HS1-Template White Eye'].name = 'HS1-Template WE '+Tex
                node = bpy.data.node_groups['HS1-Template White Eye']
                #node.extension = 'CLIP'
                #node.image = bpy.data.images[bakefinal.name]
                nodes = my_mat.node_tree.nodes
                for node in nodes:
                    node.select = False
                    node.select = True
                    nodes.active = node
                try:
                    initial_area_type = bpy.context.area.type
                    bpy.context.area.type = 'NODE_EDITOR'
                    bpy.context.area.ui_type = 'ShaderNodeTree'
                    bpy.ops.wm.redraw_timer(type='DRAW_WIN', iterations=1)
                    bpy.ops.node.group_ungroup()
                    bpy.ops.node.group_edit(exit=True)
                except Exception as e:
                    print(e)
                finally:
                    bpy.context.area.type = initial_area_type
                break
        bpy.ops.object.select_all(action='DESELECT') # Deselecciona todo en la escena
        ####################################EYE R#####################################
        ##################################EYELINE####################################
        bpy.ops.object.select_all(action='DESELECT') # Deselecciona todo en la escena
        # Get eyeline object
        elineses = (w(eline1),w(eline2),w(eline3),w(eline4),w(eline5))
        for x in elineses:
            if x is not None:
                #if bpy.data.objects.get(body1) is not None:
                op = (x.name)
                bpy.data.objects.get(op).select_set(True)
                outline_eline = bpy.data.objects.get(op)
                bpy.context.view_layer.objects.active = outline_eline
                ob = bpy.context.selected_objects
                material_set = set()
                for object in bpy.context.selected_objects:
                    for material in object.material_slots:
                        material_set.add(material)
                for material in material_set:
                    #print(material.name)
                    Tex = material.name
                    bpy.context.object.active_material.blend_method = 'HASHED'
                    bpy.context.object.active_material.shadow_method = 'HASHED'
                    #print(Tex+'_MainTex.png')
                    TexMain = Tex+'_MainTex.png'
                imgmayu = ( bpimg('cf_m_eyelashes_00_03_00_MainTex.png'), bpimg('roshi'))
                for x in imgmayu:
                    if x is not None:
                        bpy.data.images['cf_m_eyelashes_00_03_00_MainTex.png'].name = TexMain
                        bpy.data.images[TexMain].filepath = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexMain
                        bpy.data.images[TexMain].filepath_raw = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexMain
                mat = bpy.data.materials[Tex]
                #Get the node in its node tree (replace the name below)
                node_to_delete =  mat.node_tree.nodes['Principled BSDF']
                node_to_delete2 =  mat.node_tree.nodes['Material Output']
                #Remove it
                mat.node_tree.nodes.remove(node_to_delete)
                mat.node_tree.nodes.remove(node_to_delete2)
                C = bpy.context

                def instantiate_group(nodes, data_block_name):
                    group = nodes.new(type='ShaderNodeGroup')
                    group.node_tree = bpy.data.node_groups['HS1-Template Eyelashes']
                    return group
                instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
                my_mat = bpy.data.materials.get(Tex)
                bpy.data.node_groups['HS1-Template Eyelashes'].name = 'HS1-Template Eyelashes '+Tex
                node = bpy.data.node_groups['HS1-Template Eyelashes '+Tex]
                #node.extension = 'CLIP'
                #node.image = bpy.data.images[bakefinal.name]
                nodes = my_mat.node_tree.nodes
                for node in nodes:
                    node.select = False
                    node.select = True
                    nodes.active = node
                try:
                    initial_area_type = bpy.context.area.type
                    bpy.context.area.type = 'NODE_EDITOR'
                    bpy.context.area.ui_type = 'ShaderNodeTree'
                    bpy.ops.wm.redraw_timer(type='DRAW_WIN', iterations=1)
                    bpy.ops.node.group_ungroup()
                    bpy.ops.node.group_edit(exit=True)
                except Exception as e:
                    print(e)
                finally:
                    bpy.context.area.type = initial_area_type
                break
        bpy.ops.object.select_all(action='DESELECT') # Deselecciona todo en la escena
        ##################################MAYUGE#####################################
        bpy.ops.object.select_all(action='DESELECT') # Deselecciona todo en la escena
        # Get mayu object
        mayugeses = (w(mayu1),w(mayu2),w(mayu3),w(mayu4),w(mayu5))
        for x in mayugeses:
            if x is not None:
                #if bpy.data.objects.get(mayu1) is not None:
                op = (x.name)
                bpy.data.objects.get(op).select_set(True)
                outline_mayu = bpy.data.objects.get(op)
                bpy.context.view_layer.objects.active = outline_mayu
                ob = bpy.context.selected_objects
                material_set = set()
                for object in bpy.context.selected_objects:
                    for material in object.material_slots:
                        material_set.add(material)
                for material in material_set:
                    #print(material.name)
                    Tex = material.name
                    bpy.context.object.active_material.blend_method = 'HASHED'
                    bpy.context.object.active_material.shadow_method = 'HASHED'
                    #print(Tex+'_MainTex.png')
                    TexMain = Tex+'_MainTex.png'
                    TexSpecGM = Tex+'_SpecGlossMap.png'
                imgmayu = ( bpimg('cf_m_eyebrow_00_22_00_MainTex.png'), bpimg('roshi'))
                for x in imgmayu:
                    if x is not None:
                        bpy.data.images['cf_m_eyebrow_00_22_00_MainTex.png'].name = TexMain 
                        bpy.data.images['cf_m_eyebrow_00_22_00_SpecGlossMap.png'].name = TexSpecGM
                        bpy.data.images[TexMain].filepath = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexMain
                        bpy.data.images[TexMain].filepath_raw = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexMain
                        bpy.data.images[TexSpecGM].filepath = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexSpecGM
                        bpy.data.images[TexSpecGM].filepath_raw = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexSpecGM
                mat = bpy.data.materials[Tex]
                #Get the node in its node tree (replace the name below)
                node_to_delete =  mat.node_tree.nodes['Principled BSDF']
                node_to_delete2 =  mat.node_tree.nodes['Material Output']
                #Remove it
                mat.node_tree.nodes.remove(node_to_delete)
                mat.node_tree.nodes.remove(node_to_delete2)
                C = bpy.context

                def instantiate_group(nodes, data_block_name):
                    group = nodes.new(type='ShaderNodeGroup')
                    group.node_tree = bpy.data.node_groups['HS1-Template Eyebrows']
                    return group
                instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
                my_mat = bpy.data.materials.get(Tex)
                bpy.data.node_groups['HS1-Template Eyebrows'].name = 'HS1-Template Eyebrows '+Tex
                node = bpy.data.node_groups['HS1-Template Eyebrows '+Tex]
                #node.extension = 'CLIP'
                #node.image = bpy.data.images[bakefinal.name]
                nodes = my_mat.node_tree.nodes
                for node in nodes:
                    node.select = False
                    node.select = True
                    nodes.active = node
                try:
                    initial_area_type = bpy.context.area.type
                    bpy.context.area.type = 'NODE_EDITOR'
                    bpy.context.area.ui_type = 'ShaderNodeTree'
                    bpy.ops.wm.redraw_timer(type='DRAW_WIN', iterations=1)
                    bpy.ops.node.group_ungroup()
                    bpy.ops.node.group_edit(exit=True)
                except Exception as e:
                    print(e)
                finally:
                    bpy.context.area.type = initial_area_type
                break
        bpy.ops.object.select_all(action='DESELECT') # Deselecciona todo en la escena
        ##################################EYEKAGE####################################
        bpy.ops.object.select_all(action='DESELECT') # Deselecciona todo en la escena
        # Get mayu object
        kageses = (w(kage1),w(kage2),w(kage3),w(kage4),w(kage5))
        for x in kageses:
            if x is not None:
                #if bpy.data.objects.get(mayu1) is not None:
                op = (x.name)
                bpy.data.objects.get(op).select_set(True)
                outline_kage = bpy.data.objects.get(op)
                bpy.context.view_layer.objects.active = outline_kage
                ob = bpy.context.selected_objects
                material_set = set()
                for object in bpy.context.selected_objects:
                    for material in object.material_slots:
                        material_set.add(material)
                for material in material_set:
                    #    print(material.name)
                    Tex = material.name
                    #  print(Tex+'_MainTex.png')
                    TexMain = Tex+'_MainTex.png'
                    bpy.context.object.active_material.blend_method = 'BLEND'
                    bpy.context.object.active_material.shadow_method = 'HASHED'
                imgmayu = ( bpimg('cf_M_eyekage_01_MainTex.png'), bpimg('roshi'))
                for x in imgmayu:
                    if x is not None:
                        bpy.data.images['cf_M_eyekage_01_MainTex.png'].name = TexMain
                        bpy.data.images[TexMain].filepath = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexMain
                        bpy.data.images[TexMain].filepath_raw = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexMain
                mat = bpy.data.materials[Tex]
                #Get the node in its node tree (replace the name below)
                node_to_delete =  mat.node_tree.nodes['Principled BSDF']
                node_to_delete2 =  mat.node_tree.nodes['Material Output']
                #Remove it
                mat.node_tree.nodes.remove(node_to_delete)
                mat.node_tree.nodes.remove(node_to_delete2)
                C = bpy.context

                def instantiate_group(nodes, data_block_name):
                    group = nodes.new(type='ShaderNodeGroup')
                    group.node_tree = bpy.data.node_groups['HS1-Template Kage']
                    return group
                instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
                my_mat = bpy.data.materials.get(Tex)
                bpy.data.node_groups['HS1-Template Kage'].name = 'HS1-Template Kage '+Tex
                node = bpy.data.node_groups['HS1-Template Kage '+Tex]
                #node.extension = 'CLIP'
                #node.image = bpy.data.images[bakefinal.name]
                nodes = my_mat.node_tree.nodes
                for node in nodes:
                    node.select = False
                    node.select = True
                    nodes.active = node
                try:
                    initial_area_type = bpy.context.area.type
                    bpy.context.area.type = 'NODE_EDITOR'
                    bpy.context.area.ui_type = 'ShaderNodeTree'
                    bpy.ops.wm.redraw_timer(type='DRAW_WIN', iterations=1)
                    bpy.ops.node.group_ungroup()
                    bpy.ops.node.group_edit(exit=True)
                except Exception as e:
                    print(e)
                finally:
                    bpy.context.area.type = initial_area_type
                break
        bpy.ops.object.select_all(action='DESELECT') # Deselecciona todo en la escena
        ##################################PupilL#####################################
        bpy.ops.object.select_all(action='DESELECT') # Deselecciona todo en la escena
        # Get mayu object
        pupilLes = (w(pupilL1),w(pupilL2),w(pupilL3),w(pupilL4),w(pupilL5))
        for x in pupilLes:
            if x is not None:
                #if bpy.data.objects.get(mayu1) is not None:
                op = (x.name)
                bpy.data.objects.get(op).select_set(True)
                outline_pupilL = bpy.data.objects.get(op)
                bpy.context.view_layer.objects.active = outline_pupilL
                ob = bpy.context.selected_objects
                material_set = set()
                for object in bpy.context.selected_objects:
                    for material in object.material_slots:
                        material_set.add(material)
                for material in material_set:
                #    print(material.name)
                    Tex = material.name
                #  print(Tex+'_MainTex.png')
                    TexMainPupil = Tex+'_MainTex.png'
                    TexOccPupil = Tex+'_OcclusionMap.png'
                    TexSGMPupil = Tex+'_SpecGlossMap.png'
        #        imgmayu = ( bpimg('cf_m_eye_00_23_00_MainTex.png'), bpimg('roshi'))
        #        for x in imgmayu:
        #            if x is not None:
                bpy.data.images['cf_M_eyewhite_01_MainTex.png'].name = TexMainPupil
                bpy.data.images['cf_M_eyewhite_01_OcclusionMap.png'].name = TexOccPupil
                bpy.data.images['cf_M_eyewhite_01_SpecGlossMap.png'].name = TexSGMPupil
                bpy.data.images[TexMainPupil].filepath = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexMainPupil
                bpy.data.images[TexMainPupil].filepath_raw = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexMainPupil
                bpy.data.images[TexOccPupil].filepath = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexOccPupil
                bpy.data.images[TexOccPupil].filepath_raw = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexOccPupil
                bpy.data.images[TexSGMPupil].filepath = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexSGMPupil
                bpy.data.images[TexSGMPupil].filepath_raw = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexSGMPupil
                mat = bpy.data.materials[Tex]
                #Get the node in its node tree (replace the name below)
                node_to_delete =  mat.node_tree.nodes['Principled BSDF']
                node_to_delete2 =  mat.node_tree.nodes['Material Output']
                #Remove it
                mat.node_tree.nodes.remove(node_to_delete)
                mat.node_tree.nodes.remove(node_to_delete2)
                C = bpy.context

                def instantiate_group(nodes, data_block_name):
                    group = nodes.new(type='ShaderNodeGroup')
                    group.node_tree = bpy.data.node_groups['HS1-Template Pupil']
                    return group
                instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
                bpy.context.object.active_material.blend_method = 'BLEND'
                bpy.context.object.active_material.shadow_method = 'HASHED'
                my_mat = bpy.data.materials.get(Tex)
        #        bpy.data.node_groups['HS1-Template Pupil'].name = 'HS1-Template Pupil '+Tex
                node = bpy.data.node_groups['HS1-Template Pupil']
                #node.extension = 'CLIP'
                #node.image = bpy.data.images[bakefinal.name]
                nodes = my_mat.node_tree.nodes
                for node in nodes:
                    node.select = False
                    node.select = True
                    nodes.active = node
                try:
                    initial_area_type = bpy.context.area.type
                    bpy.context.area.type = 'NODE_EDITOR'
                    bpy.context.area.ui_type = 'ShaderNodeTree'
                    bpy.ops.wm.redraw_timer(type='DRAW_WIN', iterations=1)
                    bpy.ops.node.group_ungroup()
                    bpy.ops.node.group_edit(exit=True)
                except Exception as e:
                    print(e)
                finally:
                    bpy.context.area.type = initial_area_type
                break
        bpy.ops.object.select_all(action='DESELECT') # Deselecciona todo en la escena
        ##################################PupilR#####################################
        ##################################EyehiKL#####################################
        bpy.ops.object.select_all(action='DESELECT') # Deselecciona todo en la escena
        # Get mayu object
        eyehikLes = (w(eyehikL1),w(eyehikL2),w(eyehikL3),w(eyehikL4),w(eyehikL5))
        for x in eyehikLes:
            if x is not None:
                #if bpy.data.objects.get(mayu1) is not None:
                op = (x.name)
                bpy.data.objects.get(op).select_set(True)
                outline_hlL = bpy.data.objects.get(op)
                bpy.context.view_layer.objects.active = outline_hlL
                ob = bpy.context.selected_objects
                material_set = set()
                for object in bpy.context.selected_objects:
                    for material in object.material_slots:
                        material_set.add(material)
                for material in material_set:
                #    print(material.name)
                    Tex = material.name
                #  print(Tex+'_MainTex.png')
                    TexMain = Tex+'_MainTex.png'
                imgmayu = ( bpimg('cf_m_eyehi_00_02_00_MainTex.png'), bpimg('roshi'))
                for x in imgmayu:
                    if x is not None:
                        bpy.data.images['cf_m_eyehi_00_02_00_MainTex.png'].name = TexMain
                        bpy.data.images[TexMain].filepath = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexMain
                        bpy.data.images[TexMain].filepath_raw = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexMain
                mat = bpy.data.materials[Tex]
                #Get the node in its node tree (replace the name below)
                node_to_delete =  mat.node_tree.nodes['Principled BSDF']
                node_to_delete2 =  mat.node_tree.nodes['Material Output']
                #Remove it
                mat.node_tree.nodes.remove(node_to_delete)
                mat.node_tree.nodes.remove(node_to_delete2)
                C = bpy.context

                def instantiate_group(nodes, data_block_name):
                    group = nodes.new(type='ShaderNodeGroup')
                    group.node_tree = bpy.data.node_groups['HS1-Template HL']
                    return group
                instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
                bpy.context.object.active_material.blend_method = 'HASHED'
                bpy.context.object.active_material.shadow_method = 'HASHED'
                my_mat = bpy.data.materials.get(Tex)
                node = bpy.data.node_groups['HS1-Template HL']
                #node.extension = 'CLIP'
                #node.image = bpy.data.images[bakefinal.name]
                nodes = my_mat.node_tree.nodes
                for node in nodes:
                    node.select = False
                    node.select = True
                    nodes.active = node
                try:
                    initial_area_type = bpy.context.area.type
                    bpy.context.area.type = 'NODE_EDITOR'
                    bpy.context.area.ui_type = 'ShaderNodeTree'
                    bpy.ops.wm.redraw_timer(type='DRAW_WIN', iterations=1)
                    bpy.ops.node.group_ungroup()
                    bpy.ops.node.group_edit(exit=True)
                except Exception as e:
                    print(e)
                finally:
                    bpy.context.area.type = initial_area_type
                break
        bpy.ops.object.select_all(action='DESELECT') # Deselecciona todo en la escena
        ##################################EyehiKR#####################################
        ################################Tooth###################################
        bpy.ops.object.select_all(action='DESELECT') # Deselecciona todo en la escena
        # Get tooth object
        tootheses = (w(tooth1),w(tooth2),w(tooth3),w(tooth4),w(tooth5))
        for x in tootheses:
            if x is not None:
                #if bpy.data.objects.get(mayu1) is not None:
                op = (x.name)
                bpy.data.objects.get(op).select_set(True)
                outline_tooth = bpy.data.objects.get(op)
                bpy.context.view_layer.objects.active = outline_tooth
                ob = bpy.context.selected_objects
                material_set = set()
                for object in bpy.context.selected_objects:
                    for material in object.material_slots:
                        material_set.add(material)
                for material in material_set:
                #    print(material.name)
                    Tex = material.name
                #  print(Tex+'_MainTex.png')
                    TexMain = Tex+'_MainTex.png'
                    TexOcclusionM = Tex+'_OcclusionMap.png'
                    TexBump = Tex+'_BumpMap.png'
                imgtooth = ( bpimg('cf_M_tooth_MainTex.png'), bpimg('tenseigan'))
                for x in imgtooth:
                    if x is not None:
                        bpy.data.images['cf_M_tooth_MainTex.png'].name = TexMain 
                        bpy.data.images['cf_M_tooth_OcclusionMap.png'].name = TexOcclusionM
                        bpy.data.images['cf_M_tooth_BumpMap.png'].name = TexBump
                        bpy.data.images[TexMain].filepath = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexMain
                        bpy.data.images[TexMain].filepath_raw = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexMain
                        bpy.data.images[TexOcclusionM].filepath = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexOcclusionM
                        bpy.data.images[TexOcclusionM].filepath_raw = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexOcclusionM
                        bpy.data.images[TexBump].filepath_raw = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexBump
                        bpy.data.images[TexBump].filepath = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexBump
                mat = bpy.data.materials[Tex]
                #Get the node in its node tree (replace the name below)
                node_to_delete =  mat.node_tree.nodes['Principled BSDF']
                node_to_delete2 =  mat.node_tree.nodes['Material Output']
                #Remove it
                mat.node_tree.nodes.remove(node_to_delete)
                mat.node_tree.nodes.remove(node_to_delete2)
                C = bpy.context

                def instantiate_group(nodes, data_block_name):
                    group = nodes.new(type='ShaderNodeGroup')
                    group.node_tree = bpy.data.node_groups['HS1-Template Tooth']
                    return group
                instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
                my_mat = bpy.data.materials.get(Tex)
                bpy.data.node_groups['HS1-Template Tooth'].name = 'HS1-Template Tooth '+Tex
                node = bpy.data.node_groups['HS1-Template Tooth '+Tex]
                #node.extension = 'CLIP'
                #node.image = bpy.data.images[bakefinal.name]
                nodes = my_mat.node_tree.nodes
                for node in nodes:
                    node.select = False
                    node.select = True
                    nodes.active = node
                try:
                    initial_area_type = bpy.context.area.type
                    bpy.context.area.type = 'NODE_EDITOR'
                    bpy.context.area.ui_type = 'ShaderNodeTree'
                    bpy.ops.wm.redraw_timer(type='DRAW_WIN', iterations=1)
                    bpy.ops.node.group_ungroup()
                    bpy.ops.node.group_edit(exit=True)
                except Exception as e:
                    print(e)
                finally:
                    bpy.context.area.type = initial_area_type
                break
        bpy.ops.object.select_all(action='DESELECT') # Deselecciona todo en la escena
        ###################################TONGUE####################################
        tongeses = (w(tong1),w(tong2),w(tong3),w(tong4),w(tong5))
        for x in tongeses:
            if x is not None:
                #if bpy.data.objects.get(mayu1) is not None:
                op = (x.name)
                bpy.data.objects.get(op).select_set(True)
                outline_tong = bpy.data.objects.get(op)
                bpy.context.view_layer.objects.active = outline_tong
                ob = bpy.context.selected_objects
                material_set = set()
                for object in bpy.context.selected_objects:
                    for material in object.material_slots:
                        material_set.add(material)
                for material in material_set:
                #    print(material.name)
                    Tex = material.name
                #  print(Tex+'_MainTex.png')
                    TexMain = Tex+'_MainTex.png'
                    TexOcclusionM = Tex+'_OcclusionMap.png'
                    TexSpecGM = Tex+'_SpecGlossMap.png'
                    TexDetailM = Tex+'_DetailMask.png'
                    TexBump = Tex+'_BumpMap.png'
                    TexDetailNormalM = Tex+'_DetailNormalMap.png'
                imgtong = ( bpimg('cf_M_tang_head_MainTex.png'), bpimg('tenseigan'))
                for x in imgtong:
                    if x is not None:
                        bpy.data.images['cf_M_tang_head_MainTex.png'].name = TexMain 
                        bpy.data.images['cf_M_tang_head_OcclusionMap.png'].name = TexOcclusionM
                        bpy.data.images['cf_M_tang_head_SpecGlossMap.png'].name = TexSpecGM 
                        bpy.data.images['cf_M_tang_head_DetailMask.png'].name = TexDetailM 
                        bpy.data.images['cf_M_tang_head_BumpMap.png'].name = TexBump 
                        bpy.data.images['cf_M_tang_head_DetailNormalMap.png'].name = TexDetailNormalM
                        bpy.data.images[TexMain].filepath = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexMain
                        bpy.data.images[TexMain].filepath_raw = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexMain
                        bpy.data.images[TexOcclusionM].filepath = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexOcclusionM
                        bpy.data.images[TexOcclusionM].filepath_raw = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexOcclusionM
                        bpy.data.images[TexSpecGM].filepath = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexSpecGM
                        bpy.data.images[TexSpecGM].filepath_raw = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexSpecGM
                        bpy.data.images[TexDetailM].filepath = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexDetailM
                        bpy.data.images[TexDetailM].filepath_raw = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexDetailM
                        bpy.data.images[TexBump].filepath = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexBump
                        bpy.data.images[TexBump].filepath_raw = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexBump
                        bpy.data.images[TexDetailNormalM].filepath = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexDetailNormalM
                        bpy.data.images[TexDetailNormalM].filepath_raw = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexDetailNormalM
                mat = bpy.data.materials[Tex]
                #Get the node in its node tree (replace the name below)
                node_to_delete =  mat.node_tree.nodes['Principled BSDF']
                node_to_delete2 =  mat.node_tree.nodes['Material Output']
                #Remove it
                mat.node_tree.nodes.remove(node_to_delete)
                mat.node_tree.nodes.remove(node_to_delete2)
                C = bpy.context 

                def instantiate_group(nodes, data_block_name):
                    group = nodes.new(type='ShaderNodeGroup')
                    group.node_tree = bpy.data.node_groups['HS1-Template Tang']
                    return group
                instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
                my_mat = bpy.data.materials.get(Tex)
                bpy.data.node_groups['HS1-Template Tang'].name = 'HS1-Template Tang '+Tex
                node = bpy.data.node_groups['HS1-Template Tang '+Tex]
                #node.extension = 'CLIP'
                #node.image = bpy.data.images[bakefinal.name]
                nodes = my_mat.node_tree.nodes
                for node in nodes:
                    node.select = False
                    node.select = True
                    nodes.active = node
                try:
                    initial_area_type = bpy.context.area.type
                    bpy.context.area.type = 'NODE_EDITOR'
                    bpy.context.area.ui_type = 'ShaderNodeTree'
                    bpy.ops.wm.redraw_timer(type='DRAW_WIN', iterations=1)
                    bpy.ops.node.group_ungroup()
                    bpy.ops.node.group_edit(exit=True)
                except Exception as e:
                    print(e)
                finally:
                    bpy.context.area.type = initial_area_type
                break
        bpy.ops.object.select_all(action='DESELECT') # Deselecciona todo en la escena
        #bpy.ops.object.select_all(action='DESELECT')
        #bpy.data.objects.get('Armature.001').select_set(True)
        #armatureobject = bpy.data.objects.get('Armature.001')
        #bpy.context.view_layer.objects.active = armatureobject
        #bpy.ops.object.delete()
        #bpy.ops.object.select_all(action='DESELECT')
        #bpy.data.objects.get('Cube.001').select_set(True)
        #Cubeobject = bpy.data.objects.get('Cube.001')
        #bpy.context.view_layer.objects.active = Cubeobject
        #bpy.ops.object.delete()
        bpy.data.armatures['Armature'].display_type = "STICK"
        bpy.ops.file.find_missing_files('INVOKE_DEFAULT')
        return {"FINISHED"}

    def invoke(self, context, event):
        return self.execute(context)


class SNA_OT_Hs1Face_091B8(bpy.types.Operator):
    bl_idname = "sna.hs1face_091b8"
    bl_label = "hs1-face"
    bl_description = ""
    bl_options = {"REGISTER", "UNDO"}

    @classmethod
    def poll(cls, context):
        return not False

    def execute(self, context):
        import os
        ########################################################################
        my_mat = bpy.context.object.material_slots[0].material
        print(my_mat.name)
        Tex=my_mat.name
        rem_mat = bpy.data.materials[Tex]
        #Get the node in its node tree (replace the name below)
        node_to_delete =  rem_mat.node_tree.nodes['Principled BSDF']
        node_to_delete2 =  rem_mat.node_tree.nodes['Material Output']
        #Remove it
        rem_mat.node_tree.nodes.remove(node_to_delete)
        rem_mat.node_tree.nodes.remove(node_to_delete2)
        #Tex = material.name
        TexMain = Tex+'_MainTex.png'
        TexDetailM = Tex+'_DetailMask.png'
        TexNormal = Tex+'_NormalMap.png'
        TexNDetail = Tex+'_NormalMapDetail.png'
        TexAlphaM = Tex+'_AlphaMask.png'
        TexAnotherR = Tex+'_AnotherRamp.png'
        TexLiquidM = Tex+'_liquidmask.png'
        TexTex2 = Tex+'_Texture2.png'
        TexTex3 = Tex+'_Texture3.png'
        TexOv1 = Tex+'_overtex1.png'
        TexOv2 = Tex+'_overtex2.png'
        TexLineM = Tex+'_LineMask.png'
        TexColorM = Tex+'_ColorMask.png'
        TexHairG = Tex+'_HairGloss.png'
        TexBump = Tex+'_BumpMap.png'
        TexDNM = Tex+'_DetailNormalMap.png'
        TexBNM = Tex+'_BlendNormalMap.png'
        TexSGM = Tex+'_SpecGlossMap.png'
        TexOM = Tex+'_OcclusionMap.png'
        TexTSS = Tex+'_Thickness.png'
        TexMGM = Tex+'_MetallicGlossMap.png'
        TexOV = Tex+'_OverTex.png'
        originaltex = 'cf_m_face_02_'
        originaltss = 'cf_m_face_01_'
        #kkp
        nm = originaltex+'NormalMap.png'
        nd = originaltex+'NormalMapDetail.png'
        dm = originaltex+'DetailMask.png'
        mm = originaltex+'MainTex.png'
        t3 = originaltex+'Texture3.png'
        t2 = originaltex+'Texture2.png'
        am = originaltex+'AlphaMask.png'
        lm = originaltex+'liquidmask.png'
        ar = originaltex+'AnotherRamp.png'
        ov1 = originaltex+'overtex1.png'
        ov2 = originaltex+'overtex2.png'
        lnm = originaltex+'LineMask.png'
        com = originaltex+'ColorMask.png'
        glo = originaltex+'HairGloss.png'
        #hs1
        bum = originaltex+'BumpMap.png'
        dnm = originaltex+'DetailNormalMap.png'
        bnm = originaltex+'BlendNormalMap.png'
        sgm = originaltex+'SpecGlossMap.png'
        om = originaltex+'OcclusionMap.png'
        tss = originaltss+'Thickness.png'
        mgm = originaltex+'MetallicGlossMap.png'
        ov = originaltex+'OverTex.png'
        Template='HS1-Template Face'
        CTemplate=Template+' '
        C = bpy.context

        def instantiate_group(nodes, data_block_name):
            group = nodes.new(type='ShaderNodeGroup')
            group.node_tree = bpy.data.node_groups[Template]
            return group
        if Template in bpy.data.node_groups:
            instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
        else:
        #    versions = ( t0, t1, t2, t3, t4)
        #    for x in versions:
        #        if os.path.isdir(x) and os.access(x, os.R_OK):
            if (3, 0, 0) <= bpy.app.version < (3, 0, 99):
                before_data = list(bpy.data.node_groups)
                bpy.ops.wm.append(directory=os.path.expanduser(r"~\AppData\Roaming\Blender Foundation\Blender\3.0\scripts\addons\sklx_creator\assets\HS1_Template_Shader.blend") + r'\NodeTree',filename=Template,link=False)
                new_data=list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
                appended_2B5AC = None if not new_data else new_data[0]
                instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
            else:
                if (3, 1, 0) <= bpy.app.version < (3, 1, 99):
                    before_data = list(bpy.data.node_groups)
                    bpy.ops.wm.append(directory=os.path.expanduser(r"~\AppData\Roaming\Blender Foundation\Blender\3.1\scripts\addons\sklx_creator\assets\HS1_Template_Shader.blend") + r'\NodeTree',filename=Template,link=False)
                    new_data=list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
                    appended_2B5AC = None if not new_data else new_data[0]
                    instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
                else:
                    if (3, 2, 0) <= bpy.app.version < (3, 2, 99):
                        before_data = list(bpy.data.node_groups)
                        bpy.ops.wm.append(directory=os.path.expanduser(r"~\AppData\Roaming\Blender Foundation\Blender\3.2\scripts\addons\sklx_creator\assets\HS1_Template_Shader.blend") + r'\NodeTree',filename=Template,link=False)
                        new_data=list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
                        appended_2B5AC = None if not new_data else new_data[0]
                        instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
                    else:
                        if (3, 3, 0) <= bpy.app.version < (3, 3, 99):
                            before_data = list(bpy.data.node_groups)
                            bpy.ops.wm.append(directory=os.path.expanduser(r"~\AppData\Roaming\Blender Foundation\Blender\3.3\scripts\addons\sklx_creator\assets\HS1_Template_Shader.blend") + r'\NodeTree',filename=Template,link=False)
                            new_data=list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
                            appended_2B5AC = None if not new_data else new_data[0]
                            instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
                        else:
                            if (3, 4, 0) <= bpy.app.version < (3, 4, 99):
                                before_data = list(bpy.data.node_groups)
                                bpy.ops.wm.append(directory=os.path.expanduser(r"~\AppData\Roaming\Blender Foundation\Blender\3.4\scripts\addons\sklx_creator\assets\HS1_Template_Shader.blend") + r'\NodeTree',filename=Template,link=False)
                                new_data=list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
                                appended_2B5AC = None if not new_data else new_data[0]
                                instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
        bpy.data.node_groups[Template].name = CTemplate+Tex
        node = bpy.data.node_groups[CTemplate+Tex]
        #initial_area_type = bpy.context.area.type
        #bpy.context.area.type = 'NODE_EDITOR'
        #bpy.context.area.ui_type = 'ShaderNodeTree'
        #bpy.ops.node.group_ungroup()
        #bpy.context.area.type = initial_area_type
        nodes = my_mat.node_tree.nodes
        for node in nodes:
            #node.select = False
            print(node.name)
            node.select = True
            nodes.active = node
        try:
            initial_area_type = bpy.context.area.type
            bpy.context.area.type = 'NODE_EDITOR'
            bpy.context.area.ui_type = 'ShaderNodeTree'
            bpy.ops.wm.redraw_timer(type='DRAW_WIN', iterations=1)
            bpy.ops.node.group_ungroup()
            nonono = node," to Ungroup"
            print(nonono)
            bpy.ops.node.group_edit(exit=True)
        except Exception as e:
            print(e)
        finally:
            bpy.context.area.type = initial_area_type
        fixlocate = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\\20220603141428_Chika_Haruno\\Textures\\"
        bpimg = bpy.data.images.get
        if 1==1:
            print(mm)
            print(dm)
            print(nm)
            print(t2)
            print(t3)
        #formula_list=(nm,nd,dm,mm,t2,t3,am,lm,ar,ov1,ov2,lnm,com,glo,bum,dnm,bnm,sgm,om,tss,mgm,ov)
        #for formula in formula_list:
        #    if bpimg(formula) is not None:
        f1 = bpimg(mm)
        #for x in f1:
        if f1 is not None:
            bpy.data.images[mm].name = TexMain
            bpy.data.images[TexMain].filepath = fixlocate+TexMain
            bpy.data.images[TexMain].filepath_raw = fixlocate+TexMain
        f2 = bpimg(dm)
        #for x in f2:
        if f2 is not None:
            bpy.data.images[dm].name = TexDetailM
            bpy.data.images[TexDetailM].filepath = fixlocate+TexDetailM
            bpy.data.images[TexDetailM].filepath_raw = fixlocate+TexDetailM
        f3 = bpimg(nm)
        #for x in f3:
        if f3 is not None:
            bpy.data.images[nm].name = TexNormal
            bpy.data.images[TexNormal].filepath = fixlocate+TexNormal
            bpy.data.images[TexNormal].filepath_raw = fixlocate+TexNormal
        f4 = bpimg(t2)
        #for x in f3:
        if f4 is not None:
            bpy.data.images[t2].name = TexTex2
            bpy.data.images[TexTex2].filepath = fixlocate+TexTex2
            bpy.data.images[TexTex2].filepath_raw = fixlocate+TexTex2
        f5 = bpimg(t3)
        #for x in f4:
        if f5 is not None:
            bpy.data.images[t3].name = TexTex3
            bpy.data.images[TexTex3].filepath = fixlocate+TexTex3
            bpy.data.images[TexTex3].filepath_raw = fixlocate+TexTex3
        f6 = bpimg(am)
        #for x in f5:
        if f6 is not None:
            bpy.data.images[am].name = TexAlphaM
            bpy.data.images[TexAlphaM].filepath = fixlocate+TexAlphaM
            bpy.data.images[TexAlphaM].filepath_raw = fixlocate+TexAlphaM
        f7 = bpimg(lm)
        #for x in f6:
        if f7 is not None:
            bpy.data.images[lm].name = TexLiquidM
            bpy.data.images[TexLiquidM].filepath = fixlocate+TexLiquidM
            bpy.data.images[TexLiquidM].filepath_raw = fixlocate+TexLiquidM
        f8 = bpimg(ar)
        #for f8 in f8:
        if f8 is not None:
            bpy.data.images[ar].name = TexAnotherR
            bpy.data.images[TexAnotherR].filepath = fixlocate+TexAnotherR
            bpy.data.images[TexAnotherR].filepath_raw = fixlocate+TexAnotherR
        f9 = bpimg(nd)
        #for f8 in f8:
        if f9 is not None:
            bpy.data.images[nd].name = TexNDetail
            bpy.data.images[TexNDetail].filepath = fixlocate+TexNDetail
            bpy.data.images[TexNDetail].filepath_raw = fixlocate+TexNDetail
        f10 = bpimg(ov1)
        #for f8 in f8:
        if f10 is not None:
            bpy.data.images[ov1].name = TexOv1
            bpy.data.images[TexOv1].filepath = fixlocate+TexOv1
            bpy.data.images[TexOv1].filepath_raw = fixlocate+TexOv1
        f11 = bpimg(ov2)
        #for f8 in f8:
        if f11 is not None:
            bpy.data.images[ov2].name = TexOv2
            bpy.data.images[TexOv2].filepath = fixlocate+TexOv2
            bpy.data.images[TexOv2].filepath_raw = fixlocate+TexOv2
        f12 = bpimg(lnm)
        #for f8 in f8:
        if f12 is not None:
            bpy.data.images[lnm].name = TexLineM
            bpy.data.images[TexLineM].filepath = fixlocate+TexLineM
            bpy.data.images[TexLineM].filepath_raw = fixlocate+TexLineM
        f13 = bpimg(com)
        #for f8 in f8:
        if f13 is not None:
            bpy.data.images[com].name = TexColorM
            bpy.data.images[TexColorM].filepath = fixlocate+TexColorM
            bpy.data.images[TexColorM].filepath_raw = fixlocate+TexColorM
        f14 = bpimg(glo)
        #for f8 in f8:
        if f14 is not None:
            bpy.data.images[glo].name = TexHairG
            bpy.data.images[TexHairG].filepath = fixlocate+TexHairG
            bpy.data.images[TexHairG].filepath_raw = fixlocate+TexHairG
        f15 = bpimg(bum)
        #for f8 in f8:
        if f15 is not None:
            bpy.data.images[bum].name = TexBump
            bpy.data.images[TexBump].filepath = fixlocate+TexBump
            bpy.data.images[TexBump].filepath_raw = fixlocate+TexBump
        f16 = bpimg(dnm)
        #for f8 in f8:
        if f16 is not None:
            bpy.data.images[dnm].name = TexDNM
            bpy.data.images[TexDNM].filepath = fixlocate+TexDNM
            bpy.data.images[TexDNM].filepath_raw = fixlocate+TexDNM
        f17 = bpimg(bnm)
        #for f8 in f8:
        if f17 is not None:
            bpy.data.images[bnm].name = TexBNM
            bpy.data.images[TexBNM].filepath = fixlocate+TexBNM
            bpy.data.images[TexBNM].filepath_raw = fixlocate+TexBNM
        f18 = bpimg(sgm)
        #for f8 in f8:
        if f18 is not None:
            bpy.data.images[sgm].name = TexSGM
            bpy.data.images[TexSGM].filepath = fixlocate+TexSGM
            bpy.data.images[TexSGM].filepath_raw = fixlocate+TexSGM
        f19 = bpimg(om)
        #for f8 in f8:
        if f19 is not None:
            bpy.data.images[om].name = TexOM
            bpy.data.images[TexOM].filepath = fixlocate+TexOM
            bpy.data.images[TexOM].filepath_raw = fixlocate+TexOM
        f20 = bpimg(tss)
        #for f8 in f8:
        if f20 is not None:
            bpy.data.images[tss].name = TexTSS
            bpy.data.images[TexTSS].filepath = fixlocate+TexTSS
            bpy.data.images[TexTSS].filepath_raw = fixlocate+TexTSS
        f21 = bpimg(mgm)
        #for f8 in f8:
        if f21 is not None:
            bpy.data.images[mgm].name = TexMGM
            bpy.data.images[TexMGM].filepath = fixlocate+TexMGM
            bpy.data.images[TexMGM].filepath_raw = fixlocate+TexMGM
        f22 = bpimg(ov)
        #for f8 in f8:
        if f22 is not None:
            bpy.data.images[ov].name = TexOV
            bpy.data.images[TexOV].filepath = fixlocate+TexOV
            bpy.data.images[TexOV].filepath_raw = fixlocate+TexOV
        bpy.ops.file.find_missing_files('INVOKE_DEFAULT')
        return {"FINISHED"}

    def invoke(self, context, event):
        return self.execute(context)


class SNA_OT_Hs1Body_8Befd(bpy.types.Operator):
    bl_idname = "sna.hs1body_8befd"
    bl_label = "hs1-body"
    bl_description = ""
    bl_options = {"REGISTER", "UNDO"}

    @classmethod
    def poll(cls, context):
        return not False

    def execute(self, context):
        import os
        ########################################################################
        my_mat = bpy.context.object.material_slots[0].material
        print(my_mat.name)
        Tex=my_mat.name
        rem_mat = bpy.data.materials[Tex]
        #Get the node in its node tree (replace the name below)
        node_to_delete =  rem_mat.node_tree.nodes['Principled BSDF']
        node_to_delete2 =  rem_mat.node_tree.nodes['Material Output']
        #Remove it
        rem_mat.node_tree.nodes.remove(node_to_delete)
        rem_mat.node_tree.nodes.remove(node_to_delete2)
        #Tex = material.name
        TexMain = Tex+'_MainTex.png'
        TexDetailM = Tex+'_DetailMask.png'
        TexNormal = Tex+'_NormalMap.png'
        TexNDetail = Tex+'_NormalMapDetail.png'
        TexAlphaM = Tex+'_AlphaMask.png'
        TexAnotherR = Tex+'_AnotherRamp.png'
        TexLiquidM = Tex+'_liquidmask.png'
        TexTex2 = Tex+'_Texture2.png'
        TexTex3 = Tex+'_Texture3.png'
        TexOv1 = Tex+'_overtex1.png'
        TexOv2 = Tex+'_overtex2.png'
        TexLineM = Tex+'_LineMask.png'
        TexColorM = Tex+'_ColorMask.png'
        TexHairG = Tex+'_HairGloss.png'
        TexBump = Tex+'_BumpMap.png'
        TexDNM = Tex+'_DetailNormalMap.png'
        TexBNM = Tex+'_BlendNormalMap.png'
        TexSGM = Tex+'_SpecGlossMap.png'
        TexOM = Tex+'_OcclusionMap.png'
        TexTSS = Tex+'_Thickness.png'
        TexMGM = Tex+'_MetallicGlossMap.png'
        TexOV = Tex+'_OverTex.png'
        originaltex = 'cf_m_body_'
        #originaltss = 'cf_m_body_01_'
        #kkp
        nm = originaltex+'NormalMap.png'
        nd = originaltex+'NormalMapDetail.png'
        dm = originaltex+'DetailMask.png'
        mm = originaltex+'MainTex.png'
        t3 = originaltex+'Texture3.png'
        t2 = originaltex+'Texture2.png'
        am = originaltex+'AlphaMask.png'
        lm = originaltex+'liquidmask.png'
        ar = originaltex+'AnotherRamp.png'
        ov1 = originaltex+'overtex1.png'
        ov2 = originaltex+'overtex2.png'
        lnm = originaltex+'LineMask.png'
        com = originaltex+'ColorMask.png'
        glo = originaltex+'HairGloss.png'
        #hs1
        bum = originaltex+'BumpMap.png'
        dnm = originaltex+'DetailNormalMap.png'
        bnm = originaltex+'BlendNormalMap.png'
        sgm = originaltex+'SpecGlossMap.png'
        om = originaltex+'OcclusionMap.png'
        tss = originaltex+'Thickness.png'
        mgm = originaltex+'MetallicGlossMap.png'
        ov = originaltex+'OverTex.png'
        Template='HS1-Template Body'
        CTemplate=Template+' '
        C = bpy.context

        def instantiate_group(nodes, data_block_name):
            group = nodes.new(type='ShaderNodeGroup')
            group.node_tree = bpy.data.node_groups[Template]
            return group
        if Template in bpy.data.node_groups:
            instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
        else:
        #    versions = ( t0, t1, t2, t3, t4)
        #    for x in versions:
        #        if os.path.isdir(x) and os.access(x, os.R_OK):
            if (3, 0, 0) <= bpy.app.version < (3, 0, 99):
                before_data = list(bpy.data.node_groups)
                bpy.ops.wm.append(directory=os.path.expanduser(r"~\AppData\Roaming\Blender Foundation\Blender\3.0\scripts\addons\sklx_creator\assets\HS1_Template_Shader.blend") + r'\NodeTree',filename=Template,link=False)
                new_data=list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
                appended_2B5AC = None if not new_data else new_data[0]
                instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
            else:
                if (3, 1, 0) <= bpy.app.version < (3, 1, 99):
                    before_data = list(bpy.data.node_groups)
                    bpy.ops.wm.append(directory=os.path.expanduser(r"~\AppData\Roaming\Blender Foundation\Blender\3.1\scripts\addons\sklx_creator\assets\HS1_Template_Shader.blend") + r'\NodeTree',filename=Template,link=False)
                    new_data=list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
                    appended_2B5AC = None if not new_data else new_data[0]
                    instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
                else:
                    if (3, 2, 0) <= bpy.app.version < (3, 2, 99):
                        before_data = list(bpy.data.node_groups)
                        bpy.ops.wm.append(directory=os.path.expanduser(r"~\AppData\Roaming\Blender Foundation\Blender\3.2\scripts\addons\sklx_creator\assets\HS1_Template_Shader.blend") + r'\NodeTree',filename=Template,link=False)
                        new_data=list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
                        appended_2B5AC = None if not new_data else new_data[0]
                        instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
                    else:
                        if (3, 3, 0) <= bpy.app.version < (3, 3, 99):
                            before_data = list(bpy.data.node_groups)
                            bpy.ops.wm.append(directory=os.path.expanduser(r"~\AppData\Roaming\Blender Foundation\Blender\3.3\scripts\addons\sklx_creator\assets\HS1_Template_Shader.blend") + r'\NodeTree',filename=Template,link=False)
                            new_data=list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
                            appended_2B5AC = None if not new_data else new_data[0]
                            instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
                        else:
                            if (3, 4, 0) <= bpy.app.version < (3, 4, 99):
                                before_data = list(bpy.data.node_groups)
                                bpy.ops.wm.append(directory=os.path.expanduser(r"~\AppData\Roaming\Blender Foundation\Blender\3.4\scripts\addons\sklx_creator\assets\HS1_Template_Shader.blend") + r'\NodeTree',filename=Template,link=False)
                                new_data=list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
                                appended_2B5AC = None if not new_data else new_data[0]
                                instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
        bpy.data.node_groups[Template].name = CTemplate+Tex
        node = bpy.data.node_groups[CTemplate+Tex]
        #initial_area_type = bpy.context.area.type
        #bpy.context.area.type = 'NODE_EDITOR'
        #bpy.context.area.ui_type = 'ShaderNodeTree'
        #bpy.ops.node.group_ungroup()
        #bpy.context.area.type = initial_area_type
        nodes = my_mat.node_tree.nodes
        for node in nodes:
            #node.select = False
            print(node.name)
            node.select = True
            nodes.active = node
        try:
            initial_area_type = bpy.context.area.type
            bpy.context.area.type = 'NODE_EDITOR'
            bpy.context.area.ui_type = 'ShaderNodeTree'
            bpy.ops.wm.redraw_timer(type='DRAW_WIN', iterations=1)
            bpy.ops.node.group_ungroup()
            nonono = node," to Ungroup"
            print(nonono)
            bpy.ops.node.group_edit(exit=True)
        except Exception as e:
            print(e)
        finally:
            bpy.context.area.type = initial_area_type
        fixlocate = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\\20220603141428_Chika_Haruno\\Textures\\"
        bpimg = bpy.data.images.get
        if 1==1:
            print(mm)
            print(dm)
            print(nm)
            print(t2)
            print(t3)
        #formula_list=(nm,nd,dm,mm,t2,t3,am,lm,ar,ov1,ov2,lnm,com,glo,bum,dnm,bnm,sgm,om,tss,mgm,ov)
        #for formula in formula_list:
        #    if bpimg(formula) is not None:
        f1 = bpimg(mm)
        #for x in f1:
        if f1 is not None:
            bpy.data.images[mm].name = TexMain
            bpy.data.images[TexMain].filepath = fixlocate+TexMain
            bpy.data.images[TexMain].filepath_raw = fixlocate+TexMain
        f2 = bpimg(dm)
        #for x in f2:
        if f2 is not None:
            bpy.data.images[dm].name = TexDetailM
            bpy.data.images[TexDetailM].filepath = fixlocate+TexDetailM
            bpy.data.images[TexDetailM].filepath_raw = fixlocate+TexDetailM
        f3 = bpimg(nm)
        #for x in f3:
        if f3 is not None:
            bpy.data.images[nm].name = TexNormal
            bpy.data.images[TexNormal].filepath = fixlocate+TexNormal
            bpy.data.images[TexNormal].filepath_raw = fixlocate+TexNormal
        f4 = bpimg(t2)
        #for x in f3:
        if f4 is not None:
            bpy.data.images[t2].name = TexTex2
            bpy.data.images[TexTex2].filepath = fixlocate+TexTex2
            bpy.data.images[TexTex2].filepath_raw = fixlocate+TexTex2
        f5 = bpimg(t3)
        #for x in f4:
        if f5 is not None:
            bpy.data.images[t3].name = TexTex3
            bpy.data.images[TexTex3].filepath = fixlocate+TexTex3
            bpy.data.images[TexTex3].filepath_raw = fixlocate+TexTex3
        f6 = bpimg(am)
        #for x in f5:
        if f6 is not None:
            bpy.data.images[am].name = TexAlphaM
            bpy.data.images[TexAlphaM].filepath = fixlocate+TexAlphaM
            bpy.data.images[TexAlphaM].filepath_raw = fixlocate+TexAlphaM
        f7 = bpimg(lm)
        #for x in f6:
        if f7 is not None:
            bpy.data.images[lm].name = TexLiquidM
            bpy.data.images[TexLiquidM].filepath = fixlocate+TexLiquidM
            bpy.data.images[TexLiquidM].filepath_raw = fixlocate+TexLiquidM
        f8 = bpimg(ar)
        #for f8 in f8:
        if f8 is not None:
            bpy.data.images[ar].name = TexAnotherR
            bpy.data.images[TexAnotherR].filepath = fixlocate+TexAnotherR
            bpy.data.images[TexAnotherR].filepath_raw = fixlocate+TexAnotherR
        f9 = bpimg(nd)
        #for f8 in f8:
        if f9 is not None:
            bpy.data.images[nd].name = TexNDetail
            bpy.data.images[TexNDetail].filepath = fixlocate+TexNDetail
            bpy.data.images[TexNDetail].filepath_raw = fixlocate+TexNDetail
        f10 = bpimg(ov1)
        #for f8 in f8:
        if f10 is not None:
            bpy.data.images[ov1].name = TexOv1
            bpy.data.images[TexOv1].filepath = fixlocate+TexOv1
            bpy.data.images[TexOv1].filepath_raw = fixlocate+TexOv1
        f11 = bpimg(ov2)
        #for f8 in f8:
        if f11 is not None:
            bpy.data.images[ov2].name = TexOv2
            bpy.data.images[TexOv2].filepath = fixlocate+TexOv2
            bpy.data.images[TexOv2].filepath_raw = fixlocate+TexOv2
        f12 = bpimg(lnm)
        #for f8 in f8:
        if f12 is not None:
            bpy.data.images[lnm].name = TexLineM
            bpy.data.images[TexLineM].filepath = fixlocate+TexLineM
            bpy.data.images[TexLineM].filepath_raw = fixlocate+TexLineM
        f13 = bpimg(com)
        #for f8 in f8:
        if f13 is not None:
            bpy.data.images[com].name = TexColorM
            bpy.data.images[TexColorM].filepath = fixlocate+TexColorM
            bpy.data.images[TexColorM].filepath_raw = fixlocate+TexColorM
        f14 = bpimg(glo)
        #for f8 in f8:
        if f14 is not None:
            bpy.data.images[glo].name = TexHairG
            bpy.data.images[TexHairG].filepath = fixlocate+TexHairG
            bpy.data.images[TexHairG].filepath_raw = fixlocate+TexHairG
        f15 = bpimg(bum)
        #for f8 in f8:
        if f15 is not None:
            bpy.data.images[bum].name = TexBump
            bpy.data.images[TexBump].filepath = fixlocate+TexBump
            bpy.data.images[TexBump].filepath_raw = fixlocate+TexBump
        f16 = bpimg(dnm)
        #for f8 in f8:
        if f16 is not None:
            bpy.data.images[dnm].name = TexDNM
            bpy.data.images[TexDNM].filepath = fixlocate+TexDNM
            bpy.data.images[TexDNM].filepath_raw = fixlocate+TexDNM
        f17 = bpimg(bnm)
        #for f8 in f8:
        if f17 is not None:
            bpy.data.images[bnm].name = TexBNM
            bpy.data.images[TexBNM].filepath = fixlocate+TexBNM
            bpy.data.images[TexBNM].filepath_raw = fixlocate+TexBNM
        f18 = bpimg(sgm)
        #for f8 in f8:
        if f18 is not None:
            bpy.data.images[sgm].name = TexSGM
            bpy.data.images[TexSGM].filepath = fixlocate+TexSGM
            bpy.data.images[TexSGM].filepath_raw = fixlocate+TexSGM
        f19 = bpimg(om)
        #for f8 in f8:
        if f19 is not None:
            bpy.data.images[om].name = TexOM
            bpy.data.images[TexOM].filepath = fixlocate+TexOM
            bpy.data.images[TexOM].filepath_raw = fixlocate+TexOM
        f20 = bpimg(tss)
        #for f8 in f8:
        if f20 is not None:
            bpy.data.images[tss].name = TexTSS
            bpy.data.images[TexTSS].filepath = fixlocate+TexTSS
            bpy.data.images[TexTSS].filepath_raw = fixlocate+TexTSS
        f21 = bpimg(mgm)
        #for f8 in f8:
        if f21 is not None:
            bpy.data.images[mgm].name = TexMGM
            bpy.data.images[TexMGM].filepath = fixlocate+TexMGM
            bpy.data.images[TexMGM].filepath_raw = fixlocate+TexMGM
        f22 = bpimg(ov)
        #for f8 in f8:
        if f22 is not None:
            bpy.data.images[ov].name = TexOV
            bpy.data.images[TexOV].filepath = fixlocate+TexOV
            bpy.data.images[TexOV].filepath_raw = fixlocate+TexOV
        bpy.ops.file.find_missing_files('INVOKE_DEFAULT')
        return {"FINISHED"}

    def invoke(self, context, event):
        return self.execute(context)


class SNA_OT_Hs1Top_Cd510(bpy.types.Operator):
    bl_idname = "sna.hs1top_cd510"
    bl_label = "hs1-top"
    bl_description = ""
    bl_options = {"REGISTER", "UNDO"}

    @classmethod
    def poll(cls, context):
        return not False

    def execute(self, context):
        import os
        ########################################################################
        my_mat = bpy.context.object.material_slots[0].material
        print(my_mat.name)
        Tex=my_mat.name
        rem_mat = bpy.data.materials[Tex]
        #Get the node in its node tree (replace the name below)
        node_to_delete =  rem_mat.node_tree.nodes['Principled BSDF']
        node_to_delete2 =  rem_mat.node_tree.nodes['Material Output']
        #Remove it
        rem_mat.node_tree.nodes.remove(node_to_delete)
        rem_mat.node_tree.nodes.remove(node_to_delete2)
        #Tex = material.name
        TexMain = Tex+'_MainTex.png'
        TexDetailM = Tex+'_DetailMask.png'
        TexNormal = Tex+'_NormalMap.png'
        TexNDetail = Tex+'_NormalMapDetail.png'
        TexAlphaM = Tex+'_AlphaMask.png'
        TexAnotherR = Tex+'_AnotherRamp.png'
        TexLiquidM = Tex+'_liquidmask.png'
        TexTex2 = Tex+'_Texture2.png'
        TexTex3 = Tex+'_Texture3.png'
        TexOv1 = Tex+'_overtex1.png'
        TexOv2 = Tex+'_overtex2.png'
        TexLineM = Tex+'_LineMask.png'
        TexColorM = Tex+'_ColorMask.png'
        TexHairG = Tex+'_HairGloss.png'
        TexBump = Tex+'_BumpMap.png'
        TexDNM = Tex+'_DetailNormalMap.png'
        TexBNM = Tex+'_BlendNormalMap.png'
        TexSGM = Tex+'_SpecGlossMap.png'
        TexOM = Tex+'_OcclusionMap.png'
        TexTSS = Tex+'_Thickness.png'
        TexMGM = Tex+'_MetallicGlossMap.png'
        TexOV = Tex+'_OverTex.png'
        originaltex = 'cf_m_top51_con_00_'
        #originaltss = 'cf_m_body_01_'
        #kkp
        nm = originaltex+'NormalMap.png'
        nd = originaltex+'NormalMapDetail.png'
        dm = originaltex+'DetailMask.png'
        mm = originaltex+'MainTex.png'
        t3 = originaltex+'Texture3.png'
        t2 = originaltex+'Texture2.png'
        am = originaltex+'AlphaMask.png'
        lm = originaltex+'liquidmask.png'
        ar = originaltex+'AnotherRamp.png'
        ov1 = originaltex+'overtex1.png'
        ov2 = originaltex+'overtex2.png'
        lnm = originaltex+'LineMask.png'
        com = originaltex+'ColorMask.png'
        glo = originaltex+'HairGloss.png'
        #hs1
        bum = originaltex+'BumpMap.png'
        dnm = originaltex+'DetailNormalMap.png'
        bnm = originaltex+'BlendNormalMap.png'
        sgm = originaltex+'SpecGlossMap.png'
        om = originaltex+'OcclusionMap.png'
        tss = originaltex+'Thickness.png'
        mgm = originaltex+'MetallicGlossMap.png'
        ov = originaltex+'OverTex.png'
        Template='HS1-Template Top'
        CTemplate=Template+' '
        C = bpy.context

        def instantiate_group(nodes, data_block_name):
            group = nodes.new(type='ShaderNodeGroup')
            group.node_tree = bpy.data.node_groups[Template]
            return group
        if Template in bpy.data.node_groups:
            instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
        else:
        #    versions = ( t0, t1, t2, t3, t4)
        #    for x in versions:
        #        if os.path.isdir(x) and os.access(x, os.R_OK):
            if (3, 0, 0) <= bpy.app.version < (3, 0, 99):
                before_data = list(bpy.data.node_groups)
                bpy.ops.wm.append(directory=os.path.expanduser(r"~\AppData\Roaming\Blender Foundation\Blender\3.0\scripts\addons\sklx_creator\assets\HS1_Template_Shader.blend") + r'\NodeTree',filename=Template,link=False)
                new_data=list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
                appended_2B5AC = None if not new_data else new_data[0]
                instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
            else:
                if (3, 1, 0) <= bpy.app.version < (3, 1, 99):
                    before_data = list(bpy.data.node_groups)
                    bpy.ops.wm.append(directory=os.path.expanduser(r"~\AppData\Roaming\Blender Foundation\Blender\3.1\scripts\addons\sklx_creator\assets\HS1_Template_Shader.blend") + r'\NodeTree',filename=Template,link=False)
                    new_data=list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
                    appended_2B5AC = None if not new_data else new_data[0]
                    instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
                else:
                    if (3, 2, 0) <= bpy.app.version < (3, 2, 99):
                        before_data = list(bpy.data.node_groups)
                        bpy.ops.wm.append(directory=os.path.expanduser(r"~\AppData\Roaming\Blender Foundation\Blender\3.2\scripts\addons\sklx_creator\assets\HS1_Template_Shader.blend") + r'\NodeTree',filename=Template,link=False)
                        new_data=list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
                        appended_2B5AC = None if not new_data else new_data[0]
                        instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
                    else:
                        if (3, 3, 0) <= bpy.app.version < (3, 3, 99):
                            before_data = list(bpy.data.node_groups)
                            bpy.ops.wm.append(directory=os.path.expanduser(r"~\AppData\Roaming\Blender Foundation\Blender\3.3\scripts\addons\sklx_creator\assets\HS1_Template_Shader.blend") + r'\NodeTree',filename=Template,link=False)
                            new_data=list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
                            appended_2B5AC = None if not new_data else new_data[0]
                            instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
                        else:
                            if (3, 4, 0) <= bpy.app.version < (3, 4, 99):
                                before_data = list(bpy.data.node_groups)
                                bpy.ops.wm.append(directory=os.path.expanduser(r"~\AppData\Roaming\Blender Foundation\Blender\3.4\scripts\addons\sklx_creator\assets\HS1_Template_Shader.blend") + r'\NodeTree',filename=Template,link=False)
                                new_data=list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
                                appended_2B5AC = None if not new_data else new_data[0]
                                instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
        bpy.data.node_groups[Template].name = CTemplate+Tex
        node = bpy.data.node_groups[CTemplate+Tex]
        #initial_area_type = bpy.context.area.type
        #bpy.context.area.type = 'NODE_EDITOR'
        #bpy.context.area.ui_type = 'ShaderNodeTree'
        #bpy.ops.node.group_ungroup()
        #bpy.context.area.type = initial_area_type
        nodes = my_mat.node_tree.nodes
        for node in nodes:
            #node.select = False
            print(node.name)
            node.select = True
            nodes.active = node
        try:
            initial_area_type = bpy.context.area.type
            bpy.context.area.type = 'NODE_EDITOR'
            bpy.context.area.ui_type = 'ShaderNodeTree'
            bpy.ops.wm.redraw_timer(type='DRAW_WIN', iterations=1)
            bpy.ops.node.group_ungroup()
            nonono = node," to Ungroup"
            print(nonono)
            bpy.ops.node.group_edit(exit=True)
        except Exception as e:
            print(e)
        finally:
            bpy.context.area.type = initial_area_type
        fixlocate = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\\20220603141428_Chika_Haruno\\Textures\\"
        bpimg = bpy.data.images.get
        if 1==1:
            print(mm)
            print(dm)
            print(nm)
            print(t2)
            print(t3)
        #formula_list=(nm,nd,dm,mm,t2,t3,am,lm,ar,ov1,ov2,lnm,com,glo,bum,dnm,bnm,sgm,om,tss,mgm,ov)
        #for formula in formula_list:
        #    if bpimg(formula) is not None:
        f1 = bpimg(mm)
        #for x in f1:
        if f1 is not None:
            bpy.data.images[mm].name = TexMain
            bpy.data.images[TexMain].filepath = fixlocate+TexMain
            bpy.data.images[TexMain].filepath_raw = fixlocate+TexMain
        f2 = bpimg(dm)
        #for x in f2:
        if f2 is not None:
            bpy.data.images[dm].name = TexDetailM
            bpy.data.images[TexDetailM].filepath = fixlocate+TexDetailM
            bpy.data.images[TexDetailM].filepath_raw = fixlocate+TexDetailM
        f3 = bpimg(nm)
        #for x in f3:
        if f3 is not None:
            bpy.data.images[nm].name = TexNormal
            bpy.data.images[TexNormal].filepath = fixlocate+TexNormal
            bpy.data.images[TexNormal].filepath_raw = fixlocate+TexNormal
        f4 = bpimg(t2)
        #for x in f3:
        if f4 is not None:
            bpy.data.images[t2].name = TexTex2
            bpy.data.images[TexTex2].filepath = fixlocate+TexTex2
            bpy.data.images[TexTex2].filepath_raw = fixlocate+TexTex2
        f5 = bpimg(t3)
        #for x in f4:
        if f5 is not None:
            bpy.data.images[t3].name = TexTex3
            bpy.data.images[TexTex3].filepath = fixlocate+TexTex3
            bpy.data.images[TexTex3].filepath_raw = fixlocate+TexTex3
        f6 = bpimg(am)
        #for x in f5:
        if f6 is not None:
            bpy.data.images[am].name = TexAlphaM
            bpy.data.images[TexAlphaM].filepath = fixlocate+TexAlphaM
            bpy.data.images[TexAlphaM].filepath_raw = fixlocate+TexAlphaM
        f7 = bpimg(lm)
        #for x in f6:
        if f7 is not None:
            bpy.data.images[lm].name = TexLiquidM
            bpy.data.images[TexLiquidM].filepath = fixlocate+TexLiquidM
            bpy.data.images[TexLiquidM].filepath_raw = fixlocate+TexLiquidM
        f8 = bpimg(ar)
        #for f8 in f8:
        if f8 is not None:
            bpy.data.images[ar].name = TexAnotherR
            bpy.data.images[TexAnotherR].filepath = fixlocate+TexAnotherR
            bpy.data.images[TexAnotherR].filepath_raw = fixlocate+TexAnotherR
        f9 = bpimg(nd)
        #for f8 in f8:
        if f9 is not None:
            bpy.data.images[nd].name = TexNDetail
            bpy.data.images[TexNDetail].filepath = fixlocate+TexNDetail
            bpy.data.images[TexNDetail].filepath_raw = fixlocate+TexNDetail
        f10 = bpimg(ov1)
        #for f8 in f8:
        if f10 is not None:
            bpy.data.images[ov1].name = TexOv1
            bpy.data.images[TexOv1].filepath = fixlocate+TexOv1
            bpy.data.images[TexOv1].filepath_raw = fixlocate+TexOv1
        f11 = bpimg(ov2)
        #for f8 in f8:
        if f11 is not None:
            bpy.data.images[ov2].name = TexOv2
            bpy.data.images[TexOv2].filepath = fixlocate+TexOv2
            bpy.data.images[TexOv2].filepath_raw = fixlocate+TexOv2
        f12 = bpimg(lnm)
        #for f8 in f8:
        if f12 is not None:
            bpy.data.images[lnm].name = TexLineM
            bpy.data.images[TexLineM].filepath = fixlocate+TexLineM
            bpy.data.images[TexLineM].filepath_raw = fixlocate+TexLineM
        f13 = bpimg(com)
        #for f8 in f8:
        if f13 is not None:
            bpy.data.images[com].name = TexColorM
            bpy.data.images[TexColorM].filepath = fixlocate+TexColorM
            bpy.data.images[TexColorM].filepath_raw = fixlocate+TexColorM
        f14 = bpimg(glo)
        #for f8 in f8:
        if f14 is not None:
            bpy.data.images[glo].name = TexHairG
            bpy.data.images[TexHairG].filepath = fixlocate+TexHairG
            bpy.data.images[TexHairG].filepath_raw = fixlocate+TexHairG
        f15 = bpimg(bum)
        #for f8 in f8:
        if f15 is not None:
            bpy.data.images[bum].name = TexBump
            bpy.data.images[TexBump].filepath = fixlocate+TexBump
            bpy.data.images[TexBump].filepath_raw = fixlocate+TexBump
        f16 = bpimg(dnm)
        #for f8 in f8:
        if f16 is not None:
            bpy.data.images[dnm].name = TexDNM
            bpy.data.images[TexDNM].filepath = fixlocate+TexDNM
            bpy.data.images[TexDNM].filepath_raw = fixlocate+TexDNM
        f17 = bpimg(bnm)
        #for f8 in f8:
        if f17 is not None:
            bpy.data.images[bnm].name = TexBNM
            bpy.data.images[TexBNM].filepath = fixlocate+TexBNM
            bpy.data.images[TexBNM].filepath_raw = fixlocate+TexBNM
        f18 = bpimg(sgm)
        #for f8 in f8:
        if f18 is not None:
            bpy.data.images[sgm].name = TexSGM
            bpy.data.images[TexSGM].filepath = fixlocate+TexSGM
            bpy.data.images[TexSGM].filepath_raw = fixlocate+TexSGM
        f19 = bpimg(om)
        #for f8 in f8:
        if f19 is not None:
            bpy.data.images[om].name = TexOM
            bpy.data.images[TexOM].filepath = fixlocate+TexOM
            bpy.data.images[TexOM].filepath_raw = fixlocate+TexOM
        f20 = bpimg(tss)
        #for f8 in f8:
        if f20 is not None:
            bpy.data.images[tss].name = TexTSS
            bpy.data.images[TexTSS].filepath = fixlocate+TexTSS
            bpy.data.images[TexTSS].filepath_raw = fixlocate+TexTSS
        f21 = bpimg(mgm)
        #for f8 in f8:
        if f21 is not None:
            bpy.data.images[mgm].name = TexMGM
            bpy.data.images[TexMGM].filepath = fixlocate+TexMGM
            bpy.data.images[TexMGM].filepath_raw = fixlocate+TexMGM
        f22 = bpimg(ov)
        #for f8 in f8:
        if f22 is not None:
            bpy.data.images[ov].name = TexOV
            bpy.data.images[TexOV].filepath = fixlocate+TexOV
            bpy.data.images[TexOV].filepath_raw = fixlocate+TexOV
        bpy.ops.file.find_missing_files('INVOKE_DEFAULT')
        return {"FINISHED"}

    def invoke(self, context, event):
        return self.execute(context)


class SNA_OT_Hs1Bot_A2C63(bpy.types.Operator):
    bl_idname = "sna.hs1bot_a2c63"
    bl_label = "hs1-bot"
    bl_description = ""
    bl_options = {"REGISTER", "UNDO"}

    @classmethod
    def poll(cls, context):
        return not False

    def execute(self, context):
        import os
        ########################################################################
        my_mat = bpy.context.object.material_slots[0].material
        print(my_mat.name)
        Tex=my_mat.name
        rem_mat = bpy.data.materials[Tex]
        #Get the node in its node tree (replace the name below)
        node_to_delete =  rem_mat.node_tree.nodes['Principled BSDF']
        node_to_delete2 =  rem_mat.node_tree.nodes['Material Output']
        #Remove it
        rem_mat.node_tree.nodes.remove(node_to_delete)
        rem_mat.node_tree.nodes.remove(node_to_delete2)
        #Tex = material.name
        TexMain = Tex+'_MainTex.png'
        TexDetailM = Tex+'_DetailMask.png'
        TexNormal = Tex+'_NormalMap.png'
        TexNDetail = Tex+'_NormalMapDetail.png'
        TexAlphaM = Tex+'_AlphaMask.png'
        TexAnotherR = Tex+'_AnotherRamp.png'
        TexLiquidM = Tex+'_liquidmask.png'
        TexTex2 = Tex+'_Texture2.png'
        TexTex3 = Tex+'_Texture3.png'
        TexOv1 = Tex+'_overtex1.png'
        TexOv2 = Tex+'_overtex2.png'
        TexLineM = Tex+'_LineMask.png'
        TexColorM = Tex+'_ColorMask.png'
        TexHairG = Tex+'_HairGloss.png'
        TexBump = Tex+'_BumpMap.png'
        TexDNM = Tex+'_DetailNormalMap.png'
        TexBNM = Tex+'_BlendNormalMap.png'
        TexSGM = Tex+'_SpecGlossMap.png'
        TexOM = Tex+'_OcclusionMap.png'
        TexTSS = Tex+'_Thickness.png'
        TexMGM = Tex+'_MetallicGlossMap.png'
        TexOV = Tex+'_OverTex.png'
        originaltex = 'cf_m_bot51_con_00_'
        #originaltss = 'cf_m_body_01_'
        #kkp
        nm = originaltex+'NormalMap.png'
        nd = originaltex+'NormalMapDetail.png'
        dm = originaltex+'DetailMask.png'
        mm = originaltex+'MainTex.png'
        t3 = originaltex+'Texture3.png'
        t2 = originaltex+'Texture2.png'
        am = originaltex+'AlphaMask.png'
        lm = originaltex+'liquidmask.png'
        ar = originaltex+'AnotherRamp.png'
        ov1 = originaltex+'overtex1.png'
        ov2 = originaltex+'overtex2.png'
        lnm = originaltex+'LineMask.png'
        com = originaltex+'ColorMask.png'
        glo = originaltex+'HairGloss.png'
        #hs1
        bum = originaltex+'BumpMap.png'
        dnm = originaltex+'DetailNormalMap.png'
        bnm = originaltex+'BlendNormalMap.png'
        sgm = originaltex+'SpecGlossMap.png'
        om = originaltex+'OcclusionMap.png'
        tss = originaltex+'Thickness.png'
        mgm = originaltex+'MetallicGlossMap.png'
        ov = originaltex+'OverTex.png'
        Template='HS1-Template Pants'
        CTemplate=Template+' '
        C = bpy.context

        def instantiate_group(nodes, data_block_name):
            group = nodes.new(type='ShaderNodeGroup')
            group.node_tree = bpy.data.node_groups[Template]
            return group
        if Template in bpy.data.node_groups:
            instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
        else:
        #    versions = ( t0, t1, t2, t3, t4)
        #    for x in versions:
        #        if os.path.isdir(x) and os.access(x, os.R_OK):
            if (3, 0, 0) <= bpy.app.version < (3, 0, 99):
                before_data = list(bpy.data.node_groups)
                bpy.ops.wm.append(directory=os.path.expanduser(r"~\AppData\Roaming\Blender Foundation\Blender\3.0\scripts\addons\sklx_creator\assets\HS1_Template_Shader.blend") + r'\NodeTree',filename=Template,link=False)
                new_data=list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
                appended_2B5AC = None if not new_data else new_data[0]
                instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
            else:
                if (3, 1, 0) <= bpy.app.version < (3, 1, 99):
                    before_data = list(bpy.data.node_groups)
                    bpy.ops.wm.append(directory=os.path.expanduser(r"~\AppData\Roaming\Blender Foundation\Blender\3.1\scripts\addons\sklx_creator\assets\HS1_Template_Shader.blend") + r'\NodeTree',filename=Template,link=False)
                    new_data=list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
                    appended_2B5AC = None if not new_data else new_data[0]
                    instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
                else:
                    if (3, 2, 0) <= bpy.app.version < (3, 2, 99):
                        before_data = list(bpy.data.node_groups)
                        bpy.ops.wm.append(directory=os.path.expanduser(r"~\AppData\Roaming\Blender Foundation\Blender\3.2\scripts\addons\sklx_creator\assets\HS1_Template_Shader.blend") + r'\NodeTree',filename=Template,link=False)
                        new_data=list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
                        appended_2B5AC = None if not new_data else new_data[0]
                        instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
                    else:
                        if (3, 3, 0) <= bpy.app.version < (3, 3, 99):
                            before_data = list(bpy.data.node_groups)
                            bpy.ops.wm.append(directory=os.path.expanduser(r"~\AppData\Roaming\Blender Foundation\Blender\3.3\scripts\addons\sklx_creator\assets\HS1_Template_Shader.blend") + r'\NodeTree',filename=Template,link=False)
                            new_data=list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
                            appended_2B5AC = None if not new_data else new_data[0]
                            instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
                        else:
                            if (3, 4, 0) <= bpy.app.version < (3, 4, 99):
                                before_data = list(bpy.data.node_groups)
                                bpy.ops.wm.append(directory=os.path.expanduser(r"~\AppData\Roaming\Blender Foundation\Blender\3.4\scripts\addons\sklx_creator\assets\HS1_Template_Shader.blend") + r'\NodeTree',filename=Template,link=False)
                                new_data=list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
                                appended_2B5AC = None if not new_data else new_data[0]
                                instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
        bpy.data.node_groups[Template].name = CTemplate+Tex
        node = bpy.data.node_groups[CTemplate+Tex]
        #initial_area_type = bpy.context.area.type
        #bpy.context.area.type = 'NODE_EDITOR'
        #bpy.context.area.ui_type = 'ShaderNodeTree'
        #bpy.ops.node.group_ungroup()
        #bpy.context.area.type = initial_area_type
        nodes = my_mat.node_tree.nodes
        for node in nodes:
            #node.select = False
            print(node.name)
            node.select = True
            nodes.active = node
        try:
            initial_area_type = bpy.context.area.type
            bpy.context.area.type = 'NODE_EDITOR'
            bpy.context.area.ui_type = 'ShaderNodeTree'
            bpy.ops.wm.redraw_timer(type='DRAW_WIN', iterations=1)
            bpy.ops.node.group_ungroup()
            nonono = node," to Ungroup"
            print(nonono)
            bpy.ops.node.group_edit(exit=True)
        except Exception as e:
            print(e)
        finally:
            bpy.context.area.type = initial_area_type
        fixlocate = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\\20220603141428_Chika_Haruno\\Textures\\"
        bpimg = bpy.data.images.get
        if 1==1:
            print(mm)
            print(dm)
            print(nm)
            print(t2)
            print(t3)
        #formula_list=(nm,nd,dm,mm,t2,t3,am,lm,ar,ov1,ov2,lnm,com,glo,bum,dnm,bnm,sgm,om,tss,mgm,ov)
        #for formula in formula_list:
        #    if bpimg(formula) is not None:
        f1 = bpimg(mm)
        #for x in f1:
        if f1 is not None:
            bpy.data.images[mm].name = TexMain
            bpy.data.images[TexMain].filepath = fixlocate+TexMain
            bpy.data.images[TexMain].filepath_raw = fixlocate+TexMain
        f2 = bpimg(dm)
        #for x in f2:
        if f2 is not None:
            bpy.data.images[dm].name = TexDetailM
            bpy.data.images[TexDetailM].filepath = fixlocate+TexDetailM
            bpy.data.images[TexDetailM].filepath_raw = fixlocate+TexDetailM
        f3 = bpimg(nm)
        #for x in f3:
        if f3 is not None:
            bpy.data.images[nm].name = TexNormal
            bpy.data.images[TexNormal].filepath = fixlocate+TexNormal
            bpy.data.images[TexNormal].filepath_raw = fixlocate+TexNormal
        f4 = bpimg(t2)
        #for x in f3:
        if f4 is not None:
            bpy.data.images[t2].name = TexTex2
            bpy.data.images[TexTex2].filepath = fixlocate+TexTex2
            bpy.data.images[TexTex2].filepath_raw = fixlocate+TexTex2
        f5 = bpimg(t3)
        #for x in f4:
        if f5 is not None:
            bpy.data.images[t3].name = TexTex3
            bpy.data.images[TexTex3].filepath = fixlocate+TexTex3
            bpy.data.images[TexTex3].filepath_raw = fixlocate+TexTex3
        f6 = bpimg(am)
        #for x in f5:
        if f6 is not None:
            bpy.data.images[am].name = TexAlphaM
            bpy.data.images[TexAlphaM].filepath = fixlocate+TexAlphaM
            bpy.data.images[TexAlphaM].filepath_raw = fixlocate+TexAlphaM
        f7 = bpimg(lm)
        #for x in f6:
        if f7 is not None:
            bpy.data.images[lm].name = TexLiquidM
            bpy.data.images[TexLiquidM].filepath = fixlocate+TexLiquidM
            bpy.data.images[TexLiquidM].filepath_raw = fixlocate+TexLiquidM
        f8 = bpimg(ar)
        #for f8 in f8:
        if f8 is not None:
            bpy.data.images[ar].name = TexAnotherR
            bpy.data.images[TexAnotherR].filepath = fixlocate+TexAnotherR
            bpy.data.images[TexAnotherR].filepath_raw = fixlocate+TexAnotherR
        f9 = bpimg(nd)
        #for f8 in f8:
        if f9 is not None:
            bpy.data.images[nd].name = TexNDetail
            bpy.data.images[TexNDetail].filepath = fixlocate+TexNDetail
            bpy.data.images[TexNDetail].filepath_raw = fixlocate+TexNDetail
        f10 = bpimg(ov1)
        #for f8 in f8:
        if f10 is not None:
            bpy.data.images[ov1].name = TexOv1
            bpy.data.images[TexOv1].filepath = fixlocate+TexOv1
            bpy.data.images[TexOv1].filepath_raw = fixlocate+TexOv1
        f11 = bpimg(ov2)
        #for f8 in f8:
        if f11 is not None:
            bpy.data.images[ov2].name = TexOv2
            bpy.data.images[TexOv2].filepath = fixlocate+TexOv2
            bpy.data.images[TexOv2].filepath_raw = fixlocate+TexOv2
        f12 = bpimg(lnm)
        #for f8 in f8:
        if f12 is not None:
            bpy.data.images[lnm].name = TexLineM
            bpy.data.images[TexLineM].filepath = fixlocate+TexLineM
            bpy.data.images[TexLineM].filepath_raw = fixlocate+TexLineM
        f13 = bpimg(com)
        #for f8 in f8:
        if f13 is not None:
            bpy.data.images[com].name = TexColorM
            bpy.data.images[TexColorM].filepath = fixlocate+TexColorM
            bpy.data.images[TexColorM].filepath_raw = fixlocate+TexColorM
        f14 = bpimg(glo)
        #for f8 in f8:
        if f14 is not None:
            bpy.data.images[glo].name = TexHairG
            bpy.data.images[TexHairG].filepath = fixlocate+TexHairG
            bpy.data.images[TexHairG].filepath_raw = fixlocate+TexHairG
        f15 = bpimg(bum)
        #for f8 in f8:
        if f15 is not None:
            bpy.data.images[bum].name = TexBump
            bpy.data.images[TexBump].filepath = fixlocate+TexBump
            bpy.data.images[TexBump].filepath_raw = fixlocate+TexBump
        f16 = bpimg(dnm)
        #for f8 in f8:
        if f16 is not None:
            bpy.data.images[dnm].name = TexDNM
            bpy.data.images[TexDNM].filepath = fixlocate+TexDNM
            bpy.data.images[TexDNM].filepath_raw = fixlocate+TexDNM
        f17 = bpimg(bnm)
        #for f8 in f8:
        if f17 is not None:
            bpy.data.images[bnm].name = TexBNM
            bpy.data.images[TexBNM].filepath = fixlocate+TexBNM
            bpy.data.images[TexBNM].filepath_raw = fixlocate+TexBNM
        f18 = bpimg(sgm)
        #for f8 in f8:
        if f18 is not None:
            bpy.data.images[sgm].name = TexSGM
            bpy.data.images[TexSGM].filepath = fixlocate+TexSGM
            bpy.data.images[TexSGM].filepath_raw = fixlocate+TexSGM
        f19 = bpimg(om)
        #for f8 in f8:
        if f19 is not None:
            bpy.data.images[om].name = TexOM
            bpy.data.images[TexOM].filepath = fixlocate+TexOM
            bpy.data.images[TexOM].filepath_raw = fixlocate+TexOM
        f20 = bpimg(tss)
        #for f8 in f8:
        if f20 is not None:
            bpy.data.images[tss].name = TexTSS
            bpy.data.images[TexTSS].filepath = fixlocate+TexTSS
            bpy.data.images[TexTSS].filepath_raw = fixlocate+TexTSS
        f21 = bpimg(mgm)
        #for f8 in f8:
        if f21 is not None:
            bpy.data.images[mgm].name = TexMGM
            bpy.data.images[TexMGM].filepath = fixlocate+TexMGM
            bpy.data.images[TexMGM].filepath_raw = fixlocate+TexMGM
        f22 = bpimg(ov)
        #for f8 in f8:
        if f22 is not None:
            bpy.data.images[ov].name = TexOV
            bpy.data.images[TexOV].filepath = fixlocate+TexOV
            bpy.data.images[TexOV].filepath_raw = fixlocate+TexOV
        bpy.ops.file.find_missing_files('INVOKE_DEFAULT')
        return {"FINISHED"}

    def invoke(self, context, event):
        return self.execute(context)


class SNA_OT_Hs1Fit_Bb512(bpy.types.Operator):
    bl_idname = "sna.hs1fit_bb512"
    bl_label = "hs1-fit"
    bl_description = ""
    bl_options = {"REGISTER", "UNDO"}

    @classmethod
    def poll(cls, context):
        return not False

    def execute(self, context):
        import os
        ########################################################################
        my_mat = bpy.context.object.material_slots[0].material
        print(my_mat.name)
        Tex=my_mat.name
        rem_mat = bpy.data.materials[Tex]
        #Get the node in its node tree (replace the name below)
        node_to_delete =  rem_mat.node_tree.nodes['Principled BSDF']
        node_to_delete2 =  rem_mat.node_tree.nodes['Material Output']
        #Remove it
        rem_mat.node_tree.nodes.remove(node_to_delete)
        rem_mat.node_tree.nodes.remove(node_to_delete2)
        #Tex = material.name
        TexMain = Tex+'_MainTex.png'
        TexDetailM = Tex+'_DetailMask.png'
        TexNormal = Tex+'_NormalMap.png'
        TexNDetail = Tex+'_NormalMapDetail.png'
        TexAlphaM = Tex+'_AlphaMask.png'
        TexAnotherR = Tex+'_AnotherRamp.png'
        TexLiquidM = Tex+'_liquidmask.png'
        TexTex2 = Tex+'_Texture2.png'
        TexTex3 = Tex+'_Texture3.png'
        TexOv1 = Tex+'_overtex1.png'
        TexOv2 = Tex+'_overtex2.png'
        TexLineM = Tex+'_LineMask.png'
        TexColorM = Tex+'_ColorMask.png'
        TexHairG = Tex+'_HairGloss.png'
        TexBump = Tex+'_BumpMap.png'
        TexDNM = Tex+'_DetailNormalMap.png'
        TexBNM = Tex+'_BlendNormalMap.png'
        TexSGM = Tex+'_SpecGlossMap.png'
        TexOM = Tex+'_OcclusionMap.png'
        TexTSS = Tex+'_Thickness.png'
        TexMGM = Tex+'_MetallicGlossMap.png'
        TexOV = Tex+'_OverTex.png'
        originaltex = 'cf_M_panst_'
        #originaltss = 'cf_m_body_01_'
        #kkp
        nm = originaltex+'NormalMap.png'
        nd = originaltex+'NormalMapDetail.png'
        dm = originaltex+'DetailMask.png'
        mm = originaltex+'MainTex.png'
        t3 = originaltex+'Texture3.png'
        t2 = originaltex+'Texture2.png'
        am = originaltex+'AlphaMask.png'
        lm = originaltex+'liquidmask.png'
        ar = originaltex+'AnotherRamp.png'
        ov1 = originaltex+'overtex1.png'
        ov2 = originaltex+'overtex2.png'
        lnm = originaltex+'LineMask.png'
        com = originaltex+'ColorMask.png'
        glo = originaltex+'HairGloss.png'
        #hs1
        bum = originaltex+'BumpMap.png'
        dnm = originaltex+'DetailNormalMap.png'
        bnm = originaltex+'BlendNormalMap.png'
        sgm = originaltex+'SpecGlossMap.png'
        om = originaltex+'OcclusionMap.png'
        tss = originaltex+'Thickness.png'
        mgm = originaltex+'MetallicGlossMap.png'
        ov = originaltex+'OverTex.png'
        Template='HS1-Template Fit'
        CTemplate=Template+' '
        C = bpy.context

        def instantiate_group(nodes, data_block_name):
            group = nodes.new(type='ShaderNodeGroup')
            group.node_tree = bpy.data.node_groups[Template]
            return group
        if Template in bpy.data.node_groups:
            instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
        else:
        #    versions = ( t0, t1, t2, t3, t4)
        #    for x in versions:
        #        if os.path.isdir(x) and os.access(x, os.R_OK):
            if (3, 0, 0) <= bpy.app.version < (3, 0, 99):
                before_data = list(bpy.data.node_groups)
                bpy.ops.wm.append(directory=os.path.expanduser(r"~\AppData\Roaming\Blender Foundation\Blender\3.0\scripts\addons\sklx_creator\assets\HS1_Template_Shader.blend") + r'\NodeTree',filename=Template,link=False)
                new_data=list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
                appended_2B5AC = None if not new_data else new_data[0]
                instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
            else:
                if (3, 1, 0) <= bpy.app.version < (3, 1, 99):
                    before_data = list(bpy.data.node_groups)
                    bpy.ops.wm.append(directory=os.path.expanduser(r"~\AppData\Roaming\Blender Foundation\Blender\3.1\scripts\addons\sklx_creator\assets\HS1_Template_Shader.blend") + r'\NodeTree',filename=Template,link=False)
                    new_data=list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
                    appended_2B5AC = None if not new_data else new_data[0]
                    instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
                else:
                    if (3, 2, 0) <= bpy.app.version < (3, 2, 99):
                        before_data = list(bpy.data.node_groups)
                        bpy.ops.wm.append(directory=os.path.expanduser(r"~\AppData\Roaming\Blender Foundation\Blender\3.2\scripts\addons\sklx_creator\assets\HS1_Template_Shader.blend") + r'\NodeTree',filename=Template,link=False)
                        new_data=list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
                        appended_2B5AC = None if not new_data else new_data[0]
                        instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
                    else:
                        if (3, 3, 0) <= bpy.app.version < (3, 3, 99):
                            before_data = list(bpy.data.node_groups)
                            bpy.ops.wm.append(directory=os.path.expanduser(r"~\AppData\Roaming\Blender Foundation\Blender\3.3\scripts\addons\sklx_creator\assets\HS1_Template_Shader.blend") + r'\NodeTree',filename=Template,link=False)
                            new_data=list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
                            appended_2B5AC = None if not new_data else new_data[0]
                            instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
                        else:
                            if (3, 4, 0) <= bpy.app.version < (3, 4, 99):
                                before_data = list(bpy.data.node_groups)
                                bpy.ops.wm.append(directory=os.path.expanduser(r"~\AppData\Roaming\Blender Foundation\Blender\3.4\scripts\addons\sklx_creator\assets\HS1_Template_Shader.blend") + r'\NodeTree',filename=Template,link=False)
                                new_data=list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
                                appended_2B5AC = None if not new_data else new_data[0]
                                instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
        bpy.data.node_groups[Template].name = CTemplate+Tex
        node = bpy.data.node_groups[CTemplate+Tex]
        #initial_area_type = bpy.context.area.type
        #bpy.context.area.type = 'NODE_EDITOR'
        #bpy.context.area.ui_type = 'ShaderNodeTree'
        #bpy.ops.node.group_ungroup()
        #bpy.context.area.type = initial_area_type
        nodes = my_mat.node_tree.nodes
        for node in nodes:
            #node.select = False
            print(node.name)
            node.select = True
            nodes.active = node
        try:
            initial_area_type = bpy.context.area.type
            bpy.context.area.type = 'NODE_EDITOR'
            bpy.context.area.ui_type = 'ShaderNodeTree'
            bpy.ops.wm.redraw_timer(type='DRAW_WIN', iterations=1)
            bpy.ops.node.group_ungroup()
            nonono = node," to Ungroup"
            print(nonono)
            bpy.ops.node.group_edit(exit=True)
        except Exception as e:
            print(e)
        finally:
            bpy.context.area.type = initial_area_type
        fixlocate = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\\20220603141428_Chika_Haruno\\Textures\\"
        bpimg = bpy.data.images.get
        if 1==1:
            print(mm)
            print(dm)
            print(nm)
            print(t2)
            print(t3)
        #formula_list=(nm,nd,dm,mm,t2,t3,am,lm,ar,ov1,ov2,lnm,com,glo,bum,dnm,bnm,sgm,om,tss,mgm,ov)
        #for formula in formula_list:
        #    if bpimg(formula) is not None:
        f1 = bpimg(mm)
        #for x in f1:
        if f1 is not None:
            bpy.data.images[mm].name = TexMain
            bpy.data.images[TexMain].filepath = fixlocate+TexMain
            bpy.data.images[TexMain].filepath_raw = fixlocate+TexMain
        f2 = bpimg(dm)
        #for x in f2:
        if f2 is not None:
            bpy.data.images[dm].name = TexDetailM
            bpy.data.images[TexDetailM].filepath = fixlocate+TexDetailM
            bpy.data.images[TexDetailM].filepath_raw = fixlocate+TexDetailM
        f3 = bpimg(nm)
        #for x in f3:
        if f3 is not None:
            bpy.data.images[nm].name = TexNormal
            bpy.data.images[TexNormal].filepath = fixlocate+TexNormal
            bpy.data.images[TexNormal].filepath_raw = fixlocate+TexNormal
        f4 = bpimg(t2)
        #for x in f3:
        if f4 is not None:
            bpy.data.images[t2].name = TexTex2
            bpy.data.images[TexTex2].filepath = fixlocate+TexTex2
            bpy.data.images[TexTex2].filepath_raw = fixlocate+TexTex2
        f5 = bpimg(t3)
        #for x in f4:
        if f5 is not None:
            bpy.data.images[t3].name = TexTex3
            bpy.data.images[TexTex3].filepath = fixlocate+TexTex3
            bpy.data.images[TexTex3].filepath_raw = fixlocate+TexTex3
        f6 = bpimg(am)
        #for x in f5:
        if f6 is not None:
            bpy.data.images[am].name = TexAlphaM
            bpy.data.images[TexAlphaM].filepath = fixlocate+TexAlphaM
            bpy.data.images[TexAlphaM].filepath_raw = fixlocate+TexAlphaM
        f7 = bpimg(lm)
        #for x in f6:
        if f7 is not None:
            bpy.data.images[lm].name = TexLiquidM
            bpy.data.images[TexLiquidM].filepath = fixlocate+TexLiquidM
            bpy.data.images[TexLiquidM].filepath_raw = fixlocate+TexLiquidM
        f8 = bpimg(ar)
        #for f8 in f8:
        if f8 is not None:
            bpy.data.images[ar].name = TexAnotherR
            bpy.data.images[TexAnotherR].filepath = fixlocate+TexAnotherR
            bpy.data.images[TexAnotherR].filepath_raw = fixlocate+TexAnotherR
        f9 = bpimg(nd)
        #for f8 in f8:
        if f9 is not None:
            bpy.data.images[nd].name = TexNDetail
            bpy.data.images[TexNDetail].filepath = fixlocate+TexNDetail
            bpy.data.images[TexNDetail].filepath_raw = fixlocate+TexNDetail
        f10 = bpimg(ov1)
        #for f8 in f8:
        if f10 is not None:
            bpy.data.images[ov1].name = TexOv1
            bpy.data.images[TexOv1].filepath = fixlocate+TexOv1
            bpy.data.images[TexOv1].filepath_raw = fixlocate+TexOv1
        f11 = bpimg(ov2)
        #for f8 in f8:
        if f11 is not None:
            bpy.data.images[ov2].name = TexOv2
            bpy.data.images[TexOv2].filepath = fixlocate+TexOv2
            bpy.data.images[TexOv2].filepath_raw = fixlocate+TexOv2
        f12 = bpimg(lnm)
        #for f8 in f8:
        if f12 is not None:
            bpy.data.images[lnm].name = TexLineM
            bpy.data.images[TexLineM].filepath = fixlocate+TexLineM
            bpy.data.images[TexLineM].filepath_raw = fixlocate+TexLineM
        f13 = bpimg(com)
        #for f8 in f8:
        if f13 is not None:
            bpy.data.images[com].name = TexColorM
            bpy.data.images[TexColorM].filepath = fixlocate+TexColorM
            bpy.data.images[TexColorM].filepath_raw = fixlocate+TexColorM
        f14 = bpimg(glo)
        #for f8 in f8:
        if f14 is not None:
            bpy.data.images[glo].name = TexHairG
            bpy.data.images[TexHairG].filepath = fixlocate+TexHairG
            bpy.data.images[TexHairG].filepath_raw = fixlocate+TexHairG
        f15 = bpimg(bum)
        #for f8 in f8:
        if f15 is not None:
            bpy.data.images[bum].name = TexBump
            bpy.data.images[TexBump].filepath = fixlocate+TexBump
            bpy.data.images[TexBump].filepath_raw = fixlocate+TexBump
        f16 = bpimg(dnm)
        #for f8 in f8:
        if f16 is not None:
            bpy.data.images[dnm].name = TexDNM
            bpy.data.images[TexDNM].filepath = fixlocate+TexDNM
            bpy.data.images[TexDNM].filepath_raw = fixlocate+TexDNM
        f17 = bpimg(bnm)
        #for f8 in f8:
        if f17 is not None:
            bpy.data.images[bnm].name = TexBNM
            bpy.data.images[TexBNM].filepath = fixlocate+TexBNM
            bpy.data.images[TexBNM].filepath_raw = fixlocate+TexBNM
        f18 = bpimg(sgm)
        #for f8 in f8:
        if f18 is not None:
            bpy.data.images[sgm].name = TexSGM
            bpy.data.images[TexSGM].filepath = fixlocate+TexSGM
            bpy.data.images[TexSGM].filepath_raw = fixlocate+TexSGM
        f19 = bpimg(om)
        #for f8 in f8:
        if f19 is not None:
            bpy.data.images[om].name = TexOM
            bpy.data.images[TexOM].filepath = fixlocate+TexOM
            bpy.data.images[TexOM].filepath_raw = fixlocate+TexOM
        f20 = bpimg(tss)
        #for f8 in f8:
        if f20 is not None:
            bpy.data.images[tss].name = TexTSS
            bpy.data.images[TexTSS].filepath = fixlocate+TexTSS
            bpy.data.images[TexTSS].filepath_raw = fixlocate+TexTSS
        f21 = bpimg(mgm)
        #for f8 in f8:
        if f21 is not None:
            bpy.data.images[mgm].name = TexMGM
            bpy.data.images[TexMGM].filepath = fixlocate+TexMGM
            bpy.data.images[TexMGM].filepath_raw = fixlocate+TexMGM
        f22 = bpimg(ov)
        #for f8 in f8:
        if f22 is not None:
            bpy.data.images[ov].name = TexOV
            bpy.data.images[TexOV].filepath = fixlocate+TexOV
            bpy.data.images[TexOV].filepath_raw = fixlocate+TexOV
        bpy.ops.file.find_missing_files('INVOKE_DEFAULT')
        return {"FINISHED"}

    def invoke(self, context, event):
        return self.execute(context)


class SNA_OT_Hs1Shoes_1C954(bpy.types.Operator):
    bl_idname = "sna.hs1shoes_1c954"
    bl_label = "hs1-shoes"
    bl_description = ""
    bl_options = {"REGISTER", "UNDO"}

    @classmethod
    def poll(cls, context):
        return not False

    def execute(self, context):
        import os
        ########################################################################
        my_mat = bpy.context.object.material_slots[0].material
        print(my_mat.name)
        Tex=my_mat.name
        rem_mat = bpy.data.materials[Tex]
        #Get the node in its node tree (replace the name below)
        node_to_delete =  rem_mat.node_tree.nodes['Principled BSDF']
        node_to_delete2 =  rem_mat.node_tree.nodes['Material Output']
        #Remove it
        rem_mat.node_tree.nodes.remove(node_to_delete)
        rem_mat.node_tree.nodes.remove(node_to_delete2)
        #Tex = material.name
        TexMain = Tex+'_MainTex.png'
        TexDetailM = Tex+'_DetailMask.png'
        TexNormal = Tex+'_NormalMap.png'
        TexNDetail = Tex+'_NormalMapDetail.png'
        TexAlphaM = Tex+'_AlphaMask.png'
        TexAnotherR = Tex+'_AnotherRamp.png'
        TexLiquidM = Tex+'_liquidmask.png'
        TexTex2 = Tex+'_Texture2.png'
        TexTex3 = Tex+'_Texture3.png'
        TexOv1 = Tex+'_overtex1.png'
        TexOv2 = Tex+'_overtex2.png'
        TexLineM = Tex+'_LineMask.png'
        TexColorM = Tex+'_ColorMask.png'
        TexHairG = Tex+'_HairGloss.png'
        TexBump = Tex+'_BumpMap.png'
        TexDNM = Tex+'_DetailNormalMap.png'
        TexBNM = Tex+'_BlendNormalMap.png'
        TexSGM = Tex+'_SpecGlossMap.png'
        TexOM = Tex+'_OcclusionMap.png'
        TexTSS = Tex+'_Thickness.png'
        TexMGM = Tex+'_MetallicGlossMap.png'
        TexOV = Tex+'_OverTex.png'
        originaltex = 'cf_m_shoes_con_00_'
        #originaltss = 'cf_m_body_01_'
        #kkp
        nm = originaltex+'NormalMap.png'
        nd = originaltex+'NormalMapDetail.png'
        dm = originaltex+'DetailMask.png'
        mm = originaltex+'MainTex.png'
        t3 = originaltex+'Texture3.png'
        t2 = originaltex+'Texture2.png'
        am = originaltex+'AlphaMask.png'
        lm = originaltex+'liquidmask.png'
        ar = originaltex+'AnotherRamp.png'
        ov1 = originaltex+'overtex1.png'
        ov2 = originaltex+'overtex2.png'
        lnm = originaltex+'LineMask.png'
        com = originaltex+'ColorMask.png'
        glo = originaltex+'HairGloss.png'
        #hs1
        bum = originaltex+'BumpMap.png'
        dnm = originaltex+'DetailNormalMap.png'
        bnm = originaltex+'BlendNormalMap.png'
        sgm = originaltex+'SpecGlossMap.png'
        om = originaltex+'OcclusionMap.png'
        tss = originaltex+'Thickness.png'
        mgm = originaltex+'MetallicGlossMap.png'
        ov = originaltex+'OverTex.png'
        Template='HS1-Template Shoes'
        CTemplate=Template+' '
        C = bpy.context

        def instantiate_group(nodes, data_block_name):
            group = nodes.new(type='ShaderNodeGroup')
            group.node_tree = bpy.data.node_groups[Template]
            return group
        if Template in bpy.data.node_groups:
            instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
        else:
        #    versions = ( t0, t1, t2, t3, t4)
        #    for x in versions:
        #        if os.path.isdir(x) and os.access(x, os.R_OK):
            if (3, 0, 0) <= bpy.app.version < (3, 0, 99):
                before_data = list(bpy.data.node_groups)
                bpy.ops.wm.append(directory=os.path.expanduser(r"~\AppData\Roaming\Blender Foundation\Blender\3.0\scripts\addons\sklx_creator\assets\HS1_Template_Shader.blend") + r'\NodeTree',filename=Template,link=False)
                new_data=list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
                appended_2B5AC = None if not new_data else new_data[0]
                instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
            else:
                if (3, 1, 0) <= bpy.app.version < (3, 1, 99):
                    before_data = list(bpy.data.node_groups)
                    bpy.ops.wm.append(directory=os.path.expanduser(r"~\AppData\Roaming\Blender Foundation\Blender\3.1\scripts\addons\sklx_creator\assets\HS1_Template_Shader.blend") + r'\NodeTree',filename=Template,link=False)
                    new_data=list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
                    appended_2B5AC = None if not new_data else new_data[0]
                    instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
                else:
                    if (3, 2, 0) <= bpy.app.version < (3, 2, 99):
                        before_data = list(bpy.data.node_groups)
                        bpy.ops.wm.append(directory=os.path.expanduser(r"~\AppData\Roaming\Blender Foundation\Blender\3.2\scripts\addons\sklx_creator\assets\HS1_Template_Shader.blend") + r'\NodeTree',filename=Template,link=False)
                        new_data=list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
                        appended_2B5AC = None if not new_data else new_data[0]
                        instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
                    else:
                        if (3, 3, 0) <= bpy.app.version < (3, 3, 99):
                            before_data = list(bpy.data.node_groups)
                            bpy.ops.wm.append(directory=os.path.expanduser(r"~\AppData\Roaming\Blender Foundation\Blender\3.3\scripts\addons\sklx_creator\assets\HS1_Template_Shader.blend") + r'\NodeTree',filename=Template,link=False)
                            new_data=list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
                            appended_2B5AC = None if not new_data else new_data[0]
                            instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
                        else:
                            if (3, 4, 0) <= bpy.app.version < (3, 4, 99):
                                before_data = list(bpy.data.node_groups)
                                bpy.ops.wm.append(directory=os.path.expanduser(r"~\AppData\Roaming\Blender Foundation\Blender\3.4\scripts\addons\sklx_creator\assets\HS1_Template_Shader.blend") + r'\NodeTree',filename=Template,link=False)
                                new_data=list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
                                appended_2B5AC = None if not new_data else new_data[0]
                                instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
        bpy.data.node_groups[Template].name = CTemplate+Tex
        node = bpy.data.node_groups[CTemplate+Tex]
        #initial_area_type = bpy.context.area.type
        #bpy.context.area.type = 'NODE_EDITOR'
        #bpy.context.area.ui_type = 'ShaderNodeTree'
        #bpy.ops.node.group_ungroup()
        #bpy.context.area.type = initial_area_type
        nodes = my_mat.node_tree.nodes
        for node in nodes:
            #node.select = False
            print(node.name)
            node.select = True
            nodes.active = node
        try:
            initial_area_type = bpy.context.area.type
            bpy.context.area.type = 'NODE_EDITOR'
            bpy.context.area.ui_type = 'ShaderNodeTree'
            bpy.ops.wm.redraw_timer(type='DRAW_WIN', iterations=1)
            bpy.ops.node.group_ungroup()
            nonono = node," to Ungroup"
            print(nonono)
            bpy.ops.node.group_edit(exit=True)
        except Exception as e:
            print(e)
        finally:
            bpy.context.area.type = initial_area_type
        fixlocate = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\\20220603141428_Chika_Haruno\\Textures\\"
        bpimg = bpy.data.images.get
        if 1==1:
            print(mm)
            print(dm)
            print(nm)
            print(t2)
            print(t3)
        #formula_list=(nm,nd,dm,mm,t2,t3,am,lm,ar,ov1,ov2,lnm,com,glo,bum,dnm,bnm,sgm,om,tss,mgm,ov)
        #for formula in formula_list:
        #    if bpimg(formula) is not None:
        f1 = bpimg(mm)
        #for x in f1:
        if f1 is not None:
            bpy.data.images[mm].name = TexMain
            bpy.data.images[TexMain].filepath = fixlocate+TexMain
            bpy.data.images[TexMain].filepath_raw = fixlocate+TexMain
        f2 = bpimg(dm)
        #for x in f2:
        if f2 is not None:
            bpy.data.images[dm].name = TexDetailM
            bpy.data.images[TexDetailM].filepath = fixlocate+TexDetailM
            bpy.data.images[TexDetailM].filepath_raw = fixlocate+TexDetailM
        f3 = bpimg(nm)
        #for x in f3:
        if f3 is not None:
            bpy.data.images[nm].name = TexNormal
            bpy.data.images[TexNormal].filepath = fixlocate+TexNormal
            bpy.data.images[TexNormal].filepath_raw = fixlocate+TexNormal
        f4 = bpimg(t2)
        #for x in f3:
        if f4 is not None:
            bpy.data.images[t2].name = TexTex2
            bpy.data.images[TexTex2].filepath = fixlocate+TexTex2
            bpy.data.images[TexTex2].filepath_raw = fixlocate+TexTex2
        f5 = bpimg(t3)
        #for x in f4:
        if f5 is not None:
            bpy.data.images[t3].name = TexTex3
            bpy.data.images[TexTex3].filepath = fixlocate+TexTex3
            bpy.data.images[TexTex3].filepath_raw = fixlocate+TexTex3
        f6 = bpimg(am)
        #for x in f5:
        if f6 is not None:
            bpy.data.images[am].name = TexAlphaM
            bpy.data.images[TexAlphaM].filepath = fixlocate+TexAlphaM
            bpy.data.images[TexAlphaM].filepath_raw = fixlocate+TexAlphaM
        f7 = bpimg(lm)
        #for x in f6:
        if f7 is not None:
            bpy.data.images[lm].name = TexLiquidM
            bpy.data.images[TexLiquidM].filepath = fixlocate+TexLiquidM
            bpy.data.images[TexLiquidM].filepath_raw = fixlocate+TexLiquidM
        f8 = bpimg(ar)
        #for f8 in f8:
        if f8 is not None:
            bpy.data.images[ar].name = TexAnotherR
            bpy.data.images[TexAnotherR].filepath = fixlocate+TexAnotherR
            bpy.data.images[TexAnotherR].filepath_raw = fixlocate+TexAnotherR
        f9 = bpimg(nd)
        #for f8 in f8:
        if f9 is not None:
            bpy.data.images[nd].name = TexNDetail
            bpy.data.images[TexNDetail].filepath = fixlocate+TexNDetail
            bpy.data.images[TexNDetail].filepath_raw = fixlocate+TexNDetail
        f10 = bpimg(ov1)
        #for f8 in f8:
        if f10 is not None:
            bpy.data.images[ov1].name = TexOv1
            bpy.data.images[TexOv1].filepath = fixlocate+TexOv1
            bpy.data.images[TexOv1].filepath_raw = fixlocate+TexOv1
        f11 = bpimg(ov2)
        #for f8 in f8:
        if f11 is not None:
            bpy.data.images[ov2].name = TexOv2
            bpy.data.images[TexOv2].filepath = fixlocate+TexOv2
            bpy.data.images[TexOv2].filepath_raw = fixlocate+TexOv2
        f12 = bpimg(lnm)
        #for f8 in f8:
        if f12 is not None:
            bpy.data.images[lnm].name = TexLineM
            bpy.data.images[TexLineM].filepath = fixlocate+TexLineM
            bpy.data.images[TexLineM].filepath_raw = fixlocate+TexLineM
        f13 = bpimg(com)
        #for f8 in f8:
        if f13 is not None:
            bpy.data.images[com].name = TexColorM
            bpy.data.images[TexColorM].filepath = fixlocate+TexColorM
            bpy.data.images[TexColorM].filepath_raw = fixlocate+TexColorM
        f14 = bpimg(glo)
        #for f8 in f8:
        if f14 is not None:
            bpy.data.images[glo].name = TexHairG
            bpy.data.images[TexHairG].filepath = fixlocate+TexHairG
            bpy.data.images[TexHairG].filepath_raw = fixlocate+TexHairG
        f15 = bpimg(bum)
        #for f8 in f8:
        if f15 is not None:
            bpy.data.images[bum].name = TexBump
            bpy.data.images[TexBump].filepath = fixlocate+TexBump
            bpy.data.images[TexBump].filepath_raw = fixlocate+TexBump
        f16 = bpimg(dnm)
        #for f8 in f8:
        if f16 is not None:
            bpy.data.images[dnm].name = TexDNM
            bpy.data.images[TexDNM].filepath = fixlocate+TexDNM
            bpy.data.images[TexDNM].filepath_raw = fixlocate+TexDNM
        f17 = bpimg(bnm)
        #for f8 in f8:
        if f17 is not None:
            bpy.data.images[bnm].name = TexBNM
            bpy.data.images[TexBNM].filepath = fixlocate+TexBNM
            bpy.data.images[TexBNM].filepath_raw = fixlocate+TexBNM
        f18 = bpimg(sgm)
        #for f8 in f8:
        if f18 is not None:
            bpy.data.images[sgm].name = TexSGM
            bpy.data.images[TexSGM].filepath = fixlocate+TexSGM
            bpy.data.images[TexSGM].filepath_raw = fixlocate+TexSGM
        f19 = bpimg(om)
        #for f8 in f8:
        if f19 is not None:
            bpy.data.images[om].name = TexOM
            bpy.data.images[TexOM].filepath = fixlocate+TexOM
            bpy.data.images[TexOM].filepath_raw = fixlocate+TexOM
        f20 = bpimg(tss)
        #for f8 in f8:
        if f20 is not None:
            bpy.data.images[tss].name = TexTSS
            bpy.data.images[TexTSS].filepath = fixlocate+TexTSS
            bpy.data.images[TexTSS].filepath_raw = fixlocate+TexTSS
        f21 = bpimg(mgm)
        #for f8 in f8:
        if f21 is not None:
            bpy.data.images[mgm].name = TexMGM
            bpy.data.images[TexMGM].filepath = fixlocate+TexMGM
            bpy.data.images[TexMGM].filepath_raw = fixlocate+TexMGM
        f22 = bpimg(ov)
        #for f8 in f8:
        if f22 is not None:
            bpy.data.images[ov].name = TexOV
            bpy.data.images[TexOV].filepath = fixlocate+TexOV
            bpy.data.images[TexOV].filepath_raw = fixlocate+TexOV
        bpy.ops.file.find_missing_files('INVOKE_DEFAULT')
        return {"FINISHED"}

    def invoke(self, context, event):
        return self.execute(context)


class SNA_OT_Hs1Accs_81340(bpy.types.Operator):
    bl_idname = "sna.hs1accs_81340"
    bl_label = "hs1-accs"
    bl_description = ""
    bl_options = {"REGISTER", "UNDO"}

    @classmethod
    def poll(cls, context):
        return not False

    def execute(self, context):
        import os
        ########################################################################
        my_mat = bpy.context.object.material_slots[0].material
        print(my_mat.name)
        Tex=my_mat.name
        rem_mat = bpy.data.materials[Tex]
        #Get the node in its node tree (replace the name below)
        node_to_delete =  rem_mat.node_tree.nodes['Principled BSDF']
        node_to_delete2 =  rem_mat.node_tree.nodes['Material Output']
        #Remove it
        rem_mat.node_tree.nodes.remove(node_to_delete)
        rem_mat.node_tree.nodes.remove(node_to_delete2)
        #Tex = material.name
        TexMain = Tex+'_MainTex.png'
        TexDetailM = Tex+'_DetailMask.png'
        TexNormal = Tex+'_NormalMap.png'
        TexNDetail = Tex+'_NormalMapDetail.png'
        TexAlphaM = Tex+'_AlphaMask.png'
        TexAnotherR = Tex+'_AnotherRamp.png'
        TexLiquidM = Tex+'_liquidmask.png'
        TexTex2 = Tex+'_Texture2.png'
        TexTex3 = Tex+'_Texture3.png'
        TexOv1 = Tex+'_overtex1.png'
        TexOv2 = Tex+'_overtex2.png'
        TexLineM = Tex+'_LineMask.png'
        TexColorM = Tex+'_ColorMask.png'
        TexHairG = Tex+'_HairGloss.png'
        TexBump = Tex+'_BumpMap.png'
        TexDNM = Tex+'_DetailNormalMap.png'
        TexBNM = Tex+'_BlendNormalMap.png'
        TexSGM = Tex+'_SpecGlossMap.png'
        TexOM = Tex+'_OcclusionMap.png'
        TexTSS = Tex+'_Thickness.png'
        TexMGM = Tex+'_MetallicGlossMap.png'
        TexOV = Tex+'_OverTex.png'
        originaltex = 'cf_m_glove_con_00_'
        #originaltss = 'cf_m_body_01_'
        #kkp
        nm = originaltex+'NormalMap.png'
        nd = originaltex+'NormalMapDetail.png'
        dm = originaltex+'DetailMask.png'
        mm = originaltex+'MainTex.png'
        t3 = originaltex+'Texture3.png'
        t2 = originaltex+'Texture2.png'
        am = originaltex+'AlphaMask.png'
        lm = originaltex+'liquidmask.png'
        ar = originaltex+'AnotherRamp.png'
        ov1 = originaltex+'overtex1.png'
        ov2 = originaltex+'overtex2.png'
        lnm = originaltex+'LineMask.png'
        com = originaltex+'ColorMask.png'
        glo = originaltex+'HairGloss.png'
        #hs1
        bum = originaltex+'BumpMap.png'
        dnm = originaltex+'DetailNormalMap.png'
        bnm = originaltex+'BlendNormalMap.png'
        sgm = originaltex+'SpecGlossMap.png'
        om = originaltex+'OcclusionMap.png'
        tss = originaltex+'Thickness.png'
        mgm = originaltex+'MetallicGlossMap.png'
        ov = originaltex+'OverTex.png'
        Template='HS1-Template Gloves'
        CTemplate=Template+' '
        C = bpy.context

        def instantiate_group(nodes, data_block_name):
            group = nodes.new(type='ShaderNodeGroup')
            group.node_tree = bpy.data.node_groups[Template]
            return group
        if Template in bpy.data.node_groups:
            instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
        else:
        #    versions = ( t0, t1, t2, t3, t4)
        #    for x in versions:
        #        if os.path.isdir(x) and os.access(x, os.R_OK):
            if (3, 0, 0) <= bpy.app.version < (3, 0, 99):
                before_data = list(bpy.data.node_groups)
                bpy.ops.wm.append(directory=os.path.expanduser(r"~\AppData\Roaming\Blender Foundation\Blender\3.0\scripts\addons\sklx_creator\assets\HS1_Template_Shader.blend") + r'\NodeTree',filename=Template,link=False)
                new_data=list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
                appended_2B5AC = None if not new_data else new_data[0]
                instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
            else:
                if (3, 1, 0) <= bpy.app.version < (3, 1, 99):
                    before_data = list(bpy.data.node_groups)
                    bpy.ops.wm.append(directory=os.path.expanduser(r"~\AppData\Roaming\Blender Foundation\Blender\3.1\scripts\addons\sklx_creator\assets\HS1_Template_Shader.blend") + r'\NodeTree',filename=Template,link=False)
                    new_data=list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
                    appended_2B5AC = None if not new_data else new_data[0]
                    instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
                else:
                    if (3, 2, 0) <= bpy.app.version < (3, 2, 99):
                        before_data = list(bpy.data.node_groups)
                        bpy.ops.wm.append(directory=os.path.expanduser(r"~\AppData\Roaming\Blender Foundation\Blender\3.2\scripts\addons\sklx_creator\assets\HS1_Template_Shader.blend") + r'\NodeTree',filename=Template,link=False)
                        new_data=list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
                        appended_2B5AC = None if not new_data else new_data[0]
                        instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
                    else:
                        if (3, 3, 0) <= bpy.app.version < (3, 3, 99):
                            before_data = list(bpy.data.node_groups)
                            bpy.ops.wm.append(directory=os.path.expanduser(r"~\AppData\Roaming\Blender Foundation\Blender\3.3\scripts\addons\sklx_creator\assets\HS1_Template_Shader.blend") + r'\NodeTree',filename=Template,link=False)
                            new_data=list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
                            appended_2B5AC = None if not new_data else new_data[0]
                            instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
                        else:
                            if (3, 4, 0) <= bpy.app.version < (3, 4, 99):
                                before_data = list(bpy.data.node_groups)
                                bpy.ops.wm.append(directory=os.path.expanduser(r"~\AppData\Roaming\Blender Foundation\Blender\3.4\scripts\addons\sklx_creator\assets\HS1_Template_Shader.blend") + r'\NodeTree',filename=Template,link=False)
                                new_data=list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
                                appended_2B5AC = None if not new_data else new_data[0]
                                instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
        bpy.data.node_groups[Template].name = CTemplate+Tex
        node = bpy.data.node_groups[CTemplate+Tex]
        #initial_area_type = bpy.context.area.type
        #bpy.context.area.type = 'NODE_EDITOR'
        #bpy.context.area.ui_type = 'ShaderNodeTree'
        #bpy.ops.node.group_ungroup()
        #bpy.context.area.type = initial_area_type
        nodes = my_mat.node_tree.nodes
        for node in nodes:
            #node.select = False
            print(node.name)
            node.select = True
            nodes.active = node
        try:
            initial_area_type = bpy.context.area.type
            bpy.context.area.type = 'NODE_EDITOR'
            bpy.context.area.ui_type = 'ShaderNodeTree'
            bpy.ops.wm.redraw_timer(type='DRAW_WIN', iterations=1)
            bpy.ops.node.group_ungroup()
            nonono = node," to Ungroup"
            print(nonono)
            bpy.ops.node.group_edit(exit=True)
        except Exception as e:
            print(e)
        finally:
            bpy.context.area.type = initial_area_type
        fixlocate = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\\20220603141428_Chika_Haruno\\Textures\\"
        bpimg = bpy.data.images.get
        if 1==1:
            print(mm)
            print(dm)
            print(nm)
            print(t2)
            print(t3)
        #formula_list=(nm,nd,dm,mm,t2,t3,am,lm,ar,ov1,ov2,lnm,com,glo,bum,dnm,bnm,sgm,om,tss,mgm,ov)
        #for formula in formula_list:
        #    if bpimg(formula) is not None:
        f1 = bpimg(mm)
        #for x in f1:
        if f1 is not None:
            bpy.data.images[mm].name = TexMain
            bpy.data.images[TexMain].filepath = fixlocate+TexMain
            bpy.data.images[TexMain].filepath_raw = fixlocate+TexMain
        f2 = bpimg(dm)
        #for x in f2:
        if f2 is not None:
            bpy.data.images[dm].name = TexDetailM
            bpy.data.images[TexDetailM].filepath = fixlocate+TexDetailM
            bpy.data.images[TexDetailM].filepath_raw = fixlocate+TexDetailM
        f3 = bpimg(nm)
        #for x in f3:
        if f3 is not None:
            bpy.data.images[nm].name = TexNormal
            bpy.data.images[TexNormal].filepath = fixlocate+TexNormal
            bpy.data.images[TexNormal].filepath_raw = fixlocate+TexNormal
        f4 = bpimg(t2)
        #for x in f3:
        if f4 is not None:
            bpy.data.images[t2].name = TexTex2
            bpy.data.images[TexTex2].filepath = fixlocate+TexTex2
            bpy.data.images[TexTex2].filepath_raw = fixlocate+TexTex2
        f5 = bpimg(t3)
        #for x in f4:
        if f5 is not None:
            bpy.data.images[t3].name = TexTex3
            bpy.data.images[TexTex3].filepath = fixlocate+TexTex3
            bpy.data.images[TexTex3].filepath_raw = fixlocate+TexTex3
        f6 = bpimg(am)
        #for x in f5:
        if f6 is not None:
            bpy.data.images[am].name = TexAlphaM
            bpy.data.images[TexAlphaM].filepath = fixlocate+TexAlphaM
            bpy.data.images[TexAlphaM].filepath_raw = fixlocate+TexAlphaM
        f7 = bpimg(lm)
        #for x in f6:
        if f7 is not None:
            bpy.data.images[lm].name = TexLiquidM
            bpy.data.images[TexLiquidM].filepath = fixlocate+TexLiquidM
            bpy.data.images[TexLiquidM].filepath_raw = fixlocate+TexLiquidM
        f8 = bpimg(ar)
        #for f8 in f8:
        if f8 is not None:
            bpy.data.images[ar].name = TexAnotherR
            bpy.data.images[TexAnotherR].filepath = fixlocate+TexAnotherR
            bpy.data.images[TexAnotherR].filepath_raw = fixlocate+TexAnotherR
        f9 = bpimg(nd)
        #for f8 in f8:
        if f9 is not None:
            bpy.data.images[nd].name = TexNDetail
            bpy.data.images[TexNDetail].filepath = fixlocate+TexNDetail
            bpy.data.images[TexNDetail].filepath_raw = fixlocate+TexNDetail
        f10 = bpimg(ov1)
        #for f8 in f8:
        if f10 is not None:
            bpy.data.images[ov1].name = TexOv1
            bpy.data.images[TexOv1].filepath = fixlocate+TexOv1
            bpy.data.images[TexOv1].filepath_raw = fixlocate+TexOv1
        f11 = bpimg(ov2)
        #for f8 in f8:
        if f11 is not None:
            bpy.data.images[ov2].name = TexOv2
            bpy.data.images[TexOv2].filepath = fixlocate+TexOv2
            bpy.data.images[TexOv2].filepath_raw = fixlocate+TexOv2
        f12 = bpimg(lnm)
        #for f8 in f8:
        if f12 is not None:
            bpy.data.images[lnm].name = TexLineM
            bpy.data.images[TexLineM].filepath = fixlocate+TexLineM
            bpy.data.images[TexLineM].filepath_raw = fixlocate+TexLineM
        f13 = bpimg(com)
        #for f8 in f8:
        if f13 is not None:
            bpy.data.images[com].name = TexColorM
            bpy.data.images[TexColorM].filepath = fixlocate+TexColorM
            bpy.data.images[TexColorM].filepath_raw = fixlocate+TexColorM
        f14 = bpimg(glo)
        #for f8 in f8:
        if f14 is not None:
            bpy.data.images[glo].name = TexHairG
            bpy.data.images[TexHairG].filepath = fixlocate+TexHairG
            bpy.data.images[TexHairG].filepath_raw = fixlocate+TexHairG
        f15 = bpimg(bum)
        #for f8 in f8:
        if f15 is not None:
            bpy.data.images[bum].name = TexBump
            bpy.data.images[TexBump].filepath = fixlocate+TexBump
            bpy.data.images[TexBump].filepath_raw = fixlocate+TexBump
        f16 = bpimg(dnm)
        #for f8 in f8:
        if f16 is not None:
            bpy.data.images[dnm].name = TexDNM
            bpy.data.images[TexDNM].filepath = fixlocate+TexDNM
            bpy.data.images[TexDNM].filepath_raw = fixlocate+TexDNM
        f17 = bpimg(bnm)
        #for f8 in f8:
        if f17 is not None:
            bpy.data.images[bnm].name = TexBNM
            bpy.data.images[TexBNM].filepath = fixlocate+TexBNM
            bpy.data.images[TexBNM].filepath_raw = fixlocate+TexBNM
        f18 = bpimg(sgm)
        #for f8 in f8:
        if f18 is not None:
            bpy.data.images[sgm].name = TexSGM
            bpy.data.images[TexSGM].filepath = fixlocate+TexSGM
            bpy.data.images[TexSGM].filepath_raw = fixlocate+TexSGM
        f19 = bpimg(om)
        #for f8 in f8:
        if f19 is not None:
            bpy.data.images[om].name = TexOM
            bpy.data.images[TexOM].filepath = fixlocate+TexOM
            bpy.data.images[TexOM].filepath_raw = fixlocate+TexOM
        f20 = bpimg(tss)
        #for f8 in f8:
        if f20 is not None:
            bpy.data.images[tss].name = TexTSS
            bpy.data.images[TexTSS].filepath = fixlocate+TexTSS
            bpy.data.images[TexTSS].filepath_raw = fixlocate+TexTSS
        f21 = bpimg(mgm)
        #for f8 in f8:
        if f21 is not None:
            bpy.data.images[mgm].name = TexMGM
            bpy.data.images[TexMGM].filepath = fixlocate+TexMGM
            bpy.data.images[TexMGM].filepath_raw = fixlocate+TexMGM
        f22 = bpimg(ov)
        #for f8 in f8:
        if f22 is not None:
            bpy.data.images[ov].name = TexOV
            bpy.data.images[TexOV].filepath = fixlocate+TexOV
            bpy.data.images[TexOV].filepath_raw = fixlocate+TexOV
        bpy.ops.file.find_missing_files('INVOKE_DEFAULT')
        return {"FINISHED"}

    def invoke(self, context, event):
        return self.execute(context)


class SNA_OT_Hs1Simple_D9F66(bpy.types.Operator):
    bl_idname = "sna.hs1simple_d9f66"
    bl_label = "hs1-simple"
    bl_description = ""
    bl_options = {"REGISTER", "UNDO"}

    @classmethod
    def poll(cls, context):
        return not False

    def execute(self, context):
        import os
        ########################################################################
        my_mat = bpy.context.object.material_slots[0].material
        print(my_mat.name)
        Tex=my_mat.name
        rem_mat = bpy.data.materials[Tex]
        #Get the node in its node tree (replace the name below)
        node_to_delete =  rem_mat.node_tree.nodes['Principled BSDF']
        node_to_delete2 =  rem_mat.node_tree.nodes['Material Output']
        #Remove it
        rem_mat.node_tree.nodes.remove(node_to_delete)
        rem_mat.node_tree.nodes.remove(node_to_delete2)
        #Tex = material.name
        TexMain = Tex+'_MainTex.png'
        TexDetailM = Tex+'_DetailMask.png'
        TexNormal = Tex+'_NormalMap.png'
        TexNDetail = Tex+'_NormalMapDetail.png'
        TexAlphaM = Tex+'_AlphaMask.png'
        TexAnotherR = Tex+'_AnotherRamp.png'
        TexLiquidM = Tex+'_liquidmask.png'
        TexTex2 = Tex+'_Texture2.png'
        TexTex3 = Tex+'_Texture3.png'
        TexOv1 = Tex+'_overtex1.png'
        TexOv2 = Tex+'_overtex2.png'
        TexLineM = Tex+'_LineMask.png'
        TexColorM = Tex+'_ColorMask.png'
        TexHairG = Tex+'_HairGloss.png'
        TexBump = Tex+'_BumpMap.png'
        TexDNM = Tex+'_DetailNormalMap.png'
        TexBNM = Tex+'_BlendNormalMap.png'
        TexSGM = Tex+'_SpecGlossMap.png'
        TexOM = Tex+'_OcclusionMap.png'
        TexTSS = Tex+'_Thickness.png'
        TexMGM = Tex+'_MetallicGlossMap.png'
        TexOV = Tex+'_OverTex.png'
        originaltex = 'acs_m_conhut_01_'
        #originaltss = 'cf_m_body_01_'
        #kkp
        nm = originaltex+'NormalMap.png'
        nd = originaltex+'NormalMapDetail.png'
        dm = originaltex+'DetailMask.png'
        mm = originaltex+'MainTex.png'
        t3 = originaltex+'Texture3.png'
        t2 = originaltex+'Texture2.png'
        am = originaltex+'AlphaMask.png'
        lm = originaltex+'liquidmask.png'
        ar = originaltex+'AnotherRamp.png'
        ov1 = originaltex+'overtex1.png'
        ov2 = originaltex+'overtex2.png'
        lnm = originaltex+'LineMask.png'
        com = originaltex+'ColorMask.png'
        glo = originaltex+'HairGloss.png'
        #hs1
        bum = originaltex+'BumpMap.png'
        dnm = originaltex+'DetailNormalMap.png'
        bnm = originaltex+'BlendNormalMap.png'
        sgm = originaltex+'SpecGlossMap.png'
        om = originaltex+'OcclusionMap.png'
        tss = originaltex+'Thickness.png'
        mgm = originaltex+'MetallicGlossMap.png'
        ov = originaltex+'OverTex.png'
        Template='HS1-Template Hat'
        CTemplate=Template+' '
        C = bpy.context

        def instantiate_group(nodes, data_block_name):
            group = nodes.new(type='ShaderNodeGroup')
            group.node_tree = bpy.data.node_groups[Template]
            return group
        if Template in bpy.data.node_groups:
            instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
        else:
        #    versions = ( t0, t1, t2, t3, t4)
        #    for x in versions:
        #        if os.path.isdir(x) and os.access(x, os.R_OK):
            if (3, 0, 0) <= bpy.app.version < (3, 0, 99):
                before_data = list(bpy.data.node_groups)
                bpy.ops.wm.append(directory=os.path.expanduser(r"~\AppData\Roaming\Blender Foundation\Blender\3.0\scripts\addons\sklx_creator\assets\HS1_Template_Shader.blend") + r'\NodeTree',filename=Template,link=False)
                new_data=list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
                appended_2B5AC = None if not new_data else new_data[0]
                instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
            else:
                if (3, 1, 0) <= bpy.app.version < (3, 1, 99):
                    before_data = list(bpy.data.node_groups)
                    bpy.ops.wm.append(directory=os.path.expanduser(r"~\AppData\Roaming\Blender Foundation\Blender\3.1\scripts\addons\sklx_creator\assets\HS1_Template_Shader.blend") + r'\NodeTree',filename=Template,link=False)
                    new_data=list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
                    appended_2B5AC = None if not new_data else new_data[0]
                    instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
                else:
                    if (3, 2, 0) <= bpy.app.version < (3, 2, 99):
                        before_data = list(bpy.data.node_groups)
                        bpy.ops.wm.append(directory=os.path.expanduser(r"~\AppData\Roaming\Blender Foundation\Blender\3.2\scripts\addons\sklx_creator\assets\HS1_Template_Shader.blend") + r'\NodeTree',filename=Template,link=False)
                        new_data=list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
                        appended_2B5AC = None if not new_data else new_data[0]
                        instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
                    else:
                        if (3, 3, 0) <= bpy.app.version < (3, 3, 99):
                            before_data = list(bpy.data.node_groups)
                            bpy.ops.wm.append(directory=os.path.expanduser(r"~\AppData\Roaming\Blender Foundation\Blender\3.3\scripts\addons\sklx_creator\assets\HS1_Template_Shader.blend") + r'\NodeTree',filename=Template,link=False)
                            new_data=list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
                            appended_2B5AC = None if not new_data else new_data[0]
                            instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
                        else:
                            if (3, 4, 0) <= bpy.app.version < (3, 4, 99):
                                before_data = list(bpy.data.node_groups)
                                bpy.ops.wm.append(directory=os.path.expanduser(r"~\AppData\Roaming\Blender Foundation\Blender\3.4\scripts\addons\sklx_creator\assets\HS1_Template_Shader.blend") + r'\NodeTree',filename=Template,link=False)
                                new_data=list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
                                appended_2B5AC = None if not new_data else new_data[0]
                                instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
        bpy.data.node_groups[Template].name = CTemplate+Tex
        node = bpy.data.node_groups[CTemplate+Tex]
        #initial_area_type = bpy.context.area.type
        #bpy.context.area.type = 'NODE_EDITOR'
        #bpy.context.area.ui_type = 'ShaderNodeTree'
        #bpy.ops.wm.redraw_timer(type='DRAW_WIN', iterations=1)
        #bpy.ops.node.group_ungroup()
        #bpy.ops.node.group_edit(exit=True)
        #bpy.context.area.type = initial_area_type
        nodes = my_mat.node_tree.nodes
        for node in nodes:
            #node.select = False
            print(node.name)
            node.select = True
            nodes.active = node
        try:
            initial_area_type = bpy.context.area.type
            bpy.context.area.type = 'NODE_EDITOR'
            bpy.context.area.ui_type = 'ShaderNodeTree'
            bpy.ops.wm.redraw_timer(type='DRAW_WIN', iterations=1)
            bpy.ops.node.group_ungroup()
            nonono = node," to Ungroup"
            print(nonono)
            bpy.ops.node.group_edit(exit=True)
        except Exception as e:
            print(e)
        finally:
            bpy.context.area.type = initial_area_type
        fixlocate = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\\20220603141428_Chika_Haruno\\Textures\\"
        bpimg = bpy.data.images.get
        if 1==1:
            print(mm)
            print(dm)
            print(nm)
            print(t2)
            print(t3)
        #formula_list=(nm,nd,dm,mm,t2,t3,am,lm,ar,ov1,ov2,lnm,com,glo,bum,dnm,bnm,sgm,om,tss,mgm,ov)
        #for formula in formula_list:
        #    if bpimg(formula) is not None:
        f1 = bpimg(mm)
        #for x in f1:
        if f1 is not None:
            bpy.data.images[mm].name = TexMain
            bpy.data.images[TexMain].filepath = fixlocate+TexMain
            bpy.data.images[TexMain].filepath_raw = fixlocate+TexMain
        f2 = bpimg(dm)
        #for x in f2:
        if f2 is not None:
            bpy.data.images[dm].name = TexDetailM
            bpy.data.images[TexDetailM].filepath = fixlocate+TexDetailM
            bpy.data.images[TexDetailM].filepath_raw = fixlocate+TexDetailM
        f3 = bpimg(nm)
        #for x in f3:
        if f3 is not None:
            bpy.data.images[nm].name = TexNormal
            bpy.data.images[TexNormal].filepath = fixlocate+TexNormal
            bpy.data.images[TexNormal].filepath_raw = fixlocate+TexNormal
        f4 = bpimg(t2)
        #for x in f3:
        if f4 is not None:
            bpy.data.images[t2].name = TexTex2
            bpy.data.images[TexTex2].filepath = fixlocate+TexTex2
            bpy.data.images[TexTex2].filepath_raw = fixlocate+TexTex2
        f5 = bpimg(t3)
        #for x in f4:
        if f5 is not None:
            bpy.data.images[t3].name = TexTex3
            bpy.data.images[TexTex3].filepath = fixlocate+TexTex3
            bpy.data.images[TexTex3].filepath_raw = fixlocate+TexTex3
        f6 = bpimg(am)
        #for x in f5:
        if f6 is not None:
            bpy.data.images[am].name = TexAlphaM
            bpy.data.images[TexAlphaM].filepath = fixlocate+TexAlphaM
            bpy.data.images[TexAlphaM].filepath_raw = fixlocate+TexAlphaM
        f7 = bpimg(lm)
        #for x in f6:
        if f7 is not None:
            bpy.data.images[lm].name = TexLiquidM
            bpy.data.images[TexLiquidM].filepath = fixlocate+TexLiquidM
            bpy.data.images[TexLiquidM].filepath_raw = fixlocate+TexLiquidM
        f8 = bpimg(ar)
        #for f8 in f8:
        if f8 is not None:
            bpy.data.images[ar].name = TexAnotherR
            bpy.data.images[TexAnotherR].filepath = fixlocate+TexAnotherR
            bpy.data.images[TexAnotherR].filepath_raw = fixlocate+TexAnotherR
        f9 = bpimg(nd)
        #for f8 in f8:
        if f9 is not None:
            bpy.data.images[nd].name = TexNDetail
            bpy.data.images[TexNDetail].filepath = fixlocate+TexNDetail
            bpy.data.images[TexNDetail].filepath_raw = fixlocate+TexNDetail
        f10 = bpimg(ov1)
        #for f8 in f8:
        if f10 is not None:
            bpy.data.images[ov1].name = TexOv1
            bpy.data.images[TexOv1].filepath = fixlocate+TexOv1
            bpy.data.images[TexOv1].filepath_raw = fixlocate+TexOv1
        f11 = bpimg(ov2)
        #for f8 in f8:
        if f11 is not None:
            bpy.data.images[ov2].name = TexOv2
            bpy.data.images[TexOv2].filepath = fixlocate+TexOv2
            bpy.data.images[TexOv2].filepath_raw = fixlocate+TexOv2
        f12 = bpimg(lnm)
        #for f8 in f8:
        if f12 is not None:
            bpy.data.images[lnm].name = TexLineM
            bpy.data.images[TexLineM].filepath = fixlocate+TexLineM
            bpy.data.images[TexLineM].filepath_raw = fixlocate+TexLineM
        f13 = bpimg(com)
        #for f8 in f8:
        if f13 is not None:
            bpy.data.images[com].name = TexColorM
            bpy.data.images[TexColorM].filepath = fixlocate+TexColorM
            bpy.data.images[TexColorM].filepath_raw = fixlocate+TexColorM
        f14 = bpimg(glo)
        #for f8 in f8:
        if f14 is not None:
            bpy.data.images[glo].name = TexHairG
            bpy.data.images[TexHairG].filepath = fixlocate+TexHairG
            bpy.data.images[TexHairG].filepath_raw = fixlocate+TexHairG
        f15 = bpimg(bum)
        #for f8 in f8:
        if f15 is not None:
            bpy.data.images[bum].name = TexBump
            bpy.data.images[TexBump].filepath = fixlocate+TexBump
            bpy.data.images[TexBump].filepath_raw = fixlocate+TexBump
        f16 = bpimg(dnm)
        #for f8 in f8:
        if f16 is not None:
            bpy.data.images[dnm].name = TexDNM
            bpy.data.images[TexDNM].filepath = fixlocate+TexDNM
            bpy.data.images[TexDNM].filepath_raw = fixlocate+TexDNM
        f17 = bpimg(bnm)
        #for f8 in f8:
        if f17 is not None:
            bpy.data.images[bnm].name = TexBNM
            bpy.data.images[TexBNM].filepath = fixlocate+TexBNM
            bpy.data.images[TexBNM].filepath_raw = fixlocate+TexBNM
        f18 = bpimg(sgm)
        #for f8 in f8:
        if f18 is not None:
            bpy.data.images[sgm].name = TexSGM
            bpy.data.images[TexSGM].filepath = fixlocate+TexSGM
            bpy.data.images[TexSGM].filepath_raw = fixlocate+TexSGM
        f19 = bpimg(om)
        #for f8 in f8:
        if f19 is not None:
            bpy.data.images[om].name = TexOM
            bpy.data.images[TexOM].filepath = fixlocate+TexOM
            bpy.data.images[TexOM].filepath_raw = fixlocate+TexOM
        f20 = bpimg(tss)
        #for f8 in f8:
        if f20 is not None:
            bpy.data.images[tss].name = TexTSS
            bpy.data.images[TexTSS].filepath = fixlocate+TexTSS
            bpy.data.images[TexTSS].filepath_raw = fixlocate+TexTSS
        f21 = bpimg(mgm)
        #for f8 in f8:
        if f21 is not None:
            bpy.data.images[mgm].name = TexMGM
            bpy.data.images[TexMGM].filepath = fixlocate+TexMGM
            bpy.data.images[TexMGM].filepath_raw = fixlocate+TexMGM
        f22 = bpimg(ov)
        #for f8 in f8:
        if f22 is not None:
            bpy.data.images[ov].name = TexOV
            bpy.data.images[TexOV].filepath = fixlocate+TexOV
            bpy.data.images[TexOV].filepath_raw = fixlocate+TexOV
        bpy.ops.file.find_missing_files('INVOKE_DEFAULT')
        return {"FINISHED"}

    def invoke(self, context, event):
        return self.execute(context)


class SNA_OT_Hs1Hair_9D604(bpy.types.Operator):
    bl_idname = "sna.hs1hair_9d604"
    bl_label = "hs1-hair"
    bl_description = ""
    bl_options = {"REGISTER", "UNDO"}

    @classmethod
    def poll(cls, context):
        return not False

    def execute(self, context):
        import os
        ########################################################################
        my_mat = bpy.context.object.material_slots[0].material
        print(my_mat.name)
        Tex=my_mat.name
        rem_mat = bpy.data.materials[Tex]
        #Get the node in its node tree (replace the name below)
        node_to_delete =  rem_mat.node_tree.nodes['Principled BSDF']
        node_to_delete2 =  rem_mat.node_tree.nodes['Material Output']
        #Remove it
        rem_mat.node_tree.nodes.remove(node_to_delete)
        rem_mat.node_tree.nodes.remove(node_to_delete2)
        #Tex = material.name
        TexMain = Tex+'_MainTex.png'
        TexDetailM = Tex+'_DetailMask.png'
        TexNormal = Tex+'_NormalMap.png'
        TexNDetail = Tex+'_NormalMapDetail.png'
        TexAlphaM = Tex+'_AlphaMask.png'
        TexAnotherR = Tex+'_AnotherRamp.png'
        TexLiquidM = Tex+'_liquidmask.png'
        TexTex2 = Tex+'_Texture2.png'
        TexTex3 = Tex+'_Texture3.png'
        TexOv1 = Tex+'_overtex1.png'
        TexOv2 = Tex+'_overtex2.png'
        TexLineM = Tex+'_LineMask.png'
        TexColorM = Tex+'_ColorMask.png'
        TexHairG = Tex+'_HairGloss.png'
        TexBump = Tex+'_BumpMap.png'
        TexDNM = Tex+'_DetailNormalMap.png'
        TexBNM = Tex+'_BlendNormalMap.png'
        TexSGM = Tex+'_SpecGlossMap.png'
        TexOM = Tex+'_OcclusionMap.png'
        TexTSS = Tex+'_Thickness.png'
        TexMGM = Tex+'_MetallicGlossMap.png'
        TexOV = Tex+'_OverTex.png'
        originaltex = 'cf_M_hairbackk_88_00_'
        #originaltss = 'cf_m_body_01_'
        #kkp
        nm = originaltex+'NormalMap.png'
        nd = originaltex+'NormalMapDetail.png'
        dm = originaltex+'DetailMask.png'
        mm = originaltex+'MainTex.png'
        t3 = originaltex+'Texture3.png'
        t2 = originaltex+'Texture2.png'
        am = originaltex+'AlphaMask.png'
        lm = originaltex+'liquidmask.png'
        ar = originaltex+'AnotherRamp.png'
        ov1 = originaltex+'overtex1.png'
        ov2 = originaltex+'overtex2.png'
        lnm = originaltex+'LineMask.png'
        com = originaltex+'ColorMask.png'
        glo = originaltex+'HairGloss.png'
        #hs1
        bum = originaltex+'BumpMap.png'
        dnm = originaltex+'DetailNormalMap.png'
        bnm = originaltex+'BlendNormalMap.png'
        sgm = originaltex+'SpecGlossMap.png'
        om = originaltex+'OcclusionMap.png'
        tss = originaltex+'Thickness.png'
        mgm = originaltex+'MetallicGlossMap.png'
        ov = originaltex+'OverTex.png'
        Template='HS1-Template Back Hair'
        CTemplate=Template+' '
        C = bpy.context

        def instantiate_group(nodes, data_block_name):
            group = nodes.new(type='ShaderNodeGroup')
            group.node_tree = bpy.data.node_groups[Template]
            return group
        if Template in bpy.data.node_groups:
            instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
        else:
        #    versions = ( t0, t1, t2, t3, t4)
        #    for x in versions:
        #        if os.path.isdir(x) and os.access(x, os.R_OK):
            if (3, 0, 0) <= bpy.app.version < (3, 0, 99):
                before_data = list(bpy.data.node_groups)
                bpy.ops.wm.append(directory=os.path.expanduser(r"~\AppData\Roaming\Blender Foundation\Blender\3.0\scripts\addons\sklx_creator\assets\HS1_Template_Shader.blend") + r'\NodeTree',filename=Template,link=False)
                new_data=list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
                appended_2B5AC = None if not new_data else new_data[0]
                instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
            else:
                if (3, 1, 0) <= bpy.app.version < (3, 1, 99):
                    before_data = list(bpy.data.node_groups)
                    bpy.ops.wm.append(directory=os.path.expanduser(r"~\AppData\Roaming\Blender Foundation\Blender\3.1\scripts\addons\sklx_creator\assets\HS1_Template_Shader.blend") + r'\NodeTree',filename=Template,link=False)
                    new_data=list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
                    appended_2B5AC = None if not new_data else new_data[0]
                    instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
                else:
                    if (3, 2, 0) <= bpy.app.version < (3, 2, 99):
                        before_data = list(bpy.data.node_groups)
                        bpy.ops.wm.append(directory=os.path.expanduser(r"~\AppData\Roaming\Blender Foundation\Blender\3.2\scripts\addons\sklx_creator\assets\HS1_Template_Shader.blend") + r'\NodeTree',filename=Template,link=False)
                        new_data=list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
                        appended_2B5AC = None if not new_data else new_data[0]
                        instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
                    else:
                        if (3, 3, 0) <= bpy.app.version < (3, 3, 99):
                            before_data = list(bpy.data.node_groups)
                            bpy.ops.wm.append(directory=os.path.expanduser(r"~\AppData\Roaming\Blender Foundation\Blender\3.3\scripts\addons\sklx_creator\assets\HS1_Template_Shader.blend") + r'\NodeTree',filename=Template,link=False)
                            new_data=list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
                            appended_2B5AC = None if not new_data else new_data[0]
                            instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
                        else:
                            if (3, 4, 0) <= bpy.app.version < (3, 4, 99):
                                before_data = list(bpy.data.node_groups)
                                bpy.ops.wm.append(directory=os.path.expanduser(r"~\AppData\Roaming\Blender Foundation\Blender\3.4\scripts\addons\sklx_creator\assets\HS1_Template_Shader.blend") + r'\NodeTree',filename=Template,link=False)
                                new_data=list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
                                appended_2B5AC = None if not new_data else new_data[0]
                                instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
        bpy.context.object.active_material.blend_method = 'HASHED'
        bpy.context.object.active_material.shadow_method = 'HASHED'
        bpy.data.node_groups[Template].name = CTemplate+Tex
        node = bpy.data.node_groups[CTemplate+Tex]
        #initial_area_type = bpy.context.area.type
        #bpy.context.area.type = 'NODE_EDITOR'
        #bpy.context.area.ui_type = 'ShaderNodeTree'
        #bpy.ops.node.group_ungroup()
        #bpy.context.area.type = initial_area_type
        nodes = my_mat.node_tree.nodes
        for node in nodes:
            #node.select = False
            print(node.name)
            node.select = True
            nodes.active = node
        try:
            initial_area_type = bpy.context.area.type
            bpy.context.area.type = 'NODE_EDITOR'
            bpy.context.area.ui_type = 'ShaderNodeTree'
            bpy.ops.wm.redraw_timer(type='DRAW_WIN', iterations=1)
            bpy.ops.node.group_ungroup()
            nonono = node," to Ungroup"
            print(nonono)
            bpy.ops.node.group_edit(exit=True)
        except Exception as e:
            print(e)
        finally:
            bpy.context.area.type = initial_area_type
        fixlocate = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\\20220603141428_Chika_Haruno\\Textures\\"
        bpimg = bpy.data.images.get
        if 1==1:
            print(mm)
            print(dm)
            print(nm)
            print(t2)
            print(t3)
        #formula_list=(nm,nd,dm,mm,t2,t3,am,lm,ar,ov1,ov2,lnm,com,glo,bum,dnm,bnm,sgm,om,tss,mgm,ov)
        #for formula in formula_list:
        #    if bpimg(formula) is not None:
        f1 = bpimg(mm)
        #for x in f1:
        if f1 is not None:
            bpy.data.images[mm].name = TexMain
            bpy.data.images[TexMain].filepath = fixlocate+TexMain
            bpy.data.images[TexMain].filepath_raw = fixlocate+TexMain
        f2 = bpimg(dm)
        #for x in f2:
        if f2 is not None:
            bpy.data.images[dm].name = TexDetailM
            bpy.data.images[TexDetailM].filepath = fixlocate+TexDetailM
            bpy.data.images[TexDetailM].filepath_raw = fixlocate+TexDetailM
        f3 = bpimg(nm)
        #for x in f3:
        if f3 is not None:
            bpy.data.images[nm].name = TexNormal
            bpy.data.images[TexNormal].filepath = fixlocate+TexNormal
            bpy.data.images[TexNormal].filepath_raw = fixlocate+TexNormal
        f4 = bpimg(t2)
        #for x in f3:
        if f4 is not None:
            bpy.data.images[t2].name = TexTex2
            bpy.data.images[TexTex2].filepath = fixlocate+TexTex2
            bpy.data.images[TexTex2].filepath_raw = fixlocate+TexTex2
        f5 = bpimg(t3)
        #for x in f4:
        if f5 is not None:
            bpy.data.images[t3].name = TexTex3
            bpy.data.images[TexTex3].filepath = fixlocate+TexTex3
            bpy.data.images[TexTex3].filepath_raw = fixlocate+TexTex3
        f6 = bpimg(am)
        #for x in f5:
        if f6 is not None:
            bpy.data.images[am].name = TexAlphaM
            bpy.data.images[TexAlphaM].filepath = fixlocate+TexAlphaM
            bpy.data.images[TexAlphaM].filepath_raw = fixlocate+TexAlphaM
        f7 = bpimg(lm)
        #for x in f6:
        if f7 is not None:
            bpy.data.images[lm].name = TexLiquidM
            bpy.data.images[TexLiquidM].filepath = fixlocate+TexLiquidM
            bpy.data.images[TexLiquidM].filepath_raw = fixlocate+TexLiquidM
        f8 = bpimg(ar)
        #for f8 in f8:
        if f8 is not None:
            bpy.data.images[ar].name = TexAnotherR
            bpy.data.images[TexAnotherR].filepath = fixlocate+TexAnotherR
            bpy.data.images[TexAnotherR].filepath_raw = fixlocate+TexAnotherR
        f9 = bpimg(nd)
        #for f8 in f8:
        if f9 is not None:
            bpy.data.images[nd].name = TexNDetail
            bpy.data.images[TexNDetail].filepath = fixlocate+TexNDetail
            bpy.data.images[TexNDetail].filepath_raw = fixlocate+TexNDetail
        f10 = bpimg(ov1)
        #for f8 in f8:
        if f10 is not None:
            bpy.data.images[ov1].name = TexOv1
            bpy.data.images[TexOv1].filepath = fixlocate+TexOv1
            bpy.data.images[TexOv1].filepath_raw = fixlocate+TexOv1
        f11 = bpimg(ov2)
        #for f8 in f8:
        if f11 is not None:
            bpy.data.images[ov2].name = TexOv2
            bpy.data.images[TexOv2].filepath = fixlocate+TexOv2
            bpy.data.images[TexOv2].filepath_raw = fixlocate+TexOv2
        f12 = bpimg(lnm)
        #for f8 in f8:
        if f12 is not None:
            bpy.data.images[lnm].name = TexLineM
            bpy.data.images[TexLineM].filepath = fixlocate+TexLineM
            bpy.data.images[TexLineM].filepath_raw = fixlocate+TexLineM
        f13 = bpimg(com)
        #for f8 in f8:
        if f13 is not None:
            bpy.data.images[com].name = TexColorM
            bpy.data.images[TexColorM].filepath = fixlocate+TexColorM
            bpy.data.images[TexColorM].filepath_raw = fixlocate+TexColorM
        f14 = bpimg(glo)
        #for f8 in f8:
        if f14 is not None:
            bpy.data.images[glo].name = TexHairG
            bpy.data.images[TexHairG].filepath = fixlocate+TexHairG
            bpy.data.images[TexHairG].filepath_raw = fixlocate+TexHairG
        f15 = bpimg(bum)
        #for f8 in f8:
        if f15 is not None:
            bpy.data.images[bum].name = TexBump
            bpy.data.images[TexBump].filepath = fixlocate+TexBump
            bpy.data.images[TexBump].filepath_raw = fixlocate+TexBump
        f16 = bpimg(dnm)
        #for f8 in f8:
        if f16 is not None:
            bpy.data.images[dnm].name = TexDNM
            bpy.data.images[TexDNM].filepath = fixlocate+TexDNM
            bpy.data.images[TexDNM].filepath_raw = fixlocate+TexDNM
        f17 = bpimg(bnm)
        #for f8 in f8:
        if f17 is not None:
            bpy.data.images[bnm].name = TexBNM
            bpy.data.images[TexBNM].filepath = fixlocate+TexBNM
            bpy.data.images[TexBNM].filepath_raw = fixlocate+TexBNM
        f18 = bpimg(sgm)
        #for f8 in f8:
        if f18 is not None:
            bpy.data.images[sgm].name = TexSGM
            bpy.data.images[TexSGM].filepath = fixlocate+TexSGM
            bpy.data.images[TexSGM].filepath_raw = fixlocate+TexSGM
        f19 = bpimg(om)
        #for f8 in f8:
        if f19 is not None:
            bpy.data.images[om].name = TexOM
            bpy.data.images[TexOM].filepath = fixlocate+TexOM
            bpy.data.images[TexOM].filepath_raw = fixlocate+TexOM
        f20 = bpimg(tss)
        #for f8 in f8:
        if f20 is not None:
            bpy.data.images[tss].name = TexTSS
            bpy.data.images[TexTSS].filepath = fixlocate+TexTSS
            bpy.data.images[TexTSS].filepath_raw = fixlocate+TexTSS
        f21 = bpimg(mgm)
        #for f8 in f8:
        if f21 is not None:
            bpy.data.images[mgm].name = TexMGM
            bpy.data.images[TexMGM].filepath = fixlocate+TexMGM
            bpy.data.images[TexMGM].filepath_raw = fixlocate+TexMGM
        f22 = bpimg(ov)
        #for f8 in f8:
        if f22 is not None:
            bpy.data.images[ov].name = TexOV
            bpy.data.images[TexOV].filepath = fixlocate+TexOV
            bpy.data.images[TexOV].filepath_raw = fixlocate+TexOV
        bpy.ops.file.find_missing_files('INVOKE_DEFAULT')
        return {"FINISHED"}

    def invoke(self, context, event):
        return self.execute(context)


class SNA_OT_Hs1Bra_Dafef(bpy.types.Operator):
    bl_idname = "sna.hs1bra_dafef"
    bl_label = "hs1-bra"
    bl_description = ""
    bl_options = {"REGISTER", "UNDO"}

    @classmethod
    def poll(cls, context):
        return not False

    def execute(self, context):
        import os
        ########################################################################
        my_mat = bpy.context.object.material_slots[0].material
        print(my_mat.name)
        Tex=my_mat.name
        rem_mat = bpy.data.materials[Tex]
        #Get the node in its node tree (replace the name below)
        node_to_delete =  rem_mat.node_tree.nodes['Principled BSDF']
        node_to_delete2 =  rem_mat.node_tree.nodes['Material Output']
        #Remove it
        rem_mat.node_tree.nodes.remove(node_to_delete)
        rem_mat.node_tree.nodes.remove(node_to_delete2)
        #Tex = material.name
        TexMain = Tex+'_MainTex.png'
        TexDetailM = Tex+'_DetailMask.png'
        TexNormal = Tex+'_NormalMap.png'
        TexNDetail = Tex+'_NormalMapDetail.png'
        TexAlphaM = Tex+'_AlphaMask.png'
        TexAnotherR = Tex+'_AnotherRamp.png'
        TexLiquidM = Tex+'_liquidmask.png'
        TexTex2 = Tex+'_Texture2.png'
        TexTex3 = Tex+'_Texture3.png'
        TexOv1 = Tex+'_overtex1.png'
        TexOv2 = Tex+'_overtex2.png'
        TexLineM = Tex+'_LineMask.png'
        TexColorM = Tex+'_ColorMask.png'
        TexHairG = Tex+'_HairGloss.png'
        TexBump = Tex+'_BumpMap.png'
        TexDNM = Tex+'_DetailNormalMap.png'
        TexBNM = Tex+'_BlendNormalMap.png'
        TexSGM = Tex+'_SpecGlossMap.png'
        TexOM = Tex+'_OcclusionMap.png'
        TexTSS = Tex+'_Thickness.png'
        TexMGM = Tex+'_MetallicGlossMap.png'
        TexOV = Tex+'_OverTex.png'
        originaltex = 'cf_M_bra_fan01_'
        #originaltss = 'cf_m_body_01_'
        #kkp
        nm = originaltex+'NormalMap.png'
        nd = originaltex+'NormalMapDetail.png'
        dm = originaltex+'DetailMask.png'
        mm = originaltex+'MainTex.png'
        t3 = originaltex+'Texture3.png'
        t2 = originaltex+'Texture2.png'
        am = originaltex+'AlphaMask.png'
        lm = originaltex+'liquidmask.png'
        ar = originaltex+'AnotherRamp.png'
        ov1 = originaltex+'overtex1.png'
        ov2 = originaltex+'overtex2.png'
        lnm = originaltex+'LineMask.png'
        com = originaltex+'ColorMask.png'
        glo = originaltex+'HairGloss.png'
        #hs1
        bum = originaltex+'BumpMap.png'
        dnm = originaltex+'DetailNormalMap.png'
        bnm = originaltex+'BlendNormalMap.png'
        sgm = originaltex+'SpecGlossMap.png'
        om = originaltex+'OcclusionMap.png'
        tss = originaltex+'Thickness.png'
        mgm = originaltex+'MetallicGlossMap.png'
        ov = originaltex+'OverTex.png'
        Template='HS1-Template Bra'
        CTemplate=Template+' '
        C = bpy.context

        def instantiate_group(nodes, data_block_name):
            group = nodes.new(type='ShaderNodeGroup')
            group.node_tree = bpy.data.node_groups[Template]
            return group
        if Template in bpy.data.node_groups:
            instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
        else:
        #    versions = ( t0, t1, t2, t3, t4)
        #    for x in versions:
        #        if os.path.isdir(x) and os.access(x, os.R_OK):
            if (3, 0, 0) <= bpy.app.version < (3, 0, 99):
                before_data = list(bpy.data.node_groups)
                bpy.ops.wm.append(directory=os.path.expanduser(r"~\AppData\Roaming\Blender Foundation\Blender\3.0\scripts\addons\sklx_creator\assets\HS1_Template_Shader.blend") + r'\NodeTree',filename=Template,link=False)
                new_data=list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
                appended_2B5AC = None if not new_data else new_data[0]
                instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
            else:
                if (3, 1, 0) <= bpy.app.version < (3, 1, 99):
                    before_data = list(bpy.data.node_groups)
                    bpy.ops.wm.append(directory=os.path.expanduser(r"~\AppData\Roaming\Blender Foundation\Blender\3.1\scripts\addons\sklx_creator\assets\HS1_Template_Shader.blend") + r'\NodeTree',filename=Template,link=False)
                    new_data=list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
                    appended_2B5AC = None if not new_data else new_data[0]
                    instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
                else:
                    if (3, 2, 0) <= bpy.app.version < (3, 2, 99):
                        before_data = list(bpy.data.node_groups)
                        bpy.ops.wm.append(directory=os.path.expanduser(r"~\AppData\Roaming\Blender Foundation\Blender\3.2\scripts\addons\sklx_creator\assets\HS1_Template_Shader.blend") + r'\NodeTree',filename=Template,link=False)
                        new_data=list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
                        appended_2B5AC = None if not new_data else new_data[0]
                        instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
                    else:
                        if (3, 3, 0) <= bpy.app.version < (3, 3, 99):
                            before_data = list(bpy.data.node_groups)
                            bpy.ops.wm.append(directory=os.path.expanduser(r"~\AppData\Roaming\Blender Foundation\Blender\3.3\scripts\addons\sklx_creator\assets\HS1_Template_Shader.blend") + r'\NodeTree',filename=Template,link=False)
                            new_data=list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
                            appended_2B5AC = None if not new_data else new_data[0]
                            instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
                        else:
                            if (3, 4, 0) <= bpy.app.version < (3, 4, 99):
                                before_data = list(bpy.data.node_groups)
                                bpy.ops.wm.append(directory=os.path.expanduser(r"~\AppData\Roaming\Blender Foundation\Blender\3.4\scripts\addons\sklx_creator\assets\HS1_Template_Shader.blend") + r'\NodeTree',filename=Template,link=False)
                                new_data=list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
                                appended_2B5AC = None if not new_data else new_data[0]
                                instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
        bpy.data.node_groups[Template].name = CTemplate+Tex
        node = bpy.data.node_groups[CTemplate+Tex]
        #initial_area_type = bpy.context.area.type
        #bpy.context.area.type = 'NODE_EDITOR'
        #bpy.context.area.ui_type = 'ShaderNodeTree'
        #bpy.ops.node.group_ungroup()
        #bpy.context.area.type = initial_area_type
        nodes = my_mat.node_tree.nodes
        for node in nodes:
            #node.select = False
            print(node.name)
            node.select = True
            nodes.active = node
        try:
            initial_area_type = bpy.context.area.type
            bpy.context.area.type = 'NODE_EDITOR'
            bpy.context.area.ui_type = 'ShaderNodeTree'
            bpy.ops.wm.redraw_timer(type='DRAW_WIN', iterations=1)
            bpy.ops.node.group_ungroup()
            nonono = node," to Ungroup"
            print(nonono)
            bpy.ops.node.group_edit(exit=True)
        except Exception as e:
            print(e)
        finally:
            bpy.context.area.type = initial_area_type
        fixlocate = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\\20220603141428_Chika_Haruno\\Textures\\"
        bpimg = bpy.data.images.get
        if 1==1:
            print(mm)
            print(dm)
            print(nm)
            print(t2)
            print(t3)
        #formula_list=(nm,nd,dm,mm,t2,t3,am,lm,ar,ov1,ov2,lnm,com,glo,bum,dnm,bnm,sgm,om,tss,mgm,ov)
        #for formula in formula_list:
        #    if bpimg(formula) is not None:
        f1 = bpimg(mm)
        #for x in f1:
        if f1 is not None:
            bpy.data.images[mm].name = TexMain
            bpy.data.images[TexMain].filepath = fixlocate+TexMain
            bpy.data.images[TexMain].filepath_raw = fixlocate+TexMain
        f2 = bpimg(dm)
        #for x in f2:
        if f2 is not None:
            bpy.data.images[dm].name = TexDetailM
            bpy.data.images[TexDetailM].filepath = fixlocate+TexDetailM
            bpy.data.images[TexDetailM].filepath_raw = fixlocate+TexDetailM
        f3 = bpimg(nm)
        #for x in f3:
        if f3 is not None:
            bpy.data.images[nm].name = TexNormal
            bpy.data.images[TexNormal].filepath = fixlocate+TexNormal
            bpy.data.images[TexNormal].filepath_raw = fixlocate+TexNormal
        f4 = bpimg(t2)
        #for x in f3:
        if f4 is not None:
            bpy.data.images[t2].name = TexTex2
            bpy.data.images[TexTex2].filepath = fixlocate+TexTex2
            bpy.data.images[TexTex2].filepath_raw = fixlocate+TexTex2
        f5 = bpimg(t3)
        #for x in f4:
        if f5 is not None:
            bpy.data.images[t3].name = TexTex3
            bpy.data.images[TexTex3].filepath = fixlocate+TexTex3
            bpy.data.images[TexTex3].filepath_raw = fixlocate+TexTex3
        f6 = bpimg(am)
        #for x in f5:
        if f6 is not None:
            bpy.data.images[am].name = TexAlphaM
            bpy.data.images[TexAlphaM].filepath = fixlocate+TexAlphaM
            bpy.data.images[TexAlphaM].filepath_raw = fixlocate+TexAlphaM
        f7 = bpimg(lm)
        #for x in f6:
        if f7 is not None:
            bpy.data.images[lm].name = TexLiquidM
            bpy.data.images[TexLiquidM].filepath = fixlocate+TexLiquidM
            bpy.data.images[TexLiquidM].filepath_raw = fixlocate+TexLiquidM
        f8 = bpimg(ar)
        #for f8 in f8:
        if f8 is not None:
            bpy.data.images[ar].name = TexAnotherR
            bpy.data.images[TexAnotherR].filepath = fixlocate+TexAnotherR
            bpy.data.images[TexAnotherR].filepath_raw = fixlocate+TexAnotherR
        f9 = bpimg(nd)
        #for f8 in f8:
        if f9 is not None:
            bpy.data.images[nd].name = TexNDetail
            bpy.data.images[TexNDetail].filepath = fixlocate+TexNDetail
            bpy.data.images[TexNDetail].filepath_raw = fixlocate+TexNDetail
        f10 = bpimg(ov1)
        #for f8 in f8:
        if f10 is not None:
            bpy.data.images[ov1].name = TexOv1
            bpy.data.images[TexOv1].filepath = fixlocate+TexOv1
            bpy.data.images[TexOv1].filepath_raw = fixlocate+TexOv1
        f11 = bpimg(ov2)
        #for f8 in f8:
        if f11 is not None:
            bpy.data.images[ov2].name = TexOv2
            bpy.data.images[TexOv2].filepath = fixlocate+TexOv2
            bpy.data.images[TexOv2].filepath_raw = fixlocate+TexOv2
        f12 = bpimg(lnm)
        #for f8 in f8:
        if f12 is not None:
            bpy.data.images[lnm].name = TexLineM
            bpy.data.images[TexLineM].filepath = fixlocate+TexLineM
            bpy.data.images[TexLineM].filepath_raw = fixlocate+TexLineM
        f13 = bpimg(com)
        #for f8 in f8:
        if f13 is not None:
            bpy.data.images[com].name = TexColorM
            bpy.data.images[TexColorM].filepath = fixlocate+TexColorM
            bpy.data.images[TexColorM].filepath_raw = fixlocate+TexColorM
        f14 = bpimg(glo)
        #for f8 in f8:
        if f14 is not None:
            bpy.data.images[glo].name = TexHairG
            bpy.data.images[TexHairG].filepath = fixlocate+TexHairG
            bpy.data.images[TexHairG].filepath_raw = fixlocate+TexHairG
        f15 = bpimg(bum)
        #for f8 in f8:
        if f15 is not None:
            bpy.data.images[bum].name = TexBump
            bpy.data.images[TexBump].filepath = fixlocate+TexBump
            bpy.data.images[TexBump].filepath_raw = fixlocate+TexBump
        f16 = bpimg(dnm)
        #for f8 in f8:
        if f16 is not None:
            bpy.data.images[dnm].name = TexDNM
            bpy.data.images[TexDNM].filepath = fixlocate+TexDNM
            bpy.data.images[TexDNM].filepath_raw = fixlocate+TexDNM
        f17 = bpimg(bnm)
        #for f8 in f8:
        if f17 is not None:
            bpy.data.images[bnm].name = TexBNM
            bpy.data.images[TexBNM].filepath = fixlocate+TexBNM
            bpy.data.images[TexBNM].filepath_raw = fixlocate+TexBNM
        f18 = bpimg(sgm)
        #for f8 in f8:
        if f18 is not None:
            bpy.data.images[sgm].name = TexSGM
            bpy.data.images[TexSGM].filepath = fixlocate+TexSGM
            bpy.data.images[TexSGM].filepath_raw = fixlocate+TexSGM
        f19 = bpimg(om)
        #for f8 in f8:
        if f19 is not None:
            bpy.data.images[om].name = TexOM
            bpy.data.images[TexOM].filepath = fixlocate+TexOM
            bpy.data.images[TexOM].filepath_raw = fixlocate+TexOM
        f20 = bpimg(tss)
        #for f8 in f8:
        if f20 is not None:
            bpy.data.images[tss].name = TexTSS
            bpy.data.images[TexTSS].filepath = fixlocate+TexTSS
            bpy.data.images[TexTSS].filepath_raw = fixlocate+TexTSS
        f21 = bpimg(mgm)
        #for f8 in f8:
        if f21 is not None:
            bpy.data.images[mgm].name = TexMGM
            bpy.data.images[TexMGM].filepath = fixlocate+TexMGM
            bpy.data.images[TexMGM].filepath_raw = fixlocate+TexMGM
        f22 = bpimg(ov)
        #for f8 in f8:
        if f22 is not None:
            bpy.data.images[ov].name = TexOV
            bpy.data.images[TexOV].filepath = fixlocate+TexOV
            bpy.data.images[TexOV].filepath_raw = fixlocate+TexOV
        bpy.ops.file.find_missing_files('INVOKE_DEFAULT')
        return {"FINISHED"}

    def invoke(self, context, event):
        return self.execute(context)


class SNA_OT_Hs1Panties_F51B5(bpy.types.Operator):
    bl_idname = "sna.hs1panties_f51b5"
    bl_label = "hs1-panties"
    bl_description = ""
    bl_options = {"REGISTER", "UNDO"}

    @classmethod
    def poll(cls, context):
        return not False

    def execute(self, context):
        import os
        ########################################################################
        my_mat = bpy.context.object.material_slots[0].material
        print(my_mat.name)
        Tex=my_mat.name
        rem_mat = bpy.data.materials[Tex]
        #Get the node in its node tree (replace the name below)
        node_to_delete =  rem_mat.node_tree.nodes['Principled BSDF']
        node_to_delete2 =  rem_mat.node_tree.nodes['Material Output']
        #Remove it
        rem_mat.node_tree.nodes.remove(node_to_delete)
        rem_mat.node_tree.nodes.remove(node_to_delete2)
        #Tex = material.name
        TexMain = Tex+'_MainTex.png'
        TexDetailM = Tex+'_DetailMask.png'
        TexNormal = Tex+'_NormalMap.png'
        TexNDetail = Tex+'_NormalMapDetail.png'
        TexAlphaM = Tex+'_AlphaMask.png'
        TexAnotherR = Tex+'_AnotherRamp.png'
        TexLiquidM = Tex+'_liquidmask.png'
        TexTex2 = Tex+'_Texture2.png'
        TexTex3 = Tex+'_Texture3.png'
        TexOv1 = Tex+'_overtex1.png'
        TexOv2 = Tex+'_overtex2.png'
        TexLineM = Tex+'_LineMask.png'
        TexColorM = Tex+'_ColorMask.png'
        TexHairG = Tex+'_HairGloss.png'
        TexBump = Tex+'_BumpMap.png'
        TexDNM = Tex+'_DetailNormalMap.png'
        TexBNM = Tex+'_BlendNormalMap.png'
        TexSGM = Tex+'_SpecGlossMap.png'
        TexOM = Tex+'_OcclusionMap.png'
        TexTSS = Tex+'_Thickness.png'
        TexMGM = Tex+'_MetallicGlossMap.png'
        TexOV = Tex+'_OverTex.png'
        originaltex = 'cf_M_shorts_08_00_'
        #originaltss = 'cf_m_body_01_'
        #kkp
        nm = originaltex+'NormalMap.png'
        nd = originaltex+'NormalMapDetail.png'
        dm = originaltex+'DetailMask.png'
        mm = originaltex+'MainTex.png'
        t3 = originaltex+'Texture3.png'
        t2 = originaltex+'Texture2.png'
        am = originaltex+'AlphaMask.png'
        lm = originaltex+'liquidmask.png'
        ar = originaltex+'AnotherRamp.png'
        ov1 = originaltex+'overtex1.png'
        ov2 = originaltex+'overtex2.png'
        lnm = originaltex+'LineMask.png'
        com = originaltex+'ColorMask.png'
        glo = originaltex+'HairGloss.png'
        #hs1
        bum = originaltex+'BumpMap.png'
        dnm = originaltex+'DetailNormalMap.png'
        bnm = originaltex+'BlendNormalMap.png'
        sgm = originaltex+'SpecGlossMap.png'
        om = originaltex+'OcclusionMap.png'
        tss = originaltex+'Thickness.png'
        mgm = originaltex+'MetallicGlossMap.png'
        ov = originaltex+'OverTex.png'
        Template='HS1-Template Short'
        CTemplate=Template+' '
        C = bpy.context

        def instantiate_group(nodes, data_block_name):
            group = nodes.new(type='ShaderNodeGroup')
            group.node_tree = bpy.data.node_groups[Template]
            return group
        if Template in bpy.data.node_groups:
            instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
        else:
        #    versions = ( t0, t1, t2, t3, t4)
        #    for x in versions:
        #        if os.path.isdir(x) and os.access(x, os.R_OK):
            if (3, 0, 0) <= bpy.app.version < (3, 0, 99):
                before_data = list(bpy.data.node_groups)
                bpy.ops.wm.append(directory=os.path.expanduser(r"~\AppData\Roaming\Blender Foundation\Blender\3.0\scripts\addons\sklx_creator\assets\HS1_Template_Shader.blend") + r'\NodeTree',filename=Template,link=False)
                new_data=list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
                appended_2B5AC = None if not new_data else new_data[0]
                instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
            else:
                if (3, 1, 0) <= bpy.app.version < (3, 1, 99):
                    before_data = list(bpy.data.node_groups)
                    bpy.ops.wm.append(directory=os.path.expanduser(r"~\AppData\Roaming\Blender Foundation\Blender\3.1\scripts\addons\sklx_creator\assets\HS1_Template_Shader.blend") + r'\NodeTree',filename=Template,link=False)
                    new_data=list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
                    appended_2B5AC = None if not new_data else new_data[0]
                    instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
                else:
                    if (3, 2, 0) <= bpy.app.version < (3, 2, 99):
                        before_data = list(bpy.data.node_groups)
                        bpy.ops.wm.append(directory=os.path.expanduser(r"~\AppData\Roaming\Blender Foundation\Blender\3.2\scripts\addons\sklx_creator\assets\HS1_Template_Shader.blend") + r'\NodeTree',filename=Template,link=False)
                        new_data=list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
                        appended_2B5AC = None if not new_data else new_data[0]
                        instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
                    else:
                        if (3, 3, 0) <= bpy.app.version < (3, 3, 99):
                            before_data = list(bpy.data.node_groups)
                            bpy.ops.wm.append(directory=os.path.expanduser(r"~\AppData\Roaming\Blender Foundation\Blender\3.3\scripts\addons\sklx_creator\assets\HS1_Template_Shader.blend") + r'\NodeTree',filename=Template,link=False)
                            new_data=list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
                            appended_2B5AC = None if not new_data else new_data[0]
                            instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
                        else:
                            if (3, 4, 0) <= bpy.app.version < (3, 4, 99):
                                before_data = list(bpy.data.node_groups)
                                bpy.ops.wm.append(directory=os.path.expanduser(r"~\AppData\Roaming\Blender Foundation\Blender\3.4\scripts\addons\sklx_creator\assets\HS1_Template_Shader.blend") + r'\NodeTree',filename=Template,link=False)
                                new_data=list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
                                appended_2B5AC = None if not new_data else new_data[0]
                                instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
        bpy.data.node_groups[Template].name = CTemplate+Tex
        node = bpy.data.node_groups[CTemplate+Tex]
        #initial_area_type = bpy.context.area.type
        #bpy.context.area.type = 'NODE_EDITOR'
        #bpy.context.area.ui_type = 'ShaderNodeTree'
        #bpy.ops.node.group_ungroup()
        #bpy.context.area.type = initial_area_type
        nodes = my_mat.node_tree.nodes
        for node in nodes:
            #node.select = False
            print(node.name)
            node.select = True
            nodes.active = node
        try:
            initial_area_type = bpy.context.area.type
            bpy.context.area.type = 'NODE_EDITOR'
            bpy.context.area.ui_type = 'ShaderNodeTree'
            bpy.ops.wm.redraw_timer(type='DRAW_WIN', iterations=1)
            bpy.ops.node.group_ungroup()
            nonono = node," to Ungroup"
            print(nonono)
            bpy.ops.node.group_edit(exit=True)
        except Exception as e:
            print(e)
        finally:
            bpy.context.area.type = initial_area_type
        fixlocate = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\\20220603141428_Chika_Haruno\\Textures\\"
        bpimg = bpy.data.images.get
        if 1==1:
            print(mm)
            print(dm)
            print(nm)
            print(t2)
            print(t3)
        #formula_list=(nm,nd,dm,mm,t2,t3,am,lm,ar,ov1,ov2,lnm,com,glo,bum,dnm,bnm,sgm,om,tss,mgm,ov)
        #for formula in formula_list:
        #    if bpimg(formula) is not None:
        f1 = bpimg(mm)
        #for x in f1:
        if f1 is not None:
            bpy.data.images[mm].name = TexMain
            bpy.data.images[TexMain].filepath = fixlocate+TexMain
            bpy.data.images[TexMain].filepath_raw = fixlocate+TexMain
        f2 = bpimg(dm)
        #for x in f2:
        if f2 is not None:
            bpy.data.images[dm].name = TexDetailM
            bpy.data.images[TexDetailM].filepath = fixlocate+TexDetailM
            bpy.data.images[TexDetailM].filepath_raw = fixlocate+TexDetailM
        f3 = bpimg(nm)
        #for x in f3:
        if f3 is not None:
            bpy.data.images[nm].name = TexNormal
            bpy.data.images[TexNormal].filepath = fixlocate+TexNormal
            bpy.data.images[TexNormal].filepath_raw = fixlocate+TexNormal
        f4 = bpimg(t2)
        #for x in f3:
        if f4 is not None:
            bpy.data.images[t2].name = TexTex2
            bpy.data.images[TexTex2].filepath = fixlocate+TexTex2
            bpy.data.images[TexTex2].filepath_raw = fixlocate+TexTex2
        f5 = bpimg(t3)
        #for x in f4:
        if f5 is not None:
            bpy.data.images[t3].name = TexTex3
            bpy.data.images[TexTex3].filepath = fixlocate+TexTex3
            bpy.data.images[TexTex3].filepath_raw = fixlocate+TexTex3
        f6 = bpimg(am)
        #for x in f5:
        if f6 is not None:
            bpy.data.images[am].name = TexAlphaM
            bpy.data.images[TexAlphaM].filepath = fixlocate+TexAlphaM
            bpy.data.images[TexAlphaM].filepath_raw = fixlocate+TexAlphaM
        f7 = bpimg(lm)
        #for x in f6:
        if f7 is not None:
            bpy.data.images[lm].name = TexLiquidM
            bpy.data.images[TexLiquidM].filepath = fixlocate+TexLiquidM
            bpy.data.images[TexLiquidM].filepath_raw = fixlocate+TexLiquidM
        f8 = bpimg(ar)
        #for f8 in f8:
        if f8 is not None:
            bpy.data.images[ar].name = TexAnotherR
            bpy.data.images[TexAnotherR].filepath = fixlocate+TexAnotherR
            bpy.data.images[TexAnotherR].filepath_raw = fixlocate+TexAnotherR
        f9 = bpimg(nd)
        #for f8 in f8:
        if f9 is not None:
            bpy.data.images[nd].name = TexNDetail
            bpy.data.images[TexNDetail].filepath = fixlocate+TexNDetail
            bpy.data.images[TexNDetail].filepath_raw = fixlocate+TexNDetail
        f10 = bpimg(ov1)
        #for f8 in f8:
        if f10 is not None:
            bpy.data.images[ov1].name = TexOv1
            bpy.data.images[TexOv1].filepath = fixlocate+TexOv1
            bpy.data.images[TexOv1].filepath_raw = fixlocate+TexOv1
        f11 = bpimg(ov2)
        #for f8 in f8:
        if f11 is not None:
            bpy.data.images[ov2].name = TexOv2
            bpy.data.images[TexOv2].filepath = fixlocate+TexOv2
            bpy.data.images[TexOv2].filepath_raw = fixlocate+TexOv2
        f12 = bpimg(lnm)
        #for f8 in f8:
        if f12 is not None:
            bpy.data.images[lnm].name = TexLineM
            bpy.data.images[TexLineM].filepath = fixlocate+TexLineM
            bpy.data.images[TexLineM].filepath_raw = fixlocate+TexLineM
        f13 = bpimg(com)
        #for f8 in f8:
        if f13 is not None:
            bpy.data.images[com].name = TexColorM
            bpy.data.images[TexColorM].filepath = fixlocate+TexColorM
            bpy.data.images[TexColorM].filepath_raw = fixlocate+TexColorM
        f14 = bpimg(glo)
        #for f8 in f8:
        if f14 is not None:
            bpy.data.images[glo].name = TexHairG
            bpy.data.images[TexHairG].filepath = fixlocate+TexHairG
            bpy.data.images[TexHairG].filepath_raw = fixlocate+TexHairG
        f15 = bpimg(bum)
        #for f8 in f8:
        if f15 is not None:
            bpy.data.images[bum].name = TexBump
            bpy.data.images[TexBump].filepath = fixlocate+TexBump
            bpy.data.images[TexBump].filepath_raw = fixlocate+TexBump
        f16 = bpimg(dnm)
        #for f8 in f8:
        if f16 is not None:
            bpy.data.images[dnm].name = TexDNM
            bpy.data.images[TexDNM].filepath = fixlocate+TexDNM
            bpy.data.images[TexDNM].filepath_raw = fixlocate+TexDNM
        f17 = bpimg(bnm)
        #for f8 in f8:
        if f17 is not None:
            bpy.data.images[bnm].name = TexBNM
            bpy.data.images[TexBNM].filepath = fixlocate+TexBNM
            bpy.data.images[TexBNM].filepath_raw = fixlocate+TexBNM
        f18 = bpimg(sgm)
        #for f8 in f8:
        if f18 is not None:
            bpy.data.images[sgm].name = TexSGM
            bpy.data.images[TexSGM].filepath = fixlocate+TexSGM
            bpy.data.images[TexSGM].filepath_raw = fixlocate+TexSGM
        f19 = bpimg(om)
        #for f8 in f8:
        if f19 is not None:
            bpy.data.images[om].name = TexOM
            bpy.data.images[TexOM].filepath = fixlocate+TexOM
            bpy.data.images[TexOM].filepath_raw = fixlocate+TexOM
        f20 = bpimg(tss)
        #for f8 in f8:
        if f20 is not None:
            bpy.data.images[tss].name = TexTSS
            bpy.data.images[TexTSS].filepath = fixlocate+TexTSS
            bpy.data.images[TexTSS].filepath_raw = fixlocate+TexTSS
        f21 = bpimg(mgm)
        #for f8 in f8:
        if f21 is not None:
            bpy.data.images[mgm].name = TexMGM
            bpy.data.images[TexMGM].filepath = fixlocate+TexMGM
            bpy.data.images[TexMGM].filepath_raw = fixlocate+TexMGM
        f22 = bpimg(ov)
        #for f8 in f8:
        if f22 is not None:
            bpy.data.images[ov].name = TexOV
            bpy.data.images[TexOV].filepath = fixlocate+TexOV
            bpy.data.images[TexOV].filepath_raw = fixlocate+TexOV
        bpy.ops.file.find_missing_files('INVOKE_DEFAULT')
        return {"FINISHED"}

    def invoke(self, context, event):
        return self.execute(context)


class SNA_OT_Hs1Socks_A2F22(bpy.types.Operator):
    bl_idname = "sna.hs1socks_a2f22"
    bl_label = "hs1-socks"
    bl_description = ""
    bl_options = {"REGISTER", "UNDO"}

    @classmethod
    def poll(cls, context):
        return not False

    def execute(self, context):
        import os
        ########################################################################
        my_mat = bpy.context.object.material_slots[0].material
        print(my_mat.name)
        Tex=my_mat.name
        rem_mat = bpy.data.materials[Tex]
        #Get the node in its node tree (replace the name below)
        node_to_delete =  rem_mat.node_tree.nodes['Principled BSDF']
        node_to_delete2 =  rem_mat.node_tree.nodes['Material Output']
        #Remove it
        rem_mat.node_tree.nodes.remove(node_to_delete)
        rem_mat.node_tree.nodes.remove(node_to_delete2)
        #Tex = material.name
        TexMain = Tex+'_MainTex.png'
        TexDetailM = Tex+'_DetailMask.png'
        TexNormal = Tex+'_NormalMap.png'
        TexNDetail = Tex+'_NormalMapDetail.png'
        TexAlphaM = Tex+'_AlphaMask.png'
        TexAnotherR = Tex+'_AnotherRamp.png'
        TexLiquidM = Tex+'_liquidmask.png'
        TexTex2 = Tex+'_Texture2.png'
        TexTex3 = Tex+'_Texture3.png'
        TexOv1 = Tex+'_overtex1.png'
        TexOv2 = Tex+'_overtex2.png'
        TexLineM = Tex+'_LineMask.png'
        TexColorM = Tex+'_ColorMask.png'
        TexHairG = Tex+'_HairGloss.png'
        TexBump = Tex+'_BumpMap.png'
        TexDNM = Tex+'_DetailNormalMap.png'
        TexBNM = Tex+'_BlendNormalMap.png'
        TexSGM = Tex+'_SpecGlossMap.png'
        TexOM = Tex+'_OcclusionMap.png'
        TexTSS = Tex+'_Thickness.png'
        TexMGM = Tex+'_MetallicGlossMap.png'
        TexOV = Tex+'_OverTex.png'
        originaltex = 'cf_M_socks_ballet_'
        #originaltss = 'cf_m_body_01_'
        #kkp
        nm = originaltex+'NormalMap.png'
        nd = originaltex+'NormalMapDetail.png'
        dm = originaltex+'DetailMask.png'
        mm = originaltex+'MainTex.png'
        t3 = originaltex+'Texture3.png'
        t2 = originaltex+'Texture2.png'
        am = originaltex+'AlphaMask.png'
        lm = originaltex+'liquidmask.png'
        ar = originaltex+'AnotherRamp.png'
        ov1 = originaltex+'overtex1.png'
        ov2 = originaltex+'overtex2.png'
        lnm = originaltex+'LineMask.png'
        com = originaltex+'ColorMask.png'
        glo = originaltex+'HairGloss.png'
        #hs1
        bum = originaltex+'BumpMap.png'
        dnm = originaltex+'DetailNormalMap.png'
        bnm = originaltex+'BlendNormalMap.png'
        sgm = originaltex+'SpecGlossMap.png'
        om = originaltex+'OcclusionMap.png'
        tss = originaltex+'Thickness.png'
        mgm = originaltex+'MetallicGlossMap.png'
        ov = originaltex+'OverTex.png'
        Template='HS1-Template Socks'
        CTemplate=Template+' '
        C = bpy.context

        def instantiate_group(nodes, data_block_name):
            group = nodes.new(type='ShaderNodeGroup')
            group.node_tree = bpy.data.node_groups[Template]
            return group
        if Template in bpy.data.node_groups:
            instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
        else:
        #    versions = ( t0, t1, t2, t3, t4)
        #    for x in versions:
        #        if os.path.isdir(x) and os.access(x, os.R_OK):
            if (3, 0, 0) <= bpy.app.version < (3, 0, 99):
                before_data = list(bpy.data.node_groups)
                bpy.ops.wm.append(directory=os.path.expanduser(r"~\AppData\Roaming\Blender Foundation\Blender\3.0\scripts\addons\sklx_creator\assets\HS1_Template_Shader.blend") + r'\NodeTree',filename=Template,link=False)
                new_data=list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
                appended_2B5AC = None if not new_data else new_data[0]
                instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
            else:
                if (3, 1, 0) <= bpy.app.version < (3, 1, 99):
                    before_data = list(bpy.data.node_groups)
                    bpy.ops.wm.append(directory=os.path.expanduser(r"~\AppData\Roaming\Blender Foundation\Blender\3.1\scripts\addons\sklx_creator\assets\HS1_Template_Shader.blend") + r'\NodeTree',filename=Template,link=False)
                    new_data=list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
                    appended_2B5AC = None if not new_data else new_data[0]
                    instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
                else:
                    if (3, 2, 0) <= bpy.app.version < (3, 2, 99):
                        before_data = list(bpy.data.node_groups)
                        bpy.ops.wm.append(directory=os.path.expanduser(r"~\AppData\Roaming\Blender Foundation\Blender\3.2\scripts\addons\sklx_creator\assets\HS1_Template_Shader.blend") + r'\NodeTree',filename=Template,link=False)
                        new_data=list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
                        appended_2B5AC = None if not new_data else new_data[0]
                        instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
                    else:
                        if (3, 3, 0) <= bpy.app.version < (3, 3, 99):
                            before_data = list(bpy.data.node_groups)
                            bpy.ops.wm.append(directory=os.path.expanduser(r"~\AppData\Roaming\Blender Foundation\Blender\3.3\scripts\addons\sklx_creator\assets\HS1_Template_Shader.blend") + r'\NodeTree',filename=Template,link=False)
                            new_data=list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
                            appended_2B5AC = None if not new_data else new_data[0]
                            instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
                        else:
                            if (3, 4, 0) <= bpy.app.version < (3, 4, 99):
                                before_data = list(bpy.data.node_groups)
                                bpy.ops.wm.append(directory=os.path.expanduser(r"~\AppData\Roaming\Blender Foundation\Blender\3.4\scripts\addons\sklx_creator\assets\HS1_Template_Shader.blend") + r'\NodeTree',filename=Template,link=False)
                                new_data=list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
                                appended_2B5AC = None if not new_data else new_data[0]
                                instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
        bpy.data.node_groups[Template].name = CTemplate+Tex
        node = bpy.data.node_groups[CTemplate+Tex]
        #initial_area_type = bpy.context.area.type
        #bpy.context.area.type = 'NODE_EDITOR'
        #bpy.context.area.ui_type = 'ShaderNodeTree'
        #bpy.ops.node.group_ungroup()
        #bpy.context.area.type = initial_area_type
        nodes = my_mat.node_tree.nodes
        for node in nodes:
            #node.select = False
            print(node.name)
            node.select = True
            nodes.active = node
        try:
            initial_area_type = bpy.context.area.type
            bpy.context.area.type = 'NODE_EDITOR'
            bpy.context.area.ui_type = 'ShaderNodeTree'
            bpy.ops.wm.redraw_timer(type='DRAW_WIN', iterations=1)
            bpy.ops.node.group_ungroup()
            nonono = node," to Ungroup"
            print(nonono)
            bpy.ops.node.group_edit(exit=True)
        except Exception as e:
            print(e)
        finally:
            bpy.context.area.type = initial_area_type
        fixlocate = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\\20220603141428_Chika_Haruno\\Textures\\"
        bpimg = bpy.data.images.get
        if 1==1:
            print(mm)
            print(dm)
            print(nm)
            print(t2)
            print(t3)
        #formula_list=(nm,nd,dm,mm,t2,t3,am,lm,ar,ov1,ov2,lnm,com,glo,bum,dnm,bnm,sgm,om,tss,mgm,ov)
        #for formula in formula_list:
        #    if bpimg(formula) is not None:
        f1 = bpimg(mm)
        #for x in f1:
        if f1 is not None:
            bpy.data.images[mm].name = TexMain
            bpy.data.images[TexMain].filepath = fixlocate+TexMain
            bpy.data.images[TexMain].filepath_raw = fixlocate+TexMain
        f2 = bpimg(dm)
        #for x in f2:
        if f2 is not None:
            bpy.data.images[dm].name = TexDetailM
            bpy.data.images[TexDetailM].filepath = fixlocate+TexDetailM
            bpy.data.images[TexDetailM].filepath_raw = fixlocate+TexDetailM
        f3 = bpimg(nm)
        #for x in f3:
        if f3 is not None:
            bpy.data.images[nm].name = TexNormal
            bpy.data.images[TexNormal].filepath = fixlocate+TexNormal
            bpy.data.images[TexNormal].filepath_raw = fixlocate+TexNormal
        f4 = bpimg(t2)
        #for x in f3:
        if f4 is not None:
            bpy.data.images[t2].name = TexTex2
            bpy.data.images[TexTex2].filepath = fixlocate+TexTex2
            bpy.data.images[TexTex2].filepath_raw = fixlocate+TexTex2
        f5 = bpimg(t3)
        #for x in f4:
        if f5 is not None:
            bpy.data.images[t3].name = TexTex3
            bpy.data.images[TexTex3].filepath = fixlocate+TexTex3
            bpy.data.images[TexTex3].filepath_raw = fixlocate+TexTex3
        f6 = bpimg(am)
        #for x in f5:
        if f6 is not None:
            bpy.data.images[am].name = TexAlphaM
            bpy.data.images[TexAlphaM].filepath = fixlocate+TexAlphaM
            bpy.data.images[TexAlphaM].filepath_raw = fixlocate+TexAlphaM
        f7 = bpimg(lm)
        #for x in f6:
        if f7 is not None:
            bpy.data.images[lm].name = TexLiquidM
            bpy.data.images[TexLiquidM].filepath = fixlocate+TexLiquidM
            bpy.data.images[TexLiquidM].filepath_raw = fixlocate+TexLiquidM
        f8 = bpimg(ar)
        #for f8 in f8:
        if f8 is not None:
            bpy.data.images[ar].name = TexAnotherR
            bpy.data.images[TexAnotherR].filepath = fixlocate+TexAnotherR
            bpy.data.images[TexAnotherR].filepath_raw = fixlocate+TexAnotherR
        f9 = bpimg(nd)
        #for f8 in f8:
        if f9 is not None:
            bpy.data.images[nd].name = TexNDetail
            bpy.data.images[TexNDetail].filepath = fixlocate+TexNDetail
            bpy.data.images[TexNDetail].filepath_raw = fixlocate+TexNDetail
        f10 = bpimg(ov1)
        #for f8 in f8:
        if f10 is not None:
            bpy.data.images[ov1].name = TexOv1
            bpy.data.images[TexOv1].filepath = fixlocate+TexOv1
            bpy.data.images[TexOv1].filepath_raw = fixlocate+TexOv1
        f11 = bpimg(ov2)
        #for f8 in f8:
        if f11 is not None:
            bpy.data.images[ov2].name = TexOv2
            bpy.data.images[TexOv2].filepath = fixlocate+TexOv2
            bpy.data.images[TexOv2].filepath_raw = fixlocate+TexOv2
        f12 = bpimg(lnm)
        #for f8 in f8:
        if f12 is not None:
            bpy.data.images[lnm].name = TexLineM
            bpy.data.images[TexLineM].filepath = fixlocate+TexLineM
            bpy.data.images[TexLineM].filepath_raw = fixlocate+TexLineM
        f13 = bpimg(com)
        #for f8 in f8:
        if f13 is not None:
            bpy.data.images[com].name = TexColorM
            bpy.data.images[TexColorM].filepath = fixlocate+TexColorM
            bpy.data.images[TexColorM].filepath_raw = fixlocate+TexColorM
        f14 = bpimg(glo)
        #for f8 in f8:
        if f14 is not None:
            bpy.data.images[glo].name = TexHairG
            bpy.data.images[TexHairG].filepath = fixlocate+TexHairG
            bpy.data.images[TexHairG].filepath_raw = fixlocate+TexHairG
        f15 = bpimg(bum)
        #for f8 in f8:
        if f15 is not None:
            bpy.data.images[bum].name = TexBump
            bpy.data.images[TexBump].filepath = fixlocate+TexBump
            bpy.data.images[TexBump].filepath_raw = fixlocate+TexBump
        f16 = bpimg(dnm)
        #for f8 in f8:
        if f16 is not None:
            bpy.data.images[dnm].name = TexDNM
            bpy.data.images[TexDNM].filepath = fixlocate+TexDNM
            bpy.data.images[TexDNM].filepath_raw = fixlocate+TexDNM
        f17 = bpimg(bnm)
        #for f8 in f8:
        if f17 is not None:
            bpy.data.images[bnm].name = TexBNM
            bpy.data.images[TexBNM].filepath = fixlocate+TexBNM
            bpy.data.images[TexBNM].filepath_raw = fixlocate+TexBNM
        f18 = bpimg(sgm)
        #for f8 in f8:
        if f18 is not None:
            bpy.data.images[sgm].name = TexSGM
            bpy.data.images[TexSGM].filepath = fixlocate+TexSGM
            bpy.data.images[TexSGM].filepath_raw = fixlocate+TexSGM
        f19 = bpimg(om)
        #for f8 in f8:
        if f19 is not None:
            bpy.data.images[om].name = TexOM
            bpy.data.images[TexOM].filepath = fixlocate+TexOM
            bpy.data.images[TexOM].filepath_raw = fixlocate+TexOM
        f20 = bpimg(tss)
        #for f8 in f8:
        if f20 is not None:
            bpy.data.images[tss].name = TexTSS
            bpy.data.images[TexTSS].filepath = fixlocate+TexTSS
            bpy.data.images[TexTSS].filepath_raw = fixlocate+TexTSS
        f21 = bpimg(mgm)
        #for f8 in f8:
        if f21 is not None:
            bpy.data.images[mgm].name = TexMGM
            bpy.data.images[TexMGM].filepath = fixlocate+TexMGM
            bpy.data.images[TexMGM].filepath_raw = fixlocate+TexMGM
        f22 = bpimg(ov)
        #for f8 in f8:
        if f22 is not None:
            bpy.data.images[ov].name = TexOV
            bpy.data.images[TexOV].filepath = fixlocate+TexOV
            bpy.data.images[TexOV].filepath_raw = fixlocate+TexOV
        bpy.ops.file.find_missing_files('INVOKE_DEFAULT')
        return {"FINISHED"}

    def invoke(self, context, event):
        return self.execute(context)


class SNA_OT_Hs2Appenddata_4F4D0(bpy.types.Operator):
    bl_idname = "sna.hs2appenddata_4f4d0"
    bl_label = "hs2-append-data"
    bl_description = "Set the shaders to the Honey Select 2 character"
    bl_options = {"REGISTER", "UNDO"}

    @classmethod
    def poll(cls, context):
        return not False

    def execute(self, context):
        #--- Eliminate Material Duplicates

        def eliminate_materials():
            print("\nEliminate Material Duplicates:")
            #--- Search for mat. slots in all objects
            mats = bpy.data.materials
            for obj in bpy.data.objects:
                for slot in obj.material_slots:
                    # Get the material name as 3-tuple (base, separator, extension)
                    (base, sep, ext) = slot.name.rpartition('.')
                    # Replace the numbered duplicate with the original if found
                    if ext.isnumeric():
                        if base in mats:
                            print("  For object '%s' replace '%s' with '%s'" % (obj.name, slot.name, base))
                            slot.material = mats.get(base)
        #--- Execute
        eliminate_materials()
        before_data = list(bpy.data.node_groups)
        bpy.ops.wm.append(directory=os.path.join(os.path.dirname(__file__), 'assets', 'HS2_Template_Shader.blend') + r'\NodeTree', filename='HS2-Template Eyelashes', link=False)
        new_data = list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
        appended_1EDEA = None if not new_data else new_data[0]
        before_data = list(bpy.data.node_groups)
        bpy.ops.wm.append(directory=os.path.join(os.path.dirname(__file__), 'assets', 'HS2_Template_Shader.blend') + r'\NodeTree', filename='HS2-Template Eye', link=False)
        new_data = list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
        appended_8B2B5 = None if not new_data else new_data[0]
        before_data = list(bpy.data.node_groups)
        bpy.ops.wm.append(directory=os.path.join(os.path.dirname(__file__), 'assets', 'HS2_Template_Shader.blend') + r'\NodeTree', filename='HS2-Template Teeth', link=False)
        new_data = list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
        appended_1D20A = None if not new_data else new_data[0]
        before_data = list(bpy.data.node_groups)
        bpy.ops.wm.append(directory=os.path.join(os.path.dirname(__file__), 'assets', 'HS2_Template_Shader.blend') + r'\NodeTree', filename='HS2-Template Tongue', link=False)
        new_data = list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
        appended_173C8 = None if not new_data else new_data[0]
        before_data = list(bpy.data.node_groups)
        bpy.ops.wm.append(directory=os.path.join(os.path.dirname(__file__), 'assets', 'HS2_Template_Shader.blend') + r'\NodeTree', filename='HS2-Template Face', link=False)
        new_data = list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
        appended_0CC59 = None if not new_data else new_data[0]
        before_data = list(bpy.data.node_groups)
        bpy.ops.wm.append(directory=os.path.join(os.path.dirname(__file__), 'assets', 'HS2_Template_Shader.blend') + r'\NodeTree', filename='HS2-Template Body', link=False)
        new_data = list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
        appended_5BCDD = None if not new_data else new_data[0]
        before_data = list(bpy.data.node_groups)
        bpy.ops.wm.append(directory=os.path.join(os.path.dirname(__file__), 'assets', 'HS2_Template_Shader.blend') + r'\NodeTree', filename='HS2-Template Front Hair', link=False)
        new_data = list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
        appended_C4B3B = None if not new_data else new_data[0]
        before_data = list(bpy.data.node_groups)
        bpy.ops.wm.append(directory=os.path.join(os.path.dirname(__file__), 'assets', 'HS2_Template_Shader.blend') + r'\NodeTree', filename='HS2-Template Back Hair', link=False)
        new_data = list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
        appended_0300E = None if not new_data else new_data[0]
        before_data = list(bpy.data.node_groups)
        bpy.ops.wm.append(directory=os.path.join(os.path.dirname(__file__), 'assets', 'HS2_Template_Shader.blend') + r'\NodeTree', filename='HS2-Template Top', link=False)
        new_data = list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
        appended_689CB = None if not new_data else new_data[0]
        before_data = list(bpy.data.node_groups)
        bpy.ops.wm.append(directory=os.path.join(os.path.dirname(__file__), 'assets', 'HS2_Template_Shader.blend') + r'\NodeTree', filename='HS2-Template Pants', link=False)
        new_data = list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
        appended_1AF61 = None if not new_data else new_data[0]
        before_data = list(bpy.data.node_groups)
        bpy.ops.wm.append(directory=os.path.join(os.path.dirname(__file__), 'assets', 'HS2_Template_Shader.blend') + r'\NodeTree', filename='HS2-Template Inner', link=False)
        new_data = list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
        appended_8E2BE = None if not new_data else new_data[0]
        before_data = list(bpy.data.node_groups)
        bpy.ops.wm.append(directory=os.path.join(os.path.dirname(__file__), 'assets', 'HS2_Template_Shader.blend') + r'\NodeTree', filename='HS2-Template Shoes', link=False)
        new_data = list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
        appended_F6DB7 = None if not new_data else new_data[0]
        before_data = list(bpy.data.node_groups)
        bpy.ops.wm.append(directory=os.path.join(os.path.dirname(__file__), 'assets', 'HS2_Template_Shader.blend') + r'\NodeTree', filename='HS2-Template Socks', link=False)
        new_data = list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
        appended_50498 = None if not new_data else new_data[0]
        before_data = list(bpy.data.node_groups)
        bpy.ops.wm.append(directory=os.path.join(os.path.dirname(__file__), 'assets', 'HS2_Template_Shader.blend') + r'\NodeTree', filename='HS2-Template Short', link=False)
        new_data = list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
        appended_9D177 = None if not new_data else new_data[0]
        before_data = list(bpy.data.node_groups)
        bpy.ops.wm.append(directory=os.path.join(os.path.dirname(__file__), 'assets', 'HS2_Template_Shader.blend') + r'\NodeTree', filename='HS2-Template Bra', link=False)
        new_data = list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
        appended_EEFEF = None if not new_data else new_data[0]
        before_data = list(bpy.data.node_groups)
        bpy.ops.wm.append(directory=os.path.join(os.path.dirname(__file__), 'assets', 'HS2_Template_Shader.blend') + r'\NodeTree', filename='HS2-Template Nails', link=False)
        new_data = list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
        appended_02070 = None if not new_data else new_data[0]
        before_data = list(bpy.data.node_groups)
        bpy.ops.wm.append(directory=os.path.join(os.path.dirname(__file__), 'assets', 'HS2_Template_Shader.blend') + r'\NodeTree', filename='HS2-Template Tears', link=False)
        new_data = list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
        appended_51623 = None if not new_data else new_data[0]
        # for easily use of the addon and implementation of variety of name meshes
        # this is a list created for add more names
        #mods added:
        # Body names:
        body1 = 'o_body_cf'
        body2 = 'o_body_cm'
        # Face names: #full koikatsu
        face1 = 'o_head' #los de abajo son relleno
        face2 = 'o_face'
        face3 = 'o_mannequin_head'
        face4 = 'o_face4'
        face5 = 'o_face5'
        # Front Hair
        fronth1 = 'cf_O_hairfront_01_01a'
        fronth2 = 'cf_O_hairfront_01_01b'
        fronth3 = 'cf_O_hairfront_01_02a'
        fronth4 = 'cf_O_hairfront_01_02b'
        fronth5 = 'cf_O_hairfront_02_01'
        fronth6 = 'cf_O_hairfront_02_02'
        fronth7 = 'cf_O_hairfront_03_01'
        fronth8 = 'cf_O_hairfront_17_01'
        fronth9 = 'cf_O_hairfront_04_01'
        fronth10 = 'cf_O_hairfront_05_01'
        fronth11 = 'cf_O_hairfront_05_02'
        fronth12 = 'cf_O_hair_f_06_01'
        fronth13 = 'cf_O_hair_f_06_02'
        fronth14 = 'cf_O_hair_f_07_01'
        fronth15 = 'cf_O_hairfront_08_01'
        fronth16 = 'cf_O_hairfront_09_01'
        fronth17 = 'cf_O_hairfront_10_00'
        fronth18 = 'cf_O_hairback_11_01'
        fronth19 = 'cf_O_hairfront_12_01'
        fronth20 = 'cf_O_hairfront_30_01'
        fronth21 = 'cf_O_hairfront_30_03'
        fronth22 = 'cf_O_hairfront_31_01'
        fronth23 = 'cf_O_hairfront_32_01'
        fronth24 = 'cf_O_hairfront_33_01' #FINISHED WITH FRONT HAIR 00
        fronth25 = 'cf_O_hairfront_17_01'
        fronth26 = 'cf_O_hairfront_34_00'
        fronth27 = 'cf_O_hairfront_34_01' # 05
        fronth28 = 'cf_O_hairfront_35_00'
        fronth29 = 'cf_O_hairfront_r_35_00' # 08
        fronth30 = 'cf_O_hairfront_18_01' # 10
        fronth31 = 'cf_O_hairfront_36_00'
        fronth32 = 'cf_O_hairfront_36_01' # 13
        fronth33 = 'cf_O_hairfront_18_00'
        fronth34 = 'cf_O_hairfront_18_01' # 14
        fronth35 = 'cf_O_hairfront_15_00'
        fronth36 = 'cf_O_hairfront_16_00'
        fronth37 = 'cf_O_hairfront_17_00'
        fronth38 = 'cf_O_hairfront_19_02'
        fronth39 = 'cf_O_hairfront_19_03'
        fronth40 = 'cf_O_hairfront_20_00'
        fronth41 = 'cf_O_hairfront_21_00'
        fronth42 = 'cf_O_hairfront_37_00' # 30
        fronth43 = 'cf_O_hairfront_22_00' # 34
        fronth44 = 'cf_O_hairfront_23_00'
        fronth45 = 'cf_O_hairfront_23_01'
        fronth46 = 'cf_O_hairfront_23_02' # 40
        fronth47 = 'cf_O_hair_24_00'
        fronth48 = 'cf_O_hair_24_01' # 41
        fronth49 = 'cf_O_hairfront_25_00'
        fronth50 = 'cf_O_hairfront_25_01'
        fronth51 = 'cf_O_hairfront_26_00'
        fronth52 = 'cf_O_hairfront_26_01'
        fronth53 = 'cf_O_hairfront_27_00'
        fronth54 = 'cf_O_hairfront_28_00'
        fronth55 = 'cf_O_hairfront_28_01'
        fronth56 = 'cf_O_hairfront_28_02'
        fronth57 = 'cf_O_hairfront_29_00' # 50
        fronth58 = 'cf_O_hairf_93_03'
        fronth59 = 'cf_O_hairf_93_03_deprecated'
        fronth60 = 'o_hair_0'
        fronth61 = 'o_hair_1'
        fronth62 = 'o_hair_2'
        fronth63 = 'o_hair_3'
        fronth64 = 'o_hair_4'
        fronth65 = 'o_u_hair_1'
        fronth66 = 'o_u_hair_2'
        fronth67 = 'o_u_hair_3'
        fronth68 = 'o_u_hair_4'
        fronth69 = 'o_hairF_0'
        fronth70 = 'o_hairF_01'
        fronth71 = 'o_hairF_1'
        fronth72 = 'o_hairF_2'
        fronth73 = 'o_hairF_3'
        fronth74 = 'o_hairF_8'
        fronth75 = 'o_hairF_9'
        fronth76 = 'o_u_hairF_0'
        fronth77 = 'o_u_hairF_01'
        fronth78 = 'o_u_hairF_1'
        fronth79 = 'o_u_hairF_2'
        fronth80 = 'o_u_hairF_3'
        fronth81 = 'o_u_hairF_8'
        fronth82 = 'o_u_hairF_9'
        fronth83 = 'cf_O_hairfront_97_00'
        fronth84 = 'cf_O_hairfront_97_00_deprecated'
        fronth85 = 'cf_O_hairfront_97_01'
        fronth86 = 'cf_O_hairfront_97_01_deprecated'
        fronth87 = 'cf_O_hairfront_97_02'
        fronth88 = 'cf_O_hairfront_97_02_deprecated'
        fronth89 = 'cf_O_hairfront_97_03'
        fronth90 = 'cf_O_hairfront_97_03_deprecated'
        fronth91 = 'cf_O_hairfront_97_04'
        fronth92 = 'cf_O_hairfront_97_04_deprecated'
        fronth93 = 'cf_O_hairfront_97_05'
        fronth94 = 'cf_O_hairfront_97_05_deprecated'
        fronth95 = 'cf_O_hairfront_97_06'
        fronth96 = 'cf_O_hairfront_97_06_deprecated'
        fronth97 = 'cf_O_hairfront_97_07'
        fronth98 = 'cf_O_hairfront_97_07_deprecated'
        fronth99 = 'cf_O_hairfront_97_08'
        fronth100 = 'cf_O_hairfront_97_08_deprecated'
        fronth101 = 'cf_O_hairfront_97_09'
        fronth102 = 'cf_O_hairfront_97_09_deprecated'
        fronth103 = 'cf_O_hairfront_97_10'
        fronth104 = 'cf_O_hairfront_97_10_deprecated'
        fronth105 = 'cf_O_hairfront_97_11'
        fronth106 = 'cf_O_hairfront_97_11_deprecated'
        fronth107 = 'cf_O_hairfront00'
        fronth108 = 'cf_O_hairfront00_deprecated'
        fronth109 = 'cf_O_hairfront01_00'
        fronth110 = 'cf_O_hairfront01_00_deprecated'
        fronth111 = 'cf_O_hairfront03_00'
        fronth112 = 'cf_O_hairfront03_00_deprecated'
        fronth113 = 'cf_O_hairfront05_00'
        fronth114 = 'cf_O_hairfront05_01'
        fronth115 = 'cf_O_hair_f06_00'
        fronth116 = 'cf_O_hair_s06_00'
        fronth117 = 'cf_O_hair_s06_00_deprecated'
        fronth118 = 'cf_O_hair_s06_01'
        fronth119 = 'cf_O_hair_s06_01_deprecated'
        fronth120 = 'cf_O_hair_s06_02'
        fronth121 = 'cf_O_hair_s06_02_deprecated'
        fronth122 = 'cf_O_hair_s06_03'
        fronth123 = 'cf_O_hair_s06_03_deprecated'
        fronth124 = 'cf_O_hairfront_08_00'
        fronth125 = 'cf_O_hairfront_08_00_deprecated'
        fronth126 = 'cf_O_hairfront_08_01'
        fronth127 = 'cf_O_hairfront_08_01_deprecated'
        fronth128 = 'cf_O_hairfront_09_00'
        fronth129 = 'cf_O_hairfront_09_00_deprecated'
        fronth130 = 'cf_O_hairfront_09_01'
        fronth131 = 'cf_O_hairfront_09_01_deprecated'
        fronth132 = 'cf_O_hairfront10_00'
        fronth133 = 'cf_O_hairfront10_00_deprecated'
        fronth134 = 'cf_O_hairfront10_01'
        fronth135 = 'cf_O_hairfront_11_00'
        fronth136 = 'cf_O_hairfront_11_00_deprecated'
        fronth137 = 'cf_O_hairfront_11_01'
        fronth138 = 'cf_O_hairfront_11_01_deprecated'
        fronth139 = 'cf_O_hairfront_11_02'
        fronth140 = 'cf_O_hairfront_11_02_deprecated'
        fronth141 = 'cf_O_hairfront_11_03'
        fronth142 = 'cf_O_hairfront_11_03_deprecated'
        fronth143 = 'cf_O_hairfront_11_04'
        fronth144 = 'cf_O_hairfront_11_04_deprecated'
        fronth145 = 'cf_O_hairfront_11_05'
        fronth146 = 'cf_O_hairfront_11_05_deprecated'
        fronth147 = 'cf_O_hairfront_11_06'
        fronth148 = 'cf_O_hairfront_11_06_deprecated'
        fronth149 = 'cf_O_hairfront_11_07'
        fronth150 = 'cf_O_hairfront_11_07_deprecated'
        fronth151 = 'cf_O_hairfront_11_08'
        fronth152 = 'cf_O_hairfront_11_08_deprecated'
        fronth153 = 'cf_O_hairfront_12_00'
        fronth154 = 'cf_O_hairfront_12_00_deprecated'
        fronth155 = 'cf_O_hairfront_12_01'
        fronth156 = 'cf_O_hairfront_12_01_deprecated'
        fronth157 = 'cf_O_hairfront_12_02'
        fronth158 = 'cf_O_hairfront_12_02_deprecated'
        fronth159 = 'cf_O_hairfront_13_00'
        fronth160 = 'cf_O_hairfront_13_00_deprecated'
        fronth161 = 'cf_O_hairfront_14_00'
        fronth162 = 'cf_O_hairfront_14_00_deprecated'
        fronth163 = 'cf_O_hairfront_15_00'
        fronth164 = 'cf_O_hairfront_15_00_deprecated'
        fronth165 = 'cf_O_hairfront_16_00'
        fronth166 = 'cf_O_hairfront_16_00_deprecated'
        fronth167 = 'cf_O_hairfront_18_00'
        fronth168 = 'cf_O_hairfront_18_00_deprecated'
        fronth169 = 'cf_O_hairfront_18_01'
        fronth170 = 'cf_O_hairfront_18_01_deprecated'
        fronth171 = 'cf_O_hairfront_20_01'
        fronth172 = 'cf_O_hairfront_20_01_deprecated'
        fronth173 = 'cf_O_hairfront_20_02'
        fronth174 = 'cf_O_hairfront_20_02_deprecated'
        fronth175 = 'cf_O_hairfront_20_03'
        fronth176 = 'cf_O_hairfront_20_03_deprecated'
        fronth177 = 'cf_O_hairfront_21_01'
        fronth178 = 'cf_O_hairfront_21_01_deprecated'
        fronth179 = 'cf_O_hairfront_21_02'
        fronth180 = 'cf_O_hairfront_21_02_deprecated'
        fronth181 = 'cf_O_hairfront_21_03'
        fronth182 = 'cf_O_hairfront_21_03_deprecated'
        fronth183 = 'cf_O_hairfront_21_04'
        fronth184 = 'cf_O_hairfront_21_04_deprecated'
        fronth185 = 'cf_O_hairfront_21_05'
        fronth186 = 'cf_O_hairfront_21_05_deprecated'
        fronth187 = 'cf_O_hairfront_21_06'
        fronth188 = 'cf_O_hairfront_21_06_deprecated'
        fronth189 = 'cf_O_hairfront_21_07'
        fronth190 = 'cf_O_hairfront_21_07_deprecated'
        fronth191 = 'cf_O_hairfront_22_01'
        fronth192 = 'cf_O_hairfront_22_01_deprecated'
        fronth193 = 'cf_O_hairfront_22_02'
        fronth194 = 'cf_O_hairfront_22_02_deprecated'
        fronth195 = 'cf_O_hairfront_22_03'
        fronth196 = 'cf_O_hairfront_22_03_deprecated'
        fronth197 = 'cf_O_hairfront_22_04'
        fronth198 = 'cf_O_hairfront_22_04_deprecated'
        fronth199 = 'hair24_f_L_01'
        fronth200 = 'hair24_f_L_01_deprecated'
        fronth201 = 'hair24_f_L_02'
        fronth202 = 'hair24_f_L_02_deprecated'
        fronth203 = 'hair24_f_L_03'
        fronth204 = 'hair24_f_L_03_deprecated'
        fronth205 = 'hair24_f_L_04'
        fronth206 = 'hair24_f_L_04_deprecated'
        fronth207 = 'hair24_f_L_05'
        fronth208 = 'hair24_f_L_05_deprecated'
        fronth209 = 'hair24_f_L_06'
        fronth210 = 'hair24_f_L_06_deprecated'
        fronth211 = 'hair24_f_R_01'
        fronth212 = 'hair24_f_R_01_deprecated'
        fronth213 = 'hair24_f_R_02'
        fronth214 = 'hair24_f_R_02_deprecated'
        fronth215 = 'hair24_f_R_03'
        fronth216 = 'hair24_f_R_03_deprecated'
        fronth217 = 'hair24_f_R_04'
        fronth218 = 'hair24_f_R_04_deprecated'
        fronth219 = 'hair24_f_R_05'
        fronth220 = 'hair24_f_R_05_deprecated'
        fronth221 = 'hair24_f_R_06'
        fronth222 = 'hair24_f_R_06_deprecated'
        fronth223 = 'cf_O_hairfront_25_00'
        fronth224 = 'cf_O_hairfront_25_00_deprecated'
        fronth225 = 'cf_O_hairfront_25_01'
        fronth226 = 'cf_O_hairfront_25_01_deprecated'
        fronth227 = 'cf_O_hairfront_25_02'
        fronth228 = 'cf_O_hairfront_25_02_deprecated'
        fronth229 = 'cf_O_hairfront_25_03'
        fronth230 = 'cf_O_hairfront_25_03_deprecated'
        fronth231 = 'cf_O_hairfront_25_04'
        fronth232 = 'cf_O_hairfront_25_04_deprecated'
        fronth233 = 'cf_O_hairfront_25_05'
        fronth234 = 'cf_O_hairfront_25_05_deprecated'
        fronth235 = 'cf_O_hairfront_28_00'
        fronth236 = 'cf_O_hairfront_28_00_deprecated'
        fronth237 = 'cf_O_hairfront_28_01'
        fronth238 = 'cf_O_hairfront_28_01_deprecated'
        fronth239 = 'cf_O_hairfront_28_02'
        fronth240 = 'cf_O_hairfront_28_02_deprecated'
        fronth241 = 'cf_O_hairfront_28_03'
        fronth242 = 'cf_O_hairfront_28_03_deprecated'
        fronth243 = 'cf_O_hairfront_28_04'
        fronth244 = 'cf_O_hairfront_28_04_deprecated'
        fronth245 = 'cf_O_hairfront_28_05'
        fronth246 = 'cf_O_hairfront_28_05_deprecated'
        fronth247 = 'cf_O_hairfront_28_06'
        fronth248 = 'cf_O_hairfront_28_06_deprecated'
        fronth249 = 'cf_O_hairfront_29_00'
        fronth250 = 'cf_O_hairfront_29_00_deprecated'
        fronth251 = 'cf_O_hairfront_30_00'
        fronth252 = 'cf_O_hairfront_30_00_deprecated'
        fronth253 = 'cf_O_hairfront_30_01'
        fronth254 = 'cf_O_hairfront_30_01_deprecated'
        fronth255 = 'cf_O_hairfront_30_02'
        fronth256 = 'cf_O_hairfront_30_02_deprecated'
        fronth257 = 'cf_O_hairfront_30_03'
        fronth258 = 'cf_O_hairfront_30_03_deprecated'
        fronth259 = 'cf_O_hairfront_30_04'
        fronth260 = 'cf_O_hairfront_30_04_deprecated'
        fronth261 = 'FK06_O_00'
        fronth262 = 'FK10_O_00'
        fronth263 = 'A017_O_hairF00'
        fronth264 = 'A017_O_hairF01'
        fronth265 = 'A017_O_hairF02'
        fronth266 = 'A017_O_hairF03'
        fronth267 = 'A017_O_hairFL00'
        fronth268 = 'A017_O_hairFR00'
        fronth269 = 'A019_O_hairF00'
        fronth270 = 'A019_O_hairFL00'
        fronth271 = 'A019_O_hairFR00'
        fronth272 = 'A019_O_hairFR01'
        fronth273 = 'cf_O_hairfront_83_00'
        fronth274 = 'cf_O_hairfront_83_00_deprecated'
        fronth275 = 'cf_O_hairfront_83_01'
        fronth276 = 'cf_O_hairfront_83_01_deprecated'
        fronth277 = 'cf_O_hairfront_83_02'
        fronth278 = 'cf_O_hairfront_83_02_deprecated'
        fronth279 = 'cf_O_hairfront_83_03'
        fronth280 = 'cf_O_hairfront_83_03_deprecated'
        fronth281 = 'cf_O_hairfront_83_04'
        fronth282 = 'cf_O_hairfront_83_04_deprecated'
        fronth283 = 'cf_O_hairfront_83_05'
        fronth284 = 'cf_O_hairfront_83_05_deprecated'
        fronth285 = 'cf_O_hairfront_83_06'
        fronth286 = 'cf_O_hairfront_83_06_deprecated'
        fronth287 = 'cf_O_hairfront_83_07'
        fronth288 = 'cf_O_hairfront_83_07_deprecated'
        fronth289 = 'cf_O_hairfront_83_08'
        fronth290 = 'cf_O_hairfront_83_08_deprecated'
        fronth291 = 'cf_O_hairfront_83_09'
        fronth292 = 'cf_O_hairfront_83_09_deprecated'
        fronth293 = 'cf_O_hairfront_83_10'
        fronth294 = 'cf_O_hairfront_83_10_deprecated'
        fronth295 = 'cf_O_hairfront_83_11'
        fronth296 = 'cf_O_hairfront_83_11_deprecated'
        fronth297 = 'cf_O_hairfront_83_12'
        fronth298 = 'cf_O_hairfront_83_12_deprecated'
        fronth299 = 'O_hs_cf_hair_84_f_00'
        fronth300 = 'O_hs_cf_hair_84_f_00_deprecated'
        fronth301 = 'O_hs_cf_hair_84_f_01'
        fronth302 = 'O_hs_cf_hair_84_f_01_deprecated'
        fronth303 = 'O_hs_cf_hair_84_f_02'
        fronth304 = 'O_hs_cf_hair_84_f_02_deprecated'
        fronth305 = 'O_hs_cf_hair_84_f_03'
        fronth306 = 'O_hs_cf_hair_84_f_03_deprecated'
        fronth307 = 'O_hs_cf_hair_84_f_04'
        fronth308 = 'O_hs_cf_hair_84_f_04_deprecated'
        fronth309 = 'O_hs_cf_hair_84_f_05'
        fronth310 = 'O_hs_cf_hair_84_f_05_deprecated'
        fronth311 = 'O_hs_cf_hair_84_f_06'
        fronth312 = 'O_hs_cf_hair_84_f_06_deprecated'
        fronth313 = 'O_hs_cf_hair_84_f_07'
        fronth314 = 'O_hs_cf_hair_84_f_07_deprecated'
        fronth315 = 'O_hs_cf_hair_84_f_08'
        fronth316 = 'O_hs_cf_hair_84_f_08_deprecated'
        fronth317 = 'O_hs_cf_hair_84_f_09'
        fronth318 = 'O_hs_cf_hair_84_f_09_deprecated'
        fronth319 = 'O_hs_cf_hair_84_f_10'
        fronth320 = 'O_hs_cf_hair_84_f_10_deprecated'
        fronth321 = 'O_hs_cf_hair_85_f_00'
        fronth322 = 'O_hs_cf_hair_85_f_00_deprecated'
        fronth323 = 'O_hs_cf_hair_85_f_01'
        fronth324 = 'O_hs_cf_hair_85_f_01_deprecated'
        fronth325 = 'O_hs_cf_hair_85_f_03'
        fronth326 = 'O_hs_cf_hair_85_f_03_deprecated'
        fronth327 = 'O_hs_cf_hair_85_f_04'
        fronth328 = 'O_hs_cf_hair_85_f_04_deprecated'
        fronth329 = 'O_hs_cf_hair_85_f_09'
        fronth330 = 'O_hs_cf_hair_85_f_09_deprecated'
        fronth331 = 'O_hs_cf_hair_85_f_10'
        fronth332 = 'O_hs_cf_hair_85_f_10_deprecated'
        fronth333 = 'O_hs_cf_hair_85_f_11'
        fronth334 = 'O_hs_cf_hair_85_f_11_deprecated'
        fronth335 = 'O_hs_cf_hair_85_f_12'
        fronth336 = 'O_hs_cf_hair_85_f_12_deprecated'
        fronth337 = 'O_hs_cf_hair_85_f_13'
        fronth338 = 'O_hs_cf_hair_85_f_13_deprecated'
        fronth339 = 'O_hs_cf_hair_85_f_14'
        fronth340 = 'O_hs_cf_hair_85_f_14_deprecated'
        fronth341 = 'O_hs_cf_hair_85_f_15'
        fronth342 = 'O_hs_cf_hair_85_f_15_deprecated'
        fronth343 = 'cf_O_hairfront_25_00'
        fronth344 = 'cf_O_hairfront_25_00_deprecated'
        fronth345 = 'cf_O_hairfront_25_01'
        fronth346 = 'cf_O_hairfront_25_01_deprecated'
        fronth347 = 'cf_O_hairfront_25_02'
        fronth348 = 'cf_O_hairfront_25_02_deprecated'
        fronth349 = 'cf_O_hairfront_25_03'
        fronth350 = 'cf_O_hairfront_25_03_deprecated'
        fronth351 = 'cf_O_hairfront_25_04'
        fronth352 = 'cf_O_hairfront_25_04_deprecated'
        fronth353 = 'cf_O_hairfront_25_05'
        fronth354 = 'cf_O_hairfront_25_05_deprecated'
        fronth355 = 'cf_O_hairfront_25_06'
        fronth356 = 'cf_O_hairfront_25_06_deprecated'
        fronth357 = 'cf_O_hairfront_25_07'
        fronth358 = 'cf_O_hairfront_25_07_deprecated'
        fronth359 = 'cf_O_hairfront_25_08'
        fronth360 = 'cf_O_hairfront_25_08_deprecated'
        fronth361 = 'cf_O_hairfront_25_09'
        fronth362 = 'cf_O_hairfront_25_09_deprecated'
        fronth363 = 'cf_O_hairfront_25_10'
        fronth364 = 'cf_O_hairfront_25_10_deprecated'
        fronth365 = 'cf_O_hairfront_25_11'
        fronth366 = 'cf_O_hairfront_25_11_deprecated'
        fronth367 = 'cf_O_hairfront_89_01'
        fronth368 = 'cf_O_hairfront_89_01_deprecated'
        fronth369 = 'cf_O_hairfront_89_02'
        fronth370 = 'cf_O_hairfront_89_02_deprecated'
        fronth371 = 'cf_O_hairfront_89_03'
        fronth372 = 'cf_O_hairfront_89_03_deprecated'
        fronth373 = 'cf_O_hairfront_89_04'
        fronth374 = 'cf_O_hairfront_89_04_deprecated'
        fronth375 = 'cf_O_hairfront_89_05'
        fronth376 = 'cf_O_hairfront_89_05_deprecated'
        fronth377 = 'cf_O_hairfront_89_06'
        fronth378 = 'cf_O_hairfront_89_06_deprecated'
        fronth379 = 'cf_O_hairfront_89_07'
        fronth380 = 'cf_O_hairfront_89_07_deprecated'
        fronth381 = 'cf_O_hairfront_89_08'
        fronth382 = 'cf_O_hairfront_89_08_deprecated'
        fronth383 = 'cf_O_hairfront_89_09'
        fronth384 = 'cf_O_hairfront_89_09_deprecated'
        fronth385 = 'cf_O_hairfront_89_10'
        fronth386 = 'cf_O_hairfront_89_10_deprecated'
        fronth387 = 'cf_O_hairfront_89_11'
        fronth388 = 'cf_O_hairfront_89_11_deprecated'
        fronth389 = 'cf_O_hairfront_89_12'
        fronth390 = 'cf_O_hairfront_89_12_deprecated'
        fronth391 = 'cf_O_hairfront_91_01'
        fronth392 = 'cf_O_hairfront_91_01_deprecated'
        fronth393 = 'cf_O_hairfront_91_02'
        fronth394 = 'cf_O_hairfront_91_02_deprecated'
        fronth395 = 'cf_O_hairfront_91_03'
        fronth396 = 'cf_O_hairfront_91_03_deprecated'
        fronth397 = 'cf_O_hairfront_91_04'
        fronth398 = 'cf_O_hairfront_91_04_deprecated'
        fronth399 = 'cf_O_hairfront_91_05'
        fronth400 = 'cf_O_hairfront_91_05_deprecated'
        fronth401 = 'cf_O_hairfront_91_06'
        fronth402 = 'cf_O_hairfront_91_06_deprecated'
        fronth403 = 'cf_O_hairfront_91_07'
        fronth404 = 'cf_O_hairfront_91_07_deprecated'
        fronth405 = 'cf_O_hairfront_91_08'
        fronth406 = 'cf_O_hairfront_91_08_deprecated'
        fronth407 = 'cf_O_hairfront_91_09'
        fronth408 = 'cf_O_hairfront_91_09_deprecated'
        fronth409 = 'cf_O_hairfront_91_10'
        fronth410 = 'cf_O_hairfront_91_10_deprecated'
        fronth411 = 'cf_O_hairfront_91_11'
        fronth412 = 'cf_O_hairfront_91_11_deprecated'
        fronth413 = 'cf_O_hairfront_91_12'
        fronth414 = 'cf_O_hairfront_91_12_deprecated'
        fronth415 = 'cf_O_hairfront_91_13'
        fronth416 = 'cf_O_hairfront_91_13_deprecated'
        fronth417 = 'cf_O_hairfront_91_14'
        fronth418 = 'cf_O_hairfront_91_14_deprecated'
        fronth419 = 'cf_O_hairfront_91_15'
        fronth420 = 'cf_O_hairfront_91_15_deprecated'
        fronth421 = 'cf_O_hairfront_91_16'
        fronth422 = 'cf_O_hairfront_91_16_deprecated'
        fronth423 = 'cf_O_hairfront_92_01'
        fronth424 = 'cf_O_hairfront_92_01_deprecated'
        fronth425 = 'cf_O_hairfront_92_02'
        fronth426 = 'cf_O_hairfront_92_02_deprecated'
        fronth427 = 'cf_O_hairfront_92_03'
        fronth428 = 'cf_O_hairfront_92_03_deprecated'
        fronth429 = 'cf_O_hairfront_92_04'
        fronth430 = 'cf_O_hairfront_92_04_deprecated'
        fronth431 = 'cf_O_hairfront_92_05'
        fronth432 = 'cf_O_hairfront_92_05_deprecated'
        fronth433 = 'cf_O_hairfront_92_06'
        fronth434 = 'cf_O_hairfront_92_06_deprecated'
        fronth435 = 'cf_O_hairfront_92_07'
        fronth436 = 'cf_O_hairfront_92_07_deprecated'
        fronth437 = 'cf_O_hairfront_92_08'
        fronth438 = 'cf_O_hairfront_92_08_deprecated'
        fronth439 = 'cf_O_hairfront_92_09'
        fronth440 = 'cf_O_hairfront_92_09_deprecated'
        fronth441 = 'cf_O_hairfront_92_010'
        fronth442 = 'cf_O_hairfront_92_010_deprecated'
        fronth443 = 'cf_O_hairfront_92_011'
        fronth444 = 'cf_O_hairfront_92_011_deprecated'
        fronth445 = 'cf_O_hairfront_92_012'
        fronth446 = 'cf_O_hairfront_92_012_deprecated'
        fronth447 = 'cf_O_hairfront_94_00'
        fronth448 = 'cf_O_hairfront_94_00_deprecated'
        fronth449 = 'cf_O_hairfront_94_01'
        fronth450 = 'cf_O_hairfront_94_01_deprecated'
        fronth451 = 'cf_O_hairfront_94_02'
        fronth452 = 'cf_O_hairfront_94_02_deprecated'
        fronth453 = 'cf_O_hairfront_94_03'
        fronth454 = 'cf_O_hairfront_94_03_deprecated'
        fronth455 = 'cf_O_hairfront_94_04'
        fronth456 = 'cf_O_hairfront_94_04_deprecated'
        fronth457 = 'cf_O_hairfront_94_05'
        fronth458 = 'cf_O_hairfront_94_05_deprecated'
        fronth459 = 'cf_O_hairfront_94_06'
        fronth460 = 'cf_O_hairfront_94_06_deprecated'
        fronth461 = 'cf_O_hairfront_100_00'
        fronth462 = 'cf_O_hairfront_100_00_deprecated'
        fronth463 = 'cf_O_hairfront_100_01'
        fronth464 = 'cf_O_hairfront_100_01_deprecated'
        fronth465 = 'cf_O_hairfront_100_02'
        fronth466 = 'cf_O_hairfront_100_02_deprecated'
        fronth467 = 'cf_O_hairfront_100_03'
        fronth468 = 'cf_O_hairfront_100_03_deprecated'
        fronth469 = 'cf_O_hairfront_100_04'
        fronth470 = 'cf_O_hairfront_100_04_deprecated'
        fronth471 = 'cf_O_hairfront_100_05'
        fronth472 = 'cf_O_hairfront_100_05_deprecated'
        fronth473 = 'cf_O_hairfront_100_06'
        fronth474 = 'cf_O_hairfront_100_06_deprecated'
        fronth475 = 'cf_O_hairfront_100_07'
        fronth476 = 'cf_O_hairfront_100_07_deprecated'
        fronth477 = 'cf_O_hairfront_100_08'
        fronth478 = 'cf_O_hairfront_100_08_deprecated'
        fronth479 = 'cf_O_hairfront_100_09'
        fronth480 = 'cf_O_hairfront_100_09_deprecated'
        fronth481 = 'cf_O_hairfront_100_10'
        fronth482 = 'cf_O_hairfront_100_10_deprecated'
        fronth483 = 'cf_O_hairfront_100_11'
        fronth484 = 'cf_O_hairfront_100_11_deprecated'
        fronth485 = 'cf_O_hairfront_100_12'
        fronth486 = 'cf_O_hairfront_100_12_deprecated'
        fronth487 = 'cf_O_hairfront_100_13'
        fronth488 = 'cf_O_hairfront_100_13_deprecated'
        fronth489 = 'cf_O_hairfront_100_14'
        fronth490 = 'cf_O_hairfront_100_14_deprecated'
        fronth491 = 'cf_O_hairfront_100_15'
        fronth492 = 'cf_O_hairfront_100_15_deprecated'
        fronth493 = 'cf_O_hairfront_100_16'
        fronth494 = 'cf_O_hairfront_100_16_deprecated'
        fronth495 = 'cf_O_hairfront_100_17'
        fronth496 = 'cf_O_hairfront_100_17_deprecated'
        fronth497 = 'cf_O_hairfront_94_00'
        fronth498 = 'cf_O_hairfront_94_00_deprecated'
        fronth499 = 'cf_O_hairfront_94_01'
        fronth500 = 'cf_O_hairfront_94_01_deprecated'
        fronth501 = 'cf_O_hairfront_94_02'
        fronth502 = 'cf_O_hairfront_94_02_deprecated'
        fronth503 = 'cf_O_hairfront_94_03'
        fronth504 = 'cf_O_hairfront_94_03_deprecated'
        fronth505 = 'cf_O_hairfront_94_04'
        fronth506 = 'cf_O_hairfront_94_04_deprecated'
        fronth507 = 'cf_O_hairfront_94_05'
        fronth508 = 'cf_O_hairfront_94_05_deprecated'
        fronth509 = 'cf_O_hairfront_94_06'
        fronth510 = 'cf_O_hairfront_94_06_deprecated'
        fronth511 = 'cf_O_hairfront_94_07'
        fronth512 = 'cf_O_hairfront_94_07_deprecated'
        fronth513 = 'cf_O_hairfront_94_08'
        fronth514 = 'cf_O_hairfront_94_08_deprecated'
        fronth515 = 'cf_O_hairfront_94_09'
        fronth516 = 'cf_O_hairfront_94_09_deprecated'
        fronth517 = 'cf_O_hairfront_94_10'
        fronth518 = 'cf_O_hairfront_94_10_deprecated'
        fronth519 = 'cf_O_hairfront_94_11'
        fronth520 = 'cf_O_hairfront_94_11_deprecated'
        fronth521 = 'cf_O_hairfront_94_12'
        fronth522 = 'cf_O_hairfront_94_12_deprecated'
        fronth523 = 'cf_O_hairfront_94_13'
        fronth524 = 'cf_O_hairfront_94_13_deprecated'
        fronth525 = 'cf_O_hairside_94_00'
        fronth526 = 'cf_O_hairside_94_01'
        fronth527 = 'cf_O_hairside_94_02'
        fronth528 = 'cf_O_hairside_94_02_deprecated'
        fronth529 = 'cf_O_hairside_94_03'
        fronth530 = 'cf_O_hairside_94_03_deprecated'
        fronth531 = 'cf_O_hairfront_97_00'
        fronth532 = 'cf_O_hairfront_97_00_deprecated'
        fronth533 = 'cf_O_hairfront_97_01'
        fronth534 = 'cf_O_hairfront_97_01_deprecated'
        fronth535 = 'cf_O_hairfront_97_02'
        fronth536 = 'cf_O_hairfront_97_02_deprecated'
        fronth537 = 'cf_O_hairfront_97_03'
        fronth538 = 'cf_O_hairfront_97_03_deprecated'
        fronth539 = 'cf_O_hairfront_97_04'
        fronth540 = 'cf_O_hairfront_97_04_deprecated'
        fronth541 = 'cf_O_hairfront_97_05'
        fronth542 = 'cf_O_hairfront_97_05_deprecated'
        fronth543 = 'cf_O_hairfront_97_06'
        fronth544 = 'cf_O_hairfront_97_06_deprecated'
        fronth545 = 'cf_O_hairfront_97_07'
        fronth546 = 'cf_O_hairfront_97_07_deprecated'
        fronth547 = 'cf_O_hairfront_97_08'
        fronth548 = 'cf_O_hairfront_97_08_deprecated'
        fronth549 = 'cf_O_hairfront_97_09'
        fronth550 = 'cf_O_hairfront_97_09_deprecated'
        fronth551 = 'cf_O_hairfront_98_00'
        fronth552 = 'cf_O_hairfront_98_00_deprecated'
        fronth553 = 'cf_O_hairfront_98_01'
        fronth554 = 'cf_O_hairfront_98_01_deprecated'
        fronth555 = 'cf_O_hairfront_98_02'
        fronth556 = 'cf_O_hairfront_98_02_deprecated'
        fronth557 = 'cf_O_hairfront_98_03'
        fronth558 = 'cf_O_hairfront_98_03_deprecated'
        fronth559 = 'cf_O_hairfront_98_04'
        fronth560 = 'cf_O_hairfront_98_04_deprecated'
        fronth561 = 'cf_O_hairfront_98_05'
        fronth562 = 'cf_O_hairfront_98_05_deprecated'
        fronth563 = 'cf_O_hairfront_98_06'
        fronth564 = 'cf_O_hairfront_98_06_deprecated'
        fronth565 = 'cf_O_hairfront_98_07'
        fronth566 = 'cf_O_hairfront_98_07_deprecated'
        fronth567 = 'cf_O_hairfront_98_08'
        fronth568 = 'cf_O_hairfront_98_08_deprecated'
        fronth569 = 'cf_O_hairfront_98_09'
        fronth570 = 'cf_O_hairfront_98_09_deprecated'
        fronth571 = 'cf_O_hairfront_98_10'
        fronth572 = 'cf_O_hairfront_98_10_deprecated'
        fronth573 = 'cf_O_hairfront_98_11'
        fronth574 = 'cf_O_hairfront_98_11_deprecated'
        fronth575 = 'cf_O_hairfront_98_12'
        fronth576 = 'cf_O_hairfront_98_12_deprecated'
        fronth577 = 'cf_O_hairfront_98_13'
        fronth578 = 'cf_O_hairfront_98_13_deprecated'
        fronth579 = 'cf_O_hairfront_98_14'
        fronth580 = 'cf_O_hairfront_98_14_deprecated'
        fronth581 = 'cf_O_hairfront_99_00'
        fronth582 = 'cf_O_hairfront_99_00_deprecated'
        fronth583 = 'cf_O_hairfront_99_01'
        fronth584 = 'cf_O_hairfront_99_01_deprecated'
        fronth585 = 'cf_O_hairfront_99_02'
        fronth586 = 'cf_O_hairfront_99_02_deprecated'
        fronth587 = 'cf_O_hairfront_99_03'
        fronth588 = 'cf_O_hairfront_99_03_deprecated'
        fronth589 = 'cf_O_hairfront_99_04'
        fronth590 = 'cf_O_hairfront_99_04_deprecated'
        fronth591 = 'cf_O_hairfront_99_05'
        fronth592 = 'cf_O_hairfront_99_05_deprecated'
        fronth593 = 'cf_O_hairfront_99_06'
        fronth594 = 'cf_O_hairfront_99_06_deprecated'
        fronth595 = 'cf_O_hairfront_99_07'
        fronth596 = 'cf_O_hairfront_99_07_deprecated'
        fronth597 = 'cf_O_hairfront_99_08'
        fronth598 = 'cf_O_hairfront_99_08_deprecated'
        fronth599 = 'cf_O_hairfront_99_09'
        fronth600 = 'cf_O_hairfront_99_09_deprecated'
        fronth601 = 'cf_O_hairside_08_00'
        fronth602 = 'cf_O_hairside_08_00_deprecated'
        fronth603 = 'cf_O_hairside_12_00'
        fronth604 = 'cf_O_hairside_12_00_deprecated'
        fronth605 = 'cf_O_hairside_13_00'
        fronth606 = 'cf_O_hairside_13_00_deprecated'
        fronth607 = 'cf_O_hairside_14_00'
        fronth608 = 'cf_O_hairside_15_00'
        fronth609 = 'cf_O_hairside_15_00_deprecated'
        fronth610 = 'cf_O_hairside_16_00'
        fronth611 = 'cf_O_hairside_16_00_deprecated'
        fronth612 = 'bp_hair_00_00_L'
        fronth613 = 'bp_hair_00_00_R'
        fronth614 = 'bp_hair_00_01_L'
        fronth615 = 'bp_hair_00_01_R'
        # Back Hair
        backh1 = 'cf_O_hairback_01_01'
        backh2 = 'cf_O_hairback_01_02'
        backh3 = 'cf_O_hairback_01_03'
        backh4 = 'cf_O_hairback_02_01'
        backh5 = 'cf_O_hairback_02_02'
        backh6 = 'cf_O_hairback_03_00_DEMO'
        backh7 = 'cf_O_hairback_03_01_DEMO'
        backh8 = 'cf_O_hairback_03_02_DEMO'
        backh9 = 'cf_O_hairback_03_acs_DEMO'
        backh10 = 'cf_O_hairback_03_shadow_DEMO'
        backh11 = 'cf_O_hairback_03_00'
        backh12 = 'cf_O_hairback_03_01'
        backh13 = 'cf_O_hairback_03_02'
        backh14 = 'cf_O_hairback_03_acs'
        backh15 = 'cf_O_hairback_03_shadow'
        backh16 = 'cf_O_hairback_04_01a'
        backh17 = 'cf_O_hairback_04_01b'
        backh18 = 'cf_O_hairback_04_02'
        backh19 = 'cf_O_hairback_04_acs'
        backh20 = 'cf_O_hairback_04_shadow'
        backh21 = 'cf_O_hairback_05_01'
        backh22 = 'cf_O_hairback_05_02'
        backh23 = 'cf_O_hairback_05_03'
        backh24 = 'cf_O_hairback_06_01'
        backh25 = 'cf_O_hairback_06_02'
        backh26 = 'cf_O_hairback_06_03'
        backh27 = 'cf_O_hairback_06_04'
        backh28 = 'cf_O_hairback_07_01a'
        backh29 = 'cf_O_hairback_07_01b'
        backh30 = 'cf_O_hairback_07_acs'
        backh31 = 'cf_O_hairback_07_shadow'
        backh32 = 'cf_O_hairbackl_07_00'
        backh33 = 'cf_O_hairback_08_01a'
        backh34 = 'cf_O_hairback_08_01b'
        backh35 = 'cf_O_hairback_08_02'
        backh36 = 'cf_O_hairback_08_acs'
        backh37 = 'cf_O_hairback_08_shadow'
        backh38 = 'cf_o_hairback_09_01'
        backh39 = 'cf_O_hairback_09_02'
        backh40 = 'cf_O_hairback_10_01a'
        backh41 = 'cf_O_hairback_10_01b'
        backh42 = 'cf_O_hairback_10_02'
        backh43 = 'cf_O_hairback_11_01'
        backh44 = 'cf_O_hairback_11_02a'
        backh45 = 'cf_O_hairback_11_02b'
        backh46 = 'cf_O_hairback_11_acs'
        backh47 = 'cf_O_hairback_11_shadow'
        backh48 = 'cf_O_hairback_12_01'
        backh49 = 'cf_O_hairback_12_02'
        backh50 = 'cf_O_hairback_12_03'
        backh51 = 'cf_O_hairback_13_01a'
        backh52 = 'cf_O_hairback_13_01b'
        backh53 = 'cf_O_hairback_13_02'
        backh54 = 'cf_O_hairback_13_acs'
        backh55 = 'cf_O_hairback_13_shadow'
        backh56 = 'cf_O_hairback_14_01'
        backh57 = 'cf_O_hairback_14_02a'
        backh58 = 'cf_O_hairback_14_02b'
        backh59 = 'cf_O_hairback_14_acs'
        backh60 = 'cf_O_hairback_14_shadow'
        backh61 = 'cf_O_hairback_30_04'
        backh62 = 'cf_O_hairfront_30_01'
        backh63 = 'cf_O_hairfront_30_02'
        backh64 = 'cf_O_hairfront_30_03'
        backh65 = 'cf_O_hairback_31_01'
        backh66 = 'cf_O_hairback_31_02'
        backh67 = 'cf_O_hairback_32_01'
        backh68 = 'cf_O_hairback_32_02'
        backh69 = 'cf_O_hairback_33_01'
        backh70 = 'cf_O_hairback_33_02'
        backh71 = 'cf_O_hairback_33_03'
        backh72 = 'cf_O_hairback_33_acs'
        backh73 = 'cf_O_hairback_15_00a'
        backh74 = 'cf_O_hairback_15_00b'
        backh75 = 'cf_O_hairback_15_02'
        backh76 = 'cf_O_hairback_15_03'
        backh77 = 'cf_O_hairback_15_04'
        backh78 = 'cf_O_hairback_15_acs'
        backh79 = 'cf_O_hairback_34_00a'
        backh80 = 'cf_O_hairback_34_00b'
        backh81 = 'cf_O_hairback_34_01' #finished 00 and 05
        backh82 = 'cf_O_hairback_17_01'
        backh83 = 'cf_O_hairback_17_02a'
        backh84 = 'cf_O_hairback_17_02b'
        backh85 = 'cf_O_hairback_17_shadow'
        backh86 = 'cf_O_hairback_18_00'
        backh87 = 'cf_O_hairback_18_01'
        backh88 = 'cf_O_hairback_18_02'
        backh89 = 'cf_O_hairback_18_shadow' # 06
        backh90 = 'cf_O_hairback_20_00a'
        backh91 = 'cf_O_hairback_20_00b'
        backh92 = 'cf_O_hairback_20_01'
        backh93 = 'cf_O_hairback_20_02'
        backh94 = 'cf_O_hairback_20_03'
        backh95 = 'cf_O_hairback_20_04'
        backh96 = 'cf_O_hairback_20_acs'
        backh97 = 'cf_O_hairback_21_00a'
        backh98 = 'cf_O_hairback_21_00b'
        backh99 = 'cf_O_hairback_21_01'
        backh100 = 'cf_O_hairback_21_acs'
        backh101 = 'cf_O_hairback_21_shadow'
        backh102 = 'cf_O_hairback_19_00'
        backh103 = 'cm_O_hairback_19_00' # 07
        backh104 = 'cf_O_hairback_35_00'
        backh105 = 'cf_O_hairback_35_01'
        backh106 = 'cf_O_hairback_r_35_00'
        backh107 = 'cf_O_hairback_r_35_01' #acs 08
        backh108 = 'cf_O_hairback_16_00'
        backh109 = 'cf_O_hairback_16_01'
        backh110 = 'cf_O_hairback_16_acs' # 10
        backh111 = 'cf_O_hairback_36_00'
        backh112 = 'cf_O_hairback_36_01' # 13
        backh113 = 'cf_O_hairback_12_01'
        backh114 = 'cf_O_hairback_12_02'
        backh115 = 'cf_O_hairback_12_03'
        backh116 = 'cf_O_hairback_27_00'
        backh117 = 'cf_O_hairback_27_01'
        backh118 = 'cf_O_hairback_27_02'
        backh119 = 'cf_O_hairback_27_acs'
        backh120 = 'cf_O_hairback_27_shadow' # 14
        backh121 = 'cf_O_hairback_23_01'
        backh122 = 'cf_O_hairback_23_02'
        backh123 = 'cf_O_hairback_23_03'
        backh124 = 'cf_O_hairback_24_01'
        backh125 = 'cf_O_hairback_24_02'
        backh126 = 'cf_O_hairback_24_03'
        backh127 = 'cf_O_hairback_24_acs'
        backh128 = 'cf_O_hairback_25_00'
        backh129 = 'cf_O_hairback_25_01'
        backh130 = 'cf_O_hairback_25_02'
        backh131 = 'cf_O_hairback_26_00'
        backh132 = 'cf_O_hairback_26_01'
        backh133 = 'cf_O_hairback_26_02'
        backh134 = 'cf_O_hairback_28_00'
        backh135 = 'cf_O_hairback_28_02'
        backh136 = 'cf_O_hairback_28_acs'
        backh137 = 'cf_O_hairback_29_00'
        backh138 = 'cf_O_hairback_29_01'
        backh139 = 'cf_O_hairback_29_02'
        backh140 = 'cf_O_hairback_29_acs'
        backh141 = 'cf_O_hairback_37_00'
        backh142 = 'cf_O_hairback_37_01'
        backh143 = 'cf_O_hairback_37_02'
        backh144 = 'cf_O_hairback_38_00'
        backh145 = 'cf_O_hairback_38_01'
        backh146 = 'cf_O_hairback_38_02'
        backh147 = 'cf_O_hairback_38_03'
        backh148 = 'cf_O_hairback_38_acs'
        backh149 = 'cf_O_hairback_39_00'
        backh150 = 'cf_O_hairback_39_01'
        backh151 = 'cf_O_hairback_39_02'
        backh152 = 'cf_O_hairback_39_acs'
        backh153 = 'cf_O_hairback_22_00'
        backh154 = 'cf_O_hairback_22_01'
        backh155 = 'cf_O_hairback_22_02'
        backh156 = 'cm_O_hairback_39_00'
        backh157 = 'cm_O_hairback_39_01'
        backh158 = 'cm_O_hairback_39_02'
        backh159 = 'cm_O_hairback_39_acs'
        backh160 = 'cm_O_hairback_22_00'
        backh161 = 'cm_O_hairback_22_01'
        backh162 = 'cm_O_hairback_22_02' # 30
        backh163 = 'cf_O_hair_b_40_00'
        backh164 = 'cf_O_hair_b_40_01'
        backh165 = 'cf_O_hair_b_40_02'
        backh166 = 'cf_O_hair_b_40_03'
        backh167 = 'cf_O_hair_b_40_acs' # 34
        backh168 = 'cf_O_hairback_12_01'
        backh169 = 'cf_O_hairback_12_02'
        backh170 = 'cf_O_hairback_12_03' # 38
        backh171 = 'cf_O_hairback_41_00'
        backh172 = 'cf_O_hairback_41_01'
        backh173 = 'cf_O_hairback_41_02'
        backh174 = 'cf_O_hairback_41_03'
        backh175 = 'cf_O_hairback_42_00'
        backh176 = 'cf_O_hairback_42_01'
        backh177 = 'cf_O_hairback_42_02'
        backh178 = 'cf_O_hairback_42_03'
        backh179 = 'cf_O_hairback_42_04'
        backh180 = 'cf_O_hairback_42_acs' # 40
        backh181 = 'cf_O_hairback_43_00'
        backh182 = 'cf_O_hairback_43_01'
        backh183 = 'cf_O_hairback_43_02'
        backh184 = 'cf_O_hairback_43_03' # 41
        backh185 = 'cf_O_hairback_44_00'
        backh186 = 'cf_O_hairback_44_01'
        backh187 = 'cf_O_hairback_44_02'
        backh188 = 'cf_O_hairback_44_03'
        backh189 = 'cf_O_hairback_45_00'
        backh190 = 'cf_O_hairback_45_01'
        backh191 = 'cf_O_hairback_45_02'
        backh192 = 'cf_O_hairback_45_acs'
        backh193 = 'cf_O_hairback_46_00'
        backh194 = 'cf_O_hairback_46_01'
        backh195 = 'cf_O_hairback_46_02'
        backh196 = 'cf_O_hairback_46_acs'
        backh197 = 'cf_O_hairback_47_00'
        backh198 = 'cf_O_hairback_47_01'
        backh199 = 'cf_O_hairback_47_02'
        backh200 = 'cf_O_hairback_47_03'
        backh201 = 'cf_O_hairback_47_acs'
        backh202 = 'cf_O_hairback_48_00'
        backh203 = 'cf_O_hairback_48_01'
        backh204 = 'cf_O_hairback_48_02'
        backh205 = 'cf_O_hairback_48_acs' # 50
        backh206 = 'cf_O_hairpony21_04_deprecated'
        backh207 = 'cf_O_hairpony21_05'
        backh208 = 'cf_O_hairpony21_05_deprecated'
        backh209 = 'cf_O_hairpony21_06'
        backh210 = 'cf_O_hairpony21_06_deprecated'
        backh211 = 'cf_O_hairpony21_07'
        backh212 = 'cf_O_hairpony21_07_deprecated'
        backh213 = 'cf_O_hairpony21_08'
        backh214 = 'cf_O_hairpony21_08_deprecated'
        backh215 = 'cf_O_hairpony21_09'
        backh216 = 'cf_O_hairpony21_09_deprecated'
        backh217 = 'cf_O_hairback_22_01'
        backh218 = 'cf_O_hairback_22_01_deprecated'
        backh219 = 'cf_O_hairback_22_02'
        backh220 = 'cf_O_hairback_22_02_deprecated'
        backh221 = 'cf_O_hairback_22_03'
        backh222 = 'cf_O_hairkiwa_b13_01'
        backh223 = 'cf_O_hairkiwa_b22_01'
        backh224 = 'cf_O_hairkiwa_b22_01_deprecated'
        backh225 = 'cf_O_hairback_23_00'
        backh226 = 'cf_O_hairback_23_01'
        backh227 = 'cf_O_hairback_23_02'
        backh228 = 'cf_O_hairback_23_03'
        backh229 = 'cf_O_hairback_23_04'
        backh230 = 'cf_O_hairtail_23_00'
        backh231 = 'cf_O_hairtail_23_00_deprecated'
        backh232 = 'cf_O_hairtail_23_01'
        backh233 = 'cf_O_hairtail_23_01_deprecated'
        backh234 = 'cf_O_hairback_25_01'
        backh235 = 'cf_O_hairback_25_01_deprecated'
        backh236 = 'cf_O_hairback_25_02'
        backh237 = 'cf_O_hairback_25_03'
        backh238 = 'cf_O_hairback_25_04'
        backh239 = 'cf_O_hairback_26_00'
        backh240 = 'cf_O_hairback_26_00_deprecated'
        backh241 = 'cf_O_hairback_26_01'
        backh242 = 'cf_O_hairback_26_01_deprecated'
        backh243 = 'cf_O_hairback_26_02'
        backh244 = 'cf_O_hairback_26_02_deprecated'
        backh245 = 'cf_O_hairback_26_03'
        backh246 = 'cf_O_hairback_26_03_deprecated'
        backh247 = 'cf_O_hairpon_26_00'
        backh248 = 'cf_O_hairpon_26_01'
        backh249 = 'cf_O_hairpon_26_01_deprecated'
        backh250 = 'cf_O_hairpon_26_02'
        backh251 = 'cf_O_hairpon_26_02_deprecated'
        backh252 = 'cf_O_hairpon_26_03'
        backh253 = 'cf_O_hairpon_26_03_deprecated'
        backh254 = 'cf_O_hairpon_26_04'
        backh255 = 'cf_O_hairpon_26_04_deprecated'
        backh256 = 'cf_O_hairpon_26_05'
        backh257 = 'cf_O_hairpon_26_05_deprecated'
        backh258 = 'cf_O_hairpon_26_06'
        backh259 = 'cf_O_hairpon_26_06_deprecated'
        backh260 = 'cf_O_hairpon_26_07'
        backh261 = 'cf_O_hairpon_26_07_deprecated'
        backh262 = 'cf_O_hairback_27_00'
        backh263 = 'cf_O_hairback_27_00_deprecated'
        backh264 = 'cf_O_hairback_27_01'
        backh265 = 'cf_O_hairback_27_01_deprecated'
        backh266 = 'cf_O_hairback_27_02'
        backh267 = 'cf_O_hairback_27_02_deprecated'
        backh268 = 'cf_O_hairback_27_03'
        backh269 = 'cf_O_hairback_27_03_deprecated'
        backh270 = 'cf_O_hairback_27_04'
        backh271 = 'cf_O_hairback_27_04_deprecated'
        backh272 = 'cf_O_hairback_27_05'
        backh273 = 'cf_O_hairback_27_05_deprecated'
        backh274 = 'cf_O_hairback_27_06'
        backh275 = 'cf_O_hairback_27_06_deprecated'
        backh276 = 'cf_O_hairback_28_00'
        backh277 = 'cf_O_hairback_28_01'
        backh278 = 'cf_O_hairback_28_02'
        backh279 = 'cf_O_hairback_28_03'
        backh280 = 'cf_O_hairback_28_03_deprecated'
        backh281 = 'cf_O_hairback_29_00'
        backh282 = 'cf_O_hairback_29_00_deprecated'
        backh283 = 'cf_O_hairback_29_01'
        backh284 = 'cf_O_hairback_29_01_deprecated'
        backh285 = 'cf_O_hairback_29_02'
        backh286 = 'cf_O_hairback_29_02_deprecated'
        backh287 = 'cf_O_hairback_29_03'
        backh288 = 'cf_O_hairback_29_03_deprecated'
        backh289 = 'cf_O_hairback_30_00'
        backh290 = 'cf_O_hairback_30_00_deprecated'
        backh291 = 'cf_O_hairback_30_01'
        backh292 = 'cf_O_hairback_30_02'
        backh293 = 'cf_O_hairbL_30_00'
        backh294 = 'cf_O_hairbL_30_00_deprecated'
        backh295 = 'cf_O_hairbL_30_01'
        backh296 = 'cf_O_hairbL_30_01_deprecated'
        backh297 = 'cf_O_hairbL_30_02'
        backh298 = 'cf_O_hairbL_30_02_deprecated'
        backh299 = 'cf_O_hairbL_30_03'
        backh300 = 'cf_O_hairbL_30_03_deprecated'
        backh301 = 'cf_O_hairbR_30_00'
        backh302 = 'cf_O_hairbR_30_00_deprecated'
        backh303 = 'cf_O_hairbR_30_01'
        backh304 = 'cf_O_hairbR_30_01_deprecated'
        backh305 = 'cf_O_hairbR_30_02'
        backh306 = 'cf_O_hairbR_30_02_deprecated'
        backh307 = 'cf_O_hairbR_30_03'
        backh308 = 'cf_O_hairbR_30_03_deprecated'
        backh309 = 'A003_O_hairBCL00'
        backh310 = 'A003_O_hairBCL00_deprecated'
        backh311 = 'A003_O_hairBCR00'
        backh312 = 'A003_O_hairBCR00_deprecated'
        backh313 = 'A003_O_hairBL00'
        backh314 = 'A003_O_hairBL00_deprecated'
        backh315 = 'A003_O_hairBR00'
        backh316 = 'A003_O_hairBR00_deprecated'
        backh317 = 'A015_O_hairBC00'
        backh318 = 'A015_O_hairBC01'
        backh319 = 'A015_O_hairBC01 1'
        backh320 = 'A006_O_hairBC00'
        backh321 = 'A006_O_hairBC00_deprecated'
        backh322 = 'A006_O_hairBC01'
        backh323 = 'A006_O_hairBC02'
        backh324 = 'A006_O_hairBL00'
        backh325 = 'A006_O_hairBL00_deprecated'
        backh326 = 'A006_O_hairBR00'
        backh327 = 'A006_O_hairBR00_deprecated'
        backh328 = 'A025_O_hairBC00'
        backh329 = 'A025_O_hairBC00_deprecated'
        backh330 = 'A025_O_hairBC01'
        backh331 = 'A025_O_hairBC02'
        backh332 = 'A025_O_hairBL00'
        backh333 = 'A025_O_hairBL00_deprecated'
        backh334 = 'A025_O_hairBR00'
        backh335 = 'A025_O_hairBR00_deprecated'
        backh336 = 'A016_O_hairBC00'
        backh337 = 'A016_O_hairBC01'
        backh338 = 'A016_O_hairBC02'
        backh339 = 'A016_O_hairBRL00'
        backh340 = 'A016_O_hairBRL01'
        backh341 = 'A032_O_hairBC00'
        backh342 = 'A032_O_hairBC01'
        backh343 = 'A032_O_hairBC02'
        backh344 = 'A032_O_hairBRL00'
        backh345 = 'cf_O_hairback_82_00'
        backh346 = 'cf_O_hairback_82_01'
        backh347 = 'cf_O_hairback_82_01_deprecated'
        backh348 = 'cf_O_hairback_82_02'
        backh349 = 'cf_O_hairback_82_02_deprecated'
        backh350 = 'cf_O_hairback_82_03'
        backh351 = 'cf_O_hairback_82_03_deprecated'
        backh352 = 'cf_O_hairback_82_04'
        backh353 = 'cf_O_hairback_82_04_deprecated'
        backh354 = 'cf_O_hairback_82_05'
        backh355 = 'cf_O_hairback_82_05_deprecated'
        backh356 = 'cf_O_hairback_82_06'
        backh357 = 'cf_O_hairback_82_06_deprecated'
        backh358 = 'cf_O_hairback_82_07'
        backh359 = 'cf_O_hairback_82_07_deprecated'
        backh360 = 'cf_O_hairback_83_00'
        backh361 = 'cf_O_hairback_83_01'
        backh362 = 'cf_O_hairback_83_02'
        backh363 = 'cf_O_hairback_83_02_deprecated'
        backh364 = 'cf_O_hairback_83_03'
        backh365 = 'cf_O_hairback_83_03_deprecated'
        backh366 = 'cf_O_hairback_83_04'
        backh367 = 'cf_O_hairback_83_04_deprecated'
        backh368 = 'cf_O_hairback_83_05'
        backh369 = 'cf_O_hairback_83_05_deprecated'
        backh370 = 'cf_O_hairback_83_06'
        backh371 = 'cf_O_hairback_83_06_deprecated'
        backh372 = 'cf_O_hairback_83_07'
        backh373 = 'cf_O_hairback_83_07_deprecated'
        backh374 = 'cf_O_hairback_83_08'
        backh375 = 'cf_O_hairback_83_08_deprecated'
        backh376 = 'cf_O_hairback_83_09'
        backh377 = 'cf_O_hairback_83_09_deprecated'
        backh378 = 'cf_O_hairback_83_10'
        backh379 = 'cf_O_hairback_83_10_deprecated'
        backh380 = 'cf_O_hairback_83_11'
        backh381 = 'cf_O_hairback_83_11_deprecated'
        backh382 = 'cf_O_hairback_83_12'
        backh383 = 'cf_O_hairback_83_12_deprecated'
        backh384 = 'cf_O_hairback_83_13'
        backh385 = 'cf_O_hairback_83_13_deprecated'
        backh386 = 'cf_O_hairback_83_14'
        backh387 = 'cf_O_hairback_83_14_deprecated'
        backh388 = 'cf_O_hairback_83_15'
        backh389 = 'cf_O_hairback_83_15_deprecated'
        backh390 = 'cf_O_hairback_83_16'
        backh391 = 'cf_O_hairback_83_16_deprecated'
        backh392 = 'cf_O_hairback_83_17'
        backh393 = 'cf_O_hairback_83_17_deprecated'
        backh394 = 'cf_O_hairback_83_18'
        backh395 = 'cf_O_hairback_83_18_deprecated'
        backh396 = 'cf_O_hairback_83_19'
        backh397 = 'cf_O_hairback_83_19_deprecated'
        backh398 = 'cf_O_hairback_83_21'
        backh399 = 'cf_O_hairback_83_21_deprecated'
        backh400 = 'cf_O_hairback_83_22'
        backh401 = 'O_hs_cf_hair_84_b_00'
        backh402 = 'O_hs_cf_hair_84_b_00_deprecated'
        backh403 = 'O_hs_cf_hair_84_b_02'
        backh404 = 'O_hs_cf_hair_84_b_02_deprecated'
        backh405 = 'O_hs_cf_hair_84_b_03'
        backh406 = 'O_hs_cf_hair_84_b_03_deprecated'
        backh407 = 'O_hs_cf_hair_84_b_04'
        backh408 = 'O_hs_cf_hair_84_b_04_deprecated'
        backh409 = 'O_hs_cf_hair_84_b_05'
        backh410 = 'O_hs_cf_hair_84_b_05_deprecated'
        backh411 = 'O_hs_cf_hair_84_b_06'
        backh412 = 'O_hs_cf_hair_84_b_06_deprecated'
        backh413 = 'O_hs_cf_hair_84_b_07'
        backh414 = 'O_hs_cf_hair_84_b_07_deprecated'
        backh415 = 'O_hs_cf_hair_84_b_08'
        backh416 = 'O_hs_cf_hair_84_b_08_deprecated'
        backh417 = 'O_hs_cf_hair_84_b_09'
        backh418 = 'O_hs_cf_hair_84_b_09_deprecated'
        backh419 = 'O_hs_cf_hair_84_b_10'
        backh420 = 'O_hs_cf_hair_84_b_10_deprecated'
        backh421 = 'O_hs_cf_hair_84_b_11'
        backh422 = 'O_hs_cf_hair_84_b_11_deprecated'
        backh423 = 'O_hs_cf_hair_84_b_12'
        backh424 = 'O_hs_cf_hair_84_b_12_deprecated'
        backh425 = 'O_hs_cf_hair_84_b_13'
        backh426 = 'O_hs_cf_hair_84_b_13_deprecated'
        backh427 = 'O_hs_cf_hair_84_b_14'
        backh428 = 'O_hs_cf_hair_84_b_14_deprecated'
        backh429 = 'O_hs_cf_hair_84_b_15'
        backh430 = 'O_hs_cf_hair_84_b_15_deprecated'
        backh431 = 'O_hs_cf_hair_84_b_16'
        backh432 = 'O_hs_cf_hair_84_b_16_deprecated'
        backh433 = 'O_hs_cf_hair_84_b_17'
        backh434 = 'O_hs_cf_hair_84_b_17_deprecated'
        backh435 = 'O_hs_cf_hair_84_b_18'
        backh436 = 'O_hs_cf_hair_84_b_18_deprecated'
        backh437 = 'O_hs_cf_hair_84_b_19'
        backh438 = 'O_hs_cf_hair_84_b_19_deprecated'
        backh439 = 'O_hs_cf_hair_84_b_20'
        backh440 = 'O_hs_cf_hair_84_b_20_deprecated'
        backh441 = 'O_hs_cf_hair_84_b_21'
        backh442 = 'O_hs_cf_hair_84_b_21_deprecated'
        backh443 = 'O_hs_cf_hair_85_b_00'
        backh444 = 'O_hs_cf_hair_85_b_00_deprecated'
        backh445 = 'O_hs_cf_hair_85_b_02'
        backh446 = 'O_hs_cf_hair_85_b_02_deprecated'
        backh447 = 'O_hs_cf_hair_85_b_03'
        backh448 = 'O_hs_cf_hair_85_b_03_deprecated'
        backh449 = 'O_hs_cf_hair_85_b_04'
        backh450 = 'O_hs_cf_hair_85_b_04_deprecated'
        backh451 = 'O_hs_cf_hair_85_b_05'
        backh452 = 'O_hs_cf_hair_85_b_05_deprecated'
        backh453 = 'O_hs_cf_hair_85_b_06'
        backh454 = 'O_hs_cf_hair_85_b_06_deprecated'
        backh455 = 'O_hs_cf_hair_85_b_07'
        backh456 = 'O_hs_cf_hair_85_b_07_deprecated'
        backh457 = 'O_hs_cf_hair_85_b_08'
        backh458 = 'O_hs_cf_hair_85_b_08_deprecated'
        backh459 = 'O_hs_cf_hair_85_b_09'
        backh460 = 'O_hs_cf_hair_85_b_09_deprecated'
        backh461 = 'O_hs_cf_hair_85_b_10'
        backh462 = 'O_hs_cf_hair_85_b_10_deprecated'
        backh463 = 'O_hs_cf_hair_85_b_11'
        backh464 = 'O_hs_cf_hair_85_b_11_deprecated'
        backh465 = 'O_hs_cf_hair_85_b_12'
        backh466 = 'O_hs_cf_hair_85_b_12_deprecated'
        backh467 = 'O_hs_cf_hair_85_b_13'
        backh468 = 'O_hs_cf_hair_85_b_13_deprecated'
        backh469 = 'O_hs_cf_hair_85_b_14'
        backh470 = 'O_hs_cf_hair_85_b_14_deprecated'
        backh471 = 'O_hs_cf_hair_85_b_15'
        backh472 = 'O_hs_cf_hair_85_b_15_deprecated'
        backh473 = 'O_hs_cf_hair_85_b_16'
        backh474 = 'O_hs_cf_hair_85_b_16_deprecated'
        backh475 = 'O_hs_cf_hair_85_b_17'
        backh476 = 'O_hs_cf_hair_85_b_17_deprecated'
        backh477 = 'O_hs_cf_hair_85_b_18'
        backh478 = 'O_hs_cf_hair_85_b_18_deprecated'
        backh479 = 'O_hs_cf_hair_85_b_19'
        backh480 = 'O_hs_cf_hair_85_b_19_deprecated'
        backh481 = 'O_hs_cf_hair_85_b_20'
        backh482 = 'O_hs_cf_hair_85_b_20_deprecated'
        backh483 = 'O_hs_cf_hair_85_b_21'
        backh484 = 'O_hs_cf_hair_85_b_21_deprecated'
        backh485 = 'cf_O_hairback_86_01'
        backh486 = 'cf_O_hairback_86_01_deprecated'
        backh487 = 'cf_O_hairback_86_eri'
        backh488 = 'cf_O_hairback_86_eri_deprecated'
        backh489 = 'cf_O_hairback_86_kiwa'
        backh490 = 'cf_O_hairback_86_kiwa_deprecated'
        backh491 = 'cf_O_hairback_86_L'
        backh492 = 'cf_O_hairback_86_L_02'
        backh493 = 'cf_O_hairback_86_L_02_deprecated'
        backh494 = 'cf_O_hairback_86_L_03'
        backh495 = 'cf_O_hairback_86_L_03_deprecated'
        backh496 = 'cf_O_hairback_86_L_deprecated'
        backh497 = 'cf_O_hairback_86_mom_L'
        backh498 = 'cf_O_hairback_86_mom_L_deprecated'
        backh499 = 'cf_O_hairback_86_mom_R'
        backh500 = 'cf_O_hairback_86_mom_R_deprecated'
        backh501 = 'cf_O_hairback_86_R'
        backh502 = 'cf_O_hairback_86_R_02'
        backh503 = 'cf_O_hairback_86_R_02_deprecated'
        backh504 = 'cf_O_hairback_86_R_03'
        backh505 = 'cf_O_hairback_86_R_03_deprecated'
        backh506 = 'cf_O_hairback_86_R_deprecated'
        backh507 = 'O_hs_cf_hair_88_b_00'
        backh508 = 'O_hs_cf_hair_88_b_00_deprecated'
        backh509 = 'O_hs_cf_hair_88_b_01'
        backh510 = 'O_hs_cf_hair_88_b_01_deprecated'
        backh511 = 'O_hs_cf_hair_88_b_02'
        backh512 = 'O_hs_cf_hair_88_b_02_deprecated'
        backh513 = 'O_hs_cf_hair_88_b_03'
        backh514 = 'O_hs_cf_hair_88_b_03_deprecated'
        backh515 = 'O_hs_cf_hair_88_b_05'
        backh516 = 'O_hs_cf_hair_88_b_05_deprecated'
        backh517 = 'O_hs_cf_hair_88_b_06'
        backh518 = 'O_hs_cf_hair_88_b_06_deprecated'
        backh519 = 'O_hs_cf_hair_88_b_07'
        backh520 = 'O_hs_cf_hair_88_b_07_deprecated'
        backh521 = 'O_hs_cf_hair_88_b_08'
        backh522 = 'O_hs_cf_hair_88_b_08_deprecated'
        backh523 = 'O_hs_cf_hair_88_b_09'
        backh524 = 'O_hs_cf_hair_88_b_09_deprecated'
        backh525 = 'O_hs_cf_hair_88_b_10'
        backh526 = 'O_hs_cf_hair_88_b_10_deprecated'
        backh527 = 'O_hs_cf_hair_88_b_11'
        backh528 = 'O_hs_cf_hair_88_b_11_deprecated'
        backh529 = 'O_hs_cf_hair_88_b_12'
        backh530 = 'O_hs_cf_hair_88_b_12_deprecated'
        backh531 = 'O_hs_cf_hair_88_b_13'
        backh532 = 'O_hs_cf_hair_88_b_13_deprecated'
        backh533 = 'cf_O_hairback_89_01'
        backh534 = 'cf_O_hairback_89_01_deprecated'
        backh535 = 'cf_O_hairback_89_02'
        backh536 = 'cf_O_hairback_89_02_deprecated'
        backh537 = 'cf_O_hairback_89_03'
        backh538 = 'cf_O_hairback_89_03_deprecated'
        backh539 = 'cf_O_hairpony_89_01'
        backh540 = 'cf_O_hairpony_89_02'
        backh541 = 'cf_O_hairpony_89_02_deprecated'
        backh542 = 'cf_O_hairpony_89_03'
        backh543 = 'cf_O_hairpony_89_03_deprecated'
        backh544 = 'cf_O_hairpony_89_04'
        backh545 = 'cf_O_hairpony_89_04_deprecated'
        backh546 = 'cf_O_hairpony_89_05'
        backh547 = 'cf_O_hairpony_89_05_deprecated'
        backh548 = 'cf_O_hairpony_89_06'
        backh549 = 'cf_O_hairpony_89_06_deprecated'
        backh550 = 'cf_O_hairpony_89_07'
        backh551 = 'cf_O_hairpony_89_07_deprecated'
        backh552 = 'cf_O_hairpony_89_08'
        backh553 = 'cf_O_hairpony_89_08_deprecated'
        backh554 = 'cf_O_hairpony_89_09'
        backh555 = 'cf_O_hairpony_89_09_deprecated'
        backh556 = 'cf_O_hairpony_89_10'
        backh557 = 'cf_O_hairpony_89_10_deprecated'
        backh558 = 'cf_O_hairpony_89_11'
        backh559 = 'cf_O_hairpony_89_11_deprecated'
        backh560 = 'cf_O_hairpony_89_12'
        backh561 = 'cf_O_hairpony_89_12_deprecated'
        backh562 = 'cf_O_hairpony_89_13'
        backh563 = 'cf_O_hairpony_89_13_deprecated'
        backh564 = 'cf_O_hairpony_89_14'
        backh565 = 'cf_O_hairpony_89_14_deprecated'
        backh566 = 'cf_O_hairpony_89_15'
        backh567 = 'cf_O_hairpony_89_15_deprecated'
        backh568 = 'cf_O_hairpony_89_16'
        backh569 = 'cf_O_hairpony_89_16_deprecated'
        backh570 = 'cf_O_hairpony_89_17'
        backh571 = 'cf_O_hairpony_89_17_deprecated'
        backh572 = 'cf_O_hairpony_89_18'
        backh573 = 'cf_O_hairpony_89_18_deprecated'
        backh574 = 'cf_O_hairpony_89_19'
        backh575 = 'cf_O_hairpony_89_19_deprecated'
        backh576 = 'cf_O_hairpony_89_20'
        backh577 = 'cf_O_hairpony_89_20_deprecated'
        backh578 = 'cf_O_hairpony_89_21'
        backh579 = 'cf_O_hairpony_89_21_deprecated'
        backh580 = 'cf_O_hairpony_89_22'
        backh581 = 'cf_O_hairpony_89_22_deprecated'
        backh582 = 'cf_O_hairbase'
        backh583 = 'cf_O_hairback_91_01'
        backh584 = 'cf_O_hairback_91_01_deprecated'
        backh585 = 'cf_O_hairback_91_02'
        backh586 = 'cf_O_hairback_91_02_deprecated'
        backh587 = 'cf_O_hairback_91_03'
        backh588 = 'cf_O_hairback_91_03_deprecated'
        backh589 = 'cf_O_hairback_91_04'
        backh590 = 'cf_O_hairback_91_05'
        backh591 = 'cf_O_hairback_91_06'
        backh592 = 'cf_O_hairback_91_07'
        backh593 = 'cf_O_hairback_92_01'
        backh594 = 'cf_O_hairback_92_01_deprecated'
        backh595 = 'cf_O_hairback_92_02'
        backh596 = 'cf_O_hairback_92_02_deprecated'
        backh597 = 'cf_O_hairback_92_03'
        backh598 = 'cf_O_hairback_92_03_deprecated'
        backh599 = 'cf_O_hairback_92_04'
        backh600 = 'cf_O_hairback_92_04_deprecated'
        backh601 = 'cf_O_hairback_92_05'
        backh602 = 'cf_O_hairback_92_05_deprecated'
        backh603 = 'cf_O_hairback_92_06'
        backh604 = 'cf_O_hairback_92_06_deprecated'
        backh605 = 'cf_O_hairback_92_07'
        backh606 = 'cf_O_hairback_92_07_deprecated'
        backh607 = 'cf_O_hairback_92_08'
        backh608 = 'cf_O_hairback_92_08_deprecated'
        backh609 = 'cf_O_hairback_92_tail_L'
        backh610 = 'cf_O_hairback_92_tail_R'
        backh611 = 'cf_O_hairback_93_01'
        backh612 = 'cf_O_hairback_93_01_deprecated'
        backh613 = 'cf_O_hairback_93_02'
        backh614 = 'cf_O_hairback_93_02_deprecated'
        backh615 = 'cf_O_hairbL_93_01'
        backh616 = 'cf_O_hairbL_93_01_deprecated'
        backh617 = 'cf_O_hairbL_93_010'
        backh618 = 'cf_O_hairbL_93_010_deprecated'
        backh619 = 'cf_O_hairbL_93_02'
        backh620 = 'cf_O_hairbL_93_02_deprecated'
        backh621 = 'cf_O_hairbL_93_03'
        backh622 = 'cf_O_hairbL_93_03_deprecated'
        backh623 = 'cf_O_hairbL_93_04'
        backh624 = 'cf_O_hairbL_93_04_deprecated'
        backh625 = 'cf_O_hairbL_93_05'
        backh626 = 'cf_O_hairbL_93_05_deprecated'
        backh627 = 'cf_O_hairbL_93_06'
        backh628 = 'cf_O_hairbL_93_06_deprecated'
        backh629 = 'cf_O_hairbL_93_07'
        backh630 = 'cf_O_hairbL_93_07_deprecated'
        backh631 = 'cf_O_hairbL_93_08'
        backh632 = 'cf_O_hairbL_93_08_deprecated'
        backh633 = 'cf_O_hairbL_93_09'
        backh634 = 'cf_O_hairbL_93_09_deprecated'
        backh635 = 'cf_O_hairbR_93_01'
        backh636 = 'cf_O_hairbR_93_01_deprecated'
        backh637 = 'cf_O_hairbR_93_02'
        backh638 = 'cf_O_hairbR_93_02_deprecated'
        backh639 = 'cf_O_hairbR_93_03'
        backh640 = 'cf_O_hairbR_93_03_deprecated'
        backh641 = 'cf_O_hairbR_93_04'
        backh642 = 'cf_O_hairbR_93_04_deprecated'
        backh643 = 'cf_O_hairbR_93_05'
        backh644 = 'cf_O_hairbR_93_05_deprecated'
        backh645 = 'cf_O_hairbR_93_06'
        backh646 = 'cf_O_hairbR_93_06_deprecated'
        backh647 = 'cf_O_hairbR_93_07'
        backh648 = 'cf_O_hairbR_93_07_deprecated'
        backh649 = 'cf_O_hairback_95_01'
        backh650 = 'cf_O_hairback_95_01_deprecated'
        backh651 = 'cf_O_hairback_95_02'
        backh652 = 'cf_O_hairback_95_02_deprecated'
        backh653 = 'cf_O_hairback_95_03'
        backh654 = 'cf_O_hairback_95_03_deprecated'
        backh655 = 'cf_O_hairback_95_04'
        backh656 = 'cf_O_hairback_95_05'
        backh657 = 'cf_O_hairback_95_06'
        backh658 = 'cf_O_hairback_95_07'
        backh659 = 'o_hairB_0'
        backh660 = 'o_hairB_1'
        backh661 = 'o_hairB_2'
        backh662 = 'o_hairB_6'
        backh663 = 'o_hairB_7'
        backh664 = 'o_hairB_8'
        backh665 = 'o_hairB_t_1'
        backh666 = 'o_hairB_t_2'
        backh667 = 'o_hairB_t_3'
        backh668 = 'o_hairB_t_4'
        backh669 = 'o_hairB_t_5'
        backh670 = 'o_u_hairB_1'
        backh671 = 'o_u_hairB_2'
        backh672 = 'o_u_hairB_6'
        backh673 = 'o_u_hairB_7'
        backh674 = 'o_u_hairB_8'
        backh675 = 'o_u_hairB_t_1'
        backh676 = 'o_u_hairB_t_2'
        backh677 = 'o_u_hairB_t_3'
        backh678 = 'o_u_hairB_t_4'
        backh679 = 'o_u_hairB_t_5'
        backh680 = 'cf_O_dango_01'
        backh681 = 'cf_O_dango_02'
        backh682 = 'cf_O_dango_02_deprecated'
        backh683 = 'cf_O_dango_03'
        backh684 = 'cf_O_dango_03_deprecated'
        backh685 = 'cf_O_dango_04'
        backh686 = 'cf_O_dango_04u'
        backh687 = 'cf_O_dango_05'
        backh688 = 'cf_O_dango_05_deprecated'
        backh689 = 'cf_O_hairback_100_00'
        backh690 = 'cf_O_hairback_100_00_deprecated'
        backh691 = 'cf_O_hairback_100_01'
        backh692 = 'cf_O_hairback_100_01_deprecated'
        backh693 = 'cf_O_hairback_100_02'
        backh694 = 'cf_O_hairback_100_02_deprecated'
        backh695 = 'cf_O_himosaki_L_01'
        backh696 = 'cf_O_himosaki_L_01_deprecated'
        backh697 = 'cf_O_himosaki_L_02'
        backh698 = 'cf_O_himosaki_L_02_deprecated'
        backh699 = 'cf_O_himosaki_L_03'
        backh700 = 'cf_O_himosaki_L_03_deprecated'
        backh701 = 'cf_O_himosaki_L_04'
        backh702 = 'cf_O_himosaki_L_04_deprecated'
        backh703 = 'cf_O_himosaki_R_01'
        backh704 = 'cf_O_himosaki_R_01_deprecated'
        backh705 = 'cf_O_himosaki_R_02'
        backh706 = 'cf_O_himosaki_R_02_deprecated'
        backh707 = 'cf_O_himosaki_R_03'
        backh708 = 'cf_O_himosaki_R_03_deprecated'
        backh709 = 'cf_O_himosaki_R_04'
        backh710 = 'cf_O_himosaki_R_04_deprecated'
        backh711 = 'cf_O_hairback_96_01'
        backh712 = 'cf_O_hairback_96_01_deprecated'
        backh713 = 'cf_O_hairback_96_02'
        backh714 = 'cf_O_hairback_96_02_deprecated'
        backh715 = 'cf_O_hairback_96_03'
        backh716 = 'cf_O_hairback_96_03_deprecated'
        backh717 = 'cf_O_hairpo_96_01'
        backh718 = 'cf_O_hairpo_96_01_deprecated'
        backh719 = 'cf_O_hairpo_96_02'
        backh720 = 'cf_O_hairpo_96_02_deprecated'
        backh721 = 'cf_O_hairpo_96_03'
        backh722 = 'cf_O_hairpo_96_03_deprecated'
        backh723 = 'cf_O_hairpo_96_04'
        backh724 = 'cf_O_hairpo_96_04_deprecated'
        backh725 = 'cf_O_hairpo_96_05'
        backh726 = 'cf_O_hairpo_96_05_deprecated'
        backh727 = 'cf_O_hairpo_96_06'
        backh728 = 'cf_O_hairpo_96_06_deprecated'
        backh729 = 'cf_O_hairpo_96_07'
        backh730 = 'cf_O_hairpo_96_07_deprecated'
        backh731 = 'cf_O_hairback_98_00'
        backh732 = 'cf_O_hairback_98_00_deprecated'
        backh733 = 'cf_O_hairback_98_01'
        backh734 = 'cf_O_hairback_98_02'
        backh735 = 'cf_O_hairback_98_03'
        backh736 = 'cf_O_hairback_98_04'
        backh737 = 'cf_O_hairback_98_05'
        backh738 = 'cf_O_hairback_98_05_deprecated'
        backh739 = 'cf_O_hairback_98_06'
        backh740 = 'cf_O_hairback_98_06_deprecated'
        backh741 = 'cf_O_hairback_98_07'
        backh742 = 'cf_O_hairback_98_07_deprecated'
        backh743 = 'cf_O_hairback_98_08'
        backh744 = 'cf_O_hairback_98_08_deprecated'
        backh745 = 'cf_O_hairback_98_09'
        backh746 = 'cf_O_hairback_98_09_deprecated'
        backh747 = 'cf_O_hairback_98_10'
        backh748 = 'cf_O_hairback_98_10_deprecated'
        backh749 = 'cf_O_hairback_98_11'
        backh750 = 'cf_O_hairback_98_11_deprecated'
        backh751 = 'cf_O_hairback_98_12'
        backh752 = 'cf_O_hairback_98_12_deprecated'
        backh753 = 'cf_O_hairback_99_00'
        backh754 = 'cf_O_hairback_99_00_deprecated'
        backh755 = 'cf_O_hairback_99_01'
        backh756 = 'cf_O_hairback_99_02'
        backh757 = 'cf_O_hairback_99_03'
        backh758 = 'cf_O_hairback_99_04'
        backh759 = 'cf_O_hairback_99_04_deprecated'
        backh760 = 'cf_O_hairback_99_05'
        backh761 = 'cf_O_hairback_99_05_deprecated'
        backh762 = 'cf_O_hairback_99_06'
        backh763 = 'cf_O_hairback_99_07'
        backh764 = 'cf_O_hairback_99_07_deprecated'
        backh765 = 'cf_O_hairback_99_08'
        backh766 = 'cf_O_hairback_99_08_deprecated'
        backh767 = 'cf_O_hairback_99_09'
        backh768 = 'cf_O_hairback_99_09_deprecated'
        backh769 = 'cf_O_hairback_99_10'
        backh770 = 'cf_O_hairback_99_10_deprecated'
        backh771 = 'cf_O_hairback_99_11'
        backh772 = 'cf_O_hairback_99_11_deprecated'
        backh773 = 'cf_O_hairback_99_12'
        backh774 = 'cf_O_hairback_99_12_deprecated'
        backh775 = 'cf_O_hairback_99_13'
        backh776 = 'cf_O_hairback_99_13_deprecated'
        backh777 = 'cf_O_hairback_99_14'
        backh778 = 'cf_O_hairback_99_14_deprecated'
        backh779 = 'cf_O_hairback_99_15'
        backh780 = 'cf_O_hairback_99_15_deprecated'
        backh781 = 'osageB_001'
        backh782 = 'osageB_002'
        backh783 = 'osageB_003'
        backh784 = 'osageB_004'
        backh785 = 'osageB_005'
        backh786 = 'osageB_006'
        backh787 = 'osageB_007'
        backh788 = 'osageB_008'
        backh789 = 'osageB_009'
        backh790 = 'osageB_base'
        backh791 = 'osageB_front'
        backh792 = 'osageB_front_deprecated'
        backh793 = 'osageB_inside'
        backh794 = 'osageB_inside2'
        backh795 = 'osageB_osage'
        backh796 = 'osageB_osageB'
        # Top names:
        #top
        top1 = 'o_top_camisole1_a'
        top2 = 'o_top_camisole1_b'
        top3 = 'o_top_camisole2_a'
        top4 = 'o_top_camisole2_b'
        top5 = 'o_top_camisole3_a'
        top6 = 'o_top_camisole3_b'
        top7 = 'o_top_cardigan1_a'
        top8 = 'o_top_cardigan1_b'
        top9 = 'o_top_cardigan2_a'
        top10 = 'o_top_cardigan2_b'
        top11 = 'o_top_cardigan3_a'
        top12 = 'o_top_cardigan3_b'
        top13 = 'o_cf_bot_cdress_a'
        top14 = 'o_cf_bot_cdress_n'
        top15 = 'o_cf_top_cdress_a'
        top16 = 'o_cf_top_cdress_b'
        top17 = 'o_top_cutejacket_a'
        top18 = 'o_top_cutejacket_b'
        top19 = 'o_bot_elegant_a'
        top20 = 'o_bot_elegant_b'
        top21 = 'o_top_elegant_a'
        top22 = 'o_top_elegant_b'
        top23 = 'o_top_flareshirts_a'
        top24 = 'o_top_flareshirts_b'
        top25 = 'cf_top_harness_a'
        top26 = 'o_top_hula_a'
        top27 = 'o_top_hula_b'
        top28 = 'o_top_suit1_a'
        top29 = 'o_top_suit1_b'
        top30 = 'o_cf_top_nitcami_d'
        top31 = 'o_cf_top_nitcami_n'
        top32 = 'o_top_nosleaveblouse_a'
        top33 = 'o_top_nosleaveblouse_b'
        top34 = 'o_top_nsknit_a'
        top35 = 'o_top_nsknit_b'
        top36 = 'o_bot_onepiece1_a'
        top37 = 'o_bot_onepiece1_b'
        top38 = 'o_top_onepiece1_a'
        top39 = 'o_top_onepiece1_b'
        top40 = 'o_top_openshoulder_a'
        top41 = 'o_top_openshoulder_b'
        top42 = 'o_top_overall1_b_a'
        top43 = 'o_top_overall1_b_b'
        top44 = 'o_top_overall1_t_a'
        top45 = 'o_top_overall1_t_b'
        top46 = 'o_top_overall2_b_a'
        top47 = 'o_top_overall2_b_b'
        top48 = 'o_top_overall2_t_a'
        top49 = 'o_top_overall2_t_b'
        top50 = 'o_top_parker1_a'
        top51 = 'o_top_parker1_b'
        top52 = 'o_top_parker1op_a'
        top53 = 'o_top_riboncami_a'
        top54 = 'o_top_riboncami_b'
        top55 = 'o_top_riboncamiribon_a'
        top56 = 'o_top_sailor1_a'
        top57 = 'o_top_sailor1_b'
        top58 = 'o_top_sailormini_a'
        top59 = 'o_bot_south1_a'
        top60 = 'o_bot_south1_b'
        top61 = 'o_top_south1_a'
        top62 = 'o_top_south1_b'
        top63 = 'o_top_south2_a'
        top64 = 'o_top_south2_b'
        top65 = 'o_top_southcami_a'
        top66 = 'o_top_southcami_b'
        top67 = 'o_top_sportsw_a'
        top68 = 'o_top_sportsw_b'
        top69 = 'o_top_suit0_a'
        top70 = 'o_top_suit0_b'
        top71 = 'o_top_suit2_a'
        top72 = 'o_top_suit2_b'
        top73 = 'o_top_suit3_a'
        top74 = 'o_top_suit3_b'
        top75 = 'o_cf_bot_summerdress_a'
        top76 = 'o_cf_bot_summerdress_b'
        top77 = 'o_cf_top_summerdress_a'
        top78 = 'o_cf_top_summerdress_b'
        top79 = 'o_cf_top_summernit_a'
        top80 = 'o_cf_top_summernit_b'
        top81 = 'o_top_taisou_a'
        top82 = 'o_top_taisou_b'
        top83 = 'o_bot_onedress_a'
        top84 = 'o_bot_onedress_b'
        top85 = 'o_top_onedress_a'
        top86 = 'o_top_onedress_b'
        top87 = 'o_top_trekkingwear_a'
        top88 = 'o_top_trekkingwear_b'
        top89 = 'o_top_tsyatu1_a'
        top90 = 'o_top_tsyatu1_b'
        top91 = 'o_top_tsyatu2_a'
        top92 = 'o_top_tsyatu2_b'
        top93 = 'o_top_tsyatu3_a'
        top94 = 'o_top_tsyatu3_b'
        top95 = 'o_top_tsyatu4_a'
        top96 = 'o_top_tsyatu4_b'
        top97 = 'o_top_tubetop1_a'
        top98 = 'o_top_tubetop1_b'
        top99 = 'o_top_turtleneck_a'
        top100 = 'o_top_turtleneck_b'
        top101 = 'o_bot_ylong1_a'
        top102 = 'o_bot_ylong1_b'
        top103 = 'o_top_ylong1_a'
        top104 = 'o_top_ylong1_b'
        top105 = 'o_top_yshirt1_a'
        top106 = 'o_top_yshirt1_b'
        top107 = 'o_top_yshirt1op_a'
        top108 = 'o_top_yshirt1op_b' #top 00
        top109 = 'o_top_navy_a'
        top110 = 'o_top_navy_b' # 02
        top111 = 'o_top_soldier_a'
        top112 = 'o_top_soldier_b'
        top113 = 'o_cf_bot_cdress_a'
        top114 = 'o_cf_bot_cdress_n'
        top115 = 'o_cf_top_cdress_a'
        top116 = 'o_cf_top_cdress_b'
        top117 = 'o_bot_elegant_a'
        top118 = 'o_bot_elegant_b'
        top119 = 'o_top_elegant_a'
        top120 = 'o_top_elegant_b'
        top121 = 'o_top_a_hallow'
        top122 = 'o_top_b_hallow'
        top123 = 'o_cm_top_poloshit_a'
        top124 = 'o_top_tunktop'
        top125 = 'o_top_tunktop01'
        top126 = 'o_top_yshirtin'
        top127 = 'o_top_yshirt_long' # 05
        top128 = 'o_top_suit1_a'
        top129 = 'o_top_suit1_b'
        top130 = 'o_top_suit0_a'
        top131 = 'o_top_suit0_b'
        top132 = 'o_top_suit2_a'
        top133 = 'o_top_suit2_b'
        top134 = 'o_top_suit3_a'
        top135 = 'o_top_suit3_b' # 08
        top136 = 'o_bot_kitune_a'
        top137 = 'o_bot_kitune_b'
        top138 = 'o_top_kitune_a'
        top139 = 'o_top_kitune_b'
        top140 = 'o_top_kitune_sode_a'
        top141 = 'o_top_kitune_sode_b' # 10
        top142 = 'o_food_boa'
        top143 = 'o_hood'
        top144 = 'o_top_xmas_a4'
        top145 = 'o_top_xmas_b'
        top146 = 'o_top_xmasboa_b_op01'
        top147 = 'o_top_xmasboa_b_op02' # 12
        top148 = 'o_babydoll_bot_a'
        top149 = 'o_babydoll_bot_b'
        top150 = 'o_babydoll_bot_u_a'
        top151 = 'o_babydoll_bot_u_b'
        top152 = 'o_babydoll_top_a'
        top153 = 'o_babydoll_top_b'
        top154 = 'o_babydoll_top_u_a'
        top155 = 'o_babydoll_top_u_b'
        top156 = 'o_top_barg_b_a'
        top157 = 'o_top_barg_b_b'
        top158 = 'o_top_barg_t_a'
        top159 = 'o_top_barg_t_b'
        top160 = 'o_cf_bathtowel00'
        top161 = 'o_cf_bathtowel01'
        top162 = 'o_cf_bathtowel02'
        top163 = 'o_cf_bathtowel03'
        top164 = 'o_top_camg_a'
        top165 = 'o_top_camg_b'
        top166 = 'o_bot_chaina_a'
        top167 = 'o_bot_chaina_b'
        top168 = 'o_bot_chaina_op02'
        top169 = 'o_top_chaina_a'
        top170 = 'o_top_chaina_b'
        top171 = 'o_top_chaina_op_a'
        top172 = 'o_top_chaina_op_b'
        top173 = 'o_cf_top_cheer00'
        top174 = 'o_cf_top_cheer01'
        top175 = 'o_top_cowg_a'
        top176 = 'cf_top_dancer_a'
        top177 = 'cf_top_dancer_b'
        top178 = 'cf_o_bot_dougi_b'
        top179 = 'cf_o_dougi_obi'
        top180 = 'cf_o_top_dougi_b'
        top181 = 'cf_o_top_dougi_bot_a'
        top182 = 'cf_o_top_dougi_top_a10'
        top183 = 'cf_top_elf_a_01'
        top184 = 'cf_top_elf_a_kosiop02'
        top185 = 'cf_top_elf_a_op02'
        top186 = 'cf_top_elf_b_02'
        top187 = 'cf_top_elf_b_kosiop02'
        top188 = 'cf_top_elf_op01'
        top189 = 'cf_top_gos_a'
        top190 = 'cf_top_gos_a_op01'
        top191 = 'cf_top_gos_a_op02'
        top192 = 'cf_top_gos_b'
        top193 = 'cf_top_gos_b_op01'
        top194 = 'o_top_h2main_2_b_a'
        top195 = 'o_top_h2main_2_b_b'
        top196 = 'o_top_h2main_2_t_a'
        top197 = 'o_top_h2main_2_t_b'
        top198 = 'o_hakui_bot_a'
        top199 = 'o_hakui_bot_b'
        top200 = 'o_hakui_top_a'
        top201 = 'o_hakui_top_b'
        top202 = 'cf_bot_healer_a'
        top203 = 'cf_bot_healer_b'
        top204 = 'cf_bot_healer_op_a'
        top205 = 'cf_bot_healer_op_b'
        top206 = 'cf_bot_healer_op_huta'
        top207 = 'cf_top_healer_a'
        top208 = 'cf_top_healer_a_ura'
        top209 = 'cf_top_healer_b'
        top210 = 'cf_top_healer_huta'
        top211 = 'cf_top_healer_op_a'
        top212 = 'cf_top_healer_op_b'
        top213 = 'o_top_hnurse_a'
        top214 = 'o_top_hnurse_b'
        top215 = 'o_cf_top_jersey00'
        top216 = 'o_cf_top_jersey01'
        top217 = 'cf_top_o_keibi_a'
        top218 = 'cf_top_o_keibi_a_op'
        top219 = 'cf_top_o_keibi_b_op'
        top220 = 'cf_top_o_keibi_b3'
        top221 = 'cf_top_o_keibi_op01'
        top222 = 'o_cf_knitshirt00'
        top223 = 'o_cf_knitshirt01'
        top224 = 'o_cf_knitshirt02'
        top225 = 'cf_o_bot_madesuit_a'
        top226 = 'cf_o_bot_madesuit_a_op'
        top227 = 'cf_o_bot_madesuit_b'
        top228 = 'cf_o_bot_madesuit_b_op'
        top229 = 'cf_o_bot_madesuit_huta'
        top230 = 'cf_o_top_madesuit_a4'
        top231 = 'cf_o_top_madesuit_b15'
        top232 = 'o_nig_top_a'
        top233 = 'o_nig_top_b'
        top234 = 'cf_bot_o_nurse_a'
        top235 = 'cf_bot_o_nurse_b'
        top236 = 'cf_bot_o_nurse_huta'
        top237 = 'cf_top_o_nurse_a'
        top238 = 'cf_top_o_nurse_b'
        top239 = 'o_cf_top_pajama00'
        top240 = 'o_cf_top_pajama01'
        top241 = 'cf_top_o_poli_d'
        top242 = 'cf_top_o_poli_n'
        top243 = 'cf_top_o_poli_op01'
        top244 = 'cf_top_o_poli_op02'
        top245 = 'cf_bot_rider_a'
        top246 = 'cf_bot_rider_b'
        top247 = 'cf_rider_op01'
        top248 = 'cf_rider_op02'
        top249 = 'cf_top_rider_a'
        top250 = 'cf_top_rider_b'
        top251 = 'pSphere122'
        top252 = 'pSphere123'
        top253 = 'o_cf_top_runner00'
        top254 = 'o_cf_top_runner01'
        top255 = 'cf_o_top_tennis_a'
        top256 = 'cf_o_top_tennis_a_op01'
        top257 = 'cf_o_top_tennis_b'
        top258 = 'cf_o_top_tennis_b_op01'
        top259 = 'o_tunagi_bot_a'
        top260 = 'o_tunagi_bot_b'
        top261 = 'o_tunagi_top_a'
        top262 = 'o_tunagi_top_b'
        top263 = 'o_cf_top_volley00'
        top264 = 'o_cf_top_volley01'
        top265 = 'o_body_cm_ork'
        top266 = 'o_body_cm_ork_a'
        top267 = 'o_body_cm_ork_b'
        top268 = 'cm_o_top_longcoat_base'
        top269 = 'cm_o_top_longcoat_huta'
        top270 = 'cm_o_top_longcoat_in'
        top271 = 'cm_o_top_longcoat_op'
        top272 = 'cm_o_top_longcoat_siro' # 30
        top273 = 'cf_bot_ninja_a'
        top274 = 'cf_bot_ninja_b'
        top275 = 'cf_top_ninja_a'
        top276 = 'cf_top_ninja_b'
        top277 = 'cf_top_ninja_obi'
        top278 = 'cf_top_ninja_op'
        top279 = 'n_top_ninja_obi_himo'
        top280 = 'n_top_ninja_obi_himo1' # 32
        top281 = 'cf_bot_epu_base_a'
        top282 = 'cf_bot_epu_base_b'
        top283 = 'cf_bot_epu_furiru_a'
        top284 = 'cf_bot_epu_furiru_b'
        top285 = 'cf_bot_epu_ribon_a'
        top286 = 'cf_bot_epu_ribon_b'
        top287 = 'cf_top_epu_base_a'
        top288 = 'cf_top_epu_base_b'
        top289 = 'cf_top_epu_op01_a'
        top290 = 'cf_top_epu_op01_b'
        top291 = 'cf_top_epu_op02_a'
        top292 = 'cf_top_epu_op02_b'
        top293 = 'o_cf_top_kikkou00'
        top294 = 'o_cf_top_kikkou01'
        top295 = 'o_cf_top_kikkou02'
        top296 = 'o_cf_top_kikkou03'
        top297 = 'o_ribbon'
        top298 = 'o_top_kimonoh_b_a'
        top299 = 'o_top_kimonoh_b_b'
        top300 = 'o_top_kimonoh_t_a'
        top301 = 'o_top_kimonoh_t_b' # 34
        top302 = 'o_cf_top_bunnyR00' # 35
        top303 = 'o_top_sister_bot_a'
        top304 = 'o_top_sister_bot_b'
        top305 = 'o_top_sister_op1_a'
        top306 = 'o_top_sister_op1_b'
        top307 = 'o_top_sister_top_a'
        top308 = 'o_top_sister_top_b'
        top309 = 'o_top_sister_s_bot_a'
        top310 = 'o_top_sister_s_bot_b'
        top311 = 'o_top_sister_s_top_a'
        top312 = 'o_top_sister_s_top_b' # 40
        top313 = 'o_top_bont_a'
        top314 = 'o_top_bont_b'
        top315 = 'o_top_bont_op1'
        top316 = 'o_top_bont_op1 1' # 41
        top317 = 'o_cf_bathtowel00'
        top318 = 'o_cf_bathtowel01'
        top319 = 'o_cf_bathtowel02'
        top320 = 'o_cf_bathtowel03'
        top321 = 'cf_top_ribonburausu_a'
        top322 = 'cf_top_ribonburausu_b'
        top323 = 'o_top_con1_a'
        top324 = 'o_top_con1_b'
        top325 = 'o_top_con1_b_a'
        top326 = 'o_top_con1_b_b'
        top327 = 'cf_top_furirucollar_a'
        top328 = 'cf_top_furirucollar_b'
        top329 = 'cf_top_wahuku_b_himo'
        top330 = 'cf_top_wahuku_b1'
        top331 = 'cf_top_wahuku_huta'
        top332 = 'cf_top_wahuku02_a'
        top333 = 'cf_top_wahuku02_a_himo'
        top334 = 'cf_top_wahuku02_op'
        top335 = 'cf_top_wahuku02_sode'
        top336 = 'cf_top_wahuku02ribon_op1'
        top337 = 'o_cf_top_pank00'
        top338 = 'o_cf_top_pank01'
        top339 = 'o_cf_top_pank02'
        top340 = 'o_cf_top_pank03'
        top341 = 'o_cf_top_pank04'
        top342 = 'o_cf_top_pank05'
        top343 = 'cf_o_bot_raceqween_a'
        top344 = 'cf_o_bot_raceqween_b'
        top345 = 'cf_o_bot_raceqween_beruto'
        top346 = 'cf_o_bot_raceqween_huta'
        top347 = 'cf_o_top_raceqween_a'
        top348 = 'cf_o_top_raceqween_b'
        top349 = 'o_cf_top_syokusyu00'
        top350 = 'o_cf_top_syokusyu01'
        top351 = 'o_cf_top_thief00' # 57
        top352 = 'o_cf_top_thief01'
        top353 = 'o_cf_top_thief02'
        top354 = 'o_cf_top_thief03'
        top355 = 'cf_top_wahuku_a'
        top356 = 'cf_top_wahuku_b'
        top357 = 'cf_top_wahuku_huta'
        top358 = 'cf_top_wahuku_op'
        top359 = 'cf_top_wedding_a_base'
        top360 = 'cf_top_wedding_a_op01'
        top361 = 'cf_top_wedding_a_op02'
        top362 = 'cf_top_wedding_b_base'
        top363 = 'cf_top_wedding_b_op01'
        top364 = 'cf_top_wedding_b_op02' # 50
        top365 = 'o_cf_bot_dragonic00'
        top366 = 'o_cf_bot_dragonic01'
        top367 = 'o_cf_top_dragonic00'
        top368 = 'o_cf_top_dragonic01'
        top369 = 'o_cf_top_dragonic03' # 51
        top370 = 'o_cf_top_magic00'
        top371 = 'o_cf_top_magic01'
        top372 = 'o_cf_top_magic02'
        top373 = 'o_cf_top_magic03' # 52
        # bot names:
        bot1 = 'O_bot00'
        bot2 = 'O_bot00 1'
        bot3 = 'O_bot01_d'
        bot4 = 'O_bot01_d_u'
        bot5 = 'O_bot01_n'
        bot6 = 'O_bot01_n_u'
        bot7 = 'O_bot00_d'
        bot8 = 'O_bot00_d_u'
        bot9 = 'O_bot00_n'
        bot10 = 'O_bot03_d'
        bot11 = 'O_bot03_n'
        bot12 = 'O_bot02_d'
        bot13 = 'O_bot_d'
        bot14 = 'O_bot_n'
        bot15 = 'o_bot_n'
        bot16 = 'cf_O_bot_shortP_d_00'
        bot17 = 'cf_O_bot_shortP_d_00_U'
        bot18 = 'cf_O_bot_shortP_n_00'
        bot19 = 'cf_O_bot_shortP_n_00 1'
        bot20 = 'cf_O_bot_shortPC_d_00'
        bot21 = 'cf_O_bot_shortPC_d_00_U'
        bot22 = 'cf_O_bot_shortPC_d_01_sode_L'
        bot23 = 'cf_O_bot_shortPC_d_01_sode_L 1'
        bot24 = 'cf_O_bot_shortPC_d_01_sode_R'
        bot25 = 'cf_O_bot_shortPC_d_01_sode_R 1'
        bot26 = 'cf_O_bot_shortPC_d_swerter'
        bot27 = 'cf_O_bot_shortPC_d_swerter_U'
        bot28 = 'cf_O_bot_shortPC_n_00'
        bot29 = 'cf_O_bot_shortPC_n_00_U'
        bot30 = 'cf_O_bot_shortPC_n_sweater'
        bot31 = 'cf_O_bot_shortPC_n_sweater 1'
        bot32 = 'cf_o_bot_pajama_d_01'
        bot33 = 'cf_O_botRW_skirt'
        bot34 = 'cf_O_botRW_skirt_n'
        bot35 = 'cf_O_botRW_epuron'
        bot36 = 'cf_O_botRW_epuron_n'
        bot37 = 'cf_O_bot_gos_iro_ribon_ska'
        bot38 = 'cf_O_bot_gos_iro_ribon_ska_U'
        bot39 = 'cf_O_bot_gos_ska_base_line_O'
        bot40 = 'cf_O_bot_gos_ska_furiru_iro_O'
        bot41 = 'cf_O_bot_gos_ska_furiru_iro_O1'
        bot42 = 'cf_O_bot_gos_ska_furiru_O'
        bot43 = 'cf_O_bot_gos_ska_furiru_U'
        bot44 = 'cf_O_bot_gos_ska_iro_lace_mini'
        bot45 = 'cf_O_bot_gos_ska_iro_O'
        bot46 = 'cf_O_bot_gos_ska_iro_U'
        bot47 = 'cf_O_bot_gos_ska_Lace_iro_O'
        bot48 = 'cf_O_bot_gos_ska_ue_O'
        bot49 = 'cf_O_bot_gos_ska_ue_O1'
        bot50 = 'cf_O_bot_ska_base_iro_n_O'
        bot51 = 'cf_O_bot_ska_base_iro_n_U'
        bot52 = 'cf_O_bot_ska_base_line_n_O'
        bot53 = 'cf_O_bot_ska_huriru_jro_n_O'
        bot54 = 'cf_O_bot_ska_huriru_iro_n_U'
        bot55 = 'cf_O_bot_ska_lace_n'
        bot56 = 'cf_O_bot_ska_n_huriru_O'
        bot57 = 'cf_O_bot_ska_n_huriru_U'
        bot58 = 'cf_O_bot_ska_n_ue_O'
        bot59 = 'cf_O_bot_ska_n_ue_U'
        bot60 = 'cf_O_bot_ska_ribon_n_O'
        bot61 = 'cf_O_bot_ska_ribon_n_U'
        bot62 = 'cf_0_bot_GOS_ribon_side_iro_N_O'
        bot63 = 'cf_0_bot_GOS_ribon_side_iro_N_U'
        bot64 = 'cf_0_bot_GOS_ribon_side_iro_O'
        bot65 = 'cf_0_bot_GOS_ribon_side_iro_U'
        bot66 = 'cf_o_bot_GOS_Z_poke_huriru_iro_N_O'
        bot67 = 'cf_o_bot_GOS_Z_poke_huriru_iro_N_U'
        bot68 = 'cf_o_bot_GOS_Z_poke_huriru_iro_O'
        bot69 = 'cf_o_bot_GOS_Z_poke_huriru_iro_U'
        bot70 = 'cf_o_bot_GOS_zubon_base_d'
        bot71 = 'cf_o_bot_GOS_zubon_base_n_O'
        bot72 = 'cf_o_bot_GOS_zubon_base_n_suso_U'
        bot73 = 'cf_o_bot_GOS_zubon_base_n_U'
        bot74 = 'cf_o_bot_GOS_zubon_base_u'
        bot75 = 'cf_o_bot_GOS_zubon_huriru_d'
        bot76 = 'cf_o_bot_GOS_zubon_huriru_d_U'
        bot77 = 'cf_o_bot_GOS_zubon_huriru_d_U 1'
        bot78 = 'cf_o_bot_GOS_zubon_huriru_n_iro_O'
        bot79 = 'cf_o_bot_GOS_zubon_iro_d'
        bot80 = 'cf_o_bot_GOS_zubon_iro_d_U'
        bot81 = 'cf_o_bot_GOS_zubon_iro_n'
        bot82 = 'cf_o_bot_GOS_zubon_iro_n_U'
        bot83 = 'cf_o_bot_GOS_zubon_lase_iro'
        bot84 = 'cf_o_bot_GOS_zubon_lase_iro_n'
        bot85 = 'cf_o_bot_GOS_zubon_line_iro_n_U'
        bot86 = 'cf_o_bot_GOS_zubon_ribon_iro'
        bot87 = 'cf_o_bot_GOS_zubon_ribon_iro_N_O'
        bot88 = 'cf_o_bot_GOS_zubon_ribon_iro_N_U'
        bot89 = 'cf_o_bot_GOS_zubon_ribon_iro_U'
        bot90 = 'cf_o_bot_n_wedding_kosi'
        bot91 = 'cf_o_bot_weding_skirt_n_o'
        bot92 = 'cf_o_bot_weding_skirt_n_u'
        bot93 = 'cf_o_bot_weding_skirt_o'
        bot94 = 'cf_o_bot_weding_skirt_u'
        bot95 = 'cf_o_botd__wedding_kosi'
        bot96 = 'o_bot_idol_d'
        bot97 = 'o_bot_idol_n'
        bot98 = 'o_bot_robe2_a'
        bot99 = 'o_bot_robe2_a_u'
        bot100 = 'o_bot_robe2_b'
        bot101 = 'o_bot_robe2_b_u'
        bot102 = 'o_tightpants_a'
        bot103 = 'o_tightpants_b'
        bot104 = 'cf_O_bot_shortP_d_tare'
        bot105 = 'cf_O_bot_shortP_d_tare_U'
        bot106 = 'cf_O_bot_shortP_n_tare'
        bot107 = 'cf_O_bot_shortP_n_tare_u'
        bot108 = 'cf_o_LA_skirt_d_00'
        bot109 = 'cf_o_LA_skirt_d_beruto_d_01'
        bot110 = 'cf_o_LA_skirt_d_kanagu'
        bot111 = 'cf_o_LA_skirt_d_kosi'
        bot112 = 'cf_o_LA_skirt_d_kosi_U'
        bot113 = 'cf_o_LA_skirt_d_lace_O1'
        bot114 = 'cf_o_LA_skirt_d_lace_U'
        bot115 = 'cf_o_LA_skirt_d_pouch'
        bot116 = 'cf_o_LA_skirt_n_00'
        bot117 = 'cf_o_LA_skirt_n_00_u'
        bot118 = 'cf_o_LA_skirt_n_kanagu'
        bot119 = 'cf_o_LA_skirt_n_kosi'
        bot120 = 'cf_o_LA_skirt_n_lace_O'
        bot121 = 'cf_o_LA_skirt_n_lace_U'
        bot122 = 'cf_o_LA_skirt_u_00'
        bot123 = 'o_yayoi_bot_a'
        bot124 = 'o_yayoi_bot_n'
        bot125 = 'cf_o_bot_furiru_PN_01'
        bot126 = 'cf_o_bot_furiru_PN_01_U'
        bot127 = 'cf_o_bot_furiru_PN_02'
        bot128 = 'cf_o_bot_furiru_PN_02_U'
        bot129 = 'cf_o_bot_furiru_PN_03'
        bot130 = 'cf_o_bot_furiru_PN_03_U'
        bot131 = 'cf_o_bot_ska_PN_himo'
        bot132 = 'cf_o_bot_ska_PN_himo_n'
        bot133 = 'cf_o_bot_ska_PN_himo_n_u'
        bot134 = 'cf_o_bot_ska_PN_himo_U'
        bot135 = 'cf_o_bot_ska_PN_N_O'
        bot136 = 'cf_o_bot_ska_PN_N_U'
        bot137 = 'cf_o_bot_ska_PN_und'
        bot138 = 'cf_o_bot_ska_PN_und_U'
        bot139 = 'cf_o_bot_ska_PN_up'
        bot140 = 'cf_o_bot_ska_PN_up_U'
        bot141 = 'cf_o_bot_skaRIbon_PN_01'
        bot142 = 'cf_o_bot_skaRIbon_PN_01_U'
        bot143 = 'cf_o_bot_skaRIbon_PN_02'
        bot144 = 'cf_o_bot_skaRIbon_PN_02_U'
        bot145 = 'cf_o_bot_skaRIbon_PN_03'
        bot146 = 'cf_o_bot_skaRIbon_PN_03_U'
        bot147 = 'cf_o_bot_zb_PN_d'
        bot148 = 'cf_o_bot_zb_PN_d_ribon'
        bot149 = 'cf_o_bot_zb_PN_d_ribon 1'
        bot150 = 'cf_o_bot_zb_PN_d_ribon_u'
        bot151 = 'cf_o_bot_zb_PN_d4'
        bot152 = 'cf_o_bot_zb_PN_d4 1'
        bot153 = 'cf_o_bot_zb_PN_d5'
        bot154 = 'cf_o_bot_zb_PN_n_ribon_u'
        bot155 = 'O_bot00_a'
        bot156 = 'O_bot00_b'
        bot157 = 'o_bot_a'
        bot158 = 'o_bot_b'
        bot159 = 'cf_o_AP_n_bot'
        bot160 = 'cf_o_AP_n_bot_u'
        bot161 = 'cf_o_AP_d_bot'
        bot162 = 'cf_o_AP_d_bot_u'
        bot163 = 'cf_o_bot_kimono_D_O'
        bot164 = 'cf_o_bot_kimono_D_U'
        bot165 = 'cf_o_bot_kimono_N_O'
        bot166 = 'cf_o_bot_kimono_N_O1'
        bot167 = 'cf_o_bot_kimonoGOS_D_01'
        bot168 = 'cf_o_bot_kimonoGOS_D_02'
        bot169 = 'cf_o_bot_kimonoGOS_D_huriru'
        bot170 = 'cf_o_bot_kimonoGOS_D_huriru_nuki'
        bot171 = 'cf_o_bot_kimonoGOS_D_huriru_U'
        bot172 = 'cf_o_bot_kimonoGOS_N'
        bot173 = 'cf_o_bot_kimonoGOS_N_huriru'
        bot174 = 'cf_o_bot_kimonoGOS_N_huriru_U'
        bot175 = 'cf_o_bot_kimonoGOS_N_race'
        bot176 = 'cf_o_bot_kimonoGOS_N_U'
        bot177 = 'cf_bot_kimonoGOS_ska_ribon'
        bot178 = 'cf_bot_kimonoGOS_ska_ribonN'
        bot179 = 'cf_bot_kimonoGOS_ska_ribonN_U'
        bot180 = 'cf_bot_kimonoGOS_ska_ribonU'
        bot181 = 'cf_o_bot_splitska_D_00'
        bot182 = 'cf_o_bot_splitska_D_00_U'
        bot183 = 'cf_o_bot_splitska_D_furiru'
        bot184 = 'cf_o_bot_splitska_D_race'
        bot185 = 'cf_o_bot_splitska_D_ribon'
        bot186 = 'cf_o_bot_splitska_D_ribon_U'
        bot187 = 'cf_o_bot_splitska_N_00'
        bot188 = 'cf_o_bot_splitska_N_00_U'
        bot189 = 'cf_o_bot_splitska_N_furiru'
        bot190 = 'cf_o_bot_splitska_N_race'
        bot191 = 'cf_o_bot_splitska_N_ribon'
        bot192 = 'cf_o_bot_splitska_N_ribonU'
        bot193 = 'cf_o_bot_kimono_D_O'
        bot194 = 'cf_o_bot_kimono_D_U'
        bot195 = 'cf_o_bot_kimono_N_O'
        bot196 = 'cf_o_bot_kimono_N_O1'
        bot197 = 'o_bot_a'
        bot198 = 'o_bot_n'
        bot199 = 'o_fri1'
        bot200 = 'o_fri2'
        bot201 = 'o_maid_bot_d'
        bot202 = 'o_maid_bot_n'
        bot203 = 'cf_o_waitress_skirt_N_under_O'
        bot204 = 'cf_o_waitress_skirt_N_under_U'
        bot205 = 'cf_o_waitress_skirt_N_up_O'
        bot206 = 'cf_o_waitress_skirt_N_up_U'
        bot207 = 'cf_o_waitress_skirt_under_O'
        bot208 = 'cf_o_waitress_skirt_under_U'
        bot209 = 'cf_o_waitress_skirt_up_O'
        bot210 = 'cf_o_waitress_skirt_up_U'
        bot211 = 'o_kimono_bot_a'
        bot212 = 'o_kimono_bot_b'
        bot213 = 'o_kimono_obi_a'
        bot214 = 'o_bot_miko1_a'
        bot215 = 'o_bot_miko1_b'
        bot216 = 'o_bot_miko2_2_a'
        bot217 = 'o_bot_miko2_a'
        bot218 = 'o_bot_miko2_b'
        bot219 = 'o_sis1_bot_d'
        bot220 = 'o_sis1_bot_n'
        bot221 = 'cf_O_ovbot_Enurse_aka_d'
        bot222 = 'cf_O_ovbot_Enurse_base_d_O'
        bot223 = 'cf_O_ovbot_Enurse_base_d_U'
        bot224 = 'cf_O_ovbot_Enurse_heartB'
        bot225 = 'o_bot_d'
        # shoes names:
        shoes1 = 'cf_O_shoes_01'
        shoes2 = 'cf_O_shoes_02'
        shoes3 = 'cf_O_shoes_03'
        shoes4 = 'cf_O_shoes_04'
        shoes5 = 'cf_O_shoes_05'
        shoes6 = 'cf_O_shoes_06'
        shoes7 = 'cf_O_shoes_07'
        shoes8 = 'cf_O_shoes_08'
        shoes9 = 'cf_O_shoes_09'
        shoes10 = 'cf_O_shoes_10'
        shoes11 = 'cf_O_shoes_11'
        shoes12 = 'cf_O_shoes_12'
        shoes13 = 'cf_O_shoes_13'
        shoes14 = 'cf_O_shoes_14'
        shoes15 = 'cf_O_shoes_15'
        shoes16 = 'cf_O_shoes_16'
        shoes17 = 'cf_O_shoes_16_02'
        shoes18 = 'cf_O_shoes_17'
        shoes19 = 'cf_O_shoes_17_02'
        shoes20 = 'cf_O_shoes_18'
        shoes21 = 'cf_O_shoes_19'
        shoes22 = 'O_shoes_20'
        shoes23 = 'O_shoes_21'
        shoes24 = 'o_shoes_con'
        shoes25 = 'cf_o_shoes_aplong'
        shoes26 = 'cf_o_shoes_apshort'
        shoes27 = 'cf_O_shoes_ballet_base'
        shoes28 = 'cf_O_shoes_ballet_soko'
        shoes29 = 'o_shoes_china_00'
        shoes30 = 'cf_O_shoes_china'
        shoes31 = 'O_shoes_gla01'
        shoes32 = 'cf_o_shoes_glass_O'
        shoes33 = 'cf_o_shoes_glass_U'
        shoes34 = 'cf_O_shoes_kaigara'
        shoes35 = 'cf_O_shoes_loose_R'
        shoes36 = 'o_magic_shoes'
        shoes37 = 'cf_o_shoes_plant_L'
        shoes38 = 'cf_O_shoes_plant_S'
        shoes39 = 'cf_O_shoes_RW_01'
        shoes40 = 'cf_O_shoes_RW_02'
        shoes41 = 'cf_O_shoes_sweet'
        shoes42 = 'cf_O_shoes_uwabaki_ao'
        shoes43 = 'cf_o_shoes_waitress_00'
        shoes44 = 'cf_O_shoes_weastern'
        shoes45 = 'cf_o_shoes_wedding_base'
        shoes46 = 'cf_o_shoes_Xmas'
        shoes47 = 'cf_O_shoes_zouri_00'
        shoes48 = 'cf_O_shoes_zouri_00_base'
        shoes49 = 'cf_O_shoes_zouri_B'
        shoes50 = 'cf_O_shoes_zouri_B_iro'
        shoes51 = 'cf_O_shoes_zouri_R'
        shoes52 = 'cf_O_shoes_zouri_R_iro'
        shoes53 = 'o_zouri'
        shoes54 = 'o_shoes_miko1'
        shoes55 = 'cf_o_shoes_gos_base'
        shoes56 = 'cf_o_shoes_GOS_boots_base'
        shoes57 = 'o_shoes_sis1'
        shoes58 = 'o_shoes_sis1_r'
        shoes59 = 'o_bond1_shoes_1'
        shoes60 = 'o_bond1_shoes_himo_1'
        shoes61 = 'o_camp1_shoes'
        shoes62 = 'cf_o_shoes_Emagi'
        shoes63 = 'o_idol1_shoes'
        shoes64 = 'cf_o_shoes_Xmas_iro'
        shoes65 = 'o_armor1_shoes'
        shoes66 = 'cf_O_shoes_sandal_asikubi'
        shoes67 = 'cf_O_shoes_sandal_asikubi_U'
        shoes68 = 'cf_O_shoes_sandal_kin'
        shoes69 = 'cf_O_shoes_sandal_kin_huchi'
        shoes70 = 'cf_O_shoes_sandal_kin_huchi_U'
        shoes71 = 'cf_O_shoes_sandal_nuno'
        shoes72 = 'cf_O_shoes_sandal_nuno_U'
        shoes73 = 'cf_O_shoes_sandal_soko'
        shoes74 = 'o_shoes_hood1'
        shoes75 = 'o_shoes_hood1_far'
        shoes76 = 'o_shoes_kuno1'
        shoes77 = 'cf_O_shoes_Lboots_base'
        shoes78 = 'cf_O_shoes_Lboots_base_U'
        shoes79 = 'cf_O_shoes_Lboots_kanagu'
        shoes80 = 'cf_O_shoes_Lboots_nuno'
        shoes81 = 'cf_O_shoes_Lboots_nuno_U'
        shoes82 = 'cf_O_shoes_Lboots_ue'
        shoes83 = 'cf_O_shoes_Lboots_ue_U'
        shoes84 = 'o_shoes_robe1'
        shoes85 = 'o_robe2_shoes'
        shoes86 = 'o_shoes_bikiarm1'
        shoes87 = 'battleboots_mesh'
        shoes88 = 'o_yayoi_shoes'
        shoes89 = 'cf_o_shoes_PN_00'
        shoes90 = 'cf_o_shoes_PN_hane'
        shoes91 = 'cf_o_shoes_PN_hiza'
        shoes92 = 'cf_o_shoes_PN_hiza_u'
        shoes93 = 'cf_o_shoes_PN_ura'
        shoes94 = 'cf_o_shoes_HM'
        shoes95 = 'cf_o_shoes_HM_u'
        shoes96 = 'muma_shoes'
        # short names:
        short1 = 'cf_O_shorts_d'
        short2 = 'cf_O_shorts_d_u'
        short3 = 'cf_O_shorts_n'
        short4 = 'cf_O_shorts_n_u'
        # bra names:
        bra1 = 'cf_O_bra_d'
        bra2 = 'cf_O_bra_n'
        bra3 = 'cf_O_bra_n1'
        bra4 = 'cf_O_bra_n2'
        bra5 = 'cf_O_bra_n3'
        # socks names:
        socks1 = 'cf_O_socks01'
        socks2 = 'cf_O_socks02'
        socks3 = 'cf_O_socks03'
        socks4 = 'cf_O_socks04'
        socks5 = 'cf_O_socks05'
        socks6 = 'cf_O_socks05_02'
        socks7 = 'cf_O_socks06'
        socks8 = 'cf_O_socks07'
        socks9 = 'cf_O_socks08'
        socks10 = 'cf_O_socks09_00'
        socks11 = 'cf_O_socks09_01'
        socks12 = 'cf_O_socks_ballet'
        socks13 = 'O_socks_boro01'
        socks14 = 'cf_O_socks_china'
        socks15 = 'cf_O_socks_china_U'
        socks16 = 'cf_o_socks_halloween'
        socks17 = 'cf_o_socks_kaigara'
        socks18 = 'cf_o_socks_kaigara_line'
        socks19 = 'cf_o_socks_kaigara_line_U'
        socks20 = 'cf_o_socks_kaigara_ribon'
        socks21 = 'cf_o_socks_kaigara_siro'
        socks22 = 'cf_o_socks_kaigara_siro_U'
        socks23 = 'cf_o_socks_ivy'
        socks24 = 'cf_o_socks_ivy_leaf'
        socks25 = 'cf_O_socks_sweet'
        socks26 = 'cf_O_socks_sweet_ribon'
        socks27 = 'cf_O_socks_sweetS'
        socks28 = 'cf_O_socks_sweetS_ribon'
        socks29 = 'cf_O_socks_tabi'
        socks30 = 'cf_O_socks_waitress_00'
        socks31 = 'cf_O_socks_waitress_01_O'
        socks32 = 'cf_O_socks_waitress_01_U'
        socks33 = 'cf_O_socks_wedding'
        socks34 = 'o_socks_leopord'
        socks35 = 'o_socks_miko2'
        socks36 = 'o_camp1_socks'
        socks37 = 'cf_O_socks_Emagi'
        socks38 = 'cf_O_socks_Xmas_CC'
        socks39 = 'cf_O_socks_Xmas_CC_ke_00'
        socks40 = 'cf_O_socks_Xmas_CC_ke_00_U'
        socks41 = 'cf_O_socks_Xmas_CC_ke_01'
        socks42 = 'cf_O_socks_Xmas_CC_ke_01_U'
        socks43 = 'cf_O_socks_Xmas_CC_ke_02'
        socks44 = 'cf_O_socks_Xmas_CC_ke_02_U'
        socks45 = 'cf_O_socks_Xmas_CC_ke_03'
        socks46 = 'cf_O_socks_Xmas_CC_ke_03_U'
        socks47 = 'cf_o_socks_dancer_amidown'
        socks48 = 'cf_o_socks_dancer_amidown_U'
        socks49 = 'cf_o_socks_dancer_amiup'
        socks50 = 'cf_o_socks_dancer_amiup_U'
        socks51 = 'cf_o_socks_dancer_base'
        socks52 = 'cf_o_socks_dancer_base_U'
        socks53 = 'cf_o_socks_dancer_kin'
        socks54 = 'cf_o_socks_dancer_lace'
        socks55 = 'cf_o_socks_dancer_lace_U'
        socks56 = 'o_socks_hood1'
        socks57 = 'o_socks_hood1_u'
        socks58 = 'o_socks_kuno1'
        socks59 = 'cf_O_socks_Larmor'
        socks60 = 'cf_o_socks_paerlB_00'
        socks61 = 'cf_o_socks_paerlB_00_U'
        socks62 = 'cf_o_socks_paerlB_lace'
        socks63 = 'cf_o_socks_paerlB_lace_u'
        socks64 = 'cf_o_socks_paerlB_pearl'
        socks65 = 'cf_o_socks_paerlB_ribon'
        socks66 = 'cf_o_socks_paerlB_ribon_u'
        socks67 = 'cf_o_socks_Hunder_00_O'
        socks68 = 'cf_o_socks_Hunder_00_U'
        socks69 = 'o_yayoi_socks'
        socks70 = 'cf_o_socks_CF'
        socks71 = 'cf_o_socks_CF_flower_O'
        socks72 = 'cf_o_socks_CF_flower_U'
        socks73 = 'cf_O_socks_CF_frill_O'
        socks74 = 'cf_O_socks_CF_frill_U'
        socks75 = 'cf_o_socks_CF_ribon_O'
        socks76 = 'cf_o_socks_CF_ribon_U'
        # gloves names:
        glove1 = 'cf_O_glove01'
        glove2 = 'cf_O_glove02'
        glove3 = 'cf_O_glove03'
        glove4 = 'cf_O_glove04'
        glove5 = 'cf_O_glove05'
        glove6 = 'cf_O_glove05_02'
        glove7 = 'cf_O_glove06'
        glove8 = 'cf_O_glove06_02'
        glove9 = 'cf_O_glove07'
        glove10 = 'cf_O_glove07_01'
        glove11 = 'cf_O_glove08_01'
        glove12 = 'cf_O_glove08_02'
        glove13 = 'O_glove06'
        glove14 = 'O_glove_spy'
        glove15 = 'cf_O_glove_sweet'
        glove16 = 'cf_O_glove_sweet_01'
        glove17 = 'cf_o_glove_sweet_ribon'
        glove18 = 'o_glove_con'
        glove19 = 'cf_O_glove_china'
        glove20 = 'cf_O_glove_china_U'
        glove21 = 'cf_O_glove_cow'
        glove22 = 'cf_O_glove_cow_hira_O'
        glove23 = 'cf_O_glove_cow_hira_U'
        glove24 = 'cf_O_glove_halloween'
        glove25 = 'cf_o_glove_kaigara'
        glove26 = 'cf_o_glove_kaigara_line'
        glove27 = 'cf_o_glove_kaigara_line_U'
        glove28 = 'cf_o_glove_kaigara_ribon'
        glove29 = 'cf_o_glove_kaigara_siro'
        glove30 = 'cf_o_glove_kaigara_siro_U'
        glove31 = 'o_magic_glove'
        glove32 = 'cf_o_glove_ivy'
        glove33 = 'cf_o_glove_ivy_leaf'
        glove34 = 'cf_o_glove_waitress_O'
        glove35 = 'cf_o_glove_waitress_U'
        glove36 = 'cf_O_glove_wedding_long'
        glove37 = 'cf_O_glove_wedding_long_race'
        glove38 = 'cf_O_glove_wedding_long_ribon'
        glove39 = 'cf_O_glove_wedding_short'
        glove40 = 'cf_O_glove_wedding_short_race'
        glove41 = 'cf_O_glove_wedding_short_ribon'
        glove42 = 'cf_O_glove_Xmas'
        glove43 = 'cf_O_glove_neglace_O'
        glove44 = 'cf_o_glove_neglace_ribon_O'
        glove45 = 'cf_o_glove_neglace_ribon_U'
        glove46 = 'cf_O_glove_neglace_U'
        glove47 = 'o_bond1_glove_1'
        glove48 = 'o_bond1_glove_himo_1'
        glove49 = 'cf_O_glove_Xmas_CC_iro'
        glove50 = 'cf_O_glove_Xmas_CC_siro'
        glove51 = 'cf_o_glove_dancer'
        glove52 = 'cf_o_glove_dancer_kin'
        glove53 = 'cf_o_glove_dancer_naka'
        glove54 = 'cf_o_glove_dancer_naka_kin'
        glove55 = 'cf_o_glove_dancer_U'
        glove56 = 'cf_O_glove_LG_iro_L'
        glove57 = 'cf_O_glove_LG_L'
        glove58 = 'cf_O_glove_LG_L_U'
        glove59 = 'cf_O_glove_LG_lace_L'
        glove60 = 'cf_O_glove_LG_lace_L_U'
        glove61 = 'cf_O_glove_LG_lanagu'
        glove62 = 'cf_O_glove_LG_iro_M'
        glove63 = 'cf_O_glove_LG_iro_M_u'
        glove64 = 'cf_O_glove_LG_lace_M'
        glove65 = 'cf_O_glove_LG_lace_M_u'
        glove66 = 'cf_O_glove_LG_lanagu_M'
        glove67 = 'cf_O_glove_LG_M'
        glove68 = 'cf_O_glove_LG_M_U'
        glove69 = 'o_glove_armor1'
        glove70 = 'o_gloves_hood1'
        glove71 = 'o_gloves_kuno1'
        glove72 = 'o_gloves_kuno1_2'
        glove73 = 'o_gloves_robe1'
        glove74 = 'cf_o_glove_paerlB_00'
        glove75 = 'cf_o_glove_paerlB_00_lace'
        glove76 = 'cf_o_glove_paerlB_00_lace_u'
        glove77 = 'cf_o_glove_paerlB_00_u'
        glove78 = 'cf_o_glove_paerlB_pearl'
        glove79 = 'cf_o_glove_paerlB_ribon'
        glove80 = 'cf_o_glove_paerlB_ribon_u'
        glove81 = 'o_yayoi_arm'
        glove82 = 'o_yayoi_gloves'
        glove83 = 'cf_o_glove_PN_O'
        glove84 = 'cf_o_glove_PN_U'
        glove85 = 'cf_O_glove_HM_00'
        glove86 = 'cf_O_glove_HM_00_u'
        glove87 = 'cf_O_glove_HM_himo'
        glove88 = 'cf_O_glove_HM_himo_u'
        glove89 = 'cf_O_glove_HM_ribon'
        glove90 = 'cf_O_glove_HM_ribon_u'
        glove91 = 'cf_O_glove_CF'
        glove92 = 'cf_o_glove_CF_flower_O'
        glove93 = 'cf_o_glove_CF_flower_u'
        glove94 = 'cf_o_glove_CF_in'
        glove95 = 'cf_o_glove_CF_ribon_O'
        glove96 = 'cf_o_glove_CF_ribon_u'
        glove97 = 'cf_O_glove_CF_u'
        glove98 = 'muma_gloves'
        # tongue names:
        tong1 = 'o_tang'
        tong2 = 'o_tang1'
        tong3 = 'o_tang2'
        tong4 = 'o_tang3'
        tong5 = 'o_tang4'
        # tooth names:
        tooth1 = 'o_tooth'
        tooth2 = 'o_tooth1'
        tooth3 = 'o_tooth2'
        tooth4 = 'o_tooth3'
        tooth5 = 'o_tooth4'
        # mayu names:
        mayu1 = 'o_namida'
        mayu2 = 'o_namida1'
        mayu3 = 'o_namida2'
        mayu4 = 'o_namida3'
        mayu5 = 'o_namida4'
        # eyelashes names:
        eline1 = 'o_eyelashes'
        eline2 = 'o_eyelashes1'
        eline3 = 'o_eyelashes2'
        eline4 = 'o_eyelashes3'
        eline5 = 'o_eyelashes4'
        # eyeL names:
        eyeL1 = 'o_eyebase_L'
        eyeL2 = 'o_eyebase_L1'
        eyeL3 = 'o_eyebase_L2'
        eyeL4 = 'o_eyebase_L3'
        eyeL5 = 'o_eyebase_L4'
        # eyeR names:
        #eyeR1 = 'cf_O_eye_R'
        #eyeR2 = 'cf_O_eye_R1'
        #eyeR3 = 'cf_O_eye_R2'
        #eyeR4 = 'cf_O_eye_R3'
        #eyeR5 = 'cf_O_eye_R4'
        #Dont edit this#
        bpy.ops.object.select_all(action='DESELECT') # Deselecciona todo en la escena
        for o in ("cf_O_eyeline_low", "Highlight_cf_O_face_rend", "Highlight_o_body_a_rend", "o_shadowcaster", "o_eyeshadow"):
            obj = bpy.context.scene.objects.get(o)
            #if obj: obj.hide_viewport = False
            if obj is not None:
                obj.hide_set(True)
                obj.hide_render = True
        bpy.ops.object.select_all(action='DESELECT') # Deselecciona todo en la escena
        #############################################################################
        mesh = [m for m in bpy.context.scene.objects if m.type == 'MESH']
        for obj in bpy.data.objects:
            if obj.name.endswith("_u") or obj.name.endswith("_U") is not obj.name.startswith("cf_hair_sklx"):
                obj.select_set(state=True)
                obj.hide_set(True)
                obj.hide_render = True
            continue
        w = bpy.data.objects.get
        bpimg = bpy.data.images.get
        #####################################BODY####################################
        bpy.ops.object.select_all(action='DESELECT') # Deselecciona todo en la escena
        # Get body object
        bodies = (w(body1), w(body2))
        for x in bodies:
            if x is not None:
                #if bpy.data.objects.get(body1) is not None:
                op = (x.name)
                bpy.data.objects.get(op).select_set(True)
                outline_body = bpy.data.objects.get(op)
                bpy.context.view_layer.objects.active = outline_body
                o  = bpy.context.object
                ms = o.material_slots
                n_to_remove = 1 # Change this number to decide how many material slots to remove
                for i in range( len(ms) - 1, len(ms) - n_to_remove - 1, -1):
                    o.active_material_index = i
                    bpy.ops.object.material_slot_remove()
                ob = bpy.context.selected_objects
                material_set = set()
                for object in bpy.context.selected_objects:
                    for material in object.material_slots:
                        material_set.add(material)
                for material in material_set:
                #    print(material.name)
                    Tex = material.name
                    bpy.data.scenes['Scene'].sna_color01 = bpy.data.materials[Tex].node_tree.nodes['Principled BSDF'].inputs[0].default_value
                    bpy.data.node_groups['HS2-Template Body'].nodes['Color-Value'].outputs[0].default_value = bpy.data.scenes['Scene'].sna_color01
                    TexMain = Tex+'_MainTex.png'
                    TexDMT = Tex+'_DetailMainTex.png'
                    TexOcclusionM = Tex+'_OcclusionMap.png'
                    TexDGM = Tex+'_DetailGlossMap.png'
                    TexTex3 = Tex+'_Texture3.png'
                    TexNailM = Tex+'_NailMask.png'
                    TexTex2 = Tex+'_Texture2.png'
                    TexBump = Tex+'_BumpMap.png'
                    TexBump2 = Tex+'_BumpMap2.png'
                    TexWetMK = Tex+'_WeatheringMask.png'
                    TexWetMP = Tex+'_WeatheringMap.png'
                mat = bpy.data.materials[Tex]
                #Get the node in its node tree (replace the name below)
                node_to_delete =  mat.node_tree.nodes['Principled BSDF']
                node_to_delete2 =  mat.node_tree.nodes['Material Output']
                #Remove it
                mat.node_tree.nodes.remove( node_to_delete )
                mat.node_tree.nodes.remove( node_to_delete2 )
                bpy.data.images['mat_body_preset_MainTex.png'].name = TexMain
                bpy.data.images['mat_body_preset_DetailMainTex.png'].name = TexDMT
                bpy.data.images['mat_body_preset_OcclusionMap.png'].name = TexOcclusionM
                bpy.data.images['mat_body_preset_DetailGlossMap.png'].name = TexDGM
                bpy.data.images['mat_body_preset_NailMask.png'].name = TexNailM
                bpy.data.images['mat_body_preset_BumpMap.png'].name = TexBump
                bpy.data.images['mat_body_preset_BumpMap2.png'].name = TexBump2
                bpy.data.images['mat_body_preset_Texture2.png'].name = TexTex2
                bpy.data.images['mat_body_preset_Texture3.png'].name = TexTex3
                bpy.data.images['mat_body_preset_WeatheringMask.png'].name = TexWetMK
                bpy.data.images['mat_body_preset_WeatheringMap.png'].name = TexWetMP
                bpy.data.images[TexMain].filepath = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexMain
                bpy.data.images[TexMain].filepath_raw = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexMain
                bpy.data.images[TexDMT].filepath = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexDMT
                bpy.data.images[TexDMT].filepath_raw = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexDMT
                bpy.data.images[TexOcclusionM].filepath = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexOcclusionM
                bpy.data.images[TexOcclusionM].filepath_raw = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexOcclusionM
                bpy.data.images[TexDGM].filepath = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexDGM
                bpy.data.images[TexDGM].filepath_raw = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexDGM
                bpy.data.images[TexNailM].filepath = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexNailM
                bpy.data.images[TexNailM].filepath_raw = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexNailM
                bpy.data.images[TexBump].filepath = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexBump
                bpy.data.images[TexBump].filepath_raw = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexBump
                bpy.data.images[TexBump2].filepath = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexBump2
                bpy.data.images[TexBump2].filepath_raw = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexBump2
                bpy.data.images[TexTex2].filepath = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexTex2
                bpy.data.images[TexTex2].filepath_raw = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexTex2
                bpy.data.images[TexTex3].filepath = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexTex3
                bpy.data.images[TexTex3].filepath_raw = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexTex3
                bpy.data.images[TexWetMK].filepath = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexWetMK
                bpy.data.images[TexWetMK].filepath_raw = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexWetMK
                bpy.data.images[TexWetMP].filepath = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexWetMP
                bpy.data.images[TexWetMP].filepath_raw = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexWetMP
                C = bpy.context

                def instantiate_group(nodes, data_block_name):
                    group = nodes.new(type='ShaderNodeGroup')
                    group.node_tree = bpy.data.node_groups['HS2-Template Body']
                    return group
                instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
                bpy.context.object.active_material.blend_method = 'CLIP'
                bpy.context.object.active_material.shadow_method = 'CLIP'
                my_mat = bpy.data.materials.get(Tex)
                bpy.data.node_groups['HS2-Template Body'].name = 'HS2-Template Body '+Tex
                node = bpy.data.node_groups['HS2-Template Body '+Tex]
                nodes = my_mat.node_tree.nodes
                for node in nodes:
                    node.select = False
                    node.select = True
                    nodes.active = node
                try:
                    initial_area_type = bpy.context.area.type
                    bpy.context.area.type = 'NODE_EDITOR'
                    bpy.context.area.ui_type = 'ShaderNodeTree'
                    bpy.ops.wm.redraw_timer(type='DRAW_WIN', iterations=1)
                    bpy.ops.node.group_ungroup()
                    bpy.ops.node.group_edit(exit=True)
                except Exception as e:
                    print(e)
                finally:
                    bpy.context.area.type = initial_area_type
                break
        bpy.ops.object.select_all(action='DESELECT') # Deselecciona todo en la escena
        ####################################FACE#####################################
        bpy.ops.object.select_all(action='DESELECT') # Deselecciona todo en la escena
        # Get face object
        faces = (w(face1),w(face2),w(face3),w(face4),w(face5))
        for x in faces:
            if x is not None:
                #if bpy.data.objects.get(face1) is not None:
                op = (x.name)
                bpy.data.objects.get(op).select_set(True)
                outline_face = bpy.data.objects.get(op)
                bpy.context.view_layer.objects.active = outline_face
                #o  = bpy.context.object
                #ms = o.material_slots
                #n_to_remove = 1 # Change this number to decide how many material slots to remove
                #for i in range( len(ms) - 1, len(ms) - n_to_remove - 1, -1):
                #    o.active_material_index = i
                #    bpy.ops.object.material_slot_remove()
                ob = bpy.context.selected_objects
                material_set = set()
                for object in bpy.context.selected_objects:
                    for material in object.material_slots:
                        material_set.add(material)
                for material in material_set:
                #    print(material.name)
                    Tex = material.name
                    bpy.data.scenes['Scene'].sna_color02 = bpy.data.materials[Tex].node_tree.nodes['Principled BSDF'].inputs[0].default_value
                    bpy.data.node_groups['HS2-Template Face'].nodes['Color-Value'].outputs[0].default_value = bpy.data.scenes['Scene'].sna_color02
                    TexMain = Tex+'_MainTex.png'
                    TexDMT = Tex+'_DetailMainTex.png'
                    TexOcclusionM = Tex+'_OcclusionMap.png'
                    TexDGM = Tex+'_DetailGlossMap.png'
                    TexTex3 = Tex+'_Texture3.png'
                    TexWetMK = Tex+'_WeatheringMask.png'
                    TexWetMP = Tex+'_WeatheringMap.png'
                    TexBump = Tex+'_BumpMap.png'
                    TexBump2 = Tex+'_BumpMap2.png'
                    TexNailM = Tex+'_NailMask.png'
                mat = bpy.data.materials[Tex]
                #Get the node in its node tree (replace the name below)
                node_to_delete =  mat.node_tree.nodes['Principled BSDF']
                node_to_delete2 =  mat.node_tree.nodes['Material Output']
                #Remove it
                mat.node_tree.nodes.remove(node_to_delete)
                mat.node_tree.nodes.remove(node_to_delete2)
                bpy.data.images['mat_head_preset_MainTex.png'].name = TexMain
                bpy.data.images['mat_head_preset_DetailMainTex.png'].name = TexDMT
                bpy.data.images['mat_head_preset_OcclusionMap.png'].name = TexOcclusionM
                bpy.data.images['mat_head_preset_DetailGlossMap.png'].name = TexDGM
                bpy.data.images['mat_head_preset_BumpMap.png'].name = TexBump
                bpy.data.images['mat_head_preset_BumpMap2.png'].name = TexBump2
                bpy.data.images['mat_head_preset_Texture3.png'].name = TexTex3
                bpy.data.images['mat_head_preset_WeatheringMask.png'].name = TexWetMK
                bpy.data.images['mat_head_preset_WeatheringMap.png'].name = TexWetMP
                bpy.data.images['mat_head_preset_NailMask.png'].name = TexNailM
                bpy.data.images[TexMain].filepath = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexMain
                bpy.data.images[TexMain].filepath_raw = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexMain
                bpy.data.images[TexDMT].filepath = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexDMT
                bpy.data.images[TexDMT].filepath_raw = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexDMT
                bpy.data.images[TexOcclusionM].filepath = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexOcclusionM
                bpy.data.images[TexOcclusionM].filepath_raw = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexOcclusionM
                bpy.data.images[TexDGM].filepath = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexDGM
                bpy.data.images[TexDGM].filepath_raw = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexDGM
                bpy.data.images[TexNailM].filepath = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexNailM
                bpy.data.images[TexNailM].filepath_raw = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexNailM
                bpy.data.images[TexBump].filepath = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexBump
                bpy.data.images[TexBump].filepath_raw = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexBump
                bpy.data.images[TexBump2].filepath = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexBump2
                bpy.data.images[TexBump2].filepath_raw = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexBump2
                bpy.data.images[TexTex3].filepath = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexTex3
                bpy.data.images[TexTex3].filepath_raw = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexTex3
                bpy.data.images[TexWetMK].filepath = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexWetMK
                bpy.data.images[TexWetMK].filepath_raw = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexWetMK
                bpy.data.images[TexWetMP].filepath = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexWetMP
                bpy.data.images[TexWetMP].filepath_raw = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexWetMP
                C = bpy.context

                def instantiate_group(nodes, data_block_name):
                    group = nodes.new(type='ShaderNodeGroup')
                    group.node_tree = bpy.data.node_groups['HS2-Template Face']
                    return group
                instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
                my_mat = bpy.data.materials.get(Tex)
                bpy.data.node_groups['HS2-Template Face'].name = 'HS2-Template Face '+Tex
                node = bpy.data.node_groups['HS2-Template Face '+Tex]
                #node.extension = 'CLIP'
                #node.image = bpy.data.images[bakefinal.name]
                nodes = my_mat.node_tree.nodes
                for node in nodes:
                    node.select = False
                    node.select = True
                    nodes.active = node
                try:
                    initial_area_type = bpy.context.area.type
                    bpy.context.area.type = 'NODE_EDITOR'
                    bpy.context.area.ui_type = 'ShaderNodeTree'
                    bpy.ops.wm.redraw_timer(type='DRAW_WIN', iterations=1)
                    bpy.ops.node.group_ungroup()
                    bpy.ops.node.group_edit(exit=True)
                except Exception as e:
                    print(e)
                finally:
                    bpy.context.area.type = initial_area_type
                break
        bpy.ops.object.select_all(action='DESELECT') # Deselecciona todo en la escena
        #################################NIPPLES#####################################
        #bpy.ops.object.select_all(action='DESELECT') # Deselecciona todo en la escena
        ## Get shoes object
        #nipplescoll = ( w(nip1), w(nip2), w(nip3), w(nip4))
        #for x in nipplescoll:
        #    if x is not None:
        #        #if bpy.data.objects.get(body1) is not None:
        #        op = (x.name)
        #        bpy.data.objects.get(op).select_set(True)
        #        outline_nipples = bpy.data.objects.get(op)
        #        bpy.context.view_layer.objects.active = outline_nipples
        #        ob = bpy.context.selected_objects
        #        material_set = set()
        #        for object in bpy.context.selected_objects:
        #            for material in object.material_slots:
        #                material_set.add(material)
        #        for material in material_set:
        #        #    print(material.name)
        #            Tex = material.name
        #        if bpimg(Tex+"_MainTex.png") is None:
        #            #print(Tex+'_MainTex.png')
        #            TexMain = Tex+'_MainTex.png'
        #            TexSpecGM = Tex+'_SpecGlossMap.png'
        #            TexBump = Tex+'_BumpMap.png'
        #            
        #            mat = bpy.data.materials[Tex]
        #            #Get the node in its node tree (replace the name below)
        #            node_to_delete =  mat.node_tree.nodes['Principled BSDF']
        #            node_to_delete2 =  mat.node_tree.nodes['Material Output']
        #            #Remove it
        #            mat.node_tree.nodes.remove(node_to_delete)
        #            mat.node_tree.nodes.remove(node_to_delete2)
        #        
        #            imgsocks = ( bpimg('cf_m_nip_00_00_00_MainTex.png'), bpimg('amaterasu'))
        #            for x in imgsocks:
        #                if x is not None:
        #                    bpy.data.images['cf_m_nip_00_00_00_MainTex.png'].name = TexMain
        #                    bpy.data.images['cf_m_nip_00_00_00_SpecGlossMap.png'].name = TexSpecGM
        #                    bpy.data.images['cf_m_nip_00_00_00_BumpMap.png'].name = TexBump
        #                    bpy.data.images[TexMain].filepath = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexMain
        #                    bpy.data.images[TexMain].filepath_raw = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexMain
        #                    
        #                    bpy.data.images[TexSpecGM].filepath = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexSpecGM
        #                    bpy.data.images[TexSpecGM].filepath_raw = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexSpecGM
        #                    
        #                    bpy.data.images[TexBump].filepath = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexBump
        #                    
        #                    bpy.data.images[TexBump].filepath_raw = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexBump
        #            C = bpy.context
        #            def instantiate_group(nodes, data_block_name):
        #                group = nodes.new(type='ShaderNodeGroup')
        #                group.node_tree = bpy.data.node_groups['HS1-Template Nip']
        #                return group
        #            instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
        #            
        #            bpy.context.object.active_material.blend_method = 'HASHED'
        #            bpy.context.object.active_material.shadow_method = 'HASHED'
        #            
        #            my_mat = bpy.data.materials.get(Tex)
        #            
        #            bpy.data.node_groups['HS1-Template Nip'].name = 'HS1-Template Nip '+Tex
        #            
        #            node = bpy.data.node_groups['HS1-Template Nip '+Tex]
        #            #node.extension = 'CLIP'
        #            #node.image = bpy.data.images[bakefinal.name]
        #            nodes = my_mat.node_tree.nodes
        #            for node in nodes:
        #                node.select = False
        #                node.select = True
        #                nodes.active = node
        #            try:
        #                initial_area_type = bpy.context.area.type
        #                bpy.context.area.type = 'NODE_EDITOR'
        #                bpy.context.area.ui_type = 'ShaderNodeTree'
        #                bpy.ops.wm.redraw_timer(type='DRAW_WIN', iterations=1)
        #                bpy.ops.node.group_ungroup()
        #                bpy.ops.node.group_edit(exit=True)
        #            except Exception as e:
        #                print(e)
        #            finally:
        #                bpy.context.area.type = initial_area_type
        #            break
        #        else:
        #            continue
        #bpy.ops.object.select_all(action='DESELECT') # Deselecciona todo en la escena
        ##################################FRONT HAIR#################################
        bpy.ops.object.select_all(action='DESELECT') # Deselecciona todo en la escena
        # Get hairf object
        hairfronts = ( w(fronth1), w(fronth2), w(fronth3), w(fronth4), w(fronth5), w(fronth6), w(fronth7), w(fronth8), w(fronth9), w(fronth10), w(fronth11), w(fronth12), w(fronth13), w(fronth14), w(fronth15), w(fronth16), w(fronth17), w(fronth18), w(fronth19), w(fronth20), w(fronth21), w(fronth22), w(fronth23), w(fronth24), w(fronth25), w(fronth26), w(fronth27), w(fronth28), w(fronth29), w(fronth30), w(fronth31), w(fronth32), w(fronth33), w(fronth34), w(fronth35), w(fronth36), w(fronth37), w(fronth38), w(fronth39), w(fronth40), w(fronth41), w(fronth42), w(fronth43), w(fronth44), w(fronth45), w(fronth46), w(fronth47), w(fronth48), w(fronth49), w(fronth50), w(fronth51), w(fronth52), w(fronth53), w(fronth54), w(fronth55), w(fronth56), w(fronth57), w(fronth58), w(fronth59), w(fronth60), w(fronth61), w(fronth62), w(fronth63), w(fronth64), w(fronth65), w(fronth66), w(fronth67), w(fronth68), w(fronth69), w(fronth70), w(fronth71), w(fronth72), w(fronth73), w(fronth74), w(fronth75), w(fronth76), w(fronth77), w(fronth78), w(fronth79), w(fronth80), w(fronth81), w(fronth82), w(fronth83), w(fronth84), w(fronth85), w(fronth86), w(fronth87), w(fronth88), w(fronth89), w(fronth90), w(fronth91), w(fronth92), w(fronth93), w(fronth94), w(fronth95), w(fronth96), w(fronth97), w(fronth98), w(fronth99), w(fronth100), w(fronth101), w(fronth102), w(fronth103), w(fronth104), w(fronth105), w(fronth106), w(fronth107), w(fronth108), w(fronth109), w(fronth110), w(fronth111), w(fronth112), w(fronth113), w(fronth114), w(fronth115), w(fronth116), w(fronth117), w(fronth118), w(fronth119), w(fronth120), w(fronth121), w(fronth122), w(fronth123), w(fronth124), w(fronth125), w(fronth126), w(fronth127), w(fronth128), w(fronth129), w(fronth130), w(fronth131), w(fronth132), w(fronth133), w(fronth134), w(fronth135), w(fronth136), w(fronth137), w(fronth138), w(fronth139), w(fronth140), w(fronth141), w(fronth142), w(fronth143), w(fronth144), w(fronth145), w(fronth146), w(fronth147), w(fronth148), w(fronth149), w(fronth150), w(fronth151), w(fronth152), w(fronth153), w(fronth154), w(fronth155), w(fronth156), w(fronth157), w(fronth158), w(fronth159), w(fronth160), w(fronth161), w(fronth162), w(fronth163), w(fronth164), w(fronth165), w(fronth166), w(fronth167), w(fronth168), w(fronth169), w(fronth170), w(fronth171), w(fronth172), w(fronth173), w(fronth174), w(fronth175), w(fronth176), w(fronth177), w(fronth178), w(fronth179), w(fronth180), w(fronth181), w(fronth182), w(fronth183), w(fronth184), w(fronth185), w(fronth186), w(fronth187), w(fronth188), w(fronth189), w(fronth190), w(fronth191), w(fronth192), w(fronth193), w(fronth194), w(fronth195), w(fronth196), w(fronth197), w(fronth198), w(fronth199), w(fronth200), w(fronth201), w(fronth202), w(fronth203), w(fronth204), w(fronth205), w(fronth206), w(fronth207), w(fronth208), w(fronth209), w(fronth210), w(fronth211), w(fronth212), w(fronth213), w(fronth214), w(fronth215), w(fronth216), w(fronth217), w(fronth218), w(fronth219), w(fronth220), w(fronth221), w(fronth222), w(fronth223), w(fronth224), w(fronth225), w(fronth226), w(fronth227), w(fronth228), w(fronth229), w(fronth230), w(fronth231), w(fronth232), w(fronth233), w(fronth234), w(fronth235), w(fronth236), w(fronth237), w(fronth238), w(fronth239), w(fronth240), w(fronth241), w(fronth242), w(fronth243), w(fronth244), w(fronth245), w(fronth246), w(fronth247), w(fronth248), w(fronth249), w(fronth250), w(fronth251), w(fronth252), w(fronth253), w(fronth254), w(fronth255), w(fronth256), w(fronth257), w(fronth258), w(fronth259), w(fronth260), w(fronth261), w(fronth262), w(fronth263), w(fronth264), w(fronth265), w(fronth266), w(fronth267), w(fronth268), w(fronth269), w(fronth270), w(fronth271), w(fronth272), w(fronth273), w(fronth274), w(fronth275), w(fronth276), w(fronth277), w(fronth278), w(fronth279), w(fronth280), w(fronth281), w(fronth282), w(fronth283), w(fronth284), w(fronth285), w(fronth286), w(fronth287), w(fronth288), w(fronth289), w(fronth290), w(fronth291), w(fronth292), w(fronth293), w(fronth294), w(fronth295), w(fronth296), w(fronth297), w(fronth298), w(fronth299), w(fronth300), w(fronth301), w(fronth302), w(fronth303), w(fronth304), w(fronth305), w(fronth306), w(fronth307), w(fronth308), w(fronth309), w(fronth310), w(fronth311), w(fronth312), w(fronth313), w(fronth314), w(fronth315), w(fronth316), w(fronth317), w(fronth318), w(fronth319), w(fronth320), w(fronth321), w(fronth322), w(fronth323), w(fronth324), w(fronth325), w(fronth326), w(fronth327), w(fronth328), w(fronth329), w(fronth330), w(fronth331), w(fronth332), w(fronth333), w(fronth334), w(fronth335), w(fronth336), w(fronth337), w(fronth338), w(fronth339), w(fronth340), w(fronth341), w(fronth342), w(fronth343), w(fronth344), w(fronth345), w(fronth346), w(fronth347), w(fronth348), w(fronth349), w(fronth350), w(fronth351), w(fronth352), w(fronth353), w(fronth354), w(fronth355), w(fronth356), w(fronth357), w(fronth358), w(fronth359), w(fronth360), w(fronth361), w(fronth362), w(fronth363), w(fronth364), w(fronth365), w(fronth366), w(fronth367), w(fronth368), w(fronth369), w(fronth370), w(fronth371), w(fronth372), w(fronth373), w(fronth374), w(fronth375), w(fronth376), w(fronth377), w(fronth378), w(fronth379), w(fronth380), w(fronth381), w(fronth382), w(fronth383), w(fronth384), w(fronth385), w(fronth386), w(fronth387), w(fronth388), w(fronth389), w(fronth390), w(fronth391), w(fronth392), w(fronth393), w(fronth394), w(fronth395), w(fronth396), w(fronth397), w(fronth398), w(fronth399), w(fronth400), w(fronth401), w(fronth402), w(fronth403), w(fronth404), w(fronth405), w(fronth406), w(fronth407), w(fronth408), w(fronth409), w(fronth410), w(fronth411), w(fronth412), w(fronth413), w(fronth414), w(fronth415), w(fronth416), w(fronth417), w(fronth418), w(fronth419), w(fronth420), w(fronth421), w(fronth422), w(fronth423), w(fronth424), w(fronth425), w(fronth426), w(fronth427), w(fronth428), w(fronth429), w(fronth430), w(fronth431), w(fronth432), w(fronth433), w(fronth434), w(fronth435), w(fronth436), w(fronth437), w(fronth438), w(fronth439), w(fronth440), w(fronth441), w(fronth442), w(fronth443), w(fronth444), w(fronth445), w(fronth446), w(fronth447), w(fronth448), w(fronth449), w(fronth450), w(fronth451), w(fronth452), w(fronth453), w(fronth454), w(fronth455), w(fronth456), w(fronth457), w(fronth458), w(fronth459), w(fronth460), w(fronth461), w(fronth462), w(fronth463), w(fronth464), w(fronth465), w(fronth466), w(fronth467), w(fronth468), w(fronth469), w(fronth470), w(fronth471), w(fronth472), w(fronth473), w(fronth474), w(fronth475), w(fronth476), w(fronth477), w(fronth478), w(fronth479), w(fronth480), w(fronth481), w(fronth482), w(fronth483), w(fronth484), w(fronth485), w(fronth486), w(fronth487), w(fronth488), w(fronth489), w(fronth490), w(fronth491), w(fronth492), w(fronth493), w(fronth494), w(fronth495), w(fronth496), w(fronth497), w(fronth498), w(fronth499), w(fronth500), w(fronth501), w(fronth502), w(fronth503), w(fronth504), w(fronth505), w(fronth506), w(fronth507), w(fronth508), w(fronth509), w(fronth510), w(fronth511), w(fronth512), w(fronth513), w(fronth514), w(fronth515), w(fronth516), w(fronth517), w(fronth518), w(fronth519), w(fronth520), w(fronth521), w(fronth522), w(fronth523), w(fronth524), w(fronth525), w(fronth526), w(fronth527), w(fronth528), w(fronth529), w(fronth530), w(fronth531), w(fronth532), w(fronth533), w(fronth534), w(fronth535), w(fronth536), w(fronth537), w(fronth538), w(fronth539), w(fronth540), w(fronth541), w(fronth542), w(fronth543), w(fronth544), w(fronth545), w(fronth546), w(fronth547), w(fronth548), w(fronth549), w(fronth550), w(fronth551), w(fronth552), w(fronth553), w(fronth554), w(fronth555), w(fronth556), w(fronth557), w(fronth558), w(fronth559), w(fronth560), w(fronth561), w(fronth562), w(fronth563), w(fronth564), w(fronth565), w(fronth566), w(fronth567), w(fronth568), w(fronth569), w(fronth570), w(fronth571), w(fronth572), w(fronth573), w(fronth574), w(fronth575), w(fronth576), w(fronth577), w(fronth578), w(fronth579), w(fronth580), w(fronth581), w(fronth582), w(fronth583), w(fronth584), w(fronth585), w(fronth586), w(fronth587), w(fronth588), w(fronth589), w(fronth590), w(fronth591), w(fronth592), w(fronth593), w(fronth594), w(fronth595), w(fronth596), w(fronth597), w(fronth598), w(fronth599), w(fronth600), w(fronth601), w(fronth602), w(fronth603), w(fronth604), w(fronth605), w(fronth606), w(fronth607), w(fronth608), w(fronth609), w(fronth610), w(fronth611), w(fronth612), w(fronth613), w(fronth614), w(fronth615))
        for x in hairfronts:
            if x is not None:
                #if bpy.data.objects.get(body1) is not None:
                op = (x.name)
                bpy.data.objects.get(op).select_set(True)
                outline_hfront = bpy.data.objects.get(op)
                bpy.context.view_layer.objects.active = outline_hfront
                ob = bpy.context.selected_objects
                material_set = set()
                for object in bpy.context.selected_objects:
                    for material in object.material_slots:
                        material_set.add(material)
                for material in material_set:
                #    print(material.name)
                    Tex = material.name
                if bpimg(Tex+"_MainTex.png") is None:
                    TexMain = Tex+'_MainTex.png'
                    TexOcclusion = Tex+'_Occlusion.png'
                    TexColorM = Tex+'_ColorMask.png'
                    TexBump = Tex+'_BumpMap.png'
                    TexDetailM = Tex+'_DetailMask.png'
                    bpy.data.scenes['Scene'].sna_color03 = bpy.data.materials[Tex].node_tree.nodes['Principled BSDF'].inputs[0].default_value
                    bpy.data.node_groups['HS2-Template Front Hair'].nodes['HF-Color-Value'].outputs[0].default_value = bpy.data.scenes['Scene'].sna_color03
                    imghairf = ( bpimg('mat_hair_preset_MainTex.png'), bpimg('tenseigan'))
                    for x in imghairf:
                        if x is not None:
                            bpy.data.images['mat_hair_preset_MainTex.png'].name = TexMain 
                            bpy.data.images['mat_hair_preset_Occlusion.png'].name = TexOcclusion
                            bpy.data.images['mat_hair_preset_ColorMask.png'].name = TexColorM
                            bpy.data.images['mat_hair_preset_BumpMap.png'].name = TexBump
                            bpy.data.images['mat_hair_preset_DetailMask.png'].name = TexDetailM
                            bpy.data.images[TexMain].filepath = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexMain
                            bpy.data.images[TexMain].filepath_raw = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexMain
                            bpy.data.images[TexOcclusion].filepath = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexOcclusion
                            bpy.data.images[TexOcclusion].filepath_raw = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexOcclusion
                            bpy.data.images[TexColorM].filepath = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexColorM
                            bpy.data.images[TexColorM].filepath_raw = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexColorM
                            bpy.data.images[TexBump].filepath = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexBump
                            bpy.data.images[TexBump].filepath_raw = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexBump
                            bpy.data.images[TexDetailM].filepath = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexDetailM
                            bpy.data.images[TexDetailM].filepath_raw = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexDetailM
                    mat = bpy.data.materials[Tex]
                    #Get the node in its node tree (replace the name below)
                    node_to_delete =  mat.node_tree.nodes['Principled BSDF']
                    node_to_delete2 =  mat.node_tree.nodes['Material Output']
                    #Remove it
                    mat.node_tree.nodes.remove(node_to_delete)
                    mat.node_tree.nodes.remove(node_to_delete2)
                    C = bpy.context

                    def instantiate_group(nodes, data_block_name):
                        group = nodes.new(type='ShaderNodeGroup')
                        group.node_tree = bpy.data.node_groups['HS2-Template Front Hair']
                        return group
                    instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
                    bpy.context.object.active_material.blend_method = 'HASHED'
                    bpy.context.object.active_material.shadow_method = 'HASHED'
                    my_mat = bpy.data.materials.get(Tex)
                    bpy.data.node_groups['HS2-Template Front Hair'].name = 'HS2-Template FH '+Tex
                    node = bpy.data.node_groups['HS2-Template FH '+Tex]
                    #node.extension = 'CLIP'
                    #node.image = bpy.data.images[bakefinal.name]
                    nodes = my_mat.node_tree.nodes
                    for node in nodes:
                        node.select = False
                        node.select = True
                        nodes.active = node
                    try:
                        initial_area_type = bpy.context.area.type
                        bpy.context.area.type = 'NODE_EDITOR'
                        bpy.context.area.ui_type = 'ShaderNodeTree'
                        bpy.ops.wm.redraw_timer(type='DRAW_WIN', iterations=1)
                        bpy.ops.node.group_ungroup()
                        bpy.ops.node.group_edit(exit=True)
                    except Exception as e:
                        print(e)
                    finally:
                        bpy.context.area.type = initial_area_type
                    break
                else:
                    continue
        bpy.ops.object.select_all(action='DESELECT') # Deselecciona todo en la escena
        ##################################BACK HAIR##################################
        bpy.ops.object.select_all(action='DESELECT') # Deselecciona todo en la escena
        # Get hairb object
        hairbacks = ( w(backh1), w(backh2), w(backh3), w(backh4), w(backh5), w(backh6), w(backh7), w(backh8), w(backh9), w(backh10), w(backh11), w(backh12), w(backh13), w(backh14), w(backh15), w(backh16), w(backh17), w(backh18), w(backh19), w(backh20), w(backh21), w(backh22), w(backh23), w(backh24), w(backh25), w(backh26), w(backh27), w(backh28), w(backh29), w(backh30), w(backh31), w(backh32), w(backh33), w(backh34), w(backh35), w(backh36), w(backh37), w(backh38), w(backh39), w(backh40), w(backh41), w(backh42), w(backh43), w(backh44), w(backh45), w(backh46), w(backh47), w(backh48), w(backh49), w(backh50), w(backh51), w(backh52), w(backh53), w(backh54), w(backh55), w(backh56), w(backh57), w(backh58), w(backh59), w(backh60), w(backh61), w(backh62), w(backh63), w(backh64), w(backh65), w(backh66), w(backh67), w(backh68), w(backh69), w(backh70), w(backh71), w(backh72), w(backh73), w(backh74), w(backh75), w(backh76), w(backh77), w(backh78), w(backh79), w(backh80), w(backh81), w(backh82), w(backh83), w(backh84), w(backh85), w(backh86), w(backh87), w(backh88), w(backh89), w(backh90), w(backh91), w(backh92), w(backh93), w(backh94), w(backh95), w(backh96), w(backh97), w(backh98), w(backh99), w(backh100), w(backh101), w(backh102), w(backh103), w(backh104), w(backh105), w(backh106), w(backh107), w(backh108), w(backh109), w(backh110), w(backh111), w(backh112), w(backh113), w(backh114), w(backh115), w(backh116), w(backh117), w(backh118), w(backh119), w(backh120), w(backh121), w(backh122), w(backh123), w(backh124), w(backh125), w(backh126), w(backh127), w(backh128), w(backh129), w(backh130), w(backh131), w(backh132), w(backh133), w(backh134), w(backh135), w(backh136), w(backh137), w(backh138), w(backh139), w(backh140), w(backh141), w(backh142), w(backh143), w(backh144), w(backh145), w(backh146), w(backh147), w(backh148), w(backh149), w(backh150), w(backh151), w(backh152), w(backh153), w(backh154), w(backh155), w(backh156), w(backh157), w(backh158), w(backh159), w(backh160), w(backh161), w(backh162), w(backh163), w(backh164), w(backh165), w(backh166), w(backh167), w(backh168), w(backh169), w(backh170), w(backh171), w(backh172), w(backh173), w(backh174), w(backh175), w(backh176), w(backh177), w(backh178), w(backh179), w(backh180), w(backh181), w(backh182), w(backh183), w(backh184), w(backh185), w(backh186), w(backh187), w(backh188), w(backh189), w(backh190), w(backh191), w(backh192), w(backh193), w(backh194), w(backh195), w(backh196), w(backh197), w(backh198), w(backh199), w(backh200), w(backh201), w(backh202), w(backh203), w(backh204), w(backh205), w(backh206), w(backh207), w(backh208), w(backh209), w(backh210), w(backh211), w(backh212), w(backh213), w(backh214), w(backh215), w(backh216), w(backh217), w(backh218), w(backh219), w(backh220), w(backh221), w(backh222), w(backh223), w(backh224), w(backh225), w(backh226), w(backh227), w(backh228), w(backh229), w(backh230), w(backh231), w(backh232), w(backh233), w(backh234), w(backh235), w(backh236), w(backh237), w(backh238), w(backh239), w(backh240), w(backh241), w(backh242), w(backh243), w(backh244), w(backh245), w(backh246), w(backh247), w(backh248), w(backh249), w(backh250), w(backh251), w(backh252), w(backh253), w(backh254), w(backh255), w(backh256), w(backh257), w(backh258), w(backh259), w(backh260), w(backh261), w(backh262), w(backh263), w(backh264), w(backh265), w(backh266), w(backh267), w(backh268), w(backh269), w(backh270), w(backh271), w(backh272), w(backh273), w(backh274), w(backh275), w(backh276), w(backh277), w(backh278), w(backh279), w(backh280), w(backh281), w(backh282), w(backh283), w(backh284), w(backh285), w(backh286), w(backh287), w(backh288), w(backh289), w(backh290), w(backh291), w(backh292), w(backh293), w(backh294), w(backh295), w(backh296), w(backh297), w(backh298), w(backh299), w(backh300), w(backh301), w(backh302), w(backh303), w(backh304), w(backh305), w(backh306), w(backh307), w(backh308), w(backh309), w(backh310), w(backh311), w(backh312), w(backh313), w(backh314), w(backh315), w(backh316), w(backh317), w(backh318), w(backh319), w(backh320), w(backh321), w(backh322), w(backh323), w(backh324), w(backh325), w(backh326), w(backh327), w(backh328), w(backh329), w(backh330), w(backh331), w(backh332), w(backh333), w(backh334), w(backh335), w(backh336), w(backh337), w(backh338), w(backh339), w(backh340), w(backh341), w(backh342), w(backh343), w(backh344), w(backh345), w(backh346), w(backh347), w(backh348), w(backh349), w(backh350), w(backh351), w(backh352), w(backh353), w(backh354), w(backh355), w(backh356), w(backh357), w(backh358), w(backh359), w(backh360), w(backh361), w(backh362), w(backh363), w(backh364), w(backh365), w(backh366), w(backh367), w(backh368), w(backh369), w(backh370), w(backh371), w(backh372), w(backh373), w(backh374), w(backh375), w(backh376), w(backh377), w(backh378), w(backh379), w(backh380), w(backh381), w(backh382), w(backh383), w(backh384), w(backh385), w(backh386), w(backh387), w(backh388), w(backh389), w(backh390), w(backh391), w(backh392), w(backh393), w(backh394), w(backh395), w(backh396), w(backh397), w(backh398), w(backh399), w(backh400), w(backh401), w(backh402), w(backh403), w(backh404), w(backh405), w(backh406), w(backh407), w(backh408), w(backh409), w(backh410), w(backh411), w(backh412), w(backh413), w(backh414), w(backh415), w(backh416), w(backh417), w(backh418), w(backh419), w(backh420), w(backh421), w(backh422), w(backh423), w(backh424), w(backh425), w(backh426), w(backh427), w(backh428), w(backh429), w(backh430), w(backh431), w(backh432), w(backh433), w(backh434), w(backh435), w(backh436), w(backh437), w(backh438), w(backh439), w(backh440), w(backh441), w(backh442), w(backh443), w(backh444), w(backh445), w(backh446), w(backh447), w(backh448), w(backh449), w(backh450), w(backh451), w(backh452), w(backh453), w(backh454), w(backh455), w(backh456), w(backh457), w(backh458), w(backh459), w(backh460), w(backh461), w(backh462), w(backh463), w(backh464), w(backh465), w(backh466), w(backh467), w(backh468), w(backh469), w(backh470), w(backh471), w(backh472), w(backh473), w(backh474), w(backh475), w(backh476), w(backh477), w(backh478), w(backh479), w(backh480), w(backh481), w(backh482), w(backh483), w(backh484), w(backh485), w(backh486), w(backh487), w(backh488), w(backh489), w(backh490), w(backh491), w(backh492), w(backh493), w(backh494), w(backh495), w(backh496), w(backh497), w(backh498), w(backh499), w(backh500), w(backh501), w(backh502), w(backh503), w(backh504), w(backh505), w(backh506), w(backh507), w(backh508), w(backh509), w(backh510), w(backh511), w(backh512), w(backh513), w(backh514), w(backh515), w(backh516), w(backh517), w(backh518), w(backh519), w(backh520), w(backh521), w(backh522), w(backh523), w(backh524), w(backh525), w(backh526), w(backh527), w(backh528), w(backh529), w(backh530), w(backh531), w(backh532), w(backh533), w(backh534), w(backh535), w(backh536), w(backh537), w(backh538), w(backh539), w(backh540), w(backh541), w(backh542), w(backh543), w(backh544), w(backh545), w(backh546), w(backh547), w(backh548), w(backh549), w(backh550), w(backh551), w(backh552), w(backh553), w(backh554), w(backh555), w(backh556), w(backh557), w(backh558), w(backh559), w(backh560), w(backh561), w(backh562), w(backh563), w(backh564), w(backh565), w(backh566), w(backh567), w(backh568), w(backh569), w(backh570), w(backh571), w(backh572), w(backh573), w(backh574), w(backh575), w(backh576), w(backh577), w(backh578), w(backh579), w(backh580), w(backh581), w(backh582), w(backh583), w(backh584), w(backh585), w(backh586), w(backh587), w(backh588), w(backh589), w(backh590), w(backh591), w(backh592), w(backh593), w(backh594), w(backh595), w(backh596), w(backh597), w(backh598), w(backh599), w(backh600), w(backh601), w(backh602), w(backh603), w(backh604), w(backh605), w(backh606), w(backh607), w(backh608), w(backh609), w(backh610), w(backh611), w(backh612), w(backh613), w(backh614), w(backh615), w(backh616), w(backh617), w(backh618), w(backh619), w(backh620), w(backh621), w(backh622), w(backh623), w(backh624), w(backh625), w(backh626), w(backh627), w(backh628), w(backh629), w(backh630), w(backh631), w(backh632), w(backh633), w(backh634), w(backh635), w(backh636), w(backh637), w(backh638), w(backh639), w(backh640), w(backh641), w(backh642), w(backh643), w(backh644), w(backh645), w(backh646), w(backh647), w(backh648), w(backh649), w(backh650), w(backh651), w(backh652), w(backh653), w(backh654), w(backh655), w(backh656), w(backh657), w(backh658), w(backh659), w(backh660), w(backh661), w(backh662), w(backh663), w(backh664), w(backh665), w(backh666), w(backh667), w(backh668), w(backh669), w(backh670), w(backh671), w(backh672), w(backh673), w(backh674), w(backh675), w(backh676), w(backh677), w(backh678), w(backh679), w(backh680), w(backh681), w(backh682), w(backh683), w(backh684), w(backh685), w(backh686), w(backh687), w(backh688), w(backh689), w(backh690), w(backh691), w(backh692), w(backh693), w(backh694), w(backh695), w(backh696), w(backh697), w(backh698), w(backh699), w(backh700), w(backh701), w(backh702), w(backh703), w(backh704), w(backh705), w(backh706), w(backh707), w(backh708), w(backh709), w(backh710), w(backh711), w(backh712), w(backh713), w(backh714), w(backh715), w(backh716), w(backh717), w(backh718), w(backh719), w(backh720), w(backh721), w(backh722), w(backh723), w(backh724), w(backh725), w(backh726), w(backh727), w(backh728), w(backh729), w(backh730), w(backh731), w(backh732), w(backh733), w(backh734), w(backh735), w(backh736), w(backh737), w(backh738), w(backh739), w(backh740), w(backh741), w(backh742), w(backh743), w(backh744), w(backh745), w(backh746), w(backh747), w(backh748), w(backh749), w(backh750), w(backh751), w(backh752), w(backh753), w(backh754), w(backh755), w(backh756), w(backh757), w(backh758), w(backh759), w(backh760), w(backh761), w(backh762), w(backh763), w(backh764), w(backh765), w(backh766), w(backh767), w(backh768), w(backh769), w(backh770), w(backh771), w(backh772), w(backh773), w(backh774), w(backh775), w(backh776), w(backh777), w(backh778), w(backh779), w(backh780), w(backh781), w(backh782), w(backh783), w(backh784), w(backh785), w(backh786), w(backh787), w(backh788), w(backh789), w(backh790), w(backh791), w(backh792), w(backh793), w(backh794), w(backh795), w(backh796))
        for x in hairbacks:
            if x is not None:
                #if bpy.data.objects.get(body1) is not None:
                op = (x.name)
                bpy.data.objects.get(op).select_set(True)
                outline_hback = bpy.data.objects.get(op)
                bpy.context.view_layer.objects.active = outline_hback
                ob = bpy.context.selected_objects
                material_set = set()
                for object in bpy.context.selected_objects:
                    for material in object.material_slots:
                        material_set.add(material)
                for material in material_set:
                #    print(material.name)
                    Tex = material.name
                #  print(Tex+'_MainTex.png')
                if bpimg(Tex+"_MainTex.png") is None:
                    TexMain = Tex+'_MainTex.png'
                    TexOcclusion = Tex+'_Occlusion.png'
                    TexColorM = Tex+'_ColorMask.png'
                    TexBump = Tex+'_BumpMap.png'
                    TexDetailM = Tex+'_DetailMask.png'
                    bpy.data.scenes['Scene'].sna_color03 = bpy.data.materials[Tex].node_tree.nodes['Principled BSDF'].inputs[0].default_value
                    bpy.data.node_groups['HS2-Template Back Hair'].nodes['HB-Color-Value'].outputs[0].default_value = bpy.data.scenes['Scene'].sna_color03
                    imghairb = ( bpimg('mat_hairback_preset_MainTex.png'), bpimg('roshi'))
                    for x in imghairb:
                        if x is not None:
                            bpy.data.images['mat_hairback_preset_MainTex.png'].name = TexMain 
                            bpy.data.images['mat_hairback_preset_Occlusion.png'].name = TexOcclusion
                            bpy.data.images['mat_hairback_preset_ColorMask.png'].name = TexColorM
                            bpy.data.images['mat_hairback_preset_BumpMap.png'].name = TexBump
                            bpy.data.images['mat_hairback_preset_DetailMask.png'].name = TexDetailM
                            bpy.data.images[TexMain].filepath = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexMain
                            bpy.data.images[TexMain].filepath_raw = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexMain
                            bpy.data.images[TexOcclusion].filepath = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexOcclusion
                            bpy.data.images[TexOcclusion].filepath_raw = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexOcclusion
                            bpy.data.images[TexColorM].filepath = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexColorM
                            bpy.data.images[TexColorM].filepath_raw = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexColorM
                            bpy.data.images[TexBump].filepath = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexBump
                            bpy.data.images[TexBump].filepath_raw = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexBump
                            bpy.data.images[TexDetailM].filepath = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexDetailM
                            bpy.data.images[TexDetailM].filepath_raw = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexDetailM
                    mat = bpy.data.materials[Tex]
                    #Get the node in its node tree (replace the name below)
                    node_to_delete =  mat.node_tree.nodes['Principled BSDF']
                    node_to_delete2 =  mat.node_tree.nodes['Material Output']
                    #Remove it
                    mat.node_tree.nodes.remove(node_to_delete)
                    mat.node_tree.nodes.remove(node_to_delete2)
                    C = bpy.context

                    def instantiate_group(nodes, data_block_name):
                        group = nodes.new(type='ShaderNodeGroup')
                        group.node_tree = bpy.data.node_groups['HS2-Template Back Hair']
                        return group
                    instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
                    bpy.context.object.active_material.blend_method = 'HASHED'
                    bpy.context.object.active_material.shadow_method = 'HASHED'
                    my_mat = bpy.data.materials.get(Tex)
                    bpy.data.node_groups['HS2-Template Back Hair'].name = 'HS2-Template BH '+Tex
                    node = bpy.data.node_groups['HS2-Template BH '+Tex]
                    #node.extension = 'CLIP'
                    #node.image = bpy.data.images[bakefinal.name]
                    nodes = my_mat.node_tree.nodes
                    for node in nodes:
                        node.select = False
                        node.select = True
                        nodes.active = node
                    try:
                        initial_area_type = bpy.context.area.type
                        bpy.context.area.type = 'NODE_EDITOR'
                        bpy.context.area.ui_type = 'ShaderNodeTree'
                        bpy.ops.wm.redraw_timer(type='DRAW_WIN', iterations=1)
                        bpy.ops.node.group_ungroup()
                        bpy.ops.node.group_edit(exit=True)
                    except Exception as e:
                        print(e)
                    finally:
                        bpy.context.area.type = initial_area_type
                    break
                else:
                    continue
        bpy.ops.object.select_all(action='DESELECT') # Deselecciona todo en la escena
        ########################################TOP##################################
        bpy.ops.object.select_all(action='DESELECT') # Deselecciona todo en la escena
        ropitas = (w(top1), w(top2), w(top3), w(top4), w(top5), w(top6), w(top7), w(top8), w(top9), w(top10), w(top11), w(top12), w(top13), w(top14), w(top15), w(top16), w(top17), w(top18), w(top19), w(top20), w(top21), w(top22), w(top23), w(top24), w(top25), w(top26), w(top27), w(top28), w(top29), w(top30), w(top31), w(top32), w(top33), w(top34), w(top35), w(top36), w(top37), w(top38), w(top39), w(top40), w(top41), w(top42), w(top43), w(top44), w(top45), w(top46), w(top47), w(top48), w(top49), w(top50), w(top51), w(top52), w(top53), w(top54), w(top55), w(top56), w(top57), w(top58), w(top59), w(top60), w(top61), w(top62), w(top63), w(top64), w(top65), w(top66), w(top67), w(top68), w(top69), w(top70), w(top71), w(top72), w(top73), w(top74), w(top75), w(top76), w(top77), w(top78), w(top79), w(top80), w(top81), w(top82), w(top83), w(top84), w(top85), w(top86), w(top87), w(top88), w(top89), w(top90), w(top91), w(top92), w(top93), w(top94), w(top95), w(top96), w(top97), w(top98), w(top99), w(top100), w(top101), w(top102), w(top103), w(top104), w(top105), w(top106), w(top107), w(top108), w(top109), w(top110), w(top111), w(top112), w(top113), w(top114), w(top115), w(top116), w(top117), w(top118), w(top119), w(top120), w(top121), w(top122), w(top123), w(top124), w(top125), w(top126), w(top127), w(top128), w(top129), w(top130), w(top131), w(top132), w(top133), w(top134), w(top135), w(top136), w(top137), w(top138), w(top139), w(top140), w(top141), w(top142), w(top143), w(top144), w(top145), w(top146), w(top147), w(top148), w(top149), w(top150), w(top151), w(top152), w(top153), w(top154), w(top155), w(top156), w(top157), w(top158), w(top159), w(top160), w(top161), w(top162), w(top163), w(top164), w(top165), w(top166), w(top167), w(top168), w(top169), w(top170), w(top171), w(top172), w(top173), w(top174), w(top175), w(top176), w(top177), w(top178), w(top179), w(top180), w(top181), w(top182), w(top183), w(top184), w(top185), w(top186), w(top187), w(top188), w(top189), w(top190), w(top191), w(top192), w(top193), w(top194), w(top195), w(top196), w(top197), w(top198), w(top199), w(top200), w(top201), w(top202), w(top203), w(top204), w(top205), w(top206), w(top207), w(top208), w(top209), w(top210), w(top211), w(top212), w(top213), w(top214), w(top215), w(top216), w(top217), w(top218), w(top219), w(top220), w(top221), w(top222), w(top223), w(top224), w(top225), w(top226), w(top227), w(top228), w(top229), w(top230), w(top231), w(top232), w(top233), w(top234), w(top235), w(top236), w(top237), w(top238), w(top239), w(top240), w(top241), w(top242), w(top243), w(top244), w(top245), w(top246), w(top247), w(top248), w(top249), w(top250), w(top251), w(top252), w(top253), w(top254), w(top255), w(top256), w(top257), w(top258), w(top259), w(top260), w(top261), w(top262), w(top263), w(top264), w(top265), w(top266), w(top267), w(top268), w(top269), w(top270), w(top271), w(top272), w(top273), w(top274), w(top275), w(top276), w(top277), w(top278), w(top279), w(top280), w(top281), w(top282), w(top283), w(top284), w(top285), w(top286), w(top287), w(top288), w(top289), w(top290), w(top291), w(top292), w(top293), w(top294), w(top295), w(top296), w(top297), w(top298), w(top299), w(top300), w(top301), w(top302), w(top303), w(top304), w(top305), w(top306), w(top307), w(top308), w(top309), w(top310), w(top311), w(top312), w(top313), w(top314), w(top315), w(top316), w(top317), w(top318), w(top319), w(top320), w(top321), w(top322), w(top323), w(top324), w(top325), w(top326), w(top327), w(top328), w(top329), w(top330), w(top331), w(top332), w(top333), w(top334), w(top335), w(top336), w(top337), w(top338), w(top339), w(top340), w(top341), w(top342), w(top343), w(top344), w(top345), w(top346), w(top347), w(top348), w(top349), w(top350), w(top351), w(top352), w(top353), w(top354), w(top355), w(top356), w(top357), w(top358), w(top359), w(top360), w(top361), w(top362), w(top363), w(top364), w(top365), w(top366), w(top367), w(top368), w(top369), w(top370), w(top371), w(top372), w(top373))
        for x in ropitas:
            if x is not None:
                #if bpy.data.objects.get(body1) is not None:
                op = (x.name)
                bpy.data.objects.get(op).select_set(True)
                bpy.context.view_layer.objects.active = bpy.data.objects.get(op)
                ob = bpy.context.selected_objects
                material_set = set()
                for object in bpy.context.selected_objects:
                    for material in object.material_slots:
                        material_set.add(material)
                for material in material_set:
                    Tex = material.name
                if bpimg(Tex+"_MainTex.png") is None:    
                    bpy.data.scenes['Scene'].sna_color04 = bpy.data.materials[Tex].node_tree.nodes['Principled BSDF'].inputs[0].default_value
                    bpy.data.node_groups['HS2-Template Top'].nodes['Color-Value'].outputs[0].default_value = bpy.data.scenes['Scene'].sna_color04
                    TexMain = Tex+'_MainTex.png'
                    TexDMT = Tex+'_DetailMainTex.png'
                    TexOcclusionM = Tex+'_OcclusionMap.png'
                    TexMetallicGM = Tex+'_MetallicGlossMap.png'
                    TexDGM = Tex+'_DetailGlossMap.png'
                    TexDGM2 = Tex+'_DetailGlossMap2.png'
                    TexBump = Tex+'_BumpMap.png'
                    TexDetailM = Tex+'_DetailMask.png'
                    TexWetMK = Tex+'_WeatheringMask.png'
                    TexWetMP = Tex+'_WeatheringMap.png'
                    imgcloths = ( bpimg('mat_top_preset_MainTex.png'), bpimg('chidori'))
                    for x in imgcloths:
                        if x is not None:
                            bpy.data.images['mat_top_preset_MainTex.png'].name = TexMain
                            bpy.data.images['mat_top_preset_DetailMainTex.png'].name = TexDMT
                            bpy.data.images['mat_top_preset_OcclusionMap.png'].name = TexOcclusionM
                            bpy.data.images['mat_top_preset_MetallicGlossMap.png'].name = TexMetallicGM
                            bpy.data.images['mat_top_preset_DetailGlossMap.png'].name = TexDGM
                            bpy.data.images['mat_top_preset_DetailGlossMap2.png'].name = TexDGM2
                            bpy.data.images['mat_top_preset_BumpMap.png'].name = TexBump
                            bpy.data.images['mat_top_preset_DetailMask.png'].name = TexDetailM
                            bpy.data.images['mat_top_preset_WeatheringMask.png'].name = TexWetMK
                            bpy.data.images['mat_top_preset_WeatheringMap.png'].name = TexWetMP
                            bpy.data.images[TexMain].filepath = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexMain
                            bpy.data.images[TexMain].filepath_raw = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexMain
                            bpy.data.images[TexDMT].filepath = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexDMT
                            bpy.data.images[TexDMT].filepath_raw = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexDMT
                            bpy.data.images[TexOcclusionM].filepath = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexOcclusionM
                            bpy.data.images[TexOcclusionM].filepath_raw = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexOcclusionM
                            bpy.data.images[TexMetallicGM].filepath = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexMetallicGM
                            bpy.data.images[TexMetallicGM].filepath_raw = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexMetallicGM
                            bpy.data.images[TexDGM].filepath = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexDGM
                            bpy.data.images[TexDGM].filepath_raw = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexDGM
                            bpy.data.images[TexDGM2].filepath = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexDGM2
                            bpy.data.images[TexDGM2].filepath_raw = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexDGM2
                            bpy.data.images[TexBump].filepath = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexBump
                            bpy.data.images[TexBump].filepath_raw = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexBump
                            bpy.data.images[TexDetailM].filepath = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexDetailM
                            bpy.data.images[TexDetailM].filepath_raw = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexDetailM
                            bpy.data.images[TexWetMK].filepath = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexWetMK
                            bpy.data.images[TexWetMK].filepath_raw = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexWetMK
                            bpy.data.images[TexWetMP].filepath = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexWetMP
                            bpy.data.images[TexWetMP].filepath_raw = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexWetMP
                    mat = bpy.data.materials[Tex]
                    #Get the node in its node tree (replace the name below)
                    node_to_delete =  mat.node_tree.nodes['Principled BSDF']
                    node_to_delete2 =  mat.node_tree.nodes['Material Output']
                    #Remove it
                    mat.node_tree.nodes.remove(node_to_delete)
                    mat.node_tree.nodes.remove(node_to_delete2)
                    C = bpy.context

                    def instantiate_group(nodes, data_block_name):
                        group = nodes.new(type='ShaderNodeGroup')
                        group.node_tree = bpy.data.node_groups['HS2-Template Top']
                        return group
                    instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
                    my_mat = bpy.data.materials.get(Tex)
                    bpy.data.node_groups['HS2-Template Top'].name = 'HS2-Template Top '+Tex
                    node = bpy.data.node_groups['HS2-Template Top '+Tex]
                    #node.extension = 'CLIP'
                    #node.image = bpy.data.images[bakefinal.name]
                    nodes = my_mat.node_tree.nodes
                    for node in nodes:
                        node.select = False
                        node.select = True
                        nodes.active = node
                    try:
                        initial_area_type = bpy.context.area.type
                        bpy.context.area.type = 'NODE_EDITOR'
                        bpy.context.area.ui_type = 'ShaderNodeTree'
                        bpy.ops.wm.redraw_timer(type='DRAW_WIN', iterations=1)
                        bpy.ops.node.group_ungroup()
                        bpy.ops.node.group_edit(exit=True)
                    except Exception as e:
                        print(e)
                    finally:
                        bpy.context.area.type = initial_area_type
                    break
                else:
                    continue
        bpy.ops.object.select_all(action='DESELECT') # Deselecciona todo en la escena
        #####################################BOT#####################################
        bpy.ops.object.select_all(action='DESELECT') # Deselecciona todo en la escena
        # Get body object
        pantes = ( w(bot1), w(bot2), w(bot3), w(bot4), w(bot5), w(bot6), w(bot7), w(bot8), w(bot9), w(bot10), w(bot11), w(bot12), w(bot13), w(bot14), w(bot15), w(bot16), w(bot17), w(bot18), w(bot19), w(bot20), w(bot21), w(bot22), w(bot23), w(bot24), w(bot25), w(bot26), w(bot27), w(bot28), w(bot29), w(bot30), w(bot31), w(bot32), w(bot33), w(bot34), w(bot35), w(bot36), w(bot37), w(bot38), w(bot39), w(bot40), w(bot41), w(bot42), w(bot43), w(bot44), w(bot45), w(bot46), w(bot47), w(bot48), w(bot49), w(bot50), w(bot51), w(bot52), w(bot53), w(bot54), w(bot55), w(bot56), w(bot57), w(bot58), w(bot59), w(bot60), w(bot61), w(bot62), w(bot63), w(bot64), w(bot65), w(bot66), w(bot67), w(bot68), w(bot69), w(bot70), w(bot71), w(bot72), w(bot73), w(bot74), w(bot75), w(bot76), w(bot77), w(bot78), w(bot79), w(bot80), w(bot81), w(bot82), w(bot83), w(bot84), w(bot85), w(bot86), w(bot87), w(bot88), w(bot89), w(bot90), w(bot91), w(bot92), w(bot93), w(bot94), w(bot95), w(bot96), w(bot97), w(bot98), w(bot99), w(bot100), w(bot101), w(bot102), w(bot103), w(bot104), w(bot105), w(bot106), w(bot107), w(bot108), w(bot109), w(bot110), w(bot111), w(bot112), w(bot113), w(bot114), w(bot115), w(bot116), w(bot117), w(bot118), w(bot119), w(bot120), w(bot121), w(bot122), w(bot123), w(bot124), w(bot125), w(bot126), w(bot127), w(bot128), w(bot129), w(bot130), w(bot131), w(bot132), w(bot133), w(bot134), w(bot135), w(bot136), w(bot137), w(bot138), w(bot139), w(bot140), w(bot141), w(bot142), w(bot143), w(bot144), w(bot145), w(bot146), w(bot147), w(bot148), w(bot149), w(bot150), w(bot151), w(bot152), w(bot153), w(bot154), w(bot155), w(bot156), w(bot157), w(bot158), w(bot159), w(bot160), w(bot161), w(bot162), w(bot163), w(bot164), w(bot165), w(bot166), w(bot167), w(bot168), w(bot169), w(bot170), w(bot171), w(bot172), w(bot173), w(bot174), w(bot175), w(bot176), w(bot177), w(bot178), w(bot179), w(bot180), w(bot181), w(bot182), w(bot183), w(bot184), w(bot185), w(bot186), w(bot187), w(bot188), w(bot189), w(bot190), w(bot191), w(bot192), w(bot193), w(bot194), w(bot195), w(bot196), w(bot197), w(bot198), w(bot199), w(bot200), w(bot201), w(bot202), w(bot203), w(bot204), w(bot205), w(bot206), w(bot207), w(bot208), w(bot209), w(bot210), w(bot211), w(bot212), w(bot213), w(bot214), w(bot215), w(bot216), w(bot217), w(bot218), w(bot219), w(bot220), w(bot221), w(bot222), w(bot223), w(bot224), w(bot225))
        for x in pantes:
            if x is not None:
                #if bpy.data.objects.get(body1) is not None:
                op = (x.name)
                bpy.data.objects.get(op).select_set(True)
                outline_pants = bpy.data.objects.get(op)
                bpy.context.view_layer.objects.active = outline_pants
                #bpy.ops.object.join()
                #bpy.ops.object.origin_set(type='ORIGIN_CENTER_OF_VOLUME')
                ob = bpy.context.selected_objects
                material_set = set()
                for object in bpy.context.selected_objects:
                    for material in object.material_slots:
                        material_set.add(material)
                for material in material_set:
                #    print(material.name)
                    Tex = material.name
                if bpimg(Tex+"_MainTex.png") is None:
                    bpy.data.scenes['Scene'].sna_color05 = bpy.data.materials[Tex].node_tree.nodes['Principled BSDF'].inputs[0].default_value
                    bpy.data.node_groups['HS2-Template Pants'].nodes['Color-Value'].outputs[0].default_value = bpy.data.scenes['Scene'].sna_color05
                    TexMain = Tex+'_MainTex.png'
                    TexDMT = Tex+'_DetailMainTex.png'
                    TexOcclusionM = Tex+'_OcclusionMap.png'
                    TexMetallicGM = Tex+'_MetallicGlossMap.png'
                    TexDGM = Tex+'_DetailGlossMap.png'
                    TexDGM2 = Tex+'_DetailGlossMap2.png'
                    TexBump = Tex+'_BumpMap.png'
                    TexDetailM = Tex+'_DetailMask.png'
                    TexWetMK = Tex+'_WeatheringMask.png'
                    TexWetMP = Tex+'_WeatheringMap.png'
                    imgpants = ( bpimg('mat_bot_preset_MainTex.png'), bpimg('rasengan'))
                    for x in imgpants:
                        if x is not None:
                            bpy.data.images['mat_bot_preset_MainTex.png'].name = TexMain
                            bpy.data.images['mat_bot_preset_DetailMainTex.png'].name = TexDMT
                            bpy.data.images['mat_bot_preset_OcclusionMap.png'].name = TexOcclusionM
                            bpy.data.images['mat_bot_preset_MetallicGlossMap.png'].name = TexMetallicGM
                            bpy.data.images['mat_bot_preset_DetailGlossMap.png'].name = TexDGM
                            bpy.data.images['mat_bot_preset_DetailGlossMap2.png'].name = TexDGM2
                            bpy.data.images['mat_bot_preset_BumpMap.png'].name = TexBump
                            bpy.data.images['mat_bot_preset_DetailMask.png'].name = TexDetailM
                            bpy.data.images['mat_bot_preset_WeatheringMask.png'].name = TexWetMK
                            bpy.data.images['mat_bot_preset_WeatheringMap.png'].name = TexWetMP
                            bpy.data.images[TexMain].filepath = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexMain
                            bpy.data.images[TexMain].filepath_raw = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexMain
                            bpy.data.images[TexDMT].filepath = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexDMT
                            bpy.data.images[TexDMT].filepath_raw = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexDMT
                            bpy.data.images[TexOcclusionM].filepath = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexOcclusionM
                            bpy.data.images[TexOcclusionM].filepath_raw = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexOcclusionM
                            bpy.data.images[TexMetallicGM].filepath = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexMetallicGM
                            bpy.data.images[TexMetallicGM].filepath_raw = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexMetallicGM
                            bpy.data.images[TexDGM].filepath = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexDGM
                            bpy.data.images[TexDGM].filepath_raw = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexDGM
                            bpy.data.images[TexDGM2].filepath = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexDGM2
                            bpy.data.images[TexDGM2].filepath_raw = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexDGM2
                            bpy.data.images[TexBump].filepath = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexBump
                            bpy.data.images[TexBump].filepath_raw = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexBump
                            bpy.data.images[TexDetailM].filepath = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexDetailM
                            bpy.data.images[TexDetailM].filepath_raw = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexDetailM
                            bpy.data.images[TexWetMK].filepath = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexWetMK
                            bpy.data.images[TexWetMK].filepath_raw = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexWetMK
                            bpy.data.images[TexWetMP].filepath = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexWetMP
                            bpy.data.images[TexWetMP].filepath_raw = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexWetMP
                    mat = bpy.data.materials[Tex]
                    #Get the node in its node tree (replace the name below)
                    node_to_delete =  mat.node_tree.nodes['Principled BSDF']
                    node_to_delete2 =  mat.node_tree.nodes['Material Output']
                    #Remove it
                    mat.node_tree.nodes.remove(node_to_delete)
                    mat.node_tree.nodes.remove(node_to_delete2)
                    C = bpy.context

                    def instantiate_group(nodes, data_block_name):
                        group = nodes.new(type='ShaderNodeGroup')
                        group.node_tree = bpy.data.node_groups['HS2-Template Pants']
                        return group
                    instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
                    my_mat = bpy.data.materials.get(Tex)
                    bpy.data.node_groups['HS2-Template Pants'].name = 'HS2-Template Pants '+Tex
                    node = bpy.data.node_groups['HS2-Template Pants '+Tex]
                    #node.extension = 'CLIP'
                    #node.image = bpy.data.images[bakefinal.name]
                    nodes = my_mat.node_tree.nodes
                    for node in nodes:
                        node.select = False
                        node.select = True
                        nodes.active = node
                    try:
                        initial_area_type = bpy.context.area.type
                        bpy.context.area.type = 'NODE_EDITOR'
                        bpy.context.area.ui_type = 'ShaderNodeTree'
                        bpy.ops.wm.redraw_timer(type='DRAW_WIN', iterations=1)
                        bpy.ops.node.group_ungroup()
                        bpy.ops.node.group_edit(exit=True)
                    except Exception as e:
                        print(e)
                    finally:
                        bpy.context.area.type = initial_area_type
                    break
                else:
                    continue
        bpy.ops.object.select_all(action='DESELECT') # Deselecciona todo en la escena
        ###################################SHOES#####################################
        bpy.ops.object.select_all(action='DESELECT') # Deselecciona todo en la escena
        # Get shoes object
        shoeses = ( w(shoes1), w(shoes2), w(shoes3), w(shoes4), w(shoes5), w(shoes6), w(shoes7), w(shoes8), w(shoes9), w(shoes10), w(shoes11), w(shoes12), w(shoes13), w(shoes14), w(shoes15), w(shoes16), w(shoes17), w(shoes18), w(shoes19), w(shoes20), w(shoes21), w(shoes22), w(shoes23), w(shoes24), w(shoes25), w(shoes26), w(shoes27), w(shoes28), w(shoes29), w(shoes30), w(shoes31), w(shoes32), w(shoes33), w(shoes34), w(shoes35), w(shoes36), w(shoes37), w(shoes38), w(shoes39), w(shoes40), w(shoes41), w(shoes42), w(shoes43), w(shoes44), w(shoes45), w(shoes46), w(shoes47), w(shoes48), w(shoes49), w(shoes50), w(shoes51), w(shoes52), w(shoes53), w(shoes54), w(shoes55), w(shoes56), w(shoes57), w(shoes58), w(shoes59), w(shoes60), w(shoes61), w(shoes62), w(shoes63), w(shoes64), w(shoes65), w(shoes66), w(shoes67), w(shoes68), w(shoes69), w(shoes70), w(shoes71), w(shoes72), w(shoes73), w(shoes74), w(shoes75), w(shoes76), w(shoes77), w(shoes78), w(shoes79), w(shoes80), w(shoes81), w(shoes82), w(shoes83), w(shoes84), w(shoes85), w(shoes86), w(shoes87), w(shoes88), w(shoes89), w(shoes90), w(shoes91), w(shoes92), w(shoes93), w(shoes94), w(shoes95), w(shoes96))
        for x in shoeses:
            if x is not None:
                #if bpy.data.objects.get(body1) is not None:
                op = (x.name)
                bpy.data.objects.get(op).select_set(True)
                outline_shoes = bpy.data.objects.get(op)
                bpy.context.view_layer.objects.active = outline_shoes
                ob = bpy.context.selected_objects
                material_set = set()
                for object in bpy.context.selected_objects:
                    for material in object.material_slots:
                        material_set.add(material)
                for material in material_set:
                #    print(material.name)
                    Tex = material.name
                    bpy.data.scenes['Scene'].sna_color06 = bpy.data.materials[Tex].node_tree.nodes['Principled BSDF'].inputs[0].default_value
                    bpy.data.node_groups['HS2-Template Shoes'].nodes['Color-Value'].outputs[0].default_value = bpy.data.scenes['Scene'].sna_color06
                    TexMain = Tex+'_MainTex.png'
                    TexDMT = Tex+'_DetailMainTex.png'
                    TexOcclusionM = Tex+'_OcclusionMap.png'
                    TexMetallicGM = Tex+'_MetallicGlossMap.png'
                    TexDGM = Tex+'_DetailGlossMap.png'
                    TexDGM2 = Tex+'_DetailGlossMap2.png'
                    TexBump = Tex+'_BumpMap.png'
                    TexDetailM = Tex+'_DetailMask.png'
                    TexWetMK = Tex+'_WeatheringMask.png'
                    TexWetMP = Tex+'_WeatheringMap.png'
                imgshoes = ( bpimg('mat_shoes_preset_MainTex.png'), bpimg('byakugan'))
                for x in imgshoes:
                    if x is not None:
                        bpy.data.images['mat_shoes_preset_MainTex.png'].name = TexMain
                        bpy.data.images['mat_shoes_preset_DetailMainTex.png'].name = TexDMT
                        bpy.data.images['mat_shoes_preset_OcclusionMap.png'].name = TexOcclusionM
                        bpy.data.images['mat_shoes_preset_MetallicGlossMap.png'].name = TexMetallicGM
                        bpy.data.images['mat_shoes_preset_DetailGlossMap.png'].name = TexDGM
                        bpy.data.images['mat_shoes_preset_DetailGlossMap2.png'].name = TexDGM2
                        bpy.data.images['mat_shoes_preset_BumpMap.png'].name = TexBump
                        bpy.data.images['mat_shoes_preset_DetailMask.png'].name = TexDetailM
                        bpy.data.images['mat_shoes_preset_WeatheringMask.png'].name = TexWetMK
                        bpy.data.images['mat_shoes_preset_WeatheringMap.png'].name = TexWetMP
                        bpy.data.images[TexMain].filepath = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexMain
                        bpy.data.images[TexMain].filepath_raw = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexMain
                        bpy.data.images[TexDMT].filepath = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexDMT
                        bpy.data.images[TexDMT].filepath_raw = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexDMT
                        bpy.data.images[TexOcclusionM].filepath = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexOcclusionM
                        bpy.data.images[TexOcclusionM].filepath_raw = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexOcclusionM
                        bpy.data.images[TexMetallicGM].filepath = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexMetallicGM
                        bpy.data.images[TexMetallicGM].filepath_raw = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexMetallicGM
                        bpy.data.images[TexDGM].filepath = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexDGM
                        bpy.data.images[TexDGM].filepath_raw = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexDGM
                        bpy.data.images[TexDGM2].filepath = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexDGM2
                        bpy.data.images[TexDGM2].filepath_raw = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexDGM2
                        bpy.data.images[TexBump].filepath = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexBump
                        bpy.data.images[TexBump].filepath_raw = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexBump
                        bpy.data.images[TexDetailM].filepath = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexDetailM
                        bpy.data.images[TexDetailM].filepath_raw = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexDetailM
                        bpy.data.images[TexWetMK].filepath = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexWetMK
                        bpy.data.images[TexWetMK].filepath_raw = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexWetMK
                        bpy.data.images[TexWetMP].filepath = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexWetMP
                        bpy.data.images[TexWetMP].filepath_raw = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexWetMP
                mat = bpy.data.materials[Tex]
                #Get the node in its node tree (replace the name below)
                node_to_delete =  mat.node_tree.nodes['Principled BSDF']
                node_to_delete2 =  mat.node_tree.nodes['Material Output']
                #Remove it
                mat.node_tree.nodes.remove(node_to_delete)
                mat.node_tree.nodes.remove(node_to_delete2)
                C = bpy.context

                def instantiate_group(nodes, data_block_name):
                    group = nodes.new(type='ShaderNodeGroup')
                    group.node_tree = bpy.data.node_groups['HS2-Template Shoes']
                    return group
                instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
                my_mat = bpy.data.materials.get(Tex)
                bpy.data.node_groups['HS2-Template Shoes'].name = 'HS2-Template Shoes '+Tex
                node = bpy.data.node_groups['HS2-Template Shoes '+Tex]
                #node.extension = 'CLIP'
                #node.image = bpy.data.images[bakefinal.name]
                nodes = my_mat.node_tree.nodes
                for node in nodes:
                    node.select = False
                    node.select = True
                    nodes.active = node
                try:
                    initial_area_type = bpy.context.area.type
                    bpy.context.area.type = 'NODE_EDITOR'
                    bpy.context.area.ui_type = 'ShaderNodeTree'
                    bpy.ops.wm.redraw_timer(type='DRAW_WIN', iterations=1)
                    bpy.ops.node.group_ungroup()
                    bpy.ops.node.group_edit(exit=True)
                except Exception as e:
                    print(e)
                finally:
                    bpy.context.area.type = initial_area_type
                break
        bpy.ops.object.select_all(action='DESELECT') # Deselecciona todo en la escena
        ###################################SOCKS#####################################
        bpy.ops.object.select_all(action='DESELECT') # Deselecciona todo en la escena
        # Get shoes object
        sockys = ( w(socks1), w(socks2), w(socks3), w(socks4), w(socks5), w(socks6), w(socks7), w(socks8), w(socks9), w(socks10), w(socks11), w(socks12), w(socks13), w(socks14), w(socks15), w(socks16), w(socks17), w(socks18), w(socks19), w(socks20), w(socks21), w(socks22), w(socks23), w(socks24), w(socks25), w(socks26), w(socks27), w(socks28), w(socks29), w(socks30), w(socks31), w(socks32), w(socks33), w(socks34), w(socks35), w(socks36), w(socks37), w(socks38), w(socks39), w(socks40), w(socks41), w(socks42), w(socks43), w(socks44), w(socks45), w(socks46), w(socks47), w(socks48), w(socks49), w(socks50), w(socks51), w(socks52), w(socks53), w(socks54), w(socks55), w(socks56), w(socks57), w(socks58), w(socks59), w(socks60), w(socks61), w(socks62), w(socks63), w(socks64), w(socks65), w(socks66), w(socks67), w(socks68), w(socks69), w(socks70), w(socks71), w(socks72), w(socks73), w(socks74), w(socks75), w(socks76))
        for x in sockys:
            if x is not None:
                #if bpy.data.objects.get(body1) is not None:
                op = (x.name)
                bpy.data.objects.get(op).select_set(True)
                outline_socks = bpy.data.objects.get(op)
                bpy.context.view_layer.objects.active = outline_socks
                ob = bpy.context.selected_objects
                material_set = set()
                for object in bpy.context.selected_objects:
                    for material in object.material_slots:
                        material_set.add(material)
                for material in material_set:
                #    print(material.name)
                    Tex = material.name
                    bpy.data.scenes['Scene'].sna_color09 = bpy.data.materials[Tex].node_tree.nodes['Principled BSDF'].inputs[0].default_value
                    bpy.data.node_groups['HS2-Template Socks'].nodes['Color-Value'].outputs[0].default_value = bpy.data.scenes['Scene'].sna_color09
                    TexMain = Tex+'_MainTex.png'
                    TexDMT = Tex+'_DetailMainTex.png'
                    TexOcclusionM = Tex+'_OcclusionMap.png'
                    TexMetallicGM = Tex+'_MetallicGlossMap.png'
                    TexDGM = Tex+'_DetailGlossMap.png'
                    TexDGM2 = Tex+'_DetailGlossMap2.png'
                    TexBump = Tex+'_BumpMap.png'
                    TexDetailM = Tex+'_DetailMask.png'
                    TexWetMK = Tex+'_WeatheringMask.png'
                    TexWetMP = Tex+'_WeatheringMap.png'
                imgsocks = ( bpimg('mat_socks_preset_MainTex.png'), bpimg('amaterasu'))
                for x in imgsocks:
                    if x is not None:
                        bpy.data.images['mat_socks_preset_MainTex.png'].name = TexMain
                        bpy.data.images['mat_socks_preset_DetailMainTex.png'].name = TexDMT
                        bpy.data.images['mat_socks_preset_OcclusionMap.png'].name = TexOcclusionM
                        bpy.data.images['mat_socks_preset_MetallicGlossMap.png'].name = TexMetallicGM
                        bpy.data.images['mat_socks_preset_DetailGlossMap.png'].name = TexDGM
                        bpy.data.images['mat_socks_preset_DetailGlossMap2.png'].name = TexDGM2
                        bpy.data.images['mat_socks_preset_BumpMap.png'].name = TexBump
                        bpy.data.images['mat_socks_preset_DetailMask.png'].name = TexDetailM
                        bpy.data.images['mat_socks_preset_WeatheringMask.png'].name = TexWetMK
                        bpy.data.images['mat_socks_preset_WeatheringMap.png'].name = TexWetMP
                        bpy.data.images[TexMain].filepath = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexMain
                        bpy.data.images[TexMain].filepath_raw = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexMain
                        bpy.data.images[TexDMT].filepath = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexDMT
                        bpy.data.images[TexDMT].filepath_raw = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexDMT
                        bpy.data.images[TexOcclusionM].filepath = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexOcclusionM
                        bpy.data.images[TexOcclusionM].filepath_raw = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexOcclusionM
                        bpy.data.images[TexMetallicGM].filepath = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexMetallicGM
                        bpy.data.images[TexMetallicGM].filepath_raw = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexMetallicGM
                        bpy.data.images[TexDGM].filepath = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexDGM
                        bpy.data.images[TexDGM].filepath_raw = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexDGM
                        bpy.data.images[TexDGM2].filepath = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexDGM2
                        bpy.data.images[TexDGM2].filepath_raw = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexDGM2
                        bpy.data.images[TexBump].filepath = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexBump
                        bpy.data.images[TexBump].filepath_raw = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexBump
                        bpy.data.images[TexDetailM].filepath = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexDetailM
                        bpy.data.images[TexDetailM].filepath_raw = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexDetailM
                        bpy.data.images[TexWetMK].filepath = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexWetMK
                        bpy.data.images[TexWetMK].filepath_raw = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexWetMK
                        bpy.data.images[TexWetMP].filepath = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexWetMP
                        bpy.data.images[TexWetMP].filepath_raw = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexWetMP
                mat = bpy.data.materials[Tex]
                #Get the node in its node tree (replace the name below)
                node_to_delete =  mat.node_tree.nodes['Principled BSDF']
                node_to_delete2 =  mat.node_tree.nodes['Material Output']
                #Remove it
                mat.node_tree.nodes.remove(node_to_delete)
                mat.node_tree.nodes.remove(node_to_delete2)
                C = bpy.context

                def instantiate_group(nodes, data_block_name):
                    group = nodes.new(type='ShaderNodeGroup')
                    group.node_tree = bpy.data.node_groups['HS2-Template Socks']
                    return group
                instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
                bpy.context.object.active_material.blend_method = 'CLIP'
                bpy.context.object.active_material.shadow_method = 'CLIP'
                my_mat = bpy.data.materials.get(Tex)
                bpy.data.node_groups['HS2-Template Socks'].name = 'HS2-Template Socks '+Tex
                node = bpy.data.node_groups['HS2-Template Socks '+Tex]
                #node.extension = 'CLIP'
                #node.image = bpy.data.images[bakefinal.name]
                nodes = my_mat.node_tree.nodes
                for node in nodes:
                    node.select = False
                    node.select = True
                    nodes.active = node
                try:
                    initial_area_type = bpy.context.area.type
                    bpy.context.area.type = 'NODE_EDITOR'
                    bpy.context.area.ui_type = 'ShaderNodeTree'
                    bpy.ops.wm.redraw_timer(type='DRAW_WIN', iterations=1)
                    bpy.ops.node.group_ungroup()
                    bpy.ops.node.group_edit(exit=True)
                except Exception as e:
                    print(e)
                finally:
                    bpy.context.area.type = initial_area_type
                break
        bpy.ops.object.select_all(action='DESELECT') # Deselecciona todo en la escena
        ##################################INNER#####################################
        #bpy.ops.object.select_all(action='DESELECT') # Deselecciona todo en la escena
        ## Get inner object
        #glovescoll = ( w(glove1), w(glove2), w(glove3), w(glove4), w(glove5), w(glove6), w(glove7), w(glove8), w(glove9), w(glove10), w(glove11), w(glove12), w(glove13), w(glove14), w(glove15), w(glove16), w(glove17), w(glove18), w(glove19), w(glove20), w(glove21), w(glove22), w(glove23), w(glove24), w(glove25), w(glove26), w(glove27), w(glove28), w(glove29), w(glove30), w(glove31), w(glove32), w(glove33), w(glove34), w(glove35), w(glove36), w(glove37), w(glove38), w(glove39), w(glove40), w(glove41), w(glove42), w(glove43), w(glove44), w(glove45), w(glove46), w(glove47), w(glove48), w(glove49), w(glove50), w(glove51), w(glove52), w(glove53), w(glove54), w(glove55), w(glove56), w(glove57), w(glove58), w(glove59), w(glove60), w(glove61), w(glove62), w(glove63), w(glove64), w(glove65), w(glove66), w(glove67), w(glove68), w(glove69), w(glove70), w(glove71), w(glove72), w(glove73), w(glove74), w(glove75), w(glove76), w(glove77), w(glove78), w(glove79), w(glove80), w(glove81), w(glove82), w(glove83), w(glove84), w(glove85), w(glove86), w(glove87), w(glove88), w(glove89), w(glove90), w(glove91), w(glove92), w(glove93), w(glove94), w(glove95), w(glove96), w(glove97), w(glove98))
        #for x in glovescoll:
        #    if x is not None:
        #        #if bpy.data.objects.get(body1) is not None:
        #        op = (x.name)
        #        bpy.data.objects.get(op).select_set(True)
        #        outline_gloves = bpy.data.objects.get(op)
        #        bpy.context.view_layer.objects.active = outline_gloves
        #        ob = bpy.context.selected_objects
        #        material_set = set()
        #        for object in bpy.context.selected_objects:
        #            for material in object.material_slots:
        #                material_set.add(material)
        #        for material in material_set:
        #        #    print(material.name)
        #            Tex = material.name
        #            
        #            bpy.data.scenes['Scene'].sna_color10 = bpy.data.materials[Tex].node_tree.nodes['Principled BSDF'].inputs[0].default_value
        #            bpy.data.node_groups['HS2-Template Inner'].nodes['Color-Value'].outputs[0].default_value = bpy.data.scenes['Scene'].sna_color10
        #            
        #            TexMain = Tex+'_MainTex.png'
        #            TexDMT = Tex+'_DetailMainTex.png'
        #            TexOcclusionM = Tex+'_OcclusionMap.png'
        #            TexDGM = Tex+'_DetailGlossMap.png'
        #            TexBump = Tex+'_BumpMap.png'
        #    
        #        imgsocks = ( bpimg('mat_inner_preset_MainTex.png'), bpimg('amaterasu'))
        #        for x in imgsocks:
        #            if x is not None:
        #                bpy.data.images['mat_inner_preset_MainTex.png'].name = TexMain
        #                bpy.data.images['mat_inner_preset_DetailMainTex.png'].name = TexDMT
        #                bpy.data.images['mat_inner_preset_OcclusionMap.png'].name = TexOcclusionM
        #                bpy.data.images['mat_inner_preset_DetailGlossMap.png'].name = TexDGM
        #                bpy.data.images['mat_inner_preset_BumpMap.png'].name = TexBump
        #                bpy.data.images[TexMain].filepath = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexMain
        #                bpy.data.images[TexMain].filepath_raw = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexMain
        #                
        #                bpy.data.images[TexDMT].filepath = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexDMT
        #                bpy.data.images[TexDMT].filepath_raw = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexDMT
        #                bpy.data.images[TexOcclusionM].filepath = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexOcclusionM
        #                bpy.data.images[TexOcclusionM].filepath_raw = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexOcclusionM
        #                
        #                bpy.data.images[TexDGM].filepath = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexDGM
        #                bpy.data.images[TexDGM].filepath_raw = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexDGM
        #                bpy.data.images[TexBump].filepath = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexBump
        #                bpy.data.images[TexBump].filepath_raw = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexBump
        #                
        #        mat = bpy.data.materials[Tex]
        #        #Get the node in its node tree (replace the name below)
        #        node_to_delete =  mat.node_tree.nodes['Principled BSDF']
        #        node_to_delete2 =  mat.node_tree.nodes['Material Output']
        #        #Remove it
        #        mat.node_tree.nodes.remove(node_to_delete)
        #        mat.node_tree.nodes.remove(node_to_delete2)
        #        C = bpy.context
        #        def instantiate_group(nodes, data_block_name):
        #            group = nodes.new(type='ShaderNodeGroup')
        #            group.node_tree = bpy.data.node_groups['HS2-Template Inner']
        #            return group
        #        instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
        #        
        #        bpy.context.object.active_material.blend_method = 'CLIP'
        #        bpy.context.object.active_material.shadow_method = 'CLIP'
        #        
        #        my_mat = bpy.data.materials.get(Tex)
        #        
        #        bpy.data.node_groups['HS2-Template Inner'].name = 'HS2-Template Inner '+Tex
        #        
        #        node = bpy.data.node_groups['HS2-Template Inner '+Tex]
        #        #node.extension = 'CLIP'
        #        #node.image = bpy.data.images[bakefinal.name]
        #        nodes = my_mat.node_tree.nodes
        #        for node in nodes:
        #            node.select = False
        #            node.select = True
        #            nodes.active = node
        #        try:
        #            initial_area_type = bpy.context.area.type
        #            bpy.context.area.type = 'NODE_EDITOR'
        #            bpy.context.area.ui_type = 'ShaderNodeTree'
        #            bpy.ops.wm.redraw_timer(type='DRAW_WIN', iterations=1)
        #            bpy.ops.node.group_ungroup()
        #            bpy.ops.node.group_edit(exit=True)
        #        except Exception as e:
        #            print(e)
        #        finally:
        #            bpy.context.area.type = initial_area_type
        #        break
        #bpy.ops.object.select_all(action='DESELECT') # Deselecciona todo en la escena
        #################################Brasier#####################################
        bpy.ops.object.select_all(action='DESELECT') # Deselecciona todo en la escena
        # Get shoes object
        bracoll = ( w(bra1), w(bra2), w(bra3), w(bra4), w(bra5))
        for x in bracoll:
            if x is not None:
                #if bpy.data.objects.get(body1) is not None:
                op = (x.name)
                bpy.data.objects.get(op).select_set(True)
                outline_bra = bpy.data.objects.get(op)
                bpy.context.view_layer.objects.active = outline_bra
                ob = bpy.context.selected_objects
                material_set = set()
                for object in bpy.context.selected_objects:
                    for material in object.material_slots:
                        material_set.add(material)
                for material in material_set:
                #    print(material.name)
                    Tex = material.name
                    bpy.data.scenes['Scene'].sna_color07 = bpy.data.materials[Tex].node_tree.nodes['Principled BSDF'].inputs[0].default_value
                    bpy.data.node_groups['HS2-Template Bra'].nodes['Color-Value'].outputs[0].default_value = bpy.data.scenes['Scene'].sna_color07
                    TexMain = Tex+'_MainTex.png'
                    TexAlphaM = Tex+'_AlphaMask.png'
                    TexDMT = Tex+'_DetailMainTex.png'
                    TexOcclusionM = Tex+'_OcclusionMap.png'
                    TexMetallicGM = Tex+'_MetallicGlossMap.png'
                    TexDGM = Tex+'_DetailGlossMap.png'
                    TexDGM2 = Tex+'_DetailGlossMap2.png'
                    TexBump = Tex+'_BumpMap.png'
                    TexDetailM = Tex+'_DetailMask.png'
                    TexWetMK = Tex+'_WeatheringMask.png'
                    TexWetMP = Tex+'_WeatheringMap.png'
                imgsocks = ( bpimg('mat_bra_preset_MainTex.png'), bpimg('amaterasu'))
                for x in imgsocks:
                    if x is not None:
                        bpy.data.images['mat_bra_preset_MainTex.png'].name = TexMain
                        bpy.data.images['mat_bra_preset_AlphaMask.png'].name = TexAlphaM
                        bpy.data.images['mat_bra_preset_DetailMainTex.png'].name = TexDMT
                        bpy.data.images['mat_bra_preset_OcclusionMap.png'].name = TexOcclusionM
                        bpy.data.images['mat_bra_preset_MetallicGlossMap.png'].name = TexMetallicGM
                        bpy.data.images['mat_bra_preset_DetailGlossMap.png'].name = TexDGM
                        bpy.data.images['mat_bra_preset_DetailGlossMap2.png'].name = TexDGM2
                        bpy.data.images['mat_bra_preset_BumpMap.png'].name = TexBump
                        bpy.data.images['mat_bra_preset_DetailMask.png'].name = TexDetailM
                        bpy.data.images['mat_bra_preset_WeatheringMask.png'].name = TexWetMK
                        bpy.data.images['mat_bra_preset_WeatheringMap.png'].name = TexWetMP
                        bpy.data.images[TexMain].filepath = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexMain
                        bpy.data.images[TexMain].filepath_raw = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexMain
                        bpy.data.images[TexAlphaM].filepath = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexAlphaM
                        bpy.data.images[TexAlphaM].filepath_raw = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexAlphaM
                        bpy.data.images[TexDMT].filepath = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexDMT
                        bpy.data.images[TexDMT].filepath_raw = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexDMT
                        bpy.data.images[TexOcclusionM].filepath = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexOcclusionM
                        bpy.data.images[TexOcclusionM].filepath_raw = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexOcclusionM
                        bpy.data.images[TexMetallicGM].filepath = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexMetallicGM
                        bpy.data.images[TexMetallicGM].filepath_raw = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexMetallicGM
                        bpy.data.images[TexDGM].filepath = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexDGM
                        bpy.data.images[TexDGM].filepath_raw = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexDGM
                        bpy.data.images[TexDGM2].filepath = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexDGM2
                        bpy.data.images[TexDGM2].filepath_raw = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexDGM2
                        bpy.data.images[TexBump].filepath = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexBump
                        bpy.data.images[TexBump].filepath_raw = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexBump
                        bpy.data.images[TexDetailM].filepath = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexDetailM
                        bpy.data.images[TexDetailM].filepath_raw = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexDetailM
                        bpy.data.images[TexWetMK].filepath = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexWetMK
                        bpy.data.images[TexWetMK].filepath_raw = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexWetMK
                        bpy.data.images[TexWetMP].filepath = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexWetMP
                        bpy.data.images[TexWetMP].filepath_raw = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexWetMP
                mat = bpy.data.materials[Tex]
                #Get the node in its node tree (replace the name below)
                node_to_delete =  mat.node_tree.nodes['Principled BSDF']
                node_to_delete2 =  mat.node_tree.nodes['Material Output']
                #Remove it
                mat.node_tree.nodes.remove(node_to_delete)
                mat.node_tree.nodes.remove(node_to_delete2)
                C = bpy.context

                def instantiate_group(nodes, data_block_name):
                    group = nodes.new(type='ShaderNodeGroup')
                    group.node_tree = bpy.data.node_groups['HS2-Template Bra']
                    return group
                instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
                bpy.context.object.active_material.blend_method = 'HASHED'
                bpy.context.object.active_material.shadow_method = 'HASHED'
                my_mat = bpy.data.materials.get(Tex)
                bpy.data.node_groups['HS2-Template Bra'].name = 'HS2-Template Bra '+Tex
                node = bpy.data.node_groups['HS2-Template Bra '+Tex]
                #node.extension = 'CLIP'
                #node.image = bpy.data.images[bakefinal.name]
                nodes = my_mat.node_tree.nodes
                for node in nodes:
                    node.select = False
                    node.select = True
                    nodes.active = node
                try:
                    initial_area_type = bpy.context.area.type
                    bpy.context.area.type = 'NODE_EDITOR'
                    bpy.context.area.ui_type = 'ShaderNodeTree'
                    bpy.ops.wm.redraw_timer(type='DRAW_WIN', iterations=1)
                    bpy.ops.node.group_ungroup()
                    bpy.ops.node.group_edit(exit=True)
                except Exception as e:
                    print(e)
                finally:
                    bpy.context.area.type = initial_area_type
                break
        bpy.ops.object.select_all(action='DESELECT') # Deselecciona todo en la escena
        ##################################PANTIES####################################
        bpy.ops.object.select_all(action='DESELECT') # Deselecciona todo en la escena
        # Get short object
        shortys = ( w(short1), w(short2), w(short3), w(short4))
        for x in shortys:
            if x is not None:
                #if bpy.data.objects.get(body1) is not None:
                op = (x.name)
                bpy.data.objects.get(op).select_set(True)
                outline_short = bpy.data.objects.get(op)
                bpy.context.view_layer.objects.active = outline_short
                ob = bpy.context.selected_objects
                material_set = set()
                for object in bpy.context.selected_objects:
                    for material in object.material_slots:
                        material_set.add(material)
                for material in material_set:
                #    print(material.name)
                    Tex = material.name
                    bpy.data.scenes['Scene'].sna_color08 = bpy.data.materials[Tex].node_tree.nodes['Principled BSDF'].inputs[0].default_value
                    bpy.data.node_groups['HS2-Template Short'].nodes['Color-Value'].outputs[0].default_value = bpy.data.scenes['Scene'].sna_color08
                    TexMain = Tex+'_MainTex.png'
                    TexDMT = Tex+'_DetailMainTex.png'
                    TexOcclusionM = Tex+'_OcclusionMap.png'
                    TexDGM = Tex+'_DetailGlossMap.png'
                    TexDGM2 = Tex+'_DetailGlossMap2.png'
                    TexBump = Tex+'_BumpMap.png'
                    TexDetailM = Tex+'_DetailMask.png'
                    TexWetMK = Tex+'_WeatheringMask.png'
                    TexWetMP = Tex+'_WeatheringMap.png'
                imgshort = ( bpimg('mat_short_preset_MainTex.png'), bpimg('tenseigan'))
                for x in imgshort:
                    if x is not None:
                        bpy.data.images['mat_short_preset_MainTex.png'].name = TexMain
                        bpy.data.images['mat_short_preset_DetailMainTex.png'].name = TexDMT
                        bpy.data.images['mat_short_preset_OcclusionMap.png'].name = TexOcclusionM
                        bpy.data.images['mat_short_preset_DetailGlossMap.png'].name = TexDGM
                        bpy.data.images['mat_short_preset_DetailGlossMap2.png'].name = TexDGM2
                        bpy.data.images['mat_short_preset_BumpMap.png'].name = TexBump
                        bpy.data.images['mat_short_preset_DetailMask.png'].name = TexDetailM
                        bpy.data.images['mat_short_preset_WeatheringMask.png'].name = TexWetMK
                        bpy.data.images['mat_short_preset_WeatheringMap.png'].name = TexWetMP
                        bpy.data.images[TexMain].filepath = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexMain
                        bpy.data.images[TexMain].filepath_raw = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexMain
                        bpy.data.images[TexDMT].filepath = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexDMT
                        bpy.data.images[TexDMT].filepath_raw = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexDMT
                        bpy.data.images[TexOcclusionM].filepath = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexOcclusionM
                        bpy.data.images[TexOcclusionM].filepath_raw = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexOcclusionM
                        bpy.data.images[TexDGM].filepath = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexDGM
                        bpy.data.images[TexDGM].filepath_raw = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexDGM
                        bpy.data.images[TexDGM2].filepath = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexDGM2
                        bpy.data.images[TexDGM2].filepath_raw = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexDGM2
                        bpy.data.images[TexBump].filepath = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexBump
                        bpy.data.images[TexBump].filepath_raw = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexBump
                        bpy.data.images[TexDetailM].filepath = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexDetailM
                        bpy.data.images[TexDetailM].filepath_raw = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexDetailM
                        bpy.data.images[TexWetMK].filepath = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexWetMK
                        bpy.data.images[TexWetMK].filepath_raw = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexWetMK
                        bpy.data.images[TexWetMP].filepath = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexWetMP
                        bpy.data.images[TexWetMP].filepath_raw = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexWetMP
                mat = bpy.data.materials[Tex]
                #Get the node in its node tree (replace the name below)
                node_to_delete =  mat.node_tree.nodes['Principled BSDF']
                node_to_delete2 =  mat.node_tree.nodes['Material Output']
                #Remove it
                mat.node_tree.nodes.remove(node_to_delete)
                mat.node_tree.nodes.remove(node_to_delete2)
                C = bpy.context

                def instantiate_group(nodes, data_block_name):
                    group = nodes.new(type='ShaderNodeGroup')
                    group.node_tree = bpy.data.node_groups['HS2-Template Short']
                    return group
                instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
                bpy.context.object.active_material.blend_method = 'CLIP'
                bpy.context.object.active_material.shadow_method = 'CLIP'
                my_mat = bpy.data.materials.get(Tex)
                bpy.data.node_groups['HS2-Template Short'].name = 'HS2-Template Short '+Tex
                node = bpy.data.node_groups['HS2-Template Short '+Tex]
                #node.extension = 'CLIP'
                #node.image = bpy.data.images[bakefinal.name]
                nodes = my_mat.node_tree.nodes
                for node in nodes:
                    node.select = False
                    node.select = True
                    nodes.active = node
                try:
                    initial_area_type = bpy.context.area.type
                    bpy.context.area.type = 'NODE_EDITOR'
                    bpy.context.area.ui_type = 'ShaderNodeTree'
                    bpy.ops.wm.redraw_timer(type='DRAW_WIN', iterations=1)
                    bpy.ops.node.group_ungroup()
                    bpy.ops.node.group_edit(exit=True)
                except Exception as e:
                    print(e)
                finally:
                    bpy.context.area.type = initial_area_type
                break
        bpy.ops.object.select_all(action='DESELECT') # Deselecciona todo en la escena
        #################################UNDERHAIR###################################
        #bpy.ops.object.select_all(action='DESELECT') # Deselecciona todo en la escena
        ## Get shoes object
        #underhcoll = ( w(underh1), w(underh2), w(underh3), w(underh4), w(underh5))
        #for x in underhcoll:
        #    if x is not None:
        #        #if bpy.data.objects.get(body1) is not None:
        #        op = (x.name)
        #        bpy.data.objects.get(op).select_set(True)
        #        outline_underh = bpy.data.objects.get(op)
        #        bpy.context.view_layer.objects.active = outline_underh
        #        ob = bpy.context.selected_objects
        #        material_set = set()
        #        for object in bpy.context.selected_objects:
        #            for material in object.material_slots:
        #                material_set.add(material)
        #        for material in material_set:
        #        #    print(material.name)
        #            Tex = material.name
        #        #  print(Tex+'_MainTex.png')
        #            TexMain = Tex+'_MainTex.png'
        #            TexSpecGM = Tex+'_SpecGlossMap.png'
        #            TexBump = Tex+'_BumpMap.png'
        #    
        #        imgsocks = ( bpimg('cf_m_underhair_00_00_00_MainTex.png'), bpimg('amaterasu'))
        #        for x in imgsocks:
        #            if x is not None:
        #                bpy.data.images['cf_m_underhair_00_00_00_MainTex.png'].name = TexMain
        #                bpy.data.images['cf_m_underhair_00_00_00_SpecGlossMap.png'].name = TexSpecGM
        #                bpy.data.images['cf_m_underhair_00_00_00_BumpMap.png'].name = TexBump
        #                bpy.data.images[TexMain].filepath = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexMain
        #                bpy.data.images[TexMain].filepath_raw = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexMain
        #                bpy.data.images[TexSpecGM].filepath = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexSpecGM
        #                bpy.data.images[TexSpecGM].filepath_raw = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexSpecGM
        #                
        #                bpy.data.images[TexBump].filepath = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexBump
        #                
        #                bpy.data.images[TexBump].filepath_raw = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexBump
        #                
        #        mat = bpy.data.materials[Tex]
        #        #Get the node in its node tree (replace the name below)
        #        node_to_delete =  mat.node_tree.nodes['Principled BSDF']
        #        node_to_delete2 =  mat.node_tree.nodes['Material Output']
        #        #Remove it
        #        mat.node_tree.nodes.remove(node_to_delete)
        #        mat.node_tree.nodes.remove(node_to_delete2)
        #        C = bpy.context
        #        def instantiate_group(nodes, data_block_name):
        #            group = nodes.new(type='ShaderNodeGroup')
        #            group.node_tree = bpy.data.node_groups['HS2-Template UnderHair']
        #            return group
        #        instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
        #        
        #        bpy.context.object.active_material.blend_method = 'HASHED'
        #        bpy.context.object.active_material.shadow_method = 'HASHED'
        #        
        #        my_mat = bpy.data.materials.get(Tex)
        #        
        #        node = bpy.data.node_groups['HS2-Template UnderHair']
        #        #node.extension = 'CLIP'
        #        #node.image = bpy.data.images[bakefinal.name]
        #        nodes = my_mat.node_tree.nodes
        #        for node in nodes:
        #            node.select = False
        #            node.select = True
        #            nodes.active = node
        #        try:
        #            initial_area_type = bpy.context.area.type
        #            bpy.context.area.type = 'NODE_EDITOR'
        #            bpy.context.area.ui_type = 'ShaderNodeTree'
        #            bpy.ops.wm.redraw_timer(type='DRAW_WIN', iterations=1)
        #            bpy.ops.node.group_ungroup()
        #            bpy.ops.node.group_edit(exit=True)
        #        except Exception as e:
        #            print(e)
        #        finally:
        #            bpy.context.area.type = initial_area_type
        #        break
        #bpy.ops.object.select_all(action='DESELECT') # Deselecciona todo en la escena
        ###################################EYES######################################
        bpy.ops.object.select_all(action='DESELECT') # Deselecciona todo en la escena
        # Get eye object
        eyeses = (w(eyeL1),w(eyeL2),w(eyeL3),w(eyeL4),w(eyeL5))
        for x in eyeses:
            if x is not None:
                #if bpy.data.objects.get(body1) is not None:
                op = (x.name)
                bpy.data.objects.get(op).select_set(True)
                outline_eye = bpy.data.objects.get(op)
                bpy.context.view_layer.objects.active = outline_eye
                ob = bpy.context.selected_objects
                material_set = set()
                for object in bpy.context.selected_objects:
                    for material in object.material_slots:
                        material_set.add(material)
                for material in material_set:
                    #    print(material.name)
                    Tex = material.name
                    #bpy.context.object.active_material.blend_method = 'BLEND'
                    #bpy.context.object.active_material.shadow_method = 'HASHED'
                    #  print(Tex+'_MainTex.png')
                    TexMain = Tex+'_MainTex.png'
                    TexIT = Tex+'_IrisTex.png'
                    TexTex2 = Tex+'_Texture2.png'
                    TexTex3 = Tex+'_Texture3.png'
                    TexTex4 = Tex+'_Texture4.png'
                    TexSIT = Tex+'_ShadeIrisTex.png'
                    TexSST = Tex+'_ShadeScleraTex.png'
                    TexIBump = Tex+'_IrisBump.png'
                    TexEBump = Tex+'_EyeBump.png'
                    TexCBump = Tex+'_CorneaBump.png'
                    TexBumpM = Tex+'_BumpMap.png'
                    imgeyes = ( bpimg('mat_eyes_preset_MainTex.png'), bpimg('rinnegan'))
                    for x in imgeyes:
                        if x is not None:
                            bpy.data.images['mat_eyes_preset_MainTex.png'].name = TexMain
                            bpy.data.images['mat_eyes_preset_IrisTex.png'].name = TexIT
                            bpy.data.images['mat_eyes_preset_Texture2.png'].name = TexTex2
                            bpy.data.images['mat_eyes_preset_Texture3.png'].name = TexTex3
                            bpy.data.images['mat_eyes_preset_Texture4.png'].name = TexTex4
                            bpy.data.images['mat_eyes_preset_ShadeIrisTex.png'].name = TexSIT
                            bpy.data.images['mat_eyes_preset_ShadeScleraTex.png'].name = TexSST
                            bpy.data.images['mat_eyes_preset_IrisBump.png'].name = TexIBump
                            bpy.data.images['mat_eyes_preset_EyeBump.png'].name = TexEBump
                            bpy.data.images['mat_eyes_preset_CorneaBump.png'].name = TexCBump
                            bpy.data.images['mat_eyes_preset_BumpMap.png'].name = TexBumpM                    
                            bpy.data.images[TexMain].filepath = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexMain
                            bpy.data.images[TexMain].filepath_raw = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexMain
                            bpy.data.images[TexIT].filepath = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexIT
                            bpy.data.images[TexIT].filepath_raw = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexIT
                            bpy.data.images[TexTex2].filepath = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexTex2
                            bpy.data.images[TexTex2].filepath_raw = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexTex2
                            bpy.data.images[TexTex3].filepath = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexTex3
                            bpy.data.images[TexTex3].filepath_raw = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexTex3
                            bpy.data.images[TexTex4].filepath = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexTex4
                            bpy.data.images[TexTex4].filepath_raw = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexTex4
                            bpy.data.images[TexSIT].filepath = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexSIT
                            bpy.data.images[TexSIT].filepath_raw = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexSIT
                            bpy.data.images[TexSST].filepath = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexSST
                            bpy.data.images[TexSST].filepath_raw = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexSST
                            bpy.data.images[TexIBump].filepath = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexIBump
                            bpy.data.images[TexIBump].filepath_raw = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexIBump
                            bpy.data.images[TexEBump].filepath = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexEBump
                            bpy.data.images[TexEBump].filepath_raw = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexEBump
                            bpy.data.images[TexCBump].filepath = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexCBump
                            bpy.data.images[TexCBump].filepath_raw = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexCBump
                            bpy.data.images[TexBumpM].filepath = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexBumpM
                            bpy.data.images[TexBumpM].filepath_raw = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexBumpM
                mat = bpy.data.materials[Tex]
                #Get the node in its node tree (replace the name below)
                node_to_delete =  mat.node_tree.nodes['Principled BSDF']
                node_to_delete2 =  mat.node_tree.nodes['Material Output']
                #Remove it
                mat.node_tree.nodes.remove(node_to_delete)
                mat.node_tree.nodes.remove(node_to_delete2)
                C = bpy.context

                def instantiate_group(nodes, data_block_name):
                    group = nodes.new(type='ShaderNodeGroup')
                    group.node_tree = bpy.data.node_groups['HS2-Template Eye']
                    return group
                instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
                my_mat = bpy.data.materials.get(Tex)
                #bpy.data.node_groups['HS1-Template White Eye'].name = 'HS1-Template WE '+Tex
                node = bpy.data.node_groups['HS2-Template Eye']
                #node.extension = 'CLIP'
                #node.image = bpy.data.images[bakefinal.name]
                nodes = my_mat.node_tree.nodes
                for node in nodes:
                    node.select = False
                    node.select = True
                    nodes.active = node
                try:
                    initial_area_type = bpy.context.area.type
                    bpy.context.area.type = 'NODE_EDITOR'
                    bpy.context.area.ui_type = 'ShaderNodeTree'
                    bpy.ops.wm.redraw_timer(type='DRAW_WIN', iterations=1)
                    bpy.ops.node.group_ungroup()
                    bpy.ops.node.group_edit(exit=True)
                except Exception as e:
                    print(e)
                finally:
                    bpy.context.area.type = initial_area_type
                break
        bpy.ops.object.select_all(action='DESELECT') # Deselecciona todo en la escena
        #################################EYELASHES###################################
        bpy.ops.object.select_all(action='DESELECT') # Deselecciona todo en la escena
        # Get eyeline object
        elineses = (w(eline1),w(eline2),w(eline3),w(eline4),w(eline5))
        for x in elineses:
            if x is not None:
                #if bpy.data.objects.get(body1) is not None:
                op = (x.name)
                bpy.data.objects.get(op).select_set(True)
                outline_eline = bpy.data.objects.get(op)
                bpy.context.view_layer.objects.active = outline_eline
                ob = bpy.context.selected_objects
                material_set = set()
                for object in bpy.context.selected_objects:
                    for material in object.material_slots:
                        material_set.add(material)
                for material in material_set:
                    #print(material.name)
                    Tex = material.name
                    bpy.context.object.active_material.blend_method = 'HASHED'
                    bpy.context.object.active_material.shadow_method = 'HASHED'
                    #print(Tex+'_MainTex.png')
                    TexMain = Tex+'_MainTex.png'
                imgmayu = ( bpimg('c_m_eyelashes_MainTex.png'), bpimg('roshi'))
                for x in imgmayu:
                    if x is not None:
                        bpy.data.images['c_m_eyelashes_MainTex.png'].name = TexMain
                        bpy.data.images[TexMain].filepath = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexMain
                        bpy.data.images[TexMain].filepath_raw = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexMain
                mat = bpy.data.materials[Tex]
                #Get the node in its node tree (replace the name below)
                node_to_delete =  mat.node_tree.nodes['Principled BSDF']
                node_to_delete2 =  mat.node_tree.nodes['Material Output']
                #Remove it
                mat.node_tree.nodes.remove(node_to_delete)
                mat.node_tree.nodes.remove(node_to_delete2)
                C = bpy.context

                def instantiate_group(nodes, data_block_name):
                    group = nodes.new(type='ShaderNodeGroup')
                    group.node_tree = bpy.data.node_groups['HS2-Template Eyelashes']
                    return group
                instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
                my_mat = bpy.data.materials.get(Tex)
                bpy.data.node_groups['HS2-Template Eyelashes'].name = 'HS2-Template Eyelashes '+Tex
                node = bpy.data.node_groups['HS2-Template Eyelashes '+Tex]
                #node.extension = 'CLIP'
                #node.image = bpy.data.images[bakefinal.name]
                nodes = my_mat.node_tree.nodes
                for node in nodes:
                    node.select = False
                    node.select = True
                    nodes.active = node
                try:
                    initial_area_type = bpy.context.area.type
                    bpy.context.area.type = 'NODE_EDITOR'
                    bpy.context.area.ui_type = 'ShaderNodeTree'
                    bpy.ops.wm.redraw_timer(type='DRAW_WIN', iterations=1)
                    bpy.ops.node.group_ungroup()
                    bpy.ops.node.group_edit(exit=True)
                except Exception as e:
                    print(e)
                finally:
                    bpy.context.area.type = initial_area_type
                break
        bpy.ops.object.select_all(action='DESELECT') # Deselecciona todo en la escena
        ###################################TEARS#####################################
        bpy.ops.object.select_all(action='DESELECT') # Deselecciona todo en la escena
        # Get mayu object
        mayugeses = (w(mayu1),w(mayu2),w(mayu3),w(mayu4),w(mayu5))
        for x in mayugeses:
            if x is not None:
                #if bpy.data.objects.get(mayu1) is not None:
                op = (x.name)
                bpy.data.objects.get(op).select_set(True)
                outline_mayu = bpy.data.objects.get(op)
                bpy.context.view_layer.objects.active = outline_mayu
                ob = bpy.context.selected_objects
                material_set = set()
                for object in bpy.context.selected_objects:
                    for material in object.material_slots:
                        material_set.add(material)
                for material in material_set:
                    #print(material.name)
                    Tex = material.name
                    bpy.context.object.active_material.blend_method = 'HASHED'
                    bpy.context.object.active_material.shadow_method = 'HASHED'
                    #print(Tex+'_MainTex.png')
                    TexMain = Tex+'_MainTex.png'
                    TexSpecGM = Tex+'_SpecGlossMap.png'
                imgmayu = ( bpimg('c_m_eye_namida_MainTex.png'), bpimg('roshi'))
                for x in imgmayu:
                    if x is not None:
                        bpy.data.images['c_m_eye_namida_MainTex.png'].name = TexMain
                        bpy.data.images[TexMain].filepath = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexMain
                        bpy.data.images[TexMain].filepath_raw = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexMain
                mat = bpy.data.materials[Tex]
                #Get the node in its node tree (replace the name below)
                node_to_delete =  mat.node_tree.nodes['Principled BSDF']
                node_to_delete2 =  mat.node_tree.nodes['Material Output']
                #Remove it
                mat.node_tree.nodes.remove(node_to_delete)
                mat.node_tree.nodes.remove(node_to_delete2)
                C = bpy.context

                def instantiate_group(nodes, data_block_name):
                    group = nodes.new(type='ShaderNodeGroup')
                    group.node_tree = bpy.data.node_groups['HS2-Template Tears']
                    return group
                instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
                my_mat = bpy.data.materials.get(Tex)
                bpy.data.node_groups['HS2-Template Tears'].name = 'HS2-Template Tears '+Tex
                node = bpy.data.node_groups['HS2-Template Tears '+Tex]
                #node.extension = 'CLIP'
                #node.image = bpy.data.images[bakefinal.name]
                nodes = my_mat.node_tree.nodes
                for node in nodes:
                    node.select = False
                    node.select = True
                    nodes.active = node
                try:
                    initial_area_type = bpy.context.area.type
                    bpy.context.area.type = 'NODE_EDITOR'
                    bpy.context.area.ui_type = 'ShaderNodeTree'
                    bpy.ops.wm.redraw_timer(type='DRAW_WIN', iterations=1)
                    bpy.ops.node.group_ungroup()
                    bpy.ops.node.group_edit(exit=True)
                except Exception as e:
                    print(e)
                finally:
                    bpy.context.area.type = initial_area_type
                break
        bpy.ops.object.select_all(action='DESELECT') # Deselecciona todo en la escena
        ##################################EYEKAGE####################################
        #bpy.ops.object.select_all(action='DESELECT') # Deselecciona todo en la escena
        ## Get mayu object
        #kageses = (w(kage1),w(kage2),w(kage3),w(kage4),w(kage5))
        #for x in kageses:
        #    if x is not None:
        #        #if bpy.data.objects.get(mayu1) is not None:
        #        op = (x.name)
        #        bpy.data.objects.get(op).select_set(True)
        #        outline_kage = bpy.data.objects.get(op)
        #        bpy.context.view_layer.objects.active = outline_kage
        #        ob = bpy.context.selected_objects
        #        material_set = set()
        #        for object in bpy.context.selected_objects:
        #            for material in object.material_slots:
        #                material_set.add(material)
        #        for material in material_set:
        #            #    print(material.name)
        #            Tex = material.name
        #            #  print(Tex+'_MainTex.png')
        #            TexMain = Tex+'_MainTex.png'
        #            bpy.context.object.active_material.blend_method = 'BLEND'
        #            bpy.context.object.active_material.shadow_method = 'HASHED'
        #        
        #        imgmayu = ( bpimg('cf_M_eyekage_01_MainTex.png'), bpimg('roshi'))
        #        for x in imgmayu:
        #            if x is not None:
        #                bpy.data.images['cf_M_eyekage_01_MainTex.png'].name = TexMain
        #                bpy.data.images[TexMain].filepath = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexMain
        #                bpy.data.images[TexMain].filepath_raw = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexMain
        #                
        #        mat = bpy.data.materials[Tex]
        #        #Get the node in its node tree (replace the name below)
        #        node_to_delete =  mat.node_tree.nodes['Principled BSDF']
        #        node_to_delete2 =  mat.node_tree.nodes['Material Output']
        #        #Remove it
        #        mat.node_tree.nodes.remove(node_to_delete)
        #        mat.node_tree.nodes.remove(node_to_delete2)
        #                
        #        C = bpy.context
        #        def instantiate_group(nodes, data_block_name):
        #            group = nodes.new(type='ShaderNodeGroup')
        #            group.node_tree = bpy.data.node_groups['HS1-Template Kage']
        #            return group
        #        instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
        #                
        #        my_mat = bpy.data.materials.get(Tex)
        #        
        #        bpy.data.node_groups['HS1-Template Kage'].name = 'HS1-Template Kage '+Tex
        #        
        #        node = bpy.data.node_groups['HS1-Template Kage '+Tex]
        #        #node.extension = 'CLIP'
        #        #node.image = bpy.data.images[bakefinal.name]
        #        nodes = my_mat.node_tree.nodes
        #        for node in nodes:
        #            node.select = False
        #            node.select = True
        #            nodes.active = node
        #        try:
        #            initial_area_type = bpy.context.area.type
        #            bpy.context.area.type = 'NODE_EDITOR'
        #            bpy.context.area.ui_type = 'ShaderNodeTree'
        #            bpy.ops.wm.redraw_timer(type='DRAW_WIN', iterations=1)
        #            bpy.ops.node.group_ungroup()
        #            bpy.ops.node.group_edit(exit=True)
        #        except Exception as e:
        #            print(e)
        #        finally:
        #            bpy.context.area.type = initial_area_type
        #        break
        #bpy.ops.object.select_all(action='DESELECT') # Deselecciona todo en la escena
        ##################################PupilL#####################################
        #bpy.ops.object.select_all(action='DESELECT') # Deselecciona todo en la escena
        ## Get mayu object
        #pupilLes = (w(pupilL1),w(pupilL2),w(pupilL3),w(pupilL4),w(pupilL5))
        #for x in pupilLes:
        #    if x is not None:
        #        #if bpy.data.objects.get(mayu1) is not None:
        #        op = (x.name)
        #        bpy.data.objects.get(op).select_set(True)
        #        outline_pupilL = bpy.data.objects.get(op)
        #        bpy.context.view_layer.objects.active = outline_pupilL
        #        ob = bpy.context.selected_objects
        #        material_set = set()
        #        for object in bpy.context.selected_objects:
        #            for material in object.material_slots:
        #                material_set.add(material)
        #        for material in material_set:
        #        #    print(material.name)
        #            Tex = material.name
        #        #  print(Tex+'_MainTex.png')
        #            TexMainPupil = Tex+'_MainTex.png'
        #            TexOccPupil = Tex+'_OcclusionMap.png'
        #            TexSGMPupil = Tex+'_SpecGlossMap.png'
        #        
        ##        imgmayu = ( bpimg('cf_m_eye_00_23_00_MainTex.png'), bpimg('roshi'))
        ##        for x in imgmayu:
        ##            if x is not None:
        #        bpy.data.images['cf_M_eyewhite_01_MainTex.png'].name = TexMainPupil
        #        bpy.data.images['cf_M_eyewhite_01_OcclusionMap.png'].name = TexOccPupil
        #        bpy.data.images['cf_M_eyewhite_01_SpecGlossMap.png'].name = TexSGMPupil
        #        bpy.data.images[TexMainPupil].filepath = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexMainPupil
        #        bpy.data.images[TexMainPupil].filepath_raw = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexMainPupil
        #        
        #        bpy.data.images[TexOccPupil].filepath = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexOccPupil
        #        bpy.data.images[TexOccPupil].filepath_raw = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexOccPupil
        #        
        #        bpy.data.images[TexSGMPupil].filepath = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexSGMPupil
        #        bpy.data.images[TexSGMPupil].filepath_raw = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexSGMPupil
        #                
        #        mat = bpy.data.materials[Tex]
        #        #Get the node in its node tree (replace the name below)
        #        node_to_delete =  mat.node_tree.nodes['Principled BSDF']
        #        node_to_delete2 =  mat.node_tree.nodes['Material Output']
        #        #Remove it
        #        mat.node_tree.nodes.remove(node_to_delete)
        #        mat.node_tree.nodes.remove(node_to_delete2)
        #        C = bpy.context
        #        def instantiate_group(nodes, data_block_name):
        #            group = nodes.new(type='ShaderNodeGroup')
        #            group.node_tree = bpy.data.node_groups['HS1-Template Pupil']
        #            return group
        #        instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
        #        
        #        bpy.context.object.active_material.blend_method = 'BLEND'
        #        bpy.context.object.active_material.shadow_method = 'HASHED'
        #        
        #        my_mat = bpy.data.materials.get(Tex)
        #        
        ##        bpy.data.node_groups['HS1-Template Pupil'].name = 'HS1-Template Pupil '+Tex
        #        
        #        node = bpy.data.node_groups['HS1-Template Pupil']
        #        #node.extension = 'CLIP'
        #        #node.image = bpy.data.images[bakefinal.name]
        #        nodes = my_mat.node_tree.nodes
        #        for node in nodes:
        #            node.select = False
        #            node.select = True
        #            nodes.active = node
        #        try:
        #            initial_area_type = bpy.context.area.type
        #            bpy.context.area.type = 'NODE_EDITOR'
        #            bpy.context.area.ui_type = 'ShaderNodeTree'
        #            bpy.ops.wm.redraw_timer(type='DRAW_WIN', iterations=1)
        #            bpy.ops.node.group_ungroup()
        #            bpy.ops.node.group_edit(exit=True)
        #        except Exception as e:
        #            print(e)
        #        finally:
        #            bpy.context.area.type = initial_area_type
        #        break
        #bpy.ops.object.select_all(action='DESELECT') # Deselecciona todo en la escena
        ##################################PupilR#####################################
        ##################################EyehiKL#####################################
        #bpy.ops.object.select_all(action='DESELECT') # Deselecciona todo en la escena
        ## Get mayu object
        #eyehikLes = (w(eyehikL1),w(eyehikL2),w(eyehikL3),w(eyehikL4),w(eyehikL5))
        #for x in eyehikLes:
        #    if x is not None:
        #        #if bpy.data.objects.get(mayu1) is not None:
        #        op = (x.name)
        #        bpy.data.objects.get(op).select_set(True)
        #        outline_hlL = bpy.data.objects.get(op)
        #        bpy.context.view_layer.objects.active = outline_hlL
        #        ob = bpy.context.selected_objects
        #        material_set = set()
        #        for object in bpy.context.selected_objects:
        #            for material in object.material_slots:
        #                material_set.add(material)
        #        for material in material_set:
        #        #    print(material.name)
        #            Tex = material.name
        #        #  print(Tex+'_MainTex.png')
        #            TexMain = Tex+'_MainTex.png'
        #        
        #        imgmayu = ( bpimg('cf_m_eyehi_00_02_00_MainTex.png'), bpimg('roshi'))
        #        for x in imgmayu:
        #            if x is not None:
        #                bpy.data.images['cf_m_eyehi_00_02_00_MainTex.png'].name = TexMain
        #                bpy.data.images[TexMain].filepath = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexMain
        #                bpy.data.images[TexMain].filepath_raw = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexMain
        #                
        #        mat = bpy.data.materials[Tex]
        #        #Get the node in its node tree (replace the name below)
        #        node_to_delete =  mat.node_tree.nodes['Principled BSDF']
        #        node_to_delete2 =  mat.node_tree.nodes['Material Output']
        #        #Remove it
        #        mat.node_tree.nodes.remove(node_to_delete)
        #        mat.node_tree.nodes.remove(node_to_delete2)
        #        C = bpy.context
        #        def instantiate_group(nodes, data_block_name):
        #            group = nodes.new(type='ShaderNodeGroup')
        #            group.node_tree = bpy.data.node_groups['HS1-Template HL']
        #            return group
        #        instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
        #        
        #        bpy.context.object.active_material.blend_method = 'HASHED'
        #        bpy.context.object.active_material.shadow_method = 'HASHED'
        #        
        #        my_mat = bpy.data.materials.get(Tex)
        #        
        #        node = bpy.data.node_groups['HS1-Template HL']
        #        #node.extension = 'CLIP'
        #        #node.image = bpy.data.images[bakefinal.name]
        #        nodes = my_mat.node_tree.nodes
        #        for node in nodes:
        #            node.select = False
        #            node.select = True
        #            nodes.active = node
        #        try:
        #            initial_area_type = bpy.context.area.type
        #            bpy.context.area.type = 'NODE_EDITOR'
        #            bpy.context.area.ui_type = 'ShaderNodeTree'
        #            bpy.ops.wm.redraw_timer(type='DRAW_WIN', iterations=1)
        #            bpy.ops.node.group_ungroup()
        #            bpy.ops.node.group_edit(exit=True)
        #        except Exception as e:
        #            print(e)
        #        finally:
        #            bpy.context.area.type = initial_area_type
        #        break
        #bpy.ops.object.select_all(action='DESELECT') # Deselecciona todo en la escena
        ##################################EyehiKR#####################################
        ################################Tooth###################################
        bpy.ops.object.select_all(action='DESELECT') # Deselecciona todo en la escena
        # Get tooth object
        tootheses = (w(tooth1),w(tooth2),w(tooth3),w(tooth4),w(tooth5))
        for x in tootheses:
            if x is not None:
                #if bpy.data.objects.get(mayu1) is not None:
                op = (x.name)
                bpy.data.objects.get(op).select_set(True)
                outline_tooth = bpy.data.objects.get(op)
                bpy.context.view_layer.objects.active = outline_tooth
                ob = bpy.context.selected_objects
                material_set = set()
                for object in bpy.context.selected_objects:
                    for material in object.material_slots:
                        material_set.add(material)
                for material in material_set:
                #    print(material.name)
                    Tex = material.name
                #  print(Tex+'_MainTex.png')
                    TexMain = Tex+'_MainTex.png'
                    TexOcclusionM = Tex+'_OcclusionMap.png'
                    TexBump = Tex+'_BumpMap.png'
                    TexMT = Tex+'_MatcapTexture.png'
                imgtooth = ( bpimg('c_m_tooth_MainTex.png'), bpimg('tenseigan'))
                for x in imgtooth:
                    if x is not None:
                        bpy.data.images['c_m_tooth_MainTex.png'].name = TexMain 
                        bpy.data.images['c_m_tooth_OcclusionMap.png'].name = TexOcclusionM
                        bpy.data.images['c_m_tooth_BumpMap.png'].name = TexBump
                        bpy.data.images['c_m_tooth_MatcapTexture.png'].name = TexMT
                        bpy.data.images[TexMain].filepath = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexMain
                        bpy.data.images[TexMain].filepath_raw = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexMain
                        bpy.data.images[TexOcclusionM].filepath = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexOcclusionM
                        bpy.data.images[TexOcclusionM].filepath_raw = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexOcclusionM
                        bpy.data.images[TexBump].filepath_raw = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexBump
                        bpy.data.images[TexBump].filepath = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexBump
                        bpy.data.images[TexMT].filepath_raw = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexMT
                        bpy.data.images[TexMT].filepath = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexMT
                mat = bpy.data.materials[Tex]
                #Get the node in its node tree (replace the name below)
                node_to_delete =  mat.node_tree.nodes['Principled BSDF']
                node_to_delete2 =  mat.node_tree.nodes['Material Output']
                #Remove it
                mat.node_tree.nodes.remove(node_to_delete)
                mat.node_tree.nodes.remove(node_to_delete2)
                C = bpy.context

                def instantiate_group(nodes, data_block_name):
                    group = nodes.new(type='ShaderNodeGroup')
                    group.node_tree = bpy.data.node_groups['HS2-Template Teeth']
                    return group
                instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
                my_mat = bpy.data.materials.get(Tex)
                bpy.data.node_groups['HS2-Template Teeth'].name = 'HS2-Template Teeth '+Tex
                node = bpy.data.node_groups['HS2-Template Teeth '+Tex]
                #node.extension = 'CLIP'
                #node.image = bpy.data.images[bakefinal.name]
                nodes = my_mat.node_tree.nodes
                for node in nodes:
                    node.select = False
                    node.select = True
                    nodes.active = node
                try:
                    initial_area_type = bpy.context.area.type
                    bpy.context.area.type = 'NODE_EDITOR'
                    bpy.context.area.ui_type = 'ShaderNodeTree'
                    bpy.ops.wm.redraw_timer(type='DRAW_WIN', iterations=1)
                    bpy.ops.node.group_ungroup()
                    bpy.ops.node.group_edit(exit=True)
                except Exception as e:
                    print(e)
                finally:
                    bpy.context.area.type = initial_area_type
                break
        bpy.ops.object.select_all(action='DESELECT') # Deselecciona todo en la escena
        ###################################TONGUE####################################
        tongeses = (w(tong1),w(tong2),w(tong3),w(tong4),w(tong5))
        for x in tongeses:
            if x is not None:
                #if bpy.data.objects.get(mayu1) is not None:
                op = (x.name)
                bpy.data.objects.get(op).select_set(True)
                outline_tong = bpy.data.objects.get(op)
                bpy.context.view_layer.objects.active = outline_tong
                ob = bpy.context.selected_objects
                material_set = set()
                for object in bpy.context.selected_objects:
                    for material in object.material_slots:
                        material_set.add(material)
                for material in material_set:
                #    print(material.name)
                    Tex = material.name
                #  print(Tex+'_MainTex.png')
                    TexMain = Tex+'_MainTex.png'
                    TexOcclusionM = Tex+'_OcclusionMap.png'
                    TexBump = Tex+'_BumpMap.png'
                    TexMT = Tex+'_MatcapTexture.png'
                    TexDGM = Tex+'_DetailGlossMap.png'
                imgtong = ( bpimg('c_m_tang_MainTex.png'), bpimg('tenseigan'))
                for x in imgtong:
                    if x is not None:
                        bpy.data.images['c_m_tang_MainTex.png'].name = TexMain 
                        bpy.data.images['c_m_tang_OcclusionMap.png'].name = TexOcclusionM
                        bpy.data.images['c_m_tang_BumpMap.png'].name = TexBump
                        bpy.data.images['c_m_tang_MatcapTexture.png'].name = TexMT
                        bpy.data.images['c_m_tang_DetailGlossMap.png'].name = TexDGM
                        bpy.data.images[TexMain].filepath = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexMain
                        bpy.data.images[TexMain].filepath_raw = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexMain
                        bpy.data.images[TexOcclusionM].filepath = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexOcclusionM
                        bpy.data.images[TexOcclusionM].filepath_raw = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexOcclusionM
                        bpy.data.images[TexDGM].filepath = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexDGM
                        bpy.data.images[TexDGM].filepath_raw = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexDGM
                        bpy.data.images[TexBump].filepath = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexBump
                        bpy.data.images[TexBump].filepath_raw = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexBump
                        bpy.data.images[TexMT].filepath = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexMT
                        bpy.data.images[TexMT].filepath_raw = "R:\Games\Honey Select Unlimited FR-3.5\Export\20220613072415_SitriTemplate\Textures/"+TexMT
                mat = bpy.data.materials[Tex]
                #Get the node in its node tree (replace the name below)
                node_to_delete =  mat.node_tree.nodes['Principled BSDF']
                node_to_delete2 =  mat.node_tree.nodes['Material Output']
                #Remove it
                mat.node_tree.nodes.remove(node_to_delete)
                mat.node_tree.nodes.remove(node_to_delete2)
                C = bpy.context 

                def instantiate_group(nodes, data_block_name):
                    group = nodes.new(type='ShaderNodeGroup')
                    group.node_tree = bpy.data.node_groups['HS2-Template Tongue']
                    return group
                instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
                my_mat = bpy.data.materials.get(Tex)
                bpy.data.node_groups['HS2-Template Tongue'].name = 'HS2-Template Tongue '+Tex
                node = bpy.data.node_groups['HS2-Template Tongue '+Tex]
                #node.extension = 'CLIP'
                #node.image = bpy.data.images[bakefinal.name]
                nodes = my_mat.node_tree.nodes
                for node in nodes:
                    node.select = False
                    node.select = True
                    nodes.active = node
                try:
                    initial_area_type = bpy.context.area.type
                    bpy.context.area.type = 'NODE_EDITOR'
                    bpy.context.area.ui_type = 'ShaderNodeTree'
                    bpy.ops.wm.redraw_timer(type='DRAW_WIN', iterations=1)
                    bpy.ops.node.group_ungroup()
                    bpy.ops.node.group_edit(exit=True)
                except Exception as e:
                    print(e)
                finally:
                    bpy.context.area.type = initial_area_type
                break
        bpy.ops.object.select_all(action='DESELECT') # Deselecciona todo en la escena
        #bpy.ops.object.select_all(action='DESELECT')
        #bpy.data.objects.get('Armature.001').select_set(True)
        #armatureobject = bpy.data.objects.get('Armature.001')
        #bpy.context.view_layer.objects.active = armatureobject
        #bpy.ops.object.delete()
        #bpy.ops.object.select_all(action='DESELECT')
        #bpy.data.objects.get('Cube.001').select_set(True)
        #Cubeobject = bpy.data.objects.get('Cube.001')
        #bpy.context.view_layer.objects.active = Cubeobject
        #bpy.ops.object.delete()
        bpy.data.armatures['Armature'].display_type = "STICK"
        bpy.ops.file.find_missing_files('INVOKE_DEFAULT')
        return {"FINISHED"}

    def invoke(self, context, event):
        return self.execute(context)


class SNA_OT_Hs2Facemanual_6429F(bpy.types.Operator):
    bl_idname = "sna.hs2facemanual_6429f"
    bl_label = "hs2-face-manual"
    bl_description = ""
    bl_options = {"REGISTER", "UNDO"}

    @classmethod
    def poll(cls, context):
        return not False

    def execute(self, context):
        import os
        ########################################################################
        my_mat = bpy.context.object.material_slots[0].material
        print(my_mat.name)
        Tex=my_mat.name
        rem_mat = bpy.data.materials[Tex]
        #Get the node in its node tree (replace the name below)
        node_to_delete =  rem_mat.node_tree.nodes['Principled BSDF']
        node_to_delete2 =  rem_mat.node_tree.nodes['Material Output']
        #Remove it
        rem_mat.node_tree.nodes.remove(node_to_delete)
        rem_mat.node_tree.nodes.remove(node_to_delete2)
        #Tex = material.name
        TexMain = Tex+'_MainTex.png'
        TexDetailM = Tex+'_DetailMask.png'
        TexNormal = Tex+'_NormalMap.png'
        TexNDetail = Tex+'_NormalMapDetail.png'
        TexAlphaM = Tex+'_AlphaMask.png'
        TexAnotherR = Tex+'_AnotherRamp.png'
        TexLiquidM = Tex+'_liquidmask.png'
        TexTex2 = Tex+'_Texture2.png'
        TexTex3 = Tex+'_Texture3.png'
        TexOv1 = Tex+'_overtex1.png'
        TexOv2 = Tex+'_overtex2.png'
        TexLineM = Tex+'_LineMask.png'
        TexColorM = Tex+'_ColorMask.png'
        TexHairG = Tex+'_HairGloss.png'
        TexBump = Tex+'_BumpMap.png'
        TexDNM = Tex+'_DetailNormalMap.png'
        TexBNM = Tex+'_BlendNormalMap.png'
        TexSGM = Tex+'_SpecGlossMap.png'
        TexOM = Tex+'_OcclusionMap.png'
        TexTSS = Tex+'_Thickness.png'
        TexMGM = Tex+'_MetallicGlossMap.png'
        TexOV = Tex+'_OverTex.png'
        #hs2
        TexBump2 = Tex+'_BumpMap2.png'
        TexDMT = Tex+'_DetailMainTex.png'
        TexDGM = Tex+'_DetailGlossMap.png'
        TexDGM2 = Tex+'_DetailGlossMap2.png'
        TexNailM = Tex+'_NailMask.png'
        TexWetMK = Tex+'_WeatheringMask.png'
        TexWetMP = Tex+'_WeatheringMap.png'
        TexOC = Tex+'_Occlusion.png'
        originaltex = 'mat_head_preset_'
        #originaltss = 'cf_m_body_01_'
        #kkp
        nm = originaltex+'NormalMap.png'
        nd = originaltex+'NormalMapDetail.png'
        dm = originaltex+'DetailMask.png'
        mm = originaltex+'MainTex.png'
        t3 = originaltex+'Texture3.png'
        t2 = originaltex+'Texture2.png'
        am = originaltex+'AlphaMask.png'
        lm = originaltex+'liquidmask.png'
        ar = originaltex+'AnotherRamp.png'
        ov1 = originaltex+'overtex1.png'
        ov2 = originaltex+'overtex2.png'
        lnm = originaltex+'LineMask.png'
        com = originaltex+'ColorMask.png'
        glo = originaltex+'HairGloss.png'
        #hs1
        bum = originaltex+'BumpMap.png'
        dnm = originaltex+'DetailNormalMap.png'
        bnm = originaltex+'BlendNormalMap.png'
        sgm = originaltex+'SpecGlossMap.png'
        om = originaltex+'OcclusionMap.png'
        tss = originaltex+'Thickness.png'
        mgm = originaltex+'MetallicGlossMap.png'
        ov = originaltex+'OverTex.png'
        #hs2
        bum2 = originaltex+'BumpMap2.png'
        dmt = originaltex+'DetailMainTex.png'
        dgm = originaltex+'DetailGlossMap.png'
        dgm2 = originaltex+'DetailGlossMap2.png'
        nail = originaltex+'NailMask.png'
        wetmk = originaltex+'WeatheringMask.png'
        wetmp = originaltex+'WeatheringMap.png'
        oc = originaltex+'Occlusion.png'
        Template='HS2-Template Face'
        CTemplate=Template+' '
        C = bpy.context

        def instantiate_group(nodes, data_block_name):
            group = nodes.new(type='ShaderNodeGroup')
            group.node_tree = bpy.data.node_groups[Template]
            return group
        if Template in bpy.data.node_groups:
            instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
        else:
        #    versions = ( t0, t1, t2, t3, t4)
        #    for x in versions:
        #        if os.path.isdir(x) and os.access(x, os.R_OK):
            if (3, 0, 0) <= bpy.app.version < (3, 0, 99):
                before_data = list(bpy.data.node_groups)
                bpy.ops.wm.append(directory=os.path.expanduser(r"~\AppData\Roaming\Blender Foundation\Blender\3.0\scripts\addons\sklx_creator\assets\HS2_Template_Shader.blend") + r'\NodeTree',filename=Template,link=False)
                new_data=list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
                appended_2B5AC = None if not new_data else new_data[0]
                instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
            else:
                if (3, 1, 0) <= bpy.app.version < (3, 1, 99):
                    before_data = list(bpy.data.node_groups)
                    bpy.ops.wm.append(directory=os.path.expanduser(r"~\AppData\Roaming\Blender Foundation\Blender\3.1\scripts\addons\sklx_creator\assets\HS2_Template_Shader.blend") + r'\NodeTree',filename=Template,link=False)
                    new_data=list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
                    appended_2B5AC = None if not new_data else new_data[0]
                    instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
                else:
                    if (3, 2, 0) <= bpy.app.version < (3, 2, 99):
                        before_data = list(bpy.data.node_groups)
                        bpy.ops.wm.append(directory=os.path.expanduser(r"~\AppData\Roaming\Blender Foundation\Blender\3.2\scripts\addons\sklx_creator\assets\HS2_Template_Shader.blend") + r'\NodeTree',filename=Template,link=False)
                        new_data=list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
                        appended_2B5AC = None if not new_data else new_data[0]
                        instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
                    else:
                        if (3, 3, 0) <= bpy.app.version < (3, 3, 99):
                            before_data = list(bpy.data.node_groups)
                            bpy.ops.wm.append(directory=os.path.expanduser(r"~\AppData\Roaming\Blender Foundation\Blender\3.3\scripts\addons\sklx_creator\assets\HS2_Template_Shader.blend") + r'\NodeTree',filename=Template,link=False)
                            new_data=list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
                            appended_2B5AC = None if not new_data else new_data[0]
                            instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
                        else:
                            if (3, 4, 0) <= bpy.app.version < (3, 4, 99):
                                before_data = list(bpy.data.node_groups)
                                bpy.ops.wm.append(directory=os.path.expanduser(r"~\AppData\Roaming\Blender Foundation\Blender\3.4\scripts\addons\sklx_creator\assets\HS2_Template_Shader.blend") + r'\NodeTree',filename=Template,link=False)
                                new_data=list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
                                appended_2B5AC = None if not new_data else new_data[0]
                                instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
        bpy.data.node_groups[Template].name = CTemplate+Tex
        node = bpy.data.node_groups[CTemplate+Tex]
        #initial_area_type = bpy.context.area.type
        #bpy.context.area.type = 'NODE_EDITOR'
        #bpy.context.area.ui_type = 'ShaderNodeTree'
        #bpy.ops.node.group_ungroup()
        #bpy.context.area.type = initial_area_type
        nodes = my_mat.node_tree.nodes
        for node in nodes:
            #node.select = False
            print(node.name)
            node.select = True
            nodes.active = node
        try:
            initial_area_type = bpy.context.area.type
            bpy.context.area.type = 'NODE_EDITOR'
            bpy.context.area.ui_type = 'ShaderNodeTree'
            bpy.ops.wm.redraw_timer(type='DRAW_WIN', iterations=1)
            bpy.ops.node.group_ungroup()
            nonono = node," to Ungroup"
            print(nonono)
            bpy.ops.node.group_edit(exit=True)
        except Exception as e:
            print(e)
        finally:
            bpy.context.area.type = initial_area_type
        fixlocate = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\\20220603141428_Chika_Haruno\\Textures\\"
        bpimg = bpy.data.images.get
        if 1==1:
            print(mm)
            print(dm)
            print(nm)
            print(t2)
            print(t3)
        #formula_list=(nm,nd,dm,mm,t2,t3,am,lm,ar,ov1,ov2,lnm,com,glo,bum,dnm,bnm,sgm,om,tss,mgm,ov)
        #for formula in formula_list:
        #    if bpimg(formula) is not None:
        f1 = bpimg(mm)
        #for x in f1:
        if f1 is not None:
            bpy.data.images[mm].name = TexMain
            bpy.data.images[TexMain].filepath = fixlocate+TexMain
            bpy.data.images[TexMain].filepath_raw = fixlocate+TexMain
        f2 = bpimg(dm)
        #for x in f2:
        if f2 is not None:
            bpy.data.images[dm].name = TexDetailM
            bpy.data.images[TexDetailM].filepath = fixlocate+TexDetailM
            bpy.data.images[TexDetailM].filepath_raw = fixlocate+TexDetailM
        f3 = bpimg(nm)
        #for x in f3:
        if f3 is not None:
            bpy.data.images[nm].name = TexNormal
            bpy.data.images[TexNormal].filepath = fixlocate+TexNormal
            bpy.data.images[TexNormal].filepath_raw = fixlocate+TexNormal
        f4 = bpimg(t2)
        #for x in f3:
        if f4 is not None:
            bpy.data.images[t2].name = TexTex2
            bpy.data.images[TexTex2].filepath = fixlocate+TexTex2
            bpy.data.images[TexTex2].filepath_raw = fixlocate+TexTex2
        f5 = bpimg(t3)
        #for x in f4:
        if f5 is not None:
            bpy.data.images[t3].name = TexTex3
            bpy.data.images[TexTex3].filepath = fixlocate+TexTex3
            bpy.data.images[TexTex3].filepath_raw = fixlocate+TexTex3
        f6 = bpimg(am)
        #for x in f5:
        if f6 is not None:
            bpy.data.images[am].name = TexAlphaM
            bpy.data.images[TexAlphaM].filepath = fixlocate+TexAlphaM
            bpy.data.images[TexAlphaM].filepath_raw = fixlocate+TexAlphaM
        f7 = bpimg(lm)
        #for x in f6:
        if f7 is not None:
            bpy.data.images[lm].name = TexLiquidM
            bpy.data.images[TexLiquidM].filepath = fixlocate+TexLiquidM
            bpy.data.images[TexLiquidM].filepath_raw = fixlocate+TexLiquidM
        f8 = bpimg(ar)
        #for f8 in f8:
        if f8 is not None:
            bpy.data.images[ar].name = TexAnotherR
            bpy.data.images[TexAnotherR].filepath = fixlocate+TexAnotherR
            bpy.data.images[TexAnotherR].filepath_raw = fixlocate+TexAnotherR
        f9 = bpimg(nd)
        #for f8 in f8:
        if f9 is not None:
            bpy.data.images[nd].name = TexNDetail
            bpy.data.images[TexNDetail].filepath = fixlocate+TexNDetail
            bpy.data.images[TexNDetail].filepath_raw = fixlocate+TexNDetail
        f10 = bpimg(ov1)
        #for f8 in f8:
        if f10 is not None:
            bpy.data.images[ov1].name = TexOv1
            bpy.data.images[TexOv1].filepath = fixlocate+TexOv1
            bpy.data.images[TexOv1].filepath_raw = fixlocate+TexOv1
        f11 = bpimg(ov2)
        #for f8 in f8:
        if f11 is not None:
            bpy.data.images[ov2].name = TexOv2
            bpy.data.images[TexOv2].filepath = fixlocate+TexOv2
            bpy.data.images[TexOv2].filepath_raw = fixlocate+TexOv2
        f12 = bpimg(lnm)
        #for f8 in f8:
        if f12 is not None:
            bpy.data.images[lnm].name = TexLineM
            bpy.data.images[TexLineM].filepath = fixlocate+TexLineM
            bpy.data.images[TexLineM].filepath_raw = fixlocate+TexLineM
        f13 = bpimg(com)
        #for f8 in f8:
        if f13 is not None:
            bpy.data.images[com].name = TexColorM
            bpy.data.images[TexColorM].filepath = fixlocate+TexColorM
            bpy.data.images[TexColorM].filepath_raw = fixlocate+TexColorM
        f14 = bpimg(glo)
        #for f8 in f8:
        if f14 is not None:
            bpy.data.images[glo].name = TexHairG
            bpy.data.images[TexHairG].filepath = fixlocate+TexHairG
            bpy.data.images[TexHairG].filepath_raw = fixlocate+TexHairG
        f15 = bpimg(bum)
        #for f8 in f8:
        if f15 is not None:
            bpy.data.images[bum].name = TexBump
            bpy.data.images[TexBump].filepath = fixlocate+TexBump
            bpy.data.images[TexBump].filepath_raw = fixlocate+TexBump
        f16 = bpimg(dnm)
        #for f8 in f8:
        if f16 is not None:
            bpy.data.images[dnm].name = TexDNM
            bpy.data.images[TexDNM].filepath = fixlocate+TexDNM
            bpy.data.images[TexDNM].filepath_raw = fixlocate+TexDNM
        f17 = bpimg(bnm)
        #for f8 in f8:
        if f17 is not None:
            bpy.data.images[bnm].name = TexBNM
            bpy.data.images[TexBNM].filepath = fixlocate+TexBNM
            bpy.data.images[TexBNM].filepath_raw = fixlocate+TexBNM
        f18 = bpimg(sgm)
        #for f8 in f8:
        if f18 is not None:
            bpy.data.images[sgm].name = TexSGM
            bpy.data.images[TexSGM].filepath = fixlocate+TexSGM
            bpy.data.images[TexSGM].filepath_raw = fixlocate+TexSGM
        f19 = bpimg(om)
        #for f8 in f8:
        if f19 is not None:
            bpy.data.images[om].name = TexOM
            bpy.data.images[TexOM].filepath = fixlocate+TexOM
            bpy.data.images[TexOM].filepath_raw = fixlocate+TexOM
        f20 = bpimg(tss)
        #for f8 in f8:
        if f20 is not None:
            bpy.data.images[tss].name = TexTSS
            bpy.data.images[TexTSS].filepath = fixlocate+TexTSS
            bpy.data.images[TexTSS].filepath_raw = fixlocate+TexTSS
        f21 = bpimg(mgm)
        #for f8 in f8:
        if f21 is not None:
            bpy.data.images[mgm].name = TexMGM
            bpy.data.images[TexMGM].filepath = fixlocate+TexMGM
            bpy.data.images[TexMGM].filepath_raw = fixlocate+TexMGM
        f22 = bpimg(ov)
        #for f8 in f8:
        if f22 is not None:
            bpy.data.images[ov].name = TexOV
            bpy.data.images[TexOV].filepath = fixlocate+TexOV
            bpy.data.images[TexOV].filepath_raw = fixlocate+TexOV
        f23 = bpimg(bum2)
        #for f8 in f8:
        if f23 is not None:
            bpy.data.images[bum2].name = TexBump2
            bpy.data.images[TexBump2].filepath = fixlocate+TexBump2
            bpy.data.images[TexBump2].filepath_raw = fixlocate+TexBump2
        f24 = bpimg(dmt)
        if f24 is not None:
            bpy.data.images[dmt].name = TexDMT
            bpy.data.images[TexDMT].filepath = fixlocate+TexDMT
            bpy.data.images[TexDMT].filepath_raw = fixlocate+TexDMT
        f25 = bpimg(dgm)
        if f25 is not None:
            bpy.data.images[dgm].name = TexDGM
            bpy.data.images[TexDGM].filepath = fixlocate+TexDGM
            bpy.data.images[TexDGM].filepath_raw = fixlocate+TexDGM
        f26 = bpimg(dgm2)
        if f26 is not None:
            bpy.data.images[dgm2].name = TexDGM2
            bpy.data.images[TexDGM2].filepath = fixlocate+TexDGM2
            bpy.data.images[TexDGM2].filepath_raw = fixlocate+TexDGM2
        f27 = bpimg(nail)
        if f27 is not None:
            bpy.data.images[nail].name = TexNailM
            bpy.data.images[TexNailM].filepath = fixlocate+TexNailM
            bpy.data.images[TexNailM].filepath_raw = fixlocate+TexNailM
        f28 = bpimg(wetmk)
        if f28 is not None:
            bpy.data.images[wetmk].name = TexWetMK
            bpy.data.images[TexWetMK].filepath = fixlocate+TexWetMK
            bpy.data.images[TexWetMK].filepath_raw = fixlocate+TexWetMK
        f29 = bpimg(wetmp)
        if f29 is not None:
            bpy.data.images[wetmp].name = TexWetMP
            bpy.data.images[TexWetMP].filepath = fixlocate+TexWetMP
            bpy.data.images[TexWetMP].filepath_raw = fixlocate+TexWetMP
        f30 = bpimg(oc)
        if f30 is not None:
            bpy.data.images[oc].name = TexOC
            bpy.data.images[TexOC].filepath = fixlocate+TexOC
            bpy.data.images[TexOC].filepath_raw = fixlocate+TexOC
        bpy.ops.file.find_missing_files('INVOKE_DEFAULT')
        return {"FINISHED"}

    def invoke(self, context, event):
        return self.execute(context)


class SNA_OT_Hs2Bodymanual_232Ed(bpy.types.Operator):
    bl_idname = "sna.hs2bodymanual_232ed"
    bl_label = "hs2-body-manual"
    bl_description = ""
    bl_options = {"REGISTER", "UNDO"}

    @classmethod
    def poll(cls, context):
        return not False

    def execute(self, context):
        import os
        ########################################################################
        my_mat = bpy.context.object.material_slots[0].material
        print(my_mat.name)
        Tex=my_mat.name
        rem_mat = bpy.data.materials[Tex]
        #Get the node in its node tree (replace the name below)
        node_to_delete =  rem_mat.node_tree.nodes['Principled BSDF']
        node_to_delete2 =  rem_mat.node_tree.nodes['Material Output']
        #Remove it
        rem_mat.node_tree.nodes.remove(node_to_delete)
        rem_mat.node_tree.nodes.remove(node_to_delete2)
        #Tex = material.name
        TexMain = Tex+'_MainTex.png'
        TexDetailM = Tex+'_DetailMask.png'
        TexNormal = Tex+'_NormalMap.png'
        TexNDetail = Tex+'_NormalMapDetail.png'
        TexAlphaM = Tex+'_AlphaMask.png'
        TexAnotherR = Tex+'_AnotherRamp.png'
        TexLiquidM = Tex+'_liquidmask.png'
        TexTex2 = Tex+'_Texture2.png'
        TexTex3 = Tex+'_Texture3.png'
        TexOv1 = Tex+'_overtex1.png'
        TexOv2 = Tex+'_overtex2.png'
        TexLineM = Tex+'_LineMask.png'
        TexColorM = Tex+'_ColorMask.png'
        TexHairG = Tex+'_HairGloss.png'
        TexBump = Tex+'_BumpMap.png'
        TexDNM = Tex+'_DetailNormalMap.png'
        TexBNM = Tex+'_BlendNormalMap.png'
        TexSGM = Tex+'_SpecGlossMap.png'
        TexOM = Tex+'_OcclusionMap.png'
        TexTSS = Tex+'_Thickness.png'
        TexMGM = Tex+'_MetallicGlossMap.png'
        TexOV = Tex+'_OverTex.png'
        #hs2
        TexBump2 = Tex+'_BumpMap2.png'
        TexDMT = Tex+'_DetailMainTex.png'
        TexDGM = Tex+'_DetailGlossMap.png'
        TexDGM2 = Tex+'_DetailGlossMap2.png'
        TexNailM = Tex+'_NailMask.png'
        TexWetMK = Tex+'_WeatheringMask.png'
        TexWetMP = Tex+'_WeatheringMap.png'
        TexOC = Tex+'_Occlusion.png'
        originaltex = 'mat_body_preset_'
        #originaltss = 'cf_m_body_01_'
        #kkp
        nm = originaltex+'NormalMap.png'
        nd = originaltex+'NormalMapDetail.png'
        dm = originaltex+'DetailMask.png'
        mm = originaltex+'MainTex.png'
        t3 = originaltex+'Texture3.png'
        t2 = originaltex+'Texture2.png'
        am = originaltex+'AlphaMask.png'
        lm = originaltex+'liquidmask.png'
        ar = originaltex+'AnotherRamp.png'
        ov1 = originaltex+'overtex1.png'
        ov2 = originaltex+'overtex2.png'
        lnm = originaltex+'LineMask.png'
        com = originaltex+'ColorMask.png'
        glo = originaltex+'HairGloss.png'
        #hs1
        bum = originaltex+'BumpMap.png'
        dnm = originaltex+'DetailNormalMap.png'
        bnm = originaltex+'BlendNormalMap.png'
        sgm = originaltex+'SpecGlossMap.png'
        om = originaltex+'OcclusionMap.png'
        tss = originaltex+'Thickness.png'
        mgm = originaltex+'MetallicGlossMap.png'
        ov = originaltex+'OverTex.png'
        #hs2
        bum2 = originaltex+'BumpMap2.png'
        dmt = originaltex+'DetailMainTex.png'
        dgm = originaltex+'DetailGlossMap.png'
        dgm2 = originaltex+'DetailGlossMap2.png'
        nail = originaltex+'NailMask.png'
        wetmk = originaltex+'WeatheringMask.png'
        wetmp = originaltex+'WeatheringMap.png'
        oc = originaltex+'Occlusion.png'
        Template='HS2-Template Body'
        CTemplate=Template+' '
        C = bpy.context

        def instantiate_group(nodes, data_block_name):
            group = nodes.new(type='ShaderNodeGroup')
            group.node_tree = bpy.data.node_groups[Template]
            return group
        if Template in bpy.data.node_groups:
            instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
        else:
        #    versions = ( t0, t1, t2, t3, t4)
        #    for x in versions:
        #        if os.path.isdir(x) and os.access(x, os.R_OK):
            if (3, 0, 0) <= bpy.app.version < (3, 0, 99):
                before_data = list(bpy.data.node_groups)
                bpy.ops.wm.append(directory=os.path.expanduser(r"~\AppData\Roaming\Blender Foundation\Blender\3.0\scripts\addons\sklx_creator\assets\HS2_Template_Shader.blend") + r'\NodeTree',filename=Template,link=False)
                new_data=list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
                appended_2B5AC = None if not new_data else new_data[0]
                instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
            else:
                if (3, 1, 0) <= bpy.app.version < (3, 1, 99):
                    before_data = list(bpy.data.node_groups)
                    bpy.ops.wm.append(directory=os.path.expanduser(r"~\AppData\Roaming\Blender Foundation\Blender\3.1\scripts\addons\sklx_creator\assets\HS2_Template_Shader.blend") + r'\NodeTree',filename=Template,link=False)
                    new_data=list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
                    appended_2B5AC = None if not new_data else new_data[0]
                    instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
                else:
                    if (3, 2, 0) <= bpy.app.version < (3, 2, 99):
                        before_data = list(bpy.data.node_groups)
                        bpy.ops.wm.append(directory=os.path.expanduser(r"~\AppData\Roaming\Blender Foundation\Blender\3.2\scripts\addons\sklx_creator\assets\HS2_Template_Shader.blend") + r'\NodeTree',filename=Template,link=False)
                        new_data=list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
                        appended_2B5AC = None if not new_data else new_data[0]
                        instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
                    else:
                        if (3, 3, 0) <= bpy.app.version < (3, 3, 99):
                            before_data = list(bpy.data.node_groups)
                            bpy.ops.wm.append(directory=os.path.expanduser(r"~\AppData\Roaming\Blender Foundation\Blender\3.3\scripts\addons\sklx_creator\assets\HS2_Template_Shader.blend") + r'\NodeTree',filename=Template,link=False)
                            new_data=list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
                            appended_2B5AC = None if not new_data else new_data[0]
                            instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
                        else:
                            if (3, 4, 0) <= bpy.app.version < (3, 4, 99):
                                before_data = list(bpy.data.node_groups)
                                bpy.ops.wm.append(directory=os.path.expanduser(r"~\AppData\Roaming\Blender Foundation\Blender\3.4\scripts\addons\sklx_creator\assets\HS2_Template_Shader.blend") + r'\NodeTree',filename=Template,link=False)
                                new_data=list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
                                appended_2B5AC = None if not new_data else new_data[0]
                                instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
        bpy.data.node_groups[Template].name = CTemplate+Tex
        node = bpy.data.node_groups[CTemplate+Tex]
        #initial_area_type = bpy.context.area.type
        #bpy.context.area.type = 'NODE_EDITOR'
        #bpy.context.area.ui_type = 'ShaderNodeTree'
        #bpy.ops.node.group_ungroup()
        #bpy.context.area.type = initial_area_type
        nodes = my_mat.node_tree.nodes
        for node in nodes:
            #node.select = False
            print(node.name)
            node.select = True
            nodes.active = node
        try:
            initial_area_type = bpy.context.area.type
            bpy.context.area.type = 'NODE_EDITOR'
            bpy.context.area.ui_type = 'ShaderNodeTree'
            bpy.ops.wm.redraw_timer(type='DRAW_WIN', iterations=1)
            bpy.ops.node.group_ungroup()
            nonono = node," to Ungroup"
            print(nonono)
            bpy.ops.node.group_edit(exit=True)
        except Exception as e:
            print(e)
        finally:
            bpy.context.area.type = initial_area_type
        fixlocate = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\\20220603141428_Chika_Haruno\\Textures\\"
        bpimg = bpy.data.images.get
        if 1==1:
            print(mm)
            print(dm)
            print(nm)
            print(t2)
            print(t3)
        #formula_list=(nm,nd,dm,mm,t2,t3,am,lm,ar,ov1,ov2,lnm,com,glo,bum,dnm,bnm,sgm,om,tss,mgm,ov)
        #for formula in formula_list:
        #    if bpimg(formula) is not None:
        f1 = bpimg(mm)
        #for x in f1:
        if f1 is not None:
            bpy.data.images[mm].name = TexMain
            bpy.data.images[TexMain].filepath = fixlocate+TexMain
            bpy.data.images[TexMain].filepath_raw = fixlocate+TexMain
        f2 = bpimg(dm)
        #for x in f2:
        if f2 is not None:
            bpy.data.images[dm].name = TexDetailM
            bpy.data.images[TexDetailM].filepath = fixlocate+TexDetailM
            bpy.data.images[TexDetailM].filepath_raw = fixlocate+TexDetailM
        f3 = bpimg(nm)
        #for x in f3:
        if f3 is not None:
            bpy.data.images[nm].name = TexNormal
            bpy.data.images[TexNormal].filepath = fixlocate+TexNormal
            bpy.data.images[TexNormal].filepath_raw = fixlocate+TexNormal
        f4 = bpimg(t2)
        #for x in f3:
        if f4 is not None:
            bpy.data.images[t2].name = TexTex2
            bpy.data.images[TexTex2].filepath = fixlocate+TexTex2
            bpy.data.images[TexTex2].filepath_raw = fixlocate+TexTex2
        f5 = bpimg(t3)
        #for x in f4:
        if f5 is not None:
            bpy.data.images[t3].name = TexTex3
            bpy.data.images[TexTex3].filepath = fixlocate+TexTex3
            bpy.data.images[TexTex3].filepath_raw = fixlocate+TexTex3
        f6 = bpimg(am)
        #for x in f5:
        if f6 is not None:
            bpy.data.images[am].name = TexAlphaM
            bpy.data.images[TexAlphaM].filepath = fixlocate+TexAlphaM
            bpy.data.images[TexAlphaM].filepath_raw = fixlocate+TexAlphaM
        f7 = bpimg(lm)
        #for x in f6:
        if f7 is not None:
            bpy.data.images[lm].name = TexLiquidM
            bpy.data.images[TexLiquidM].filepath = fixlocate+TexLiquidM
            bpy.data.images[TexLiquidM].filepath_raw = fixlocate+TexLiquidM
        f8 = bpimg(ar)
        #for f8 in f8:
        if f8 is not None:
            bpy.data.images[ar].name = TexAnotherR
            bpy.data.images[TexAnotherR].filepath = fixlocate+TexAnotherR
            bpy.data.images[TexAnotherR].filepath_raw = fixlocate+TexAnotherR
        f9 = bpimg(nd)
        #for f8 in f8:
        if f9 is not None:
            bpy.data.images[nd].name = TexNDetail
            bpy.data.images[TexNDetail].filepath = fixlocate+TexNDetail
            bpy.data.images[TexNDetail].filepath_raw = fixlocate+TexNDetail
        f10 = bpimg(ov1)
        #for f8 in f8:
        if f10 is not None:
            bpy.data.images[ov1].name = TexOv1
            bpy.data.images[TexOv1].filepath = fixlocate+TexOv1
            bpy.data.images[TexOv1].filepath_raw = fixlocate+TexOv1
        f11 = bpimg(ov2)
        #for f8 in f8:
        if f11 is not None:
            bpy.data.images[ov2].name = TexOv2
            bpy.data.images[TexOv2].filepath = fixlocate+TexOv2
            bpy.data.images[TexOv2].filepath_raw = fixlocate+TexOv2
        f12 = bpimg(lnm)
        #for f8 in f8:
        if f12 is not None:
            bpy.data.images[lnm].name = TexLineM
            bpy.data.images[TexLineM].filepath = fixlocate+TexLineM
            bpy.data.images[TexLineM].filepath_raw = fixlocate+TexLineM
        f13 = bpimg(com)
        #for f8 in f8:
        if f13 is not None:
            bpy.data.images[com].name = TexColorM
            bpy.data.images[TexColorM].filepath = fixlocate+TexColorM
            bpy.data.images[TexColorM].filepath_raw = fixlocate+TexColorM
        f14 = bpimg(glo)
        #for f8 in f8:
        if f14 is not None:
            bpy.data.images[glo].name = TexHairG
            bpy.data.images[TexHairG].filepath = fixlocate+TexHairG
            bpy.data.images[TexHairG].filepath_raw = fixlocate+TexHairG
        f15 = bpimg(bum)
        #for f8 in f8:
        if f15 is not None:
            bpy.data.images[bum].name = TexBump
            bpy.data.images[TexBump].filepath = fixlocate+TexBump
            bpy.data.images[TexBump].filepath_raw = fixlocate+TexBump
        f16 = bpimg(dnm)
        #for f8 in f8:
        if f16 is not None:
            bpy.data.images[dnm].name = TexDNM
            bpy.data.images[TexDNM].filepath = fixlocate+TexDNM
            bpy.data.images[TexDNM].filepath_raw = fixlocate+TexDNM
        f17 = bpimg(bnm)
        #for f8 in f8:
        if f17 is not None:
            bpy.data.images[bnm].name = TexBNM
            bpy.data.images[TexBNM].filepath = fixlocate+TexBNM
            bpy.data.images[TexBNM].filepath_raw = fixlocate+TexBNM
        f18 = bpimg(sgm)
        #for f8 in f8:
        if f18 is not None:
            bpy.data.images[sgm].name = TexSGM
            bpy.data.images[TexSGM].filepath = fixlocate+TexSGM
            bpy.data.images[TexSGM].filepath_raw = fixlocate+TexSGM
        f19 = bpimg(om)
        #for f8 in f8:
        if f19 is not None:
            bpy.data.images[om].name = TexOM
            bpy.data.images[TexOM].filepath = fixlocate+TexOM
            bpy.data.images[TexOM].filepath_raw = fixlocate+TexOM
        f20 = bpimg(tss)
        #for f8 in f8:
        if f20 is not None:
            bpy.data.images[tss].name = TexTSS
            bpy.data.images[TexTSS].filepath = fixlocate+TexTSS
            bpy.data.images[TexTSS].filepath_raw = fixlocate+TexTSS
        f21 = bpimg(mgm)
        #for f8 in f8:
        if f21 is not None:
            bpy.data.images[mgm].name = TexMGM
            bpy.data.images[TexMGM].filepath = fixlocate+TexMGM
            bpy.data.images[TexMGM].filepath_raw = fixlocate+TexMGM
        f22 = bpimg(ov)
        #for f8 in f8:
        if f22 is not None:
            bpy.data.images[ov].name = TexOV
            bpy.data.images[TexOV].filepath = fixlocate+TexOV
            bpy.data.images[TexOV].filepath_raw = fixlocate+TexOV
        f23 = bpimg(bum2)
        #for f8 in f8:
        if f23 is not None:
            bpy.data.images[bum2].name = TexBump2
            bpy.data.images[TexBump2].filepath = fixlocate+TexBump2
            bpy.data.images[TexBump2].filepath_raw = fixlocate+TexBump2
        f24 = bpimg(dmt)
        if f24 is not None:
            bpy.data.images[dmt].name = TexDMT
            bpy.data.images[TexDMT].filepath = fixlocate+TexDMT
            bpy.data.images[TexDMT].filepath_raw = fixlocate+TexDMT
        f25 = bpimg(dgm)
        if f25 is not None:
            bpy.data.images[dgm].name = TexDGM
            bpy.data.images[TexDGM].filepath = fixlocate+TexDGM
            bpy.data.images[TexDGM].filepath_raw = fixlocate+TexDGM
        f26 = bpimg(dgm2)
        if f26 is not None:
            bpy.data.images[dgm2].name = TexDGM2
            bpy.data.images[TexDGM2].filepath = fixlocate+TexDGM2
            bpy.data.images[TexDGM2].filepath_raw = fixlocate+TexDGM2
        f27 = bpimg(nail)
        if f27 is not None:
            bpy.data.images[nail].name = TexNailM
            bpy.data.images[TexNailM].filepath = fixlocate+TexNailM
            bpy.data.images[TexNailM].filepath_raw = fixlocate+TexNailM
        f28 = bpimg(wetmk)
        if f28 is not None:
            bpy.data.images[wetmk].name = TexWetMK
            bpy.data.images[TexWetMK].filepath = fixlocate+TexWetMK
            bpy.data.images[TexWetMK].filepath_raw = fixlocate+TexWetMK
        f29 = bpimg(wetmp)
        if f29 is not None:
            bpy.data.images[wetmp].name = TexWetMP
            bpy.data.images[TexWetMP].filepath = fixlocate+TexWetMP
            bpy.data.images[TexWetMP].filepath_raw = fixlocate+TexWetMP
        f30 = bpimg(oc)
        if f30 is not None:
            bpy.data.images[oc].name = TexOC
            bpy.data.images[TexOC].filepath = fixlocate+TexOC
            bpy.data.images[TexOC].filepath_raw = fixlocate+TexOC
        bpy.ops.file.find_missing_files('INVOKE_DEFAULT')
        return {"FINISHED"}

    def invoke(self, context, event):
        return self.execute(context)


class SNA_OT_Hs2Hairmanual_C5C88(bpy.types.Operator):
    bl_idname = "sna.hs2hairmanual_c5c88"
    bl_label = "hs2-hair-manual"
    bl_description = ""
    bl_options = {"REGISTER", "UNDO"}

    @classmethod
    def poll(cls, context):
        return not False

    def execute(self, context):
        import os
        ########################################################################
        my_mat = bpy.context.object.material_slots[0].material
        print(my_mat.name)
        Tex=my_mat.name
        rem_mat = bpy.data.materials[Tex]
        #Get the node in its node tree (replace the name below)
        node_to_delete =  rem_mat.node_tree.nodes['Principled BSDF']
        node_to_delete2 =  rem_mat.node_tree.nodes['Material Output']
        #Remove it
        rem_mat.node_tree.nodes.remove(node_to_delete)
        rem_mat.node_tree.nodes.remove(node_to_delete2)
        #Tex = material.name
        TexMain = Tex+'_MainTex.png'
        TexDetailM = Tex+'_DetailMask.png'
        TexNormal = Tex+'_NormalMap.png'
        TexNDetail = Tex+'_NormalMapDetail.png'
        TexAlphaM = Tex+'_AlphaMask.png'
        TexAnotherR = Tex+'_AnotherRamp.png'
        TexLiquidM = Tex+'_liquidmask.png'
        TexTex2 = Tex+'_Texture2.png'
        TexTex3 = Tex+'_Texture3.png'
        TexOv1 = Tex+'_overtex1.png'
        TexOv2 = Tex+'_overtex2.png'
        TexLineM = Tex+'_LineMask.png'
        TexColorM = Tex+'_ColorMask.png'
        TexHairG = Tex+'_HairGloss.png'
        TexBump = Tex+'_BumpMap.png'
        TexDNM = Tex+'_DetailNormalMap.png'
        TexBNM = Tex+'_BlendNormalMap.png'
        TexSGM = Tex+'_SpecGlossMap.png'
        TexOM = Tex+'_OcclusionMap.png'
        TexTSS = Tex+'_Thickness.png'
        TexMGM = Tex+'_MetallicGlossMap.png'
        TexOV = Tex+'_OverTex.png'
        #hs2
        TexBump2 = Tex+'_BumpMap2.png'
        TexDMT = Tex+'_DetailMainTex.png'
        TexDGM = Tex+'_DetailGlossMap.png'
        TexDGM2 = Tex+'_DetailGlossMap2.png'
        TexNailM = Tex+'_NailMask.png'
        TexWetMK = Tex+'_WeatheringMask.png'
        TexWetMP = Tex+'_WeatheringMap.png'
        TexOC = Tex+'_Occlusion.png'
        originaltex = 'mat_hair_preset_'
        #originaltss = 'cf_m_body_01_'
        #kkp
        nm = originaltex+'NormalMap.png'
        nd = originaltex+'NormalMapDetail.png'
        dm = originaltex+'DetailMask.png'
        mm = originaltex+'MainTex.png'
        t3 = originaltex+'Texture3.png'
        t2 = originaltex+'Texture2.png'
        am = originaltex+'AlphaMask.png'
        lm = originaltex+'liquidmask.png'
        ar = originaltex+'AnotherRamp.png'
        ov1 = originaltex+'overtex1.png'
        ov2 = originaltex+'overtex2.png'
        lnm = originaltex+'LineMask.png'
        com = originaltex+'ColorMask.png'
        glo = originaltex+'HairGloss.png'
        #hs1
        bum = originaltex+'BumpMap.png'
        dnm = originaltex+'DetailNormalMap.png'
        bnm = originaltex+'BlendNormalMap.png'
        sgm = originaltex+'SpecGlossMap.png'
        om = originaltex+'OcclusionMap.png'
        tss = originaltex+'Thickness.png'
        mgm = originaltex+'MetallicGlossMap.png'
        ov = originaltex+'OverTex.png'
        #hs2
        bum2 = originaltex+'BumpMap2.png'
        dmt = originaltex+'DetailMainTex.png'
        dgm = originaltex+'DetailGlossMap.png'
        dgm2 = originaltex+'DetailGlossMap2.png'
        nail = originaltex+'NailMask.png'
        wetmk = originaltex+'WeatheringMask.png'
        wetmp = originaltex+'WeatheringMap.png'
        oc = originaltex+'Occlusion.png'
        Template='HS2-Template Front Hair'
        CTemplate=Template+' '
        C = bpy.context

        def instantiate_group(nodes, data_block_name):
            group = nodes.new(type='ShaderNodeGroup')
            group.node_tree = bpy.data.node_groups[Template]
            return group
        if Template in bpy.data.node_groups:
            instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
            bpy.context.object.active_material.blend_method = 'HASHED'
            bpy.context.object.active_material.shadow_method = 'HASHED'
        else:
        #    versions = ( t0, t1, t2, t3, t4)
        #    for x in versions:
        #        if os.path.isdir(x) and os.access(x, os.R_OK):
            if (3, 0, 0) <= bpy.app.version < (3, 0, 99):
                before_data = list(bpy.data.node_groups)
                bpy.ops.wm.append(directory=os.path.expanduser(r"~\AppData\Roaming\Blender Foundation\Blender\3.0\scripts\addons\sklx_creator\assets\HS2_Template_Shader.blend") + r'\NodeTree',filename=Template,link=False)
                new_data=list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
                appended_2B5AC = None if not new_data else new_data[0]
                instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
                bpy.context.object.active_material.blend_method = 'HASHED'
                bpy.context.object.active_material.shadow_method = 'HASHED'
            else:
                if (3, 1, 0) <= bpy.app.version < (3, 1, 99):
                    before_data = list(bpy.data.node_groups)
                    bpy.ops.wm.append(directory=os.path.expanduser(r"~\AppData\Roaming\Blender Foundation\Blender\3.1\scripts\addons\sklx_creator\assets\HS2_Template_Shader.blend") + r'\NodeTree',filename=Template,link=False)
                    new_data=list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
                    appended_2B5AC = None if not new_data else new_data[0]
                    instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
                    bpy.context.object.active_material.blend_method = 'HASHED'
                    bpy.context.object.active_material.shadow_method = 'HASHED'
                else:
                    if (3, 2, 0) <= bpy.app.version < (3, 2, 99):
                        before_data = list(bpy.data.node_groups)
                        bpy.ops.wm.append(directory=os.path.expanduser(r"~\AppData\Roaming\Blender Foundation\Blender\3.2\scripts\addons\sklx_creator\assets\HS2_Template_Shader.blend") + r'\NodeTree',filename=Template,link=False)
                        new_data=list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
                        appended_2B5AC = None if not new_data else new_data[0]
                        instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
                        bpy.context.object.active_material.blend_method = 'HASHED'
                        bpy.context.object.active_material.shadow_method = 'HASHED'
                    else:
                        if (3, 3, 0) <= bpy.app.version < (3, 3, 99):
                            before_data = list(bpy.data.node_groups)
                            bpy.ops.wm.append(directory=os.path.expanduser(r"~\AppData\Roaming\Blender Foundation\Blender\3.3\scripts\addons\sklx_creator\assets\HS2_Template_Shader.blend") + r'\NodeTree',filename=Template,link=False)
                            new_data=list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
                            appended_2B5AC = None if not new_data else new_data[0]
                            instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
                            bpy.context.object.active_material.blend_method = 'HASHED'
                            bpy.context.object.active_material.shadow_method = 'HASHED'
                        else:
                            if (3, 4, 0) <= bpy.app.version < (3, 4, 99):
                                before_data = list(bpy.data.node_groups)
                                bpy.ops.wm.append(directory=os.path.expanduser(r"~\AppData\Roaming\Blender Foundation\Blender\3.4\scripts\addons\sklx_creator\assets\HS2_Template_Shader.blend") + r'\NodeTree',filename=Template,link=False)
                                new_data=list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
                                appended_2B5AC = None if not new_data else new_data[0]
                                instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
                                bpy.context.object.active_material.blend_method = 'HASHED'
                                bpy.context.object.active_material.shadow_method = 'HASHED'
        bpy.context.object.active_material.blend_method = 'HASHED'
        bpy.context.object.active_material.shadow_method = 'HASHED'
        bpy.data.node_groups[Template].name = CTemplate+Tex
        node = bpy.data.node_groups[CTemplate+Tex]
        #initial_area_type = bpy.context.area.type
        #bpy.context.area.type = 'NODE_EDITOR'
        #bpy.context.area.ui_type = 'ShaderNodeTree'
        #bpy.ops.node.group_ungroup()
        #bpy.context.area.type = initial_area_type
        nodes = my_mat.node_tree.nodes
        for node in nodes:
            #node.select = False
            print(node.name)
            node.select = True
            nodes.active = node
        try:
            initial_area_type = bpy.context.area.type
            bpy.context.area.type = 'NODE_EDITOR'
            bpy.context.area.ui_type = 'ShaderNodeTree'
            bpy.ops.wm.redraw_timer(type='DRAW_WIN', iterations=1)
            bpy.ops.node.group_ungroup()
            nonono = node," to Ungroup"
            print(nonono)
            bpy.ops.node.group_edit(exit=True)
        except Exception as e:
            print(e)
        finally:
            bpy.context.area.type = initial_area_type
        fixlocate = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\\20220603141428_Chika_Haruno\\Textures\\"
        bpimg = bpy.data.images.get
        if 1==1:
            print(mm)
            print(dm)
            print(nm)
            print(t2)
            print(t3)
        #formula_list=(nm,nd,dm,mm,t2,t3,am,lm,ar,ov1,ov2,lnm,com,glo,bum,dnm,bnm,sgm,om,tss,mgm,ov)
        #for formula in formula_list:
        #    if bpimg(formula) is not None:
        f1 = bpimg(mm)
        #for x in f1:
        if f1 is not None:
            bpy.data.images[mm].name = TexMain
            bpy.data.images[TexMain].filepath = fixlocate+TexMain
            bpy.data.images[TexMain].filepath_raw = fixlocate+TexMain
        f2 = bpimg(dm)
        #for x in f2:
        if f2 is not None:
            bpy.data.images[dm].name = TexDetailM
            bpy.data.images[TexDetailM].filepath = fixlocate+TexDetailM
            bpy.data.images[TexDetailM].filepath_raw = fixlocate+TexDetailM
        f3 = bpimg(nm)
        #for x in f3:
        if f3 is not None:
            bpy.data.images[nm].name = TexNormal
            bpy.data.images[TexNormal].filepath = fixlocate+TexNormal
            bpy.data.images[TexNormal].filepath_raw = fixlocate+TexNormal
        f4 = bpimg(t2)
        #for x in f3:
        if f4 is not None:
            bpy.data.images[t2].name = TexTex2
            bpy.data.images[TexTex2].filepath = fixlocate+TexTex2
            bpy.data.images[TexTex2].filepath_raw = fixlocate+TexTex2
        f5 = bpimg(t3)
        #for x in f4:
        if f5 is not None:
            bpy.data.images[t3].name = TexTex3
            bpy.data.images[TexTex3].filepath = fixlocate+TexTex3
            bpy.data.images[TexTex3].filepath_raw = fixlocate+TexTex3
        f6 = bpimg(am)
        #for x in f5:
        if f6 is not None:
            bpy.data.images[am].name = TexAlphaM
            bpy.data.images[TexAlphaM].filepath = fixlocate+TexAlphaM
            bpy.data.images[TexAlphaM].filepath_raw = fixlocate+TexAlphaM
        f7 = bpimg(lm)
        #for x in f6:
        if f7 is not None:
            bpy.data.images[lm].name = TexLiquidM
            bpy.data.images[TexLiquidM].filepath = fixlocate+TexLiquidM
            bpy.data.images[TexLiquidM].filepath_raw = fixlocate+TexLiquidM
        f8 = bpimg(ar)
        #for f8 in f8:
        if f8 is not None:
            bpy.data.images[ar].name = TexAnotherR
            bpy.data.images[TexAnotherR].filepath = fixlocate+TexAnotherR
            bpy.data.images[TexAnotherR].filepath_raw = fixlocate+TexAnotherR
        f9 = bpimg(nd)
        #for f8 in f8:
        if f9 is not None:
            bpy.data.images[nd].name = TexNDetail
            bpy.data.images[TexNDetail].filepath = fixlocate+TexNDetail
            bpy.data.images[TexNDetail].filepath_raw = fixlocate+TexNDetail
        f10 = bpimg(ov1)
        #for f8 in f8:
        if f10 is not None:
            bpy.data.images[ov1].name = TexOv1
            bpy.data.images[TexOv1].filepath = fixlocate+TexOv1
            bpy.data.images[TexOv1].filepath_raw = fixlocate+TexOv1
        f11 = bpimg(ov2)
        #for f8 in f8:
        if f11 is not None:
            bpy.data.images[ov2].name = TexOv2
            bpy.data.images[TexOv2].filepath = fixlocate+TexOv2
            bpy.data.images[TexOv2].filepath_raw = fixlocate+TexOv2
        f12 = bpimg(lnm)
        #for f8 in f8:
        if f12 is not None:
            bpy.data.images[lnm].name = TexLineM
            bpy.data.images[TexLineM].filepath = fixlocate+TexLineM
            bpy.data.images[TexLineM].filepath_raw = fixlocate+TexLineM
        f13 = bpimg(com)
        #for f8 in f8:
        if f13 is not None:
            bpy.data.images[com].name = TexColorM
            bpy.data.images[TexColorM].filepath = fixlocate+TexColorM
            bpy.data.images[TexColorM].filepath_raw = fixlocate+TexColorM
        f14 = bpimg(glo)
        #for f8 in f8:
        if f14 is not None:
            bpy.data.images[glo].name = TexHairG
            bpy.data.images[TexHairG].filepath = fixlocate+TexHairG
            bpy.data.images[TexHairG].filepath_raw = fixlocate+TexHairG
        f15 = bpimg(bum)
        #for f8 in f8:
        if f15 is not None:
            bpy.data.images[bum].name = TexBump
            bpy.data.images[TexBump].filepath = fixlocate+TexBump
            bpy.data.images[TexBump].filepath_raw = fixlocate+TexBump
        f16 = bpimg(dnm)
        #for f8 in f8:
        if f16 is not None:
            bpy.data.images[dnm].name = TexDNM
            bpy.data.images[TexDNM].filepath = fixlocate+TexDNM
            bpy.data.images[TexDNM].filepath_raw = fixlocate+TexDNM
        f17 = bpimg(bnm)
        #for f8 in f8:
        if f17 is not None:
            bpy.data.images[bnm].name = TexBNM
            bpy.data.images[TexBNM].filepath = fixlocate+TexBNM
            bpy.data.images[TexBNM].filepath_raw = fixlocate+TexBNM
        f18 = bpimg(sgm)
        #for f8 in f8:
        if f18 is not None:
            bpy.data.images[sgm].name = TexSGM
            bpy.data.images[TexSGM].filepath = fixlocate+TexSGM
            bpy.data.images[TexSGM].filepath_raw = fixlocate+TexSGM
        f19 = bpimg(om)
        #for f8 in f8:
        if f19 is not None:
            bpy.data.images[om].name = TexOM
            bpy.data.images[TexOM].filepath = fixlocate+TexOM
            bpy.data.images[TexOM].filepath_raw = fixlocate+TexOM
        f20 = bpimg(tss)
        #for f8 in f8:
        if f20 is not None:
            bpy.data.images[tss].name = TexTSS
            bpy.data.images[TexTSS].filepath = fixlocate+TexTSS
            bpy.data.images[TexTSS].filepath_raw = fixlocate+TexTSS
        f21 = bpimg(mgm)
        #for f8 in f8:
        if f21 is not None:
            bpy.data.images[mgm].name = TexMGM
            bpy.data.images[TexMGM].filepath = fixlocate+TexMGM
            bpy.data.images[TexMGM].filepath_raw = fixlocate+TexMGM
        f22 = bpimg(ov)
        #for f8 in f8:
        if f22 is not None:
            bpy.data.images[ov].name = TexOV
            bpy.data.images[TexOV].filepath = fixlocate+TexOV
            bpy.data.images[TexOV].filepath_raw = fixlocate+TexOV
        f23 = bpimg(bum2)
        #for f8 in f8:
        if f23 is not None:
            bpy.data.images[bum2].name = TexBump2
            bpy.data.images[TexBump2].filepath = fixlocate+TexBump2
            bpy.data.images[TexBump2].filepath_raw = fixlocate+TexBump2
        f24 = bpimg(dmt)
        if f24 is not None:
            bpy.data.images[dmt].name = TexDMT
            bpy.data.images[TexDMT].filepath = fixlocate+TexDMT
            bpy.data.images[TexDMT].filepath_raw = fixlocate+TexDMT
        f25 = bpimg(dgm)
        if f25 is not None:
            bpy.data.images[dgm].name = TexDGM
            bpy.data.images[TexDGM].filepath = fixlocate+TexDGM
            bpy.data.images[TexDGM].filepath_raw = fixlocate+TexDGM
        f26 = bpimg(dgm2)
        if f26 is not None:
            bpy.data.images[dgm2].name = TexDGM2
            bpy.data.images[TexDGM2].filepath = fixlocate+TexDGM2
            bpy.data.images[TexDGM2].filepath_raw = fixlocate+TexDGM2
        f27 = bpimg(nail)
        if f27 is not None:
            bpy.data.images[nail].name = TexNailM
            bpy.data.images[TexNailM].filepath = fixlocate+TexNailM
            bpy.data.images[TexNailM].filepath_raw = fixlocate+TexNailM
        f28 = bpimg(wetmk)
        if f28 is not None:
            bpy.data.images[wetmk].name = TexWetMK
            bpy.data.images[TexWetMK].filepath = fixlocate+TexWetMK
            bpy.data.images[TexWetMK].filepath_raw = fixlocate+TexWetMK
        f29 = bpimg(wetmp)
        if f29 is not None:
            bpy.data.images[wetmp].name = TexWetMP
            bpy.data.images[TexWetMP].filepath = fixlocate+TexWetMP
            bpy.data.images[TexWetMP].filepath_raw = fixlocate+TexWetMP
        f30 = bpimg(oc)
        if f30 is not None:
            bpy.data.images[oc].name = TexOC
            bpy.data.images[TexOC].filepath = fixlocate+TexOC
            bpy.data.images[TexOC].filepath_raw = fixlocate+TexOC
        bpy.ops.file.find_missing_files('INVOKE_DEFAULT')
        return {"FINISHED"}

    def invoke(self, context, event):
        return self.execute(context)


class SNA_OT_Hs2Topmanual_E0F0E(bpy.types.Operator):
    bl_idname = "sna.hs2topmanual_e0f0e"
    bl_label = "hs2-top-manual"
    bl_description = ""
    bl_options = {"REGISTER", "UNDO"}

    @classmethod
    def poll(cls, context):
        return not False

    def execute(self, context):
        import os
        ########################################################################
        my_mat = bpy.context.object.material_slots[0].material
        print(my_mat.name)
        Tex=my_mat.name
        rem_mat = bpy.data.materials[Tex]
        #Get the node in its node tree (replace the name below)
        node_to_delete =  rem_mat.node_tree.nodes['Principled BSDF']
        node_to_delete2 =  rem_mat.node_tree.nodes['Material Output']
        #Remove it
        rem_mat.node_tree.nodes.remove(node_to_delete)
        rem_mat.node_tree.nodes.remove(node_to_delete2)
        #Tex = material.name
        TexMain = Tex+'_MainTex.png'
        TexDetailM = Tex+'_DetailMask.png'
        TexNormal = Tex+'_NormalMap.png'
        TexNDetail = Tex+'_NormalMapDetail.png'
        TexAlphaM = Tex+'_AlphaMask.png'
        TexAnotherR = Tex+'_AnotherRamp.png'
        TexLiquidM = Tex+'_liquidmask.png'
        TexTex2 = Tex+'_Texture2.png'
        TexTex3 = Tex+'_Texture3.png'
        TexOv1 = Tex+'_overtex1.png'
        TexOv2 = Tex+'_overtex2.png'
        TexLineM = Tex+'_LineMask.png'
        TexColorM = Tex+'_ColorMask.png'
        TexHairG = Tex+'_HairGloss.png'
        TexBump = Tex+'_BumpMap.png'
        TexDNM = Tex+'_DetailNormalMap.png'
        TexBNM = Tex+'_BlendNormalMap.png'
        TexSGM = Tex+'_SpecGlossMap.png'
        TexOM = Tex+'_OcclusionMap.png'
        TexTSS = Tex+'_Thickness.png'
        TexMGM = Tex+'_MetallicGlossMap.png'
        TexOV = Tex+'_OverTex.png'
        #hs2
        TexBump2 = Tex+'_BumpMap2.png'
        TexDMT = Tex+'_DetailMainTex.png'
        TexDGM = Tex+'_DetailGlossMap.png'
        TexDGM2 = Tex+'_DetailGlossMap2.png'
        TexNailM = Tex+'_NailMask.png'
        TexWetMK = Tex+'_WeatheringMask.png'
        TexWetMP = Tex+'_WeatheringMap.png'
        TexOC = Tex+'_Occlusion.png'
        originaltex = 'mat_top_preset_'
        #originaltss = 'cf_m_body_01_'
        #kkp
        nm = originaltex+'NormalMap.png'
        nd = originaltex+'NormalMapDetail.png'
        dm = originaltex+'DetailMask.png'
        mm = originaltex+'MainTex.png'
        t3 = originaltex+'Texture3.png'
        t2 = originaltex+'Texture2.png'
        am = originaltex+'AlphaMask.png'
        lm = originaltex+'liquidmask.png'
        ar = originaltex+'AnotherRamp.png'
        ov1 = originaltex+'overtex1.png'
        ov2 = originaltex+'overtex2.png'
        lnm = originaltex+'LineMask.png'
        com = originaltex+'ColorMask.png'
        glo = originaltex+'HairGloss.png'
        #hs1
        bum = originaltex+'BumpMap.png'
        dnm = originaltex+'DetailNormalMap.png'
        bnm = originaltex+'BlendNormalMap.png'
        sgm = originaltex+'SpecGlossMap.png'
        om = originaltex+'OcclusionMap.png'
        tss = originaltex+'Thickness.png'
        mgm = originaltex+'MetallicGlossMap.png'
        ov = originaltex+'OverTex.png'
        #hs2
        bum2 = originaltex+'BumpMap2.png'
        dmt = originaltex+'DetailMainTex.png'
        dgm = originaltex+'DetailGlossMap.png'
        dgm2 = originaltex+'DetailGlossMap2.png'
        nail = originaltex+'NailMask.png'
        wetmk = originaltex+'WeatheringMask.png'
        wetmp = originaltex+'WeatheringMap.png'
        oc = originaltex+'Occlusion.png'
        Template='HS2-Template Top'
        CTemplate=Template+' '
        C = bpy.context

        def instantiate_group(nodes, data_block_name):
            group = nodes.new(type='ShaderNodeGroup')
            group.node_tree = bpy.data.node_groups[Template]
            return group
        if Template in bpy.data.node_groups:
            instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
            bpy.context.object.active_material.blend_method = 'HASHED'
            bpy.context.object.active_material.shadow_method = 'HASHED'
        else:
        #    versions = ( t0, t1, t2, t3, t4)
        #    for x in versions:
        #        if os.path.isdir(x) and os.access(x, os.R_OK):
            if (3, 0, 0) <= bpy.app.version < (3, 0, 99):
                before_data = list(bpy.data.node_groups)
                bpy.ops.wm.append(directory=os.path.expanduser(r"~\AppData\Roaming\Blender Foundation\Blender\3.0\scripts\addons\sklx_creator\assets\HS2_Template_Shader.blend") + r'\NodeTree',filename=Template,link=False)
                new_data=list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
                appended_2B5AC = None if not new_data else new_data[0]
                instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
                bpy.context.object.active_material.blend_method = 'HASHED'
                bpy.context.object.active_material.shadow_method = 'HASHED'
            else:
                if (3, 1, 0) <= bpy.app.version < (3, 1, 99):
                    before_data = list(bpy.data.node_groups)
                    bpy.ops.wm.append(directory=os.path.expanduser(r"~\AppData\Roaming\Blender Foundation\Blender\3.1\scripts\addons\sklx_creator\assets\HS2_Template_Shader.blend") + r'\NodeTree',filename=Template,link=False)
                    new_data=list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
                    appended_2B5AC = None if not new_data else new_data[0]
                    instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
                    bpy.context.object.active_material.blend_method = 'HASHED'
                    bpy.context.object.active_material.shadow_method = 'HASHED'
                else:
                    if (3, 2, 0) <= bpy.app.version < (3, 2, 99):
                        before_data = list(bpy.data.node_groups)
                        bpy.ops.wm.append(directory=os.path.expanduser(r"~\AppData\Roaming\Blender Foundation\Blender\3.2\scripts\addons\sklx_creator\assets\HS2_Template_Shader.blend") + r'\NodeTree',filename=Template,link=False)
                        new_data=list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
                        appended_2B5AC = None if not new_data else new_data[0]
                        instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
                        bpy.context.object.active_material.blend_method = 'HASHED'
                        bpy.context.object.active_material.shadow_method = 'HASHED'
                    else:
                        if (3, 3, 0) <= bpy.app.version < (3, 3, 99):
                            before_data = list(bpy.data.node_groups)
                            bpy.ops.wm.append(directory=os.path.expanduser(r"~\AppData\Roaming\Blender Foundation\Blender\3.3\scripts\addons\sklx_creator\assets\HS2_Template_Shader.blend") + r'\NodeTree',filename=Template,link=False)
                            new_data=list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
                            appended_2B5AC = None if not new_data else new_data[0]
                            instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
                            bpy.context.object.active_material.blend_method = 'HASHED'
                            bpy.context.object.active_material.shadow_method = 'HASHED'
                        else:
                            if (3, 4, 0) <= bpy.app.version < (3, 4, 99):
                                before_data = list(bpy.data.node_groups)
                                bpy.ops.wm.append(directory=os.path.expanduser(r"~\AppData\Roaming\Blender Foundation\Blender\3.4\scripts\addons\sklx_creator\assets\HS2_Template_Shader.blend") + r'\NodeTree',filename=Template,link=False)
                                new_data=list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
                                appended_2B5AC = None if not new_data else new_data[0]
                                instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
                                bpy.context.object.active_material.blend_method = 'HASHED'
                                bpy.context.object.active_material.shadow_method = 'HASHED'
        bpy.data.node_groups[Template].name = CTemplate+Tex
        node = bpy.data.node_groups[CTemplate+Tex]
        #initial_area_type = bpy.context.area.type
        #bpy.context.area.type = 'NODE_EDITOR'
        #bpy.context.area.ui_type = 'ShaderNodeTree'
        #bpy.ops.node.group_ungroup()
        #bpy.context.area.type = initial_area_type
        nodes = my_mat.node_tree.nodes
        for node in nodes:
            #node.select = False
            print(node.name)
            node.select = True
            nodes.active = node
        try:
            initial_area_type = bpy.context.area.type
            bpy.context.area.type = 'NODE_EDITOR'
            bpy.context.area.ui_type = 'ShaderNodeTree'
            bpy.ops.wm.redraw_timer(type='DRAW_WIN', iterations=1)
            bpy.ops.node.group_ungroup()
            nonono = node," to Ungroup"
            print(nonono)
            bpy.ops.node.group_edit(exit=True)
        except Exception as e:
            print(e)
        finally:
            bpy.context.area.type = initial_area_type
        fixlocate = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\\20220603141428_Chika_Haruno\\Textures\\"
        bpimg = bpy.data.images.get
        if 1==1:
            print(mm)
            print(dm)
            print(nm)
            print(t2)
            print(t3)
        #formula_list=(nm,nd,dm,mm,t2,t3,am,lm,ar,ov1,ov2,lnm,com,glo,bum,dnm,bnm,sgm,om,tss,mgm,ov)
        #for formula in formula_list:
        #    if bpimg(formula) is not None:
        f1 = bpimg(mm)
        #for x in f1:
        if f1 is not None:
            bpy.data.images[mm].name = TexMain
            bpy.data.images[TexMain].filepath = fixlocate+TexMain
            bpy.data.images[TexMain].filepath_raw = fixlocate+TexMain
        f2 = bpimg(dm)
        #for x in f2:
        if f2 is not None:
            bpy.data.images[dm].name = TexDetailM
            bpy.data.images[TexDetailM].filepath = fixlocate+TexDetailM
            bpy.data.images[TexDetailM].filepath_raw = fixlocate+TexDetailM
        f3 = bpimg(nm)
        #for x in f3:
        if f3 is not None:
            bpy.data.images[nm].name = TexNormal
            bpy.data.images[TexNormal].filepath = fixlocate+TexNormal
            bpy.data.images[TexNormal].filepath_raw = fixlocate+TexNormal
        f4 = bpimg(t2)
        #for x in f3:
        if f4 is not None:
            bpy.data.images[t2].name = TexTex2
            bpy.data.images[TexTex2].filepath = fixlocate+TexTex2
            bpy.data.images[TexTex2].filepath_raw = fixlocate+TexTex2
        f5 = bpimg(t3)
        #for x in f4:
        if f5 is not None:
            bpy.data.images[t3].name = TexTex3
            bpy.data.images[TexTex3].filepath = fixlocate+TexTex3
            bpy.data.images[TexTex3].filepath_raw = fixlocate+TexTex3
        f6 = bpimg(am)
        #for x in f5:
        if f6 is not None:
            bpy.data.images[am].name = TexAlphaM
            bpy.data.images[TexAlphaM].filepath = fixlocate+TexAlphaM
            bpy.data.images[TexAlphaM].filepath_raw = fixlocate+TexAlphaM
        f7 = bpimg(lm)
        #for x in f6:
        if f7 is not None:
            bpy.data.images[lm].name = TexLiquidM
            bpy.data.images[TexLiquidM].filepath = fixlocate+TexLiquidM
            bpy.data.images[TexLiquidM].filepath_raw = fixlocate+TexLiquidM
        f8 = bpimg(ar)
        #for f8 in f8:
        if f8 is not None:
            bpy.data.images[ar].name = TexAnotherR
            bpy.data.images[TexAnotherR].filepath = fixlocate+TexAnotherR
            bpy.data.images[TexAnotherR].filepath_raw = fixlocate+TexAnotherR
        f9 = bpimg(nd)
        #for f8 in f8:
        if f9 is not None:
            bpy.data.images[nd].name = TexNDetail
            bpy.data.images[TexNDetail].filepath = fixlocate+TexNDetail
            bpy.data.images[TexNDetail].filepath_raw = fixlocate+TexNDetail
        f10 = bpimg(ov1)
        #for f8 in f8:
        if f10 is not None:
            bpy.data.images[ov1].name = TexOv1
            bpy.data.images[TexOv1].filepath = fixlocate+TexOv1
            bpy.data.images[TexOv1].filepath_raw = fixlocate+TexOv1
        f11 = bpimg(ov2)
        #for f8 in f8:
        if f11 is not None:
            bpy.data.images[ov2].name = TexOv2
            bpy.data.images[TexOv2].filepath = fixlocate+TexOv2
            bpy.data.images[TexOv2].filepath_raw = fixlocate+TexOv2
        f12 = bpimg(lnm)
        #for f8 in f8:
        if f12 is not None:
            bpy.data.images[lnm].name = TexLineM
            bpy.data.images[TexLineM].filepath = fixlocate+TexLineM
            bpy.data.images[TexLineM].filepath_raw = fixlocate+TexLineM
        f13 = bpimg(com)
        #for f8 in f8:
        if f13 is not None:
            bpy.data.images[com].name = TexColorM
            bpy.data.images[TexColorM].filepath = fixlocate+TexColorM
            bpy.data.images[TexColorM].filepath_raw = fixlocate+TexColorM
        f14 = bpimg(glo)
        #for f8 in f8:
        if f14 is not None:
            bpy.data.images[glo].name = TexHairG
            bpy.data.images[TexHairG].filepath = fixlocate+TexHairG
            bpy.data.images[TexHairG].filepath_raw = fixlocate+TexHairG
        f15 = bpimg(bum)
        #for f8 in f8:
        if f15 is not None:
            bpy.data.images[bum].name = TexBump
            bpy.data.images[TexBump].filepath = fixlocate+TexBump
            bpy.data.images[TexBump].filepath_raw = fixlocate+TexBump
        f16 = bpimg(dnm)
        #for f8 in f8:
        if f16 is not None:
            bpy.data.images[dnm].name = TexDNM
            bpy.data.images[TexDNM].filepath = fixlocate+TexDNM
            bpy.data.images[TexDNM].filepath_raw = fixlocate+TexDNM
        f17 = bpimg(bnm)
        #for f8 in f8:
        if f17 is not None:
            bpy.data.images[bnm].name = TexBNM
            bpy.data.images[TexBNM].filepath = fixlocate+TexBNM
            bpy.data.images[TexBNM].filepath_raw = fixlocate+TexBNM
        f18 = bpimg(sgm)
        #for f8 in f8:
        if f18 is not None:
            bpy.data.images[sgm].name = TexSGM
            bpy.data.images[TexSGM].filepath = fixlocate+TexSGM
            bpy.data.images[TexSGM].filepath_raw = fixlocate+TexSGM
        f19 = bpimg(om)
        #for f8 in f8:
        if f19 is not None:
            bpy.data.images[om].name = TexOM
            bpy.data.images[TexOM].filepath = fixlocate+TexOM
            bpy.data.images[TexOM].filepath_raw = fixlocate+TexOM
        f20 = bpimg(tss)
        #for f8 in f8:
        if f20 is not None:
            bpy.data.images[tss].name = TexTSS
            bpy.data.images[TexTSS].filepath = fixlocate+TexTSS
            bpy.data.images[TexTSS].filepath_raw = fixlocate+TexTSS
        f21 = bpimg(mgm)
        #for f8 in f8:
        if f21 is not None:
            bpy.data.images[mgm].name = TexMGM
            bpy.data.images[TexMGM].filepath = fixlocate+TexMGM
            bpy.data.images[TexMGM].filepath_raw = fixlocate+TexMGM
        f22 = bpimg(ov)
        #for f8 in f8:
        if f22 is not None:
            bpy.data.images[ov].name = TexOV
            bpy.data.images[TexOV].filepath = fixlocate+TexOV
            bpy.data.images[TexOV].filepath_raw = fixlocate+TexOV
        f23 = bpimg(bum2)
        #for f8 in f8:
        if f23 is not None:
            bpy.data.images[bum2].name = TexBump2
            bpy.data.images[TexBump2].filepath = fixlocate+TexBump2
            bpy.data.images[TexBump2].filepath_raw = fixlocate+TexBump2
        f24 = bpimg(dmt)
        if f24 is not None:
            bpy.data.images[dmt].name = TexDMT
            bpy.data.images[TexDMT].filepath = fixlocate+TexDMT
            bpy.data.images[TexDMT].filepath_raw = fixlocate+TexDMT
        f25 = bpimg(dgm)
        if f25 is not None:
            bpy.data.images[dgm].name = TexDGM
            bpy.data.images[TexDGM].filepath = fixlocate+TexDGM
            bpy.data.images[TexDGM].filepath_raw = fixlocate+TexDGM
        f26 = bpimg(dgm2)
        if f26 is not None:
            bpy.data.images[dgm2].name = TexDGM2
            bpy.data.images[TexDGM2].filepath = fixlocate+TexDGM2
            bpy.data.images[TexDGM2].filepath_raw = fixlocate+TexDGM2
        f27 = bpimg(nail)
        if f27 is not None:
            bpy.data.images[nail].name = TexNailM
            bpy.data.images[TexNailM].filepath = fixlocate+TexNailM
            bpy.data.images[TexNailM].filepath_raw = fixlocate+TexNailM
        f28 = bpimg(wetmk)
        if f28 is not None:
            bpy.data.images[wetmk].name = TexWetMK
            bpy.data.images[TexWetMK].filepath = fixlocate+TexWetMK
            bpy.data.images[TexWetMK].filepath_raw = fixlocate+TexWetMK
        f29 = bpimg(wetmp)
        if f29 is not None:
            bpy.data.images[wetmp].name = TexWetMP
            bpy.data.images[TexWetMP].filepath = fixlocate+TexWetMP
            bpy.data.images[TexWetMP].filepath_raw = fixlocate+TexWetMP
        f30 = bpimg(oc)
        if f30 is not None:
            bpy.data.images[oc].name = TexOC
            bpy.data.images[TexOC].filepath = fixlocate+TexOC
            bpy.data.images[TexOC].filepath_raw = fixlocate+TexOC
        bpy.ops.file.find_missing_files('INVOKE_DEFAULT')
        return {"FINISHED"}

    def invoke(self, context, event):
        return self.execute(context)


class SNA_OT_Hs2Botmanual_D9F93(bpy.types.Operator):
    bl_idname = "sna.hs2botmanual_d9f93"
    bl_label = "hs2-bot-manual"
    bl_description = ""
    bl_options = {"REGISTER", "UNDO"}

    @classmethod
    def poll(cls, context):
        return not False

    def execute(self, context):
        import os
        ########################################################################
        my_mat = bpy.context.object.material_slots[0].material
        print(my_mat.name)
        Tex=my_mat.name
        rem_mat = bpy.data.materials[Tex]
        #Get the node in its node tree (replace the name below)
        node_to_delete =  rem_mat.node_tree.nodes['Principled BSDF']
        node_to_delete2 =  rem_mat.node_tree.nodes['Material Output']
        #Remove it
        rem_mat.node_tree.nodes.remove(node_to_delete)
        rem_mat.node_tree.nodes.remove(node_to_delete2)
        #Tex = material.name
        TexMain = Tex+'_MainTex.png'
        TexDetailM = Tex+'_DetailMask.png'
        TexNormal = Tex+'_NormalMap.png'
        TexNDetail = Tex+'_NormalMapDetail.png'
        TexAlphaM = Tex+'_AlphaMask.png'
        TexAnotherR = Tex+'_AnotherRamp.png'
        TexLiquidM = Tex+'_liquidmask.png'
        TexTex2 = Tex+'_Texture2.png'
        TexTex3 = Tex+'_Texture3.png'
        TexOv1 = Tex+'_overtex1.png'
        TexOv2 = Tex+'_overtex2.png'
        TexLineM = Tex+'_LineMask.png'
        TexColorM = Tex+'_ColorMask.png'
        TexHairG = Tex+'_HairGloss.png'
        TexBump = Tex+'_BumpMap.png'
        TexDNM = Tex+'_DetailNormalMap.png'
        TexBNM = Tex+'_BlendNormalMap.png'
        TexSGM = Tex+'_SpecGlossMap.png'
        TexOM = Tex+'_OcclusionMap.png'
        TexTSS = Tex+'_Thickness.png'
        TexMGM = Tex+'_MetallicGlossMap.png'
        TexOV = Tex+'_OverTex.png'
        #hs2
        TexBump2 = Tex+'_BumpMap2.png'
        TexDMT = Tex+'_DetailMainTex.png'
        TexDGM = Tex+'_DetailGlossMap.png'
        TexDGM2 = Tex+'_DetailGlossMap2.png'
        TexNailM = Tex+'_NailMask.png'
        TexWetMK = Tex+'_WeatheringMask.png'
        TexWetMP = Tex+'_WeatheringMap.png'
        TexOC = Tex+'_Occlusion.png'
        originaltex = 'mat_bot_preset_'
        #originaltss = 'cf_m_body_01_'
        #kkp
        nm = originaltex+'NormalMap.png'
        nd = originaltex+'NormalMapDetail.png'
        dm = originaltex+'DetailMask.png'
        mm = originaltex+'MainTex.png'
        t3 = originaltex+'Texture3.png'
        t2 = originaltex+'Texture2.png'
        am = originaltex+'AlphaMask.png'
        lm = originaltex+'liquidmask.png'
        ar = originaltex+'AnotherRamp.png'
        ov1 = originaltex+'overtex1.png'
        ov2 = originaltex+'overtex2.png'
        lnm = originaltex+'LineMask.png'
        com = originaltex+'ColorMask.png'
        glo = originaltex+'HairGloss.png'
        #hs1
        bum = originaltex+'BumpMap.png'
        dnm = originaltex+'DetailNormalMap.png'
        bnm = originaltex+'BlendNormalMap.png'
        sgm = originaltex+'SpecGlossMap.png'
        om = originaltex+'OcclusionMap.png'
        tss = originaltex+'Thickness.png'
        mgm = originaltex+'MetallicGlossMap.png'
        ov = originaltex+'OverTex.png'
        #hs2
        bum2 = originaltex+'BumpMap2.png'
        dmt = originaltex+'DetailMainTex.png'
        dgm = originaltex+'DetailGlossMap.png'
        dgm2 = originaltex+'DetailGlossMap2.png'
        nail = originaltex+'NailMask.png'
        wetmk = originaltex+'WeatheringMask.png'
        wetmp = originaltex+'WeatheringMap.png'
        oc = originaltex+'Occlusion.png'
        Template='HS2-Template Pants'
        CTemplate=Template+' '
        C = bpy.context

        def instantiate_group(nodes, data_block_name):
            group = nodes.new(type='ShaderNodeGroup')
            group.node_tree = bpy.data.node_groups[Template]
            return group
        if Template in bpy.data.node_groups:
            instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
            bpy.context.object.active_material.blend_method = 'HASHED'
            bpy.context.object.active_material.shadow_method = 'HASHED'
        else:
        #    versions = ( t0, t1, t2, t3, t4)
        #    for x in versions:
        #        if os.path.isdir(x) and os.access(x, os.R_OK):
            if (3, 0, 0) <= bpy.app.version < (3, 0, 99):
                before_data = list(bpy.data.node_groups)
                bpy.ops.wm.append(directory=os.path.expanduser(r"~\AppData\Roaming\Blender Foundation\Blender\3.0\scripts\addons\sklx_creator\assets\HS2_Template_Shader.blend") + r'\NodeTree',filename=Template,link=False)
                new_data=list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
                appended_2B5AC = None if not new_data else new_data[0]
                instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
                bpy.context.object.active_material.blend_method = 'HASHED'
                bpy.context.object.active_material.shadow_method = 'HASHED'
            else:
                if (3, 1, 0) <= bpy.app.version < (3, 1, 99):
                    before_data = list(bpy.data.node_groups)
                    bpy.ops.wm.append(directory=os.path.expanduser(r"~\AppData\Roaming\Blender Foundation\Blender\3.1\scripts\addons\sklx_creator\assets\HS2_Template_Shader.blend") + r'\NodeTree',filename=Template,link=False)
                    new_data=list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
                    appended_2B5AC = None if not new_data else new_data[0]
                    instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
                    bpy.context.object.active_material.blend_method = 'HASHED'
                    bpy.context.object.active_material.shadow_method = 'HASHED'
                else:
                    if (3, 2, 0) <= bpy.app.version < (3, 2, 99):
                        before_data = list(bpy.data.node_groups)
                        bpy.ops.wm.append(directory=os.path.expanduser(r"~\AppData\Roaming\Blender Foundation\Blender\3.2\scripts\addons\sklx_creator\assets\HS2_Template_Shader.blend") + r'\NodeTree',filename=Template,link=False)
                        new_data=list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
                        appended_2B5AC = None if not new_data else new_data[0]
                        instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
                        bpy.context.object.active_material.blend_method = 'HASHED'
                        bpy.context.object.active_material.shadow_method = 'HASHED'
                    else:
                        if (3, 3, 0) <= bpy.app.version < (3, 3, 99):
                            before_data = list(bpy.data.node_groups)
                            bpy.ops.wm.append(directory=os.path.expanduser(r"~\AppData\Roaming\Blender Foundation\Blender\3.3\scripts\addons\sklx_creator\assets\HS2_Template_Shader.blend") + r'\NodeTree',filename=Template,link=False)
                            new_data=list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
                            appended_2B5AC = None if not new_data else new_data[0]
                            instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
                            bpy.context.object.active_material.blend_method = 'HASHED'
                            bpy.context.object.active_material.shadow_method = 'HASHED'
                        else:
                            if (3, 4, 0) <= bpy.app.version < (3, 4, 99):
                                before_data = list(bpy.data.node_groups)
                                bpy.ops.wm.append(directory=os.path.expanduser(r"~\AppData\Roaming\Blender Foundation\Blender\3.4\scripts\addons\sklx_creator\assets\HS2_Template_Shader.blend") + r'\NodeTree',filename=Template,link=False)
                                new_data=list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
                                appended_2B5AC = None if not new_data else new_data[0]
                                instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
                                bpy.context.object.active_material.blend_method = 'HASHED'
                                bpy.context.object.active_material.shadow_method = 'HASHED'
        bpy.data.node_groups[Template].name = CTemplate+Tex
        node = bpy.data.node_groups[CTemplate+Tex]
        #initial_area_type = bpy.context.area.type
        #bpy.context.area.type = 'NODE_EDITOR'
        #bpy.context.area.ui_type = 'ShaderNodeTree'
        #bpy.ops.node.group_ungroup()
        #bpy.context.area.type = initial_area_type
        nodes = my_mat.node_tree.nodes
        for node in nodes:
            #node.select = False
            print(node.name)
            node.select = True
            nodes.active = node
        try:
            initial_area_type = bpy.context.area.type
            bpy.context.area.type = 'NODE_EDITOR'
            bpy.context.area.ui_type = 'ShaderNodeTree'
            bpy.ops.wm.redraw_timer(type='DRAW_WIN', iterations=1)
            bpy.ops.node.group_ungroup()
            nonono = node," to Ungroup"
            print(nonono)
            bpy.ops.node.group_edit(exit=True)
        except Exception as e:
            print(e)
        finally:
            bpy.context.area.type = initial_area_type
        fixlocate = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\\20220603141428_Chika_Haruno\\Textures\\"
        bpimg = bpy.data.images.get
        if 1==1:
            print(mm)
            print(dm)
            print(nm)
            print(t2)
            print(t3)
        #formula_list=(nm,nd,dm,mm,t2,t3,am,lm,ar,ov1,ov2,lnm,com,glo,bum,dnm,bnm,sgm,om,tss,mgm,ov)
        #for formula in formula_list:
        #    if bpimg(formula) is not None:
        f1 = bpimg(mm)
        #for x in f1:
        if f1 is not None:
            bpy.data.images[mm].name = TexMain
            bpy.data.images[TexMain].filepath = fixlocate+TexMain
            bpy.data.images[TexMain].filepath_raw = fixlocate+TexMain
        f2 = bpimg(dm)
        #for x in f2:
        if f2 is not None:
            bpy.data.images[dm].name = TexDetailM
            bpy.data.images[TexDetailM].filepath = fixlocate+TexDetailM
            bpy.data.images[TexDetailM].filepath_raw = fixlocate+TexDetailM
        f3 = bpimg(nm)
        #for x in f3:
        if f3 is not None:
            bpy.data.images[nm].name = TexNormal
            bpy.data.images[TexNormal].filepath = fixlocate+TexNormal
            bpy.data.images[TexNormal].filepath_raw = fixlocate+TexNormal
        f4 = bpimg(t2)
        #for x in f3:
        if f4 is not None:
            bpy.data.images[t2].name = TexTex2
            bpy.data.images[TexTex2].filepath = fixlocate+TexTex2
            bpy.data.images[TexTex2].filepath_raw = fixlocate+TexTex2
        f5 = bpimg(t3)
        #for x in f4:
        if f5 is not None:
            bpy.data.images[t3].name = TexTex3
            bpy.data.images[TexTex3].filepath = fixlocate+TexTex3
            bpy.data.images[TexTex3].filepath_raw = fixlocate+TexTex3
        f6 = bpimg(am)
        #for x in f5:
        if f6 is not None:
            bpy.data.images[am].name = TexAlphaM
            bpy.data.images[TexAlphaM].filepath = fixlocate+TexAlphaM
            bpy.data.images[TexAlphaM].filepath_raw = fixlocate+TexAlphaM
        f7 = bpimg(lm)
        #for x in f6:
        if f7 is not None:
            bpy.data.images[lm].name = TexLiquidM
            bpy.data.images[TexLiquidM].filepath = fixlocate+TexLiquidM
            bpy.data.images[TexLiquidM].filepath_raw = fixlocate+TexLiquidM
        f8 = bpimg(ar)
        #for f8 in f8:
        if f8 is not None:
            bpy.data.images[ar].name = TexAnotherR
            bpy.data.images[TexAnotherR].filepath = fixlocate+TexAnotherR
            bpy.data.images[TexAnotherR].filepath_raw = fixlocate+TexAnotherR
        f9 = bpimg(nd)
        #for f8 in f8:
        if f9 is not None:
            bpy.data.images[nd].name = TexNDetail
            bpy.data.images[TexNDetail].filepath = fixlocate+TexNDetail
            bpy.data.images[TexNDetail].filepath_raw = fixlocate+TexNDetail
        f10 = bpimg(ov1)
        #for f8 in f8:
        if f10 is not None:
            bpy.data.images[ov1].name = TexOv1
            bpy.data.images[TexOv1].filepath = fixlocate+TexOv1
            bpy.data.images[TexOv1].filepath_raw = fixlocate+TexOv1
        f11 = bpimg(ov2)
        #for f8 in f8:
        if f11 is not None:
            bpy.data.images[ov2].name = TexOv2
            bpy.data.images[TexOv2].filepath = fixlocate+TexOv2
            bpy.data.images[TexOv2].filepath_raw = fixlocate+TexOv2
        f12 = bpimg(lnm)
        #for f8 in f8:
        if f12 is not None:
            bpy.data.images[lnm].name = TexLineM
            bpy.data.images[TexLineM].filepath = fixlocate+TexLineM
            bpy.data.images[TexLineM].filepath_raw = fixlocate+TexLineM
        f13 = bpimg(com)
        #for f8 in f8:
        if f13 is not None:
            bpy.data.images[com].name = TexColorM
            bpy.data.images[TexColorM].filepath = fixlocate+TexColorM
            bpy.data.images[TexColorM].filepath_raw = fixlocate+TexColorM
        f14 = bpimg(glo)
        #for f8 in f8:
        if f14 is not None:
            bpy.data.images[glo].name = TexHairG
            bpy.data.images[TexHairG].filepath = fixlocate+TexHairG
            bpy.data.images[TexHairG].filepath_raw = fixlocate+TexHairG
        f15 = bpimg(bum)
        #for f8 in f8:
        if f15 is not None:
            bpy.data.images[bum].name = TexBump
            bpy.data.images[TexBump].filepath = fixlocate+TexBump
            bpy.data.images[TexBump].filepath_raw = fixlocate+TexBump
        f16 = bpimg(dnm)
        #for f8 in f8:
        if f16 is not None:
            bpy.data.images[dnm].name = TexDNM
            bpy.data.images[TexDNM].filepath = fixlocate+TexDNM
            bpy.data.images[TexDNM].filepath_raw = fixlocate+TexDNM
        f17 = bpimg(bnm)
        #for f8 in f8:
        if f17 is not None:
            bpy.data.images[bnm].name = TexBNM
            bpy.data.images[TexBNM].filepath = fixlocate+TexBNM
            bpy.data.images[TexBNM].filepath_raw = fixlocate+TexBNM
        f18 = bpimg(sgm)
        #for f8 in f8:
        if f18 is not None:
            bpy.data.images[sgm].name = TexSGM
            bpy.data.images[TexSGM].filepath = fixlocate+TexSGM
            bpy.data.images[TexSGM].filepath_raw = fixlocate+TexSGM
        f19 = bpimg(om)
        #for f8 in f8:
        if f19 is not None:
            bpy.data.images[om].name = TexOM
            bpy.data.images[TexOM].filepath = fixlocate+TexOM
            bpy.data.images[TexOM].filepath_raw = fixlocate+TexOM
        f20 = bpimg(tss)
        #for f8 in f8:
        if f20 is not None:
            bpy.data.images[tss].name = TexTSS
            bpy.data.images[TexTSS].filepath = fixlocate+TexTSS
            bpy.data.images[TexTSS].filepath_raw = fixlocate+TexTSS
        f21 = bpimg(mgm)
        #for f8 in f8:
        if f21 is not None:
            bpy.data.images[mgm].name = TexMGM
            bpy.data.images[TexMGM].filepath = fixlocate+TexMGM
            bpy.data.images[TexMGM].filepath_raw = fixlocate+TexMGM
        f22 = bpimg(ov)
        #for f8 in f8:
        if f22 is not None:
            bpy.data.images[ov].name = TexOV
            bpy.data.images[TexOV].filepath = fixlocate+TexOV
            bpy.data.images[TexOV].filepath_raw = fixlocate+TexOV
        f23 = bpimg(bum2)
        #for f8 in f8:
        if f23 is not None:
            bpy.data.images[bum2].name = TexBump2
            bpy.data.images[TexBump2].filepath = fixlocate+TexBump2
            bpy.data.images[TexBump2].filepath_raw = fixlocate+TexBump2
        f24 = bpimg(dmt)
        if f24 is not None:
            bpy.data.images[dmt].name = TexDMT
            bpy.data.images[TexDMT].filepath = fixlocate+TexDMT
            bpy.data.images[TexDMT].filepath_raw = fixlocate+TexDMT
        f25 = bpimg(dgm)
        if f25 is not None:
            bpy.data.images[dgm].name = TexDGM
            bpy.data.images[TexDGM].filepath = fixlocate+TexDGM
            bpy.data.images[TexDGM].filepath_raw = fixlocate+TexDGM
        f26 = bpimg(dgm2)
        if f26 is not None:
            bpy.data.images[dgm2].name = TexDGM2
            bpy.data.images[TexDGM2].filepath = fixlocate+TexDGM2
            bpy.data.images[TexDGM2].filepath_raw = fixlocate+TexDGM2
        f27 = bpimg(nail)
        if f27 is not None:
            bpy.data.images[nail].name = TexNailM
            bpy.data.images[TexNailM].filepath = fixlocate+TexNailM
            bpy.data.images[TexNailM].filepath_raw = fixlocate+TexNailM
        f28 = bpimg(wetmk)
        if f28 is not None:
            bpy.data.images[wetmk].name = TexWetMK
            bpy.data.images[TexWetMK].filepath = fixlocate+TexWetMK
            bpy.data.images[TexWetMK].filepath_raw = fixlocate+TexWetMK
        f29 = bpimg(wetmp)
        if f29 is not None:
            bpy.data.images[wetmp].name = TexWetMP
            bpy.data.images[TexWetMP].filepath = fixlocate+TexWetMP
            bpy.data.images[TexWetMP].filepath_raw = fixlocate+TexWetMP
        f30 = bpimg(oc)
        if f30 is not None:
            bpy.data.images[oc].name = TexOC
            bpy.data.images[TexOC].filepath = fixlocate+TexOC
            bpy.data.images[TexOC].filepath_raw = fixlocate+TexOC
        bpy.ops.file.find_missing_files('INVOKE_DEFAULT')
        return {"FINISHED"}

    def invoke(self, context, event):
        return self.execute(context)


class SNA_OT_Hs2Innermanual_665D4(bpy.types.Operator):
    bl_idname = "sna.hs2innermanual_665d4"
    bl_label = "hs2-inner-manual"
    bl_description = ""
    bl_options = {"REGISTER", "UNDO"}

    @classmethod
    def poll(cls, context):
        return not False

    def execute(self, context):
        import os
        ########################################################################
        my_mat = bpy.context.object.material_slots[0].material
        print(my_mat.name)
        Tex=my_mat.name
        rem_mat = bpy.data.materials[Tex]
        #Get the node in its node tree (replace the name below)
        node_to_delete =  rem_mat.node_tree.nodes['Principled BSDF']
        node_to_delete2 =  rem_mat.node_tree.nodes['Material Output']
        #Remove it
        rem_mat.node_tree.nodes.remove(node_to_delete)
        rem_mat.node_tree.nodes.remove(node_to_delete2)
        #Tex = material.name
        TexMain = Tex+'_MainTex.png'
        TexDetailM = Tex+'_DetailMask.png'
        TexNormal = Tex+'_NormalMap.png'
        TexNDetail = Tex+'_NormalMapDetail.png'
        TexAlphaM = Tex+'_AlphaMask.png'
        TexAnotherR = Tex+'_AnotherRamp.png'
        TexLiquidM = Tex+'_liquidmask.png'
        TexTex2 = Tex+'_Texture2.png'
        TexTex3 = Tex+'_Texture3.png'
        TexOv1 = Tex+'_overtex1.png'
        TexOv2 = Tex+'_overtex2.png'
        TexLineM = Tex+'_LineMask.png'
        TexColorM = Tex+'_ColorMask.png'
        TexHairG = Tex+'_HairGloss.png'
        TexBump = Tex+'_BumpMap.png'
        TexDNM = Tex+'_DetailNormalMap.png'
        TexBNM = Tex+'_BlendNormalMap.png'
        TexSGM = Tex+'_SpecGlossMap.png'
        TexOM = Tex+'_OcclusionMap.png'
        TexTSS = Tex+'_Thickness.png'
        TexMGM = Tex+'_MetallicGlossMap.png'
        TexOV = Tex+'_OverTex.png'
        #hs2
        TexBump2 = Tex+'_BumpMap2.png'
        TexDMT = Tex+'_DetailMainTex.png'
        TexDGM = Tex+'_DetailGlossMap.png'
        TexDGM2 = Tex+'_DetailGlossMap2.png'
        TexNailM = Tex+'_NailMask.png'
        TexWetMK = Tex+'_WeatheringMask.png'
        TexWetMP = Tex+'_WeatheringMap.png'
        TexOC = Tex+'_Occlusion.png'
        originaltex = 'mat_inner_preset_'
        #originaltss = 'cf_m_body_01_'
        #kkp
        nm = originaltex+'NormalMap.png'
        nd = originaltex+'NormalMapDetail.png'
        dm = originaltex+'DetailMask.png'
        mm = originaltex+'MainTex.png'
        t3 = originaltex+'Texture3.png'
        t2 = originaltex+'Texture2.png'
        am = originaltex+'AlphaMask.png'
        lm = originaltex+'liquidmask.png'
        ar = originaltex+'AnotherRamp.png'
        ov1 = originaltex+'overtex1.png'
        ov2 = originaltex+'overtex2.png'
        lnm = originaltex+'LineMask.png'
        com = originaltex+'ColorMask.png'
        glo = originaltex+'HairGloss.png'
        #hs1
        bum = originaltex+'BumpMap.png'
        dnm = originaltex+'DetailNormalMap.png'
        bnm = originaltex+'BlendNormalMap.png'
        sgm = originaltex+'SpecGlossMap.png'
        om = originaltex+'OcclusionMap.png'
        tss = originaltex+'Thickness.png'
        mgm = originaltex+'MetallicGlossMap.png'
        ov = originaltex+'OverTex.png'
        #hs2
        bum2 = originaltex+'BumpMap2.png'
        dmt = originaltex+'DetailMainTex.png'
        dgm = originaltex+'DetailGlossMap.png'
        dgm2 = originaltex+'DetailGlossMap2.png'
        nail = originaltex+'NailMask.png'
        wetmk = originaltex+'WeatheringMask.png'
        wetmp = originaltex+'WeatheringMap.png'
        oc = originaltex+'Occlusion.png'
        Template='HS2-Template Inner'
        CTemplate=Template+' '
        C = bpy.context

        def instantiate_group(nodes, data_block_name):
            group = nodes.new(type='ShaderNodeGroup')
            group.node_tree = bpy.data.node_groups[Template]
            return group
        if Template in bpy.data.node_groups:
            instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
            bpy.context.object.active_material.blend_method = 'HASHED'
            bpy.context.object.active_material.shadow_method = 'HASHED'
        else:
        #    versions = ( t0, t1, t2, t3, t4)
        #    for x in versions:
        #        if os.path.isdir(x) and os.access(x, os.R_OK):
            if (3, 0, 0) <= bpy.app.version < (3, 0, 99):
                before_data = list(bpy.data.node_groups)
                bpy.ops.wm.append(directory=os.path.expanduser(r"~\AppData\Roaming\Blender Foundation\Blender\3.0\scripts\addons\sklx_creator\assets\HS2_Template_Shader.blend") + r'\NodeTree',filename=Template,link=False)
                new_data=list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
                appended_2B5AC = None if not new_data else new_data[0]
                instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
                bpy.context.object.active_material.blend_method = 'HASHED'
                bpy.context.object.active_material.shadow_method = 'HASHED'
            else:
                if (3, 1, 0) <= bpy.app.version < (3, 1, 99):
                    before_data = list(bpy.data.node_groups)
                    bpy.ops.wm.append(directory=os.path.expanduser(r"~\AppData\Roaming\Blender Foundation\Blender\3.1\scripts\addons\sklx_creator\assets\HS2_Template_Shader.blend") + r'\NodeTree',filename=Template,link=False)
                    new_data=list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
                    appended_2B5AC = None if not new_data else new_data[0]
                    instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
                    bpy.context.object.active_material.blend_method = 'HASHED'
                    bpy.context.object.active_material.shadow_method = 'HASHED'
                else:
                    if (3, 2, 0) <= bpy.app.version < (3, 2, 99):
                        before_data = list(bpy.data.node_groups)
                        bpy.ops.wm.append(directory=os.path.expanduser(r"~\AppData\Roaming\Blender Foundation\Blender\3.2\scripts\addons\sklx_creator\assets\HS2_Template_Shader.blend") + r'\NodeTree',filename=Template,link=False)
                        new_data=list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
                        appended_2B5AC = None if not new_data else new_data[0]
                        instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
                        bpy.context.object.active_material.blend_method = 'HASHED'
                        bpy.context.object.active_material.shadow_method = 'HASHED'
                    else:
                        if (3, 3, 0) <= bpy.app.version < (3, 3, 99):
                            before_data = list(bpy.data.node_groups)
                            bpy.ops.wm.append(directory=os.path.expanduser(r"~\AppData\Roaming\Blender Foundation\Blender\3.3\scripts\addons\sklx_creator\assets\HS2_Template_Shader.blend") + r'\NodeTree',filename=Template,link=False)
                            new_data=list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
                            appended_2B5AC = None if not new_data else new_data[0]
                            instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
                            bpy.context.object.active_material.blend_method = 'HASHED'
                            bpy.context.object.active_material.shadow_method = 'HASHED'
                        else:
                            if (3, 4, 0) <= bpy.app.version < (3, 4, 99):
                                before_data = list(bpy.data.node_groups)
                                bpy.ops.wm.append(directory=os.path.expanduser(r"~\AppData\Roaming\Blender Foundation\Blender\3.4\scripts\addons\sklx_creator\assets\HS2_Template_Shader.blend") + r'\NodeTree',filename=Template,link=False)
                                new_data=list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
                                appended_2B5AC = None if not new_data else new_data[0]
                                instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
                                bpy.context.object.active_material.blend_method = 'HASHED'
                                bpy.context.object.active_material.shadow_method = 'HASHED'
        bpy.data.node_groups[Template].name = CTemplate+Tex
        node = bpy.data.node_groups[CTemplate+Tex]
        #initial_area_type = bpy.context.area.type
        #bpy.context.area.type = 'NODE_EDITOR'
        #bpy.context.area.ui_type = 'ShaderNodeTree'
        #bpy.ops.node.group_ungroup()
        #bpy.context.area.type = initial_area_type
        nodes = my_mat.node_tree.nodes
        for node in nodes:
            #node.select = False
            print(node.name)
            node.select = True
            nodes.active = node
        try:
            initial_area_type = bpy.context.area.type
            bpy.context.area.type = 'NODE_EDITOR'
            bpy.context.area.ui_type = 'ShaderNodeTree'
            bpy.ops.wm.redraw_timer(type='DRAW_WIN', iterations=1)
            bpy.ops.node.group_ungroup()
            nonono = node," to Ungroup"
            print(nonono)
            bpy.ops.node.group_edit(exit=True)
        except Exception as e:
            print(e)
        finally:
            bpy.context.area.type = initial_area_type
        fixlocate = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\\20220603141428_Chika_Haruno\\Textures\\"
        bpimg = bpy.data.images.get
        if 1==1:
            print(mm)
            print(dm)
            print(nm)
            print(t2)
            print(t3)
        #formula_list=(nm,nd,dm,mm,t2,t3,am,lm,ar,ov1,ov2,lnm,com,glo,bum,dnm,bnm,sgm,om,tss,mgm,ov)
        #for formula in formula_list:
        #    if bpimg(formula) is not None:
        f1 = bpimg(mm)
        #for x in f1:
        if f1 is not None:
            bpy.data.images[mm].name = TexMain
            bpy.data.images[TexMain].filepath = fixlocate+TexMain
            bpy.data.images[TexMain].filepath_raw = fixlocate+TexMain
        f2 = bpimg(dm)
        #for x in f2:
        if f2 is not None:
            bpy.data.images[dm].name = TexDetailM
            bpy.data.images[TexDetailM].filepath = fixlocate+TexDetailM
            bpy.data.images[TexDetailM].filepath_raw = fixlocate+TexDetailM
        f3 = bpimg(nm)
        #for x in f3:
        if f3 is not None:
            bpy.data.images[nm].name = TexNormal
            bpy.data.images[TexNormal].filepath = fixlocate+TexNormal
            bpy.data.images[TexNormal].filepath_raw = fixlocate+TexNormal
        f4 = bpimg(t2)
        #for x in f3:
        if f4 is not None:
            bpy.data.images[t2].name = TexTex2
            bpy.data.images[TexTex2].filepath = fixlocate+TexTex2
            bpy.data.images[TexTex2].filepath_raw = fixlocate+TexTex2
        f5 = bpimg(t3)
        #for x in f4:
        if f5 is not None:
            bpy.data.images[t3].name = TexTex3
            bpy.data.images[TexTex3].filepath = fixlocate+TexTex3
            bpy.data.images[TexTex3].filepath_raw = fixlocate+TexTex3
        f6 = bpimg(am)
        #for x in f5:
        if f6 is not None:
            bpy.data.images[am].name = TexAlphaM
            bpy.data.images[TexAlphaM].filepath = fixlocate+TexAlphaM
            bpy.data.images[TexAlphaM].filepath_raw = fixlocate+TexAlphaM
        f7 = bpimg(lm)
        #for x in f6:
        if f7 is not None:
            bpy.data.images[lm].name = TexLiquidM
            bpy.data.images[TexLiquidM].filepath = fixlocate+TexLiquidM
            bpy.data.images[TexLiquidM].filepath_raw = fixlocate+TexLiquidM
        f8 = bpimg(ar)
        #for f8 in f8:
        if f8 is not None:
            bpy.data.images[ar].name = TexAnotherR
            bpy.data.images[TexAnotherR].filepath = fixlocate+TexAnotherR
            bpy.data.images[TexAnotherR].filepath_raw = fixlocate+TexAnotherR
        f9 = bpimg(nd)
        #for f8 in f8:
        if f9 is not None:
            bpy.data.images[nd].name = TexNDetail
            bpy.data.images[TexNDetail].filepath = fixlocate+TexNDetail
            bpy.data.images[TexNDetail].filepath_raw = fixlocate+TexNDetail
        f10 = bpimg(ov1)
        #for f8 in f8:
        if f10 is not None:
            bpy.data.images[ov1].name = TexOv1
            bpy.data.images[TexOv1].filepath = fixlocate+TexOv1
            bpy.data.images[TexOv1].filepath_raw = fixlocate+TexOv1
        f11 = bpimg(ov2)
        #for f8 in f8:
        if f11 is not None:
            bpy.data.images[ov2].name = TexOv2
            bpy.data.images[TexOv2].filepath = fixlocate+TexOv2
            bpy.data.images[TexOv2].filepath_raw = fixlocate+TexOv2
        f12 = bpimg(lnm)
        #for f8 in f8:
        if f12 is not None:
            bpy.data.images[lnm].name = TexLineM
            bpy.data.images[TexLineM].filepath = fixlocate+TexLineM
            bpy.data.images[TexLineM].filepath_raw = fixlocate+TexLineM
        f13 = bpimg(com)
        #for f8 in f8:
        if f13 is not None:
            bpy.data.images[com].name = TexColorM
            bpy.data.images[TexColorM].filepath = fixlocate+TexColorM
            bpy.data.images[TexColorM].filepath_raw = fixlocate+TexColorM
        f14 = bpimg(glo)
        #for f8 in f8:
        if f14 is not None:
            bpy.data.images[glo].name = TexHairG
            bpy.data.images[TexHairG].filepath = fixlocate+TexHairG
            bpy.data.images[TexHairG].filepath_raw = fixlocate+TexHairG
        f15 = bpimg(bum)
        #for f8 in f8:
        if f15 is not None:
            bpy.data.images[bum].name = TexBump
            bpy.data.images[TexBump].filepath = fixlocate+TexBump
            bpy.data.images[TexBump].filepath_raw = fixlocate+TexBump
        f16 = bpimg(dnm)
        #for f8 in f8:
        if f16 is not None:
            bpy.data.images[dnm].name = TexDNM
            bpy.data.images[TexDNM].filepath = fixlocate+TexDNM
            bpy.data.images[TexDNM].filepath_raw = fixlocate+TexDNM
        f17 = bpimg(bnm)
        #for f8 in f8:
        if f17 is not None:
            bpy.data.images[bnm].name = TexBNM
            bpy.data.images[TexBNM].filepath = fixlocate+TexBNM
            bpy.data.images[TexBNM].filepath_raw = fixlocate+TexBNM
        f18 = bpimg(sgm)
        #for f8 in f8:
        if f18 is not None:
            bpy.data.images[sgm].name = TexSGM
            bpy.data.images[TexSGM].filepath = fixlocate+TexSGM
            bpy.data.images[TexSGM].filepath_raw = fixlocate+TexSGM
        f19 = bpimg(om)
        #for f8 in f8:
        if f19 is not None:
            bpy.data.images[om].name = TexOM
            bpy.data.images[TexOM].filepath = fixlocate+TexOM
            bpy.data.images[TexOM].filepath_raw = fixlocate+TexOM
        f20 = bpimg(tss)
        #for f8 in f8:
        if f20 is not None:
            bpy.data.images[tss].name = TexTSS
            bpy.data.images[TexTSS].filepath = fixlocate+TexTSS
            bpy.data.images[TexTSS].filepath_raw = fixlocate+TexTSS
        f21 = bpimg(mgm)
        #for f8 in f8:
        if f21 is not None:
            bpy.data.images[mgm].name = TexMGM
            bpy.data.images[TexMGM].filepath = fixlocate+TexMGM
            bpy.data.images[TexMGM].filepath_raw = fixlocate+TexMGM
        f22 = bpimg(ov)
        #for f8 in f8:
        if f22 is not None:
            bpy.data.images[ov].name = TexOV
            bpy.data.images[TexOV].filepath = fixlocate+TexOV
            bpy.data.images[TexOV].filepath_raw = fixlocate+TexOV
        f23 = bpimg(bum2)
        #for f8 in f8:
        if f23 is not None:
            bpy.data.images[bum2].name = TexBump2
            bpy.data.images[TexBump2].filepath = fixlocate+TexBump2
            bpy.data.images[TexBump2].filepath_raw = fixlocate+TexBump2
        f24 = bpimg(dmt)
        if f24 is not None:
            bpy.data.images[dmt].name = TexDMT
            bpy.data.images[TexDMT].filepath = fixlocate+TexDMT
            bpy.data.images[TexDMT].filepath_raw = fixlocate+TexDMT
        f25 = bpimg(dgm)
        if f25 is not None:
            bpy.data.images[dgm].name = TexDGM
            bpy.data.images[TexDGM].filepath = fixlocate+TexDGM
            bpy.data.images[TexDGM].filepath_raw = fixlocate+TexDGM
        f26 = bpimg(dgm2)
        if f26 is not None:
            bpy.data.images[dgm2].name = TexDGM2
            bpy.data.images[TexDGM2].filepath = fixlocate+TexDGM2
            bpy.data.images[TexDGM2].filepath_raw = fixlocate+TexDGM2
        f27 = bpimg(nail)
        if f27 is not None:
            bpy.data.images[nail].name = TexNailM
            bpy.data.images[TexNailM].filepath = fixlocate+TexNailM
            bpy.data.images[TexNailM].filepath_raw = fixlocate+TexNailM
        f28 = bpimg(wetmk)
        if f28 is not None:
            bpy.data.images[wetmk].name = TexWetMK
            bpy.data.images[TexWetMK].filepath = fixlocate+TexWetMK
            bpy.data.images[TexWetMK].filepath_raw = fixlocate+TexWetMK
        f29 = bpimg(wetmp)
        if f29 is not None:
            bpy.data.images[wetmp].name = TexWetMP
            bpy.data.images[TexWetMP].filepath = fixlocate+TexWetMP
            bpy.data.images[TexWetMP].filepath_raw = fixlocate+TexWetMP
        f30 = bpimg(oc)
        if f30 is not None:
            bpy.data.images[oc].name = TexOC
            bpy.data.images[TexOC].filepath = fixlocate+TexOC
            bpy.data.images[TexOC].filepath_raw = fixlocate+TexOC
        bpy.ops.file.find_missing_files('INVOKE_DEFAULT')
        return {"FINISHED"}

    def invoke(self, context, event):
        return self.execute(context)


class SNA_OT_Hs2Pantiesmanual_Dab9C(bpy.types.Operator):
    bl_idname = "sna.hs2pantiesmanual_dab9c"
    bl_label = "hs2-panties-manual"
    bl_description = ""
    bl_options = {"REGISTER", "UNDO"}

    @classmethod
    def poll(cls, context):
        return not False

    def execute(self, context):
        import os
        ########################################################################
        my_mat = bpy.context.object.material_slots[0].material
        print(my_mat.name)
        Tex=my_mat.name
        rem_mat = bpy.data.materials[Tex]
        #Get the node in its node tree (replace the name below)
        node_to_delete =  rem_mat.node_tree.nodes['Principled BSDF']
        node_to_delete2 =  rem_mat.node_tree.nodes['Material Output']
        #Remove it
        rem_mat.node_tree.nodes.remove(node_to_delete)
        rem_mat.node_tree.nodes.remove(node_to_delete2)
        #Tex = material.name
        TexMain = Tex+'_MainTex.png'
        TexDetailM = Tex+'_DetailMask.png'
        TexNormal = Tex+'_NormalMap.png'
        TexNDetail = Tex+'_NormalMapDetail.png'
        TexAlphaM = Tex+'_AlphaMask.png'
        TexAnotherR = Tex+'_AnotherRamp.png'
        TexLiquidM = Tex+'_liquidmask.png'
        TexTex2 = Tex+'_Texture2.png'
        TexTex3 = Tex+'_Texture3.png'
        TexOv1 = Tex+'_overtex1.png'
        TexOv2 = Tex+'_overtex2.png'
        TexLineM = Tex+'_LineMask.png'
        TexColorM = Tex+'_ColorMask.png'
        TexHairG = Tex+'_HairGloss.png'
        TexBump = Tex+'_BumpMap.png'
        TexDNM = Tex+'_DetailNormalMap.png'
        TexBNM = Tex+'_BlendNormalMap.png'
        TexSGM = Tex+'_SpecGlossMap.png'
        TexOM = Tex+'_OcclusionMap.png'
        TexTSS = Tex+'_Thickness.png'
        TexMGM = Tex+'_MetallicGlossMap.png'
        TexOV = Tex+'_OverTex.png'
        #hs2
        TexBump2 = Tex+'_BumpMap2.png'
        TexDMT = Tex+'_DetailMainTex.png'
        TexDGM = Tex+'_DetailGlossMap.png'
        TexDGM2 = Tex+'_DetailGlossMap2.png'
        TexNailM = Tex+'_NailMask.png'
        TexWetMK = Tex+'_WeatheringMask.png'
        TexWetMP = Tex+'_WeatheringMap.png'
        TexOC = Tex+'_Occlusion.png'
        originaltex = 'mat_short_preset_'
        #originaltss = 'cf_m_body_01_'
        #kkp
        nm = originaltex+'NormalMap.png'
        nd = originaltex+'NormalMapDetail.png'
        dm = originaltex+'DetailMask.png'
        mm = originaltex+'MainTex.png'
        t3 = originaltex+'Texture3.png'
        t2 = originaltex+'Texture2.png'
        am = originaltex+'AlphaMask.png'
        lm = originaltex+'liquidmask.png'
        ar = originaltex+'AnotherRamp.png'
        ov1 = originaltex+'overtex1.png'
        ov2 = originaltex+'overtex2.png'
        lnm = originaltex+'LineMask.png'
        com = originaltex+'ColorMask.png'
        glo = originaltex+'HairGloss.png'
        #hs1
        bum = originaltex+'BumpMap.png'
        dnm = originaltex+'DetailNormalMap.png'
        bnm = originaltex+'BlendNormalMap.png'
        sgm = originaltex+'SpecGlossMap.png'
        om = originaltex+'OcclusionMap.png'
        tss = originaltex+'Thickness.png'
        mgm = originaltex+'MetallicGlossMap.png'
        ov = originaltex+'OverTex.png'
        #hs2
        bum2 = originaltex+'BumpMap2.png'
        dmt = originaltex+'DetailMainTex.png'
        dgm = originaltex+'DetailGlossMap.png'
        dgm2 = originaltex+'DetailGlossMap2.png'
        nail = originaltex+'NailMask.png'
        wetmk = originaltex+'WeatheringMask.png'
        wetmp = originaltex+'WeatheringMap.png'
        oc = originaltex+'Occlusion.png'
        Template='HS2-Template Short'
        CTemplate=Template+' '
        C = bpy.context

        def instantiate_group(nodes, data_block_name):
            group = nodes.new(type='ShaderNodeGroup')
            group.node_tree = bpy.data.node_groups[Template]
            return group
        if Template in bpy.data.node_groups:
            instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
            bpy.context.object.active_material.blend_method = 'HASHED'
            bpy.context.object.active_material.shadow_method = 'HASHED'
        else:
        #    versions = ( t0, t1, t2, t3, t4)
        #    for x in versions:
        #        if os.path.isdir(x) and os.access(x, os.R_OK):
            if (3, 0, 0) <= bpy.app.version < (3, 0, 99):
                before_data = list(bpy.data.node_groups)
                bpy.ops.wm.append(directory=os.path.expanduser(r"~\AppData\Roaming\Blender Foundation\Blender\3.0\scripts\addons\sklx_creator\assets\HS2_Template_Shader.blend") + r'\NodeTree',filename=Template,link=False)
                new_data=list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
                appended_2B5AC = None if not new_data else new_data[0]
                instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
                bpy.context.object.active_material.blend_method = 'HASHED'
                bpy.context.object.active_material.shadow_method = 'HASHED'
            else:
                if (3, 1, 0) <= bpy.app.version < (3, 1, 99):
                    before_data = list(bpy.data.node_groups)
                    bpy.ops.wm.append(directory=os.path.expanduser(r"~\AppData\Roaming\Blender Foundation\Blender\3.1\scripts\addons\sklx_creator\assets\HS2_Template_Shader.blend") + r'\NodeTree',filename=Template,link=False)
                    new_data=list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
                    appended_2B5AC = None if not new_data else new_data[0]
                    instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
                    bpy.context.object.active_material.blend_method = 'HASHED'
                    bpy.context.object.active_material.shadow_method = 'HASHED'
                else:
                    if (3, 2, 0) <= bpy.app.version < (3, 2, 99):
                        before_data = list(bpy.data.node_groups)
                        bpy.ops.wm.append(directory=os.path.expanduser(r"~\AppData\Roaming\Blender Foundation\Blender\3.2\scripts\addons\sklx_creator\assets\HS2_Template_Shader.blend") + r'\NodeTree',filename=Template,link=False)
                        new_data=list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
                        appended_2B5AC = None if not new_data else new_data[0]
                        instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
                        bpy.context.object.active_material.blend_method = 'HASHED'
                        bpy.context.object.active_material.shadow_method = 'HASHED'
                    else:
                        if (3, 3, 0) <= bpy.app.version < (3, 3, 99):
                            before_data = list(bpy.data.node_groups)
                            bpy.ops.wm.append(directory=os.path.expanduser(r"~\AppData\Roaming\Blender Foundation\Blender\3.3\scripts\addons\sklx_creator\assets\HS2_Template_Shader.blend") + r'\NodeTree',filename=Template,link=False)
                            new_data=list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
                            appended_2B5AC = None if not new_data else new_data[0]
                            instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
                            bpy.context.object.active_material.blend_method = 'HASHED'
                            bpy.context.object.active_material.shadow_method = 'HASHED'
                        else:
                            if (3, 4, 0) <= bpy.app.version < (3, 4, 99):
                                before_data = list(bpy.data.node_groups)
                                bpy.ops.wm.append(directory=os.path.expanduser(r"~\AppData\Roaming\Blender Foundation\Blender\3.4\scripts\addons\sklx_creator\assets\HS2_Template_Shader.blend") + r'\NodeTree',filename=Template,link=False)
                                new_data=list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
                                appended_2B5AC = None if not new_data else new_data[0]
                                instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
                                bpy.context.object.active_material.blend_method = 'HASHED'
                                bpy.context.object.active_material.shadow_method = 'HASHED'
        bpy.data.node_groups[Template].name = CTemplate+Tex
        node = bpy.data.node_groups[CTemplate+Tex]
        #initial_area_type = bpy.context.area.type
        #bpy.context.area.type = 'NODE_EDITOR'
        #bpy.context.area.ui_type = 'ShaderNodeTree'
        #bpy.ops.node.group_ungroup()
        #bpy.context.area.type = initial_area_type
        nodes = my_mat.node_tree.nodes
        for node in nodes:
            #node.select = False
            print(node.name)
            node.select = True
            nodes.active = node
        try:
            initial_area_type = bpy.context.area.type
            bpy.context.area.type = 'NODE_EDITOR'
            bpy.context.area.ui_type = 'ShaderNodeTree'
            bpy.ops.wm.redraw_timer(type='DRAW_WIN', iterations=1)
            bpy.ops.node.group_ungroup()
            nonono = node," to Ungroup"
            print(nonono)
            bpy.ops.node.group_edit(exit=True)
        except Exception as e:
            print(e)
        finally:
            bpy.context.area.type = initial_area_type
        fixlocate = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\\20220603141428_Chika_Haruno\\Textures\\"
        bpimg = bpy.data.images.get
        if 1==1:
            print(mm)
            print(dm)
            print(nm)
            print(t2)
            print(t3)
        #formula_list=(nm,nd,dm,mm,t2,t3,am,lm,ar,ov1,ov2,lnm,com,glo,bum,dnm,bnm,sgm,om,tss,mgm,ov)
        #for formula in formula_list:
        #    if bpimg(formula) is not None:
        f1 = bpimg(mm)
        #for x in f1:
        if f1 is not None:
            bpy.data.images[mm].name = TexMain
            bpy.data.images[TexMain].filepath = fixlocate+TexMain
            bpy.data.images[TexMain].filepath_raw = fixlocate+TexMain
        f2 = bpimg(dm)
        #for x in f2:
        if f2 is not None:
            bpy.data.images[dm].name = TexDetailM
            bpy.data.images[TexDetailM].filepath = fixlocate+TexDetailM
            bpy.data.images[TexDetailM].filepath_raw = fixlocate+TexDetailM
        f3 = bpimg(nm)
        #for x in f3:
        if f3 is not None:
            bpy.data.images[nm].name = TexNormal
            bpy.data.images[TexNormal].filepath = fixlocate+TexNormal
            bpy.data.images[TexNormal].filepath_raw = fixlocate+TexNormal
        f4 = bpimg(t2)
        #for x in f3:
        if f4 is not None:
            bpy.data.images[t2].name = TexTex2
            bpy.data.images[TexTex2].filepath = fixlocate+TexTex2
            bpy.data.images[TexTex2].filepath_raw = fixlocate+TexTex2
        f5 = bpimg(t3)
        #for x in f4:
        if f5 is not None:
            bpy.data.images[t3].name = TexTex3
            bpy.data.images[TexTex3].filepath = fixlocate+TexTex3
            bpy.data.images[TexTex3].filepath_raw = fixlocate+TexTex3
        f6 = bpimg(am)
        #for x in f5:
        if f6 is not None:
            bpy.data.images[am].name = TexAlphaM
            bpy.data.images[TexAlphaM].filepath = fixlocate+TexAlphaM
            bpy.data.images[TexAlphaM].filepath_raw = fixlocate+TexAlphaM
        f7 = bpimg(lm)
        #for x in f6:
        if f7 is not None:
            bpy.data.images[lm].name = TexLiquidM
            bpy.data.images[TexLiquidM].filepath = fixlocate+TexLiquidM
            bpy.data.images[TexLiquidM].filepath_raw = fixlocate+TexLiquidM
        f8 = bpimg(ar)
        #for f8 in f8:
        if f8 is not None:
            bpy.data.images[ar].name = TexAnotherR
            bpy.data.images[TexAnotherR].filepath = fixlocate+TexAnotherR
            bpy.data.images[TexAnotherR].filepath_raw = fixlocate+TexAnotherR
        f9 = bpimg(nd)
        #for f8 in f8:
        if f9 is not None:
            bpy.data.images[nd].name = TexNDetail
            bpy.data.images[TexNDetail].filepath = fixlocate+TexNDetail
            bpy.data.images[TexNDetail].filepath_raw = fixlocate+TexNDetail
        f10 = bpimg(ov1)
        #for f8 in f8:
        if f10 is not None:
            bpy.data.images[ov1].name = TexOv1
            bpy.data.images[TexOv1].filepath = fixlocate+TexOv1
            bpy.data.images[TexOv1].filepath_raw = fixlocate+TexOv1
        f11 = bpimg(ov2)
        #for f8 in f8:
        if f11 is not None:
            bpy.data.images[ov2].name = TexOv2
            bpy.data.images[TexOv2].filepath = fixlocate+TexOv2
            bpy.data.images[TexOv2].filepath_raw = fixlocate+TexOv2
        f12 = bpimg(lnm)
        #for f8 in f8:
        if f12 is not None:
            bpy.data.images[lnm].name = TexLineM
            bpy.data.images[TexLineM].filepath = fixlocate+TexLineM
            bpy.data.images[TexLineM].filepath_raw = fixlocate+TexLineM
        f13 = bpimg(com)
        #for f8 in f8:
        if f13 is not None:
            bpy.data.images[com].name = TexColorM
            bpy.data.images[TexColorM].filepath = fixlocate+TexColorM
            bpy.data.images[TexColorM].filepath_raw = fixlocate+TexColorM
        f14 = bpimg(glo)
        #for f8 in f8:
        if f14 is not None:
            bpy.data.images[glo].name = TexHairG
            bpy.data.images[TexHairG].filepath = fixlocate+TexHairG
            bpy.data.images[TexHairG].filepath_raw = fixlocate+TexHairG
        f15 = bpimg(bum)
        #for f8 in f8:
        if f15 is not None:
            bpy.data.images[bum].name = TexBump
            bpy.data.images[TexBump].filepath = fixlocate+TexBump
            bpy.data.images[TexBump].filepath_raw = fixlocate+TexBump
        f16 = bpimg(dnm)
        #for f8 in f8:
        if f16 is not None:
            bpy.data.images[dnm].name = TexDNM
            bpy.data.images[TexDNM].filepath = fixlocate+TexDNM
            bpy.data.images[TexDNM].filepath_raw = fixlocate+TexDNM
        f17 = bpimg(bnm)
        #for f8 in f8:
        if f17 is not None:
            bpy.data.images[bnm].name = TexBNM
            bpy.data.images[TexBNM].filepath = fixlocate+TexBNM
            bpy.data.images[TexBNM].filepath_raw = fixlocate+TexBNM
        f18 = bpimg(sgm)
        #for f8 in f8:
        if f18 is not None:
            bpy.data.images[sgm].name = TexSGM
            bpy.data.images[TexSGM].filepath = fixlocate+TexSGM
            bpy.data.images[TexSGM].filepath_raw = fixlocate+TexSGM
        f19 = bpimg(om)
        #for f8 in f8:
        if f19 is not None:
            bpy.data.images[om].name = TexOM
            bpy.data.images[TexOM].filepath = fixlocate+TexOM
            bpy.data.images[TexOM].filepath_raw = fixlocate+TexOM
        f20 = bpimg(tss)
        #for f8 in f8:
        if f20 is not None:
            bpy.data.images[tss].name = TexTSS
            bpy.data.images[TexTSS].filepath = fixlocate+TexTSS
            bpy.data.images[TexTSS].filepath_raw = fixlocate+TexTSS
        f21 = bpimg(mgm)
        #for f8 in f8:
        if f21 is not None:
            bpy.data.images[mgm].name = TexMGM
            bpy.data.images[TexMGM].filepath = fixlocate+TexMGM
            bpy.data.images[TexMGM].filepath_raw = fixlocate+TexMGM
        f22 = bpimg(ov)
        #for f8 in f8:
        if f22 is not None:
            bpy.data.images[ov].name = TexOV
            bpy.data.images[TexOV].filepath = fixlocate+TexOV
            bpy.data.images[TexOV].filepath_raw = fixlocate+TexOV
        f23 = bpimg(bum2)
        #for f8 in f8:
        if f23 is not None:
            bpy.data.images[bum2].name = TexBump2
            bpy.data.images[TexBump2].filepath = fixlocate+TexBump2
            bpy.data.images[TexBump2].filepath_raw = fixlocate+TexBump2
        f24 = bpimg(dmt)
        if f24 is not None:
            bpy.data.images[dmt].name = TexDMT
            bpy.data.images[TexDMT].filepath = fixlocate+TexDMT
            bpy.data.images[TexDMT].filepath_raw = fixlocate+TexDMT
        f25 = bpimg(dgm)
        if f25 is not None:
            bpy.data.images[dgm].name = TexDGM
            bpy.data.images[TexDGM].filepath = fixlocate+TexDGM
            bpy.data.images[TexDGM].filepath_raw = fixlocate+TexDGM
        f26 = bpimg(dgm2)
        if f26 is not None:
            bpy.data.images[dgm2].name = TexDGM2
            bpy.data.images[TexDGM2].filepath = fixlocate+TexDGM2
            bpy.data.images[TexDGM2].filepath_raw = fixlocate+TexDGM2
        f27 = bpimg(nail)
        if f27 is not None:
            bpy.data.images[nail].name = TexNailM
            bpy.data.images[TexNailM].filepath = fixlocate+TexNailM
            bpy.data.images[TexNailM].filepath_raw = fixlocate+TexNailM
        f28 = bpimg(wetmk)
        if f28 is not None:
            bpy.data.images[wetmk].name = TexWetMK
            bpy.data.images[TexWetMK].filepath = fixlocate+TexWetMK
            bpy.data.images[TexWetMK].filepath_raw = fixlocate+TexWetMK
        f29 = bpimg(wetmp)
        if f29 is not None:
            bpy.data.images[wetmp].name = TexWetMP
            bpy.data.images[TexWetMP].filepath = fixlocate+TexWetMP
            bpy.data.images[TexWetMP].filepath_raw = fixlocate+TexWetMP
        f30 = bpimg(oc)
        if f30 is not None:
            bpy.data.images[oc].name = TexOC
            bpy.data.images[TexOC].filepath = fixlocate+TexOC
            bpy.data.images[TexOC].filepath_raw = fixlocate+TexOC
        bpy.ops.file.find_missing_files('INVOKE_DEFAULT')
        return {"FINISHED"}

    def invoke(self, context, event):
        return self.execute(context)


class SNA_OT_Hs2Socksmanual_85526(bpy.types.Operator):
    bl_idname = "sna.hs2socksmanual_85526"
    bl_label = "hs2-socks-manual"
    bl_description = ""
    bl_options = {"REGISTER", "UNDO"}

    @classmethod
    def poll(cls, context):
        return not False

    def execute(self, context):
        import os
        ########################################################################
        my_mat = bpy.context.object.material_slots[0].material
        print(my_mat.name)
        Tex=my_mat.name
        rem_mat = bpy.data.materials[Tex]
        #Get the node in its node tree (replace the name below)
        node_to_delete =  rem_mat.node_tree.nodes['Principled BSDF']
        node_to_delete2 =  rem_mat.node_tree.nodes['Material Output']
        #Remove it
        rem_mat.node_tree.nodes.remove(node_to_delete)
        rem_mat.node_tree.nodes.remove(node_to_delete2)
        #Tex = material.name
        TexMain = Tex+'_MainTex.png'
        TexDetailM = Tex+'_DetailMask.png'
        TexNormal = Tex+'_NormalMap.png'
        TexNDetail = Tex+'_NormalMapDetail.png'
        TexAlphaM = Tex+'_AlphaMask.png'
        TexAnotherR = Tex+'_AnotherRamp.png'
        TexLiquidM = Tex+'_liquidmask.png'
        TexTex2 = Tex+'_Texture2.png'
        TexTex3 = Tex+'_Texture3.png'
        TexOv1 = Tex+'_overtex1.png'
        TexOv2 = Tex+'_overtex2.png'
        TexLineM = Tex+'_LineMask.png'
        TexColorM = Tex+'_ColorMask.png'
        TexHairG = Tex+'_HairGloss.png'
        TexBump = Tex+'_BumpMap.png'
        TexDNM = Tex+'_DetailNormalMap.png'
        TexBNM = Tex+'_BlendNormalMap.png'
        TexSGM = Tex+'_SpecGlossMap.png'
        TexOM = Tex+'_OcclusionMap.png'
        TexTSS = Tex+'_Thickness.png'
        TexMGM = Tex+'_MetallicGlossMap.png'
        TexOV = Tex+'_OverTex.png'
        #hs2
        TexBump2 = Tex+'_BumpMap2.png'
        TexDMT = Tex+'_DetailMainTex.png'
        TexDGM = Tex+'_DetailGlossMap.png'
        TexDGM2 = Tex+'_DetailGlossMap2.png'
        TexNailM = Tex+'_NailMask.png'
        TexWetMK = Tex+'_WeatheringMask.png'
        TexWetMP = Tex+'_WeatheringMap.png'
        TexOC = Tex+'_Occlusion.png'
        originaltex = 'mat_socks_preset_'
        #originaltss = 'cf_m_body_01_'
        #kkp
        nm = originaltex+'NormalMap.png'
        nd = originaltex+'NormalMapDetail.png'
        dm = originaltex+'DetailMask.png'
        mm = originaltex+'MainTex.png'
        t3 = originaltex+'Texture3.png'
        t2 = originaltex+'Texture2.png'
        am = originaltex+'AlphaMask.png'
        lm = originaltex+'liquidmask.png'
        ar = originaltex+'AnotherRamp.png'
        ov1 = originaltex+'overtex1.png'
        ov2 = originaltex+'overtex2.png'
        lnm = originaltex+'LineMask.png'
        com = originaltex+'ColorMask.png'
        glo = originaltex+'HairGloss.png'
        #hs1
        bum = originaltex+'BumpMap.png'
        dnm = originaltex+'DetailNormalMap.png'
        bnm = originaltex+'BlendNormalMap.png'
        sgm = originaltex+'SpecGlossMap.png'
        om = originaltex+'OcclusionMap.png'
        tss = originaltex+'Thickness.png'
        mgm = originaltex+'MetallicGlossMap.png'
        ov = originaltex+'OverTex.png'
        #hs2
        bum2 = originaltex+'BumpMap2.png'
        dmt = originaltex+'DetailMainTex.png'
        dgm = originaltex+'DetailGlossMap.png'
        dgm2 = originaltex+'DetailGlossMap2.png'
        nail = originaltex+'NailMask.png'
        wetmk = originaltex+'WeatheringMask.png'
        wetmp = originaltex+'WeatheringMap.png'
        oc = originaltex+'Occlusion.png'
        Template='HS2-Template Socks'
        CTemplate=Template+' '
        C = bpy.context

        def instantiate_group(nodes, data_block_name):
            group = nodes.new(type='ShaderNodeGroup')
            group.node_tree = bpy.data.node_groups[Template]
            return group
        if Template in bpy.data.node_groups:
            instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
            bpy.context.object.active_material.blend_method = 'HASHED'
            bpy.context.object.active_material.shadow_method = 'HASHED'
        else:
        #    versions = ( t0, t1, t2, t3, t4)
        #    for x in versions:
        #        if os.path.isdir(x) and os.access(x, os.R_OK):
            if (3, 0, 0) <= bpy.app.version < (3, 0, 99):
                before_data = list(bpy.data.node_groups)
                bpy.ops.wm.append(directory=os.path.expanduser(r"~\AppData\Roaming\Blender Foundation\Blender\3.0\scripts\addons\sklx_creator\assets\HS2_Template_Shader.blend") + r'\NodeTree',filename=Template,link=False)
                new_data=list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
                appended_2B5AC = None if not new_data else new_data[0]
                instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
                bpy.context.object.active_material.blend_method = 'HASHED'
                bpy.context.object.active_material.shadow_method = 'HASHED'
            else:
                if (3, 1, 0) <= bpy.app.version < (3, 1, 99):
                    before_data = list(bpy.data.node_groups)
                    bpy.ops.wm.append(directory=os.path.expanduser(r"~\AppData\Roaming\Blender Foundation\Blender\3.1\scripts\addons\sklx_creator\assets\HS2_Template_Shader.blend") + r'\NodeTree',filename=Template,link=False)
                    new_data=list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
                    appended_2B5AC = None if not new_data else new_data[0]
                    instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
                    bpy.context.object.active_material.blend_method = 'HASHED'
                    bpy.context.object.active_material.shadow_method = 'HASHED'
                else:
                    if (3, 2, 0) <= bpy.app.version < (3, 2, 99):
                        before_data = list(bpy.data.node_groups)
                        bpy.ops.wm.append(directory=os.path.expanduser(r"~\AppData\Roaming\Blender Foundation\Blender\3.2\scripts\addons\sklx_creator\assets\HS2_Template_Shader.blend") + r'\NodeTree',filename=Template,link=False)
                        new_data=list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
                        appended_2B5AC = None if not new_data else new_data[0]
                        instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
                        bpy.context.object.active_material.blend_method = 'HASHED'
                        bpy.context.object.active_material.shadow_method = 'HASHED'
                    else:
                        if (3, 3, 0) <= bpy.app.version < (3, 3, 99):
                            before_data = list(bpy.data.node_groups)
                            bpy.ops.wm.append(directory=os.path.expanduser(r"~\AppData\Roaming\Blender Foundation\Blender\3.3\scripts\addons\sklx_creator\assets\HS2_Template_Shader.blend") + r'\NodeTree',filename=Template,link=False)
                            new_data=list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
                            appended_2B5AC = None if not new_data else new_data[0]
                            instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
                            bpy.context.object.active_material.blend_method = 'HASHED'
                            bpy.context.object.active_material.shadow_method = 'HASHED'
                        else:
                            if (3, 4, 0) <= bpy.app.version < (3, 4, 99):
                                before_data = list(bpy.data.node_groups)
                                bpy.ops.wm.append(directory=os.path.expanduser(r"~\AppData\Roaming\Blender Foundation\Blender\3.4\scripts\addons\sklx_creator\assets\HS2_Template_Shader.blend") + r'\NodeTree',filename=Template,link=False)
                                new_data=list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
                                appended_2B5AC = None if not new_data else new_data[0]
                                instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
                                bpy.context.object.active_material.blend_method = 'HASHED'
                                bpy.context.object.active_material.shadow_method = 'HASHED'
        bpy.data.node_groups[Template].name = CTemplate+Tex
        node = bpy.data.node_groups[CTemplate+Tex]
        #initial_area_type = bpy.context.area.type
        #bpy.context.area.type = 'NODE_EDITOR'
        #bpy.context.area.ui_type = 'ShaderNodeTree'
        #bpy.ops.node.group_ungroup()
        #bpy.context.area.type = initial_area_type
        nodes = my_mat.node_tree.nodes
        for node in nodes:
            #node.select = False
            print(node.name)
            node.select = True
            nodes.active = node
        try:
            initial_area_type = bpy.context.area.type
            bpy.context.area.type = 'NODE_EDITOR'
            bpy.context.area.ui_type = 'ShaderNodeTree'
            bpy.ops.wm.redraw_timer(type='DRAW_WIN', iterations=1)
            bpy.ops.node.group_ungroup()
            nonono = node," to Ungroup"
            print(nonono)
            bpy.ops.node.group_edit(exit=True)
        except Exception as e:
            print(e)
        finally:
            bpy.context.area.type = initial_area_type
        fixlocate = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\\20220603141428_Chika_Haruno\\Textures\\"
        bpimg = bpy.data.images.get
        if 1==1:
            print(mm)
            print(dm)
            print(nm)
            print(t2)
            print(t3)
        #formula_list=(nm,nd,dm,mm,t2,t3,am,lm,ar,ov1,ov2,lnm,com,glo,bum,dnm,bnm,sgm,om,tss,mgm,ov)
        #for formula in formula_list:
        #    if bpimg(formula) is not None:
        f1 = bpimg(mm)
        #for x in f1:
        if f1 is not None:
            bpy.data.images[mm].name = TexMain
            bpy.data.images[TexMain].filepath = fixlocate+TexMain
            bpy.data.images[TexMain].filepath_raw = fixlocate+TexMain
        f2 = bpimg(dm)
        #for x in f2:
        if f2 is not None:
            bpy.data.images[dm].name = TexDetailM
            bpy.data.images[TexDetailM].filepath = fixlocate+TexDetailM
            bpy.data.images[TexDetailM].filepath_raw = fixlocate+TexDetailM
        f3 = bpimg(nm)
        #for x in f3:
        if f3 is not None:
            bpy.data.images[nm].name = TexNormal
            bpy.data.images[TexNormal].filepath = fixlocate+TexNormal
            bpy.data.images[TexNormal].filepath_raw = fixlocate+TexNormal
        f4 = bpimg(t2)
        #for x in f3:
        if f4 is not None:
            bpy.data.images[t2].name = TexTex2
            bpy.data.images[TexTex2].filepath = fixlocate+TexTex2
            bpy.data.images[TexTex2].filepath_raw = fixlocate+TexTex2
        f5 = bpimg(t3)
        #for x in f4:
        if f5 is not None:
            bpy.data.images[t3].name = TexTex3
            bpy.data.images[TexTex3].filepath = fixlocate+TexTex3
            bpy.data.images[TexTex3].filepath_raw = fixlocate+TexTex3
        f6 = bpimg(am)
        #for x in f5:
        if f6 is not None:
            bpy.data.images[am].name = TexAlphaM
            bpy.data.images[TexAlphaM].filepath = fixlocate+TexAlphaM
            bpy.data.images[TexAlphaM].filepath_raw = fixlocate+TexAlphaM
        f7 = bpimg(lm)
        #for x in f6:
        if f7 is not None:
            bpy.data.images[lm].name = TexLiquidM
            bpy.data.images[TexLiquidM].filepath = fixlocate+TexLiquidM
            bpy.data.images[TexLiquidM].filepath_raw = fixlocate+TexLiquidM
        f8 = bpimg(ar)
        #for f8 in f8:
        if f8 is not None:
            bpy.data.images[ar].name = TexAnotherR
            bpy.data.images[TexAnotherR].filepath = fixlocate+TexAnotherR
            bpy.data.images[TexAnotherR].filepath_raw = fixlocate+TexAnotherR
        f9 = bpimg(nd)
        #for f8 in f8:
        if f9 is not None:
            bpy.data.images[nd].name = TexNDetail
            bpy.data.images[TexNDetail].filepath = fixlocate+TexNDetail
            bpy.data.images[TexNDetail].filepath_raw = fixlocate+TexNDetail
        f10 = bpimg(ov1)
        #for f8 in f8:
        if f10 is not None:
            bpy.data.images[ov1].name = TexOv1
            bpy.data.images[TexOv1].filepath = fixlocate+TexOv1
            bpy.data.images[TexOv1].filepath_raw = fixlocate+TexOv1
        f11 = bpimg(ov2)
        #for f8 in f8:
        if f11 is not None:
            bpy.data.images[ov2].name = TexOv2
            bpy.data.images[TexOv2].filepath = fixlocate+TexOv2
            bpy.data.images[TexOv2].filepath_raw = fixlocate+TexOv2
        f12 = bpimg(lnm)
        #for f8 in f8:
        if f12 is not None:
            bpy.data.images[lnm].name = TexLineM
            bpy.data.images[TexLineM].filepath = fixlocate+TexLineM
            bpy.data.images[TexLineM].filepath_raw = fixlocate+TexLineM
        f13 = bpimg(com)
        #for f8 in f8:
        if f13 is not None:
            bpy.data.images[com].name = TexColorM
            bpy.data.images[TexColorM].filepath = fixlocate+TexColorM
            bpy.data.images[TexColorM].filepath_raw = fixlocate+TexColorM
        f14 = bpimg(glo)
        #for f8 in f8:
        if f14 is not None:
            bpy.data.images[glo].name = TexHairG
            bpy.data.images[TexHairG].filepath = fixlocate+TexHairG
            bpy.data.images[TexHairG].filepath_raw = fixlocate+TexHairG
        f15 = bpimg(bum)
        #for f8 in f8:
        if f15 is not None:
            bpy.data.images[bum].name = TexBump
            bpy.data.images[TexBump].filepath = fixlocate+TexBump
            bpy.data.images[TexBump].filepath_raw = fixlocate+TexBump
        f16 = bpimg(dnm)
        #for f8 in f8:
        if f16 is not None:
            bpy.data.images[dnm].name = TexDNM
            bpy.data.images[TexDNM].filepath = fixlocate+TexDNM
            bpy.data.images[TexDNM].filepath_raw = fixlocate+TexDNM
        f17 = bpimg(bnm)
        #for f8 in f8:
        if f17 is not None:
            bpy.data.images[bnm].name = TexBNM
            bpy.data.images[TexBNM].filepath = fixlocate+TexBNM
            bpy.data.images[TexBNM].filepath_raw = fixlocate+TexBNM
        f18 = bpimg(sgm)
        #for f8 in f8:
        if f18 is not None:
            bpy.data.images[sgm].name = TexSGM
            bpy.data.images[TexSGM].filepath = fixlocate+TexSGM
            bpy.data.images[TexSGM].filepath_raw = fixlocate+TexSGM
        f19 = bpimg(om)
        #for f8 in f8:
        if f19 is not None:
            bpy.data.images[om].name = TexOM
            bpy.data.images[TexOM].filepath = fixlocate+TexOM
            bpy.data.images[TexOM].filepath_raw = fixlocate+TexOM
        f20 = bpimg(tss)
        #for f8 in f8:
        if f20 is not None:
            bpy.data.images[tss].name = TexTSS
            bpy.data.images[TexTSS].filepath = fixlocate+TexTSS
            bpy.data.images[TexTSS].filepath_raw = fixlocate+TexTSS
        f21 = bpimg(mgm)
        #for f8 in f8:
        if f21 is not None:
            bpy.data.images[mgm].name = TexMGM
            bpy.data.images[TexMGM].filepath = fixlocate+TexMGM
            bpy.data.images[TexMGM].filepath_raw = fixlocate+TexMGM
        f22 = bpimg(ov)
        #for f8 in f8:
        if f22 is not None:
            bpy.data.images[ov].name = TexOV
            bpy.data.images[TexOV].filepath = fixlocate+TexOV
            bpy.data.images[TexOV].filepath_raw = fixlocate+TexOV
        f23 = bpimg(bum2)
        #for f8 in f8:
        if f23 is not None:
            bpy.data.images[bum2].name = TexBump2
            bpy.data.images[TexBump2].filepath = fixlocate+TexBump2
            bpy.data.images[TexBump2].filepath_raw = fixlocate+TexBump2
        f24 = bpimg(dmt)
        if f24 is not None:
            bpy.data.images[dmt].name = TexDMT
            bpy.data.images[TexDMT].filepath = fixlocate+TexDMT
            bpy.data.images[TexDMT].filepath_raw = fixlocate+TexDMT
        f25 = bpimg(dgm)
        if f25 is not None:
            bpy.data.images[dgm].name = TexDGM
            bpy.data.images[TexDGM].filepath = fixlocate+TexDGM
            bpy.data.images[TexDGM].filepath_raw = fixlocate+TexDGM
        f26 = bpimg(dgm2)
        if f26 is not None:
            bpy.data.images[dgm2].name = TexDGM2
            bpy.data.images[TexDGM2].filepath = fixlocate+TexDGM2
            bpy.data.images[TexDGM2].filepath_raw = fixlocate+TexDGM2
        f27 = bpimg(nail)
        if f27 is not None:
            bpy.data.images[nail].name = TexNailM
            bpy.data.images[TexNailM].filepath = fixlocate+TexNailM
            bpy.data.images[TexNailM].filepath_raw = fixlocate+TexNailM
        f28 = bpimg(wetmk)
        if f28 is not None:
            bpy.data.images[wetmk].name = TexWetMK
            bpy.data.images[TexWetMK].filepath = fixlocate+TexWetMK
            bpy.data.images[TexWetMK].filepath_raw = fixlocate+TexWetMK
        f29 = bpimg(wetmp)
        if f29 is not None:
            bpy.data.images[wetmp].name = TexWetMP
            bpy.data.images[TexWetMP].filepath = fixlocate+TexWetMP
            bpy.data.images[TexWetMP].filepath_raw = fixlocate+TexWetMP
        f30 = bpimg(oc)
        if f30 is not None:
            bpy.data.images[oc].name = TexOC
            bpy.data.images[TexOC].filepath = fixlocate+TexOC
            bpy.data.images[TexOC].filepath_raw = fixlocate+TexOC
        bpy.ops.file.find_missing_files('INVOKE_DEFAULT')
        return {"FINISHED"}

    def invoke(self, context, event):
        return self.execute(context)


class SNA_OT_Hs2Shoesmanual_8B32C(bpy.types.Operator):
    bl_idname = "sna.hs2shoesmanual_8b32c"
    bl_label = "hs2-shoes-manual"
    bl_description = ""
    bl_options = {"REGISTER", "UNDO"}

    @classmethod
    def poll(cls, context):
        return not False

    def execute(self, context):
        import os
        ########################################################################
        my_mat = bpy.context.object.material_slots[0].material
        print(my_mat.name)
        Tex=my_mat.name
        rem_mat = bpy.data.materials[Tex]
        #Get the node in its node tree (replace the name below)
        node_to_delete =  rem_mat.node_tree.nodes['Principled BSDF']
        node_to_delete2 =  rem_mat.node_tree.nodes['Material Output']
        #Remove it
        rem_mat.node_tree.nodes.remove(node_to_delete)
        rem_mat.node_tree.nodes.remove(node_to_delete2)
        #Tex = material.name
        TexMain = Tex+'_MainTex.png'
        TexDetailM = Tex+'_DetailMask.png'
        TexNormal = Tex+'_NormalMap.png'
        TexNDetail = Tex+'_NormalMapDetail.png'
        TexAlphaM = Tex+'_AlphaMask.png'
        TexAnotherR = Tex+'_AnotherRamp.png'
        TexLiquidM = Tex+'_liquidmask.png'
        TexTex2 = Tex+'_Texture2.png'
        TexTex3 = Tex+'_Texture3.png'
        TexOv1 = Tex+'_overtex1.png'
        TexOv2 = Tex+'_overtex2.png'
        TexLineM = Tex+'_LineMask.png'
        TexColorM = Tex+'_ColorMask.png'
        TexHairG = Tex+'_HairGloss.png'
        TexBump = Tex+'_BumpMap.png'
        TexDNM = Tex+'_DetailNormalMap.png'
        TexBNM = Tex+'_BlendNormalMap.png'
        TexSGM = Tex+'_SpecGlossMap.png'
        TexOM = Tex+'_OcclusionMap.png'
        TexTSS = Tex+'_Thickness.png'
        TexMGM = Tex+'_MetallicGlossMap.png'
        TexOV = Tex+'_OverTex.png'
        #hs2
        TexBump2 = Tex+'_BumpMap2.png'
        TexDMT = Tex+'_DetailMainTex.png'
        TexDGM = Tex+'_DetailGlossMap.png'
        TexDGM2 = Tex+'_DetailGlossMap2.png'
        TexNailM = Tex+'_NailMask.png'
        TexWetMK = Tex+'_WeatheringMask.png'
        TexWetMP = Tex+'_WeatheringMap.png'
        TexOC = Tex+'_Occlusion.png'
        originaltex = 'mat_shoes_preset_'
        #originaltss = 'cf_m_body_01_'
        #kkp
        nm = originaltex+'NormalMap.png'
        nd = originaltex+'NormalMapDetail.png'
        dm = originaltex+'DetailMask.png'
        mm = originaltex+'MainTex.png'
        t3 = originaltex+'Texture3.png'
        t2 = originaltex+'Texture2.png'
        am = originaltex+'AlphaMask.png'
        lm = originaltex+'liquidmask.png'
        ar = originaltex+'AnotherRamp.png'
        ov1 = originaltex+'overtex1.png'
        ov2 = originaltex+'overtex2.png'
        lnm = originaltex+'LineMask.png'
        com = originaltex+'ColorMask.png'
        glo = originaltex+'HairGloss.png'
        #hs1
        bum = originaltex+'BumpMap.png'
        dnm = originaltex+'DetailNormalMap.png'
        bnm = originaltex+'BlendNormalMap.png'
        sgm = originaltex+'SpecGlossMap.png'
        om = originaltex+'OcclusionMap.png'
        tss = originaltex+'Thickness.png'
        mgm = originaltex+'MetallicGlossMap.png'
        ov = originaltex+'OverTex.png'
        #hs2
        bum2 = originaltex+'BumpMap2.png'
        dmt = originaltex+'DetailMainTex.png'
        dgm = originaltex+'DetailGlossMap.png'
        dgm2 = originaltex+'DetailGlossMap2.png'
        nail = originaltex+'NailMask.png'
        wetmk = originaltex+'WeatheringMask.png'
        wetmp = originaltex+'WeatheringMap.png'
        oc = originaltex+'Occlusion.png'
        Template='HS2-Template Shoes'
        CTemplate=Template+' '
        C = bpy.context

        def instantiate_group(nodes, data_block_name):
            group = nodes.new(type='ShaderNodeGroup')
            group.node_tree = bpy.data.node_groups[Template]
            return group
        if Template in bpy.data.node_groups:
            instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
        else:
        #    versions = ( t0, t1, t2, t3, t4)
        #    for x in versions:
        #        if os.path.isdir(x) and os.access(x, os.R_OK):
            if (3, 0, 0) <= bpy.app.version < (3, 0, 99):
                before_data = list(bpy.data.node_groups)
                bpy.ops.wm.append(directory=os.path.expanduser(r"~\AppData\Roaming\Blender Foundation\Blender\3.0\scripts\addons\sklx_creator\assets\HS2_Template_Shader.blend") + r'\NodeTree',filename=Template,link=False)
                new_data=list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
                appended_2B5AC = None if not new_data else new_data[0]
                instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
            else:
                if (3, 1, 0) <= bpy.app.version < (3, 1, 99):
                    before_data = list(bpy.data.node_groups)
                    bpy.ops.wm.append(directory=os.path.expanduser(r"~\AppData\Roaming\Blender Foundation\Blender\3.1\scripts\addons\sklx_creator\assets\HS2_Template_Shader.blend") + r'\NodeTree',filename=Template,link=False)
                    new_data=list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
                    appended_2B5AC = None if not new_data else new_data[0]
                    instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
                else:
                    if (3, 2, 0) <= bpy.app.version < (3, 2, 99):
                        before_data = list(bpy.data.node_groups)
                        bpy.ops.wm.append(directory=os.path.expanduser(r"~\AppData\Roaming\Blender Foundation\Blender\3.2\scripts\addons\sklx_creator\assets\HS2_Template_Shader.blend") + r'\NodeTree',filename=Template,link=False)
                        new_data=list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
                        appended_2B5AC = None if not new_data else new_data[0]
                        instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
                    else:
                        if (3, 3, 0) <= bpy.app.version < (3, 3, 99):
                            before_data = list(bpy.data.node_groups)
                            bpy.ops.wm.append(directory=os.path.expanduser(r"~\AppData\Roaming\Blender Foundation\Blender\3.3\scripts\addons\sklx_creator\assets\HS2_Template_Shader.blend") + r'\NodeTree',filename=Template,link=False)
                            new_data=list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
                            appended_2B5AC = None if not new_data else new_data[0]
                            instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
                        else:
                            if (3, 4, 0) <= bpy.app.version < (3, 4, 99):
                                before_data = list(bpy.data.node_groups)
                                bpy.ops.wm.append(directory=os.path.expanduser(r"~\AppData\Roaming\Blender Foundation\Blender\3.4\scripts\addons\sklx_creator\assets\HS2_Template_Shader.blend") + r'\NodeTree',filename=Template,link=False)
                                new_data=list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
                                appended_2B5AC = None if not new_data else new_data[0]
                                instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
        bpy.data.node_groups[Template].name = CTemplate+Tex
        node = bpy.data.node_groups[CTemplate+Tex]
        #initial_area_type = bpy.context.area.type
        #bpy.context.area.type = 'NODE_EDITOR'
        #bpy.context.area.ui_type = 'ShaderNodeTree'
        #bpy.ops.node.group_ungroup()
        #bpy.context.area.type = initial_area_type
        nodes = my_mat.node_tree.nodes
        for node in nodes:
            #node.select = False
            print(node.name)
            node.select = True
            nodes.active = node
        try:
            initial_area_type = bpy.context.area.type
            bpy.context.area.type = 'NODE_EDITOR'
            bpy.context.area.ui_type = 'ShaderNodeTree'
            bpy.ops.wm.redraw_timer(type='DRAW_WIN', iterations=1)
            bpy.ops.node.group_ungroup()
            nonono = node," to Ungroup"
            print(nonono)
            bpy.ops.node.group_edit(exit=True)
        except Exception as e:
            print(e)
        finally:
            bpy.context.area.type = initial_area_type
        fixlocate = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\\20220603141428_Chika_Haruno\\Textures\\"
        bpimg = bpy.data.images.get
        if 1==1:
            print(mm)
            print(dm)
            print(nm)
            print(t2)
            print(t3)
        #formula_list=(nm,nd,dm,mm,t2,t3,am,lm,ar,ov1,ov2,lnm,com,glo,bum,dnm,bnm,sgm,om,tss,mgm,ov)
        #for formula in formula_list:
        #    if bpimg(formula) is not None:
        f1 = bpimg(mm)
        #for x in f1:
        if f1 is not None:
            bpy.data.images[mm].name = TexMain
            bpy.data.images[TexMain].filepath = fixlocate+TexMain
            bpy.data.images[TexMain].filepath_raw = fixlocate+TexMain
        f2 = bpimg(dm)
        #for x in f2:
        if f2 is not None:
            bpy.data.images[dm].name = TexDetailM
            bpy.data.images[TexDetailM].filepath = fixlocate+TexDetailM
            bpy.data.images[TexDetailM].filepath_raw = fixlocate+TexDetailM
        f3 = bpimg(nm)
        #for x in f3:
        if f3 is not None:
            bpy.data.images[nm].name = TexNormal
            bpy.data.images[TexNormal].filepath = fixlocate+TexNormal
            bpy.data.images[TexNormal].filepath_raw = fixlocate+TexNormal
        f4 = bpimg(t2)
        #for x in f3:
        if f4 is not None:
            bpy.data.images[t2].name = TexTex2
            bpy.data.images[TexTex2].filepath = fixlocate+TexTex2
            bpy.data.images[TexTex2].filepath_raw = fixlocate+TexTex2
        f5 = bpimg(t3)
        #for x in f4:
        if f5 is not None:
            bpy.data.images[t3].name = TexTex3
            bpy.data.images[TexTex3].filepath = fixlocate+TexTex3
            bpy.data.images[TexTex3].filepath_raw = fixlocate+TexTex3
        f6 = bpimg(am)
        #for x in f5:
        if f6 is not None:
            bpy.data.images[am].name = TexAlphaM
            bpy.data.images[TexAlphaM].filepath = fixlocate+TexAlphaM
            bpy.data.images[TexAlphaM].filepath_raw = fixlocate+TexAlphaM
        f7 = bpimg(lm)
        #for x in f6:
        if f7 is not None:
            bpy.data.images[lm].name = TexLiquidM
            bpy.data.images[TexLiquidM].filepath = fixlocate+TexLiquidM
            bpy.data.images[TexLiquidM].filepath_raw = fixlocate+TexLiquidM
        f8 = bpimg(ar)
        #for f8 in f8:
        if f8 is not None:
            bpy.data.images[ar].name = TexAnotherR
            bpy.data.images[TexAnotherR].filepath = fixlocate+TexAnotherR
            bpy.data.images[TexAnotherR].filepath_raw = fixlocate+TexAnotherR
        f9 = bpimg(nd)
        #for f8 in f8:
        if f9 is not None:
            bpy.data.images[nd].name = TexNDetail
            bpy.data.images[TexNDetail].filepath = fixlocate+TexNDetail
            bpy.data.images[TexNDetail].filepath_raw = fixlocate+TexNDetail
        f10 = bpimg(ov1)
        #for f8 in f8:
        if f10 is not None:
            bpy.data.images[ov1].name = TexOv1
            bpy.data.images[TexOv1].filepath = fixlocate+TexOv1
            bpy.data.images[TexOv1].filepath_raw = fixlocate+TexOv1
        f11 = bpimg(ov2)
        #for f8 in f8:
        if f11 is not None:
            bpy.data.images[ov2].name = TexOv2
            bpy.data.images[TexOv2].filepath = fixlocate+TexOv2
            bpy.data.images[TexOv2].filepath_raw = fixlocate+TexOv2
        f12 = bpimg(lnm)
        #for f8 in f8:
        if f12 is not None:
            bpy.data.images[lnm].name = TexLineM
            bpy.data.images[TexLineM].filepath = fixlocate+TexLineM
            bpy.data.images[TexLineM].filepath_raw = fixlocate+TexLineM
        f13 = bpimg(com)
        #for f8 in f8:
        if f13 is not None:
            bpy.data.images[com].name = TexColorM
            bpy.data.images[TexColorM].filepath = fixlocate+TexColorM
            bpy.data.images[TexColorM].filepath_raw = fixlocate+TexColorM
        f14 = bpimg(glo)
        #for f8 in f8:
        if f14 is not None:
            bpy.data.images[glo].name = TexHairG
            bpy.data.images[TexHairG].filepath = fixlocate+TexHairG
            bpy.data.images[TexHairG].filepath_raw = fixlocate+TexHairG
        f15 = bpimg(bum)
        #for f8 in f8:
        if f15 is not None:
            bpy.data.images[bum].name = TexBump
            bpy.data.images[TexBump].filepath = fixlocate+TexBump
            bpy.data.images[TexBump].filepath_raw = fixlocate+TexBump
        f16 = bpimg(dnm)
        #for f8 in f8:
        if f16 is not None:
            bpy.data.images[dnm].name = TexDNM
            bpy.data.images[TexDNM].filepath = fixlocate+TexDNM
            bpy.data.images[TexDNM].filepath_raw = fixlocate+TexDNM
        f17 = bpimg(bnm)
        #for f8 in f8:
        if f17 is not None:
            bpy.data.images[bnm].name = TexBNM
            bpy.data.images[TexBNM].filepath = fixlocate+TexBNM
            bpy.data.images[TexBNM].filepath_raw = fixlocate+TexBNM
        f18 = bpimg(sgm)
        #for f8 in f8:
        if f18 is not None:
            bpy.data.images[sgm].name = TexSGM
            bpy.data.images[TexSGM].filepath = fixlocate+TexSGM
            bpy.data.images[TexSGM].filepath_raw = fixlocate+TexSGM
        f19 = bpimg(om)
        #for f8 in f8:
        if f19 is not None:
            bpy.data.images[om].name = TexOM
            bpy.data.images[TexOM].filepath = fixlocate+TexOM
            bpy.data.images[TexOM].filepath_raw = fixlocate+TexOM
        f20 = bpimg(tss)
        #for f8 in f8:
        if f20 is not None:
            bpy.data.images[tss].name = TexTSS
            bpy.data.images[TexTSS].filepath = fixlocate+TexTSS
            bpy.data.images[TexTSS].filepath_raw = fixlocate+TexTSS
        f21 = bpimg(mgm)
        #for f8 in f8:
        if f21 is not None:
            bpy.data.images[mgm].name = TexMGM
            bpy.data.images[TexMGM].filepath = fixlocate+TexMGM
            bpy.data.images[TexMGM].filepath_raw = fixlocate+TexMGM
        f22 = bpimg(ov)
        #for f8 in f8:
        if f22 is not None:
            bpy.data.images[ov].name = TexOV
            bpy.data.images[TexOV].filepath = fixlocate+TexOV
            bpy.data.images[TexOV].filepath_raw = fixlocate+TexOV
        f23 = bpimg(bum2)
        #for f8 in f8:
        if f23 is not None:
            bpy.data.images[bum2].name = TexBump2
            bpy.data.images[TexBump2].filepath = fixlocate+TexBump2
            bpy.data.images[TexBump2].filepath_raw = fixlocate+TexBump2
        f24 = bpimg(dmt)
        if f24 is not None:
            bpy.data.images[dmt].name = TexDMT
            bpy.data.images[TexDMT].filepath = fixlocate+TexDMT
            bpy.data.images[TexDMT].filepath_raw = fixlocate+TexDMT
        f25 = bpimg(dgm)
        if f25 is not None:
            bpy.data.images[dgm].name = TexDGM
            bpy.data.images[TexDGM].filepath = fixlocate+TexDGM
            bpy.data.images[TexDGM].filepath_raw = fixlocate+TexDGM
        f26 = bpimg(dgm2)
        if f26 is not None:
            bpy.data.images[dgm2].name = TexDGM2
            bpy.data.images[TexDGM2].filepath = fixlocate+TexDGM2
            bpy.data.images[TexDGM2].filepath_raw = fixlocate+TexDGM2
        f27 = bpimg(nail)
        if f27 is not None:
            bpy.data.images[nail].name = TexNailM
            bpy.data.images[TexNailM].filepath = fixlocate+TexNailM
            bpy.data.images[TexNailM].filepath_raw = fixlocate+TexNailM
        f28 = bpimg(wetmk)
        if f28 is not None:
            bpy.data.images[wetmk].name = TexWetMK
            bpy.data.images[TexWetMK].filepath = fixlocate+TexWetMK
            bpy.data.images[TexWetMK].filepath_raw = fixlocate+TexWetMK
        f29 = bpimg(wetmp)
        if f29 is not None:
            bpy.data.images[wetmp].name = TexWetMP
            bpy.data.images[TexWetMP].filepath = fixlocate+TexWetMP
            bpy.data.images[TexWetMP].filepath_raw = fixlocate+TexWetMP
        f30 = bpimg(oc)
        if f30 is not None:
            bpy.data.images[oc].name = TexOC
            bpy.data.images[TexOC].filepath = fixlocate+TexOC
            bpy.data.images[TexOC].filepath_raw = fixlocate+TexOC
        bpy.ops.file.find_missing_files('INVOKE_DEFAULT')
        return {"FINISHED"}

    def invoke(self, context, event):
        return self.execute(context)


class SNA_OT_Hs2Accsmanual_07554(bpy.types.Operator):
    bl_idname = "sna.hs2accsmanual_07554"
    bl_label = "hs2-accs-manual"
    bl_description = ""
    bl_options = {"REGISTER", "UNDO"}

    @classmethod
    def poll(cls, context):
        return not False

    def execute(self, context):
        return {"FINISHED"}

    def invoke(self, context, event):
        return self.execute(context)


class SNA_OT_Hs2Simplemanual_425F7(bpy.types.Operator):
    bl_idname = "sna.hs2simplemanual_425f7"
    bl_label = "hs2-simple-manual"
    bl_description = ""
    bl_options = {"REGISTER", "UNDO"}

    @classmethod
    def poll(cls, context):
        return not False

    def execute(self, context):
        return {"FINISHED"}

    def invoke(self, context, event):
        return self.execute(context)


class SNA_OT_Hs2Bramanual_129Df(bpy.types.Operator):
    bl_idname = "sna.hs2bramanual_129df"
    bl_label = "hs2-bra-manual"
    bl_description = ""
    bl_options = {"REGISTER", "UNDO"}

    @classmethod
    def poll(cls, context):
        return not False

    def execute(self, context):
        import os
        ########################################################################
        my_mat = bpy.context.object.material_slots[0].material
        print(my_mat.name)
        Tex=my_mat.name
        rem_mat = bpy.data.materials[Tex]
        #Get the node in its node tree (replace the name below)
        node_to_delete =  rem_mat.node_tree.nodes['Principled BSDF']
        node_to_delete2 =  rem_mat.node_tree.nodes['Material Output']
        #Remove it
        rem_mat.node_tree.nodes.remove(node_to_delete)
        rem_mat.node_tree.nodes.remove(node_to_delete2)
        #Tex = material.name
        TexMain = Tex+'_MainTex.png'
        TexDetailM = Tex+'_DetailMask.png'
        TexNormal = Tex+'_NormalMap.png'
        TexNDetail = Tex+'_NormalMapDetail.png'
        TexAlphaM = Tex+'_AlphaMask.png'
        TexAnotherR = Tex+'_AnotherRamp.png'
        TexLiquidM = Tex+'_liquidmask.png'
        TexTex2 = Tex+'_Texture2.png'
        TexTex3 = Tex+'_Texture3.png'
        TexOv1 = Tex+'_overtex1.png'
        TexOv2 = Tex+'_overtex2.png'
        TexLineM = Tex+'_LineMask.png'
        TexColorM = Tex+'_ColorMask.png'
        TexHairG = Tex+'_HairGloss.png'
        TexBump = Tex+'_BumpMap.png'
        TexDNM = Tex+'_DetailNormalMap.png'
        TexBNM = Tex+'_BlendNormalMap.png'
        TexSGM = Tex+'_SpecGlossMap.png'
        TexOM = Tex+'_OcclusionMap.png'
        TexTSS = Tex+'_Thickness.png'
        TexMGM = Tex+'_MetallicGlossMap.png'
        TexOV = Tex+'_OverTex.png'
        #hs2
        TexBump2 = Tex+'_BumpMap2.png'
        TexDMT = Tex+'_DetailMainTex.png'
        TexDGM = Tex+'_DetailGlossMap.png'
        TexDGM2 = Tex+'_DetailGlossMap2.png'
        TexNailM = Tex+'_NailMask.png'
        TexWetMK = Tex+'_WeatheringMask.png'
        TexWetMP = Tex+'_WeatheringMap.png'
        TexOC = Tex+'_Occlusion.png'
        originaltex = 'mat_bra_preset_'
        #originaltss = 'cf_m_body_01_'
        #kkp
        nm = originaltex+'NormalMap.png'
        nd = originaltex+'NormalMapDetail.png'
        dm = originaltex+'DetailMask.png'
        mm = originaltex+'MainTex.png'
        t3 = originaltex+'Texture3.png'
        t2 = originaltex+'Texture2.png'
        am = originaltex+'AlphaMask.png'
        lm = originaltex+'liquidmask.png'
        ar = originaltex+'AnotherRamp.png'
        ov1 = originaltex+'overtex1.png'
        ov2 = originaltex+'overtex2.png'
        lnm = originaltex+'LineMask.png'
        com = originaltex+'ColorMask.png'
        glo = originaltex+'HairGloss.png'
        #hs1
        bum = originaltex+'BumpMap.png'
        dnm = originaltex+'DetailNormalMap.png'
        bnm = originaltex+'BlendNormalMap.png'
        sgm = originaltex+'SpecGlossMap.png'
        om = originaltex+'OcclusionMap.png'
        tss = originaltex+'Thickness.png'
        mgm = originaltex+'MetallicGlossMap.png'
        ov = originaltex+'OverTex.png'
        #hs2
        bum2 = originaltex+'BumpMap2.png'
        dmt = originaltex+'DetailMainTex.png'
        dgm = originaltex+'DetailGlossMap.png'
        dgm2 = originaltex+'DetailGlossMap2.png'
        nail = originaltex+'NailMask.png'
        wetmk = originaltex+'WeatheringMask.png'
        wetmp = originaltex+'WeatheringMap.png'
        oc = originaltex+'Occlusion.png'
        Template='HS2-Template Bra'
        CTemplate=Template+' '
        C = bpy.context

        def instantiate_group(nodes, data_block_name):
            group = nodes.new(type='ShaderNodeGroup')
            group.node_tree = bpy.data.node_groups[Template]
            return group
        if Template in bpy.data.node_groups:
            instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
            bpy.context.object.active_material.blend_method = 'HASHED'
            bpy.context.object.active_material.shadow_method = 'HASHED'
        else:
        #    versions = ( t0, t1, t2, t3, t4)
        #    for x in versions:
        #        if os.path.isdir(x) and os.access(x, os.R_OK):
            if (3, 0, 0) <= bpy.app.version < (3, 0, 99):
                before_data = list(bpy.data.node_groups)
                bpy.ops.wm.append(directory=os.path.expanduser(r"~\AppData\Roaming\Blender Foundation\Blender\3.0\scripts\addons\sklx_creator\assets\HS2_Template_Shader.blend") + r'\NodeTree',filename=Template,link=False)
                new_data=list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
                appended_2B5AC = None if not new_data else new_data[0]
                instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
                bpy.context.object.active_material.blend_method = 'HASHED'
                bpy.context.object.active_material.shadow_method = 'HASHED'
            else:
                if (3, 1, 0) <= bpy.app.version < (3, 1, 99):
                    before_data = list(bpy.data.node_groups)
                    bpy.ops.wm.append(directory=os.path.expanduser(r"~\AppData\Roaming\Blender Foundation\Blender\3.1\scripts\addons\sklx_creator\assets\HS2_Template_Shader.blend") + r'\NodeTree',filename=Template,link=False)
                    new_data=list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
                    appended_2B5AC = None if not new_data else new_data[0]
                    instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
                    bpy.context.object.active_material.blend_method = 'HASHED'
                    bpy.context.object.active_material.shadow_method = 'HASHED'
                else:
                    if (3, 2, 0) <= bpy.app.version < (3, 2, 99):
                        before_data = list(bpy.data.node_groups)
                        bpy.ops.wm.append(directory=os.path.expanduser(r"~\AppData\Roaming\Blender Foundation\Blender\3.2\scripts\addons\sklx_creator\assets\HS2_Template_Shader.blend") + r'\NodeTree',filename=Template,link=False)
                        new_data=list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
                        appended_2B5AC = None if not new_data else new_data[0]
                        instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
                        bpy.context.object.active_material.blend_method = 'HASHED'
                        bpy.context.object.active_material.shadow_method = 'HASHED'
                    else:
                        if (3, 3, 0) <= bpy.app.version < (3, 3, 99):
                            before_data = list(bpy.data.node_groups)
                            bpy.ops.wm.append(directory=os.path.expanduser(r"~\AppData\Roaming\Blender Foundation\Blender\3.3\scripts\addons\sklx_creator\assets\HS2_Template_Shader.blend") + r'\NodeTree',filename=Template,link=False)
                            new_data=list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
                            appended_2B5AC = None if not new_data else new_data[0]
                            instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
                            bpy.context.object.active_material.blend_method = 'HASHED'
                            bpy.context.object.active_material.shadow_method = 'HASHED'
                        else:
                            if (3, 4, 0) <= bpy.app.version < (3, 4, 99):
                                before_data = list(bpy.data.node_groups)
                                bpy.ops.wm.append(directory=os.path.expanduser(r"~\AppData\Roaming\Blender Foundation\Blender\3.4\scripts\addons\sklx_creator\assets\HS2_Template_Shader.blend") + r'\NodeTree',filename=Template,link=False)
                                new_data=list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
                                appended_2B5AC = None if not new_data else new_data[0]
                                instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
                                bpy.context.object.active_material.blend_method = 'HASHED'
                                bpy.context.object.active_material.shadow_method = 'HASHED'
        bpy.data.node_groups[Template].name = CTemplate+Tex
        node = bpy.data.node_groups[CTemplate+Tex]
        #initial_area_type = bpy.context.area.type
        #bpy.context.area.type = 'NODE_EDITOR'
        #bpy.context.area.ui_type = 'ShaderNodeTree'
        #bpy.ops.node.group_ungroup()
        #bpy.context.area.type = initial_area_type
        nodes = my_mat.node_tree.nodes
        for node in nodes:
            #node.select = False
            print(node.name)
            node.select = True
            nodes.active = node
        try:
            initial_area_type = bpy.context.area.type
            bpy.context.area.type = 'NODE_EDITOR'
            bpy.context.area.ui_type = 'ShaderNodeTree'
            bpy.ops.wm.redraw_timer(type='DRAW_WIN', iterations=1)
            bpy.ops.node.group_ungroup()
            nonono = node," to Ungroup"
            print(nonono)
            bpy.ops.node.group_edit(exit=True)
        except Exception as e:
            print(e)
        finally:
            bpy.context.area.type = initial_area_type
        fixlocate = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\\20220603141428_Chika_Haruno\\Textures\\"
        bpimg = bpy.data.images.get
        if 1==1:
            print(mm)
            print(dm)
            print(nm)
            print(t2)
            print(t3)
        #formula_list=(nm,nd,dm,mm,t2,t3,am,lm,ar,ov1,ov2,lnm,com,glo,bum,dnm,bnm,sgm,om,tss,mgm,ov)
        #for formula in formula_list:
        #    if bpimg(formula) is not None:
        f1 = bpimg(mm)
        #for x in f1:
        if f1 is not None:
            bpy.data.images[mm].name = TexMain
            bpy.data.images[TexMain].filepath = fixlocate+TexMain
            bpy.data.images[TexMain].filepath_raw = fixlocate+TexMain
        f2 = bpimg(dm)
        #for x in f2:
        if f2 is not None:
            bpy.data.images[dm].name = TexDetailM
            bpy.data.images[TexDetailM].filepath = fixlocate+TexDetailM
            bpy.data.images[TexDetailM].filepath_raw = fixlocate+TexDetailM
        f3 = bpimg(nm)
        #for x in f3:
        if f3 is not None:
            bpy.data.images[nm].name = TexNormal
            bpy.data.images[TexNormal].filepath = fixlocate+TexNormal
            bpy.data.images[TexNormal].filepath_raw = fixlocate+TexNormal
        f4 = bpimg(t2)
        #for x in f3:
        if f4 is not None:
            bpy.data.images[t2].name = TexTex2
            bpy.data.images[TexTex2].filepath = fixlocate+TexTex2
            bpy.data.images[TexTex2].filepath_raw = fixlocate+TexTex2
        f5 = bpimg(t3)
        #for x in f4:
        if f5 is not None:
            bpy.data.images[t3].name = TexTex3
            bpy.data.images[TexTex3].filepath = fixlocate+TexTex3
            bpy.data.images[TexTex3].filepath_raw = fixlocate+TexTex3
        f6 = bpimg(am)
        #for x in f5:
        if f6 is not None:
            bpy.data.images[am].name = TexAlphaM
            bpy.data.images[TexAlphaM].filepath = fixlocate+TexAlphaM
            bpy.data.images[TexAlphaM].filepath_raw = fixlocate+TexAlphaM
        f7 = bpimg(lm)
        #for x in f6:
        if f7 is not None:
            bpy.data.images[lm].name = TexLiquidM
            bpy.data.images[TexLiquidM].filepath = fixlocate+TexLiquidM
            bpy.data.images[TexLiquidM].filepath_raw = fixlocate+TexLiquidM
        f8 = bpimg(ar)
        #for f8 in f8:
        if f8 is not None:
            bpy.data.images[ar].name = TexAnotherR
            bpy.data.images[TexAnotherR].filepath = fixlocate+TexAnotherR
            bpy.data.images[TexAnotherR].filepath_raw = fixlocate+TexAnotherR
        f9 = bpimg(nd)
        #for f8 in f8:
        if f9 is not None:
            bpy.data.images[nd].name = TexNDetail
            bpy.data.images[TexNDetail].filepath = fixlocate+TexNDetail
            bpy.data.images[TexNDetail].filepath_raw = fixlocate+TexNDetail
        f10 = bpimg(ov1)
        #for f8 in f8:
        if f10 is not None:
            bpy.data.images[ov1].name = TexOv1
            bpy.data.images[TexOv1].filepath = fixlocate+TexOv1
            bpy.data.images[TexOv1].filepath_raw = fixlocate+TexOv1
        f11 = bpimg(ov2)
        #for f8 in f8:
        if f11 is not None:
            bpy.data.images[ov2].name = TexOv2
            bpy.data.images[TexOv2].filepath = fixlocate+TexOv2
            bpy.data.images[TexOv2].filepath_raw = fixlocate+TexOv2
        f12 = bpimg(lnm)
        #for f8 in f8:
        if f12 is not None:
            bpy.data.images[lnm].name = TexLineM
            bpy.data.images[TexLineM].filepath = fixlocate+TexLineM
            bpy.data.images[TexLineM].filepath_raw = fixlocate+TexLineM
        f13 = bpimg(com)
        #for f8 in f8:
        if f13 is not None:
            bpy.data.images[com].name = TexColorM
            bpy.data.images[TexColorM].filepath = fixlocate+TexColorM
            bpy.data.images[TexColorM].filepath_raw = fixlocate+TexColorM
        f14 = bpimg(glo)
        #for f8 in f8:
        if f14 is not None:
            bpy.data.images[glo].name = TexHairG
            bpy.data.images[TexHairG].filepath = fixlocate+TexHairG
            bpy.data.images[TexHairG].filepath_raw = fixlocate+TexHairG
        f15 = bpimg(bum)
        #for f8 in f8:
        if f15 is not None:
            bpy.data.images[bum].name = TexBump
            bpy.data.images[TexBump].filepath = fixlocate+TexBump
            bpy.data.images[TexBump].filepath_raw = fixlocate+TexBump
        f16 = bpimg(dnm)
        #for f8 in f8:
        if f16 is not None:
            bpy.data.images[dnm].name = TexDNM
            bpy.data.images[TexDNM].filepath = fixlocate+TexDNM
            bpy.data.images[TexDNM].filepath_raw = fixlocate+TexDNM
        f17 = bpimg(bnm)
        #for f8 in f8:
        if f17 is not None:
            bpy.data.images[bnm].name = TexBNM
            bpy.data.images[TexBNM].filepath = fixlocate+TexBNM
            bpy.data.images[TexBNM].filepath_raw = fixlocate+TexBNM
        f18 = bpimg(sgm)
        #for f8 in f8:
        if f18 is not None:
            bpy.data.images[sgm].name = TexSGM
            bpy.data.images[TexSGM].filepath = fixlocate+TexSGM
            bpy.data.images[TexSGM].filepath_raw = fixlocate+TexSGM
        f19 = bpimg(om)
        #for f8 in f8:
        if f19 is not None:
            bpy.data.images[om].name = TexOM
            bpy.data.images[TexOM].filepath = fixlocate+TexOM
            bpy.data.images[TexOM].filepath_raw = fixlocate+TexOM
        f20 = bpimg(tss)
        #for f8 in f8:
        if f20 is not None:
            bpy.data.images[tss].name = TexTSS
            bpy.data.images[TexTSS].filepath = fixlocate+TexTSS
            bpy.data.images[TexTSS].filepath_raw = fixlocate+TexTSS
        f21 = bpimg(mgm)
        #for f8 in f8:
        if f21 is not None:
            bpy.data.images[mgm].name = TexMGM
            bpy.data.images[TexMGM].filepath = fixlocate+TexMGM
            bpy.data.images[TexMGM].filepath_raw = fixlocate+TexMGM
        f22 = bpimg(ov)
        #for f8 in f8:
        if f22 is not None:
            bpy.data.images[ov].name = TexOV
            bpy.data.images[TexOV].filepath = fixlocate+TexOV
            bpy.data.images[TexOV].filepath_raw = fixlocate+TexOV
        f23 = bpimg(bum2)
        #for f8 in f8:
        if f23 is not None:
            bpy.data.images[bum2].name = TexBump2
            bpy.data.images[TexBump2].filepath = fixlocate+TexBump2
            bpy.data.images[TexBump2].filepath_raw = fixlocate+TexBump2
        f24 = bpimg(dmt)
        if f24 is not None:
            bpy.data.images[dmt].name = TexDMT
            bpy.data.images[TexDMT].filepath = fixlocate+TexDMT
            bpy.data.images[TexDMT].filepath_raw = fixlocate+TexDMT
        f25 = bpimg(dgm)
        if f25 is not None:
            bpy.data.images[dgm].name = TexDGM
            bpy.data.images[TexDGM].filepath = fixlocate+TexDGM
            bpy.data.images[TexDGM].filepath_raw = fixlocate+TexDGM
        f26 = bpimg(dgm2)
        if f26 is not None:
            bpy.data.images[dgm2].name = TexDGM2
            bpy.data.images[TexDGM2].filepath = fixlocate+TexDGM2
            bpy.data.images[TexDGM2].filepath_raw = fixlocate+TexDGM2
        f27 = bpimg(nail)
        if f27 is not None:
            bpy.data.images[nail].name = TexNailM
            bpy.data.images[TexNailM].filepath = fixlocate+TexNailM
            bpy.data.images[TexNailM].filepath_raw = fixlocate+TexNailM
        f28 = bpimg(wetmk)
        if f28 is not None:
            bpy.data.images[wetmk].name = TexWetMK
            bpy.data.images[TexWetMK].filepath = fixlocate+TexWetMK
            bpy.data.images[TexWetMK].filepath_raw = fixlocate+TexWetMK
        f29 = bpimg(wetmp)
        if f29 is not None:
            bpy.data.images[wetmp].name = TexWetMP
            bpy.data.images[TexWetMP].filepath = fixlocate+TexWetMP
            bpy.data.images[TexWetMP].filepath_raw = fixlocate+TexWetMP
        f30 = bpimg(oc)
        if f30 is not None:
            bpy.data.images[oc].name = TexOC
            bpy.data.images[TexOC].filepath = fixlocate+TexOC
            bpy.data.images[TexOC].filepath_raw = fixlocate+TexOC
        bpy.ops.file.find_missing_files('INVOKE_DEFAULT')
        return {"FINISHED"}

    def invoke(self, context, event):
        return self.execute(context)


class SNA_OT_Kkpappenddata_B9B14(bpy.types.Operator):
    bl_idname = "sna.kkpappenddata_b9b14"
    bl_label = "kkp-append-data"
    bl_description = "Set the shaders to the koikatsu party character"
    bl_options = {"REGISTER", "UNDO"}

    @classmethod
    def poll(cls, context):
        return not False

    def execute(self, context):
        before_data = list(bpy.data.node_groups)
        bpy.ops.wm.append(directory=os.path.join(os.path.dirname(__file__), 'assets', 'KK_Template_Shader.blend') + r'\NodeTree', filename='KK-Template Face', link=False)
        new_data = list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
        appended_50972 = None if not new_data else new_data[0]
        before_data = list(bpy.data.node_groups)
        bpy.ops.wm.append(directory=os.path.join(os.path.dirname(__file__), 'assets', 'KK_Template_Shader.blend') + r'\NodeTree', filename='KK-Template Body', link=False)
        new_data = list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
        appended_FCD4E = None if not new_data else new_data[0]
        before_data = list(bpy.data.node_groups)
        bpy.ops.wm.append(directory=os.path.join(os.path.dirname(__file__), 'assets', 'KK_Template_Shader.blend') + r'\NodeTree', filename='KK-Template Tooth', link=False)
        new_data = list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
        appended_F14DC = None if not new_data else new_data[0]
        before_data = list(bpy.data.node_groups)
        bpy.ops.wm.append(directory=os.path.join(os.path.dirname(__file__), 'assets', 'KK_Template_Shader.blend') + r'\NodeTree', filename='KK-Template Tongue', link=False)
        new_data = list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
        appended_781FA = None if not new_data else new_data[0]
        before_data = list(bpy.data.node_groups)
        bpy.ops.wm.append(directory=os.path.join(os.path.dirname(__file__), 'assets', 'KK_Template_Shader.blend') + r'\NodeTree', filename='KK-Template Mayuge', link=False)
        new_data = list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
        appended_1E370 = None if not new_data else new_data[0]
        before_data = list(bpy.data.node_groups)
        bpy.ops.wm.append(directory=os.path.join(os.path.dirname(__file__), 'assets', 'KK_Template_Shader.blend') + r'\NodeTree', filename='KK-Template Noseline', link=False)
        new_data = list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
        appended_27599 = None if not new_data else new_data[0]
        before_data = list(bpy.data.node_groups)
        bpy.ops.wm.append(directory=os.path.join(os.path.dirname(__file__), 'assets', 'KK_Template_Shader.blend') + r'\NodeTree', filename='KK-Template BackEye', link=False)
        new_data = list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
        appended_BA93A = None if not new_data else new_data[0]
        before_data = list(bpy.data.node_groups)
        bpy.ops.wm.append(directory=os.path.join(os.path.dirname(__file__), 'assets', 'KK_Template_Shader.blend') + r'\NodeTree', filename='KK-Template Eye', link=False)
        new_data = list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
        appended_C8B6E = None if not new_data else new_data[0]
        before_data = list(bpy.data.node_groups)
        bpy.ops.wm.append(directory=os.path.join(os.path.dirname(__file__), 'assets', 'KK_Template_Shader.blend') + r'\NodeTree', filename='KK-Template Eyeline', link=False)
        new_data = list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
        appended_E1884 = None if not new_data else new_data[0]
        before_data = list(bpy.data.materials)
        bpy.ops.wm.append(directory=os.path.join(os.path.dirname(__file__), 'assets', 'KK_Template_Shader.blend') + r'\Material', filename='KK-Template Outline', link=False)
        new_data = list(filter(lambda d: not d in before_data, list(bpy.data.materials)))
        appended_CF162 = None if not new_data else new_data[0]
        before_data = list(bpy.data.materials)
        bpy.ops.wm.append(directory=os.path.join(os.path.dirname(__file__), 'assets', 'KK_Template_Shader.blend') + r'\Material', filename='KK-Template Bra Outline', link=False)
        new_data = list(filter(lambda d: not d in before_data, list(bpy.data.materials)))
        appended_8291B = None if not new_data else new_data[0]
        before_data = list(bpy.data.materials)
        bpy.ops.wm.append(directory=os.path.join(os.path.dirname(__file__), 'assets', 'KK_Template_Shader.blend') + r'\Material', filename='KK-Template Body Outline', link=False)
        new_data = list(filter(lambda d: not d in before_data, list(bpy.data.materials)))
        appended_8506C = None if not new_data else new_data[0]
        before_data = list(bpy.data.node_groups)
        bpy.ops.wm.append(directory=os.path.join(os.path.dirname(__file__), 'assets', 'KK_Template_Shader.blend') + r'\NodeTree', filename='KK-Template Accesories', link=False)
        new_data = list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
        appended_6D03F = None if not new_data else new_data[0]
        before_data = list(bpy.data.node_groups)
        bpy.ops.wm.append(directory=os.path.join(os.path.dirname(__file__), 'assets', 'KK_Template_Shader.blend') + r'\NodeTree', filename='KK-Template Hair Front', link=False)
        new_data = list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
        appended_7D862 = None if not new_data else new_data[0]
        before_data = list(bpy.data.node_groups)
        bpy.ops.wm.append(directory=os.path.join(os.path.dirname(__file__), 'assets', 'KK_Template_Shader.blend') + r'\NodeTree', filename='KK-Template Hair Front', link=False)
        new_data = list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
        appended_4407B = None if not new_data else new_data[0]
        before_data = list(bpy.data.node_groups)
        bpy.ops.wm.append(directory=os.path.join(os.path.dirname(__file__), 'assets', 'KK_Template_Shader.blend') + r'\NodeTree', filename='KK-Template Hair Front', link=False)
        new_data = list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
        appended_3B8D4 = None if not new_data else new_data[0]
        before_data = list(bpy.data.node_groups)
        bpy.ops.wm.append(directory=os.path.join(os.path.dirname(__file__), 'assets', 'KK_Template_Shader.blend') + r'\NodeTree', filename='KK-Template Hair Front', link=False)
        new_data = list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
        appended_DEB0F = None if not new_data else new_data[0]
        before_data = list(bpy.data.node_groups)
        bpy.ops.wm.append(directory=os.path.join(os.path.dirname(__file__), 'assets', 'KK_Template_Shader.blend') + r'\NodeTree', filename='KK-Template Hair Front', link=False)
        new_data = list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
        appended_F7E42 = None if not new_data else new_data[0]
        before_data = list(bpy.data.node_groups)
        bpy.ops.wm.append(directory=os.path.join(os.path.dirname(__file__), 'assets', 'KK_Template_Shader.blend') + r'\NodeTree', filename='KK-Template Hair Front', link=False)
        new_data = list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
        appended_FD7B9 = None if not new_data else new_data[0]
        before_data = list(bpy.data.node_groups)
        bpy.ops.wm.append(directory=os.path.join(os.path.dirname(__file__), 'assets', 'KK_Template_Shader.blend') + r'\NodeTree', filename='KK-Template Hair Front', link=False)
        new_data = list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
        appended_6A254 = None if not new_data else new_data[0]
        before_data = list(bpy.data.node_groups)
        bpy.ops.wm.append(directory=os.path.join(os.path.dirname(__file__), 'assets', 'KK_Template_Shader.blend') + r'\NodeTree', filename='KK-Template Hair Front', link=False)
        new_data = list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
        appended_C1420 = None if not new_data else new_data[0]
        before_data = list(bpy.data.node_groups)
        bpy.ops.wm.append(directory=os.path.join(os.path.dirname(__file__), 'assets', 'KK_Template_Shader.blend') + r'\NodeTree', filename='KK-Template Hair Front', link=False)
        new_data = list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
        appended_831EC = None if not new_data else new_data[0]
        before_data = list(bpy.data.node_groups)
        bpy.ops.wm.append(directory=os.path.join(os.path.dirname(__file__), 'assets', 'KK_Template_Shader.blend') + r'\NodeTree', filename='KK-Template Hair Front', link=False)
        new_data = list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
        appended_D9C8B = None if not new_data else new_data[0]
        before_data = list(bpy.data.node_groups)
        bpy.ops.wm.append(directory=os.path.join(os.path.dirname(__file__), 'assets', 'KK_Template_Shader.blend') + r'\NodeTree', filename='KK-Template Hair Back', link=False)
        new_data = list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
        appended_D2413 = None if not new_data else new_data[0]
        before_data = list(bpy.data.node_groups)
        bpy.ops.wm.append(directory=os.path.join(os.path.dirname(__file__), 'assets', 'KK_Template_Shader.blend') + r'\NodeTree', filename='KK-Template Hair Back', link=False)
        new_data = list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
        appended_0939A = None if not new_data else new_data[0]
        before_data = list(bpy.data.node_groups)
        bpy.ops.wm.append(directory=os.path.join(os.path.dirname(__file__), 'assets', 'KK_Template_Shader.blend') + r'\NodeTree', filename='KK-Template Hair Back', link=False)
        new_data = list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
        appended_BFDBB = None if not new_data else new_data[0]
        before_data = list(bpy.data.node_groups)
        bpy.ops.wm.append(directory=os.path.join(os.path.dirname(__file__), 'assets', 'KK_Template_Shader.blend') + r'\NodeTree', filename='KK-Template Hair Back', link=False)
        new_data = list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
        appended_0708B = None if not new_data else new_data[0]
        before_data = list(bpy.data.node_groups)
        bpy.ops.wm.append(directory=os.path.join(os.path.dirname(__file__), 'assets', 'KK_Template_Shader.blend') + r'\NodeTree', filename='KK-Template Hair Back', link=False)
        new_data = list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
        appended_E6F4F = None if not new_data else new_data[0]
        before_data = list(bpy.data.node_groups)
        bpy.ops.wm.append(directory=os.path.join(os.path.dirname(__file__), 'assets', 'KK_Template_Shader.blend') + r'\NodeTree', filename='KK-Template Hair Back', link=False)
        new_data = list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
        appended_481DB = None if not new_data else new_data[0]
        before_data = list(bpy.data.node_groups)
        bpy.ops.wm.append(directory=os.path.join(os.path.dirname(__file__), 'assets', 'KK_Template_Shader.blend') + r'\NodeTree', filename='KK-Template Hair Back', link=False)
        new_data = list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
        appended_C4DB3 = None if not new_data else new_data[0]
        before_data = list(bpy.data.node_groups)
        bpy.ops.wm.append(directory=os.path.join(os.path.dirname(__file__), 'assets', 'KK_Template_Shader.blend') + r'\NodeTree', filename='KK-Template Hair Back', link=False)
        new_data = list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
        appended_B90A6 = None if not new_data else new_data[0]
        before_data = list(bpy.data.node_groups)
        bpy.ops.wm.append(directory=os.path.join(os.path.dirname(__file__), 'assets', 'KK_Template_Shader.blend') + r'\NodeTree', filename='KK-Template Hair Back', link=False)
        new_data = list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
        appended_00A1C = None if not new_data else new_data[0]
        before_data = list(bpy.data.node_groups)
        bpy.ops.wm.append(directory=os.path.join(os.path.dirname(__file__), 'assets', 'KK_Template_Shader.blend') + r'\NodeTree', filename='KK-Template Hair Back', link=False)
        new_data = list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
        appended_49DFD = None if not new_data else new_data[0]
        before_data = list(bpy.data.node_groups)
        bpy.ops.wm.append(directory=os.path.join(os.path.dirname(__file__), 'assets', 'KK_Template_Shader.blend') + r'\NodeTree', filename='KK-Template Sachi', link=False)
        new_data = list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
        appended_ADE83 = None if not new_data else new_data[0]
        before_data = list(bpy.data.node_groups)
        bpy.ops.wm.append(directory=os.path.join(os.path.dirname(__file__), 'assets', 'KK_Template_Shader.blend') + r'\NodeTree', filename='KK-Template Sachi', link=False)
        new_data = list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
        appended_C363C = None if not new_data else new_data[0]
        before_data = list(bpy.data.node_groups)
        bpy.ops.wm.append(directory=os.path.join(os.path.dirname(__file__), 'assets', 'KK_Template_Shader.blend') + r'\NodeTree', filename='KK-Template Sachi', link=False)
        new_data = list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
        appended_0E57C = None if not new_data else new_data[0]
        before_data = list(bpy.data.node_groups)
        bpy.ops.wm.append(directory=os.path.join(os.path.dirname(__file__), 'assets', 'KK_Template_Shader.blend') + r'\NodeTree', filename='KK-Template UnderCloth', link=False)
        new_data = list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
        appended_5FDAB = None if not new_data else new_data[0]
        before_data = list(bpy.data.node_groups)
        bpy.ops.wm.append(directory=os.path.join(os.path.dirname(__file__), 'assets', 'KK_Template_Shader.blend') + r'\NodeTree', filename='KK-Template Pants', link=False)
        new_data = list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
        appended_2B7E2 = None if not new_data else new_data[0]
        before_data = list(bpy.data.node_groups)
        bpy.ops.wm.append(directory=os.path.join(os.path.dirname(__file__), 'assets', 'KK_Template_Shader.blend') + r'\NodeTree', filename='KK-Template Pants', link=False)
        new_data = list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
        appended_509AB = None if not new_data else new_data[0]
        before_data = list(bpy.data.node_groups)
        bpy.ops.wm.append(directory=os.path.join(os.path.dirname(__file__), 'assets', 'KK_Template_Shader.blend') + r'\NodeTree', filename='KK-Template Bra', link=False)
        new_data = list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
        appended_49ABE = None if not new_data else new_data[0]
        before_data = list(bpy.data.node_groups)
        bpy.ops.wm.append(directory=os.path.join(os.path.dirname(__file__), 'assets', 'KK_Template_Shader.blend') + r'\NodeTree', filename='KK-Template Panties', link=False)
        new_data = list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
        appended_5E5DB = None if not new_data else new_data[0]
        before_data = list(bpy.data.node_groups)
        bpy.ops.wm.append(directory=os.path.join(os.path.dirname(__file__), 'assets', 'KK_Template_Shader.blend') + r'\NodeTree', filename='KK-Template Shoes', link=False)
        new_data = list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
        appended_DF6C8 = None if not new_data else new_data[0]
        before_data = list(bpy.data.node_groups)
        bpy.ops.wm.append(directory=os.path.join(os.path.dirname(__file__), 'assets', 'KK_Template_Shader.blend') + r'\NodeTree', filename='KK-Template Socks', link=False)
        new_data = list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
        appended_6EB6F = None if not new_data else new_data[0]
        before_data = list(bpy.data.node_groups)
        bpy.ops.wm.append(directory=os.path.join(os.path.dirname(__file__), 'assets', 'KK_Template_Shader.blend') + r'\NodeTree', filename='KK-Template Simple', link=False)
        new_data = list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
        appended_845C7 = None if not new_data else new_data[0]
        before_data = list(bpy.data.node_groups)
        bpy.ops.wm.append(directory=os.path.join(os.path.dirname(__file__), 'assets', 'KK_Template_Shader.blend') + r'\NodeTree', filename='KK-Template Simple', link=False)
        new_data = list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
        appended_DCB48 = None if not new_data else new_data[0]
        before_data = list(bpy.data.node_groups)
        bpy.ops.wm.append(directory=os.path.join(os.path.dirname(__file__), 'assets', 'KK_Template_Shader.blend') + r'\NodeTree', filename='KK-Template Simple', link=False)
        new_data = list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
        appended_194FC = None if not new_data else new_data[0]
        before_data = list(bpy.data.node_groups)
        bpy.ops.wm.append(directory=os.path.join(os.path.dirname(__file__), 'assets', 'KK_Template_Shader.blend') + r'\NodeTree', filename='KK-Template Simple', link=False)
        new_data = list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
        appended_03999 = None if not new_data else new_data[0]
        before_data = list(bpy.data.node_groups)
        bpy.ops.wm.append(directory=os.path.join(os.path.dirname(__file__), 'assets', 'KK_Template_Shader.blend') + r'\NodeTree', filename='KK-Template Simple', link=False)
        new_data = list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
        appended_3C045 = None if not new_data else new_data[0]
        before_data = list(bpy.data.node_groups)
        bpy.ops.wm.append(directory=os.path.join(os.path.dirname(__file__), 'assets', 'KK_Template_Shader.blend') + r'\NodeTree', filename='KK-Template Simple', link=False)
        new_data = list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
        appended_AE7D4 = None if not new_data else new_data[0]
        before_data = list(bpy.data.node_groups)
        bpy.ops.wm.append(directory=os.path.join(os.path.dirname(__file__), 'assets', 'KK_Template_Shader.blend') + r'\NodeTree', filename='KK-Template Simple', link=False)
        new_data = list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
        appended_80DC9 = None if not new_data else new_data[0]
        before_data = list(bpy.data.node_groups)
        bpy.ops.wm.append(directory=os.path.join(os.path.dirname(__file__), 'assets', 'KK_Template_Shader.blend') + r'\NodeTree', filename='KK-Template Simple', link=False)
        new_data = list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
        appended_D5F80 = None if not new_data else new_data[0]
        before_data = list(bpy.data.node_groups)
        bpy.ops.wm.append(directory=os.path.join(os.path.dirname(__file__), 'assets', 'KK_Template_Shader.blend') + r'\NodeTree', filename='KK-Template Simple', link=False)
        new_data = list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
        appended_54EDC = None if not new_data else new_data[0]
        before_data = list(bpy.data.node_groups)
        bpy.ops.wm.append(directory=os.path.join(os.path.dirname(__file__), 'assets', 'KK_Template_Shader.blend') + r'\NodeTree', filename='KK-Template Simple', link=False)
        new_data = list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
        appended_EE6EE = None if not new_data else new_data[0]
        before_data = list(bpy.data.node_groups)
        bpy.ops.wm.append(directory=os.path.join(os.path.dirname(__file__), 'assets', 'KK_Template_Shader.blend') + r'\NodeTree', filename='KK-Template Simple', link=False)
        new_data = list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
        appended_BBC2E = None if not new_data else new_data[0]
        before_data = list(bpy.data.node_groups)
        bpy.ops.wm.append(directory=os.path.join(os.path.dirname(__file__), 'assets', 'KK_Template_Shader.blend') + r'\NodeTree', filename='KK-Template Simple', link=False)
        new_data = list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
        appended_F1928 = None if not new_data else new_data[0]
        before_data = list(bpy.data.node_groups)
        bpy.ops.wm.append(directory=os.path.join(os.path.dirname(__file__), 'assets', 'KK_Template_Shader.blend') + r'\NodeTree', filename='KK-Template Simple', link=False)
        new_data = list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
        appended_84080 = None if not new_data else new_data[0]
        before_data = list(bpy.data.node_groups)
        bpy.ops.wm.append(directory=os.path.join(os.path.dirname(__file__), 'assets', 'KK_Template_Shader.blend') + r'\NodeTree', filename='KK-Template Simple', link=False)
        new_data = list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
        appended_7E03C = None if not new_data else new_data[0]
        before_data = list(bpy.data.node_groups)
        bpy.ops.wm.append(directory=os.path.join(os.path.dirname(__file__), 'assets', 'KK_Template_Shader.blend') + r'\NodeTree', filename='KK-Template Simple', link=False)
        new_data = list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
        appended_3A91F = None if not new_data else new_data[0]
        before_data = list(bpy.data.node_groups)
        bpy.ops.wm.append(directory=os.path.join(os.path.dirname(__file__), 'assets', 'KK_Template_Shader.blend') + r'\NodeTree', filename='KK-Template Simple', link=False)
        new_data = list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
        appended_537E6 = None if not new_data else new_data[0]
        before_data = list(bpy.data.node_groups)
        bpy.ops.wm.append(directory=os.path.join(os.path.dirname(__file__), 'assets', 'KK_Template_Shader.blend') + r'\NodeTree', filename='KK-Template Simple', link=False)
        new_data = list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
        appended_3154B = None if not new_data else new_data[0]
        before_data = list(bpy.data.node_groups)
        bpy.ops.wm.append(directory=os.path.join(os.path.dirname(__file__), 'assets', 'KK_Template_Shader.blend') + r'\NodeTree', filename='KK-Template Simple', link=False)
        new_data = list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
        appended_937D2 = None if not new_data else new_data[0]
        before_data = list(bpy.data.node_groups)
        bpy.ops.wm.append(directory=os.path.join(os.path.dirname(__file__), 'assets', 'KK_Template_Shader.blend') + r'\NodeTree', filename='KK-Template Simple', link=False)
        new_data = list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
        appended_D4893 = None if not new_data else new_data[0]
        before_data = list(bpy.data.node_groups)
        bpy.ops.wm.append(directory=os.path.join(os.path.dirname(__file__), 'assets', 'KK_Template_Shader.blend') + r'\NodeTree', filename='KK-Template Simple', link=False)
        new_data = list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
        appended_D04B9 = None if not new_data else new_data[0]
        MatFace = None
        # for easily use of the addon and implementation of variety of name meshes
        # this is a list created for add more names
        #mods added:
        #[nashi]jacket 5.2
        #[yamadamod]accneckP rev4
        #[anse] anse_high-waist_skirt v1
        #[DeathWeasel] Bras v1.2.1
        #[DeathWeasel]Panties v1.3.2
        #[ztokki]Long Socks
        #[H_enry] Shoes be walkin v3.0.0
        #[MrDelegado] Full Jinx v1.0
        #[Giuls] Full mods
        #[Evaan] Komi-San
        #[Evaan] Dangaronpa
        #[Evaan] MHA Girls
        #[Evaan] Naruto Gurls
        #[Evaan] OPM girls
        #[Evaan] Mavis Dracula
        #[Evaan] Final Fantasy Tifa
        #[Evaan] Overwatch DVA,Tracer
        #[Evaan] Overlord Albedo
        #[Evaan] Dragon Maid Elma horn
        # Body names: #full koikatsu
        body1 = 'o_body_a'
        body2 = 'o_body_b'
        body3 = 'o_body_c'
        body4 = 'o_body_d'
        body5 = 'o_body_e'
        # Face names: #full koikatsu
        face1 = 'cf_O_face'
        face2 = 'cf_O_face_atari'
        face3 = 'cf_O_face3'
        face4 = 'cf_O_face4'
        face5 = 'cf_O_face5'
        # Hair Front names:
        #bo_hair_f #full koikatsu
        hairf1 = 'cf_hair_idol_hair_f_00'
        hairf2 = 'cf_hair_idol_hair_f_01'
        hairf3 = 'cf_hair_idol_hair_f_02'
        hairf4 = 'cf_hair_f_02_00'
        hairf5 = 'cf_hair_f_02_01'
        hairf6 = 'cf_hair_f_02_02'
        hairf7 = 'cf_hair_f_02_03'
        hairf8 = 'cf_hair_f_03_00'
        hairf9 = 'cf_hair_f_03_01'
        hairf10 = 'cf_hair_f_03_02'
        hairf11 = 'cf_hair_f_03_03'
        hairf12 = 'cf_hair_f_03_04'
        hairf13 = 'cf_hair_f_04_00'
        hairf14 = 'cf_hair_f_04_01'
        hairf15 = 'cf_hair_f_04_02'
        hairf16 = 'cf_hair_f_04_03'
        hairf17 = 'cf_hair_f_04_04'
        hairf18 = 'cf_hair_f_04_05'
        hairf19 = 'cf_hair_f_05_00'
        hairf20 = 'cf_hair_f_06_01'
        hairf21 = 'cf_hair_f_07_00'
        hairf22 = 'cf_hair_f_08'
        hairf23 = 'cf_hair_f_09_00'
        hairf24 = 'cf_hair_f_10_00'
        hairf25 = 'cf_hair_f_11'
        hairf26 = 'cf_hair_f_12'
        hairf27 = 'cf_hair_f_13'
        hairf28 = 'cf_hair_f_14'
        hairf29 = 'cf_hair_f_15_00'
        hairf30 = 'cf_hair_f_16_00'
        hairf31 = 'cf_hair_f_17_00'
        hairf32 = 'cf_hair_f_18_00'
        hairf33 = 'cf_hair_f_19_00'
        hairf34 = 'cf_hair_f_20'
        hairf35 = 'cf_hair_f_21_00'
        hairf36 = 'cf_hair_f_30_00'
        hairf37 = 'cf_hair_f_30_01'
        hairf38 = 'cf_hair_f_30_02'
        hairf39 = 'cf_hair_f_30_03'
        hairf40 = 'cf_hair_f_30_04'
        hairf41 = 'cf_hair_f_31_00'
        hairf42 = 'cf_hair_f_31_01'
        hairf43 = 'cf_hair_f_31_02'
        hairf44 = 'cf_hair_f_31_03'
        hairf45 = 'cf_hair_f_31_04'
        hairf46 = 'cf_hair_f_31_05'
        hairf47 = 'cf_hair_f_31_06'
        hairf48 = 'cf_hair_f_32_00'
        hairf49 = 'cf_hair_f_32_01'
        hairf50 = 'cf_hair_f_32_02'
        hairf51 = 'cf_hair_f_32_03'
        hairf52 = 'cf_hair_f_32_04'
        hairf53 = 'cf_hair_f_33_00'
        hairf54 = 'cf_hair_f_33_01'
        hairf55 = 'cf_hair_f_33_02'
        hairf56 = 'cf_hair_f_33_03'
        hairf57 = 'cf_hair_f_33_04'
        hairf58 = 'cf_hair_f_34_00'
        hairf59 = 'cf_hair_f_34_01'
        hairf60 = 'cf_hair_f_34_02'
        hairf61 = 'cf_hair_f_34_03'
        hairf62 = 'cf_hair_f_34_04'
        hairf63 = 'cf_hair_f_34_05'
        hairf64 = 'cf_hair_f_34_06'
        hairf65 = 'cf_hair_f_22_00'
        hairf66 = 'cf_hair_f_23_00'
        hairf67 = 'cf_hair_f_24_00'
        hairf68 = 'cf_hair_f_102_00'
        hairf69 = 'cf_hair_f_103_00'
        hairf70 = 'cf_hair_f_104_00'
        hairf71 = 'cf_hair_f_104_01'
        hairf72 = 'cf_hair_f_100_00'
        hairf73 = 'cf_hair_f_101_00'
        hairf74 = 'cf_hair_f_105_00'
        hairf75 = 'cf_hair_f_105_01'
        hairf76 = 'cf_hair_f_105_02'
        hairf77 = 'cf_hair_f_105_03'
        hairf78 = 'cf_hair_f_105_04'
        hairf79 = 'cf_hair_f_105_05'
        hairf80 = 'cf_hair_f_105_06'
        hairf81 = 'cf_hair_f_106_00'
        hairf82 = 'cf_hair_f_106_01'
        hairf83 = 'cf_hair_f_106_02'
        hairf84 = 'cf_hair_f_106_03'
        hairf85 = 'cf_hair_f_106_04'
        hairf86 = 'cf_hair_f_107_00'
        hairf87 = 'cf_hair_f_107_01'
        hairf88 = 'cf_hair_f_107_02'
        hairf89 = 'cf_hair_f_107_03'
        hairf90 = 'cf_hair_f_25_00'
        hairf91 = 'cf_hair_f_108_00'
        hairf92 = 'cf_hair_f_108_01'
        hairf93 = 'cf_hair_f_108_02'
        hairf94 = 'cf_hair_f_108_03'
        hairf95 = 'cf_hair_f_109_00'
        hairf96 = 'cf_hair_f_109_01'
        hairf97 = 'cf_hair_f_109_02'
        hairf98 = 'cf_hair_f_109_03'
        hairf99 = 'cf_hair_f_110_00'
        hairf100 = 'cf_hair_f_110_01'
        hairf101 = 'cf_hair_f_110_02'
        hairf102 = 'cf_hair_f_110_03'
        hairf103 = 'cf_hair_f_26_00'
        hairf104 = 'cf_hair_f_111_00'
        hairf105 = 'cf_hair_f_111_01'
        hairf106 = 'cf_hair_f_111_02'
        hairf107 = 'cf_hair_f_111_03'
        hairf108 = 'cf_hair_f_111_04'
        hairf109 = 'cf_hair_f_111_05'
        hairf110 = 'cf_hair_f_112_00'
        hairf111 = 'cf_hair_f_112_01'
        hairf112 = 'cf_hair_f_112_02'
        hairf113 = 'cf_hair_f_112_03'
        hairf114 = 'cf_hair_f_112_04'
        hairf115 = 'cf_hair_f_113_00'
        hairf116 = 'cf_hair_f_113_01'
        hairf117 = 'cf_hair_f_113_02'
        hairf118 = 'cf_hair_f_113_03'
        hairf119 = 'cf_hair_f_113_04'
        hairf120 = 'cf_hair_f_113_05'
        hairf121 = 'cf_hair_f_27_00'
        hairf122 = 'cf_hair_f_28_00'
        #bo_hair_o
        hairf123 = 'cf_hair_o_01 1'
        hairf124 = 'cf_hair_o_02'
        hairf125 = 'cf_hair_o_03'
        hairf126 = 'cf_hair_o_04 1'
        hairf127 = 'cf_hair_o_05'
        hairf128 = 'cf_hair_o_06_01'
        hairf129 = 'cf_hair_o_06_02'
        hairf130 = 'cf_hair_o_07_01'
        hairf131 = 'cf_hair_o_07_02'
        hairf132 = 'cf_hair_o_08'
        #bo_hair_s
        hairf133 = 'cf_hair_s_01'
        hairf134 = 'cf_hair_s_02_00'
        hairf135 = 'cf_hair_s_03_00'
        hairf136 = 'cf_hair_s_05_00'
        hairf137 = 'cf_hair_s_06_00'
        hairf138 = 'cf_hair_s_07_00'
        # Hair Back names:
        #bo_hair_b full koikatsu
        hairb1 = 'cf_hair_idol_b_00'
        hairb2 = 'cf_hair_idol_b_01'
        hairb3 = 'cf_hair_idol_b_02'
        hairb4 = 'cf_hair_idol_b_03'
        hairb5 = 'cf_hair_idol_b_04'
        hairb6 = 'cf_hair_idol_b_pony_00'
        hairb7 = 'cf_hair_b_03_00'
        hairb8 = 'cf_hair_b_04_00'
        hairb9 = 'cf_hair_b_04_01'
        hairb10 = 'cf_hair_b_04_02'
        hairb11 = 'cf_hair_b_04_03'
        hairb12 = 'cf_hair_b_04_04'
        hairb13 = 'cf_hair_b_04_05'
        hairb14 = 'cf_hair_b_04_06'
        hairb15 = 'cf_hair_b_04_07'
        hairb16 = 'cf_hair_b_06_00'
        hairb17 = 'cf_hair_b_06_01'
        hairb18 = 'cf_hair_07_00'
        hairb19 = 'cf_hair_07_01'
        hairb20 = 'cf_hair_07_02'
        hairb21 = 'cf_hair_b_08_00'
        hairb22 = 'cf_hair_b_09_00'
        hairb23 = 'cf_hair_b_09_01'
        hairb24 = 'cf_hair_10_b_00'
        hairb25 = 'cf_hair_10_b_01 1'
        hairb26 = 'cf_hair_b_11_01'
        hairb27 = 'cf_hair_b_11_02'
        hairb28 = 'cf_hair_b_12_00'
        hairb29 = 'cf_hair_b_12_01'
        hairb30 = 'cf_hair_b_13_00'
        hairb31 = 'cf_hair_b_14_00'
        hairb32 = 'cf_hair_b_14_01'
        hairb33 = 'cf_hair_b_14_02'
        hairb34 = 'cf_hair_b_14_03'
        hairb35 = 'cf_hair_b_15_00'
        hairb36 = 'cf_hair_b_15_01'
        hairb37 = 'cf_hair_b_16_00'
        hairb38 = 'cf_hair_b_16_01'
        hairb39 = 'cf_hair_b_16_02'
        hairb40 = 'cf_hair_b_16_03'
        hairb41 = 'cf_hair_b_16_05'
        hairb42 = 'cf_hair_b_17_00'
        hairb43 = 'cf_hair_b_18_00'
        hairb44 = 'cf_hair_b_30_00'
        hairb45 = 'cf_hair_b_30_01'
        hairb46 = 'cf_hair_31_b_00'
        hairb47 = 'cf_hair_31_b_01'
        hairb48 = 'cf_hair_b_33_00'
        hairb49 = 'cf_hair_b_19_00'
        hairb50 = 'cf_hair_b_19_01'
        hairb51 = 'cf_hair_b_19_02'
        hairb52 = 'cf_hair_b_19_03'
        hairb53= 'cf_hair_b_20_00'
        hairb54 = 'cf_hair_b_21_00'
        hairb55 = 'cf_hair_b_21_01'
        hairb56 = 'cf_hair_b_21_02'
        hairb57 = 'cf_hair_b_21_03'
        hairb58 = 'cf_hair_b_22_00'
        hairb59 = 'cf_hair_b_22_01'
        hairb60 = 'cf_hair_b_111_00'
        hairb61 = 'cf_hair_b_112_00'
        hairb62 = 'cf_hair_b_113_00'
        hairb63 = 'cf_hair_b_113_01'
        hairb64 = 'cf_hair_b_113_02'
        hairb65 = 'cf_hair_b_113_03'
        hairb66 = 'cf_hair_b_100_00'
        hairb67 = 'cf_hair_b_100_01'
        hairb68 = 'cf_hair_b_100_02'
        hairb69 = 'cf_hair_b_100_03'
        hairb70 = 'cf_hair_b_101_00'
        hairb71 = 'cf_hair_b_101_01'
        hairb72 = 'cf_hair_b_102_00'
        hairb73 = 'cf_hair_b_102_01'
        hairb74 = 'cf_hair_b_103_00'
        hairb75 = 'cf_hair_b_103_01'
        hairb76 = 'cf_hair_104_00'
        hairb77 = 'cf_hair_104_01'
        hairb78 = 'cf_hair_104_02'
        hairb79 = 'cf_hair_105_00'
        hairb80 = 'cf_hair_105_01'
        hairb81 = 'cf_hair_105_02'
        hairb82 = 'cf_hair_106_00'
        hairb83 = 'cf_hair_106_01'
        hairb84 = 'cf_hair_106_02'
        hairb85 = 'cf_hair_107_00'
        hairb86 = 'cf_hair_107_01'
        hairb87 = 'cf_hair_107_02'
        hairb88 = 'cf_hair_108_00'
        hairb89 = 'cf_hair_108_01'
        hairb90 = 'cf_hair_108_02'
        hairb91 = 'cf_hair_109_00'
        hairb92 = 'cf_hair_109_01'
        hairb93 = 'cf_hair_109_02'
        hairb94 = 'cf_hair_110_00'
        hairb95 = 'cf_hair_110_01'
        hairb96 = 'cf_hair_110_02'
        hairb97 = 'cf_hair_b_114_00'
        hairb98 = 'cf_hair_b_114_01'
        hairb99 = 'cf_hair_b_114_02'
        hairb100 = 'cf_hair_b_114_03'
        hairb101 = 'cf_hair_b_114_04'
        hairb102 = 'cf_hair_b_115_00'
        hairb103 = 'cf_hair_b_115_01'
        hairb104 = 'cf_hair_b_115_02'
        hairb105 = 'cf_hair_b_115_03'
        hairb106 = 'cf_hair_b_115_04'
        hairb107 = 'cf_hair_b_116_00'
        hairb108 = 'cf_hair_b_116_01'
        hairb109 = 'cf_hair_b_116_02'
        hairb110 = 'cf_hair_b_116_03'
        hairb111 = 'cf_hair_b_116_04'
        hairb112 = 'cf_hair_b_116_05'
        hairb113 = 'cf_hair_b_23_00'
        hairb114 = 'cf_hair_b_23_01'
        hairb115 = 'cf_hair_b_117_00'
        hairb116 = 'cf_hair_b_117_01'
        hairb117 = 'cf_hair_b_117_02'
        hairb118 = 'cf_hair_b_117_03'
        hairb119 = 'cf_hair_b_117_04'
        hairb120 = 'cf_hair_b_117_05'
        hairb121 = 'cf_hair_b_118_00'
        hairb122 = 'cf_hair_b_119_00'
        hairb123 = 'cf_hair_b_119_01'
        hairb124 = 'cf_hair_b_119_02'
        hairb125 = 'cf_hair_b_119_03'
        hairb126 = 'cf_hair_b_119_04'
        hairb127 = 'cf_hair_b_119_05'
        hairb128 = 'cf_hair_b_119_06'
        hairb129 = 'cf_hair_b_119_07'
        hairb130 = 'cf_hair_b_24_00'
        hairb131 = 'cf_hair_b_24_01'
        hairb132 = 'cf_hair_b_121_00'
        hairb133 = 'cf_hair_b_121_01'
        hairb134 = 'cf_hair_b_121_02'
        hairb135 = 'cf_hair_b_121_03'
        hairb136 = 'cf_hair_b_121_04'
        hairb137 = 'cf_hair_b_121_05'
        hairb138 = 'cf_hair_b_121_06'
        hairb138 = 'cf_hair_b_121_07'
        hairb139 = 'cf_hair_b_121_08'
        hairb140 = 'cf_hair_b_121_09'
        hairb141 = 'cf_hair_b_25_00'
        hairb142 = 'cf_hair_b_26_00'
        #from mods
        hairb143 = 'Hair'
        # Cloth names:
        #jacket_b
        cloth1 = 'o_top_jacket01_a'
        cloth2 = 'o_top_jacket01_b'
        cloth3 = 'o_top_epron_jacket_a'
        cloth4 = 'o_top_epron_jacket_b'
        cloth5 = 'o_top_jacket_01_2_a'
        cloth6 = 'o_top_jacket_01_b'
        cloth7 = 'o_top_jacket02_a'
        cloth8 = 'o_top_jacket02_b'
        cloth9 = 'o_top_jacket03_a'
        cloth10 = 'o_top_jacket03_b'
        cloth11 = 'o_top_jacket04_a'
        cloth12 = 'o_top_jacket04_b'
        cloth13 = 'o_usagiP_bot_a'
        cloth14 = 'o_usagiP_bot_b'
        cloth15 = 'o_usagiP_top_a'
        cloth16 = 'o_usagiP_top_b'
        cloth17 = 'o_top_jacket06_a'
        cloth18 = 'o_top_jacket06_b'
        cloth19 = 'o_top_jacket06_2_a'
        cloth20 = 'o_top_jacket06_2_b'
        cloth21 = 'o_top_jacket07_a'
        cloth22 = 'o_top_jacket07_b'
        cloth23 = 'o_top_ponc_a'
        cloth24 = 'o_top_ponc_b'
        cloth25 = 'o_misya_jacket_top_a'
        cloth26 = 'o_misya_jacket_top_b'
        cloth27 = 'o_jacket08_a'
        cloth28 = 'o_jacket08_b'
        cloth29 = '-'
        cloth30 = '--'
        cloth31 = '---'
        cloth32 = '----'
        cloth33 = '-----'
        cloth34 = 'o_top_jacket01_2_a'
        #sailor
        cloth35 = 'o_top_sailor01_01_a'
        cloth36 = 'o_top_sailor01_01_b'
        cloth37 = 'o_top_sailor02_01_a'
        cloth38 = 'o_top_sailor02_01_b'
        cloth39 = 'o_top_sailor03_01_a'
        cloth40 = 'top_sailor03_01_b'
        cloth41 = 'o_top_sailor04_01_a'
        cloth42 = 'o_top_sailor04_01_b'
        cloth43 = 'o_top_sailor05_01_a'
        cloth44 = 'o_top_sailor05_01_b'
        cloth45 = 'o_top_sailor06_01_a'
        cloth46 = 'o_top_sailor06_01_b'
        cloth47 = 'o_top_sailor01_02_a'
        cloth48 = 'o_top_sailor02_02_a'
        cloth49 = 'o_top_sailor03_02_a'
        cloth50 = 'o_top_sailor04_02_a'
        cloth51 = 'o_top_sailor05_02_a'
        cloth52 = 'o_top_sailor06_02_a'
        cloth53 = 'o_top_sailor01_03_a'
        cloth54 = 'o_top_sailor02_03_a'
        cloth55 = 'o_top_sailor03_03_a'
        cloth56 = 'o_top_sailor04_03_a'
        cloth57 = 'o_top_sailor05_03_a'
        cloth58 = 'o_top_sailor06_03_a'
        #inside jacket_a
        cloth59 = 'o_misya_jacket_top_a'
        cloth60 = 'o_misya_jacket_top_b'
        cloth61 = 'o_jacket08_a'
        cloth62 = 'o_jacket08_b'
        #top #full koikatsu
        cloth63 = 'o_aku01_bot_a'
        cloth64 = 'o_aku01_bot_b'
        cloth65 = 'o_aku01_top_a'
        cloth66 = 'o_aku01_top_b'
        cloth67 = 'o_babydoll_bot_a'
        cloth68 = 'o_babydoll_bot_b'
        cloth69 = 'o_babydoll_top_a'
        cloth70 = 'o_babydoll_top_b'
        cloth71 = 'o_bot_bathtowel_a'
        cloth72 = 'o_bot_bathtowel_b'
        cloth73 = 'o_top_bathtowel_a'
        cloth74 = 'o_top_bathtowel_b'
        cloth75 = 'o_top_inner08_cami01_a'
        cloth76 = 'o_top_inner08_cami01_b'
        cloth77 = 'cf_o_cheer_top_d_00'
        cloth78 = 'cf_o_cheer_top_n_00'
        cloth79 = 'o_top_tsyats_cm_a'
        cloth80 = 'o_top_jacket01_cm'
        cloth81 = 'o_top_jacket05_cm'
        cloth82 = 'o_top_jacket06_cm'
        cloth83 = 'o_bot_epron_a'
        cloth84 = 'o_bot_epron_b'
        cloth85 = 'o_top_epron_a'
        cloth86 = 'o_top_epron_b'
        cloth87 = 'cf_o_top_d_teacherGym'
        cloth88 = 'cf_o_top_n_teacherGym'
        cloth89 = 'cf_o_top_Heteacher_d_00'
        cloth90 = 'cf_o_top_Heteacher_n_00'
        cloth91 = 'cf_o_bot_teacher_d_00'
        cloth92 = 'jajameequivoque'
        cloth93 = 'cf_o_bot_teacher_n_00'
        cloth94 = 'cf_o_top_teacher_d_00'
        cloth95 = 'cf_o_top_teacher_n_00'
        cloth96 = 'o_bot_idol_a'
        cloth97 = 'o_bot_idol_b'
        cloth98 = 'o_idolwaistribbon_a'
        cloth99 = 'o_idolwaistribbon_b'
        cloth100 = 'o_top_idol_a'
        cloth101 = 'o_top_idol_b'
        cloth102 = 'o_top_normal02_a'
        cloth103 = 'o_top_jacket02_b'
        cloth104 = 'o_top_jacket02_b_fit'
        cloth105 = 'o_top_jaji01_a_fit'
        cloth106 = 'o_top_jtank_a'
        cloth107 = 'o_top_jtank_b'
        cloth108 = 'cf_o_bot_kimono'
        cloth109 = 'cf_o_bot_kimono_n'
        cloth110 = 'cf_o_top_kimono'
        cloth111 = 'cf_o_top_kimono_n'
        cloth112 = 'cf_o_top_kyuudou_d_00'
        cloth113 = 'cf_o_top_kyuudou_n_00'
        cloth114 = 'cf_o_top_kyuudou_n_04'
        cloth115 = 'cf_o_top_kyuudouMN_d_00'
        cloth116 = 'cf_o_top_manken_d_00'
        cloth117 = 'cf_o_top_manken_n_00'
        cloth118 = 'cf_o_top_reinasuit_d'
        cloth119 = 'cf_o_top_reinasuit_n'
        cloth120 = 'o_bot_neglige01_a'
        cloth121 = 'o_bot_neglige01_b'
        cloth122 = 'o_top_neglige01_a'
        cloth123 = 'o_top_neglige01_b'
        cloth124 = 'o_top_ofcard_a'
        cloth125 = 'o_top_ofcard_b'
        cloth126 = 'o_openparker_bot_a'
        cloth127 = 'o_openparker_bot_b'
        cloth128 = 'o_openparker_top_a'
        cloth129 = 'o_openparker_top_b'
        cloth130 = 'o_top_pajama_a'
        cloth131 = 'o_top_pajama_b_a'
        cloth132 = 'o_top_pajama_b_b'
        cloth133 = 'o_top_parkeropm_a'
        cloth134 = 'o_top_parkeropm_b'
        cloth135 = 'cf_o_top_run_d'
        cloth136 = 'cf_o_top_run_n'
        cloth137 = 'cf_o_bot_sadou_d'
        cloth138 = 'cf_o_bot_sadou_n'
        cloth139 = 'cf_o_top_sadou_d'
        cloth140 = 'cf_o_top_sadou_n'
        cloth141 = 'o_bot_saropet_a'
        cloth142 = 'o_bot_saropet_b'
        cloth143 = 'o_top_saropet_a'
        cloth144 = 'o_top_saropet_b'
        cloth145 = 'o_top_saropetH_a'
        cloth146 = 'o_top_saropetH_b'
        cloth147 = 'o_bot_shilon_a'
        cloth148 = 'o_bot_shilon_b'
        cloth149 = 'o_top_shilon_a'
        cloth150 = 'o_top_shilon_b'
        cloth151 = 'cf_bot_a_00'
        cloth152 = 'cf_bot_b_00'
        cloth153 = 'cf_bra_a_00'
        cloth154 = 'cf_bra_b_00'
        cloth155 = 'cf_o_top_tennis_d'
        cloth156 = 'cf_o_top_tennis_n'
        cloth157 = 'o_top_tsyats_a'
        cloth158 = 'o_top_tsyats_b'
        cloth159 = 'o_top_tubet_a'
        cloth160 = 'o_top_tubet_b'
        cloth161 = 'cf_o_bot_onpi_d'
        cloth162 = 'cf_o_bot_onpi_n'
        cloth163 = 'cf_o_top_onpi_d'
        cloth164 = 'cf_o_top_onpi_n'
        cloth165 = 'o_top_nursec_b_a'
        cloth166 = 'o_top_nursec_b_b'
        cloth167 = 'o_top_nursec_t_a'
        cloth168 = 'o_top_nursec_t_b'
        cloth169 = 'o_top_magic_a'
        cloth170 = 'o_top_magic_b'
        cloth171 = 'cf_swimtop_cattube_d'
        cloth172 = 'cf_swimtop_cattube_n'
        cloth173 = 'cf_o_top_army_d'
        cloth174 = 'cf_o_top_army_n'
        cloth175 = 'o_top_maid_01_a'
        cloth176 = 'o_top_maid_01_b'
        cloth177 = 'o_top_maid_01_bot_a'
        cloth178 = 'errar es de boludos'
        cloth179 = 'o_top_maid_01_bot_b'
        cloth180 = 'o_cf_oni_top_d'
        cloth181 = 'o_cf_oni_top_d'
        cloth182 = 'cf_o_top_knight_d'
        cloth183 = 'cf_o_top_knight_n'
        cloth183 = 'o_top_suspend_a'
        cloth184 = 'cf_bot_floweP_d'
        cloth185 = 'cf_bot_floweP_n'
        cloth186 = 'cf_top_floweP_d'
        cloth187 = 'cf_top_floweP_n'
        cloth188 = 'o_top_fwanpi_b_a'
        cloth189 = 'o_top_fwanpi_b_b'
        cloth190 = 'o_top_fwanpi_t_a'
        cloth191 = 'o_top_fwanpi_t_b'
        cloth192 = 'cf_bot_floweP_d'
        cloth193 = 'cf_bot_floweP_n'
        cloth194 = 'cf_top_floweP_d'
        cloth195 = 'cf_top_floweP_n'
        cloth196 = 'cf_top_p_pareo_suke_d'
        cloth197 = 'cf_top_p_pareo_suke_d_u'
        cloth198 = 'cf_top_p_pareo_suke_n'
        cloth199 = 'cf_top_p_pareo_suke_n_u'
        cloth200 = 'cf_top_p_pareoS_d'
        cloth201 = 'cf_top_p_pareoS_n'
        cloth202 = 'cf_o_bot_sexypareo_d'
        cloth203 = 'cf_o_bot_sexypareo_d_u'
        cloth204 = 'cf_o_bot_sexypareo_n'
        cloth205 = 'cf_o_bot_sexypareo_n_u'
        cloth206 = 'cf_o_top_sexypareo_d'
        cloth207 = 'cf_o_top_sexypareo_d_u'
        cloth208 = 'cf_o_top_sexypareo_n'
        cloth209 = 'cf_o_top_sexypareo_n_u'
        cloth210 = 'cf_top_halloween_d'
        cloth211 = 'cf_top_halloween_n'
        cloth212 = 'cf_o_top_puffblouse_d'
        cloth213 = 'cf_o_top_puffblouse_n'
        cloth214 = 'cf_o_top_tuxedo_d'
        cloth215 = 'cf_o_top_tuxedo_n'
        cloth216 = 'cf_top_o_volumeneck_d'
        cloth217 = 'cf_top_volumeneck_n'
        cloth218 = 'cf_bot_wedding_a'
        cloth219 = 'cf_bot_wedding_b'
        cloth220 = 'cf_top_wedding_a'
        cloth221 = 'cf_top_wedding_b'
        cloth222 = 'cf_o_top_jmade_d'
        cloth223 = 'cf_o_top_jmade_n'
        cloth224 = 'cf_o_top_jmade_sode_d'
        cloth225 = 'cf_o_top_jmade_sode_n'
        cloth226 = 'o_top_stw_a'
        cloth227 = 'o_top_stw_b'
        cloth228 = 'o_hep_bot_a'
        cloth229 = 'o_hep_bot_b'
        cloth230 = 'o_hep_top_a'
        cloth231 = 'o_hep_top_b'
        cloth232 = 'cf_o_top_xmas_d'
        cloth233 = 'cf_o_top_xmas_n'
        cloth234 = 'cf_o_bot_backless_d_o'
        cloth235 = 'cf_o_bot_backless_d_u'
        cloth236 = 'cf_o_bot_backless_n'
        cloth237 = 'cf_o_top_backless_d_bottan'
        cloth238 = 'cf_o_top_backless_d_f'
        cloth239 = 'cf_o_top_backless_d_o'
        cloth240 = 'cf_o_top_backless_d_u'
        cloth241 = 'cf_o_top_backless_n'
        cloth243 = 'cf_o_top_backless_n_bottan'
        #from mods
        cloth244 = 'o_top_01_a'
        cloth245 = 'o_top_01_b'
        cloth246 = 'o_top_02_a'
        cloth247 = 'o_top_02_b'
        cloth248 = 'o_top_03_a'
        cloth249 = 'o_top_03_b'
        cloth250 = 'o_top_04_a'
        cloth251 = 'o_top_04_b'
        cloth252 = 'o_top_05_a'
        cloth253 = 'o_top_05_b'
        cloth254 = 'o_top_06_a'
        cloth255 = 'o_top_06_b'
        cloth256 = 'o_top_07_a'
        cloth257 = 'o_top_07_b'
        cloth258 = 'o_top_08_a'
        cloth259 = 'o_top_08_b'
        cloth260 = 'Dress Base Top'
        cloth261 = 'Dress Base Top Shift'
        # UnderCloth names:
        #jacket_a
        ucloth1 = 'o_inner_a'
        ucloth2 = 'o_inner_b'
        #inside top
        ucloth3 = 'o_top_inner01_cm'
        ucloth4 = 'o_top_inner02_cm_a'
        ucloth5 = 'Overcoat'
        ucloth6 = 'o_top_inner01_cm'
        ucloth7 = 'o_top_inner01_cm'
        ucloth8 = 'o_top_inner01_cm'
        # SIMP NAMES:
        #jacket_b
        simp1 = 'o_emblem_01_a'
        simp2 = 'o_emblem_01_b'
        simp3 = 'o_top_epron_emblem'
        simp4 = 'o_top_epron_emblem_b'
        simp5 = 'o_emblem_01_2_a'
        simp6 = 'o_emblem_01_b'
        simp7 = 'o_emblem_jacket02_a'
        simp8 = 'o_emblem_jacket02_b'
        simp9 = 'o_emblem_jacket03'
        simp10 = 'o_emblem_jacket03_b'
        simp11 = 'o_emblem_jacket04_a'
        simp12 = 'o_emblem_jacket04_b'
        simp13 = 'o_emblem_usagiP'
        simp14 = 'o_emblem_usagiP_b'
        simp15 = 'o_emblem_06_a'
        simp16 = 'o_emblem_06_b'
        simp17 = 'o_emblem_06_2_a'
        simp18 = 'o_emblem_06_2_b'
        simp19 = 'o_emblem_jacket07_a'
        simp20 = 'o_emblem_jacket07_b'
        simp21 = 'o_misya_jacket_emblem_a'
        simp22 = 'o_misya_jacket_emblem_b'
        #sailor
        simp23 = 'o_emblem_sailor01_01_a'
        simp24 = 'o_emblem_sailor01_01_b'
        simp25 = 'o_emblem'
        simp26 = 'o_emblem_b'
        simp27 = 'o_emblem_6'
        simp28 = 'o_emblem_6_b'
        #jacket_a
        simp29 = 'o_misya_jacket_emblem_a'
        simp30 = 'o_misya_jacket_emblem_b'
        #top
        simp31 = 'o_emblem_jacket01_cm'
        simp32 = 'o_emblem_05'
        simp33 = 'o_emblem_cm06'
        simp34 = 'o_emblem_jacket02_b'
        simp35 = 'o_emblem_normal02_a'
        simp36 = 'o_top_stw_emblem_a'
        simp37 = 'o_top_stw_emblem_b'
        #evaanxd mods
        simp38 = 'n_bot_a'
        simp39 = 'n_bot_b'
        simp40 = 'Back'
        simp41 = 'Fleco'
        simp42 = 'Fleco 2'
        simp43 = 'n_top_a'
        simp44 = 'n_top_b'
        simp45 = 'N_move'
        simp46 = 'Toko Hair 2'
        simp47 = 'Toko Hair'
        simp48 = 'Antenas'
        simp49 = 'Hair2'
        simp50 = 'Bodysuit Low'
        simp51 = 'Bodysuit Pecho'
        simp52 = 'BSL N'
        simp53 = 'BSP N'
        simp54 = 'Chaleko'
        simp55 = 'Chaleko N'
        simp56 = 'Fur'
        simp57 = 'Fur N'
        simp58 = 'n_shoes_Mina'
        simp59 = 'N_shoes_Camie'
        simp60 = 'n_shoes_jiro'
        simp61 = 'n_shoes_midnight'
        simp62 = 'n_shoes_momo'
        simp63 = 'n_shoes_MtLady'
        simp64 = 'N_shoes_nejire'
        simp65 = 'N_shoes_ochako'
        simp66 = 'N_shoes_tsuyu'
        simp67 = 'Camie Cabello'
        simp68 = 'Camie Cabello 2'
        simp69 = 'Jiro Ears'
        simp70 = 'Jiro Hair'
        simp71 = 'CabeioxD'
        simp72 = 'Cabeio Largo'
        simp73 = 'Cola'
        simp74 = 'Momo cabeio'
        simp75 = 'Cabeioxd'
        simp76 = 'Cuernos'
        simp77 = 'Mascara'
        simp78 = 'Cabello'
        simp79 = 'Cuernitosxd'
        simp80 = 'Armature.002'
        simp81 = 'è›™å¹ã™æ¢…é›¨_arm'
        simp82 = 'CosasxD'
        simp83 = 'Guantes'
        simp84 = 'n_gloves_mtlady'
        simp85 = 'glovesarmr'
        simp86 = 'gluvs'
        simp87 = 'o_gloves_nejire'
        simp88 = 'CinturoncillosxD'
        simp89 = 'N_glove_tsuyu'
        simp90 = 'Cuello'
        simp91 = 'Mangas'
        simp92 = 'Zipper'
        simp93 = 'camiseta'
        simp94 = 'camisetaN'
        simp95 = 'chaketaN'
        simp96 = 'chaketaxD'
        simp97 = 'Malla bot'
        simp98 = 'Malla bot nude'
        simp99 = 'Malla top'
        simp100 = 'Malla top nude'
        simp101 = 'Malla Bot'
        simp102 = 'Malla Bot N'
        simp103 = 'Malla Top'
        simp104 = 'Malla Top N'
        simp105 = 'Pecho'
        simp106 = 'Pecho N'
        simp107 = 'Cinturon'
        simp108 = 'Esferas'
        simp109 = 'Collar'
        simp110 = 'Remera'
        simp111 = 'Cinturon Tsuyu'
        simp112 = 'Mediasxd'
        simp113 = 'book'
        simp114 = 'Goggles'
        simp115 = 'Mei Hair'
        simp116 = 'n_top_meigloves'
        simp117 = 'Buzo'
        simp118 = 'BuzoN'
        simp119 = 'Mangas'
        simp120 = 'MangasN'
        simp121 = 'Pants'
        simp122 = 'Musculosa'
        simp123 = 'MusculosaN'
        simp124 = 'Vest'
        simp125 = 'VestN'
        simp126 = 'Pendant'
        simp127 = 'n_shoes_tsunade'
        simp128 = 'Main'
        simp129 = 'Main N'
        simp130 = 'Skirt'
        simp131 = 'Skirt N'
        simp132 = 'capitaxd'
        simp133 = 'main'
        simp134 = 'n_shoes_ino'
        simp135 = 'Ino Bandana'
        simp136 = 'Ino Cola Corta'
        simp137 = 'Ino Cola Larga'
        simp138 = 'Ino Hair Base'
        simp139 = 'n_gloves_ino'
        simp140 = 'banda'
        simp141 = 'falda'
        simp142 = 'Ino Bag'
        simp143 = 'Adorno'
        simp144 = 'Hinata Cabeio'
        simp145 = 'Hair Y'
        simp146 = 'n_shoes_hinata'
        # giuls
        simp147 = 'Wolf Tail_mesh'
        simp148 = 'Wolf Ears_mesh'
        simp149 = 'Wolf Ears_mesh.001'
        simp150 = 'Angel Wings_mesh'
        simp151 = 'Angel Wings_mesh.001'
        simp152 = 'Chimera Wings_mesh'
        simp153 = 'Chimera Wings_mesh.001'
        simp154 = 'Dragon Wings_mesh'
        simp155 = 'Dragon Wings_mesh.001'
        simp156 = 'Cute_mesh'
        simp157 = 'acs_kuma_mimi_L_0'
        simp158 = 'acs_kuma_mimi_R_0'
        simp159 = 'acs_risu_mimi_L_0'
        simp160 = 'acs_risu_mimi_R_0'
        simp161 = 'acs_risu_sipo_01_0'
        simp162 = 'o_acs_usamimiribbon_0'
        simp163 = 'Sunhat_mesh'
        simp164 = 'Simple Cape_mesh'
        simp165 = 'Fluffy Cape_mesh'
        simp166 = 'Gakuranesque Long Coat_mesh'
        simp167 = 'Long Coat V1_mesh'
        simp168 = 'Long Coat V2_mesh'
        simp169 = 'Long Fluffy Coat 1_mesh'
        simp170 = 'Long Fluffy Coat 2_mesh'
        simp171 = 'Shoulder Cape_mesh'
        simp172 = 'Shoulder Coat 1_mesh'
        simp173 = 'Shoulder Coat 2_mesh'
        simp174 = 'Epatulets 1 L_mesh'
        simp175 = 'Epatulets 1 R_mesh'
        simp176 = 'Epatulets 2 L_mesh'
        simp177 = 'Epatulets 2 R_mesh'
        simp178 = 'Scarf_mesh'
        simp179 = 'Scarf Short_mesh'
        simp180 = 'Rapier A Silver_mesh'
        simp181 = 'Rapier B Silver_mesh'
        simp182 = 'Rapier C Silver_mesh'
        simp183 = 'Rapier D Silver_mesh'
        simp184 = 'Rapier E Silver_mesh'
        simp185 = 'Rapier F Silver_mesh'
        simp186 = 'Clock_mesh'
        simp187 = 'Pw_mesh'
        simp188 = 'Pw Close_mesh'
        simp189 = 'Phantom spirit_mesh'
        simp190 = 'Ethereal Halo_mesh'
        simp191 = 'Halo Stars_mesh'
        simp192 = 'Horn Halo_mesh'
        simp193 = 'Light Halo_mesh'
        simp194 = 'Radiant Halo_mesh'
        simp195 = 'Ridged Horn Halo_mesh_MeshPart0'
        simp196 = 'Ridged Horn Halo_mesh_MeshPart1'
        simp197 = 'Simple Halo_mesh'
        simp198 = 'Star Halo_mesh'
        simp199 = 'Knives 2 L_mesh'
        simp200 = 'Knives 2 R_mesh'
        simp201 = 'Knives 3 L_mesh'
        simp202 = 'Knives 3 R_mesh'
        simp203 = 'Kitsune Tail_mesh'
        simp204 = 'Kitsune Tail_mesh.001'
        simp205 = 'Kitsune Tail_mesh.002'
        simp206 = 'Kitsune Tail_mesh.003'
        simp207 = 'Kitsune Tail_mesh.004'
        simp208 = 'Kitsune Tail_mesh.005'
        simp209 = 'Kitsune Tail_mesh.006'
        simp210 = 'Kitsune Tail_mesh.007'
        simp211 = 'Kitsune Tail_mesh.008'
        simp212 = 'Kitsune Ears_mesh'
        simp213 = 'Kitsune Ears_mesh.001'
        simp214 = 'Holland Scarf_mesh'
        simp215 = 'Heart Eyepatch_mesh'
        simp216 = 'Heart Eyepatch M_mesh'
        simp217 = 'Hat_mesh'
        simp218 = 'Oscar Hat_mesh'
        simp219 = 'Carnation_mesh'
        simp220 = 'Rose_mesh'
        simp221 = 'Floor Of Roses_mesh.002'
        simp222 = 'Horns_mesh'
        simp223 = 'Horns_mesh.001'
        simp224 = 'Horns 2_mesh'
        simp225 = 'Horns 2_mesh.001'
        simp226 = 'Cyber Sostice Headset _mesh'
        simp227 = 'Cyber Sostice Headset _mesh.001'
        simp228 = 'Crown_mesh'
        simp229 = 'Cravat 1_mesh'
        simp230 = 'Cravat 2_mesh'
        simp231 = 'Cravat 3_mesh'
        simp232 = 'Cravat 4_mesh'
        simp233 = 'Cat Tail_mesh'
        simp234 = 'Cat Ears_mesh'
        simp235 = 'Cat Ears_mesh.001'
        simp236 = 'Cape_mesh'
        simp237 = 'Cape Short_mesh'
        simp238 = 'Bun Cover_mesh'
        simp239 = 'Cage_mesh'
        simp240 = 'Big Hat_mesh'
        simp241 = 'Salieri Head_mesh'
        simp242 = 'Salieri Head 2_mesh'
        simp243 = 'Abigail Hairpiece_mesh'
        # evaan again xd
        simp244 = 'Cabeio'
        simp245 = 'ChalequitoxD'
        simp246 = 'Armature.002'
        simp247 = 'bolsitasxd'
        simp248 = 'Cuellitoxd'
        simp249 = 'N_midoriya_gloves'
        simp250 = 'Armature.003'
        simp251 = 'N_midoriya_shoes'
        simp252 = 'Tirante'
        simp253 = 'Brazalete'
        simp254 = 'Armor'
        simp255 = 'o_gloves_tifa'
        simp256 = 'o_shoes_tifa'
        simp257 = 'Colaxd'
        simp258 = 'N_glove_mirko'
        simp259 = 'OrejillasxD'
        simp260 = 'cf_o_shoes_mirko'
        simp261 = 'Motorxd'
        simp262 = 'cf_o_tracer_glove'
        simp263 = 'cf_o_glove_diane_low'
        simp264 = 'n_chousei'
        simp265 = 'cf_o_dva_glove'
        simp266 = 'cf_o_glove_diane_low'
        simp267 = 'N_gun'
        simp268 = 'cf_o_shoes_dva'
        simp269 = 'N_wings'
        simp270 = 'cf_o_albedo_glove'
        # Pants names:
        #co_bot #full koikatsu
        pants1 = 'cf_o_bot_cheerSK_d'
        pants2 = 'cf_o_bot_cheerSK_n'
        pants3 = 'o_bot_culloteSK_d'
        pants4 = 'o_bot_culloteSK_n'
        pants5 = 'o_bot_shortdenim'
        pants6 = 'cf_o_bot_d_Gymteacher'
        pants7 = 'o_bot_halfpants'
        pants8 = 'cf_o_bot_Heteacher_d_00'
        pants9 = 'cf_o_bot_Heteacher_n_00'
        pants10 = 'cf_o_bot_kyuudou_d_00'
        pants11 = 'cf_o_bot_kyuudou_n_00'
        pants12 = 'cf_o_bot_mankenSK_d_00'
        pants13 = 'cf_o_bot_mankenSK_n_00'
        pants14 = 'cf_o_bot_reinaSK_d'
        pants15 = 'cf_o_bot_reinaSK_n'
        pants16 = 'o_bot_pajama_a'
        pants17 = 'o_bot_pants01_a'
        pants18 = 'o_bot_pants01_b'
        pants19 = 'o_bot_pants02_a'
        pants20 = 'o_bot_pants03'
        pants21 = 'o_bot_pants03_2'
        pants22 = 'o_bot_pants04_cargo'
        pants23 = 'o_bot_pants05_jajim_a'
        pants24 = 'o_bot_pants05_jajimsk_a'
        pants25 = 'o_bot_pants05_jajimsk_b'
        pants26 = 'o_bot_pantshot_a'
        pants27 = 'cf_o_bot_run_d'
        pants28 = 'cf_o_bot_run_n'
        pants29 = 'o_bot_skirt01_a'
        pants30 = 'o_bot_skirt01_b'
        pants31 = 'o_bot_skirt02_a'
        pants32 = 'o_bot_skirt02_b'
        pants33 = 'o_bot_skirt03_a'
        pants34 = 'o_bot_skirt03_b'
        pants35 = 'o_bot_skirt04_a'
        pants36 = 'o_bot_skirt04_b'
        pants37 = 'o_bot_skirt05_a'
        pants38 = 'o_bot_skirt05_b'
        pants39 = 'o_bot_skirt06_a'
        pants40 = 'o_bot_skirt06_b'
        pants41 = 'o_bot_tskfrill_a'
        pants42 = 'o_bot_tskfrill_b'
        pants43 = 'o_bot_skirt_frea'
        pants44 = 'o_bot_skirt_frea_b'
        pants45 = 'o_bot_skirt09_a'
        pants46 = 'o_bot_skirt09_b'
        pants47 = 'o_bot_spants_a'
        pants48 = 'cf_o_bot_tennis_d'
        pants49 = 'cf_o_bot_tennis_n'
        pants50 = 'o_bot_tskmini_a'
        pants51 = 'o_bot_tskmini_b'
        pants52 = 'o_bot_magic_a'
        pants53 = 'o_bot_magic_b'
        pants54 = 'cf_swimbot_cattube_d'
        pants55 = 'cf_swimbot_cattube_n'
        pants56 = 'cf_o_bot_army_d'
        pants57 = 'cf_o_bot_army_n'
        pants58 = 'o_bot_maid_01_a'
        pants59 = 'o_bot_maid_01_b'
        pants60 = 'o_cf_oni_bot_nasi_d'
        pants61 = 'o_cf_oni_bot_ari_d'
        pants62 = 'o_cf_oni_bot_ari_n'
        pants63 = 'o_bot_misya_a'
        pants64 = 'o_bot_misya_b'
        pants65 = 'cf_o_bot_knightSK_d'
        pants66 = 'cf_o_bot_knightSK_n'
        pants67 = 'cf_o_bot_pareo_d'
        pants68 = 'cf_o_bot_pareo_d_u'
        pants69 = 'cf_o_bot_pareo_n'
        pants70 = 'cf_o_bot_pareo_n_u'
        pants71 = 'cf_o_bot_pumpkin'
        pants72 = 'cf_bot_furiruSK_d'
        pants73 = 'cf_bot_furiruSK_d_al_o'
        pants74 = 'cf_bot_furiruSK_d_al_u'
        pants75 = 'cf_bot_furiruSK_n'
        pants76 = 'cf_bot_furiruSK_n_al_o'
        pants77 = 'cf_bot_furiruSK_n_al_u'
        pants78 = 'cf_o_bot_tuxedo'
        pants79 = 'cf_bot_jmade_d'
        pants80 = 'cf_bot_jmade_n'
        pants81 = 'o_bot_stw_a'
        pants82 = 'o_bot_stw_b'
        pants83 = 'cf_o_botxmas_d'
        pants84 = 'cf_o_botxmas_n'
        #from mods
        pants85 = 'high-waist_skirt_a'
        pants86 = 'high-waist_skirt_suspenders'
        pants87 = 'Dress Base Bottom'
        pants88 = 'Dress Bottom Shift'
        pants89 = 'o_panst_00_a'
        # Shoes names:
        #co_shoes #full koikatsu
        shoes1 = 'o_shoes_benjosand'
        shoes2 = 'o_shoes_bootsbelt'
        shoes3 = 'o_shoes_bsand'
        shoes4 = 'cf_o_shoes_cheersboot'
        shoes5 = 'o_shoes_demis'
        shoes6 = 'o_shoes_flowersand'
        shoes7 = 'o_shoes_idol'
        shoes8 = 'cf_o_shoes_manken'
        shoes9 = 'o_shoes_pumps01'
        shoes10 = 'cf_o_shoes_pumpsR'
        shoes11 = 'cf_o_shoes_reina'
        shoes12 = 'cf_o_shose_ribonstrap'
        shoes13 = 'cf_o_shoes_rina'
        shoes14 = 'o_shoes_roafer01'
        shoes15 = 'o_shoes_run01'
        shoes16 = 'cf_o_shoes_tennis'
        shoes17 = 'o_shoes_uwabaki01'
        shoes18 = 'cf_O_shoes_zouri'
        shoes19 = 'o_shoes_nursec_a'
        shoes20 = 'o_shoes_magic_s'
        shoes21 = 'cf_shoes_army_boots'
        shoes22 = 'o_shoes_maid_01'
        shoes23 = 'cf_o_shoes_oni'
        shoes24 = 'cf_o_shoes_knight'
        shoes25 = 'o_armorboot_a'
        shoes26 = 'o_shoes_fsand2'
        shoes27 = 'cf_o_shoes_summer'
        shoes28 = 'cf_shoes_shell'
        shoes29 = 'cf_shoes_halloween'
        shoes30 = 'cf_shoes_o_amiageL'
        shoes31 = 'cf_shoes_formal'
        shoes32 = 'cf_shoes_o_wedding'
        shoes33 = 'cf_shoes_o_laceupS'
        shoes34 = 'o_shoes_stw'
        shoes35 = 'cf_o_shoes_xmas'
        #from mods
        shoes36 = '27_pantsenv_1_0_0'
        shoes37 = 'Star'
        shoes38 = 'Star Kicks'
        shoes39 = 'Boots'
        shoes40 = 'Heels'
        shoes41 = 'o_shoes_cheershort'
        # Socks names: #full koikatsu
        socks1 = 'o_socks_ankle'
        socks2 = 'o_socks_crewori'
        socks3 = 'o_socks_foot01'
        socks4 = 'o_socks_garter01'
        socks5 = 'o_socks_high01'
        socks6 = 'o_socks_idol'
        socks7 = 'o_socks_knee01'
        socks8 = 'o_socks_kneefrill'
        socks9 = 'cf_o_shoes_kyuudou_tabi'
        socks10 = 'o_socks_legwarmer'
        socks11 = 'o_socks_loose01'
        socks12 = 'cf_o_socks_manken'
        socks13 = 'o_socks_magic'
        socks14 = 'o_socks_meka'
        socks15 = 'cf_o_socks_knight'
        socks16 = 'cf_socks_halloween'
        socks17 = 'cf_o_socks_xmas'
        # Calza names:
        #co_panst
        # Bra names:
        #co_bra full
        bra1 = 'o_bra_a'
        bra2 = 'o_bra_b'
        bra3 = 'o_braa_b'
        bra4 = 'o_bra_a_sode'
        bra5 = 'o_bra_b_sode'
        bra6 = 'o_top_swim02_op1'
        bra7 = 'o_top_swim02_op1_b'
        bra8 = 'o_top_swim02_op2'
        bra9 = 'o_meka_z_suit_top_neck'
        bra10 = 'o_op_01'
        bra11 = 'o_op_02'
        bra12 = 'o_op02'
        bra13 = 'o_top_micro_op1'
        bra14 = 'o_top_bikiniF_op1'
        bra15 = 'o_top_bikiniF_op1_b'
        bra16 = 'Bikini Top'
        bra17 = 'Bikini Top Shift'
        # Panties names: 
        #co_short #full koikatsu
        short1 = 'o_shorts_a'
        short2 = 'o_shorts_b'
        short3 = 'o_shorts_c'
        short4 = 'o_bot_a'
        short5 = 'o_bot_b'
        short6 = 'o_bot_bikiniF_op1'
        short7 = 'o_bot_swim02_op1'
        short8 = 'ellamueveto'
        short9 = 'o_swim03_bot_op_a'
        short10 = 'o_swim04_bot_a'
        short11 = 'o_swim04_bot_b'
        short12 = 'o_swim04_bot_op_a'
        short13 = 'o_swim04_bot_op_b'
        short14 = 'o_bot_micro_op1'
        short15 = 'zoid_was_here'
        #inside bra files
        short16 = 'cf_o_swim_SC_bot_a'
        short17 = 'cf_o_swim_SC_bot_b'
        short18 = 'cf_o_swim_SC_bot_c'
        short19 = 'o_body_allbodytights_bot_a'
        short20 = 'o_body_allbodytights_bot_b'
        #from mods
        short21 = 'o_panst_spats01'
        short22 = 'o_body_allbodytights_bot_b'
        short23 = 'Bikini Bottom.001'
        short24 = 'Bikini Bottom Shift.001'
        # Backeye A names: #full koikatsu
        beye1 = 'cf_Ohitomi_L'
        beye2 = 'cf_Ohitomi_L_2'
        beye3 = 'cf_Ohitomi_L_3'
        beye4 = 'cf_Ohitomi_L_4'
        beye5 = 'cf_Ohitomi_L_5'
        # Backeye B names: #more control more power
        beyeb1 = 'cf_Ohitomi_R'
        beyeb2 = 'cf_Ohitomi_R_2'
        beyeb3 = 'cf_Ohitomi_R_3'
        beyeb4 = 'cf_Ohitomi_R_4'
        beyeb5 = 'cf_Ohitomi_R_5'
        # Eye A names: #full koikatsu
        eye1 = 'cf_Ohitomi_L02'
        eye2 = 'cf_Ohitomi_L02_2'
        eye3 = 'cf_Ohitomi_L02_3'
        eye4 = 'cf_Ohitomi_L02_4'
        eye5 = 'cf_Ohitomi_L02_5'
        # Eye B names: #more control more power
        eyeb1 = 'cf_Ohitomi_R02'
        eyeb2 = 'cf_Ohitomi_R02_2'
        eyeb3 = 'cf_Ohitomi_R02_3'
        eyeb4 = 'cf_Ohitomi_R02_4'
        eyeb5 = 'cf_Ohitomi_R02_5'
        # Eyeline names: #full koikatsu
        eline1 = 'cf_O_eyeline'
        eline2 = 'cf_O_eyeline_2'
        eline3 = 'cf_O_eyeline_3'
        eline4 = 'cf_O_eyeline_4'
        eline5 = 'cf_O_eyeline_5'
        # Noseline names: #full koikatsu
        nose1 = 'cf_O_noseline'
        nose2 = 'cf_O_noseline_2'
        nose3 = 'cf_O_noseline_3'
        nose4 = 'cf_O_noseline_4'
        nose5 = 'cf_O_noseline_5'
        # Mayuge names: #full koikatsu
        mayu1 = 'cf_O_mayuge'
        mayu2 = 'cf_O_mayuge_2'
        mayu3 = 'cf_O_mayuge_3'
        mayu4 = 'cf_O_mayuge_4'
        mayu5 = 'cf_O_mayuge_5'
        # Tooth names: #full koikatsu
        tooth1 = 'cf_O_tooth'
        tooth2 = 'cf_O_tooth_2'
        tooth3 = 'cf_O_tooth_3'
        tooth4 = 'cf_O_tooth_4'
        tooth5 = 'cf_O_tooth_5'
        # Tongue names: #full koikatsu
        tong1 = 'o_tang'
        tong2 = 'o_tang_2'
        tong3 = 'o_tang_3'
        tong4 = 'o_tang_4'
        tong5 = 'o_tang_5'
        # Accesories names:
        #hair accs
        accs1 = 'cf_acs_idol_b_ribon_00'
        accs2 = 'cf_acs_b_05_00_L'
        accs3 = 'cf_acs_b_05_00_R'
        accs4 = 'cf_acs_b_05_00'
        accs5 = 'cf_acs_b_05_01'
        accs6 = 'cf_acs_b_05_02'
        accs7 = 'cf_acs_b_06_00'
        accs8 = 'cf_acs_b_07_00_L'
        accs9 = 'cf_acs_b_7_00_R'
        accs10 = 'cf_acs_b_09_00'
        accs11 = 'cf_acs_b_09_01'
        accs12 = 'cf_acs_10_ribon_00'
        accs13 = 'cf_acs_11_b_ribon_00'
        accs14 = 'cf_acs_b_15_00'
        accs15 = 'cf_acs_b_16_00'
        accs16 = 'cf_acs_b_19_00'
        accs17 = 'cf_acs_b_102_00'
        accs18 = 'cf_acs_b_103_00'
        accs19 = 'cf_acs_b_104_00_L'
        accs20 = 'cf_acs_b_104_00_R'
        accs21 = 'cf_acs_b_105_00_L'
        accs22 = 'cf_acs_b_105_00_R'
        accs23 = 'cf_acs_b_107_00_L'
        accs24 = 'cf_acs_b_107_00_R'
        accs25 = 'cf_acs_b_108_00_L'
        accs26 = 'cf_acs_b_108_00_R'
        accs27 = 'cf_acs_b_109_00_L'
        accs28 = 'cf_acs_b_109_00_R'
        accs29 = 'cf_acs_b_110_00_L'
        accs30 = 'cf_acs_b_110_00_R'
        accs31 = 'cf_acs_b_115_00'
        accs32 = 'cf_acs_b_115_01'
        accs33 = 'cf_acs_b_116_00'
        accs34 = 'cf_acs_b_23_00'
        accs35 = 'cf_acs_b_119_00_L'
        accs36 = 'cf_acs_b_119_00_R'
        accs37 = 'cf_acs_b_24_00'
        accs38 = 'cf_acs_b_balet_00'
        accs39 = 'cf_acs_b_balet_01'
        accs40 = 'cf_acs_idol_hair_f_03'
        accs41 = 'cf_acs_f_03_00'
        accs42 = 'cf_acs_09_ribon_00'
        accs43 = 'cf_acs_02_ribon_00'
        #inside jacket_c
        accs44 = 'o_top_deco01'
        accs45 = 'o_top_deco02'
        accs46 = 'o_top_deco03'
        accs47 = 'o_top_deco04'
        accs48 = 'o_top_deco05'
        accs49 = 'o_misya_deco'
        accs50 = 'o_top_deco01'
        accs51 = 'o_top_deco02'
        accs52 = 'o_top_deco03'
        accs53 = 'o_top_deco04'
        accs54 = 'o_top_deco05'
        accs55 = 'o_misya_deco'
        #from mods
        accs56 = 'acs_neck_catchorker'
        accs57 = 'o_head_ribbon_hoso2'
        accs58 = 'o_robe_hood_1'
        accs59 = 'o_robe_mant_u1'
        accs60 = 'o_Dogtag_Chain1'
        accs61 = 'o_Dogtag1'
        accs62 = 'O_necklace01'
        accs63 = 'O_necklace02'
        accs64 = 'O_necklace03'
        accs65 = 'O_necklace04'
        accs66 = 'O_necklace05'
        accs67 = 'o_chain'
        accs68 = 'o_top_deco02_2'
        accs69 = 'o_top_deco03_2'
        accs70 = 'Bat'
        accs71 = 'Bat Shift'
        accs72 = 'Bikinii Deco'
        accs73 = 'Belt'
        accs74 = 'Buttons'
        accs75 = 'Buttons Shift'
        accs76 = 'Choker'
        accs77 = 'Bikini Bottom Deco.001'
        accs78 = 'Hair Bands'
        #Dont edit this#
        bpy.ops.object.select_all(action='DESELECT') # Deselecciona todo en la escena
        #############################################################################
        for o in ("cf_O_eyeline_low", "Highlight_cf_O_face_rend", "Highlight_o_body_a_rend", "o_shadowcaster"):
            obj = bpy.context.scene.objects.get(o)
            #if obj: obj.hide_viewport = False
            if obj is not None:
                obj.hide_set(True)
                obj.hide_render = True
        bpy.ops.object.select_all(action='DESELECT') # Deselecciona todo en la escena
        w = bpy.data.objects.get
        bpimg = bpy.data.images.get
        #####################################BODY####################################
        bpy.ops.object.select_all(action='DESELECT') # Deselecciona todo en la escena
        # Get body object
        bodies = (w(body1),w(body2),w(body3),w(body4),w(body5))
        for x in bodies:
            if x is not None:
                #if bpy.data.objects.get(body1) is not None:
                op = (x.name)
                bpy.data.objects.get(op).select_set(True)
                outline_body = bpy.data.objects.get(op)
                bpy.context.view_layer.objects.active = outline_body
                #if bpy.data.objects.get(body2) is not None:
                #    bpy.data.objects.get(body2).select_set(True)
                #    outline_body = bpy.data.objects.get(body2)
                #    bpy.context.view_layer.objects.active = outline_body
                #these are old lines, not worthy but hey, my first code
                ob = bpy.context.selected_objects
                material_set = set()
                for object in bpy.context.selected_objects:
                    for material in object.material_slots:
                        material_set.add(material)
                for material in material_set:
                #    print(material.name)
                    Tex = material.name
                    bpy.data.scenes['Scene'].sna_color01 = bpy.data.materials[Tex].node_tree.nodes['Principled BSDF'].inputs[0].default_value
                    #  print(Tex+'_MainTex.png')
                    TexMain = Tex+'_MainTex.png'
                    TexDetailM = Tex+'_DetailMask.png'
                    TexLineM = Tex+'_LineMask.png'
                    TexNormal = Tex+'_NormalMap.png'
                    TexNormalDetail = Tex+'_NormalMapDetail.png'
                    TexOver1 = Tex+'_overtex1.png'
                    TexOver2 = Tex+'_overtex2.png'
                    TexAlphaM = Tex+'_AlphaMask.png'
                    TexLiquidM = Tex+'_liquidmask.png'
                    TexTex2 = Tex+'_Texture2.png'
                    TexTex3 = Tex+'_Texture3.png'
                mat = bpy.data.materials[Tex]
                #Get the node in its node tree (replace the name below)
                node_to_delete =  mat.node_tree.nodes['Principled BSDF']
                node_to_delete2 =  mat.node_tree.nodes['Material Output']
                #Remove it
                mat.node_tree.nodes.remove( node_to_delete )
                mat.node_tree.nodes.remove( node_to_delete2 )
                bpy.data.images['cf_m_body_MainTex.png'].name = TexMain 
                bpy.data.images['cf_m_body_DetailMask.png'].name = TexDetailM
                bpy.data.images['cf_m_body_LineMask.png'].name = TexLineM
                bpy.data.images['cf_m_body_NormalMap.png'].name = TexNormal
                bpy.data.images['cf_m_body_NormalMapDetail.png'].name = TexNormalDetail
                bpy.data.images['cf_m_body_overtex1.png'].name = TexOver1
                bpy.data.images['cf_m_body_overtex2.png'].name = TexOver2
                bpy.data.images['cf_m_body_AlphaMask.png'].name = TexAlphaM
                bpy.data.images['cf_m_body_liquidmask.png'].name = TexLiquidM
                bpy.data.images['cf_m_body_Texture2.png'].name = TexTex2
                bpy.data.images['cf_m_body_Texture3.png'].name = TexTex3
                C = bpy.context

                def instantiate_group(nodes, data_block_name):
                    group = nodes.new(type='ShaderNodeGroup')
                    group.node_tree = bpy.data.node_groups['KK-Template Body']
                    return group
                instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
                my_mat = bpy.data.materials.get(Tex)
                bpy.data.node_groups['KK-Template Body'].name = 'KK-Template Body '+Tex
                node = bpy.data.node_groups['KK-Template Body '+Tex]
                #node.extension = 'CLIP'
                #node.image = bpy.data.images[bakefinal.name]
                nodes = my_mat.node_tree.nodes
                for node in nodes:
                    node.select = False
                    node.select = True
                    nodes.active = node
                try:
                    initial_area_type = bpy.context.area.type
                    bpy.context.area.type = 'NODE_EDITOR'
                    bpy.context.area.ui_type = 'ShaderNodeTree'
                    bpy.ops.wm.redraw_timer(type='DRAW_WIN', iterations=1)
                    bpy.ops.node.group_ungroup()
                    bpy.ops.node.group_edit(exit=True)
                except Exception as e:
                    print(e)
                finally:
                    bpy.context.area.type = initial_area_type
                bpy.context.object.active_material.blend_method = 'CLIP'
                bpy.context.object.active_material.shadow_method = 'CLIP'
        bpy.ops.object.select_all(action='DESELECT') # Deselecciona todo en la escena
        ####################################FACE#####################################
        bpy.ops.object.select_all(action='DESELECT') # Deselecciona todo en la escena
        # Get face object
        faces = (w(face1),w(face2),w(face3),w(face4),w(face5))
        for x in faces:
            if x is not None:
                #if bpy.data.objects.get(face1) is not None:
                op = (x.name)
                bpy.data.objects.get(op).select_set(True)
                outline_face = bpy.data.objects.get(op)
                bpy.context.view_layer.objects.active = outline_face
                ob = bpy.context.selected_objects
                material_set = set()
                for object in bpy.context.selected_objects:
                    for material in object.material_slots:
                        material_set.add(material)
                for material in material_set:
                #    print(material.name)
                    Tex = material.name
                    MatFace = Tex
                    bpy.data.scenes['Scene'].sna_color02 = bpy.data.materials[Tex].node_tree.nodes['Principled BSDF'].inputs[0].default_value
                #  print(Tex+'_MainTex.png')
                    TexMain = Tex+'_MainTex.png'
                    TexDetailM = Tex+'_DetailMask.png'
                    TexNormalM = Tex+'_NormalMask.png'
                    TexOver2 = Tex+'_overtex2.png'
                    TexOver3 = Tex+'_overtex3.png'
                    TexLiquidM = Tex+'_liquidmask.png'
                    TexTex2 = Tex+'_Texture2.png'
                    TexTex3 = Tex+'_Texture3.png'
                mat = bpy.data.materials[Tex]
                #Get the node in its node tree (replace the name below)
                node_to_delete =  mat.node_tree.nodes['Principled BSDF']
                node_to_delete2 =  mat.node_tree.nodes['Material Output']
                #Remove it
                mat.node_tree.nodes.remove( node_to_delete )
                mat.node_tree.nodes.remove( node_to_delete2 )
                bpy.data.images['cf_m_face_00_MainTex.png'].name = TexMain 
                bpy.data.images['cf_m_face_00_DetailMask.png'].name = TexDetailM
                bpy.data.images['cf_m_face_00_NormalMask.png'].name = TexNormalM
                bpy.data.images['cf_m_face_00_overtex2.png'].name = TexOver2
                bpy.data.images['cf_m_face_00_overtex3.png'].name = TexOver3
                bpy.data.images['cf_m_face_00_liquidmask.png'].name = TexLiquidM
                bpy.data.images['cf_m_face_00_Texture2.png'].name = TexTex2
                bpy.data.images['cf_m_face_00_Texture3.png'].name = TexTex3 
                C = bpy.context

                def instantiate_group(nodes, data_block_name):
                    group = nodes.new(type='ShaderNodeGroup')
                    group.node_tree = bpy.data.node_groups['KK-Template Face']
                    return group
                instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
                my_mat = bpy.data.materials.get(Tex)
                bpy.data.node_groups['KK-Template Face'].name = 'KK-Template Face '+Tex
                node = bpy.data.node_groups['KK-Template Face '+Tex]
                #node.extension = 'CLIP'
                #node.image = bpy.data.images[bakefinal.name]
                nodes = my_mat.node_tree.nodes
                for node in nodes:
                    node.select = False
                    node.select = True
                    nodes.active = node
                try:
                    initial_area_type = bpy.context.area.type
                    bpy.context.area.type = 'NODE_EDITOR'
                    bpy.context.area.ui_type = 'ShaderNodeTree'
                    bpy.ops.wm.redraw_timer(type='DRAW_WIN', iterations=1)
                    bpy.ops.node.group_ungroup()
                    bpy.ops.node.group_edit(exit=True)
                except Exception as e:
                    print(e)
                finally:
                    bpy.context.area.type = initial_area_type
        bpy.ops.object.select_all(action='DESELECT') # Deselecciona todo en la escena
        ########HAIR FRONT########
        bpy.ops.object.select_all(action='DESELECT') # Deselecciona todo en la escena
        # Get hairf object
        hairfronts = (w(hairf1) ,w(hairf2) ,w(hairf3) ,w(hairf4) ,w(hairf5) ,w(hairf6) ,w(hairf7) ,w(hairf8) ,w(hairf9) ,w(hairf10) ,w(hairf11) ,w(hairf12) ,w(hairf13) ,w(hairf14) ,w(hairf15) ,w(hairf16) ,w(hairf17) ,w(hairf18) ,w(hairf19) ,w(hairf20) ,w(hairf21) ,w(hairf22) ,w(hairf23) ,w(hairf24) ,w(hairf25) ,w(hairf26) ,w(hairf27) ,w(hairf28) ,w(hairf29) ,w(hairf30) ,w(hairf31) ,w(hairf32) ,w(hairf33) ,w(hairf34) ,w(hairf35) ,w(hairf36) ,w(hairf37) ,w(hairf38) ,w(hairf39) ,w(hairf40) ,w(hairf41) ,w(hairf42) ,w(hairf43) ,w(hairf44) ,w(hairf45) ,w(hairf46) ,w(hairf47) ,w(hairf48) ,w(hairf49) ,w(hairf50) ,w(hairf51) ,w(hairf52) ,w(hairf53) ,w(hairf54) ,w(hairf55) ,w(hairf56) ,w(hairf57) ,w(hairf58) ,w(hairf59) ,w(hairf60) ,w(hairf61) ,w(hairf62) ,w(hairf63) ,w(hairf64) ,w(hairf65) ,w(hairf66) ,w(hairf67) ,w(hairf68) ,w(hairf69) ,w(hairf70) ,w(hairf71) ,w(hairf72) ,w(hairf73) ,w(hairf74) ,w(hairf75) ,w(hairf76) ,w(hairf77) ,w(hairf78) ,w(hairf79) ,w(hairf80) ,w(hairf81) ,w(hairf82) ,w(hairf83) ,w(hairf84) ,w(hairf85) ,w(hairf86) ,w(hairf87) ,w(hairf88) ,w(hairf89) ,w(hairf90) ,w(hairf91) ,w(hairf92) ,w(hairf93) ,w(hairf94) ,w(hairf95) ,w(hairf96) ,w(hairf97) ,w(hairf98) ,w(hairf99) ,w(hairf100) ,w(hairf101) ,w(hairf102) ,w(hairf103) ,w(hairf104) ,w(hairf105) ,w(hairf106) ,w(hairf107) ,w(hairf108) ,w(hairf109) ,w(hairf110) ,w(hairf111) ,w(hairf112) ,w(hairf113) ,w(hairf114) ,w(hairf115) ,w(hairf116) ,w(hairf117) ,w(hairf118) ,w(hairf119) ,w(hairf120) ,w(hairf121) ,w(hairf122) ,w(hairf123) ,w(hairf124) ,w(hairf125) ,w(hairf126) ,w(hairf127) ,w(hairf128) ,w(hairf129) ,w(hairf130) ,w(hairf131) ,w(hairf132) ,w(hairf133) ,w(hairf134) ,w(hairf135) ,w(hairf136) ,w(hairf137) ,w(hairf138))
        for ob_hf in hairfronts:
            if ob_hf is not None:
                #if bpy.data.objects.get(body1) is not None:
                op = (ob_hf.name)
                bpy.data.objects.get(op).select_set(True)
                outline_hfront = bpy.data.objects.get(op)
                bpy.context.view_layer.objects.active = outline_hfront
                ob = bpy.context.selected_objects
                material_set = set()
                for object in bpy.context.selected_objects:
                    for material in object.material_slots:
                        material_set.add(material)
                for material in material_set:
                #    print(material.name)
                    Tex = material.name
                    #  print(Tex+'_MainTex.png')
                    bpy.data.scenes['Scene'].sna_color03 = bpy.data.materials[Tex].node_tree.nodes['Principled BSDF'].inputs[0].default_value
                    bpy.data.node_groups['KK-Template Hair Front'].nodes['HF-Color-Value'].outputs[0].default_value = bpy.data.scenes['Scene'].sna_color03
                mat = bpy.data.materials[Tex]
                #Get the node in its node tree (replace the name below)
                node_to_delete =  mat.node_tree.nodes['Principled BSDF']
                node_to_delete2 =  mat.node_tree.nodes['Material Output']
                #Remove it
                mat.node_tree.nodes.remove( node_to_delete )
                mat.node_tree.nodes.remove( node_to_delete2 )
                TexGloss = Tex+'_HairGloss.png'
                TexMain = Tex+'_MainTex.png'
                TexDetailM = Tex+'_DetailMask.png'
                TexColorM = Tex+'_ColorMask.png'
                imghairf = ( bpimg('cf_m_hair_f_14_00_i_HairGloss.png'), bpimg('tenseigan'))
                for x in imghairf:
                    if x is not None:
                        bpy.data.images['cf_m_hair_f_14_00_i_HairGloss.png'].name = TexGloss 
                        bpy.data.images['cf_m_hair_f_14_00_i_MainTex.png'].name = TexMain 
                        bpy.data.images['cf_m_hair_f_14_00_i_DetailMask.png'].name = TexDetailM
                        bpy.data.images['cf_m_hair_f_14_00_i_ColorMask.png'].name = TexColorM
                        bpy.data.images[TexGloss].filepath = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexGloss
                        bpy.data.images[TexGloss].filepath_raw = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexGloss
                        bpy.data.images[TexMain].filepath = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexMain
                        bpy.data.images[TexMain].filepath_raw = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexMain
                        bpy.data.images[TexDetailM].filepath = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexDetailM
                        bpy.data.images[TexDetailM].filepath_raw = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexDetailM
                        bpy.data.images[TexColorM].filepath = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexColorM
                        bpy.data.images[TexColorM].filepath_raw = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexColorM
                C = bpy.context

                def instantiate_group(nodes, data_block_name):
                    group = nodes.new(type='ShaderNodeGroup')
                    group.node_tree = bpy.data.node_groups['KK-Template Hair Front']
                    return group
                instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
                my_mat = bpy.data.materials.get(Tex)
                bpy.data.node_groups['KK-Template Hair Front'].name = 'KK-Template Hair Front '+Tex
                node = bpy.data.node_groups['KK-Template Hair Front '+Tex]
                #node.extension = 'CLIP'
                #node.image = bpy.data.images[bakefinal.name]
                nodes = my_mat.node_tree.nodes
                for node in nodes:
                    node.select = False
                    node.select = True
                    nodes.active = node
                try:
                    initial_area_type = bpy.context.area.type
                    bpy.context.area.type = 'NODE_EDITOR'
                    bpy.context.area.ui_type = 'ShaderNodeTree'
                    bpy.ops.wm.redraw_timer(type='DRAW_WIN', iterations=1)
                    bpy.ops.node.group_ungroup()
                    bpy.ops.node.group_edit(exit=True)
                except Exception as e:
                    print(e)
                finally:
                    bpy.context.area.type = initial_area_type
                break
        bpy.ops.object.select_all(action='DESELECT') # Deselecciona todo en la escena
        #############################################################################
        for ob_hf1 in hairfronts:
            if ob_hf1 is not ob_hf and ob_hf1 is not None:
                #if bpy.data.objects.get(body1) is not None:
                op = (ob_hf1.name)
                bpy.data.objects.get(op).select_set(True)
                outline_hfront1 = bpy.data.objects.get(op)
                bpy.context.view_layer.objects.active = outline_hfront1
                ob = bpy.context.selected_objects
                material_set = set()
                for object in bpy.context.selected_objects:
                    for material in object.material_slots:
                        material_set.add(material)
                for material in material_set:
                #    print(material.name)
                    Tex = material.name
                    #  print(Tex+'_MainTex.png')
                    bpy.data.scenes['Scene'].sna_color03 = bpy.data.materials[Tex].node_tree.nodes['Principled BSDF'].inputs[0].default_value
                    bpy.data.node_groups['KK-Template Hair Front.001'].nodes['HF-Color-Value'].outputs[0].default_value = bpy.data.scenes['Scene'].sna_color03
                mat = bpy.data.materials[Tex]
                #Get the node in its node tree (replace the name below)
                node_to_delete =  mat.node_tree.nodes['Principled BSDF']
                node_to_delete2 =  mat.node_tree.nodes['Material Output']
                #Remove it
                mat.node_tree.nodes.remove( node_to_delete )
                mat.node_tree.nodes.remove( node_to_delete2 )
                TexGloss = Tex+'_HairGloss.png'
                TexMain = Tex+'_MainTex.png'
                TexDetailM = Tex+'_DetailMask.png'
                TexColorM = Tex+'_ColorMask.png'
                imghairf = ( bpimg('cf_m_hair_f_14_00_i_HairGloss.png.001'), bpimg('tenseigan'))
                for x in imghairf:
                    if x is not None:
                        bpy.data.images['cf_m_hair_f_14_00_i_HairGloss.png.001'].name = TexGloss 
                        bpy.data.images['cf_m_hair_f_14_00_i_MainTex.png.001'].name = TexMain
                        bpy.data.images['cf_m_hair_f_14_00_i_DetailMask.png.001'].name = TexDetailM
                        bpy.data.images['cf_m_hair_f_14_00_i_ColorMask.png.001'].name = TexColorM
                        bpy.data.images[TexGloss].filepath = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexGloss
                        bpy.data.images[TexGloss].filepath_raw = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexGloss
                        bpy.data.images[TexMain].filepath = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexMain
                        bpy.data.images[TexMain].filepath_raw = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexMain
                        bpy.data.images[TexDetailM].filepath = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexDetailM
                        bpy.data.images[TexDetailM].filepath_raw = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexDetailM
                        bpy.data.images[TexColorM].filepath = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexColorM
                        bpy.data.images[TexColorM].filepath_raw = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexColorM
                C = bpy.context

                def instantiate_group(nodes, data_block_name):
                    group = nodes.new(type='ShaderNodeGroup')
                    group.node_tree = bpy.data.node_groups['KK-Template Hair Front.001']
                    return group
                instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
                my_mat = bpy.data.materials.get(Tex)
                bpy.data.node_groups['KK-Template Hair Front.001'].name = 'KK-Template Hair Front '+Tex
                node = bpy.data.node_groups['KK-Template Hair Front '+Tex]
                #node.extension = 'CLIP'
                #node.image = bpy.data.images[bakefinal.name]
                nodes = my_mat.node_tree.nodes
                for node in nodes:
                    node.select = False
                    node.select = True
                    nodes.active = node
                try:
                    initial_area_type = bpy.context.area.type
                    bpy.context.area.type = 'NODE_EDITOR'
                    bpy.context.area.ui_type = 'ShaderNodeTree'
                    bpy.ops.wm.redraw_timer(type='DRAW_WIN', iterations=1)
                    bpy.ops.node.group_ungroup()
                    bpy.ops.node.group_edit(exit=True)
                except Exception as e:
                    print(e)
                finally:
                    bpy.context.area.type = initial_area_type
                break
        bpy.ops.object.select_all(action='DESELECT') # Deselecciona todo en la escena
        #############################################################################
        for ob_hf2 in hairfronts:
            if ob_hf2 is not ob_hf and ob_hf2 is not ob_hf1 and ob_hf2 is not None:
                #if bpy.data.objects.get(body1) is not None:
                op = (ob_hf2.name)
                bpy.data.objects.get(op).select_set(True)
                outline_hfront2 = bpy.data.objects.get(op)
                bpy.context.view_layer.objects.active = outline_hfront2
                ob = bpy.context.selected_objects
                material_set = set()
                for object in bpy.context.selected_objects:
                    for material in object.material_slots:
                        material_set.add(material)
                for material in material_set:
                #    print(material.name)
                    Tex = material.name
                    #  print(Tex+'_MainTex.png')
                    bpy.data.scenes['Scene'].sna_color03 = bpy.data.materials[Tex].node_tree.nodes['Principled BSDF'].inputs[0].default_value
                    bpy.data.node_groups['KK-Template Hair Front.002'].nodes['HF-Color-Value'].outputs[0].default_value = bpy.data.scenes['Scene'].sna_color03
                mat = bpy.data.materials[Tex]
                #Get the node in its node tree (replace the name below)
                node_to_delete =  mat.node_tree.nodes['Principled BSDF']
                node_to_delete2 =  mat.node_tree.nodes['Material Output']
                #Remove it
                mat.node_tree.nodes.remove( node_to_delete )
                mat.node_tree.nodes.remove( node_to_delete2 )
                TexGloss = Tex+'_HairGloss.png'
                TexMain = Tex+'_MainTex.png'
                TexDetailM = Tex+'_DetailMask.png'
                TexColorM = Tex+'_ColorMask.png'
                imghairf = ( bpimg('cf_m_hair_f_14_00_i_HairGloss.png.002'), bpimg('tenseigan'))
                for x in imghairf:
                    if x is not None:
                        bpy.data.images['cf_m_hair_f_14_00_i_HairGloss.png.002'].name = TexGloss
                        bpy.data.images['cf_m_hair_f_14_00_i_MainTex.png.002'].name = TexMain
                        bpy.data.images['cf_m_hair_f_14_00_i_DetailMask.png.002'].name = TexDetailM
                        bpy.data.images['cf_m_hair_f_14_00_i_ColorMask.png.002'].name = TexColorM
                        bpy.data.images[TexGloss].filepath = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexGloss
                        bpy.data.images[TexGloss].filepath_raw = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexGloss
                        bpy.data.images[TexMain].filepath = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexMain
                        bpy.data.images[TexMain].filepath_raw = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexMain
                        bpy.data.images[TexDetailM].filepath = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexDetailM
                        bpy.data.images[TexDetailM].filepath_raw = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexDetailM
                        bpy.data.images[TexColorM].filepath = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexColorM
                        bpy.data.images[TexColorM].filepath_raw = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexColorM
                C = bpy.context

                def instantiate_group(nodes, data_block_name):
                    group = nodes.new(type='ShaderNodeGroup')
                    group.node_tree = bpy.data.node_groups['KK-Template Hair Front.002']
                    return group
                instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
                my_mat = bpy.data.materials.get(Tex)
                bpy.data.node_groups['KK-Template Hair Front.002'].name = 'KK-Template Hair Front '+Tex
                node = bpy.data.node_groups['KK-Template Hair Front '+Tex]
                #node.extension = 'CLIP'
                #node.image = bpy.data.images[bakefinal.name]
                nodes = my_mat.node_tree.nodes
                for node in nodes:
                    node.select = False
                    node.select = True
                    nodes.active = node
                try:
                    initial_area_type = bpy.context.area.type
                    bpy.context.area.type = 'NODE_EDITOR'
                    bpy.context.area.ui_type = 'ShaderNodeTree'
                    bpy.ops.wm.redraw_timer(type='DRAW_WIN', iterations=1)
                    bpy.ops.node.group_ungroup()
                    bpy.ops.node.group_edit(exit=True)
                except Exception as e:
                    print(e)
                finally:
                    bpy.context.area.type = initial_area_type
                break
        bpy.ops.object.select_all(action='DESELECT') # Deselecciona todo en la escena
        #############################################################################
        for ob_hf3 in hairfronts:
            if ob_hf3 is not ob_hf and ob_hf3 is not ob_hf1 and ob_hf3 is not ob_hf2 and ob_hf3 is not None:
                #if bpy.data.objects.get(body1) is not None:
                op = (ob_hf3.name)
                bpy.data.objects.get(op).select_set(True)
                outline_hfront3 = bpy.data.objects.get(op)
                bpy.context.view_layer.objects.active = outline_hfront3
                ob = bpy.context.selected_objects
                material_set = set()
                for object in bpy.context.selected_objects:
                    for material in object.material_slots:
                        material_set.add(material)
                for material in material_set:
                #    print(material.name)
                    Tex = material.name
                    #  print(Tex+'_MainTex.png')
                    bpy.data.scenes['Scene'].sna_color03 = bpy.data.materials[Tex].node_tree.nodes['Principled BSDF'].inputs[0].default_value
                    bpy.data.node_groups['KK-Template Hair Front.003'].nodes['HF-Color-Value'].outputs[0].default_value = bpy.data.scenes['Scene'].sna_color03
                mat = bpy.data.materials[Tex]
                #Get the node in its node tree (replace the name below)
                node_to_delete =  mat.node_tree.nodes['Principled BSDF']
                node_to_delete2 =  mat.node_tree.nodes['Material Output']
                #Remove it
                mat.node_tree.nodes.remove( node_to_delete )
                mat.node_tree.nodes.remove( node_to_delete2 )
                TexGloss = Tex+'_HairGloss.png'
                TexMain = Tex+'_MainTex.png'
                TexDetailM = Tex+'_DetailMask.png'
                TexColorM = Tex+'_ColorMask.png'
                imghairf = ( bpimg('cf_m_hair_f_14_00_i_HairGloss.png.003'), bpimg('tenseigan'))
                for x in imghairf:
                    if x is not None:
                        bpy.data.images['cf_m_hair_f_14_00_i_HairGloss.png.003'].name = TexGloss
                        bpy.data.images['cf_m_hair_f_14_00_i_MainTex.png.003'].name = TexMain
                        bpy.data.images['cf_m_hair_f_14_00_i_DetailMask.png.003'].name = TexDetailM
                        bpy.data.images['cf_m_hair_f_14_00_i_ColorMask.png.003'].name = TexColorM
                        bpy.data.images[TexGloss].filepath = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexGloss
                        bpy.data.images[TexGloss].filepath_raw = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexGloss
                        bpy.data.images[TexMain].filepath = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexMain
                        bpy.data.images[TexMain].filepath_raw = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexMain
                        bpy.data.images[TexDetailM].filepath = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexDetailM
                        bpy.data.images[TexDetailM].filepath_raw = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexDetailM
                        bpy.data.images[TexColorM].filepath = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexColorM
                        bpy.data.images[TexColorM].filepath_raw = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexColorM
                C = bpy.context

                def instantiate_group(nodes, data_block_name):
                    group = nodes.new(type='ShaderNodeGroup')
                    group.node_tree = bpy.data.node_groups['KK-Template Hair Front.003']
                    return group
                instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
                my_mat = bpy.data.materials.get(Tex)
                bpy.data.node_groups['KK-Template Hair Front.003'].name = 'KK-Template Hair Front '+Tex
                node = bpy.data.node_groups['KK-Template Hair Front '+Tex]
                #node.extension = 'CLIP'
                #node.image = bpy.data.images[bakefinal.name]
                nodes = my_mat.node_tree.nodes
                for node in nodes:
                    node.select = False
                    node.select = True
                    nodes.active = node
                try:
                    initial_area_type = bpy.context.area.type
                    bpy.context.area.type = 'NODE_EDITOR'
                    bpy.context.area.ui_type = 'ShaderNodeTree'
                    bpy.ops.wm.redraw_timer(type='DRAW_WIN', iterations=1)
                    bpy.ops.node.group_ungroup()
                    bpy.ops.node.group_edit(exit=True)
                except Exception as e:
                    print(e)
                finally:
                    bpy.context.area.type = initial_area_type
                break
        bpy.ops.object.select_all(action='DESELECT') # Deselecciona todo en la escena
        #############################################################################
        for ob_hf4 in hairfronts:
            if ob_hf4 is not ob_hf and ob_hf4 is not ob_hf1 and ob_hf4 is not ob_hf2 and ob_hf4 is not ob_hf3 and ob_hf4 is not None:
                #if bpy.data.objects.get(body1) is not None:
                op = (ob_hf4.name)
                bpy.data.objects.get(op).select_set(True)
                outline_hfront4 = bpy.data.objects.get(op)
                bpy.context.view_layer.objects.active = outline_hfront4
                ob = bpy.context.selected_objects
                material_set = set()
                for object in bpy.context.selected_objects:
                    for material in object.material_slots:
                        material_set.add(material)
                for material in material_set:
                #    print(material.name)
                    Tex = material.name
                    #  print(Tex+'_MainTex.png')
                    bpy.data.scenes['Scene'].sna_color03 = bpy.data.materials[Tex].node_tree.nodes['Principled BSDF'].inputs[0].default_value
                    bpy.data.node_groups['KK-Template Hair Front.004'].nodes['HF-Color-Value'].outputs[0].default_value = bpy.data.scenes['Scene'].sna_color03
                mat = bpy.data.materials[Tex]
                #Get the node in its node tree (replace the name below)
                node_to_delete =  mat.node_tree.nodes['Principled BSDF']
                node_to_delete2 =  mat.node_tree.nodes['Material Output']
                #Remove it
                mat.node_tree.nodes.remove( node_to_delete )
                mat.node_tree.nodes.remove( node_to_delete2 )
                TexGloss = Tex+'_HairGloss.png'
                TexMain = Tex+'_MainTex.png'
                TexDetailM = Tex+'_DetailMask.png'
                TexColorM = Tex+'_ColorMask.png'
                imghairf = ( bpimg('cf_m_hair_f_14_00_i_HairGloss.png.004'), bpimg('tenseigan'))
                for x in imghairf:
                    if x is not None:
                        bpy.data.images['cf_m_hair_f_14_00_i_HairGloss.png.004'].name = TexGloss
                        bpy.data.images['cf_m_hair_f_14_00_i_MainTex.png.004'].name = TexMain
                        bpy.data.images['cf_m_hair_f_14_00_i_DetailMask.png.004'].name = TexDetailM
                        bpy.data.images['cf_m_hair_f_14_00_i_ColorMask.png.004'].name = TexColorM
                        bpy.data.images[TexGloss].filepath = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexGloss
                        bpy.data.images[TexGloss].filepath_raw = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexGloss
                        bpy.data.images[TexMain].filepath = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexMain
                        bpy.data.images[TexMain].filepath_raw = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexMain
                        bpy.data.images[TexDetailM].filepath = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexDetailM
                        bpy.data.images[TexDetailM].filepath_raw = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexDetailM
                        bpy.data.images[TexColorM].filepath = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexColorM
                        bpy.data.images[TexColorM].filepath_raw = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexColorM
                C = bpy.context

                def instantiate_group(nodes, data_block_name):
                    group = nodes.new(type='ShaderNodeGroup')
                    group.node_tree = bpy.data.node_groups['KK-Template Hair Front.004']
                    return group
                instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
                my_mat = bpy.data.materials.get(Tex)
                bpy.data.node_groups['KK-Template Hair Front.004'].name = 'KK-Template Hair Front '+Tex
                node = bpy.data.node_groups['KK-Template Hair Front '+Tex]
                #node.extension = 'CLIP'
                #node.image = bpy.data.images[bakefinal.name]
                nodes = my_mat.node_tree.nodes
                for node in nodes:
                    node.select = False
                    node.select = True
                    nodes.active = node
                try:
                    initial_area_type = bpy.context.area.type
                    bpy.context.area.type = 'NODE_EDITOR'
                    bpy.context.area.ui_type = 'ShaderNodeTree'
                    bpy.ops.wm.redraw_timer(type='DRAW_WIN', iterations=1)
                    bpy.ops.node.group_ungroup()
                    bpy.ops.node.group_edit(exit=True)
                except Exception as e:
                    print(e)
                finally:
                    bpy.context.area.type = initial_area_type
                break
        bpy.ops.object.select_all(action='DESELECT') # Deselecciona todo en la escena
        #############################################################################
        for ob_hf5 in hairfronts:
            if ob_hf5 is not ob_hf and ob_hf5 is not ob_hf1 and ob_hf5 is not ob_hf2 and ob_hf5 is not ob_hf3 and ob_hf5 is not ob_hf4 and ob_hf5 is not None:
                #if bpy.data.objects.get(body1) is not None:
                op = (ob_hf5.name)
                bpy.data.objects.get(op).select_set(True)
                outline_hfront5 = bpy.data.objects.get(op)
                bpy.context.view_layer.objects.active = outline_hfront5
                ob = bpy.context.selected_objects
                material_set = set()
                for object in bpy.context.selected_objects:
                    for material in object.material_slots:
                        material_set.add(material)
                for material in material_set:
                #    print(material.name)
                    Tex = material.name
                    #  print(Tex+'_MainTex.png')
                    bpy.data.scenes['Scene'].sna_color03 = bpy.data.materials[Tex].node_tree.nodes['Principled BSDF'].inputs[0].default_value
                    bpy.data.node_groups['KK-Template Hair Front.005'].nodes['HF-Color-Value'].outputs[0].default_value = bpy.data.scenes['Scene'].sna_color03
                mat = bpy.data.materials[Tex]
                #Get the node in its node tree (replace the name below)
                node_to_delete =  mat.node_tree.nodes['Principled BSDF']
                node_to_delete2 =  mat.node_tree.nodes['Material Output']
                #Remove it
                mat.node_tree.nodes.remove( node_to_delete )
                mat.node_tree.nodes.remove( node_to_delete2 )
                TexGloss = Tex+'_HairGloss.png'
                TexMain = Tex+'_MainTex.png'
                TexDetailM = Tex+'_DetailMask.png'
                TexColorM = Tex+'_ColorMask.png'
                imghairf = ( bpimg('cf_m_hair_f_14_00_i_HairGloss.png.005'), bpimg('tenseigan'))
                for x in imghairf:
                    if x is not None:
                        bpy.data.images['cf_m_hair_f_14_00_i_HairGloss.png.005'].name = TexGloss
                        bpy.data.images['cf_m_hair_f_14_00_i_MainTex.png.005'].name = TexMain
                        bpy.data.images['cf_m_hair_f_14_00_i_DetailMask.png.005'].name = TexDetailM
                        bpy.data.images['cf_m_hair_f_14_00_i_ColorMask.png.005'].name = TexColorM
                        bpy.data.images[TexGloss].filepath = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexGloss
                        bpy.data.images[TexGloss].filepath_raw = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexGloss
                        bpy.data.images[TexMain].filepath = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexMain
                        bpy.data.images[TexMain].filepath_raw = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexMain
                        bpy.data.images[TexDetailM].filepath = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexDetailM
                        bpy.data.images[TexDetailM].filepath_raw = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexDetailM
                        bpy.data.images[TexColorM].filepath = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexColorM
                        bpy.data.images[TexColorM].filepath_raw = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexColorM
                C = bpy.context

                def instantiate_group(nodes, data_block_name):
                    group = nodes.new(type='ShaderNodeGroup')
                    group.node_tree = bpy.data.node_groups['KK-Template Hair Front.005']
                    return group
                instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
                my_mat = bpy.data.materials.get(Tex)
                bpy.data.node_groups['KK-Template Hair Front.005'].name = 'KK-Template Hair Front '+Tex
                node = bpy.data.node_groups['KK-Template Hair Front '+Tex]
                #node.extension = 'CLIP'
                #node.image = bpy.data.images[bakefinal.name]
                nodes = my_mat.node_tree.nodes
                for node in nodes:
                    node.select = False
                    node.select = True
                    nodes.active = node
                try:
                    initial_area_type = bpy.context.area.type
                    bpy.context.area.type = 'NODE_EDITOR'
                    bpy.context.area.ui_type = 'ShaderNodeTree'
                    bpy.ops.wm.redraw_timer(type='DRAW_WIN', iterations=1)
                    bpy.ops.node.group_ungroup()
                    bpy.ops.node.group_edit(exit=True)
                except Exception as e:
                    print(e)
                finally:
                    bpy.context.area.type = initial_area_type
                break
        bpy.ops.object.select_all(action='DESELECT') # Deselecciona todo en la escena
        #############################################################################
        for ob_hf6 in hairfronts:
            if ob_hf6 is not ob_hf and ob_hf6 is not ob_hf1 and ob_hf6 is not ob_hf2 and ob_hf6 is not ob_hf3 and ob_hf6 is not ob_hf4 and ob_hf6 is not ob_hf5 and ob_hf6 is not None:
                #if bpy.data.objects.get(body1) is not None:
                op = (ob_hf6.name)
                bpy.data.objects.get(op).select_set(True)
                outline_hfront6 = bpy.data.objects.get(op)
                bpy.context.view_layer.objects.active = outline_hfront6
                ob = bpy.context.selected_objects
                material_set = set()
                for object in bpy.context.selected_objects:
                    for material in object.material_slots:
                        material_set.add(material)
                for material in material_set:
                #    print(material.name)
                    Tex = material.name
                    #  print(Tex+'_MainTex.png')
                    bpy.data.scenes['Scene'].sna_color03 = bpy.data.materials[Tex].node_tree.nodes['Principled BSDF'].inputs[0].default_value
                    bpy.data.node_groups['KK-Template Hair Front.006'].nodes['HF-Color-Value'].outputs[0].default_value = bpy.data.scenes['Scene'].sna_color03
                mat = bpy.data.materials[Tex]
                #Get the node in its node tree (replace the name below)
                node_to_delete =  mat.node_tree.nodes['Principled BSDF']
                node_to_delete2 =  mat.node_tree.nodes['Material Output']
                #Remove it
                mat.node_tree.nodes.remove( node_to_delete )
                mat.node_tree.nodes.remove( node_to_delete2 )
                TexGloss = Tex+'_HairGloss.png'
                TexMain = Tex+'_MainTex.png'
                TexDetailM = Tex+'_DetailMask.png'
                TexColorM = Tex+'_ColorMask.png'
                imghairf = ( bpimg('cf_m_hair_f_14_00_i_HairGloss.png.006'), bpimg('tenseigan'))
                for x in imghairf:
                    if x is not None:
                        bpy.data.images['cf_m_hair_f_14_00_i_HairGloss.png.006'].name = TexGloss
                        bpy.data.images['cf_m_hair_f_14_00_i_MainTex.png.006'].name = TexMain
                        bpy.data.images['cf_m_hair_f_14_00_i_DetailMask.png.006'].name = TexDetailM
                        bpy.data.images['cf_m_hair_f_14_00_i_ColorMask.png.006'].name = TexColorM
                        bpy.data.images[TexGloss].filepath = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexGloss
                        bpy.data.images[TexGloss].filepath_raw = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexGloss
                        bpy.data.images[TexMain].filepath = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexMain
                        bpy.data.images[TexMain].filepath_raw = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexMain
                        bpy.data.images[TexDetailM].filepath = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexDetailM
                        bpy.data.images[TexDetailM].filepath_raw = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexDetailM
                        bpy.data.images[TexColorM].filepath = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexColorM
                        bpy.data.images[TexColorM].filepath_raw = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexColorM
                C = bpy.context

                def instantiate_group(nodes, data_block_name):
                    group = nodes.new(type='ShaderNodeGroup')
                    group.node_tree = bpy.data.node_groups['KK-Template Hair Front.006']
                    return group
                instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
                my_mat = bpy.data.materials.get(Tex)
                bpy.data.node_groups['KK-Template Hair Front.006'].name = 'KK-Template Hair Front '+Tex
                node = bpy.data.node_groups['KK-Template Hair Front '+Tex]
                #node.extension = 'CLIP'
                #node.image = bpy.data.images[bakefinal.name]
                nodes = my_mat.node_tree.nodes
                for node in nodes:
                    node.select = False
                    node.select = True
                    nodes.active = node
                try:
                    initial_area_type = bpy.context.area.type
                    bpy.context.area.type = 'NODE_EDITOR'
                    bpy.context.area.ui_type = 'ShaderNodeTree'
                    bpy.ops.wm.redraw_timer(type='DRAW_WIN', iterations=1)
                    bpy.ops.node.group_ungroup()
                    bpy.ops.node.group_edit(exit=True)
                except Exception as e:
                    print(e)
                finally:
                    bpy.context.area.type = initial_area_type
                break
        bpy.ops.object.select_all(action='DESELECT') # Deselecciona todo en la escena
        #############################################################################
        for ob_hf7 in hairfronts:
            if ob_hf7 is not ob_hf and ob_hf7 is not ob_hf1 and ob_hf7 is not ob_hf2 and ob_hf7 is not ob_hf3 and ob_hf7 is not ob_hf4 and ob_hf7 is not ob_hf5 and ob_hf7 is not ob_hf6 and ob_hf7 is not None:
                #if bpy.data.objects.get(body1) is not None:
                op = (ob_hf7.name)
                bpy.data.objects.get(op).select_set(True)
                outline_hfront7 = bpy.data.objects.get(op)
                bpy.context.view_layer.objects.active = outline_hfront7
                ob = bpy.context.selected_objects
                material_set = set()
                for object in bpy.context.selected_objects:
                    for material in object.material_slots:
                        material_set.add(material)
                for material in material_set:
                #    print(material.name)
                    Tex = material.name
                    #  print(Tex+'_MainTex.png')
                    bpy.data.scenes['Scene'].sna_color03 = bpy.data.materials[Tex].node_tree.nodes['Principled BSDF'].inputs[0].default_value
                    bpy.data.node_groups['KK-Template Hair Front.007'].nodes['HF-Color-Value'].outputs[0].default_value = bpy.data.scenes['Scene'].sna_color03
                mat = bpy.data.materials[Tex]
                #Get the node in its node tree (replace the name below)
                node_to_delete =  mat.node_tree.nodes['Principled BSDF']
                node_to_delete2 =  mat.node_tree.nodes['Material Output']
                #Remove it
                mat.node_tree.nodes.remove( node_to_delete )
                mat.node_tree.nodes.remove( node_to_delete2 )
                TexGloss = Tex+'_HairGloss.png'
                TexMain = Tex+'_MainTex.png'
                TexDetailM = Tex+'_DetailMask.png'
                TexColorM = Tex+'_ColorMask.png'
                imghairf = ( bpimg('cf_m_hair_f_14_00_i_HairGloss.png.007'), bpimg('tenseigan'))
                for x in imghairf:
                    if x is not None:
                        bpy.data.images['cf_m_hair_f_14_00_i_HairGloss.png.007'].name = TexGloss
                        bpy.data.images['cf_m_hair_f_14_00_i_MainTex.png.007'].name = TexMain
                        bpy.data.images['cf_m_hair_f_14_00_i_DetailMask.png.007'].name = TexDetailM
                        bpy.data.images['cf_m_hair_f_14_00_i_ColorMask.png.007'].name = TexColorM
                        bpy.data.images[TexGloss].filepath = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexGloss
                        bpy.data.images[TexGloss].filepath_raw = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexGloss
                        bpy.data.images[TexMain].filepath = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexMain
                        bpy.data.images[TexMain].filepath_raw = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexMain
                        bpy.data.images[TexDetailM].filepath = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexDetailM
                        bpy.data.images[TexDetailM].filepath_raw = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexDetailM
                        bpy.data.images[TexColorM].filepath = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexColorM
                        bpy.data.images[TexColorM].filepath_raw = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexColorM
                C = bpy.context

                def instantiate_group(nodes, data_block_name):
                    group = nodes.new(type='ShaderNodeGroup')
                    group.node_tree = bpy.data.node_groups['KK-Template Hair Front.007']
                    return group
                instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
                my_mat = bpy.data.materials.get(Tex)
                bpy.data.node_groups['KK-Template Hair Front.007'].name = 'KK-Template Hair Front '+Tex
                node = bpy.data.node_groups['KK-Template Hair Front '+Tex]
                #node.extension = 'CLIP'
                #node.image = bpy.data.images[bakefinal.name]
                nodes = my_mat.node_tree.nodes
                for node in nodes:
                    node.select = False
                    node.select = True
                    nodes.active = node
                try:
                    initial_area_type = bpy.context.area.type
                    bpy.context.area.type = 'NODE_EDITOR'
                    bpy.context.area.ui_type = 'ShaderNodeTree'
                    bpy.ops.wm.redraw_timer(type='DRAW_WIN', iterations=1)
                    bpy.ops.node.group_ungroup()
                    bpy.ops.node.group_edit(exit=True)
                except Exception as e:
                    print(e)
                finally:
                    bpy.context.area.type = initial_area_type
                break
        bpy.ops.object.select_all(action='DESELECT') # Deselecciona todo en la escena
        #############################################################################
        for ob_hf8 in hairfronts:
            if ob_hf8 is not ob_hf and ob_hf8 is not ob_hf1 and ob_hf8 is not ob_hf2 and ob_hf8 is not ob_hf3 and ob_hf8 is not ob_hf4 and ob_hf8 is not ob_hf5 and ob_hf8 is not ob_hf6 and ob_hf8 is not ob_hf7 and ob_hf8 is not None:
                #if bpy.data.objects.get(body1) is not None:
                op = (ob_hf8.name)
                bpy.data.objects.get(op).select_set(True)
                outline_hfront8 = bpy.data.objects.get(op)
                bpy.context.view_layer.objects.active = outline_hfront8
                ob = bpy.context.selected_objects
                material_set = set()
                for object in bpy.context.selected_objects:
                    for material in object.material_slots:
                        material_set.add(material)
                for material in material_set:
                #    print(material.name)
                    Tex = material.name
                    #  print(Tex+'_MainTex.png')
                    bpy.data.scenes['Scene'].sna_color03 = bpy.data.materials[Tex].node_tree.nodes['Principled BSDF'].inputs[0].default_value
                    bpy.data.node_groups['KK-Template Hair Front.008'].nodes['HF-Color-Value'].outputs[0].default_value = bpy.data.scenes['Scene'].sna_color03
                mat = bpy.data.materials[Tex]
                #Get the node in its node tree (replace the name below)
                node_to_delete =  mat.node_tree.nodes['Principled BSDF']
                node_to_delete2 =  mat.node_tree.nodes['Material Output']
                #Remove it
                mat.node_tree.nodes.remove( node_to_delete )
                mat.node_tree.nodes.remove( node_to_delete2 )
                TexGloss = Tex+'_HairGloss.png'
                TexMain = Tex+'_MainTex.png'
                TexDetailM = Tex+'_DetailMask.png'
                TexColorM = Tex+'_ColorMask.png'
                imghairf = ( bpimg('cf_m_hair_f_14_00_i_HairGloss.png.008'), bpimg('tenseigan'))
                for x in imghairf:
                    if x is not None:
                        bpy.data.images['cf_m_hair_f_14_00_i_HairGloss.png.008'].name = TexGloss
                        bpy.data.images['cf_m_hair_f_14_00_i_MainTex.png.008'].name = TexMain
                        bpy.data.images['cf_m_hair_f_14_00_i_DetailMask.png.008'].name = TexDetailM
                        bpy.data.images['cf_m_hair_f_14_00_i_ColorMask.png.008'].name = TexColorM
                        bpy.data.images[TexGloss].filepath = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexGloss
                        bpy.data.images[TexGloss].filepath_raw = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexGloss
                        bpy.data.images[TexMain].filepath = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexMain
                        bpy.data.images[TexMain].filepath_raw = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexMain
                        bpy.data.images[TexDetailM].filepath = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexDetailM
                        bpy.data.images[TexDetailM].filepath_raw = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexDetailM
                        bpy.data.images[TexColorM].filepath = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexColorM
                        bpy.data.images[TexColorM].filepath_raw = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexColorM
                C = bpy.context

                def instantiate_group(nodes, data_block_name):
                    group = nodes.new(type='ShaderNodeGroup')
                    group.node_tree = bpy.data.node_groups['KK-Template Hair Front.008']
                    return group
                instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
                my_mat = bpy.data.materials.get(Tex)
                bpy.data.node_groups['KK-Template Hair Front.008'].name = 'KK-Template Hair Front '+Tex
                node = bpy.data.node_groups['KK-Template Hair Front '+Tex]
                #node.extension = 'CLIP'
                #node.image = bpy.data.images[bakefinal.name]
                nodes = my_mat.node_tree.nodes
                for node in nodes:
                    node.select = False
                    node.select = True
                    nodes.active = node
                try:
                    initial_area_type = bpy.context.area.type
                    bpy.context.area.type = 'NODE_EDITOR'
                    bpy.context.area.ui_type = 'ShaderNodeTree'
                    bpy.ops.wm.redraw_timer(type='DRAW_WIN', iterations=1)
                    bpy.ops.node.group_ungroup()
                    bpy.ops.node.group_edit(exit=True)
                except Exception as e:
                    print(e)
                finally:
                    bpy.context.area.type = initial_area_type
                break
        bpy.ops.object.select_all(action='DESELECT') # Deselecciona todo en la escena
        #############################################################################
        for ob_hf9 in hairfronts:
            if ob_hf9 is not ob_hf and ob_hf9 is not ob_hf1 and ob_hf9 is not ob_hf2 and ob_hf9 is not ob_hf3 and ob_hf9 is not ob_hf4 and ob_hf9 is not ob_hf5 and ob_hf9 is not ob_hf6 and ob_hf9 is not ob_hf7 and ob_hf9 is not ob_hf8 and ob_hf9 is not None:
                #if bpy.data.objects.get(body1) is not None:
                op = (ob_hf9.name)
                bpy.data.objects.get(op).select_set(True)
                outline_hfront9 = bpy.data.objects.get(op)
                bpy.context.view_layer.objects.active = outline_hfront9
                ob = bpy.context.selected_objects
                material_set = set()
                for object in bpy.context.selected_objects:
                    for material in object.material_slots:
                        material_set.add(material)
                for material in material_set:
                #    print(material.name)
                    Tex = material.name
                    #  print(Tex+'_MainTex.png')
                    bpy.data.scenes['Scene'].sna_color03 = bpy.data.materials[Tex].node_tree.nodes['Principled BSDF'].inputs[0].default_value
                    bpy.data.node_groups['KK-Template Hair Front.009'].nodes['HF-Color-Value'].outputs[0].default_value = bpy.data.scenes['Scene'].sna_color03
                mat = bpy.data.materials[Tex]
                #Get the node in its node tree (replace the name below)
                node_to_delete =  mat.node_tree.nodes['Principled BSDF']
                node_to_delete2 =  mat.node_tree.nodes['Material Output']
                #Remove it
                mat.node_tree.nodes.remove( node_to_delete )
                mat.node_tree.nodes.remove( node_to_delete2 )
                TexGloss = Tex+'_HairGloss.png'
                TexMain = Tex+'_MainTex.png'
                TexDetailM = Tex+'_DetailMask.png'
                TexColorM = Tex+'_ColorMask.png'
                imghairf = ( bpimg('cf_m_hair_f_14_00_i_HairGloss.png.009'), bpimg('tenseigan'))
                for x in imghairf:
                    if x is not None:
                        bpy.data.images['cf_m_hair_f_14_00_i_HairGloss.png.009'].name = TexGloss
                        bpy.data.images['cf_m_hair_f_14_00_i_MainTex.png.009'].name = TexMain
                        bpy.data.images['cf_m_hair_f_14_00_i_DetailMask.png.009'].name = TexDetailM
                        bpy.data.images['cf_m_hair_f_14_00_i_ColorMask.png.009'].name = TexColorM
                        bpy.data.images[TexGloss].filepath = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexGloss
                        bpy.data.images[TexGloss].filepath_raw = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexGloss
                        bpy.data.images[TexMain].filepath = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexMain
                        bpy.data.images[TexMain].filepath_raw = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexMain
                        bpy.data.images[TexDetailM].filepath = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexDetailM
                        bpy.data.images[TexDetailM].filepath_raw = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexDetailM
                        bpy.data.images[TexColorM].filepath = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexColorM
                        bpy.data.images[TexColorM].filepath_raw = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexColorM
                C = bpy.context

                def instantiate_group(nodes, data_block_name):
                    group = nodes.new(type='ShaderNodeGroup')
                    group.node_tree = bpy.data.node_groups['KK-Template Hair Front.009']
                    return group
                instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
                my_mat = bpy.data.materials.get(Tex)
                bpy.data.node_groups['KK-Template Hair Front.009'].name = 'KK-Template Hair Front '+Tex
                node = bpy.data.node_groups['KK-Template Hair Front '+Tex]
                #node.extension = 'CLIP'
                #node.image = bpy.data.images[bakefinal.name]
                nodes = my_mat.node_tree.nodes
                for node in nodes:
                    node.select = False
                    node.select = True
                    nodes.active = node
                try:
                    initial_area_type = bpy.context.area.type
                    bpy.context.area.type = 'NODE_EDITOR'
                    bpy.context.area.ui_type = 'ShaderNodeTree'
                    bpy.ops.wm.redraw_timer(type='DRAW_WIN', iterations=1)
                    bpy.ops.node.group_ungroup()
                    bpy.ops.node.group_edit(exit=True)
                except Exception as e:
                    print(e)
                finally:
                    bpy.context.area.type = initial_area_type
                break
        bpy.ops.object.select_all(action='DESELECT') # Deselecciona todo en la escena
        ########HAIR BACK########
        bpy.ops.object.select_all(action='DESELECT') # Deselecciona todo en la escena
        # Get hairb object
        hairbacks = (w(hairb1), w(hairb2), w(hairb3), w(hairb4), w(hairb5), w(hairb6), w(hairb7), w(hairb8), w(hairb9), w(hairb10), w(hairb11), w(hairb12), w(hairb13), w(hairb14), w(hairb15), w(hairb16), w(hairb17), w(hairb18), w(hairb19), w(hairb20), w(hairb21), w(hairb22), w(hairb23), w(hairb24), w(hairb25), w(hairb26), w(hairb27), w(hairb28), w(hairb29), w(hairb30), w(hairb31), w(hairb32), w(hairb33), w(hairb34), w(hairb35), w(hairb36), w(hairb37), w(hairb38), w(hairb39), w(hairb40), w(hairb41), w(hairb42), w(hairb43), w(hairb44), w(hairb45), w(hairb46), w(hairb47), w(hairb48), w(hairb49), w(hairb50), w(hairb51), w(hairb52), w(hairb53), w(hairb54), w(hairb55), w(hairb56), w(hairb57), w(hairb58), w(hairb59), w(hairb60), w(hairb61), w(hairb62), w(hairb63), w(hairb64), w(hairb65), w(hairb66), w(hairb67), w(hairb68), w(hairb69), w(hairb70), w(hairb71), w(hairb72), w(hairb73), w(hairb74), w(hairb75), w(hairb76), w(hairb77), w(hairb78), w(hairb79), w(hairb80), w(hairb81), w(hairb82), w(hairb83), w(hairb84), w(hairb85), w(hairb86), w(hairb87), w(hairb88), w(hairb89), w(hairb90), w(hairb91), w(hairb92), w(hairb93), w(hairb94), w(hairb95), w(hairb96), w(hairb97), w(hairb98), w(hairb99), w(hairb100), w(hairb101), w(hairb102), w(hairb103), w(hairb104), w(hairb105), w(hairb106), w(hairb107), w(hairb108), w(hairb109), w(hairb110), w(hairb111), w(hairb112), w(hairb113), w(hairb114), w(hairb115), w(hairb116), w(hairb117), w(hairb118), w(hairb119), w(hairb120), w(hairb121), w(hairb122), w(hairb123), w(hairb124), w(hairb125), w(hairb126), w(hairb127), w(hairb128), w(hairb129), w(hairb130), w(hairb131), w(hairb132), w(hairb133), w(hairb134), w(hairb135), w(hairb136), w(hairb137), w(hairb138), w(hairb139), w(hairb140), w(hairb141), w(hairb142), w(hairb143))
        for ob_hb in hairbacks:
            if ob_hb is not None:
                #if bpy.data.objects.get(body1) is not None:
                op = (ob_hb.name)
                bpy.data.objects.get(op).select_set(True)
                outline_hback = bpy.data.objects.get(op)
                bpy.context.view_layer.objects.active = outline_hback
                ob = bpy.context.selected_objects
                material_set = set()
                for object in bpy.context.selected_objects:
                    for material in object.material_slots:
                        material_set.add(material)
                for material in material_set:
                #    print(material.name)
                    Tex = material.name
                    bpy.data.scenes['Scene'].sna_color03 = bpy.data.materials[Tex].node_tree.nodes['Principled BSDF'].inputs[0].default_value
                    bpy.data.node_groups['KK-Template Hair Back'].nodes['HB-Color-Value'].outputs[0].default_value = bpy.data.scenes['Scene'].sna_color03
                    #  print(Tex+'_MainTex.png')
                    TexGloss = Tex+'_HairGloss.png'
                    TexMain = Tex+'_MainTex.png'
                    TexDetailM = Tex+'_DetailMask.png'
                    TexColorM = Tex+'_ColorMask.png'
                mat = bpy.data.materials[Tex]
                #Get the node in its node tree (replace the name below)
                node_to_delete =  mat.node_tree.nodes['Principled BSDF']
                node_to_delete2 =  mat.node_tree.nodes['Material Output']
                #Remove it
                mat.node_tree.nodes.remove( node_to_delete )
                mat.node_tree.nodes.remove( node_to_delete2 )
                imghairb = ( bpimg('cf_m_hair_b_08_00_HairGloss.png'), bpimg('roshi'))
                for x in imghairb:
                    if x is not None:
                        bpy.data.images['cf_m_hair_b_08_00_HairGloss.png'].name = TexGloss
                        bpy.data.images['cf_m_hair_b_08_00_MainTex.png'].name = TexMain
                        bpy.data.images['cf_m_hair_b_08_00_DetailMask.png'].name = TexDetailM
                        bpy.data.images['cf_m_hair_b_08_00_ColorMask.png'].name = TexColorM
                        bpy.data.images[TexGloss].filepath = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexGloss
                        bpy.data.images[TexGloss].filepath_raw = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexGloss
                        bpy.data.images[TexMain].filepath = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexMain
                        bpy.data.images[TexMain].filepath_raw = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexMain
                        bpy.data.images[TexDetailM].filepath = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexDetailM
                        bpy.data.images[TexDetailM].filepath_raw = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexDetailM
                        bpy.data.images[TexColorM].filepath = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexColorM
                        bpy.data.images[TexColorM].filepath_raw = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexColorM
                C = bpy.context

                def instantiate_group(nodes, data_block_name):
                    group = nodes.new(type='ShaderNodeGroup')
                    group.node_tree = bpy.data.node_groups['KK-Template Hair Back']
                    return group
                instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
                my_mat = bpy.data.materials.get(Tex)
                bpy.data.node_groups['KK-Template Hair Back'].name = 'KK-Template Hair Back '+Tex
                node = bpy.data.node_groups['KK-Template Hair Back '+Tex]
                #node.extension = 'CLIP'
                #node.image = bpy.data.images[bakefinal.name]
                nodes = my_mat.node_tree.nodes
                for node in nodes:
                    node.select = False
                    node.select = True
                    nodes.active = node
                try:
                    initial_area_type = bpy.context.area.type
                    bpy.context.area.type = 'NODE_EDITOR'
                    bpy.context.area.ui_type = 'ShaderNodeTree'
                    bpy.ops.wm.redraw_timer(type='DRAW_WIN', iterations=1)
                    bpy.ops.node.group_ungroup()
                    bpy.ops.node.group_edit(exit=True)
                except Exception as e:
                    print(e)
                finally:
                    bpy.context.area.type = initial_area_type
                break
        bpy.ops.object.select_all(action='DESELECT') # Deselecciona todo en la escena
        ##############################################################################
        for ob_hb1 in hairbacks:
            if ob_hb1 is not ob_hb and ob_hb1 is not None:
                #if bpy.data.objects.get(body1) is not None:
                op = (ob_hb1.name)
                bpy.data.objects.get(op).select_set(True)
                outline_hback1 = bpy.data.objects.get(op)
                bpy.context.view_layer.objects.active = outline_hback1
                ob = bpy.context.selected_objects
                material_set = set()
                for object in bpy.context.selected_objects:
                    for material in object.material_slots:
                        material_set.add(material)
                for material in material_set:
                #    print(material.name)
                    Tex = material.name
                    bpy.data.node_groups['KK-Template Hair Back.001'].nodes['HB-Color-Value'].outputs[0].default_value = bpy.data.scenes['Scene'].sna_color03
                    #  print(Tex+'_MainTex.png')
                    TexGloss = Tex+'_HairGloss.png'
                    TexMain = Tex+'_MainTex.png'
                    TexDetailM = Tex+'_DetailMask.png'
                    TexColorM = Tex+'_ColorMask.png'
                mat = bpy.data.materials[Tex]
                #Get the node in its node tree (replace the name below)
                node_to_delete =  mat.node_tree.nodes['Principled BSDF']
                node_to_delete2 =  mat.node_tree.nodes['Material Output']
                #Remove it
                mat.node_tree.nodes.remove( node_to_delete )
                mat.node_tree.nodes.remove( node_to_delete2 )
                imghairb = ( bpimg('cf_m_hair_b_08_00_HairGloss.png.001'), bpimg('roshi'))
                for x in imghairb:
                    if x is not None:
                        bpy.data.images['cf_m_hair_b_08_00_HairGloss.png.001'].name = TexGloss
                        bpy.data.images['cf_m_hair_b_08_00_MainTex.png.001'].name = TexMain
                        bpy.data.images['cf_m_hair_b_08_00_DetailMask.png.001'].name = TexDetailM
                        bpy.data.images['cf_m_hair_b_08_00_ColorMask.png.001'].name = TexColorM
                        bpy.data.images[TexGloss].filepath = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexGloss
                        bpy.data.images[TexGloss].filepath_raw = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexGloss
                        bpy.data.images[TexMain].filepath = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexMain
                        bpy.data.images[TexMain].filepath_raw = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexMain
                        bpy.data.images[TexDetailM].filepath = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexDetailM
                        bpy.data.images[TexDetailM].filepath_raw = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexDetailM
                        bpy.data.images[TexColorM].filepath = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexColorM
                        bpy.data.images[TexColorM].filepath_raw = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexColorM
                C = bpy.context

                def instantiate_group(nodes, data_block_name):
                    group = nodes.new(type='ShaderNodeGroup')
                    group.node_tree = bpy.data.node_groups['KK-Template Hair Back.001']
                    return group
                instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
                my_mat = bpy.data.materials.get(Tex)
                bpy.data.node_groups['KK-Template Hair Back.001'].name = 'KK-Template Hair Back '+Tex
                node = bpy.data.node_groups['KK-Template Hair Back '+Tex]
                #node.extension = 'CLIP'
                #node.image = bpy.data.images[bakefinal.name]
                nodes = my_mat.node_tree.nodes
                for node in nodes:
                    node.select = False
                    node.select = True
                    nodes.active = node
                try:
                    initial_area_type = bpy.context.area.type
                    bpy.context.area.type = 'NODE_EDITOR'
                    bpy.context.area.ui_type = 'ShaderNodeTree'
                    bpy.ops.wm.redraw_timer(type='DRAW_WIN', iterations=1)
                    bpy.ops.node.group_ungroup()
                    bpy.ops.node.group_edit(exit=True)
                except Exception as e:
                    print(e)
                finally:
                    bpy.context.area.type = initial_area_type
                break
        bpy.ops.object.select_all(action='DESELECT') # Deselecciona todo en la escena
        ##############################################################################
        for ob_hb2 in hairbacks:
            if ob_hb2 is not ob_hb and ob_hb2 is not ob_hb1 and ob_hb2 is not None:
                #if bpy.data.objects.get(body1) is not None:
                op = (ob_hb2.name)
                bpy.data.objects.get(op).select_set(True)
                outline_hback2 = bpy.data.objects.get(op)
                bpy.context.view_layer.objects.active = outline_hback2
                ob = bpy.context.selected_objects
                material_set = set()
                for object in bpy.context.selected_objects:
                    for material in object.material_slots:
                        material_set.add(material)
                for material in material_set:
                #    print(material.name)
                    Tex = material.name
                    bpy.data.node_groups['KK-Template Hair Back.002'].nodes['HB-Color-Value'].outputs[0].default_value = bpy.data.scenes['Scene'].sna_color03
                    #  print(Tex+'_MainTex.png')
                    TexGloss = Tex+'_HairGloss.png'
                    TexMain = Tex+'_MainTex.png'
                    TexDetailM = Tex+'_DetailMask.png'
                    TexColorM = Tex+'_ColorMask.png'
                mat = bpy.data.materials[Tex]
                #Get the node in its node tree (replace the name below)
                node_to_delete =  mat.node_tree.nodes['Principled BSDF']
                node_to_delete2 =  mat.node_tree.nodes['Material Output']
                #Remove it
                mat.node_tree.nodes.remove( node_to_delete )
                mat.node_tree.nodes.remove( node_to_delete2 )
                imghairb = ( bpimg('cf_m_hair_b_08_00_HairGloss.png.002'), bpimg('roshi'))
                for x in imghairb:
                    if x is not None:
                        bpy.data.images['cf_m_hair_b_08_00_HairGloss.png.002'].name = TexGloss
                        bpy.data.images['cf_m_hair_b_08_00_MainTex.png.002'].name = TexMain
                        bpy.data.images['cf_m_hair_b_08_00_DetailMask.png.002'].name = TexDetailM
                        bpy.data.images['cf_m_hair_b_08_00_ColorMask.png.002'].name = TexColorM
                        bpy.data.images[TexGloss].filepath = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexGloss
                        bpy.data.images[TexGloss].filepath_raw = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexGloss
                        bpy.data.images[TexMain].filepath = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexMain
                        bpy.data.images[TexMain].filepath_raw = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexMain
                        bpy.data.images[TexDetailM].filepath = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexDetailM
                        bpy.data.images[TexDetailM].filepath_raw = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexDetailM
                        bpy.data.images[TexColorM].filepath = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexColorM
                        bpy.data.images[TexColorM].filepath_raw = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexColorM
                C = bpy.context

                def instantiate_group(nodes, data_block_name):
                    group = nodes.new(type='ShaderNodeGroup')
                    group.node_tree = bpy.data.node_groups['KK-Template Hair Back.002']
                    return group
                instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
                my_mat = bpy.data.materials.get(Tex)
                bpy.data.node_groups['KK-Template Hair Back.002'].name = 'KK-Template Hair Back '+Tex
                node = bpy.data.node_groups['KK-Template Hair Back '+Tex]
                #node.extension = 'CLIP'
                #node.image = bpy.data.images[bakefinal.name]
                nodes = my_mat.node_tree.nodes
                for node in nodes:
                    node.select = False
                    node.select = True
                    nodes.active = node
                try:
                    initial_area_type = bpy.context.area.type
                    bpy.context.area.type = 'NODE_EDITOR'
                    bpy.context.area.ui_type = 'ShaderNodeTree'
                    bpy.ops.wm.redraw_timer(type='DRAW_WIN', iterations=1)
                    bpy.ops.node.group_ungroup()
                    bpy.ops.node.group_edit(exit=True)
                except Exception as e:
                    print(e)
                finally:
                    bpy.context.area.type = initial_area_type
                break
        bpy.ops.object.select_all(action='DESELECT') # Deselecciona todo en la escena
        ##############################################################################
        for ob_hb3 in hairbacks:
            if ob_hb3 is not ob_hb and ob_hb3 is not ob_hb1 and ob_hb3 is not ob_hb2 and ob_hb3 is not None:
                #if bpy.data.objects.get(body1) is not None:
                op = (ob_hb3.name)
                bpy.data.objects.get(op).select_set(True)
                outline_hback3 = bpy.data.objects.get(op)
                bpy.context.view_layer.objects.active = outline_hback3
                ob = bpy.context.selected_objects
                material_set = set()
                for object in bpy.context.selected_objects:
                    for material in object.material_slots:
                        material_set.add(material)
                for material in material_set:
                #    print(material.name)
                    Tex = material.name
                    bpy.data.node_groups['KK-Template Hair Back.003'].nodes['HB-Color-Value'].outputs[0].default_value = bpy.data.scenes['Scene'].sna_color03
                    #  print(Tex+'_MainTex.png')
                    TexGloss = Tex+'_HairGloss.png'
                    TexMain = Tex+'_MainTex.png'
                    TexDetailM = Tex+'_DetailMask.png'
                    TexColorM = Tex+'_ColorMask.png'
                mat = bpy.data.materials[Tex]
                #Get the node in its node tree (replace the name below)
                node_to_delete =  mat.node_tree.nodes['Principled BSDF']
                node_to_delete2 =  mat.node_tree.nodes['Material Output']
                #Remove it
                mat.node_tree.nodes.remove( node_to_delete )
                mat.node_tree.nodes.remove( node_to_delete2 )
                imghairb = ( bpimg('cf_m_hair_b_08_00_HairGloss.png.003'), bpimg('roshi'))
                for x in imghairb:
                    if x is not None:
                        bpy.data.images['cf_m_hair_b_08_00_HairGloss.png.003'].name = TexGloss
                        bpy.data.images['cf_m_hair_b_08_00_MainTex.png.003'].name = TexMain
                        bpy.data.images['cf_m_hair_b_08_00_DetailMask.png.003'].name = TexDetailM
                        bpy.data.images['cf_m_hair_b_08_00_ColorMask.png.003'].name = TexColorM
                        bpy.data.images[TexGloss].filepath = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexGloss
                        bpy.data.images[TexGloss].filepath_raw = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexGloss
                        bpy.data.images[TexMain].filepath = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexMain
                        bpy.data.images[TexMain].filepath_raw = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexMain
                        bpy.data.images[TexDetailM].filepath = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexDetailM
                        bpy.data.images[TexDetailM].filepath_raw = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexDetailM
                        bpy.data.images[TexColorM].filepath = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexColorM
                        bpy.data.images[TexColorM].filepath_raw = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexColorM
                C = bpy.context

                def instantiate_group(nodes, data_block_name):
                    group = nodes.new(type='ShaderNodeGroup')
                    group.node_tree = bpy.data.node_groups['KK-Template Hair Back.003']
                    return group
                instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
                my_mat = bpy.data.materials.get(Tex)
                bpy.data.node_groups['KK-Template Hair Back.003'].name = 'KK-Template Hair Back '+Tex
                node = bpy.data.node_groups['KK-Template Hair Back '+Tex]
                #node.extension = 'CLIP'
                #node.image = bpy.data.images[bakefinal.name]
                nodes = my_mat.node_tree.nodes
                for node in nodes:
                    node.select = False
                    node.select = True
                    nodes.active = node
                try:
                    initial_area_type = bpy.context.area.type
                    bpy.context.area.type = 'NODE_EDITOR'
                    bpy.context.area.ui_type = 'ShaderNodeTree'
                    bpy.ops.wm.redraw_timer(type='DRAW_WIN', iterations=1)
                    bpy.ops.node.group_ungroup()
                    bpy.ops.node.group_edit(exit=True)
                except Exception as e:
                    print(e)
                finally:
                    bpy.context.area.type = initial_area_type
                break
        bpy.ops.object.select_all(action='DESELECT') # Deselecciona todo en la escena
        ##############################################################################
        for ob_hb4 in hairbacks:
            if ob_hb4 is not ob_hb and ob_hb4 is not ob_hb1 and ob_hb4 is not ob_hb2 and ob_hb4 is not ob_hb3 and ob_hb4 is not None:
                #if bpy.data.objects.get(body1) is not None:
                op = (ob_hb4.name)
                bpy.data.objects.get(op).select_set(True)
                outline_hback4 = bpy.data.objects.get(op)
                bpy.context.view_layer.objects.active = outline_hback4
                ob = bpy.context.selected_objects
                material_set = set()
                for object in bpy.context.selected_objects:
                    for material in object.material_slots:
                        material_set.add(material)
                for material in material_set:
                #    print(material.name)
                    Tex = material.name
                    bpy.data.node_groups['KK-Template Hair Back.004'].nodes['HB-Color-Value'].outputs[0].default_value = bpy.data.scenes['Scene'].sna_color03
                    #  print(Tex+'_MainTex.png')
                    TexGloss = Tex+'_HairGloss.png'
                    TexMain = Tex+'_MainTex.png'
                    TexDetailM = Tex+'_DetailMask.png'
                    TexColorM = Tex+'_ColorMask.png'
                mat = bpy.data.materials[Tex]
                #Get the node in its node tree (replace the name below)
                node_to_delete =  mat.node_tree.nodes['Principled BSDF']
                node_to_delete2 =  mat.node_tree.nodes['Material Output']
                #Remove it
                mat.node_tree.nodes.remove( node_to_delete )
                mat.node_tree.nodes.remove( node_to_delete2 )
                imghairb = ( bpimg('cf_m_hair_b_08_00_HairGloss.png.004'), bpimg('roshi'))
                for x in imghairb:
                    if x is not None:
                        bpy.data.images['cf_m_hair_b_08_00_HairGloss.png.004'].name = TexGloss
                        bpy.data.images['cf_m_hair_b_08_00_MainTex.png.004'].name = TexMain
                        bpy.data.images['cf_m_hair_b_08_00_DetailMask.png.004'].name = TexDetailM
                        bpy.data.images['cf_m_hair_b_08_00_ColorMask.png.004'].name = TexColorM
                        bpy.data.images[TexGloss].filepath = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexGloss
                        bpy.data.images[TexGloss].filepath_raw = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexGloss
                        bpy.data.images[TexMain].filepath = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexMain
                        bpy.data.images[TexMain].filepath_raw = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexMain
                        bpy.data.images[TexDetailM].filepath = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexDetailM
                        bpy.data.images[TexDetailM].filepath_raw = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexDetailM
                        bpy.data.images[TexColorM].filepath = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexColorM
                        bpy.data.images[TexColorM].filepath_raw = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexColorM
                C = bpy.context

                def instantiate_group(nodes, data_block_name):
                    group = nodes.new(type='ShaderNodeGroup')
                    group.node_tree = bpy.data.node_groups['KK-Template Hair Back.004']
                    return group
                instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
                my_mat = bpy.data.materials.get(Tex)
                bpy.data.node_groups['KK-Template Hair Back.004'].name = 'KK-Template Hair Back '+Tex
                node = bpy.data.node_groups['KK-Template Hair Back '+Tex]
                #node.extension = 'CLIP'
                #node.image = bpy.data.images[bakefinal.name]
                nodes = my_mat.node_tree.nodes
                for node in nodes:
                    node.select = False
                    node.select = True
                    nodes.active = node
                try:
                    initial_area_type = bpy.context.area.type
                    bpy.context.area.type = 'NODE_EDITOR'
                    bpy.context.area.ui_type = 'ShaderNodeTree'
                    bpy.ops.wm.redraw_timer(type='DRAW_WIN', iterations=1)
                    bpy.ops.node.group_ungroup()
                    bpy.ops.node.group_edit(exit=True)
                except Exception as e:
                    print(e)
                finally:
                    bpy.context.area.type = initial_area_type
                break
        bpy.ops.object.select_all(action='DESELECT') # Deselecciona todo en la escena
        ##############################################################################
        for ob_hb5 in hairbacks:
            if ob_hb5 is not ob_hb and ob_hb5 is not ob_hb1 and ob_hb5 is not ob_hb2 and ob_hb5 is not ob_hb3 and ob_hb5 is not ob_hb4 and ob_hb5 is not None:
                #if bpy.data.objects.get(body1) is not None:
                op = (ob_hb5.name)
                bpy.data.objects.get(op).select_set(True)
                outline_hback5 = bpy.data.objects.get(op)
                bpy.context.view_layer.objects.active = outline_hback5
                ob = bpy.context.selected_objects
                material_set = set()
                for object in bpy.context.selected_objects:
                    for material in object.material_slots:
                        material_set.add(material)
                for material in material_set:
                #    print(material.name)
                    Tex = material.name
                    bpy.data.node_groups['KK-Template Hair Back.005'].nodes['HB-Color-Value'].outputs[0].default_value = bpy.data.scenes['Scene'].sna_color03
                    #  print(Tex+'_MainTex.png')
                    TexGloss = Tex+'_HairGloss.png'
                    TexMain = Tex+'_MainTex.png'
                    TexDetailM = Tex+'_DetailMask.png'
                    TexColorM = Tex+'_ColorMask.png'
                mat = bpy.data.materials[Tex]
                #Get the node in its node tree (replace the name below)
                node_to_delete =  mat.node_tree.nodes['Principled BSDF']
                node_to_delete2 =  mat.node_tree.nodes['Material Output']
                #Remove it
                mat.node_tree.nodes.remove( node_to_delete )
                mat.node_tree.nodes.remove( node_to_delete2 )
                imghairb = ( bpimg('cf_m_hair_b_08_00_HairGloss.png.005'), bpimg('roshi'))
                for x in imghairb:
                    if x is not None:
                        bpy.data.images['cf_m_hair_b_08_00_HairGloss.png.005'].name = TexGloss
                        bpy.data.images['cf_m_hair_b_08_00_MainTex.png.005'].name = TexMain
                        bpy.data.images['cf_m_hair_b_08_00_DetailMask.png.005'].name = TexDetailM
                        bpy.data.images['cf_m_hair_b_08_00_ColorMask.png.005'].name = TexColorM
                        bpy.data.images[TexGloss].filepath = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexGloss
                        bpy.data.images[TexGloss].filepath_raw = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexGloss
                        bpy.data.images[TexMain].filepath = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexMain
                        bpy.data.images[TexMain].filepath_raw = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexMain
                        bpy.data.images[TexDetailM].filepath = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexDetailM
                        bpy.data.images[TexDetailM].filepath_raw = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexDetailM
                        bpy.data.images[TexColorM].filepath = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexColorM
                        bpy.data.images[TexColorM].filepath_raw = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexColorM
                C = bpy.context

                def instantiate_group(nodes, data_block_name):
                    group = nodes.new(type='ShaderNodeGroup')
                    group.node_tree = bpy.data.node_groups['KK-Template Hair Back.005']
                    return group
                instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
                my_mat = bpy.data.materials.get(Tex)
                bpy.data.node_groups['KK-Template Hair Back.005'].name = 'KK-Template Hair Back '+Tex
                node = bpy.data.node_groups['KK-Template Hair Back '+Tex]
                #node.extension = 'CLIP'
                #node.image = bpy.data.images[bakefinal.name]
                nodes = my_mat.node_tree.nodes
                for node in nodes:
                    node.select = False
                    node.select = True
                    nodes.active = node
                try:
                    initial_area_type = bpy.context.area.type
                    bpy.context.area.type = 'NODE_EDITOR'
                    bpy.context.area.ui_type = 'ShaderNodeTree'
                    bpy.ops.wm.redraw_timer(type='DRAW_WIN', iterations=1)
                    bpy.ops.node.group_ungroup()
                    bpy.ops.node.group_edit(exit=True)
                except Exception as e:
                    print(e)
                finally:
                    bpy.context.area.type = initial_area_type
                break
        bpy.ops.object.select_all(action='DESELECT') # Deselecciona todo en la escena
        ##############################################################################
        for ob_hb6 in hairbacks:
            if ob_hb6 is not ob_hb and ob_hb6 is not ob_hb1 and ob_hb6 is not ob_hb2 and ob_hb6 is not ob_hb3 and ob_hb6 is not ob_hb4 and ob_hb6 is not ob_hb5 and ob_hb6 is not None:
                #if bpy.data.objects.get(body1) is not None:
                op = (ob_hb6.name)
                bpy.data.objects.get(op).select_set(True)
                outline_hback6 = bpy.data.objects.get(op)
                bpy.context.view_layer.objects.active = outline_hback6
                ob = bpy.context.selected_objects
                material_set = set()
                for object in bpy.context.selected_objects:
                    for material in object.material_slots:
                        material_set.add(material)
                for material in material_set:
                #    print(material.name)
                    Tex = material.name
                    bpy.data.node_groups['KK-Template Hair Back.006'].nodes['HB-Color-Value'].outputs[0].default_value = bpy.data.scenes['Scene'].sna_color03
                    #  print(Tex+'_MainTex.png')
                    TexGloss = Tex+'_HairGloss.png'
                    TexMain = Tex+'_MainTex.png'
                    TexDetailM = Tex+'_DetailMask.png'
                    TexColorM = Tex+'_ColorMask.png'
                mat = bpy.data.materials[Tex]
                #Get the node in its node tree (replace the name below)
                node_to_delete =  mat.node_tree.nodes['Principled BSDF']
                node_to_delete2 =  mat.node_tree.nodes['Material Output']
                #Remove it
                mat.node_tree.nodes.remove( node_to_delete )
                mat.node_tree.nodes.remove( node_to_delete2 )
                imghairb = ( bpimg('cf_m_hair_b_08_00_HairGloss.png.006'), bpimg('roshi'))
                for x in imghairb:
                    if x is not None:
                        bpy.data.images['cf_m_hair_b_08_00_HairGloss.png.006'].name = TexGloss
                        bpy.data.images['cf_m_hair_b_08_00_MainTex.png.006'].name = TexMain
                        bpy.data.images['cf_m_hair_b_08_00_DetailMask.png.006'].name = TexDetailM
                        bpy.data.images['cf_m_hair_b_08_00_ColorMask.png.006'].name = TexColorM
                        bpy.data.images[TexGloss].filepath = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexGloss
                        bpy.data.images[TexGloss].filepath_raw = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexGloss
                        bpy.data.images[TexMain].filepath = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexMain
                        bpy.data.images[TexMain].filepath_raw = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexMain
                        bpy.data.images[TexDetailM].filepath = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexDetailM
                        bpy.data.images[TexDetailM].filepath_raw = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexDetailM
                        bpy.data.images[TexColorM].filepath = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexColorM
                        bpy.data.images[TexColorM].filepath_raw = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexColorM
                C = bpy.context

                def instantiate_group(nodes, data_block_name):
                    group = nodes.new(type='ShaderNodeGroup')
                    group.node_tree = bpy.data.node_groups['KK-Template Hair Back.006']
                    return group
                instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
                my_mat = bpy.data.materials.get(Tex)
                bpy.data.node_groups['KK-Template Hair Back.006'].name = 'KK-Template Hair Back '+Tex
                node = bpy.data.node_groups['KK-Template Hair Back '+Tex]
                #node.extension = 'CLIP'
                #node.image = bpy.data.images[bakefinal.name]
                nodes = my_mat.node_tree.nodes
                for node in nodes:
                    node.select = False
                    node.select = True
                    nodes.active = node
                try:
                    initial_area_type = bpy.context.area.type
                    bpy.context.area.type = 'NODE_EDITOR'
                    bpy.context.area.ui_type = 'ShaderNodeTree'
                    bpy.ops.wm.redraw_timer(type='DRAW_WIN', iterations=1)
                    bpy.ops.node.group_ungroup()
                    bpy.ops.node.group_edit(exit=True)
                except Exception as e:
                    print(e)
                finally:
                    bpy.context.area.type = initial_area_type
                break
        bpy.ops.object.select_all(action='DESELECT') # Deselecciona todo en la escena
        ##############################################################################
        for ob_hb7 in hairbacks:
            if ob_hb7 is not ob_hb and ob_hb7 is not ob_hb1 and ob_hb7 is not ob_hb2 and ob_hb7 is not ob_hb3 and ob_hb7 is not ob_hb4 and ob_hb7 is not ob_hb5 and ob_hb7 is not ob_hb6 and ob_hb7 is not None:
                #if bpy.data.objects.get(body1) is not None:
                op = (ob_hb7.name)
                bpy.data.objects.get(op).select_set(True)
                outline_hback7 = bpy.data.objects.get(op)
                bpy.context.view_layer.objects.active = outline_hback7
                ob = bpy.context.selected_objects
                material_set = set()
                for object in bpy.context.selected_objects:
                    for material in object.material_slots:
                        material_set.add(material)
                for material in material_set:
                #    print(material.name)
                    Tex = material.name
                    bpy.data.node_groups['KK-Template Hair Back.007'].nodes['HB-Color-Value'].outputs[0].default_value = bpy.data.scenes['Scene'].sna_color03
                    #  print(Tex+'_MainTex.png')
                    TexGloss = Tex+'_HairGloss.png'
                    TexMain = Tex+'_MainTex.png'
                    TexDetailM = Tex+'_DetailMask.png'
                    TexColorM = Tex+'_ColorMask.png'
                mat = bpy.data.materials[Tex]
                #Get the node in its node tree (replace the name below)
                node_to_delete =  mat.node_tree.nodes['Principled BSDF']
                node_to_delete2 =  mat.node_tree.nodes['Material Output']
                #Remove it
                mat.node_tree.nodes.remove( node_to_delete )
                mat.node_tree.nodes.remove( node_to_delete2 )
                imghairb = ( bpimg('cf_m_hair_b_08_00_HairGloss.png.007'), bpimg('roshi'))
                for x in imghairb:
                    if x is not None:
                        bpy.data.images['cf_m_hair_b_08_00_HairGloss.png.007'].name = TexGloss
                        bpy.data.images['cf_m_hair_b_08_00_MainTex.png.007'].name = TexMain
                        bpy.data.images['cf_m_hair_b_08_00_DetailMask.png.007'].name = TexDetailM
                        bpy.data.images['cf_m_hair_b_08_00_ColorMask.png.007'].name = TexColorM
                        bpy.data.images[TexGloss].filepath = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexGloss
                        bpy.data.images[TexGloss].filepath_raw = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexGloss
                        bpy.data.images[TexMain].filepath = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexMain
                        bpy.data.images[TexMain].filepath_raw = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexMain
                        bpy.data.images[TexDetailM].filepath = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexDetailM
                        bpy.data.images[TexDetailM].filepath_raw = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexDetailM
                        bpy.data.images[TexColorM].filepath = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexColorM
                        bpy.data.images[TexColorM].filepath_raw = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexColorM
                C = bpy.context

                def instantiate_group(nodes, data_block_name):
                    group = nodes.new(type='ShaderNodeGroup')
                    group.node_tree = bpy.data.node_groups['KK-Template Hair Back.007']
                    return group
                instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
                my_mat = bpy.data.materials.get(Tex)
                bpy.data.node_groups['KK-Template Hair Back.007'].name = 'KK-Template Hair Back '+Tex
                node = bpy.data.node_groups['KK-Template Hair Back '+Tex]
                #node.extension = 'CLIP'
                #node.image = bpy.data.images[bakefinal.name]
                nodes = my_mat.node_tree.nodes
                for node in nodes:
                    node.select = False
                    node.select = True
                    nodes.active = node
                try:
                    initial_area_type = bpy.context.area.type
                    bpy.context.area.type = 'NODE_EDITOR'
                    bpy.context.area.ui_type = 'ShaderNodeTree'
                    bpy.ops.wm.redraw_timer(type='DRAW_WIN', iterations=1)
                    bpy.ops.node.group_ungroup()
                    bpy.ops.node.group_edit(exit=True)
                except Exception as e:
                    print(e)
                finally:
                    bpy.context.area.type = initial_area_type
                break
        bpy.ops.object.select_all(action='DESELECT') # Deselecciona todo en la escena
        ##############################################################################
        for ob_hb8 in hairbacks:
            if ob_hb8 is not ob_hb and ob_hb8 is not ob_hb1 and ob_hb8 is not ob_hb2 and ob_hb8 is not ob_hb3 and ob_hb8 is not ob_hb4 and ob_hb8 is not ob_hb5 and ob_hb8 is not ob_hb6 and ob_hb8 is not ob_hb7 and ob_hb8 is not None:
                #if bpy.data.objects.get(body1) is not None:
                op = (ob_hb8.name)
                bpy.data.objects.get(op).select_set(True)
                outline_hback8 = bpy.data.objects.get(op)
                bpy.context.view_layer.objects.active = outline_hback8
                ob = bpy.context.selected_objects
                material_set = set()
                for object in bpy.context.selected_objects:
                    for material in object.material_slots:
                        material_set.add(material)
                for material in material_set:
                #    print(material.name)
                    Tex = material.name
                    bpy.data.node_groups['KK-Template Hair Back.008'].nodes['HB-Color-Value'].outputs[0].default_value = bpy.data.scenes['Scene'].sna_color03
                    #  print(Tex+'_MainTex.png')
                    TexGloss = Tex+'_HairGloss.png'
                    TexMain = Tex+'_MainTex.png'
                    TexDetailM = Tex+'_DetailMask.png'
                    TexColorM = Tex+'_ColorMask.png'
                mat = bpy.data.materials[Tex]
                #Get the node in its node tree (replace the name below)
                node_to_delete =  mat.node_tree.nodes['Principled BSDF']
                node_to_delete2 =  mat.node_tree.nodes['Material Output']
                #Remove it
                mat.node_tree.nodes.remove( node_to_delete )
                mat.node_tree.nodes.remove( node_to_delete2 )
                imghairb = ( bpimg('cf_m_hair_b_08_00_HairGloss.png.008'), bpimg('roshi'))
                for x in imghairb:
                    if x is not None:
                        bpy.data.images['cf_m_hair_b_08_00_HairGloss.png.008'].name = TexGloss
                        bpy.data.images['cf_m_hair_b_08_00_MainTex.png.008'].name = TexMain
                        bpy.data.images['cf_m_hair_b_08_00_DetailMask.png.008'].name = TexDetailM
                        bpy.data.images['cf_m_hair_b_08_00_ColorMask.png.008'].name = TexColorM
                        bpy.data.images[TexGloss].filepath = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexGloss
                        bpy.data.images[TexGloss].filepath_raw = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexGloss
                        bpy.data.images[TexMain].filepath = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexMain
                        bpy.data.images[TexMain].filepath_raw = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexMain
                        bpy.data.images[TexDetailM].filepath = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexDetailM
                        bpy.data.images[TexDetailM].filepath_raw = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexDetailM
                        bpy.data.images[TexColorM].filepath = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexColorM
                        bpy.data.images[TexColorM].filepath_raw = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexColorM
                C = bpy.context

                def instantiate_group(nodes, data_block_name):
                    group = nodes.new(type='ShaderNodeGroup')
                    group.node_tree = bpy.data.node_groups['KK-Template Hair Back.008']
                    return group
                instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
                my_mat = bpy.data.materials.get(Tex)
                bpy.data.node_groups['KK-Template Hair Back.008'].name = 'KK-Template Hair Back '+Tex
                node = bpy.data.node_groups['KK-Template Hair Back '+Tex]
                #node.extension = 'CLIP'
                #node.image = bpy.data.images[bakefinal.name]
                nodes = my_mat.node_tree.nodes
                for node in nodes:
                    node.select = False
                    node.select = True
                    nodes.active = node
                try:
                    initial_area_type = bpy.context.area.type
                    bpy.context.area.type = 'NODE_EDITOR'
                    bpy.context.area.ui_type = 'ShaderNodeTree'
                    bpy.ops.wm.redraw_timer(type='DRAW_WIN', iterations=1)
                    bpy.ops.node.group_ungroup()
                    bpy.ops.node.group_edit(exit=True)
                except Exception as e:
                    print(e)
                finally:
                    bpy.context.area.type = initial_area_type
                break
        bpy.ops.object.select_all(action='DESELECT') # Deselecciona todo en la escena
        ##############################################################################
        for ob_hb9 in hairbacks:
            if ob_hb9 is not ob_hb and ob_hb9 is not ob_hb1 and ob_hb9 is not ob_hb2 and ob_hb9 is not ob_hb3 and ob_hb9 is not ob_hb4 and ob_hb9 is not ob_hb5 and ob_hb9 is not ob_hb6 and ob_hb9 is not ob_hb7 and ob_hb9 is not ob_hb8 and ob_hb9 is not None:
                #if bpy.data.objects.get(body1) is not None:
                op = (ob_hb9.name)
                bpy.data.objects.get(op).select_set(True)
                outline_hback9 = bpy.data.objects.get(op)
                bpy.context.view_layer.objects.active = outline_hback9
                ob = bpy.context.selected_objects
                material_set = set()
                for object in bpy.context.selected_objects:
                    for material in object.material_slots:
                        material_set.add(material)
                for material in material_set:
                #    print(material.name)
                    Tex = material.name
                    bpy.data.node_groups['KK-Template Hair Back.009'].nodes['HB-Color-Value'].outputs[0].default_value = bpy.data.scenes['Scene'].sna_color03
                    #  print(Tex+'_MainTex.png')
                    TexGloss = Tex+'_HairGloss.png'
                    TexMain = Tex+'_MainTex.png'
                    TexDetailM = Tex+'_DetailMask.png'
                    TexColorM = Tex+'_ColorMask.png'
                mat = bpy.data.materials[Tex]
                #Get the node in its node tree (replace the name below)
                node_to_delete =  mat.node_tree.nodes['Principled BSDF']
                node_to_delete2 =  mat.node_tree.nodes['Material Output']
                #Remove it
                mat.node_tree.nodes.remove( node_to_delete )
                mat.node_tree.nodes.remove( node_to_delete2 )
                imghairb = ( bpimg('cf_m_hair_b_08_00_HairGloss.png.009'), bpimg('roshi'))
                for x in imghairb:
                    if x is not None:
                        bpy.data.images['cf_m_hair_b_08_00_HairGloss.png.009'].name = TexGloss
                        bpy.data.images['cf_m_hair_b_08_00_MainTex.png.009'].name = TexMain
                        bpy.data.images['cf_m_hair_b_08_00_DetailMask.png.009'].name = TexDetailM
                        bpy.data.images['cf_m_hair_b_08_00_ColorMask.png.009'].name = TexColorM
                        bpy.data.images[TexGloss].filepath = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexGloss
                        bpy.data.images[TexGloss].filepath_raw = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexGloss
                        bpy.data.images[TexMain].filepath = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexMain
                        bpy.data.images[TexMain].filepath_raw = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexMain
                        bpy.data.images[TexDetailM].filepath = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexDetailM
                        bpy.data.images[TexDetailM].filepath_raw = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexDetailM
                        bpy.data.images[TexColorM].filepath = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexColorM
                        bpy.data.images[TexColorM].filepath_raw = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexColorM
                C = bpy.context

                def instantiate_group(nodes, data_block_name):
                    group = nodes.new(type='ShaderNodeGroup')
                    group.node_tree = bpy.data.node_groups['KK-Template Hair Back.009']
                    return group
                instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
                my_mat = bpy.data.materials.get(Tex)
                bpy.data.node_groups['KK-Template Hair Back.009'].name = 'KK-Template Hair Back '+Tex
                node = bpy.data.node_groups['KK-Template Hair Back '+Tex]
                #node.extension = 'CLIP'
                #node.image = bpy.data.images[bakefinal.name]
                nodes = my_mat.node_tree.nodes
                for node in nodes:
                    node.select = False
                    node.select = True
                    nodes.active = node
                try:
                    initial_area_type = bpy.context.area.type
                    bpy.context.area.type = 'NODE_EDITOR'
                    bpy.context.area.ui_type = 'ShaderNodeTree'
                    bpy.ops.wm.redraw_timer(type='DRAW_WIN', iterations=1)
                    bpy.ops.node.group_ungroup()
                    bpy.ops.node.group_edit(exit=True)
                except Exception as e:
                    print(e)
                finally:
                    bpy.context.area.type = initial_area_type
                break
        bpy.ops.object.select_all(action='DESELECT') # Deselecciona todo en la escena
        ########################################ROPAS#################################
        bpy.ops.object.select_all(action='DESELECT') # Deselecciona todo en la escena
        ropitas = (w(cloth1), w(cloth2), w(cloth3), w(cloth4), w(cloth5), w(cloth6), w(cloth7), w(cloth8), w(cloth9), w(cloth10), w(cloth11), w(cloth12), w(cloth13), w(cloth14), w(cloth15), w(cloth16), w(cloth17), w(cloth18), w(cloth19), w(cloth20), w(cloth21), w(cloth22), w(cloth23), w(cloth24), w(cloth25), w(cloth26), w(cloth27), w(cloth28), w(cloth29), w(cloth30), w(cloth31), w(cloth32), w(cloth33), w(cloth34), w(cloth35), w(cloth36), w(cloth37), w(cloth38), w(cloth39), w(cloth40), w(cloth41), w(cloth42), w(cloth43), w(cloth44), w(cloth45), w(cloth46), w(cloth47), w(cloth48), w(cloth49), w(cloth50), w(cloth51), w(cloth52), w(cloth53), w(cloth54), w(cloth55), w(cloth56), w(cloth57), w(cloth58), w(cloth59), w(cloth60), w(cloth61), w(cloth62), w(cloth63), w(cloth64), w(cloth65), w(cloth66), w(cloth67), w(cloth68), w(cloth69), w(cloth70), w(cloth71), w(cloth72), w(cloth73), w(cloth74), w(cloth75), w(cloth76), w(cloth77), w(cloth78), w(cloth79), w(cloth80), w(cloth81), w(cloth82), w(cloth83), w(cloth84), w(cloth85), w(cloth86), w(cloth87), w(cloth88), w(cloth89), w(cloth90), w(cloth91), w(cloth92), w(cloth93), w(cloth94), w(cloth95), w(cloth96), w(cloth97), w(cloth98), w(cloth99), w(cloth100), w(cloth101), w(cloth102), w(cloth103), w(cloth104), w(cloth105), w(cloth106), w(cloth107), w(cloth108), w(cloth109), w(cloth110), w(cloth111), w(cloth112), w(cloth113), w(cloth114), w(cloth115), w(cloth116), w(cloth117), w(cloth118), w(cloth119), w(cloth120), w(cloth121), w(cloth122), w(cloth123), w(cloth124), w(cloth125), w(cloth126), w(cloth127), w(cloth128), w(cloth129), w(cloth130), w(cloth131), w(cloth132), w(cloth133), w(cloth134), w(cloth135), w(cloth136), w(cloth137), w(cloth138), w(cloth139), w(cloth140), w(cloth141), w(cloth142), w(cloth143), w(cloth144), w(cloth145), w(cloth146), w(cloth147), w(cloth148), w(cloth149), w(cloth150), w(cloth151), w(cloth152), w(cloth153), w(cloth154), w(cloth155), w(cloth156), w(cloth157), w(cloth158), w(cloth159), w(cloth160), w(cloth161), w(cloth162), w(cloth163), w(cloth164), w(cloth165), w(cloth166), w(cloth167), w(cloth168), w(cloth169), w(cloth170), w(cloth171), w(cloth172), w(cloth173), w(cloth174), w(cloth175), w(cloth176), w(cloth177), w(cloth178), w(cloth179), w(cloth180), w(cloth181), w(cloth182), w(cloth183), w(cloth184), w(cloth185), w(cloth186), w(cloth187), w(cloth188), w(cloth189), w(cloth190), w(cloth191), w(cloth192), w(cloth193), w(cloth194), w(cloth195), w(cloth196), w(cloth197), w(cloth198), w(cloth199), w(cloth200), w(cloth201), w(cloth202), w(cloth203), w(cloth204), w(cloth205), w(cloth206), w(cloth207), w(cloth208), w(cloth209), w(cloth210), w(cloth211), w(cloth212), w(cloth213), w(cloth214), w(cloth215), w(cloth216), w(cloth217), w(cloth218), w(cloth219), w(cloth220), w(cloth221), w(cloth222), w(cloth223), w(cloth224), w(cloth225), w(cloth226), w(cloth227), w(cloth228), w(cloth229), w(cloth230), w(cloth231), w(cloth232), w(cloth233), w(cloth234), w(cloth235), w(cloth236), w(cloth237), w(cloth238), w(cloth239), w(cloth240), w(cloth241), w(cloth243), w(cloth244), w(cloth245), w(cloth246), w(cloth247), w(cloth248), w(cloth249), w(cloth250), w(cloth251), w(cloth252), w(cloth253), w(cloth254), w(cloth255), w(cloth256), w(cloth257), w(cloth258), w(cloth259), w(cloth260), w(cloth261))
        for ob_top in ropitas:
            if ob_top is not None:
                #if bpy.data.objects.get(body1) is not None:
                op = (ob_top.name)
                bpy.data.objects.get(op).select_set(True)
                bpy.context.view_layer.objects.active = bpy.data.objects.get(op)
                ob = bpy.context.selected_objects
                material_set = set()
                for object in bpy.context.selected_objects:
                    for material in object.material_slots:
                        material_set.add(material)
                for material in material_set:
                    Tex = material.name
                    TexMain = Tex+'_MainTex.png'
                    TexDetailM = Tex+'_DetailMask.png'
                    TexNormal = Tex+'_NormalMap.png'
                    TexAnotherR = Tex+'_AnotherRamp.png'
                    TexLiquidM = Tex+'_liquidmask.png'
                    TexTex2 = Tex+'_Texture2.png'
                    TexTex3 = Tex+'_Texture3.png'
                    bpy.data.scenes['Scene'].sna_color04 = bpy.data.materials[Tex].node_tree.nodes['Principled BSDF'].inputs[0].default_value
                mat = bpy.data.materials[Tex]
                #Get the node in its node tree (replace the name below)
                node_to_delete =  mat.node_tree.nodes['Principled BSDF']
                node_to_delete2 =  mat.node_tree.nodes['Material Output']
                #Remove it
                mat.node_tree.nodes.remove( node_to_delete )
                mat.node_tree.nodes.remove( node_to_delete2 )
                imgcloths = ( bpimg('cf_m_top_jacket06_MainTex.png'), bpimg('chidori'))
                for x in imgcloths:
                    if x is not None:
                        bpy.data.images['cf_m_top_jacket06_MainTex.png'].name = TexMain 
                        bpy.data.images['cf_m_top_jacket06_DetailMask.png'].name = TexDetailM
                        bpy.data.images['cf_m_top_jacket06_NormalMap.png'].name = TexNormal
                        bpy.data.images['cf_m_top_jacket06_AnotherRamp.png'].name = TexAnotherR
                        bpy.data.images['cf_m_top_jacket06_liquidmask.png'].name = TexLiquidM
                        bpy.data.images['cf_m_top_jacket06_Texture2.png'].name = TexTex2
                        bpy.data.images['cf_m_top_jacket06_Texture3.png'].name = TexTex3
                        bpy.data.images[TexMain].filepath = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexMain
                        bpy.data.images[TexMain].filepath_raw = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexMain
                        bpy.data.images[TexDetailM].filepath = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexDetailM
                        bpy.data.images[TexDetailM].filepath_raw = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexDetailM
                        bpy.data.images[TexNormal].filepath = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexNormal
                        bpy.data.images[TexNormal].filepath_raw = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexNormal
                        bpy.data.images[TexAnotherR].filepath = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexAnotherR
                        bpy.data.images[TexAnotherR].filepath_raw = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexAnotherR
                        bpy.data.images[TexLiquidM].filepath = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexLiquidM
                        bpy.data.images[TexLiquidM].filepath_raw = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexLiquidM
                        bpy.data.images[TexTex2].filepath = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexTex2
                        bpy.data.images[TexTex2].filepath_raw = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexTex2
                        bpy.data.images[TexTex3].filepath = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexTex3
                        bpy.data.images[TexTex3].filepath_raw = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexTex3
                C = bpy.context

                def instantiate_group(nodes, data_block_name):
                    group = nodes.new(type='ShaderNodeGroup')
                    group.node_tree = bpy.data.node_groups['KK-Template Sachi']
                    return group
                instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
                bpy.context.object.active_material.blend_method = 'CLIP'
                bpy.context.object.active_material.shadow_method = 'CLIP'
                my_mat = bpy.data.materials.get(Tex)
                bpy.data.node_groups['KK-Template Sachi'].name = 'KK-Template Top '+Tex
                node = bpy.data.node_groups['KK-Template Top '+Tex]
                #node.extension = 'CLIP'
                #node.image = bpy.data.images[bakefinal.name]
                nodes = my_mat.node_tree.nodes
                for node in nodes:
                    node.select = False
                    node.select = True
                    nodes.active = node
                try:
                    initial_area_type = bpy.context.area.type
                    bpy.context.area.type = 'NODE_EDITOR'
                    bpy.context.area.ui_type = 'ShaderNodeTree'
                    bpy.ops.wm.redraw_timer(type='DRAW_WIN', iterations=1)
                    bpy.ops.node.group_ungroup()
                    bpy.ops.node.group_edit(exit=True)
                except Exception as e:
                    print(e)
                finally:
                    bpy.context.area.type = initial_area_type
                break
        bpy.ops.object.select_all(action='DESELECT') # Deselecciona todo en la escena
        for ob_top1 in ropitas:
            if ob_top1 is not ob_top and ob_top1 is not None:
                #if bpy.data.objects.get(body1) is not None:
                op = (ob_top1.name)
                bpy.data.objects.get(op).select_set(True)
                bpy.context.view_layer.objects.active = bpy.data.objects.get(op)
                ob = bpy.context.selected_objects
                material_set = set()
                for object in bpy.context.selected_objects:
                    for material in object.material_slots:
                        material_set.add(material)
                for material in material_set:
                    Tex = material.name
                    TexMain = Tex+'_MainTex.png'
                    TexDetailM = Tex+'_DetailMask.png'
                    TexNormal = Tex+'_NormalMap.png'
                    TexAnotherR = Tex+'_AnotherRamp.png'
                    TexLiquidM = Tex+'_liquidmask.png'
                    TexTex2 = Tex+'_Texture2.png'
                    TexTex3 = Tex+'_Texture3.png'
                    bpy.data.scenes['Scene'].sna_color04 = bpy.data.materials[Tex].node_tree.nodes['Principled BSDF'].inputs[0].default_value
                mat = bpy.data.materials[Tex]
                #Get the node in its node tree (replace the name below)
                node_to_delete =  mat.node_tree.nodes['Principled BSDF']
                node_to_delete2 =  mat.node_tree.nodes['Material Output']
                #Remove it
                mat.node_tree.nodes.remove( node_to_delete )
                mat.node_tree.nodes.remove( node_to_delete2 )
                imgcloths1 = ( bpimg('cf_m_top_jacket06_MainTex.png.001'), bpimg('chidori'))
                for x in imgcloths1:
                    if x is not None:
                        bpy.data.images['cf_m_top_jacket06_MainTex.png.001'].name = TexMain 
                        bpy.data.images['cf_m_top_jacket06_DetailMask.png.001'].name = TexDetailM
                        bpy.data.images['cf_m_top_jacket06_NormalMap.png.001'].name = TexNormal
                        bpy.data.images['cf_m_top_jacket06_AnotherRamp.png.001'].name = TexAnotherR
                        bpy.data.images['cf_m_top_jacket06_liquidmask.png.001'].name = TexLiquidM
                        bpy.data.images['cf_m_top_jacket06_Texture2.png.001'].name = TexTex2
                        bpy.data.images['cf_m_top_jacket06_Texture3.png.001'].name = TexTex3
                        bpy.data.images[TexMain].filepath = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexMain
                        bpy.data.images[TexMain].filepath_raw = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexMain
                        bpy.data.images[TexDetailM].filepath = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexDetailM
                        bpy.data.images[TexDetailM].filepath_raw = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexDetailM
                        bpy.data.images[TexNormal].filepath = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexNormal
                        bpy.data.images[TexNormal].filepath_raw = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexNormal
                        bpy.data.images[TexAnotherR].filepath = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexAnotherR
                        bpy.data.images[TexAnotherR].filepath_raw = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexAnotherR
                        bpy.data.images[TexLiquidM].filepath = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexLiquidM
                        bpy.data.images[TexLiquidM].filepath_raw = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexLiquidM
                        bpy.data.images[TexTex2].filepath = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexTex2
                        bpy.data.images[TexTex2].filepath_raw = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexTex2
                        bpy.data.images[TexTex3].filepath = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexTex3
                        bpy.data.images[TexTex3].filepath_raw = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexTex3
                C = bpy.context

                def instantiate_group(nodes, data_block_name):
                    group = nodes.new(type='ShaderNodeGroup')
                    group.node_tree = bpy.data.node_groups['KK-Template Sachi.001']
                    return group
                instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
                bpy.context.object.active_material.blend_method = 'CLIP'
                bpy.context.object.active_material.shadow_method = 'CLIP'
                my_mat = bpy.data.materials.get(Tex)
                bpy.data.node_groups['KK-Template Sachi.001'].name = 'KK-Template Top '+Tex
                node = bpy.data.node_groups['KK-Template Top '+Tex]
                #node.extension = 'CLIP'
                #node.image = bpy.data.images[bakefinal.name]
                nodes = my_mat.node_tree.nodes
                for node in nodes:
                    node.select = False
                    node.select = True
                    nodes.active = node
                try:
                    initial_area_type = bpy.context.area.type
                    bpy.context.area.type = 'NODE_EDITOR'
                    bpy.context.area.ui_type = 'ShaderNodeTree'
                    bpy.ops.wm.redraw_timer(type='DRAW_WIN', iterations=1)
                    bpy.ops.node.group_ungroup()
                    bpy.ops.node.group_edit(exit=True)
                except Exception as e:
                    print(e)
                finally:
                    bpy.context.area.type = initial_area_type
                break
        bpy.ops.object.select_all(action='DESELECT') # Deselecciona todo en la escena
        for ob_top2 in ropitas:
            if ob_top2 is not ob_top1 and ob_top2 is not ob_top and ob_top2 is not None:
                #if bpy.data.objects.get(body1) is not None:
                op = (ob_top2.name)
                bpy.data.objects.get(op).select_set(True)
                bpy.context.view_layer.objects.active = bpy.data.objects.get(op)
                ob = bpy.context.selected_objects
                material_set = set()
                for object in bpy.context.selected_objects:
                    for material in object.material_slots:
                        material_set.add(material)
                for material in material_set:
                    Tex = material.name
                    TexMain = Tex+'_MainTex.png'
                    TexDetailM = Tex+'_DetailMask.png'
                    TexNormal = Tex+'_NormalMap.png'
                    TexAnotherR = Tex+'_AnotherRamp.png'
                    TexLiquidM = Tex+'_liquidmask.png'
                    TexTex2 = Tex+'_Texture2.png'
                    TexTex3 = Tex+'_Texture3.png'
                    bpy.data.scenes['Scene'].sna_color04 = bpy.data.materials[Tex].node_tree.nodes['Principled BSDF'].inputs[0].default_value
                mat = bpy.data.materials[Tex]
                #Get the node in its node tree (replace the name below)
                node_to_delete =  mat.node_tree.nodes['Principled BSDF']
                node_to_delete2 =  mat.node_tree.nodes['Material Output']
                #Remove it
                mat.node_tree.nodes.remove( node_to_delete )
                mat.node_tree.nodes.remove( node_to_delete2 )
                imgcloths1 = ( bpimg('cf_m_top_jacket06_MainTex.png.002'), bpimg('chidori'))
                for x in imgcloths1:
                    if x is not None:
                        bpy.data.images['cf_m_top_jacket06_MainTex.png.002'].name = TexMain 
                        bpy.data.images['cf_m_top_jacket06_DetailMask.png.002'].name = TexDetailM
                        bpy.data.images['cf_m_top_jacket06_NormalMap.png.002'].name = TexNormal
                        bpy.data.images['cf_m_top_jacket06_AnotherRamp.png.002'].name = TexAnotherR
                        bpy.data.images['cf_m_top_jacket06_liquidmask.png.002'].name = TexLiquidM
                        bpy.data.images['cf_m_top_jacket06_Texture2.png.002'].name = TexTex2
                        bpy.data.images['cf_m_top_jacket06_Texture3.png.002'].name = TexTex3
                        bpy.data.images[TexMain].filepath = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexMain
                        bpy.data.images[TexMain].filepath_raw = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexMain
                        bpy.data.images[TexDetailM].filepath = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexDetailM
                        bpy.data.images[TexDetailM].filepath_raw = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexDetailM
                        bpy.data.images[TexNormal].filepath = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexNormal
                        bpy.data.images[TexNormal].filepath_raw = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexNormal
                        bpy.data.images[TexAnotherR].filepath = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexAnotherR
                        bpy.data.images[TexAnotherR].filepath_raw = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexAnotherR
                        bpy.data.images[TexLiquidM].filepath = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexLiquidM
                        bpy.data.images[TexLiquidM].filepath_raw = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexLiquidM
                        bpy.data.images[TexTex2].filepath = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexTex2
                        bpy.data.images[TexTex2].filepath_raw = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexTex2
                        bpy.data.images[TexTex3].filepath = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexTex3
                        bpy.data.images[TexTex3].filepath_raw = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexTex3
                C = bpy.context

                def instantiate_group(nodes, data_block_name):
                    group = nodes.new(type='ShaderNodeGroup')
                    group.node_tree = bpy.data.node_groups['KK-Template Sachi.002']
                    return group
                instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
                bpy.context.object.active_material.blend_method = 'CLIP'
                bpy.context.object.active_material.shadow_method = 'CLIP'
                my_mat = bpy.data.materials.get(Tex)
                bpy.data.node_groups['KK-Template Sachi.002'].name = 'KK-Template Top '+Tex
                node = bpy.data.node_groups['KK-Template Top '+Tex]
                #node.extension = 'CLIP'
                #node.image = bpy.data.images[bakefinal.name]
                nodes = my_mat.node_tree.nodes
                for node in nodes:
                    node.select = False
                    node.select = True
                    nodes.active = node
                try:
                    initial_area_type = bpy.context.area.type
                    bpy.context.area.type = 'NODE_EDITOR'
                    bpy.context.area.ui_type = 'ShaderNodeTree'
                    bpy.ops.wm.redraw_timer(type='DRAW_WIN', iterations=1)
                    bpy.ops.node.group_ungroup()
                    bpy.ops.node.group_edit(exit=True)
                except Exception as e:
                    print(e)
                finally:
                    bpy.context.area.type = initial_area_type
                break
        bpy.ops.object.select_all(action='DESELECT') # Deselecciona todo en la escena
        ################################UNDERCLOTH###################################
        bpy.ops.object.select_all(action='DESELECT') # Deselecciona todo en la escena
        # Get body object
        uclothes = (w(ucloth1), w(ucloth2), w(ucloth3), w(ucloth4), w(ucloth5), w(ucloth6), w(ucloth7), w(ucloth8))
        for x in uclothes:
            if x is not None:
                #if bpy.data.objects.get(body1) is not None:
                op = (x.name)
                bpy.data.objects.get(op).select_set(True)
                outline_ucloth = bpy.data.objects.get(op)
                bpy.context.view_layer.objects.active = outline_ucloth
                ob = bpy.context.selected_objects
                material_set = set()
                for object in bpy.context.selected_objects:
                    for material in object.material_slots:
                        material_set.add(material)
                for material in material_set:
                    Tex = material.name
                    TexMain = Tex+'_MainTex.png'
                    TexDetailM = Tex+'_DetailMask.png'
                    TexNormal = Tex+'_NormalMap.png'
                    TexAlphaM = Tex+'_AlphaMask.png'
                    TexLiquidM = Tex+'_liquidmask.png'
                    TexTex2 = Tex+'_Texture2.png'
                    TexTex3 = Tex+'_Texture3.png'
                mat = bpy.data.materials[Tex]
                #Get the node in its node tree (replace the name below)
                node_to_delete =  mat.node_tree.nodes['Principled BSDF']
                node_to_delete2 =  mat.node_tree.nodes['Material Output']
                #Remove it
                mat.node_tree.nodes.remove( node_to_delete )
                mat.node_tree.nodes.remove( node_to_delete2 )
                bpy.data.images['cf_m_top_inner01_MainTex.png'].name = TexMain 
                bpy.data.images['cf_m_top_inner01_DetailMask.png'].name = TexDetailM
                bpy.data.images['cf_m_top_inner01_NormalMap.png'].name = TexNormal
                bpy.data.images['cf_m_top_inner01_AlphaMask.png'].name = TexAlphaM
                bpy.data.images['cf_m_top_inner01_liquidmask.png'].name = TexLiquidM
                bpy.data.images['cf_m_top_inner01_Texture2.png'].name = TexTex2
                bpy.data.images['cf_m_top_inner01_Texture3.png'].name = TexTex3
                bpy.data.images[TexMain].filepath = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexMain
                bpy.data.images[TexMain].filepath_raw = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexMain
                bpy.data.images[TexDetailM].filepath = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexDetailM
                bpy.data.images[TexDetailM].filepath_raw = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexDetailM
                bpy.data.images[TexNormal].filepath = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexNormal
                bpy.data.images[TexNormal].filepath_raw = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexNormal
                bpy.data.images[TexAlphaM].filepath = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexAlphaM
                bpy.data.images[TexAlphaM].filepath_raw = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexAlphaM
                bpy.data.images[TexLiquidM].filepath = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexLiquidM
                bpy.data.images[TexLiquidM].filepath_raw = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexLiquidM
                bpy.data.images[TexTex2].filepath = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexTex2
                bpy.data.images[TexTex2].filepath_raw = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexTex2
                bpy.data.images[TexTex3].filepath = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexTex3
                bpy.data.images[TexTex3].filepath_raw = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexTex3
                C = bpy.context

                def instantiate_group(nodes, data_block_name):
                    group = nodes.new(type='ShaderNodeGroup')
                    group.node_tree = bpy.data.node_groups['KK-Template UnderCloth']
                    return group
                instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
                bpy.context.object.active_material.blend_method = 'CLIP'
                bpy.context.object.active_material.shadow_method = 'CLIP'
                my_mat = bpy.data.materials.get(Tex)
                bpy.data.node_groups['KK-Template UnderCloth'].name = 'KK-Template UnderCloth '+Tex
                node = bpy.data.node_groups['KK-Template UnderCloth '+Tex]
                #node.extension = 'CLIP'
                #node.image = bpy.data.images[bakefinal.name]
                nodes = my_mat.node_tree.nodes
                for node in nodes:
                    node.select = False
                    node.select = True
                    nodes.active = node
                try:
                    initial_area_type = bpy.context.area.type
                    bpy.context.area.type = 'NODE_EDITOR'
                    bpy.context.area.ui_type = 'ShaderNodeTree'
                    bpy.ops.wm.redraw_timer(type='DRAW_WIN', iterations=1)
                    bpy.ops.node.group_ungroup()
                    bpy.ops.node.group_edit(exit=True)
                except Exception as e:
                    print(e)
                finally:
                    bpy.context.area.type = initial_area_type
                break
        bpy.ops.object.select_all(action='DESELECT') # Deselecciona todo en la escena
        ###################################PANTS#####################################
        bpy.ops.object.select_all(action='DESELECT') # Deselecciona todo en la escena
        # Get body object
        pantes = ( w(pants1), w(pants2), w(pants3), w(pants4), w(pants5), w(pants6), w(pants7), w(pants8), w(pants9), w(pants10), w(pants11), w(pants12), w(pants13), w(pants14), w(pants15), w(pants16), w(pants17), w(pants18), w(pants19), w(pants20), w(pants21), w(pants22), w(pants23), w(pants24), w(pants25), w(pants26), w(pants27), w(pants28), w(pants29), w(pants30), w(pants31), w(pants32), w(pants33), w(pants34), w(pants35), w(pants36), w(pants37), w(pants38), w(pants39), w(pants40), w(pants41), w(pants42), w(pants43), w(pants44), w(pants45), w(pants46), w(pants47), w(pants48), w(pants49), w(pants50), w(pants51), w(pants52), w(pants53), w(pants54), w(pants55), w(pants56), w(pants57), w(pants58), w(pants59), w(pants60), w(pants61), w(pants62), w(pants63), w(pants64), w(pants65), w(pants66), w(pants67), w(pants68), w(pants69), w(pants70), w(pants71), w(pants72), w(pants73), w(pants74), w(pants75), w(pants76), w(pants77), w(pants78), w(pants79), w(pants80), w(pants81), w(pants82), w(pants83), w(pants84), w(pants85), w(pants86), w(pants87), w(pants88), w(pants89))
        for ob_pant in pantes:
            if ob_pant is not None:
                #if bpy.data.objects.get(body1) is not None:
                op = (ob_pant.name)
                bpy.data.objects.get(op).select_set(True)
                outline_pants = bpy.data.objects.get(op)
                bpy.context.view_layer.objects.active = outline_pants
                #bpy.ops.object.join()
                #bpy.ops.object.origin_set(type='ORIGIN_CENTER_OF_VOLUME')
                ob = bpy.context.selected_objects
                material_set = set()
                for object in bpy.context.selected_objects:
                    for material in object.material_slots:
                        material_set.add(material)
                for material in material_set:
                #    print(material.name)
                    Tex = material.name
                    #  print(Tex+'_MainTex.png')
                    TexMain = Tex+'_MainTex.png'
                    TexDetailM = Tex+'_DetailMask.png'
                    TexNormal = Tex+'_NormalMap.png'
                    TexLiquidM = Tex+'_liquidmask.png'
                    TexTex2 = Tex+'_Texture2.png'
                    TexTex3 = Tex+'_Texture3.png'
                    bpy.data.scenes['Scene'].sna_color05 = bpy.data.materials[Tex].node_tree.nodes['Principled BSDF'].inputs[0].default_value
                mat = bpy.data.materials[Tex]
                #Get the node in its node tree (replace the name below)
                node_to_delete =  mat.node_tree.nodes['Principled BSDF']
                node_to_delete2 =  mat.node_tree.nodes['Material Output']
                #Remove it
                mat.node_tree.nodes.remove( node_to_delete )
                mat.node_tree.nodes.remove( node_to_delete2 )
                imgpants = ( bpimg('cf_m_bot_skirt01_MainTex.png'), bpimg('rasengan'))
                for x in imgpants:
                    if x is not None:
                        bpy.data.images['cf_m_bot_skirt01_MainTex.png'].name = TexMain
                        bpy.data.images['cf_m_bot_skirt01_DetailMask.png'].name = TexDetailM
                        bpy.data.images['cf_m_bot_skirt01_NormalMap.png'].name = TexNormal
                        bpy.data.images['cf_m_bot_skirt01_liquidmask.png'].name = TexLiquidM
                        bpy.data.images['cf_m_bot_skirt01_Texture2.png'].name = TexTex2
                        bpy.data.images['cf_m_bot_skirt01_Texture3.png'].name = TexTex3
                        bpy.data.images[TexMain].filepath = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexMain
                        bpy.data.images[TexMain].filepath_raw = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexMain
                        bpy.data.images[TexDetailM].filepath = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexDetailM
                        bpy.data.images[TexDetailM].filepath_raw = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexDetailM
                        bpy.data.images[TexNormal].filepath = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexNormal
                        bpy.data.images[TexNormal].filepath_raw = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexNormal
                        bpy.data.images[TexLiquidM].filepath = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexLiquidM
                        bpy.data.images[TexLiquidM].filepath_raw = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexLiquidM
                        bpy.data.images[TexTex2].filepath = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexTex2
                        bpy.data.images[TexTex2].filepath_raw = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexTex2
                        bpy.data.images[TexTex3].filepath = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexTex3
                        bpy.data.images[TexTex3].filepath_raw = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexTex3
                C = bpy.context

                def instantiate_group(nodes, data_block_name):
                    group = nodes.new(type='ShaderNodeGroup')
                    group.node_tree = bpy.data.node_groups['KK-Template Pants']
                    return group
                instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
                bpy.context.object.active_material.blend_method = 'CLIP'
                bpy.context.object.active_material.shadow_method = 'CLIP'
                my_mat = bpy.data.materials.get(Tex)
                bpy.data.node_groups['KK-Template Pants'].name = 'KK-Template Bot '+Tex
                node = bpy.data.node_groups['KK-Template Bot '+Tex]
                #node.extension = 'CLIP'
                #node.image = bpy.data.images[bakefinal.name]
                nodes = my_mat.node_tree.nodes
                for node in nodes:
                    node.select = False
                    node.select = True
                    nodes.active = node
                try:
                    initial_area_type = bpy.context.area.type
                    bpy.context.area.type = 'NODE_EDITOR'
                    bpy.context.area.ui_type = 'ShaderNodeTree'
                    bpy.ops.wm.redraw_timer(type='DRAW_WIN', iterations=1)
                    bpy.ops.node.group_ungroup()
                    bpy.ops.node.group_edit(exit=True)
                except Exception as e:
                    print(e)
                finally:
                    bpy.context.area.type = initial_area_type
                break
        bpy.ops.object.select_all(action='DESELECT') # Deselecciona todo en la escena
        #############################################################################
        for ob_pant1 in pantes:
            if ob_pant1 is not ob_pant and ob_pant1 is not None:
                #if bpy.data.objects.get(body1) is not None:
                op = (ob_pant1.name)
                bpy.data.objects.get(op).select_set(True)
                outline_pants1 = bpy.data.objects.get(op)
                bpy.context.view_layer.objects.active = outline_pants1
                #bpy.ops.object.join()
                #bpy.ops.object.origin_set(type='ORIGIN_CENTER_OF_VOLUME')
                ob = bpy.context.selected_objects
                material_set = set()
                for object in bpy.context.selected_objects:
                    for material in object.material_slots:
                        material_set.add(material)
                for material in material_set:
                #    print(material.name)
                    Tex = material.name
                    #  print(Tex+'_MainTex.png')
                    TexMain = Tex+'_MainTex.png'
                    TexDetailM = Tex+'_DetailMask.png'
                    TexNormal = Tex+'_NormalMap.png'
                    TexLiquidM = Tex+'_liquidmask.png'
                    TexTex2 = Tex+'_Texture2.png'
                    TexTex3 = Tex+'_Texture3.png'
                    bpy.data.scenes['Scene'].sna_color05 = bpy.data.materials[Tex].node_tree.nodes['Principled BSDF'].inputs[0].default_value
                mat = bpy.data.materials[Tex]
                #Get the node in its node tree (replace the name below)
                node_to_delete =  mat.node_tree.nodes['Principled BSDF']
                node_to_delete2 =  mat.node_tree.nodes['Material Output']
                #Remove it
                mat.node_tree.nodes.remove( node_to_delete )
                mat.node_tree.nodes.remove( node_to_delete2 )
                imgpants = ( bpimg('cf_m_bot_skirt01_MainTex.png.001'), bpimg('rasengan'))
                for x in imgpants:
                    if x is not None:
                        bpy.data.images['cf_m_bot_skirt01_MainTex.png.001'].name = TexMain
                        bpy.data.images['cf_m_bot_skirt01_DetailMask.png.001'].name = TexDetailM
                        bpy.data.images['cf_m_bot_skirt01_NormalMap.png.001'].name = TexNormal
                        bpy.data.images['cf_m_bot_skirt01_liquidmask.png.001'].name = TexLiquidM
                        bpy.data.images['cf_m_bot_skirt01_Texture2.png.001'].name = TexTex2
                        bpy.data.images['cf_m_bot_skirt01_Texture3.png.001'].name = TexTex3
                        bpy.data.images[TexMain].filepath = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexMain
                        bpy.data.images[TexMain].filepath_raw = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexMain
                        bpy.data.images[TexDetailM].filepath = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexDetailM
                        bpy.data.images[TexDetailM].filepath_raw = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexDetailM
                        bpy.data.images[TexNormal].filepath = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexNormal
                        bpy.data.images[TexNormal].filepath_raw = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexNormal
                        bpy.data.images[TexLiquidM].filepath = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexLiquidM
                        bpy.data.images[TexLiquidM].filepath_raw = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexLiquidM
                        bpy.data.images[TexTex2].filepath = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexTex2
                        bpy.data.images[TexTex2].filepath_raw = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexTex2
                        bpy.data.images[TexTex3].filepath = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexTex3
                        bpy.data.images[TexTex3].filepath_raw = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexTex3
                C = bpy.context

                def instantiate_group(nodes, data_block_name):
                    group = nodes.new(type='ShaderNodeGroup')
                    group.node_tree = bpy.data.node_groups['KK-Template Pants.001']
                    return group
                instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
                bpy.context.object.active_material.blend_method = 'CLIP'
                bpy.context.object.active_material.shadow_method = 'CLIP'
                my_mat = bpy.data.materials.get(Tex)
                bpy.data.node_groups['KK-Template Pants.001'].name = 'KK-Template Bot '+Tex
                node = bpy.data.node_groups['KK-Template Bot '+Tex]
                #node.extension = 'CLIP'
                #node.image = bpy.data.images[bakefinal.name]
                nodes = my_mat.node_tree.nodes
                for node in nodes:
                    node.select = False
                    node.select = True
                    nodes.active = node
                try:
                    initial_area_type = bpy.context.area.type
                    bpy.context.area.type = 'NODE_EDITOR'
                    bpy.context.area.ui_type = 'ShaderNodeTree'
                    bpy.ops.wm.redraw_timer(type='DRAW_WIN', iterations=1)
                    bpy.ops.node.group_ungroup()
                    bpy.ops.node.group_edit(exit=True)
                except Exception as e:
                    print(e)
                finally:
                    bpy.context.area.type = initial_area_type
                break
        bpy.ops.object.select_all(action='DESELECT') # Deselecciona todo en la escena
        ###################################SHOES#####################################
        bpy.ops.object.select_all(action='DESELECT') # Deselecciona todo en la escena
        # Get shoes object
        shoeses = ( w(shoes1), w(shoes2), w(shoes3), w(shoes4), w(shoes5), w(shoes6), w(shoes7), w(shoes8), w(shoes9), w(shoes10), w(shoes11), w(shoes12), w(shoes13), w(shoes14), w(shoes15), w(shoes16), w(shoes17), w(shoes18), w(shoes19), w(shoes20), w(shoes21), w(shoes22), w(shoes23), w(shoes24), w(shoes25), w(shoes26), w(shoes27), w(shoes28), w(shoes29), w(shoes30), w(shoes31), w(shoes32), w(shoes33), w(shoes34), w(shoes35), w(shoes36), w(shoes37), w(shoes38), w(shoes39), w(shoes40), w(shoes41))
        for x in shoeses:
            if x is not None:
                #if bpy.data.objects.get(body1) is not None:
                op = (x.name)
                bpy.data.objects.get(op).select_set(True)
                outline_shoes = bpy.data.objects.get(op)
                bpy.context.view_layer.objects.active = outline_shoes
                ob = bpy.context.selected_objects
                material_set = set()
                for object in bpy.context.selected_objects:
                    for material in object.material_slots:
                        material_set.add(material)
                for material in material_set:
                #    print(material.name)
                    Tex = material.name
                    #  print(Tex+'_MainTex.png')
                    TexMain = Tex+'_MainTex.png'
                    TexDetailM = Tex+'_DetailMask.png'
                    TexNormal = Tex+'_NormalMap.png'
                    bpy.data.scenes['Scene'].sna_color06 = bpy.data.materials[Tex].node_tree.nodes['Principled BSDF'].inputs[0].default_value
                mat = bpy.data.materials[Tex]
                #Get the node in its node tree (replace the name below)
                node_to_delete =  mat.node_tree.nodes['Principled BSDF']
                node_to_delete2 =  mat.node_tree.nodes['Material Output']
                #Remove it
                mat.node_tree.nodes.remove( node_to_delete )
                mat.node_tree.nodes.remove( node_to_delete2 )
                imgshoes = ( bpimg('cf_m_shoes_roafer01_MainTex.png'), bpimg('byakugan'))
                for x in imgshoes:
                    if x is not None:
                        bpy.data.images['cf_m_shoes_roafer01_MainTex.png'].name = TexMain 
                        bpy.data.images['cf_m_shoes_roafer01_DetailMask.png'].name = TexDetailM
                        bpy.data.images['cf_m_shoes_roafer01_NormalMap.png'].name = TexNormal
                        bpy.data.images[TexMain].filepath = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexMain
                        bpy.data.images[TexMain].filepath_raw = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexMain
                        bpy.data.images[TexDetailM].filepath = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexDetailM
                        bpy.data.images[TexDetailM].filepath_raw = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexDetailM
                        bpy.data.images[TexNormal].filepath = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexNormal
                        bpy.data.images[TexNormal].filepath_raw = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexNormal
                C = bpy.context

                def instantiate_group(nodes, data_block_name):
                    group = nodes.new(type='ShaderNodeGroup')
                    group.node_tree = bpy.data.node_groups['KK-Template Shoes']
                    return group
                instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
                my_mat = bpy.data.materials.get(Tex)
                bpy.data.node_groups['KK-Template Shoes'].name = 'KK-Template Shoes '+Tex
                node = bpy.data.node_groups['KK-Template Shoes '+Tex]
                #node.extension = 'CLIP'
                #node.image = bpy.data.images[bakefinal.name]
                nodes = my_mat.node_tree.nodes
                for node in nodes:
                    node.select = False
                    node.select = True
                    nodes.active = node
                try:
                    initial_area_type = bpy.context.area.type
                    bpy.context.area.type = 'NODE_EDITOR'
                    bpy.context.area.ui_type = 'ShaderNodeTree'
                    bpy.ops.wm.redraw_timer(type='DRAW_WIN', iterations=1)
                    bpy.ops.node.group_ungroup()
                    bpy.ops.node.group_edit(exit=True)
                except Exception as e:
                    print(e)
                finally:
                    bpy.context.area.type = initial_area_type
                break
        bpy.ops.object.select_all(action='DESELECT') # Deselecciona todo en la escena
        ###################################SOCKS#####################################
        bpy.ops.object.select_all(action='DESELECT') # Deselecciona todo en la escena
        # Get shoes object
        sockys = ( w(socks1), w(socks2), w(socks3), w(socks4), w(socks5), w(socks6), w(socks7), w(socks8), w(socks9), w(socks10), w(socks11), w(socks12), w(socks13), w(socks14), w(socks15), w(socks16), w(socks17))
        for x in sockys:
            if x is not None:
                #if bpy.data.objects.get(body1) is not None:
                op = (x.name)
                bpy.data.objects.get(op).select_set(True)
                outline_socks = bpy.data.objects.get(op)
                bpy.context.view_layer.objects.active = outline_socks
                ob = bpy.context.selected_objects
                material_set = set()
                for object in bpy.context.selected_objects:
                    for material in object.material_slots:
                        material_set.add(material)
                for material in material_set:
                #    print(material.name)
                    Tex = material.name
                #  print(Tex+'_MainTex.png')
                    TexMain = Tex+'_MainTex.png'
                    TexDetailM = Tex+'_DetailMask.png'
                    TexNormal = Tex+'_NormalMap.png'
                    TexLineM = Tex+'_LineMask.png'
                    bpy.data.scenes['Scene'].sna_color09 = bpy.data.materials[Tex].node_tree.nodes['Principled BSDF'].inputs[0].default_value
                    bpy.data.node_groups['KK-Template Socks'].nodes['SocksColor'].outputs[0].default_value = bpy.data.scenes['Scene'].sna_color09
                mat = bpy.data.materials[Tex]
                #Get the node in its node tree (replace the name below)
                node_to_delete =  mat.node_tree.nodes['Principled BSDF']
                node_to_delete2 =  mat.node_tree.nodes['Material Output']
                #Remove it
                mat.node_tree.nodes.remove( node_to_delete )
                mat.node_tree.nodes.remove( node_to_delete2 )
                imgsocks = ( bpimg('cf_m_socks_high01_MainTex.png'), bpimg('amaterasu'))
                for x in imgsocks:
                    if x is not None:
                        bpy.data.images['cf_m_socks_high01_MainTex.png'].name = TexMain
                        bpy.data.images['cf_m_socks_high01_DetailMask.png'].name = TexDetailM
                        bpy.data.images['cf_m_socks_high01_NormalMap.png'].name = TexNormal
                        bpy.data.images['cf_m_socks_high01_LineMask.png'].name = TexLineM
                        bpy.data.images[TexMain].filepath = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexMain
                        bpy.data.images[TexMain].filepath_raw = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexMain
                        bpy.data.images[TexDetailM].filepath = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexDetailM
                        bpy.data.images[TexDetailM].filepath_raw = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexDetailM
                        bpy.data.images[TexNormal].filepath = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexNormal
                        bpy.data.images[TexNormal].filepath_raw = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexNormal
                        bpy.data.images[TexLineM].filepath = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexLineM
                        bpy.data.images[TexLineM].filepath_raw = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexLineM
                C = bpy.context

                def instantiate_group(nodes, data_block_name):
                    group = nodes.new(type='ShaderNodeGroup')
                    group.node_tree = bpy.data.node_groups['KK-Template Socks']
                    return group
                instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
                bpy.context.object.active_material.blend_method = 'CLIP'
                bpy.context.object.active_material.shadow_method = 'CLIP'
                my_mat = bpy.data.materials.get(Tex)
                bpy.data.node_groups['KK-Template Socks'].name = 'KK-Template Socks '+Tex
                node = bpy.data.node_groups['KK-Template Socks '+Tex]
                #node.extension = 'CLIP'
                #node.image = bpy.data.images[bakefinal.name]
                nodes = my_mat.node_tree.nodes
                for node in nodes:
                    node.select = False
                    node.select = True
                    nodes.active = node
                try:
                    initial_area_type = bpy.context.area.type
                    bpy.context.area.type = 'NODE_EDITOR'
                    bpy.context.area.ui_type = 'ShaderNodeTree'
                    bpy.ops.wm.redraw_timer(type='DRAW_WIN', iterations=1)
                    bpy.ops.node.group_ungroup()
                    bpy.ops.node.group_edit(exit=True)
                except Exception as e:
                    print(e)
                finally:
                    bpy.context.area.type = initial_area_type
                break
        bpy.ops.object.select_all(action='DESELECT') # Deselecciona todo en la escena
        ####################################BRA######################################
        bpy.ops.object.select_all(action='DESELECT') # Deselecciona todo en la escena
        # Get body object
        brasiers = ( w(bra1), w(bra2), w(bra3), w(bra4), w(bra5), w(bra6), w(bra7), w(bra8), w(bra9), w(bra10), w(bra11), w(bra12), w(bra13), w(bra14), w(bra15), w(bra16), w(bra17))
        for x in brasiers:
            if x is not None:
                #if bpy.data.objects.get(body1) is not None:
                op = (x.name)
                bpy.data.objects.get(op).select_set(True)
                outline_bra = bpy.data.objects.get(op)
                bpy.context.view_layer.objects.active = outline_bra
                ob = bpy.context.selected_objects
                material_set = set()
                for object in bpy.context.selected_objects:
                    for material in object.material_slots:
                        material_set.add(material)
                for material in material_set:
                #    print(material.name)
                    Tex = material.name
                    #  print(Tex+'_MainTex.png')
                    TexMain = Tex+'_MainTex.png'
                    TexDetailM = Tex+'_DetailMask.png'
                    TexNormal = Tex+'_NormalMap.png'
                    TexAlphaM = Tex+'_AlphaMask.png'
                    TexLiquidM = Tex+'_liquidmask.png'
                    TexTex2 = Tex+'_Texture2.png'
                    TexTex3 = Tex+'_Texture3.png'
                    bpy.data.scenes['Scene'].sna_color07 = bpy.data.materials[Tex].node_tree.nodes['Principled BSDF'].inputs[0].default_value
                mat = bpy.data.materials[Tex]
                #Get the node in its node tree (replace the name below)
                node_to_delete =  mat.node_tree.nodes['Principled BSDF']
                node_to_delete2 =  mat.node_tree.nodes['Material Output']
                #Remove it
                mat.node_tree.nodes.remove( node_to_delete )
                mat.node_tree.nodes.remove( node_to_delete2 )
                imgbra = ( bpimg('cf_m_bra_01_MainTex.png'), bpimg('rinnegan'))
                for x in imgbra:
                    if x is not None:
                        bpy.data.images['cf_m_bra_01_MainTex.png'].name = TexMain 
                        bpy.data.images['cf_m_bra_01_DetailMask.png'].name = TexDetailM
                        bpy.data.images['cf_m_bra_01_NormalMap.png'].name = TexNormal
                        bpy.data.images['cf_m_bra_01_AlphaMask.png'].name = TexAlphaM
                        bpy.data.images['cf_m_bra_01_liquidmask.png'].name = TexLiquidM
                        bpy.data.images['cf_m_bra_01_Texture2.png'].name = TexTex2
                        bpy.data.images['cf_m_bra_01_Texture3.png'].name = TexTex3
                        bpy.data.images[TexMain].filepath = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexMain
                        bpy.data.images[TexMain].filepath_raw = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexMain
                        bpy.data.images[TexDetailM].filepath = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexDetailM
                        bpy.data.images[TexDetailM].filepath_raw = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexDetailM
                        bpy.data.images[TexNormal].filepath = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexNormal
                        bpy.data.images[TexNormal].filepath_raw = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexNormal
                        bpy.data.images[TexAlphaM].filepath = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexAlphaM
                        bpy.data.images[TexAlphaM].filepath_raw = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexAlphaM
                        bpy.data.images[TexLiquidM].filepath = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexLiquidM
                        bpy.data.images[TexLiquidM].filepath_raw = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexLiquidM
                        bpy.data.images[TexTex2].filepath = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexTex2
                        bpy.data.images[TexTex2].filepath_raw = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexTex2
                        bpy.data.images[TexTex3].filepath = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexTex3
                        bpy.data.images[TexTex3].filepath_raw = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexTex3
                C = bpy.context

                def instantiate_group(nodes, data_block_name):
                    group = nodes.new(type='ShaderNodeGroup')
                    group.node_tree = bpy.data.node_groups['KK-Template Bra']
                    return group
                instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
                bpy.context.object.active_material.blend_method = 'CLIP'
                bpy.context.object.active_material.shadow_method = 'CLIP'
                my_mat = bpy.data.materials.get(Tex)
                bpy.data.node_groups['KK-Template Bra'].name = 'KK-Template Bra '+Tex
                node = bpy.data.node_groups['KK-Template Bra '+Tex]
                #node.extension = 'CLIP'
                #node.image = bpy.data.images[bakefinal.name]
                nodes = my_mat.node_tree.nodes
                for node in nodes:
                    node.select = False
                    node.select = True
                    nodes.active = node
                try:
                    initial_area_type = bpy.context.area.type
                    bpy.context.area.type = 'NODE_EDITOR'
                    bpy.context.area.ui_type = 'ShaderNodeTree'
                    bpy.ops.wm.redraw_timer(type='DRAW_WIN', iterations=1)
                    bpy.ops.node.group_ungroup()
                    bpy.ops.node.group_edit(exit=True)
                except Exception as e:
                    print(e)
                finally:
                    bpy.context.area.type = initial_area_type
                break
        bpy.ops.object.select_all(action='DESELECT') # Deselecciona todo en la escena
        ##################################PANTIES####################################
        bpy.ops.object.select_all(action='DESELECT') # Deselecciona todo en la escena
        # Get short object
        shortys = ( w(short1), w(short2), w(short3), w(short4), w(short5), w(short6), w(short7), w(short8), w(short9), w(short10), w(short11), w(short12), w(short13), w(short14), w(short15), w(short16), w(short17), w(short18), w(short19), w(short20), w(short21), w(short22), w(short23), w(short24))
        for x in shortys:
            if x is not None:
                #if bpy.data.objects.get(body1) is not None:
                op = (x.name)
                bpy.data.objects.get(op).select_set(True)
                outline_short = bpy.data.objects.get(op)
                bpy.context.view_layer.objects.active = outline_short
                ob = bpy.context.selected_objects
                material_set = set()
                for object in bpy.context.selected_objects:
                    for material in object.material_slots:
                        material_set.add(material)
                for material in material_set:
                #    print(material.name)
                    Tex = material.name
                    #  print(Tex+'_MainTex.png')
                    TexMain = Tex+'_MainTex.png'
                    TexDetailM = Tex+'_DetailMask.png'
                    TexNormal = Tex+'_NormalMap.png'
                    TexLiquidM = Tex+'_liquidmask.png'
                    TexTex2 = Tex+'_Texture2.png'
                    TexTex3 = Tex+'_Texture3.png'
                    bpy.data.scenes['Scene'].sna_color08 = bpy.data.materials[Tex].node_tree.nodes['Principled BSDF'].inputs[0].default_value
                mat = bpy.data.materials[Tex]
                #Get the node in its node tree (replace the name below)
                node_to_delete =  mat.node_tree.nodes['Principled BSDF']
                node_to_delete2 =  mat.node_tree.nodes['Material Output']
                #Remove it
                mat.node_tree.nodes.remove( node_to_delete )
                mat.node_tree.nodes.remove( node_to_delete2 )
                imgshort = ( bpimg('cf_m_shorts_01_MainTex.png'), bpimg('tenseigan'))
                for x in imgshort:
                    if x is not None:
                        bpy.data.images['cf_m_shorts_01_MainTex.png'].name = TexMain 
                        bpy.data.images['cf_m_shorts_01_DetailMask.png'].name = TexDetailM
                        bpy.data.images['cf_m_shorts_01_NormalMap.png'].name = TexNormal
                        bpy.data.images['cf_m_shorts_01_liquidmask.png'].name = TexLiquidM
                        bpy.data.images['cf_m_shorts_01_Texture2.png'].name = TexTex2
                        bpy.data.images['cf_m_shorts_01_Texture3.png'].name = TexTex3
                        bpy.data.images[TexMain].filepath = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexMain
                        bpy.data.images[TexMain].filepath_raw = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexMain
                        bpy.data.images[TexDetailM].filepath = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexDetailM
                        bpy.data.images[TexDetailM].filepath_raw = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexDetailM
                        bpy.data.images[TexNormal].filepath = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexNormal
                        bpy.data.images[TexNormal].filepath_raw = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexNormal
                        bpy.data.images[TexLiquidM].filepath = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexLiquidM
                        bpy.data.images[TexLiquidM].filepath_raw = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexLiquidM
                        bpy.data.images[TexTex2].filepath = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexTex2
                        bpy.data.images[TexTex2].filepath_raw = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexTex2
                        bpy.data.images[TexTex3].filepath = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexTex3
                        bpy.data.images[TexTex3].filepath_raw = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexTex3
                C = bpy.context

                def instantiate_group(nodes, data_block_name):
                    group = nodes.new(type='ShaderNodeGroup')
                    group.node_tree = bpy.data.node_groups['KK-Template Panties']
                    return group
                instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
                bpy.context.object.active_material.blend_method = 'HASHED'
                bpy.context.object.active_material.shadow_method = 'HASHED'
                my_mat = bpy.data.materials.get(Tex)
                bpy.data.node_groups['KK-Template Panties'].name = 'KK-Template Panties '+Tex
                node = bpy.data.node_groups['KK-Template Panties '+Tex]
                #node.extension = 'CLIP'
                #node.image = bpy.data.images[bakefinal.name]
                nodes = my_mat.node_tree.nodes
                for node in nodes:
                    node.select = False
                    node.select = True
                    nodes.active = node
                try:
                    initial_area_type = bpy.context.area.type
                    bpy.context.area.type = 'NODE_EDITOR'
                    bpy.context.area.ui_type = 'ShaderNodeTree'
                    bpy.ops.wm.redraw_timer(type='DRAW_WIN', iterations=1)
                    bpy.ops.node.group_ungroup()
                    bpy.ops.node.group_edit(exit=True)
                except Exception as e:
                    print(e)
                finally:
                    bpy.context.area.type = initial_area_type
                break
        bpy.ops.object.select_all(action='DESELECT') # Deselecciona todo en la escena
        ##################################BACKEYE A####################################
        bpy.ops.object.select_all(action='DESELECT') # Deselecciona todo en la escena
        # Get short object
        backeyes = (w(beye1),w(beye2),w(beye3),w(beye4),w(beye5))
        for x in backeyes:
            if x is not None:
                #if bpy.data.objects.get(body1) is not None:
                op = (x.name)
                bpy.data.objects.get(op).select_set(True)
                outline_beyea = bpy.data.objects.get(op)
                bpy.context.view_layer.objects.active = outline_beyea
                ob = bpy.context.selected_objects
                material_set = set()
                for object in bpy.context.selected_objects:
                    for material in object.material_slots:
                        material_set.add(material)
                for material in material_set:
                #    print(material.name)
                    Tex = material.name
                    #  print(Tex+'_MainTex.png')
                    #    TexMain = Tex+'_MainTex.png'
                mat = bpy.data.materials[Tex]
                #Get the node in its node tree (replace the name below)
                node_to_delete =  mat.node_tree.nodes['Principled BSDF']
                node_to_delete2 =  mat.node_tree.nodes['Material Output']
                #Remove it
                mat.node_tree.nodes.remove( node_to_delete )
                mat.node_tree.nodes.remove( node_to_delete2 )
                #bpy.data.images['cf_m_sirome_00_MainTex.png'].name = TexMain 
                C = bpy.context

                def instantiate_group(nodes, data_block_name):
                    group = nodes.new(type='ShaderNodeGroup')
                    group.node_tree = bpy.data.node_groups['KK-Template BackEye']
                    return group
                instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
                bpy.context.object.active_material.blend_method = 'CLIP'
                bpy.context.object.active_material.shadow_method = 'CLIP'
                my_mat = bpy.data.materials.get(Tex)
                node = bpy.data.node_groups['KK-Template BackEye']
                #node.extension = 'CLIP'
                #node.image = bpy.data.images[bakefinal.name]
                nodes = my_mat.node_tree.nodes
                for node in nodes:
                    node.select = False
                    node.select = True
                    nodes.active = node
                try:
                    initial_area_type = bpy.context.area.type
                    bpy.context.area.type = 'NODE_EDITOR'
                    bpy.context.area.ui_type = 'ShaderNodeTree'
                    bpy.ops.wm.redraw_timer(type='DRAW_WIN', iterations=1)
                    bpy.ops.node.group_ungroup()
                    bpy.ops.node.group_edit(exit=True)
                except Exception as e:
                    print(e)
                finally:
                    bpy.context.area.type = initial_area_type
                break
        bpy.ops.object.select_all(action='DESELECT') # Deselecciona todo en la escena
        ##################################BACKEYE B####################################
        bpy.ops.object.select_all(action='DESELECT') # Deselecciona todo en la escena
        # Get short object
        backeyesb = (w(beyeb1),w(beyeb2),w(beyeb3),w(beyeb4),w(beyeb5))
        for x in backeyesb:
            if x is not None:
                #if bpy.data.objects.get(body1) is not None:
                op = (x.name)
                bpy.data.objects.get(op).select_set(True)
                outline_beyebout = bpy.data.objects.get(op)
                bpy.context.view_layer.objects.active = outline_beyebout
                ob = bpy.context.selected_objects
                material_set = set()
                for object in bpy.context.selected_objects:
                    for material in object.material_slots:
                        material_set.add(material)
                for material in material_set:
                #    print(material.name)
                    Tex = material.name
                    #  print(Tex+'_MainTex.png')
                    TexMain = Tex+'_MainTex.png'
                bpy.data.images['cf_m_sirome_00_MainTex.png'].name = TexMain 
                C = bpy.context

                def instantiate_group(nodes, data_block_name):
                    group = nodes.new(type='ShaderNodeGroup')
                    group.node_tree = bpy.data.node_groups['KK-Template BackEye']
                    return group
                instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
                bpy.context.object.active_material.blend_method = 'CLIP'
                bpy.context.object.active_material.shadow_method = 'CLIP'
                my_mat = bpy.data.materials.get(Tex)
                node = bpy.data.node_groups['KK-Template BackEye']
                #node.extension = 'CLIP'
                #node.image = bpy.data.images[bakefinal.name]
                nodes = my_mat.node_tree.nodes
                for node in nodes:
                    node.select = False
                    node.select = True
                    nodes.active = node
                try:
                    initial_area_type = bpy.context.area.type
                    bpy.context.area.type = 'NODE_EDITOR'
                    bpy.context.area.ui_type = 'ShaderNodeTree'
                    bpy.ops.wm.redraw_timer(type='DRAW_WIN', iterations=1)
                    bpy.ops.node.group_ungroup()
                    bpy.ops.node.group_edit(exit=True)
                except Exception as e:
                    print(e)
                finally:
                    bpy.context.area.type = initial_area_type
                break
        bpy.ops.object.select_all(action='DESELECT') # Deselecciona todo en la escena
        ###################################EYE A#####################################
        bpy.ops.object.select_all(action='DESELECT') # Deselecciona todo en la escena
        # Get eye object
        eyeses = (w(eye1),w(eye2),w(eye3),w(eye4),w(eye5))
        for x in eyeses:
            if x is not None:
                #if bpy.data.objects.get(body1) is not None:
                op = (x.name)
                bpy.data.objects.get(op).select_set(True)
                outline_eye = bpy.data.objects.get(op)
                bpy.context.view_layer.objects.active = outline_eye
                ob = bpy.context.selected_objects
                material_set = set()
                for object in bpy.context.selected_objects:
                    for material in object.material_slots:
                        material_set.add(material)
                for material in material_set:
                #    print(material.name)
                    Tex = material.name
                    #  print(Tex+'_MainTex.png')
                    TexMain = Tex+'_MainTex.png'
                    TexOver1 = Tex+'_overtex1.png'
                    TexOver2 = Tex+'_overtex2.png'
                mat = bpy.data.materials[Tex]
                #Get the node in its node tree (replace the name below)
                node_to_delete =  mat.node_tree.nodes['Principled BSDF']
                node_to_delete2 =  mat.node_tree.nodes['Material Output']
                #Remove it
                mat.node_tree.nodes.remove( node_to_delete )
                mat.node_tree.nodes.remove( node_to_delete2 )
                #bpy.data.images['cf_m_hitomi_00_MainTex.png'].name = TexMain 
                #bpy.data.images['cf_m_hitomi_00_overtex1.png'].name = TexOver1
                #bpy.data.images['cf_m_hitomi_00_overtex2.png'].name = TexOver2
                C = bpy.context

                def instantiate_group(nodes, data_block_name):
                    group = nodes.new(type='ShaderNodeGroup')
                    group.node_tree = bpy.data.node_groups['KK-Template Eye']
                    return group
                instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
                bpy.context.object.active_material.blend_method = 'CLIP'
                bpy.context.object.active_material.shadow_method = 'CLIP'
        bpy.ops.object.select_all(action='DESELECT') # Deselecciona todo en la escena
        ###################################EYE B#####################################
        bpy.ops.object.select_all(action='DESELECT') # Deselecciona todo en la escena
        # Get eye object
        eyesesb = (w(eyeb1),w(eyeb2),w(eyeb3),w(eyeb4),w(eyeb5))
        for x in eyesesb:
            if x is not None:
                #if bpy.data.objects.get(body1) is not None:
                op = (x.name)
                bpy.data.objects.get(op).select_set(True)
                outline_eyeb = bpy.data.objects.get(op)
                bpy.context.view_layer.objects.active = outline_eyeb
                ob = bpy.context.selected_objects
                material_set = set()
                for object in bpy.context.selected_objects:
                    for material in object.material_slots:
                        material_set.add(material)
                for material in material_set:
                #    print(material.name)
                    Tex = material.name
                #  print(Tex+'_MainTex.png')
                    TexMain = Tex+'_MainTex.png'
                    TexOver1 = Tex+'_overtex1.png'
                    TexOver2 = Tex+'_overtex2.png'
                mat = bpy.data.materials[Tex]
                #Get the node in its node tree (replace the name below)
                node_to_delete =  mat.node_tree.nodes['Principled BSDF']
                node_to_delete2 =  mat.node_tree.nodes['Material Output']
                #Remove it
                mat.node_tree.nodes.remove( node_to_delete )
                mat.node_tree.nodes.remove( node_to_delete2 )
                bpy.data.images['cf_m_hitomi_00_MainTex.png'].name = TexMain 
                bpy.data.images['cf_m_hitomi_00_overtex1.png'].name = TexOver1
                bpy.data.images['cf_m_hitomi_00_overtex2.png'].name = TexOver2
                C = bpy.context

                def instantiate_group(nodes, data_block_name):
                    group = nodes.new(type='ShaderNodeGroup')
                    group.node_tree = bpy.data.node_groups['KK-Template Eye']
                    return group
                instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
                bpy.context.object.active_material.blend_method = 'CLIP'
                bpy.context.object.active_material.shadow_method = 'CLIP'
        bpy.ops.object.select_all(action='DESELECT') # Deselecciona todo en la escena
        ##################################EYELINE####################################
        bpy.ops.object.select_all(action='DESELECT') # Deselecciona todo en la escena
        # Get eyeline object
        elineses = (w(eline1),w(eline2),w(eline3),w(eline4),w(eline5))
        for x in elineses:
            if x is not None:
                #if bpy.data.objects.get(body1) is not None:
                op = (x.name)
                bpy.data.objects.get(op).select_set(True)
                outline_eline = bpy.data.objects.get(op)
                bpy.context.view_layer.objects.active = outline_eline
                ob = bpy.context.selected_objects
                material_set = set()
                for object in bpy.context.selected_objects:
                    for material in object.material_slots:
                        material_set.add(material)
                for material in material_set:
                    print(material.name)
                    Tex = material.name
                mat = bpy.data.materials[Tex]
                #Get the node in its node tree (replace the name below)
                node_to_delete =  mat.node_tree.nodes['Principled BSDF']
                node_to_delete2 =  mat.node_tree.nodes['Material Output']
                #Remove it
                mat.node_tree.nodes.remove( node_to_delete )
                mat.node_tree.nodes.remove( node_to_delete2 )
                #  print(Tex+'_MainTex.png')
                #    TexUp = 'cf_m_eyeline_00_up_MainTex.png'
                #    TexDown = 'cf_m_eyeline_down_MainTex.png'
                #    TexKage = 'cf_m_eyeline_kage_MainTex.png'
                #bpy.data.images['cf_m_eyeline_00_up_MainTex.png'].name = TexUp
                #bpy.data.images['cf_m_eyeline_down_MainTex.png'].name = TexDown
                #bpy.data.images['cf_m_eyeline_kage_MainTex.png'].name = TexKage
                C = bpy.context

                def instantiate_group(nodes, data_block_name):
                    group = nodes.new(type='ShaderNodeGroup')
                    group.node_tree = bpy.data.node_groups['KK-Template Eyeline']
                    return group
                instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
                bpy.context.object.active_material.blend_method = 'CLIP'
                bpy.context.object.active_material.shadow_method = 'CLIP'
                my_mat = bpy.data.materials.get(Tex)
                node = bpy.data.node_groups['KK-Template Eyeline']
                #node.extension = 'CLIP'
                #node.image = bpy.data.images[bakefinal.name]
                nodes = my_mat.node_tree.nodes
                for node in nodes:
                    node.select = False
                    node.select = True
                    nodes.active = node
                try:
                    initial_area_type = bpy.context.area.type
                    bpy.context.area.type = 'NODE_EDITOR'
                    bpy.context.area.ui_type = 'ShaderNodeTree'
                    bpy.ops.wm.redraw_timer(type='DRAW_WIN', iterations=1)
                    bpy.ops.node.group_ungroup()
                    bpy.ops.node.group_edit(exit=True)
                except Exception as e:
                    print(e)
                finally:
                    bpy.context.area.type = initial_area_type
                break
        bpy.ops.object.select_all(action='DESELECT') # Deselecciona todo en la escena
        #################################NOSELINE####################################
        bpy.ops.object.select_all(action='DESELECT') # Deselecciona todo en la escena
        # Get short object
        noseses = (w(nose1),w(nose2),w(nose3),w(nose4),w(nose5))
        for x in noseses:
            if x is not None:
                #if bpy.data.objects.get(nose1) is not None:
                op = (x.name)
                bpy.data.objects.get(op).select_set(True)
                outline_nose = bpy.data.objects.get(op)
                bpy.context.view_layer.objects.active = outline_nose
                ob = bpy.context.selected_objects
                material_set = set()
                for object in bpy.context.selected_objects:
                    for material in object.material_slots:
                        material_set.add(material)
                for material in material_set:
                #    print(material.name)
                    Tex = material.name
                    #  print(Tex+'_MainTex.png')
                    TexMain = Tex+'_MainTex.png'
                mat = bpy.data.materials[Tex]
                #Get the node in its node tree (replace the name below)
                node_to_delete =  mat.node_tree.nodes['Principled BSDF']
                node_to_delete2 =  mat.node_tree.nodes['Material Output']
                #Remove it
                mat.node_tree.nodes.remove( node_to_delete )
                mat.node_tree.nodes.remove( node_to_delete2 )
                bpy.data.images['cf_m_noseline_00_MainTex.png'].name = TexMain 
                C = bpy.context

                def instantiate_group(nodes, data_block_name):
                    group = nodes.new(type='ShaderNodeGroup')
                    group.node_tree = bpy.data.node_groups['KK-Template Noseline']
                    return group
                instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
                bpy.context.object.active_material.blend_method = 'CLIP'
                bpy.context.object.active_material.shadow_method = 'CLIP'
                my_mat = bpy.data.materials.get(Tex)
                node = bpy.data.node_groups['KK-Template Noseline']
                #node.extension = 'CLIP'
                #node.image = bpy.data.images[bakefinal.name]
                nodes = my_mat.node_tree.nodes
                for node in nodes:
                    node.select = False
                    node.select = True
                    nodes.active = node
                try:
                    initial_area_type = bpy.context.area.type
                    bpy.context.area.type = 'NODE_EDITOR'
                    bpy.context.area.ui_type = 'ShaderNodeTree'
                    bpy.ops.wm.redraw_timer(type='DRAW_WIN', iterations=1)
                    bpy.ops.node.group_ungroup()
                    bpy.ops.node.group_edit(exit=True)
                except Exception as e:
                    print(e)
                finally:
                    bpy.context.area.type = initial_area_type
                break
        bpy.ops.object.select_all(action='DESELECT') # Deselecciona todo en la escena
        ##################################MAYUGE#####################################
        bpy.ops.object.select_all(action='DESELECT') # Deselecciona todo en la escena
        # Get mayu object
        mayugeses = (w(mayu1),w(mayu2),w(mayu3),w(mayu4),w(mayu5))
        for x in mayugeses:
            if x is not None:
                #if bpy.data.objects.get(mayu1) is not None:
                op = (x.name)
                bpy.data.objects.get(op).select_set(True)
                outline_mayu = bpy.data.objects.get(op)
                bpy.context.view_layer.objects.active = outline_mayu
                ob = bpy.context.selected_objects
                material_set = set()
                for object in bpy.context.selected_objects:
                    for material in object.material_slots:
                        material_set.add(material)
                for material in material_set:
                #    print(material.name)
                    Tex = material.name
                    #  print(Tex+'_MainTex.png')
                    TexMain = Tex+'_MainTex.png'
                mat = bpy.data.materials[Tex]
                #Get the node in its node tree (replace the name below)
                node_to_delete =  mat.node_tree.nodes['Principled BSDF']
                node_to_delete2 =  mat.node_tree.nodes['Material Output']
                #Remove it
                mat.node_tree.nodes.remove( node_to_delete )
                mat.node_tree.nodes.remove( node_to_delete2 )
                bpy.data.images['cf_m_mayuge_00_MainTex.png'].name = TexMain 
                C = bpy.context

                def instantiate_group(nodes, data_block_name):
                    group = nodes.new(type='ShaderNodeGroup')
                    group.node_tree = bpy.data.node_groups['KK-Template Mayuge']
                    return group
                instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
                bpy.context.object.active_material.blend_method = 'CLIP'
                bpy.context.object.active_material.shadow_method = 'CLIP'
                my_mat = bpy.data.materials.get(Tex)
                node = bpy.data.node_groups['KK-Template Mayuge']
                #node.extension = 'CLIP'
                #node.image = bpy.data.images[bakefinal.name]
                nodes = my_mat.node_tree.nodes
                for node in nodes:
                    node.select = False
                    node.select = True
                    nodes.active = node
                try:
                    initial_area_type = bpy.context.area.type
                    bpy.context.area.type = 'NODE_EDITOR'
                    bpy.context.area.ui_type = 'ShaderNodeTree'
                    bpy.ops.wm.redraw_timer(type='DRAW_WIN', iterations=1)
                    bpy.ops.node.group_ungroup()
                    bpy.ops.node.group_edit(exit=True)
                except Exception as e:
                    print(e)
                finally:
                    bpy.context.area.type = initial_area_type
                break
        bpy.ops.object.select_all(action='DESELECT') # Deselecciona todo en la escena
        ################################Tooth###################################
        bpy.ops.object.select_all(action='DESELECT') # Deselecciona todo en la escena
        # Get tooth object
        tootheses = (w(tooth1),w(tooth2),w(tooth3),w(tooth4),w(tooth5))
        for x in tootheses:
            if x is not None:
                #if bpy.data.objects.get(mayu1) is not None:
                op = (x.name)
                bpy.data.objects.get(op).select_set(True)
                outline_tooth = bpy.data.objects.get(op)
                bpy.context.view_layer.objects.active = outline_tooth
                ob = bpy.context.selected_objects
                material_set = set()
                for object in bpy.context.selected_objects:
                    for material in object.material_slots:
                        material_set.add(material)
                for material in material_set:
                #    print(material.name)
                    Tex = material.name
                    #  print(Tex+'_MainTex.png')
                    TexMain = Tex+'_MainTex.png'
                    TexDetailM = Tex+'_DetailMask.png'
                    TexColorM = Tex+'_ColorMask.png'
                mat = bpy.data.materials[Tex]
                #Get the node in its node tree (replace the name below)
                node_to_delete =  mat.node_tree.nodes['Principled BSDF']
                node_to_delete2 =  mat.node_tree.nodes['Material Output']
                #Remove it
                mat.node_tree.nodes.remove( node_to_delete )
                mat.node_tree.nodes.remove( node_to_delete2 )
                bpy.data.images['cf_m_tooth_MainTex.png'].name = TexMain 
                bpy.data.images['cf_m_tooth_DetailMask.png'].name = TexDetailM
                bpy.data.images['cf_m_tooth_ColorMask.png'].name = TexColorM
                C = bpy.context

                def instantiate_group(nodes, data_block_name):
                    group = nodes.new(type='ShaderNodeGroup')
                    group.node_tree = bpy.data.node_groups['KK-Template Tooth']
                    return group
                instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
        bpy.ops.object.select_all(action='DESELECT') # Deselecciona todo en la escena
        ###################################TONGUE####################################
        tongeses = (w(tong1),w(tong2),w(tong3),w(tong4),w(tong5))
        for x in tongeses:
            if x is not None:
                #if bpy.data.objects.get(mayu1) is not None:
                op = (x.name)
                bpy.data.objects.get(op).select_set(True)
                outline_tong = bpy.data.objects.get(op)
                bpy.context.view_layer.objects.active = outline_tong
                ob = bpy.context.selected_objects
                material_set = set()
                for object in bpy.context.selected_objects:
                    for material in object.material_slots:
                        material_set.add(material)
                for material in material_set:
                #    print(material.name)
                    Tex = material.name
                    #  print(Tex+'_MainTex.png')
                    TexNormal = Tex+'_NormalMap.png'
                    TexDetailM = Tex+'_DetailMask.png'
                    TexColorM = Tex+'_ColorMask.png'
                mat = bpy.data.materials[Tex]
                #Get the node in its node tree (replace the name below)
                node_to_delete =  mat.node_tree.nodes['Principled BSDF']
                node_to_delete2 =  mat.node_tree.nodes['Material Output']
                #Remove it
                mat.node_tree.nodes.remove( node_to_delete )
                mat.node_tree.nodes.remove( node_to_delete2 )
                bpy.data.images['cf_m_tang_NormalMap.png'].name = TexNormal 
                bpy.data.images['cf_m_tang_DetailMask.png'].name = TexDetailM
                bpy.data.images['cf_m_tang_ColorMask.png'].name = TexColorM
                C = bpy.context

                def instantiate_group(nodes, data_block_name):
                    group = nodes.new(type='ShaderNodeGroup')
                    group.node_tree = bpy.data.node_groups['KK-Template Tongue']
                    return group
                instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
        bpy.ops.object.select_all(action='DESELECT') # Deselecciona todo en la escena
        #################################ACCESORIES##################################
        bpy.ops.object.select_all(action='DESELECT') # Deselecciona todo en la escena
        # Get accesory object
        accses = ( w(accs1), w(accs2), w(accs3), w(accs4), w(accs5), w(accs6), w(accs7), w(accs8), w(accs9), w(accs10), w(accs11), w(accs12), w(accs13), w(accs14), w(accs15), w(accs16), w(accs17), w(accs18), w(accs19), w(accs20), w(accs21), w(accs22), w(accs23), w(accs24), w(accs25), w(accs26), w(accs27), w(accs28), w(accs29), w(accs30), w(accs31), w(accs32), w(accs33), w(accs34), w(accs35), w(accs36), w(accs37), w(accs38), w(accs39), w(accs40), w(accs41), w(accs42), w(accs43), w(accs44), w(accs45), w(accs46), w(accs47), w(accs48), w(accs49), w(accs50), w(accs51), w(accs52), w(accs53), w(accs54), w(accs55), w(accs56), w(accs57), w(accs58), w(accs59), w(accs60), w(accs61), w(accs62), w(accs63), w(accs64), w(accs65), w(accs66), w(accs67), w(accs68), w(accs69), w(accs70), w(accs71), w(accs72), w(accs73), w(accs74), w(accs75), w(accs76), w(accs77), w(accs78))
        for x in accses:
            if x is not None:
                #if bpy.data.objects.get(accs1) is not None:
                op = (x.name)
                bpy.data.objects.get(op).select_set(True)
                outline_accs = bpy.data.objects.get(op)
                bpy.context.view_layer.objects.active = outline_accs
                ob = bpy.context.selected_objects
                material_set = set()
                for object in bpy.context.selected_objects:
                    for material in object.material_slots:
                        material_set.add(material)
                for material in material_set:
                   # if material is not None:
                        Tex = material.name
                        TexMain = Tex+'_MainTex.png'
                        TexDetailM = Tex+'_DetailMask.png'
                        TexNormal = Tex+'_NormalMap.png'
                        TexLiquidM = Tex+'_liquidmask.png'
                        TexTex2 = Tex+'_Texture2.png'
                        TexTex3 = Tex+'_Texture3.png'
                        bpy.data.scenes['Scene'].sna_color10 = bpy.data.materials[Tex].node_tree.nodes['Principled BSDF'].inputs[0].default_value
                mat = bpy.data.materials[Tex]
                #Get the node in its node tree (replace the name below)
                node_to_delete =  mat.node_tree.nodes['Principled BSDF']
                node_to_delete2 =  mat.node_tree.nodes['Material Output']
                #Remove it
                mat.node_tree.nodes.remove( node_to_delete )
                mat.node_tree.nodes.remove( node_to_delete2 )
                imgaccs = ( bpimg('cf_m_top_deco01_MainTex.png'), bpimg('tenseigan'))
                for x in imgaccs:
                    if x is not None:
                        bpy.data.images['cf_m_top_deco01_MainTex.png'].name = TexMain 
                        bpy.data.images['cf_m_top_deco01_DetailMask.png'].name = TexDetailM
                        bpy.data.images['cf_m_top_deco01_NormalMap.png'].name = TexNormal
                        bpy.data.images['cf_m_top_deco01_liquidmask.png'].name = TexLiquidM
                        bpy.data.images['cf_m_top_deco01_Texture2.png'].name = TexTex2
                        bpy.data.images['cf_m_top_deco01_Texture3.png'].name = TexTex3
                        bpy.data.images[TexMain].filepath = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexMain
                        bpy.data.images[TexMain].filepath_raw = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexMain
                        bpy.data.images[TexDetailM].filepath = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexDetailM
                        bpy.data.images[TexDetailM].filepath_raw = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexDetailM
                        bpy.data.images[TexNormal].filepath = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexNormal
                        bpy.data.images[TexNormal].filepath_raw = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexNormal
                        bpy.data.images[TexLiquidM].filepath = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexLiquidM
                        bpy.data.images[TexLiquidM].filepath_raw = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexLiquidM
                        bpy.data.images[TexTex2].filepath = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexTex2
                        bpy.data.images[TexTex2].filepath_raw = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexTex2
                        bpy.data.images[TexTex3].filepath = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexTex3
                        bpy.data.images[TexTex3].filepath_raw = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexTex3
                C = bpy.context

                def instantiate_group(nodes, data_block_name):
                    group = nodes.new(type='ShaderNodeGroup')
                    group.node_tree = bpy.data.node_groups['KK-Template Accesories']
                    return group
                instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
                bpy.context.object.active_material.blend_method = 'CLIP'
                bpy.context.object.active_material.shadow_method = 'CLIP'
                my_mat = bpy.data.materials.get(Tex)
                bpy.data.node_groups['KK-Template Accesories'].name = 'KK-Template Accs '+Tex
                node = bpy.data.node_groups['KK-Template Accs '+Tex]
                #node.extension = 'CLIP'
                #node.image = bpy.data.images[bakefinal.name]
                nodes = my_mat.node_tree.nodes
                for node in nodes:
                    node.select = False
                    node.select = True
                    nodes.active = node
                try:
                    initial_area_type = bpy.context.area.type
                    bpy.context.area.type = 'NODE_EDITOR'
                    bpy.context.area.ui_type = 'ShaderNodeTree'
                    bpy.ops.wm.redraw_timer(type='DRAW_WIN', iterations=1)
                    bpy.ops.node.group_ungroup()
                    bpy.ops.node.group_edit(exit=True)
                except Exception as e:
                    print(e)
                finally:
                    bpy.context.area.type = initial_area_type
                break
        bpy.ops.object.select_all(action='DESELECT') # Deselecciona todo en la escena
        ##################################SIMPLE#####################################
        bpy.ops.object.select_all(action='DESELECT') # Deselecciona todo en la escena
        # Get short object
        simpes = ( w(simp1), w(simp2), w(simp3), w(simp4), w(simp5), w(simp6), w(simp7), w(simp8), w(simp9), w(simp10), w(simp11), w(simp12), w(simp13), w(simp14), w(simp15), w(simp16), w(simp17), w(simp18), w(simp19), w(simp20), w(simp21), w(simp22), w(simp23), w(simp24), w(simp25), w(simp26), w(simp27), w(simp28), w(simp29), w(simp30), w(simp31), w(simp32), w(simp33), w(simp34), w(simp35), w(simp36), w(simp37), w(simp38), w(simp39), w(simp40), w(simp41), w(simp42), w(simp43), w(simp44), w(simp45), w(simp46), w(simp47), w(simp48), w(simp49), w(simp50), w(simp51), w(simp52), w(simp53), w(simp54), w(simp55), w(simp56), w(simp57), w(simp58), w(simp59), w(simp60), w(simp61), w(simp62), w(simp63), w(simp64), w(simp65), w(simp66), w(simp67), w(simp68), w(simp69), w(simp70), w(simp71), w(simp72), w(simp73), w(simp74), w(simp75), w(simp76), w(simp77), w(simp78), w(simp79), w(simp80), w(simp81), w(simp82), w(simp83), w(simp84), w(simp85), w(simp86), w(simp87), w(simp88), w(simp89), w(simp90), w(simp91), w(simp92), w(simp93), w(simp94), w(simp95), w(simp96), w(simp97), w(simp98), w(simp99), w(simp100), w(simp101), w(simp102), w(simp103), w(simp104), w(simp105), w(simp106), w(simp107), w(simp108), w(simp109), w(simp110), w(simp111), w(simp112), w(simp113), w(simp114), w(simp115), w(simp116), w(simp117), w(simp118), w(simp119), w(simp120), w(simp121), w(simp122), w(simp123), w(simp124), w(simp125), w(simp126), w(simp127), w(simp128), w(simp129), w(simp130), w(simp131), w(simp132), w(simp133), w(simp134), w(simp135), w(simp136), w(simp137), w(simp138), w(simp139), w(simp140), w(simp141), w(simp142), w(simp143), w(simp144), w(simp145), w(simp146), w(simp147), w(simp148), w(simp149), w(simp150), w(simp151), w(simp152), w(simp153), w(simp154), w(simp155), w(simp156), w(simp157), w(simp158), w(simp159), w(simp160), w(simp161), w(simp162), w(simp163), w(simp164), w(simp165), w(simp166), w(simp167), w(simp168), w(simp169), w(simp170), w(simp171), w(simp172), w(simp173), w(simp174), w(simp175), w(simp176), w(simp177), w(simp178), w(simp179), w(simp180), w(simp181), w(simp182), w(simp183), w(simp184), w(simp185), w(simp186), w(simp187), w(simp188), w(simp189), w(simp190), w(simp191), w(simp192), w(simp193), w(simp194), w(simp195), w(simp196), w(simp197), w(simp198), w(simp199), w(simp200), w(simp201), w(simp202), w(simp203), w(simp204), w(simp205), w(simp206), w(simp207), w(simp208), w(simp209), w(simp210), w(simp211), w(simp212), w(simp213), w(simp214), w(simp215), w(simp216), w(simp217), w(simp218), w(simp219), w(simp220), w(simp221), w(simp222), w(simp223), w(simp224), w(simp225), w(simp226), w(simp227), w(simp228), w(simp229), w(simp230), w(simp231), w(simp232), w(simp233), w(simp234), w(simp235), w(simp236), w(simp237), w(simp238), w(simp239), w(simp240), w(simp241), w(simp243), w(simp244), w(simp245), w(simp246), w(simp247), w(simp248), w(simp249), w(simp250), w(simp251), w(simp252), w(simp253), w(simp254), w(simp255), w(simp256), w(simp257), w(simp258), w(simp259), w(simp260), w(simp261), w(simp262), w(simp263), w(simp264), w(simp265), w(simp266), w(simp267), w(simp268), w(simp269), w(simp270))
        for ob_simp in simpes:
            if ob_simp is not None:
                #if bpy.data.objects.get(simp1) is not None:
                op = (ob_simp.name)
                print(op)
                bpy.data.objects.get(op).select_set(True)
                outline_simp = bpy.data.objects.get(op)
                bpy.context.view_layer.objects.active = outline_simp
                ob = bpy.context.selected_objects
                material_set = set()
                for object in bpy.context.selected_objects:
                    for material in object.material_slots:
                        material_set.add(material)
                for material in material_set:
                #    print(material.name)
                    Tex = material.name
                #  print(Tex+'_MainTex.png')
                    TexMain = Tex+'_MainTex.png'
                mat = bpy.data.materials[Tex]
                #Get the node in its node tree (replace the name below)
                node_to_delete =  mat.node_tree.nodes['Principled BSDF']
                node_to_delete2 =  mat.node_tree.nodes['Material Output']
                #Remove it
                mat.node_tree.nodes.remove( node_to_delete )
                mat.node_tree.nodes.remove( node_to_delete2 )
                imgsimple = ( bpimg('cf_m_emblem_MainTex.png'), bpimg('tenseigan'))
                for x in imgsimple:
                    if x is not None:
                        bpy.data.images['cf_m_emblem_MainTex.png'].name = TexMain
                        bpy.data.images[TexMain].filepath = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexMain
                        bpy.data.images[TexMain].filepath_raw = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexMain
                C = bpy.context

                def instantiate_group(nodes, data_block_name):
                    group = nodes.new(type='ShaderNodeGroup')
                    group.node_tree = bpy.data.node_groups['KK-Template Simple']
                    return group
                instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
                bpy.context.object.active_material.blend_method = 'CLIP'
                bpy.context.object.active_material.shadow_method = 'CLIP'
                my_mat = bpy.data.materials.get(Tex)
                bpy.data.node_groups['KK-Template Simple'].name = 'KK-Template S '+Tex
                node = bpy.data.node_groups['KK-Template S '+Tex]
                #node.extension = 'CLIP'
                #node.image = bpy.data.images[bakefinal.name]
                nodes = my_mat.node_tree.nodes
                for node in nodes:
                    node.select = False
                    node.select = True
                    nodes.active = node
                try:
                    initial_area_type = bpy.context.area.type
                    bpy.context.area.type = 'NODE_EDITOR'
                    bpy.context.area.ui_type = 'ShaderNodeTree'
                    bpy.ops.wm.redraw_timer(type='DRAW_WIN', iterations=1)
                    bpy.ops.node.group_ungroup()
                    bpy.ops.node.group_edit(exit=True)
                except Exception as e:
                    print(e)
                finally:
                    bpy.context.area.type = initial_area_type
                break
        bpy.ops.object.select_all(action='DESELECT') # Deselecciona todo en la escena
        for ob_simp1 in simpes:
            if ob_simp1 is not ob_simp and ob_simp1 is not None:
                #if bpy.data.objects.get(simp1) is not None:
                op1 = (ob_simp1.name)
                print(op1)
                bpy.data.objects.get(op1).select_set(True)
                outline_simp1 = bpy.data.objects.get(op1)
                bpy.context.view_layer.objects.active = outline_simp1
                ob = bpy.context.selected_objects
                material_set = set()
                for object in bpy.context.selected_objects:
                    for material in object.material_slots:
                        material_set.add(material)
                for material in material_set:
                #    print(material.name)
                    Tex = material.name
                    #  print(Tex+'_MainTex.png')
                    TexMain = Tex+'_MainTex.png'
                mat = bpy.data.materials[Tex]
                #Get the node in its node tree (replace the name below)
                node_to_delete =  mat.node_tree.nodes['Principled BSDF']
                node_to_delete2 =  mat.node_tree.nodes['Material Output']
                #Remove it
                mat.node_tree.nodes.remove( node_to_delete )
                mat.node_tree.nodes.remove( node_to_delete2 )
                imgsimple = ( bpimg('cf_m_emblem_MainTex.png.001'), bpimg('tenseigan'))
                for x in imgsimple:
                    if x is not None:
                        bpy.data.images['cf_m_emblem_MainTex.png.001'].name = TexMain
                        bpy.data.images[TexMain].filepath = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexMain
                        bpy.data.images[TexMain].filepath_raw = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexMain
                C = bpy.context

                def instantiate_group(nodes, data_block_name):
                    group = nodes.new(type='ShaderNodeGroup')
                    group.node_tree = bpy.data.node_groups['KK-Template Simple.001']
                    return group
                instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
                bpy.context.object.active_material.blend_method = 'CLIP'
                bpy.context.object.active_material.shadow_method = 'CLIP'
                my_mat = bpy.data.materials.get(Tex)
                bpy.data.node_groups['KK-Template Simple.001'].name = 'KK-Template S '+Tex
                node = bpy.data.node_groups['KK-Template S '+Tex]
                #node.extension = 'CLIP'
                #node.image = bpy.data.images[bakefinal.name]
                nodes = my_mat.node_tree.nodes
                for node in nodes:
                    node.select = False
                    node.select = True
                    nodes.active = node
                try:
                    initial_area_type = bpy.context.area.type
                    bpy.context.area.type = 'NODE_EDITOR'
                    bpy.context.area.ui_type = 'ShaderNodeTree'
                    bpy.ops.wm.redraw_timer(type='DRAW_WIN', iterations=1)
                    bpy.ops.node.group_ungroup()
                    bpy.ops.node.group_edit(exit=True)
                except Exception as e:
                    print(e)
                finally:
                    bpy.context.area.type = initial_area_type
                break
        bpy.ops.object.select_all(action='DESELECT') # Deselecciona todo en la escena
        for ob_simp2 in simpes:
            if ob_simp2 is not ob_simp and ob_simp2 is not ob_simp1 and ob_simp2 is not None:
                #if bpy.data.objects.get(simp1) is not None:
                op2 = (ob_simp2.name)
                print(op2)
                bpy.data.objects.get(op2).select_set(True)
                outline_simp2 = bpy.data.objects.get(op2)
                bpy.context.view_layer.objects.active = outline_simp2
                ob = bpy.context.selected_objects
                material_set = set()
                for object in bpy.context.selected_objects:
                    for material in object.material_slots:
                        material_set.add(material)
                for material in material_set:
                #    print(material.name)
                    Tex = material.name
                    #  print(Tex+'_MainTex.png')
                    TexMain = Tex+'_MainTex.png'
                imgsimple = ( bpimg('cf_m_emblem_MainTex.png.002'), bpimg('tenseigan'))
                for x in imgsimple:
                    if x is not None:
                        bpy.data.images['cf_m_emblem_MainTex.png.002'].name = TexMain
                        bpy.data.images[TexMain].filepath = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexMain
                        bpy.data.images[TexMain].filepath_raw = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexMain
                C = bpy.context

                def instantiate_group(nodes, data_block_name):
                    group = nodes.new(type='ShaderNodeGroup')
                    group.node_tree = bpy.data.node_groups['KK-Template Simple.002']
                    return group
                instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
                bpy.context.object.active_material.blend_method = 'CLIP'
                bpy.context.object.active_material.shadow_method = 'CLIP'
                my_mat = bpy.data.materials.get(Tex)
                bpy.data.node_groups['KK-Template Simple.002'].name = 'KK-Template S '+Tex
                node = bpy.data.node_groups['KK-Template S '+Tex]
                #node.extension = 'CLIP'
                #node.image = bpy.data.images[bakefinal.name]
                nodes = my_mat.node_tree.nodes
                for node in nodes:
                    node.select = False
                    node.select = True
                    nodes.active = node
                try:
                    initial_area_type = bpy.context.area.type
                    bpy.context.area.type = 'NODE_EDITOR'
                    bpy.context.area.ui_type = 'ShaderNodeTree'
                    bpy.ops.wm.redraw_timer(type='DRAW_WIN', iterations=1)
                    bpy.ops.node.group_ungroup()
                    bpy.ops.node.group_edit(exit=True)
                except Exception as e:
                    print(e)
                finally:
                    bpy.context.area.type = initial_area_type
                break
        bpy.ops.object.select_all(action='DESELECT') # Deselecciona todo en la escena
        for ob_simp3 in simpes:
            if ob_simp3 is not ob_simp and ob_simp3 is not ob_simp1 and ob_simp3 is not ob_simp2 and ob_simp3 is not None:
                #if bpy.data.objects.get(simp1) is not None:
                op3 = (ob_simp3.name)
                print(op3)
                bpy.data.objects.get(op3).select_set(True)
                outline_simp3 = bpy.data.objects.get(op3)
                bpy.context.view_layer.objects.active = outline_simp3
                ob = bpy.context.selected_objects
                material_set = set()
                for object in bpy.context.selected_objects:
                    for material in object.material_slots:
                        material_set.add(material)
                for material in material_set:
                #    print(material.name)
                    Tex = material.name
                    #  print(Tex+'_MainTex.png')
                    TexMain = Tex+'_MainTex.png'
                mat = bpy.data.materials[Tex]
                #Get the node in its node tree (replace the name below)
                node_to_delete =  mat.node_tree.nodes['Principled BSDF']
                node_to_delete2 =  mat.node_tree.nodes['Material Output']
                #Remove it
                mat.node_tree.nodes.remove( node_to_delete )
                mat.node_tree.nodes.remove( node_to_delete2 )
                imgsimple = ( bpimg('cf_m_emblem_MainTex.png.003'), bpimg('tenseigan'))
                for x in imgsimple:
                    if x is not None:
                        bpy.data.images['cf_m_emblem_MainTex.png.003'].name = TexMain
                        bpy.data.images[TexMain].filepath = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexMain
                        bpy.data.images[TexMain].filepath_raw = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexMain
                C = bpy.context

                def instantiate_group(nodes, data_block_name):
                    group = nodes.new(type='ShaderNodeGroup')
                    group.node_tree = bpy.data.node_groups['KK-Template Simple.003']
                    return group
                instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
                bpy.context.object.active_material.blend_method = 'CLIP'
                bpy.context.object.active_material.shadow_method = 'CLIP'
                my_mat = bpy.data.materials.get(Tex)
                bpy.data.node_groups['KK-Template Simple.003'].name = 'KK-Template S '+Tex
                node = bpy.data.node_groups['KK-Template S '+Tex]
                #node.extension = 'CLIP'
                #node.image = bpy.data.images[bakefinal.name]
                nodes = my_mat.node_tree.nodes
                for node in nodes:
                    node.select = False
                    node.select = True
                    nodes.active = node
                try:
                    initial_area_type = bpy.context.area.type
                    bpy.context.area.type = 'NODE_EDITOR'
                    bpy.context.area.ui_type = 'ShaderNodeTree'
                    bpy.ops.wm.redraw_timer(type='DRAW_WIN', iterations=1)
                    bpy.ops.node.group_ungroup()
                    bpy.ops.node.group_edit(exit=True)
                except Exception as e:
                    print(e)
                finally:
                    bpy.context.area.type = initial_area_type
                break
        bpy.ops.object.select_all(action='DESELECT') # Deselecciona todo en la escena
        for ob_simp4 in simpes:
            if ob_simp4 is not ob_simp and ob_simp4 is not ob_simp1 and ob_simp4 is not ob_simp2 and ob_simp4 is not ob_simp3 and ob_simp4 is not None:
                #if bpy.data.objects.get(simp1) is not None:
                op4 = (ob_simp4.name)
                print(op4)
                bpy.data.objects.get(op4).select_set(True)
                outline_simp4 = bpy.data.objects.get(op4)
                bpy.context.view_layer.objects.active = outline_simp4
                ob = bpy.context.selected_objects
                material_set = set()
                for object in bpy.context.selected_objects:
                    for material in object.material_slots:
                        material_set.add(material)
                for material in material_set:
                #    print(material.name)
                    Tex = material.name
                    #  print(Tex+'_MainTex.png')
                    TexMain = Tex+'_MainTex.png'
                mat = bpy.data.materials[Tex]
                #Get the node in its node tree (replace the name below)
                node_to_delete =  mat.node_tree.nodes['Principled BSDF']
                node_to_delete2 =  mat.node_tree.nodes['Material Output']
                #Remove it
                mat.node_tree.nodes.remove( node_to_delete )
                mat.node_tree.nodes.remove( node_to_delete2 )
                imgsimple = ( bpimg('cf_m_emblem_MainTex.png.004'), bpimg('tenseigan'))
                for x in imgsimple:
                    if x is not None:
                        bpy.data.images['cf_m_emblem_MainTex.png.004'].name = TexMain
                        bpy.data.images[TexMain].filepath = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexMain
                        bpy.data.images[TexMain].filepath_raw = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexMain
                C = bpy.context

                def instantiate_group(nodes, data_block_name):
                    group = nodes.new(type='ShaderNodeGroup')
                    group.node_tree = bpy.data.node_groups['KK-Template Simple.004']
                    return group
                instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
                bpy.context.object.active_material.blend_method = 'CLIP'
                bpy.context.object.active_material.shadow_method = 'CLIP'
                my_mat = bpy.data.materials.get(Tex)
                bpy.data.node_groups['KK-Template Simple.004'].name = 'KK-Template S '+Tex
                node = bpy.data.node_groups['KK-Template S '+Tex]
                #node.extension = 'CLIP'
                #node.image = bpy.data.images[bakefinal.name]
                nodes = my_mat.node_tree.nodes
                for node in nodes:
                    node.select = False
                    node.select = True
                    nodes.active = node
                try:
                    initial_area_type = bpy.context.area.type
                    bpy.context.area.type = 'NODE_EDITOR'
                    bpy.context.area.ui_type = 'ShaderNodeTree'
                    bpy.ops.wm.redraw_timer(type='DRAW_WIN', iterations=1)
                    bpy.ops.node.group_ungroup()
                    bpy.ops.node.group_edit(exit=True)
                except Exception as e:
                    print(e)
                finally:
                    bpy.context.area.type = initial_area_type
                break
        bpy.ops.object.select_all(action='DESELECT') # Deselecciona todo en la escena
        for ob_simp5 in simpes:
            if ob_simp5 is not ob_simp and ob_simp5 is not ob_simp1 and ob_simp5 is not ob_simp2 and ob_simp5 is not ob_simp3 and ob_simp5 is not ob_simp4 and ob_simp5 is not None:
                #if bpy.data.objects.get(simp1) is not None:
                op5 = (ob_simp5.name)
                print(op5)
                bpy.data.objects.get(op5).select_set(True)
                outline_simp5 = bpy.data.objects.get(op5)
                bpy.context.view_layer.objects.active = outline_simp5
                ob = bpy.context.selected_objects
                material_set = set()
                for object in bpy.context.selected_objects:
                    for material in object.material_slots:
                        material_set.add(material)
                for material in material_set:
                #    print(material.name)
                    Tex = material.name
                #  print(Tex+'_MainTex.png')
                    TexMain = Tex+'_MainTex.png'
                mat = bpy.data.materials[Tex]
                #Get the node in its node tree (replace the name below)
                node_to_delete =  mat.node_tree.nodes['Principled BSDF']
                node_to_delete2 =  mat.node_tree.nodes['Material Output']
                #Remove it
                mat.node_tree.nodes.remove( node_to_delete )
                mat.node_tree.nodes.remove( node_to_delete2 )
                imgsimple = ( bpimg('cf_m_emblem_MainTex.png.005'), bpimg('tenseigan'))
                for x in imgsimple:
                    if x is not None:
                        bpy.data.images['cf_m_emblem_MainTex.png.005'].name = TexMain
                        bpy.data.images[TexMain].filepath = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexMain
                        bpy.data.images[TexMain].filepath_raw = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexMain
                C = bpy.context

                def instantiate_group(nodes, data_block_name):
                    group = nodes.new(type='ShaderNodeGroup')
                    group.node_tree = bpy.data.node_groups['KK-Template Simple.005']
                    return group
                instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
                bpy.context.object.active_material.blend_method = 'CLIP'
                bpy.context.object.active_material.shadow_method = 'CLIP'
                my_mat = bpy.data.materials.get(Tex)
                bpy.data.node_groups['KK-Template Simple.005'].name = 'KK-Template S '+Tex
                node = bpy.data.node_groups['KK-Template S '+Tex]
                #node.extension = 'CLIP'
                #node.image = bpy.data.images[bakefinal.name]
                nodes = my_mat.node_tree.nodes
                for node in nodes:
                    node.select = False
                    node.select = True
                    nodes.active = node
                try:
                    initial_area_type = bpy.context.area.type
                    bpy.context.area.type = 'NODE_EDITOR'
                    bpy.context.area.ui_type = 'ShaderNodeTree'
                    bpy.ops.wm.redraw_timer(type='DRAW_WIN', iterations=1)
                    bpy.ops.node.group_ungroup()
                    bpy.ops.node.group_edit(exit=True)
                except Exception as e:
                    print(e)
                finally:
                    bpy.context.area.type = initial_area_type
                break
        bpy.ops.object.select_all(action='DESELECT') # Deselecciona todo en la escena
        for ob_simp6 in simpes:
            if ob_simp6 is not ob_simp and ob_simp6 is not ob_simp1 and ob_simp6 is not ob_simp2 and ob_simp6 is not ob_simp3 and ob_simp6 is not ob_simp4 and ob_simp6 is not ob_simp5 and ob_simp6 is not None:
                #if bpy.data.objects.get(simp1) is not None:
                op6 = (ob_simp6.name)
                print(op6)
                bpy.data.objects.get(op6).select_set(True)
                outline_simp6 = bpy.data.objects.get(op6)
                bpy.context.view_layer.objects.active = outline_simp6
                ob = bpy.context.selected_objects
                material_set = set()
                for object in bpy.context.selected_objects:
                    for material in object.material_slots:
                        material_set.add(material)
                for material in material_set:
                #    print(material.name)
                    Tex = material.name
                #  print(Tex+'_MainTex.png')
                    TexMain = Tex+'_MainTex.png'
                mat = bpy.data.materials[Tex]
                #Get the node in its node tree (replace the name below)
                node_to_delete =  mat.node_tree.nodes['Principled BSDF']
                node_to_delete2 =  mat.node_tree.nodes['Material Output']
                #Remove it
                mat.node_tree.nodes.remove( node_to_delete )
                mat.node_tree.nodes.remove( node_to_delete2 )
                imgsimple = ( bpimg('cf_m_emblem_MainTex.png.006'), bpimg('tenseigan'))
                for x in imgsimple:
                    if x is not None:
                        bpy.data.images['cf_m_emblem_MainTex.png.006'].name = TexMain
                        bpy.data.images[TexMain].filepath = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexMain
                        bpy.data.images[TexMain].filepath_raw = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexMain
                C = bpy.context

                def instantiate_group(nodes, data_block_name):
                    group = nodes.new(type='ShaderNodeGroup')
                    group.node_tree = bpy.data.node_groups['KK-Template Simple.006']
                    return group
                instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
                bpy.context.object.active_material.blend_method = 'CLIP'
                bpy.context.object.active_material.shadow_method = 'CLIP'
                my_mat = bpy.data.materials.get(Tex)
                bpy.data.node_groups['KK-Template Simple.006'].name = 'KK-Template S '+Tex
                node = bpy.data.node_groups['KK-Template S '+Tex]
                #node.extension = 'CLIP'
                #node.image = bpy.data.images[bakefinal.name]
                nodes = my_mat.node_tree.nodes
                for node in nodes:
                    node.select = False
                    node.select = True
                    nodes.active = node
                try:
                    initial_area_type = bpy.context.area.type
                    bpy.context.area.type = 'NODE_EDITOR'
                    bpy.context.area.ui_type = 'ShaderNodeTree'
                    bpy.ops.wm.redraw_timer(type='DRAW_WIN', iterations=1)
                    bpy.ops.node.group_ungroup()
                    bpy.ops.node.group_edit(exit=True)
                except Exception as e:
                    print(e)
                finally:
                    bpy.context.area.type = initial_area_type
                break
        bpy.ops.object.select_all(action='DESELECT') # Deselecciona todo en la escena
        for ob_simp7 in simpes:
            if ob_simp7 is not ob_simp and ob_simp7 is not ob_simp1 and ob_simp7 is not ob_simp2 and ob_simp7 is not ob_simp3 and ob_simp7 is not ob_simp4 and ob_simp7 is not ob_simp5 and ob_simp7 is not ob_simp6 and ob_simp7 is not None:
                #if bpy.data.objects.get(simp1) is not None:
                op7 = (ob_simp7.name)
                print(op7)
                bpy.data.objects.get(op7).select_set(True)
                outline_simp7 = bpy.data.objects.get(op7)
                bpy.context.view_layer.objects.active = outline_simp7
                ob = bpy.context.selected_objects
                material_set = set()
                for object in bpy.context.selected_objects:
                    for material in object.material_slots:
                        material_set.add(material)
                for material in material_set:
                #    print(material.name)
                    Tex = material.name
                #  print(Tex+'_MainTex.png')
                    TexMain = Tex+'_MainTex.png'
                mat = bpy.data.materials[Tex]
                #Get the node in its node tree (replace the name below)
                node_to_delete =  mat.node_tree.nodes['Principled BSDF']
                node_to_delete2 =  mat.node_tree.nodes['Material Output']
                #Remove it
                mat.node_tree.nodes.remove( node_to_delete )
                mat.node_tree.nodes.remove( node_to_delete2 )
                imgsimple = ( bpimg('cf_m_emblem_MainTex.png.007'), bpimg('tenseigan'))
                for x in imgsimple:
                    if x is not None:
                        bpy.data.images['cf_m_emblem_MainTex.png.007'].name = TexMain
                        bpy.data.images[TexMain].filepath = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexMain
                        bpy.data.images[TexMain].filepath_raw = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexMain
                C = bpy.context

                def instantiate_group(nodes, data_block_name):
                    group = nodes.new(type='ShaderNodeGroup')
                    group.node_tree = bpy.data.node_groups['KK-Template Simple.007']
                    return group
                instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
                bpy.context.object.active_material.blend_method = 'CLIP'
                bpy.context.object.active_material.shadow_method = 'CLIP'
                my_mat = bpy.data.materials.get(Tex)
                bpy.data.node_groups['KK-Template Simple.007'].name = 'KK-Template S '+Tex
                node = bpy.data.node_groups['KK-Template S '+Tex]
                #node.extension = 'CLIP'
                #node.image = bpy.data.images[bakefinal.name]
                nodes = my_mat.node_tree.nodes
                for node in nodes:
                    node.select = False
                    node.select = True
                    nodes.active = node
                try:
                    initial_area_type = bpy.context.area.type
                    bpy.context.area.type = 'NODE_EDITOR'
                    bpy.context.area.ui_type = 'ShaderNodeTree'
                    bpy.ops.wm.redraw_timer(type='DRAW_WIN', iterations=1)
                    bpy.ops.node.group_ungroup()
                    bpy.ops.node.group_edit(exit=True)
                except Exception as e:
                    print(e)
                finally:
                    bpy.context.area.type = initial_area_type
                break
        bpy.ops.object.select_all(action='DESELECT') # Deselecciona todo en la escena
        for ob_simp8 in simpes:
            if ob_simp8 is not ob_simp and ob_simp8 is not ob_simp1 and ob_simp8 is not ob_simp2 and ob_simp8 is not ob_simp3 and ob_simp8 is not ob_simp4 and ob_simp8 is not ob_simp5 and ob_simp8 is not ob_simp6 and ob_simp8 is not ob_simp7 and ob_simp8 is not None:
                #if bpy.data.objects.get(simp1) is not None:
                op8 = (ob_simp8.name)
                print(op8)
                bpy.data.objects.get(op8).select_set(True)
                outline_simp8 = bpy.data.objects.get(op8)
                bpy.context.view_layer.objects.active = outline_simp8
                ob = bpy.context.selected_objects
                material_set = set()
                for object in bpy.context.selected_objects:
                    for material in object.material_slots:
                        material_set.add(material)
                for material in material_set:
                #    print(material.name)
                    Tex = material.name
                #  print(Tex+'_MainTex.png')
                    TexMain = Tex+'_MainTex.png'
                mat = bpy.data.materials[Tex]
                #Get the node in its node tree (replace the name below)
                node_to_delete =  mat.node_tree.nodes['Principled BSDF']
                node_to_delete2 =  mat.node_tree.nodes['Material Output']
                #Remove it
                mat.node_tree.nodes.remove( node_to_delete )
                mat.node_tree.nodes.remove( node_to_delete2 )
                imgsimple = ( bpimg('cf_m_emblem_MainTex.png.008'), bpimg('tenseigan'))
                for x in imgsimple:
                    if x is not None:
                        bpy.data.images['cf_m_emblem_MainTex.png.008'].name = TexMain
                        bpy.data.images[TexMain].filepath = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexMain
                        bpy.data.images[TexMain].filepath_raw = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexMain
                C = bpy.context

                def instantiate_group(nodes, data_block_name):
                    group = nodes.new(type='ShaderNodeGroup')
                    group.node_tree = bpy.data.node_groups['KK-Template Simple.008']
                    return group
                instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
                bpy.context.object.active_material.blend_method = 'CLIP'
                bpy.context.object.active_material.shadow_method = 'CLIP'
                my_mat = bpy.data.materials.get(Tex)
                bpy.data.node_groups['KK-Template Simple.008'].name = 'KK-Template S '+Tex
                node = bpy.data.node_groups['KK-Template S '+Tex]
                #node.extension = 'CLIP'
                #node.image = bpy.data.images[bakefinal.name]
                nodes = my_mat.node_tree.nodes
                for node in nodes:
                    node.select = False
                    node.select = True
                    nodes.active = node
                try:
                    initial_area_type = bpy.context.area.type
                    bpy.context.area.type = 'NODE_EDITOR'
                    bpy.context.area.ui_type = 'ShaderNodeTree'
                    bpy.ops.wm.redraw_timer(type='DRAW_WIN', iterations=1)
                    bpy.ops.node.group_ungroup()
                    bpy.ops.node.group_edit(exit=True)
                except Exception as e:
                    print(e)
                finally:
                    bpy.context.area.type = initial_area_type
                break
        bpy.ops.object.select_all(action='DESELECT') # Deselecciona todo en la escena
        for ob_simp9 in simpes:
            if ob_simp9 is not ob_simp and ob_simp9 is not ob_simp1 and ob_simp9 is not ob_simp2 and ob_simp9 is not ob_simp3 and ob_simp9 is not ob_simp4 and ob_simp9 is not ob_simp5 and ob_simp9 is not ob_simp6 and ob_simp9 is not ob_simp7 and ob_simp9 is not ob_simp8 and ob_simp9 is not None:
                #if bpy.data.objects.get(simp1) is not None:
                op9 = (ob_simp9.name)
                print(op9)
                bpy.data.objects.get(op9).select_set(True)
                outline_simp9 = bpy.data.objects.get(op9)
                bpy.context.view_layer.objects.active = outline_simp9
                ob = bpy.context.selected_objects
                material_set = set()
                for object in bpy.context.selected_objects:
                    for material in object.material_slots:
                        material_set.add(material)
                for material in material_set:
                #    print(material.name)
                    Tex = material.name
                #  print(Tex+'_MainTex.png')
                    TexMain = Tex+'_MainTex.png'
                mat = bpy.data.materials[Tex]
                #Get the node in its node tree (replace the name below)
                node_to_delete =  mat.node_tree.nodes['Principled BSDF']
                node_to_delete2 =  mat.node_tree.nodes['Material Output']
                #Remove it
                mat.node_tree.nodes.remove( node_to_delete )
                mat.node_tree.nodes.remove( node_to_delete2 )
                imgsimple = ( bpimg('cf_m_emblem_MainTex.png.009'), bpimg('tenseigan'))
                for x in imgsimple:
                    if x is not None:
                        bpy.data.images['cf_m_emblem_MainTex.png.009'].name = TexMain
                        bpy.data.images[TexMain].filepath = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexMain
                        bpy.data.images[TexMain].filepath_raw = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexMain
                C = bpy.context

                def instantiate_group(nodes, data_block_name):
                    group = nodes.new(type='ShaderNodeGroup')
                    group.node_tree = bpy.data.node_groups['KK-Template Simple.009']
                    return group
                instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
                bpy.context.object.active_material.blend_method = 'CLIP'
                bpy.context.object.active_material.shadow_method = 'CLIP'
                my_mat = bpy.data.materials.get(Tex)
                bpy.data.node_groups['KK-Template Simple.009'].name = 'KK-Template S '+Tex
                node = bpy.data.node_groups['KK-Template S '+Tex]
                #node.extension = 'CLIP'
                #node.image = bpy.data.images[bakefinal.name]
                nodes = my_mat.node_tree.nodes
                for node in nodes:
                    node.select = False
                    node.select = True
                    nodes.active = node
                try:
                    initial_area_type = bpy.context.area.type
                    bpy.context.area.type = 'NODE_EDITOR'
                    bpy.context.area.ui_type = 'ShaderNodeTree'
                    bpy.ops.wm.redraw_timer(type='DRAW_WIN', iterations=1)
                    bpy.ops.node.group_ungroup()
                    bpy.ops.node.group_edit(exit=True)
                except Exception as e:
                    print(e)
                finally:
                    bpy.context.area.type = initial_area_type
                break
        bpy.ops.object.select_all(action='DESELECT') # Deselecciona todo en la escena
        for ob_simp10 in simpes:
            if ob_simp10 is not ob_simp and ob_simp10 is not ob_simp1 and ob_simp10 is not ob_simp2 and ob_simp10 is not ob_simp3 and ob_simp10 is not ob_simp4 and ob_simp10 is not ob_simp5 and ob_simp10 is not ob_simp6 and ob_simp10 is not ob_simp7 and ob_simp10 is not ob_simp8 and ob_simp10 is not ob_simp9 and ob_simp10 is not None:
                #if bpy.data.objects.get(simp1) is not None:
                op10 = (ob_simp10.name)
                print(op10)
                bpy.data.objects.get(op10).select_set(True)
                outline_simp10 = bpy.data.objects.get(op10)
                bpy.context.view_layer.objects.active = outline_simp10
                ob = bpy.context.selected_objects
                material_set = set()
                for object in bpy.context.selected_objects:
                    for material in object.material_slots:
                        material_set.add(material)
                for material in material_set:
                #    print(material.name)
                    Tex = material.name
                    #  print(Tex+'_MainTex.png')
                    TexMain = Tex+'_MainTex.png'
                mat = bpy.data.materials[Tex]
                #Get the node in its node tree (replace the name below)
                node_to_delete =  mat.node_tree.nodes['Principled BSDF']
                node_to_delete2 =  mat.node_tree.nodes['Material Output']
                #Remove it
                mat.node_tree.nodes.remove( node_to_delete )
                mat.node_tree.nodes.remove( node_to_delete2 )
                imgsimple = ( bpimg('cf_m_emblem_MainTex.png.010'), bpimg('tenseigan'))
                for x in imgsimple:
                    if x is not None:
                        bpy.data.images['cf_m_emblem_MainTex.png.010'].name = TexMain
                        bpy.data.images[TexMain].filepath = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexMain
                        bpy.data.images[TexMain].filepath_raw = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexMain
                C = bpy.context

                def instantiate_group(nodes, data_block_name):
                    group = nodes.new(type='ShaderNodeGroup')
                    group.node_tree = bpy.data.node_groups['KK-Template Simple.010']
                    return group
                instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
                bpy.context.object.active_material.blend_method = 'CLIP'
                bpy.context.object.active_material.shadow_method = 'CLIP'
                my_mat = bpy.data.materials.get(Tex)
                bpy.data.node_groups['KK-Template Simple.010'].name = 'KK-Template S '+Tex
                node = bpy.data.node_groups['KK-Template S '+Tex]
                #node.extension = 'CLIP'
                #node.image = bpy.data.images[bakefinal.name]
                nodes = my_mat.node_tree.nodes
                for node in nodes:
                    node.select = False
                    node.select = True
                    nodes.active = node
                try:
                    initial_area_type = bpy.context.area.type
                    bpy.context.area.type = 'NODE_EDITOR'
                    bpy.context.area.ui_type = 'ShaderNodeTree'
                    bpy.ops.wm.redraw_timer(type='DRAW_WIN', iterations=1)
                    bpy.ops.node.group_ungroup()
                    bpy.ops.node.group_edit(exit=True)
                except Exception as e:
                    print(e)
                finally:
                    bpy.context.area.type = initial_area_type
                break
        bpy.ops.object.select_all(action='DESELECT') # Deselecciona todo en la escena
        for ob_simp11 in simpes:
            if ob_simp11 is not ob_simp and ob_simp11 is not ob_simp1 and ob_simp11 is not ob_simp2 and ob_simp11 is not ob_simp3 and ob_simp11 is not ob_simp4 and ob_simp11 is not ob_simp5 and ob_simp11 is not ob_simp6 and ob_simp11 is not ob_simp7 and ob_simp11 is not ob_simp8 and ob_simp11 is not ob_simp9 and ob_simp11 is not ob_simp10 and ob_simp11 is not None:
                #if bpy.data.objects.get(simp1) is not None:
                op11 = (ob_simp11.name)
                print(op11)
                bpy.data.objects.get(op11).select_set(True)
                outline_simp11 = bpy.data.objects.get(op11)
                bpy.context.view_layer.objects.active = outline_simp11
                ob = bpy.context.selected_objects
                material_set = set()
                for object in bpy.context.selected_objects:
                    for material in object.material_slots:
                        material_set.add(material)
                for material in material_set:
                #    print(material.name)
                    Tex = material.name
                    #  print(Tex+'_MainTex.png')
                    TexMain = Tex+'_MainTex.png'
                mat = bpy.data.materials[Tex]
                #Get the node in its node tree (replace the name below)
                node_to_delete =  mat.node_tree.nodes['Principled BSDF']
                node_to_delete2 =  mat.node_tree.nodes['Material Output']
                #Remove it
                mat.node_tree.nodes.remove( node_to_delete )
                mat.node_tree.nodes.remove( node_to_delete2 )
                imgsimple = ( bpimg('cf_m_emblem_MainTex.png.011'), bpimg('tenseigan'))
                for x in imgsimple:
                    if x is not None:
                        bpy.data.images['cf_m_emblem_MainTex.png.011'].name = TexMain
                        bpy.data.images[TexMain].filepath = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexMain
                        bpy.data.images[TexMain].filepath_raw = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexMain
                C = bpy.context

                def instantiate_group(nodes, data_block_name):
                    group = nodes.new(type='ShaderNodeGroup')
                    group.node_tree = bpy.data.node_groups['KK-Template Simple.011']
                    return group
                instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
                bpy.context.object.active_material.blend_method = 'CLIP'
                bpy.context.object.active_material.shadow_method = 'CLIP'
                my_mat = bpy.data.materials.get(Tex)
                bpy.data.node_groups['KK-Template Simple.011'].name = 'KK-Template S '+Tex
                node = bpy.data.node_groups['KK-Template S '+Tex]
                #node.extension = 'CLIP'
                #node.image = bpy.data.images[bakefinal.name]
                nodes = my_mat.node_tree.nodes
                for node in nodes:
                    node.select = False
                    node.select = True
                    nodes.active = node
                try:
                    initial_area_type = bpy.context.area.type
                    bpy.context.area.type = 'NODE_EDITOR'
                    bpy.context.area.ui_type = 'ShaderNodeTree'
                    bpy.ops.wm.redraw_timer(type='DRAW_WIN', iterations=1)
                    bpy.ops.node.group_ungroup()
                    bpy.ops.node.group_edit(exit=True)
                except Exception as e:
                    print(e)
                finally:
                    bpy.context.area.type = initial_area_type
                break
        bpy.ops.object.select_all(action='DESELECT') # Deselecciona todo en la escena
        for ob_simp12 in simpes:
            if ob_simp12 is not ob_simp and ob_simp12 is not ob_simp1 and ob_simp12 is not ob_simp2 and ob_simp12 is not ob_simp3 and ob_simp12 is not ob_simp4 and ob_simp12 is not ob_simp5 and ob_simp12 is not ob_simp6 and ob_simp12 is not ob_simp7 and ob_simp12 is not ob_simp8 and ob_simp12 is not ob_simp9 and ob_simp12 is not ob_simp10 and ob_simp12 is not ob_simp11 and ob_simp12 is not None:
                #if bpy.data.objects.get(simp1) is not None:
                op12 = (ob_simp12.name)
                print(op12)
                bpy.data.objects.get(op12).select_set(True)
                outline_simp12 = bpy.data.objects.get(op12)
                bpy.context.view_layer.objects.active = outline_simp12
                ob = bpy.context.selected_objects
                material_set = set()
                for object in bpy.context.selected_objects:
                    for material in object.material_slots:
                        material_set.add(material)
                for material in material_set:
                #    print(material.name)
                    Tex = material.name
                    #  print(Tex+'_MainTex.png')
                    TexMain = Tex+'_MainTex.png'
                mat = bpy.data.materials[Tex]
                #Get the node in its node tree (replace the name below)
                node_to_delete =  mat.node_tree.nodes['Principled BSDF']
                node_to_delete2 =  mat.node_tree.nodes['Material Output']
                #Remove it
                mat.node_tree.nodes.remove( node_to_delete )
                mat.node_tree.nodes.remove( node_to_delete2 )
                imgsimple = ( bpimg('cf_m_emblem_MainTex.png.012'), bpimg('tenseigan'))
                for x in imgsimple:
                    if x is not None:
                        bpy.data.images['cf_m_emblem_MainTex.png.012'].name = TexMain
                        bpy.data.images[TexMain].filepath = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexMain
                        bpy.data.images[TexMain].filepath_raw = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexMain
                C = bpy.context

                def instantiate_group(nodes, data_block_name):
                    group = nodes.new(type='ShaderNodeGroup')
                    group.node_tree = bpy.data.node_groups['KK-Template Simple.012']
                    return group
                instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
                bpy.context.object.active_material.blend_method = 'CLIP'
                bpy.context.object.active_material.shadow_method = 'CLIP'
                my_mat = bpy.data.materials.get(Tex)
                bpy.data.node_groups['KK-Template Simple.012'].name = 'KK-Template S '+Tex
                node = bpy.data.node_groups['KK-Template S '+Tex]
                #node.extension = 'CLIP'
                #node.image = bpy.data.images[bakefinal.name]
                nodes = my_mat.node_tree.nodes
                for node in nodes:
                    node.select = False
                    node.select = True
                    nodes.active = node
                try:
                    initial_area_type = bpy.context.area.type
                    bpy.context.area.type = 'NODE_EDITOR'
                    bpy.context.area.ui_type = 'ShaderNodeTree'
                    bpy.ops.wm.redraw_timer(type='DRAW_WIN', iterations=1)
                    bpy.ops.node.group_ungroup()
                    bpy.ops.node.group_edit(exit=True)
                except Exception as e:
                    print(e)
                finally:
                    bpy.context.area.type = initial_area_type
                break
        bpy.ops.object.select_all(action='DESELECT') # Deselecciona todo en la escena
        for ob_simp13 in simpes:
            if ob_simp13 is not ob_simp and ob_simp13 is not ob_simp1 and ob_simp13 is not ob_simp2 and ob_simp13 is not ob_simp3 and ob_simp13 is not ob_simp4 and ob_simp13 is not ob_simp5 and ob_simp13 is not ob_simp6 and ob_simp13 is not ob_simp7 and ob_simp13 is not ob_simp8 and ob_simp13 is not ob_simp9 and ob_simp13 is not ob_simp10 and ob_simp13 is not ob_simp11 and ob_simp13 is not ob_simp12 and ob_simp13 is not None:
                #if bpy.data.objects.get(simp1) is not None:
                op13 = (ob_simp13.name)
                print(op13)
                bpy.data.objects.get(op13).select_set(True)
                outline_simp13 = bpy.data.objects.get(op13)
                bpy.context.view_layer.objects.active = outline_simp13
                ob = bpy.context.selected_objects
                material_set = set()
                for object in bpy.context.selected_objects:
                    for material in object.material_slots:
                        material_set.add(material)
                for material in material_set:
                #    print(material.name)
                    Tex = material.name
                    #  print(Tex+'_MainTex.png')
                    TexMain = Tex+'_MainTex.png'
                mat = bpy.data.materials[Tex]
                #Get the node in its node tree (replace the name below)
                node_to_delete =  mat.node_tree.nodes['Principled BSDF']
                node_to_delete2 =  mat.node_tree.nodes['Material Output']
                #Remove it
                mat.node_tree.nodes.remove( node_to_delete )
                mat.node_tree.nodes.remove( node_to_delete2 )
                imgsimple = ( bpimg('cf_m_emblem_MainTex.png.013'), bpimg('tenseigan'))
                for x in imgsimple:
                    if x is not None:
                        bpy.data.images['cf_m_emblem_MainTex.png.013'].name = TexMain
                        bpy.data.images[TexMain].filepath = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexMain
                        bpy.data.images[TexMain].filepath_raw = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexMain
                C = bpy.context

                def instantiate_group(nodes, data_block_name):
                    group = nodes.new(type='ShaderNodeGroup')
                    group.node_tree = bpy.data.node_groups['KK-Template Simple.013']
                    return group
                instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
                bpy.context.object.active_material.blend_method = 'CLIP'
                bpy.context.object.active_material.shadow_method = 'CLIP'
                my_mat = bpy.data.materials.get(Tex)
                bpy.data.node_groups['KK-Template Simple.013'].name = 'KK-Template S '+Tex
                node = bpy.data.node_groups['KK-Template S '+Tex]
                #node.extension = 'CLIP'
                #node.image = bpy.data.images[bakefinal.name]
                nodes = my_mat.node_tree.nodes
                for node in nodes:
                    node.select = False
                    node.select = True
                    nodes.active = node
                try:
                    initial_area_type = bpy.context.area.type
                    bpy.context.area.type = 'NODE_EDITOR'
                    bpy.context.area.ui_type = 'ShaderNodeTree'
                    bpy.ops.wm.redraw_timer(type='DRAW_WIN', iterations=1)
                    bpy.ops.node.group_ungroup()
                    bpy.ops.node.group_edit(exit=True)
                except Exception as e:
                    print(e)
                finally:
                    bpy.context.area.type = initial_area_type
                break
        bpy.ops.object.select_all(action='DESELECT') # Deselecciona todo en la escena
        for ob_simp14 in simpes:
            if ob_simp14 is not ob_simp and ob_simp14 is not ob_simp1 and ob_simp14 is not ob_simp2 and ob_simp14 is not ob_simp3 and ob_simp14 is not ob_simp4 and ob_simp14 is not ob_simp5 and ob_simp14 is not ob_simp6 and ob_simp14 is not ob_simp7 and ob_simp14 is not ob_simp8 and ob_simp14 is not ob_simp9 and ob_simp14 is not ob_simp10 and ob_simp14 is not ob_simp11 and ob_simp14 is not ob_simp12 and ob_simp14 is not ob_simp13 and ob_simp14 is not None:
                #if bpy.data.objects.get(simp1) is not None:
                op14 = (ob_simp14.name)
                print(op14)
                bpy.data.objects.get(op14).select_set(True)
                outline_simp14 = bpy.data.objects.get(op14)
                bpy.context.view_layer.objects.active = outline_simp14
                ob = bpy.context.selected_objects
                material_set = set()
                for object in bpy.context.selected_objects:
                    for material in object.material_slots:
                        material_set.add(material)
                for material in material_set:
                #    print(material.name)
                    Tex = material.name
                #  print(Tex+'_MainTex.png')
                    TexMain = Tex+'_MainTex.png'
                mat = bpy.data.materials[Tex]
                #Get the node in its node tree (replace the name below)
                node_to_delete =  mat.node_tree.nodes['Principled BSDF']
                node_to_delete2 =  mat.node_tree.nodes['Material Output']
                #Remove it
                mat.node_tree.nodes.remove( node_to_delete )
                mat.node_tree.nodes.remove( node_to_delete2 )
                imgsimple = ( bpimg('cf_m_emblem_MainTex.png.014'), bpimg('tenseigan'))
                for x in imgsimple:
                    if x is not None:
                        bpy.data.images['cf_m_emblem_MainTex.png.014'].name = TexMain
                        bpy.data.images[TexMain].filepath = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexMain
                        bpy.data.images[TexMain].filepath_raw = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexMain
                C = bpy.context

                def instantiate_group(nodes, data_block_name):
                    group = nodes.new(type='ShaderNodeGroup')
                    group.node_tree = bpy.data.node_groups['KK-Template Simple.014']
                    return group
                instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
                bpy.context.object.active_material.blend_method = 'CLIP'
                bpy.context.object.active_material.shadow_method = 'CLIP'
                my_mat = bpy.data.materials.get(Tex)
                bpy.data.node_groups['KK-Template Simple.014'].name = 'KK-Template S '+Tex
                node = bpy.data.node_groups['KK-Template S '+Tex]
                #node.extension = 'CLIP'
                #node.image = bpy.data.images[bakefinal.name]
                nodes = my_mat.node_tree.nodes
                for node in nodes:
                    node.select = False
                    node.select = True
                    nodes.active = node
                try:
                    initial_area_type = bpy.context.area.type
                    bpy.context.area.type = 'NODE_EDITOR'
                    bpy.context.area.ui_type = 'ShaderNodeTree'
                    bpy.ops.wm.redraw_timer(type='DRAW_WIN', iterations=1)
                    bpy.ops.node.group_ungroup()
                    bpy.ops.node.group_edit(exit=True)
                except Exception as e:
                    print(e)
                finally:
                    bpy.context.area.type = initial_area_type
                break
        bpy.ops.object.select_all(action='DESELECT') # Deselecciona todo en la escena
        for ob_simp15 in simpes:
            if ob_simp15 is not ob_simp and ob_simp15 is not ob_simp1 and ob_simp15 is not ob_simp2 and ob_simp15 is not ob_simp3 and ob_simp15 is not ob_simp4 and ob_simp15 is not ob_simp5 and ob_simp15 is not ob_simp6 and ob_simp15 is not ob_simp7 and ob_simp15 is not ob_simp8 and ob_simp15 is not ob_simp9 and ob_simp15 is not ob_simp10 and ob_simp15 is not ob_simp11 and ob_simp15 is not ob_simp12 and ob_simp15 is not ob_simp13 and ob_simp15 is not ob_simp14 and ob_simp15 is not None:
                #if bpy.data.objects.get(simp1) is not None:
                op15 = (ob_simp15.name)
                print(op15)
                bpy.data.objects.get(op15).select_set(True)
                outline_simp15 = bpy.data.objects.get(op15)
                bpy.context.view_layer.objects.active = outline_simp15
                ob = bpy.context.selected_objects
                material_set = set()
                for object in bpy.context.selected_objects:
                    for material in object.material_slots:
                        material_set.add(material)
                for material in material_set:
                #    print(material.name)
                    Tex = material.name
                #  print(Tex+'_MainTex.png')
                    TexMain = Tex+'_MainTex.png'
                mat = bpy.data.materials[Tex]
                #Get the node in its node tree (replace the name below)
                node_to_delete =  mat.node_tree.nodes['Principled BSDF']
                node_to_delete2 =  mat.node_tree.nodes['Material Output']
                #Remove it
                mat.node_tree.nodes.remove( node_to_delete )
                mat.node_tree.nodes.remove( node_to_delete2 )
                imgsimple = ( bpimg('cf_m_emblem_MainTex.png.015'), bpimg('tenseigan'))
                for x in imgsimple:
                    if x is not None:
                        bpy.data.images['cf_m_emblem_MainTex.png.015'].name = TexMain
                        bpy.data.images[TexMain].filepath = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexMain
                        bpy.data.images[TexMain].filepath_raw = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexMain
                C = bpy.context

                def instantiate_group(nodes, data_block_name):
                    group = nodes.new(type='ShaderNodeGroup')
                    group.node_tree = bpy.data.node_groups['KK-Template Simple.015']
                    return group
                instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
                bpy.context.object.active_material.blend_method = 'CLIP'
                bpy.context.object.active_material.shadow_method = 'CLIP'
                my_mat = bpy.data.materials.get(Tex)
                bpy.data.node_groups['KK-Template Simple.015'].name = 'KK-Template S '+Tex
                node = bpy.data.node_groups['KK-Template S '+Tex]
                #node.extension = 'CLIP'
                #node.image = bpy.data.images[bakefinal.name]
                nodes = my_mat.node_tree.nodes
                for node in nodes:
                    node.select = False
                    node.select = True
                    nodes.active = node
                try:
                    initial_area_type = bpy.context.area.type
                    bpy.context.area.type = 'NODE_EDITOR'
                    bpy.context.area.ui_type = 'ShaderNodeTree'
                    bpy.ops.wm.redraw_timer(type='DRAW_WIN', iterations=1)
                    bpy.ops.node.group_ungroup()
                    bpy.ops.node.group_edit(exit=True)
                except Exception as e:
                    print(e)
                finally:
                    bpy.context.area.type = initial_area_type
                break
        bpy.ops.object.select_all(action='DESELECT') # Deselecciona todo en la escena
        for ob_simp16 in simpes:
            if ob_simp16 is not ob_simp and ob_simp16 is not ob_simp1 and ob_simp16 is not ob_simp2 and ob_simp16 is not ob_simp3 and ob_simp16 is not ob_simp4 and ob_simp16 is not ob_simp5 and ob_simp16 is not ob_simp6 and ob_simp16 is not ob_simp7 and ob_simp16 is not ob_simp8 and ob_simp16 is not ob_simp9 and ob_simp16 is not ob_simp10 and ob_simp16 is not ob_simp11 and ob_simp16 is not ob_simp12 and ob_simp16 is not ob_simp13 and ob_simp16 is not ob_simp14 and ob_simp16 is not ob_simp15 and ob_simp16 is not None:
                #if bpy.data.objects.get(simp1) is not None:
                op16 = (ob_simp16.name)
                print(op16)
                bpy.data.objects.get(op16).select_set(True)
                outline_simp16 = bpy.data.objects.get(op16)
                bpy.context.view_layer.objects.active = outline_simp16
                ob = bpy.context.selected_objects
                material_set = set()
                for object in bpy.context.selected_objects:
                    for material in object.material_slots:
                        material_set.add(material)
                for material in material_set:
                #    print(material.name)
                    Tex = material.name
                #  print(Tex+'_MainTex.png')
                    TexMain = Tex+'_MainTex.png'
                mat = bpy.data.materials[Tex]
                #Get the node in its node tree (replace the name below)
                node_to_delete =  mat.node_tree.nodes['Principled BSDF']
                node_to_delete2 =  mat.node_tree.nodes['Material Output']
                #Remove it
                mat.node_tree.nodes.remove( node_to_delete )
                mat.node_tree.nodes.remove( node_to_delete2 )
                imgsimple = ( bpimg('cf_m_emblem_MainTex.png.016'), bpimg('tenseigan'))
                for x in imgsimple:
                    if x is not None:
                        bpy.data.images['cf_m_emblem_MainTex.png.016'].name = TexMain
                        bpy.data.images[TexMain].filepath = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexMain
                        bpy.data.images[TexMain].filepath_raw = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexMain
                C = bpy.context

                def instantiate_group(nodes, data_block_name):
                    group = nodes.new(type='ShaderNodeGroup')
                    group.node_tree = bpy.data.node_groups['KK-Template Simple.016']
                    return group
                instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
                bpy.context.object.active_material.blend_method = 'CLIP'
                bpy.context.object.active_material.shadow_method = 'CLIP'
                my_mat = bpy.data.materials.get(Tex)
                bpy.data.node_groups['KK-Template Simple.016'].name = 'KK-Template S '+Tex
                node = bpy.data.node_groups['KK-Template S '+Tex]
                #node.extension = 'CLIP'
                #node.image = bpy.data.images[bakefinal.name]
                nodes = my_mat.node_tree.nodes
                for node in nodes:
                    node.select = False
                    node.select = True
                    nodes.active = node
                try:
                    initial_area_type = bpy.context.area.type
                    bpy.context.area.type = 'NODE_EDITOR'
                    bpy.context.area.ui_type = 'ShaderNodeTree'
                    bpy.ops.wm.redraw_timer(type='DRAW_WIN', iterations=1)
                    bpy.ops.node.group_ungroup()
                    bpy.ops.node.group_edit(exit=True)
                except Exception as e:
                    print(e)
                finally:
                    bpy.context.area.type = initial_area_type
                break
        bpy.ops.object.select_all(action='DESELECT') # Deselecciona todo en la escena
        for ob_simp17 in simpes:
            if ob_simp17 is not ob_simp and ob_simp17 is not ob_simp1 and ob_simp17 is not ob_simp2 and ob_simp17 is not ob_simp3 and ob_simp17 is not ob_simp4 and ob_simp17 is not ob_simp5 and ob_simp17 is not ob_simp6 and ob_simp17 is not ob_simp7 and ob_simp17 is not ob_simp8 and ob_simp17 is not ob_simp9 and ob_simp17 is not ob_simp10 and ob_simp17 is not ob_simp11 and ob_simp17 is not ob_simp12 and ob_simp17 is not ob_simp13 and ob_simp17 is not ob_simp14 and ob_simp17 is not ob_simp15 and ob_simp17 is not ob_simp16 and ob_simp17 is not None:
                #if bpy.data.objects.get(simp1) is not None:
                op17 = (ob_simp17.name)
                print(op17)
                bpy.data.objects.get(op17).select_set(True)
                outline_simp17 = bpy.data.objects.get(op17)
                bpy.context.view_layer.objects.active = outline_simp17
                ob = bpy.context.selected_objects
                material_set = set()
                for object in bpy.context.selected_objects:
                    for material in object.material_slots:
                        material_set.add(material)
                for material in material_set:
                #    print(material.name)
                    Tex = material.name
                #  print(Tex+'_MainTex.png')
                    TexMain = Tex+'_MainTex.png'
                mat = bpy.data.materials[Tex]
                #Get the node in its node tree (replace the name below)
                node_to_delete =  mat.node_tree.nodes['Principled BSDF']
                node_to_delete2 =  mat.node_tree.nodes['Material Output']
                #Remove it
                mat.node_tree.nodes.remove( node_to_delete )
                mat.node_tree.nodes.remove( node_to_delete2 )
                imgsimple = ( bpimg('cf_m_emblem_MainTex.png.017'), bpimg('tenseigan'))
                for x in imgsimple:
                    if x is not None:
                        bpy.data.images['cf_m_emblem_MainTex.png.017'].name = TexMain
                        bpy.data.images[TexMain].filepath = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexMain
                        bpy.data.images[TexMain].filepath_raw = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexMain
                C = bpy.context

                def instantiate_group(nodes, data_block_name):
                    group = nodes.new(type='ShaderNodeGroup')
                    group.node_tree = bpy.data.node_groups['KK-Template Simple.017']
                    return group
                instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
                bpy.context.object.active_material.blend_method = 'CLIP'
                bpy.context.object.active_material.shadow_method = 'CLIP'
                my_mat = bpy.data.materials.get(Tex)
                bpy.data.node_groups['KK-Template Simple.017'].name = 'KK-Template S '+Tex
                node = bpy.data.node_groups['KK-Template S '+Tex]
                #node.extension = 'CLIP'
                #node.image = bpy.data.images[bakefinal.name]
                nodes = my_mat.node_tree.nodes
                for node in nodes:
                    node.select = False
                    node.select = True
                    nodes.active = node
                try:
                    initial_area_type = bpy.context.area.type
                    bpy.context.area.type = 'NODE_EDITOR'
                    bpy.context.area.ui_type = 'ShaderNodeTree'
                    bpy.ops.wm.redraw_timer(type='DRAW_WIN', iterations=1)
                    bpy.ops.node.group_ungroup()
                    bpy.ops.node.group_edit(exit=True)
                except Exception as e:
                    print(e)
                finally:
                    bpy.context.area.type = initial_area_type
                break
        bpy.ops.object.select_all(action='DESELECT') # Deselecciona todo en la escena
        for ob_simp18 in simpes:
            if ob_simp18 is not ob_simp and ob_simp18 is not ob_simp1 and ob_simp18 is not ob_simp2 and ob_simp18 is not ob_simp3 and ob_simp18 is not ob_simp4 and ob_simp18 is not ob_simp5 and ob_simp18 is not ob_simp6 and ob_simp18 is not ob_simp7 and ob_simp18 is not ob_simp8 and ob_simp18 is not ob_simp9 and ob_simp18 is not ob_simp10 and ob_simp18 is not ob_simp11 and ob_simp18 is not ob_simp12 and ob_simp18 is not ob_simp13 and ob_simp18 is not ob_simp14 and ob_simp18 is not ob_simp15 and ob_simp18 is not ob_simp16 and ob_simp18 is not ob_simp17 and ob_simp18 is not None:
                #if bpy.data.objects.get(simp1) is not None:
                op18 = (ob_simp18.name)
                print(op18)
                bpy.data.objects.get(op18).select_set(True)
                outline_simp18 = bpy.data.objects.get(op18)
                bpy.context.view_layer.objects.active = outline_simp18
                ob = bpy.context.selected_objects
                material_set = set()
                for object in bpy.context.selected_objects:
                    for material in object.material_slots:
                        material_set.add(material)
                for material in material_set:
                #    print(material.name)
                    Tex = material.name
                #  print(Tex+'_MainTex.png')
                    TexMain = Tex+'_MainTex.png'
                mat = bpy.data.materials[Tex]
                #Get the node in its node tree (replace the name below)
                node_to_delete =  mat.node_tree.nodes['Principled BSDF']
                node_to_delete2 =  mat.node_tree.nodes['Material Output']
                #Remove it
                mat.node_tree.nodes.remove( node_to_delete )
                mat.node_tree.nodes.remove( node_to_delete2 )
                imgsimple = ( bpimg('cf_m_emblem_MainTex.png.018'), bpimg('tenseigan'))
                for x in imgsimple:
                    if x is not None:
                        bpy.data.images['cf_m_emblem_MainTex.png.018'].name = TexMain
                        bpy.data.images[TexMain].filepath = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexMain
                        bpy.data.images[TexMain].filepath_raw = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexMain
                C = bpy.context

                def instantiate_group(nodes, data_block_name):
                    group = nodes.new(type='ShaderNodeGroup')
                    group.node_tree = bpy.data.node_groups['KK-Template Simple.018']
                    return group
                instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
                bpy.context.object.active_material.blend_method = 'CLIP'
                bpy.context.object.active_material.shadow_method = 'CLIP'
                my_mat = bpy.data.materials.get(Tex)
                bpy.data.node_groups['KK-Template Simple.018'].name = 'KK-Template S '+Tex
                node = bpy.data.node_groups['KK-Template S '+Tex]
                #node.extension = 'CLIP'
                #node.image = bpy.data.images[bakefinal.name]
                nodes = my_mat.node_tree.nodes
                for node in nodes:
                    node.select = False
                    node.select = True
                    nodes.active = node
                try:
                    initial_area_type = bpy.context.area.type
                    bpy.context.area.type = 'NODE_EDITOR'
                    bpy.context.area.ui_type = 'ShaderNodeTree'
                    bpy.ops.wm.redraw_timer(type='DRAW_WIN', iterations=1)
                    bpy.ops.node.group_ungroup()
                    bpy.ops.node.group_edit(exit=True)
                except Exception as e:
                    print(e)
                finally:
                    bpy.context.area.type = initial_area_type
                break
        bpy.ops.object.select_all(action='DESELECT') # Deselecciona todo en la escena
        for ob_simp19 in simpes:
            if ob_simp19 is not ob_simp and ob_simp19 is not ob_simp1 and ob_simp19 is not ob_simp2 and ob_simp19 is not ob_simp3 and ob_simp19 is not ob_simp4 and ob_simp19 is not ob_simp5 and ob_simp19 is not ob_simp6 and ob_simp19 is not ob_simp7 and ob_simp19 is not ob_simp8 and ob_simp19 is not ob_simp9 and ob_simp19 is not ob_simp10 and ob_simp19 is not ob_simp11 and ob_simp19 is not ob_simp12 and ob_simp19 is not ob_simp13 and ob_simp19 is not ob_simp14 and ob_simp19 is not ob_simp15 and ob_simp19 is not ob_simp16 and ob_simp19 is not ob_simp17 and ob_simp19 is not ob_simp18 and ob_simp19 is not None:
                #if bpy.data.objects.get(simp1) is not None:
                op19 = (ob_simp19.name)
                print(op19)
                bpy.data.objects.get(op19).select_set(True)
                outline_simp19 = bpy.data.objects.get(op19)
                bpy.context.view_layer.objects.active = outline_simp19
                ob = bpy.context.selected_objects
                material_set = set()
                for object in bpy.context.selected_objects:
                    for material in object.material_slots:
                        material_set.add(material)
                for material in material_set:
                #    print(material.name)
                    Tex = material.name
                #  print(Tex+'_MainTex.png')
                    TexMain = Tex+'_MainTex.png'
                mat = bpy.data.materials[Tex]
                #Get the node in its node tree (replace the name below)
                node_to_delete =  mat.node_tree.nodes['Principled BSDF']
                node_to_delete2 =  mat.node_tree.nodes['Material Output']
                #Remove it
                mat.node_tree.nodes.remove( node_to_delete )
                mat.node_tree.nodes.remove( node_to_delete2 )
                imgsimple = ( bpimg('cf_m_emblem_MainTex.png.019'), bpimg('tenseigan'))
                for x in imgsimple:
                    if x is not None:
                        bpy.data.images['cf_m_emblem_MainTex.png.019'].name = TexMain
                        bpy.data.images[TexMain].filepath = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexMain
                        bpy.data.images[TexMain].filepath_raw = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\20220515224641_Chika_Haruno\\Textures\\"+TexMain
                C = bpy.context

                def instantiate_group(nodes, data_block_name):
                    group = nodes.new(type='ShaderNodeGroup')
                    group.node_tree = bpy.data.node_groups['KK-Template Simple.019']
                    return group
                instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
                bpy.context.object.active_material.blend_method = 'CLIP'
                bpy.context.object.active_material.shadow_method = 'CLIP'
                my_mat = bpy.data.materials.get(Tex)
                bpy.data.node_groups['KK-Template Simple.019'].name = 'KK-Template S '+Tex
                node = bpy.data.node_groups['KK-Template S '+Tex]
                #node.extension = 'CLIP'
                #node.image = bpy.data.images[bakefinal.name]
                nodes = my_mat.node_tree.nodes
                for node in nodes:
                    node.select = False
                    node.select = True
                    nodes.active = node
                try:
                    initial_area_type = bpy.context.area.type
                    bpy.context.area.type = 'NODE_EDITOR'
                    bpy.context.area.ui_type = 'ShaderNodeTree'
                    bpy.ops.wm.redraw_timer(type='DRAW_WIN', iterations=1)
                    bpy.ops.node.group_ungroup()
                    bpy.ops.node.group_edit(exit=True)
                except Exception as e:
                    print(e)
                finally:
                    bpy.context.area.type = initial_area_type
                break
        bpy.ops.object.select_all(action='DESELECT') # Deselecciona todo en la escena
        #############################################################################
        #mesh = [m for m in bpy.context.scene.objects if m.type == 'MESH']
        #for obj in bpy.data.objects:
        #    if obj.name.startswith("cf_hair") is not obj.name.startswith("cf_hair_sklx"):
        #        obj.select_set(state=True)
        #        bpy.context.view_layer.objects.active = obj
        #        bpy.context.object.active_material.blend_method = 'CLIP'
        #        bpy.context.object.active_material.shadow_method = 'CLIP'
        #        bpy.ops.object.join()
        #        obj.name = 'cf_hair_sklx'
        #    continue
        #        
        #bpy.ops.object.select_all(action='DESELECT') # Deselecciona todo en la escena
        #################################OUTLINE SECTION#############################
        #################################OUTLINE SECTION#############################
        #################################OUTLINE SECTION#############################
        #----------------------------------------------------------------------------
        for x in hairfronts:
            if x is not None:
                x.select_set(True)
                bpy.context.view_layer.objects.active = x
                bpy.ops.object.material_slot_add()
                ob = bpy.context.selected_objects
                # Get material
                mat = bpy.data.materials.get("KK-Template Outline")
                #if mat is None:
                # create material
                #    mat = bpy.data.materials.new(name="KK-Template Bra Outline")
                # Assign it to object
                for i, val in enumerate(ob):
                    #assign it to object
                    if ob[i].data.materials:
                        #asign to 1st material slot
                        ob[i].data.materials[-1] = mat
                    else:
                        #no slots
                        ob[i].data.materials.append(mat)
                bpy.ops.object.modifier_add(type='SOLIDIFY')
                modsetting = x.modifiers['Solidify']
                modsetting.thickness = 0.00069
                modsetting.offset = 1
                modsetting.use_rim = False
                modsetting.use_flip_normals = True
                modsetting.use_quality_normals = True
                modsetting.material_offset = 69
                modsetting.name = 'Outline Modifier'
        bpy.ops.object.select_all(action='DESELECT') # Deselecciona todo en la escena
        #----------------------------------------------------------------------------
        for x in hairbacks:
            if x is not None:
                x.select_set(True)
                bpy.context.view_layer.objects.active = x
                bpy.ops.object.material_slot_add()
                ob = bpy.context.selected_objects
                # Get material
                mat = bpy.data.materials.get("KK-Template Outline")
                #if mat is None:
                # create material
                #    mat = bpy.data.materials.new(name="KK-Template Bra Outline")
                # Assign it to object
                for i, val in enumerate(ob):
                    #assign it to object
                    if ob[i].data.materials:
                        #asign to 1st material slot
                        ob[i].data.materials[-1] = mat
                    else:
                        #no slots
                        ob[i].data.materials.append(mat)
                bpy.ops.object.modifier_add(type='SOLIDIFY')
                modsetting = x.modifiers['Solidify']
                modsetting.thickness = 0.00069
                modsetting.offset = 1
                modsetting.use_rim = False
                modsetting.use_flip_normals = True
                modsetting.use_quality_normals = True
                modsetting.material_offset = 69
                modsetting.name = 'Outline Modifier'
        bpy.ops.object.select_all(action='DESELECT') # Deselecciona todo en la escena
        ##################################OUTLINE BODY###############################
        # Get body object
        for x in bodies:
            if x is not None:
                #if bpy.data.objects.get(body1) is not None:
                op = (x.name)
                bpy.data.objects.get(op).select_set(True)
                outline_body = bpy.data.objects.get(op)
                bpy.context.view_layer.objects.active = outline_body
                bpy.ops.object.select_all(action='DESELECT') # Deselecciona todo en la escena
                #Get Body object
                #if bpy.data.objects.get(body1) is not None:
                #    bpy.data.objects.get(body1).select_set(True)
                #    bpy.context.view_layer.objects.active = bpy.data.objects.get('body1')
                #    bpy.ops.object.material_slot_add()
                #if bpy.data.objects.get('body2') is not None:
                #    bpy.data.objects.get('body2').select_set(True)
                #    bpy.context.view_layer.objects.active = bpy.data.objects.get('body2')
                #    bpy.ops.object.material_slot_add()
                if outline_body is not None:
                    outline_body.select_set(True)
                    bpy.context.view_layer.objects.active = outline_body
                    bpy.ops.object.material_slot_add()
                ob = bpy.context.selected_objects
                # Get material
                mat = bpy.data.materials.get("KK-Template Body Outline")
                #if mat is None:
                    # create material
                #    mat = bpy.data.materials.new(name="KK-Template Body Outline")
                # Assign it to object
                for i, val in enumerate(ob):
                    #assign it to object
                    if ob[i].data.materials:
                        #asign to 1st material slot
                        ob[i].data.materials[-1] = mat
                    else:
                        #no slots
                        ob[i].data.materials.append(mat)
                bpy.ops.object.select_all(action='DESELECT') # Deselecciona todo en la escena
                # Outline Modifier
                if outline_body is not None:
                #    bpy.context.view_layer.objects.active = bpy.data.objects.get('o_body_a')
                    bpy.ops.object.modifier_add(type='SOLIDIFY')
                    modsetting = outline_body.modifiers['Solidify']
                    modsetting.thickness = 0.0005
                    modsetting.offset = 1
                    modsetting.use_rim = False
                    modsetting.use_flip_normals = True
                    modsetting.use_quality_normals = True
                    modsetting.material_offset = 69
                    modsetting.name = 'Outline Body Modifier'
        bpy.ops.object.select_all(action='DESELECT') # Deselecciona todo en la escena
        #################################OUTLINE BRA#################################
        # Get bra object
        for x in brasiers:
            if x is not None:
                #if bpy.data.objects.get(body1) is not None:
                op = (x.name)
                bpy.data.objects.get(op).select_set(True)
                outline_bra = bpy.data.objects.get(op)
                bpy.context.view_layer.objects.active = outline_bra
                bpy.ops.object.select_all(action='DESELECT') # Deselecciona todo en la escena
                #Get Bra object
                if outline_bra is not None:
                    outline_bra.select_set(True)
                    bpy.context.view_layer.objects.active = outline_bra
                    bpy.ops.object.material_slot_add()
                ob = bpy.context.selected_objects
                # Get material
                mat = bpy.data.materials.get("KK-Template Bra Outline")
                #if mat is None:
                # create material
                #    mat = bpy.data.materials.new(name="KK-Template Bra Outline")
                # Assign it to object
                for i, val in enumerate(ob):
                    #assign it to object
                    if ob[i].data.materials:
                        #asign to 1st material slot
                        ob[i].data.materials[-1] = mat
                    else:
                        #no slots
                        ob[i].data.materials.append(mat)
                bpy.ops.object.select_all(action='DESELECT') # Deselecciona todo en la escena
                # Outline Modifier
                if outline_bra is not None:
                #    bpy.context.view_layer.objects.active = bpy.data.objects.get('o_bra_a')
                    bpy.ops.object.modifier_add(type='SOLIDIFY')
                    modsetting = outline_bra.modifiers['Solidify']
                    modsetting.thickness = 0.0005
                    modsetting.offset = 1
                    modsetting.use_rim = False
                    modsetting.use_flip_normals = True
                    modsetting.use_quality_normals = True
                    modsetting.material_offset = 69
                    modsetting.name = 'Outline Bra Modifier'
        bpy.ops.object.select_all(action='DESELECT') # Deselecciona todo en la escena
        #################################OUTLINE PANTS###############################
        # Get PANTS object
        for x in pantes:
            if x is not None:
                #if bpy.data.objects.get(body1) is not None:
                op = (x.name)
                bpy.data.objects.get(op).select_set(True)
                outline_pants = bpy.data.objects.get(op)
                bpy.context.view_layer.objects.active = outline_pants
                bpy.ops.object.select_all(action='DESELECT') # Deselecciona todo en la escena
                #Get other objects
                if outline_pants is not None:
                    outline_pants.select_set(True)
                    bpy.context.view_layer.objects.active = outline_pants
                    bpy.ops.object.material_slot_add()
                ob = bpy.context.selected_objects
                # Get material
                mat = bpy.data.materials.get("KK-Template Outline")
                #if mat is None:
                    # create material
                #    mat = bpy.data.materials.new(name="KK-Template Bra Outline")
                # Assign it to object
                for i, val in enumerate(ob):
                    #assign it to object
                    if ob[i].data.materials:
                        #asign to 1st material slot
                        ob[i].data.materials[-1] = mat
                    else:
                        #no slots
                        ob[i].data.materials.append(mat)
                bpy.ops.object.select_all(action='DESELECT') # Deselecciona todo en la escena
                        # Outline Modifier
                if outline_pants is not None:
                #    bpy.context.view_layer.objects.active = bpy.data.objects.get('o_bra_a')
                    bpy.ops.object.modifier_add(type='SOLIDIFY')
                    modsetting = outline_pants.modifiers['Solidify']
                    modsetting.thickness = 0.0005
                    modsetting.offset = 1
                    modsetting.use_rim = False
                    modsetting.use_flip_normals = True
                    modsetting.use_quality_normals = True
                    modsetting.material_offset = 69
                    modsetting.name = 'Outline Bot Modifier'
        bpy.ops.object.select_all(action='DESELECT') # Deselecciona todo en la escena
        #################################OUTLINE CLOTH###############################
        for x in ropitas:
            if x is not None:
                #if bpy.data.objects.get(body1) is not None:
                op = (x.name)
                bpy.data.objects.get(op).select_set(True)
                outline_ropa = bpy.data.objects.get(op)
                bpy.context.view_layer.objects.active = outline_ropa
                bpy.ops.object.select_all(action='DESELECT') # Deselecciona todo en la escena
                #Get other objects
                if outline_ropa is not None:
                    outline_ropa.select_set(True)
                    bpy.context.view_layer.objects.active = outline_ropa
                    bpy.ops.object.material_slot_add()
                ob = bpy.context.selected_objects
                # Get material
                mat = bpy.data.materials.get("KK-Template Outline")
                #if mat is None:
                    # create material
                #    mat = bpy.data.materials.new(name="KK-Template Bra Outline")
                # Assign it to object
                for i, val in enumerate(ob):
                    #assign it to object
                    if ob[i].data.materials:
                        #asign to 1st material slot
                        ob[i].data.materials[-1] = mat
                    else:
                        #no slots
                        ob[i].data.materials.append(mat)
                bpy.ops.object.select_all(action='DESELECT') # Deselecciona todo en la escena
                        # Outline Modifier
                if outline_ropa is not None:
                #    bpy.context.view_layer.objects.active = bpy.data.objects.get('o_bra_a')
                    bpy.ops.object.modifier_add(type='SOLIDIFY')
                    modsetting = outline_ropa.modifiers['Solidify']
                    modsetting.thickness = 0.00069
                    modsetting.offset = 1
                    modsetting.use_rim = False
                    modsetting.use_flip_normals = True
                    modsetting.use_quality_normals = True
                    modsetting.material_offset = 69
                    modsetting.name = 'Outline Top Modifier'
        bpy.ops.object.select_all(action='DESELECT') # Deselecciona todo en la escena
        ##################################OUTLINE FACE###############################
        # Get body object
        for x in faces:
            if x is not None:
                #if bpy.data.objects.get(body1) is not None:
                op = (x.name)
                bpy.data.objects.get(op).select_set(True)
                outline_face = bpy.data.objects.get(op)
                bpy.context.view_layer.objects.active = outline_face
                bpy.ops.object.select_all(action='DESELECT') # Deselecciona todo en la escena
                #Get Body object
                #if bpy.data.objects.get(body1) is not None:
                #    bpy.data.objects.get(body1).select_set(True)
                #    bpy.context.view_layer.objects.active = bpy.data.objects.get('body1')
                #    bpy.ops.object.material_slot_add()
                #if bpy.data.objects.get('body2') is not None:
                #    bpy.data.objects.get('body2').select_set(True)
                #    bpy.context.view_layer.objects.active = bpy.data.objects.get('body2')
                #    bpy.ops.object.material_slot_add()
                if outline_face is not None:
                    outline_face.select_set(True)
                    bpy.context.view_layer.objects.active = outline_face
                    bpy.ops.object.material_slot_add()
                ob = bpy.context.selected_objects
                # Get material
                mat = bpy.data.materials.get("KK-Template Outline")
                #if mat is None:
                    # create material
                #    mat = bpy.data.materials.new(name="KK-Template Body Outline")
                # Assign it to object
                for i, val in enumerate(ob):
                    #assign it to object
                    if ob[i].data.materials:
                        #asign to 1st material slot
                        ob[i].data.materials[-1] = mat
                    else:
                        #no slots
                        ob[i].data.materials.append(mat)
                bpy.ops.object.select_all(action='DESELECT') # Deselecciona todo en la escena
                # Outline Modifier
                if outline_face is not None:
                #    bpy.context.view_layer.objects.active = bpy.data.objects.get('o_body_a')
                    bpy.ops.object.modifier_add(type='SOLIDIFY')
                    modsetting = outline_face.modifiers['Solidify']
                    modsetting.thickness = 0.0005
                    modsetting.offset = 0.33
                    modsetting.use_rim = False
                    modsetting.use_flip_normals = True
                    modsetting.use_quality_normals = True
                    modsetting.material_offset = 69
                    modsetting.name = 'Outline Modifier'
        bpy.ops.object.select_all(action='DESELECT') # Deselecciona todo en la escena
        #############################################################################
        MatFace = MatFace
        bpy.ops.object.select_all(action='DESELECT')
        bpy.ops.mesh.primitive_cube_add(size=2, enter_editmode=False, align='WORLD', location=(0, 0, 0), scale=(0.1, 0.1, 0.14))
        bpy.ops.object.transform_apply(location=True, rotation=False, scale=True)
        #bpy.data.objects.get('Armature').select_set(True)
        bpy.data.objects['Armature'].hide_viewport = False
        face_rig = bpy.data.objects.get('Armature')
        bpy.context.view_layer.objects.active = face_rig
        ob = bpy.data.objects['Cube']
        arma = bpy.data.objects['Armature']
        bpy.ops.object.select_all(action='DESELECT')
        arma.select_set(True)
        bpy.ops.object.mode_set(mode='EDIT')
        bpy.ops.armature.select_all(action='DESELECT')
        bpy.context.object.data.edit_bones['cf_J_FaceUp_ty'].select = True
        arm = bpy.data.armatures['Armature']
        bone = arm.edit_bones["cf_J_FaceUp_ty"]
        arm.edit_bones.active = bone
        bpy.ops.object.mode_set(mode='OBJECT')
        bpy.ops.object.select_all(action='DESELECT') #deselect all objects
        ob.select_set(True)
        arma.select_set(True)
        bpy.context.view_layer.objects.active = arma    #the active object will be the parent of all selected object
        bpy.ops.object.parent_set(type='BONE', keep_transform=True)
        bpy.ops.object.select_all(action='DESELECT') #deselect all objects
        bpy.context.view_layer.objects.active = ob
        bpy.context.object.display_type = 'WIRE'
        bpy.ops.object.constraint_add(type='COPY_LOCATION')
        bpy.context.object.constraints["Copy Location"].target = bpy.data.objects["Armature"]
        bpy.context.object.constraints["Copy Location"].subtarget = "cf_J_FaceUp_ty"
        bpy.context.scene.objects.get('Cube').hide_render = True
        #bpy.context.scene.objects.get('Cube').hide_set(True)
        bpy.context.object.constraints["Copy Location"].enabled = False
        bpy.data.objects.get('Cube').name = 'Shadow Box'
        bpy.data.materials[MatFace].node_tree.nodes["Texture Coordinate.002"].object = bpy.data.objects["Shadow Box"]
        print('shadow cube done')
        #--- Eliminate Material Duplicates

        def eliminate_materials():
            print("\nEliminate Material Duplicates:")
            #--- Search for mat. slots in all objects
            mats = bpy.data.materials
            for obj in bpy.data.objects:
                for slot in obj.material_slots:
                    # Get the material name as 3-tuple (base, separator, extension)
                    (base, sep, ext) = slot.name.rpartition('.')
                    # Replace the numbered duplicate with the original if found
                    if ext.isnumeric():
                        if base in mats:
                            print("  For object '%s' replace '%s' with '%s'" % (obj.name, slot.name, base))
                            slot.material = mats.get(base)
        #--- Execute
        eliminate_materials()
        #bpy.ops.object.select_all(action='DESELECT')
        #bpy.data.objects.get('Armature.001').select_set(True)
        #armatureobject = bpy.data.objects.get('Armature.001')
        #bpy.context.view_layer.objects.active = armatureobject
        #bpy.ops.object.delete()
        #bpy.ops.object.select_all(action='DESELECT')
        #bpy.data.objects.get('Cube.001').select_set(True)
        #Cubeobject = bpy.data.objects.get('Cube.001')
        #bpy.context.view_layer.objects.active = Cubeobject
        #bpy.ops.object.delete()
        bpy.data.armatures['Armature'].display_type = "STICK"
        bpy.ops.file.find_missing_files('INVOKE_DEFAULT')
        return {"FINISHED"}

    def invoke(self, context, event):
        return self.execute(context)


class SNA_OT_Animeoutline_D89C9(bpy.types.Operator):
    bl_idname = "sna.animeoutline_d89c9"
    bl_label = "anime-outline"
    bl_description = "OUTLINE"
    bl_options = {"REGISTER", "UNDO"}

    @classmethod
    def poll(cls, context):
        return not False

    def execute(self, context):
        for object in bpy.context.selected_objects:
            outline_ropa = bpy.data.objects.get(object.name)
            bpy.context.view_layer.objects.active = outline_ropa
            bpy.ops.object.select_all(action='DESELECT') # Deselecciona todo en la escena
        #Get other objects
        if outline_ropa is not None:
            outline_ropa.select_set(True)
            bpy.context.view_layer.objects.active = outline_ropa
            bpy.ops.object.material_slot_add()
        ob = bpy.context.selected_objects
                # Get material
        mat = bpy.data.materials.get("KK-Template Outline")
                #if mat is None:
                    # create material
        #    mat = bpy.data.materials.new(name="KK-Template Bra Outline")
        # Assign it to object
        for i, val in enumerate(ob):
            #assign it to object
            if ob[i].data.materials:
                #asign to 1st material slot
                ob[i].data.materials[-1] = mat
            else:
                #no slots
                ob[i].data.materials.append(mat)
        bpy.ops.object.select_all(action='DESELECT') # Deselecciona todo en la escena
                 # Outline Modifier
        if outline_ropa is not None:
        #    bpy.context.view_layer.objects.active = bpy.data.objects.get('o_bra_a')
            bpy.ops.object.modifier_add(type='SOLIDIFY')
            modsetting = outline_ropa.modifiers['Solidify']
            modsetting.thickness = 0.0005
            modsetting.offset = 1
            modsetting.use_rim = False
            modsetting.use_flip_normals = True
            modsetting.use_quality_normals = True
            modsetting.material_offset = 69
            modsetting.name = 'Outline Modifier'
        return {"FINISHED"}

    def invoke(self, context, event):
        return self.execute(context)


class SNA_OT_Kkptop_08379(bpy.types.Operator):
    bl_idname = "sna.kkptop_08379"
    bl_label = "kkp-top"
    bl_description = ""
    bl_options = {"REGISTER", "UNDO"}

    @classmethod
    def poll(cls, context):
        return not False

    def execute(self, context):
        import os
        ########################################################################
        my_mat = bpy.context.object.material_slots[0].material
        print(my_mat.name)
        Tex=my_mat.name
        rem_mat = bpy.data.materials[Tex]
        #Get the node in its node tree (replace the name below)
        node_to_delete =  rem_mat.node_tree.nodes['Principled BSDF']
        node_to_delete2 =  rem_mat.node_tree.nodes['Material Output']
        #Remove it
        rem_mat.node_tree.nodes.remove(node_to_delete)
        rem_mat.node_tree.nodes.remove(node_to_delete2)
        #Tex = material.name
        TexMain = Tex+'_MainTex.png'
        TexDetailM = Tex+'_DetailMask.png'
        TexNormal = Tex+'_NormalMap.png'
        TexNDetail = Tex+'_NormalMapDetail.png'
        TexAlphaM = Tex+'_AlphaMask.png'
        TexAnotherR = Tex+'_AnotherRamp.png'
        TexLiquidM = Tex+'_liquidmask.png'
        TexTex2 = Tex+'_Texture2.png'
        TexTex3 = Tex+'_Texture3.png'
        TexOv1 = Tex+'_overtex1.png'
        TexOv2 = Tex+'_overtex2.png'
        TexLineM = Tex+'_LineMask.png'
        TexColorM = Tex+'_ColorMask.png'
        TexHairG = Tex+'_HairGloss.png'
        TexBump = Tex+'_BumpMap.png'
        TexDNM = Tex+'_DetailNormalMap.png'
        TexBNM = Tex+'_BlendNormalMap.png'
        TexSGM = Tex+'_SpecGlossMap.png'
        TexOM = Tex+'_OcclusionMap.png'
        TexTSS = Tex+'_Thickness.png'
        TexMGM = Tex+'_MetallicGlossMap.png'
        TexOV = Tex+'_OverTex.png'
        originaltex = 'cf_m_top_jacket06_'
        #originaltss = 'cf_m_body_01_'
        #kkp
        nm = originaltex+'NormalMap.png'
        nd = originaltex+'NormalMapDetail.png'
        dm = originaltex+'DetailMask.png'
        mm = originaltex+'MainTex.png'
        t3 = originaltex+'Texture3.png'
        t2 = originaltex+'Texture2.png'
        am = originaltex+'AlphaMask.png'
        lm = originaltex+'liquidmask.png'
        ar = originaltex+'AnotherRamp.png'
        ov1 = originaltex+'overtex1.png'
        ov2 = originaltex+'overtex2.png'
        lnm = originaltex+'LineMask.png'
        com = originaltex+'ColorMask.png'
        glo = originaltex+'HairGloss.png'
        #hs1
        bum = originaltex+'BumpMap.png'
        dnm = originaltex+'DetailNormalMap.png'
        bnm = originaltex+'BlendNormalMap.png'
        sgm = originaltex+'SpecGlossMap.png'
        om = originaltex+'OcclusionMap.png'
        tss = originaltex+'Thickness.png'
        mgm = originaltex+'MetallicGlossMap.png'
        ov = originaltex+'OverTex.png'
        Template='KK-Template Sachi'
        CTemplate=Template+' '
        C = bpy.context

        def instantiate_group(nodes, data_block_name):
            group = nodes.new(type='ShaderNodeGroup')
            group.node_tree = bpy.data.node_groups[Template]
            return group
        if Template in bpy.data.node_groups:
            instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
        else:
        #    versions = ( t0, t1, t2, t3, t4)
        #    for x in versions:
        #        if os.path.isdir(x) and os.access(x, os.R_OK):
            if (3, 0, 0) <= bpy.app.version < (3, 0, 99):
                before_data = list(bpy.data.node_groups)
                bpy.ops.wm.append(directory=os.path.expanduser(r"~\AppData\Roaming\Blender Foundation\Blender\3.0\scripts\addons\sklx_creator\assets\KK_Template_Shader.blend") + r'\NodeTree',filename=Template,link=False)
                new_data=list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
                appended_2B5AC = None if not new_data else new_data[0]
                instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
            else:
                if (3, 1, 0) <= bpy.app.version < (3, 1, 99):
                    before_data = list(bpy.data.node_groups)
                    bpy.ops.wm.append(directory=os.path.expanduser(r"~\AppData\Roaming\Blender Foundation\Blender\3.1\scripts\addons\sklx_creator\assets\KK_Template_Shader.blend") + r'\NodeTree',filename=Template,link=False)
                    new_data=list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
                    appended_2B5AC = None if not new_data else new_data[0]
                    instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
                else:
                    if (3, 2, 0) <= bpy.app.version < (3, 2, 99):
                        before_data = list(bpy.data.node_groups)
                        bpy.ops.wm.append(directory=os.path.expanduser(r"~\AppData\Roaming\Blender Foundation\Blender\3.2\scripts\addons\sklx_creator\assets\KK_Template_Shader.blend") + r'\NodeTree',filename=Template,link=False)
                        new_data=list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
                        appended_2B5AC = None if not new_data else new_data[0]
                        instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
                    else:
                        if (3, 3, 0) <= bpy.app.version < (3, 3, 99):
                            before_data = list(bpy.data.node_groups)
                            bpy.ops.wm.append(directory=os.path.expanduser(r"~\AppData\Roaming\Blender Foundation\Blender\3.3\scripts\addons\sklx_creator\assets\KK_Template_Shader.blend") + r'\NodeTree',filename=Template,link=False)
                            new_data=list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
                            appended_2B5AC = None if not new_data else new_data[0]
                            instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
                        else:
                            if (3, 4, 0) <= bpy.app.version < (3, 4, 99):
                                before_data = list(bpy.data.node_groups)
                                bpy.ops.wm.append(directory=os.path.expanduser(r"~\AppData\Roaming\Blender Foundation\Blender\3.4\scripts\addons\sklx_creator\assets\KK_Template_Shader.blend") + r'\NodeTree',filename=Template,link=False)
                                new_data=list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
                                appended_2B5AC = None if not new_data else new_data[0]
                                instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
        bpy.data.node_groups[Template].name = CTemplate+Tex
        node = bpy.data.node_groups[CTemplate+Tex]
        #initial_area_type = bpy.context.area.type
        #bpy.context.area.type = 'NODE_EDITOR'
        #bpy.context.area.ui_type = 'ShaderNodeTree'
        #bpy.ops.wm.redraw_timer(type='DRAW_WIN', iterations=1)
        #bpy.ops.node.group_ungroup()
        #bpy.ops.node.group_edit(exit=True)
        #bpy.context.area.type = initial_area_type
        nodes = my_mat.node_tree.nodes
        for node in nodes:
            #node.select = False
            print(node.name)
            node.select = True
            nodes.active = node
        try:
            initial_area_type = bpy.context.area.type
            bpy.context.area.type = 'NODE_EDITOR'
            bpy.context.area.ui_type = 'ShaderNodeTree'
            bpy.ops.wm.redraw_timer(type='DRAW_WIN', iterations=1)
            bpy.ops.node.group_ungroup()
            nonono = node," to Ungroup"
            print(nonono)
            bpy.ops.node.group_edit(exit=True)
        except Exception as e:
            print(e)
        finally:
            bpy.context.area.type = initial_area_type
        fixlocate = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\\20220603141428_Chika_Haruno\\Textures\\"
        bpimg = bpy.data.images.get
        if 1==1:
            print(mm)
            print(dm)
            print(nm)
            print(t2)
            print(t3)
        #formula_list=(nm,nd,dm,mm,t2,t3,am,lm,ar,ov1,ov2,lnm,com,glo,bum,dnm,bnm,sgm,om,tss,mgm,ov)
        #for formula in formula_list:
        #    if bpimg(formula) is not None:
        f1 = bpimg(mm)
        #for x in f1:
        if f1 is not None:
            bpy.data.images[mm].name = TexMain
            bpy.data.images[TexMain].filepath = fixlocate+TexMain
            bpy.data.images[TexMain].filepath_raw = fixlocate+TexMain
        f2 = bpimg(dm)
        #for x in f2:
        if f2 is not None:
            bpy.data.images[dm].name = TexDetailM
            bpy.data.images[TexDetailM].filepath = fixlocate+TexDetailM
            bpy.data.images[TexDetailM].filepath_raw = fixlocate+TexDetailM
        f3 = bpimg(nm)
        #for x in f3:
        if f3 is not None:
            bpy.data.images[nm].name = TexNormal
            bpy.data.images[TexNormal].filepath = fixlocate+TexNormal
            bpy.data.images[TexNormal].filepath_raw = fixlocate+TexNormal
        f4 = bpimg(t2)
        #for x in f3:
        if f4 is not None:
            bpy.data.images[t2].name = TexTex2
            bpy.data.images[TexTex2].filepath = fixlocate+TexTex2
            bpy.data.images[TexTex2].filepath_raw = fixlocate+TexTex2
        f5 = bpimg(t3)
        #for x in f4:
        if f5 is not None:
            bpy.data.images[t3].name = TexTex3
            bpy.data.images[TexTex3].filepath = fixlocate+TexTex3
            bpy.data.images[TexTex3].filepath_raw = fixlocate+TexTex3
        f6 = bpimg(am)
        #for x in f5:
        if f6 is not None:
            bpy.data.images[am].name = TexAlphaM
            bpy.data.images[TexAlphaM].filepath = fixlocate+TexAlphaM
            bpy.data.images[TexAlphaM].filepath_raw = fixlocate+TexAlphaM
        f7 = bpimg(lm)
        #for x in f6:
        if f7 is not None:
            bpy.data.images[lm].name = TexLiquidM
            bpy.data.images[TexLiquidM].filepath = fixlocate+TexLiquidM
            bpy.data.images[TexLiquidM].filepath_raw = fixlocate+TexLiquidM
        f8 = bpimg(ar)
        #for f8 in f8:
        if f8 is not None:
            bpy.data.images[ar].name = TexAnotherR
            bpy.data.images[TexAnotherR].filepath = fixlocate+TexAnotherR
            bpy.data.images[TexAnotherR].filepath_raw = fixlocate+TexAnotherR
        f9 = bpimg(nd)
        #for f8 in f8:
        if f9 is not None:
            bpy.data.images[nd].name = TexNDetail
            bpy.data.images[TexNDetail].filepath = fixlocate+TexNDetail
            bpy.data.images[TexNDetail].filepath_raw = fixlocate+TexNDetail
        f10 = bpimg(ov1)
        #for f8 in f8:
        if f10 is not None:
            bpy.data.images[ov1].name = TexOv1
            bpy.data.images[TexOv1].filepath = fixlocate+TexOv1
            bpy.data.images[TexOv1].filepath_raw = fixlocate+TexOv1
        f11 = bpimg(ov2)
        #for f8 in f8:
        if f11 is not None:
            bpy.data.images[ov2].name = TexOv2
            bpy.data.images[TexOv2].filepath = fixlocate+TexOv2
            bpy.data.images[TexOv2].filepath_raw = fixlocate+TexOv2
        f12 = bpimg(lnm)
        #for f8 in f8:
        if f12 is not None:
            bpy.data.images[lnm].name = TexLineM
            bpy.data.images[TexLineM].filepath = fixlocate+TexLineM
            bpy.data.images[TexLineM].filepath_raw = fixlocate+TexLineM
        f13 = bpimg(com)
        #for f8 in f8:
        if f13 is not None:
            bpy.data.images[com].name = TexColorM
            bpy.data.images[TexColorM].filepath = fixlocate+TexColorM
            bpy.data.images[TexColorM].filepath_raw = fixlocate+TexColorM
        f14 = bpimg(glo)
        #for f8 in f8:
        if f14 is not None:
            bpy.data.images[glo].name = TexHairG
            bpy.data.images[TexHairG].filepath = fixlocate+TexHairG
            bpy.data.images[TexHairG].filepath_raw = fixlocate+TexHairG
        f15 = bpimg(bum)
        #for f8 in f8:
        if f15 is not None:
            bpy.data.images[bum].name = TexBump
            bpy.data.images[TexBump].filepath = fixlocate+TexBump
            bpy.data.images[TexBump].filepath_raw = fixlocate+TexBump
        f16 = bpimg(dnm)
        #for f8 in f8:
        if f16 is not None:
            bpy.data.images[dnm].name = TexDNM
            bpy.data.images[TexDNM].filepath = fixlocate+TexDNM
            bpy.data.images[TexDNM].filepath_raw = fixlocate+TexDNM
        f17 = bpimg(bnm)
        #for f8 in f8:
        if f17 is not None:
            bpy.data.images[bnm].name = TexBNM
            bpy.data.images[TexBNM].filepath = fixlocate+TexBNM
            bpy.data.images[TexBNM].filepath_raw = fixlocate+TexBNM
        f18 = bpimg(sgm)
        #for f8 in f8:
        if f18 is not None:
            bpy.data.images[sgm].name = TexSGM
            bpy.data.images[TexSGM].filepath = fixlocate+TexSGM
            bpy.data.images[TexSGM].filepath_raw = fixlocate+TexSGM
        f19 = bpimg(om)
        #for f8 in f8:
        if f19 is not None:
            bpy.data.images[om].name = TexOM
            bpy.data.images[TexOM].filepath = fixlocate+TexOM
            bpy.data.images[TexOM].filepath_raw = fixlocate+TexOM
        f20 = bpimg(tss)
        #for f8 in f8:
        if f20 is not None:
            bpy.data.images[tss].name = TexTSS
            bpy.data.images[TexTSS].filepath = fixlocate+TexTSS
            bpy.data.images[TexTSS].filepath_raw = fixlocate+TexTSS
        f21 = bpimg(mgm)
        #for f8 in f8:
        if f21 is not None:
            bpy.data.images[mgm].name = TexMGM
            bpy.data.images[TexMGM].filepath = fixlocate+TexMGM
            bpy.data.images[TexMGM].filepath_raw = fixlocate+TexMGM
        f22 = bpimg(ov)
        #for f8 in f8:
        if f22 is not None:
            bpy.data.images[ov].name = TexOV
            bpy.data.images[TexOV].filepath = fixlocate+TexOV
            bpy.data.images[TexOV].filepath_raw = fixlocate+TexOV
        bpy.ops.file.find_missing_files('INVOKE_DEFAULT')
        return {"FINISHED"}

    def invoke(self, context, event):
        return self.execute(context)


class SNA_OT_Kkpsimple_C0011(bpy.types.Operator):
    bl_idname = "sna.kkpsimple_c0011"
    bl_label = "kkp-simple"
    bl_description = "SIMPLE"
    bl_options = {"REGISTER", "UNDO"}

    @classmethod
    def poll(cls, context):
        return not False

    def execute(self, context):
        import os
        ########################################################################
        my_mat = bpy.context.object.material_slots[0].material
        print(my_mat.name)
        Tex=my_mat.name
        rem_mat = bpy.data.materials[Tex]
        #Get the node in its node tree (replace the name below)
        node_to_delete =  rem_mat.node_tree.nodes['Principled BSDF']
        node_to_delete2 =  rem_mat.node_tree.nodes['Material Output']
        #Remove it
        rem_mat.node_tree.nodes.remove(node_to_delete)
        rem_mat.node_tree.nodes.remove(node_to_delete2)
        #Tex = material.name
        TexMain = Tex+'_MainTex.png'
        TexDetailM = Tex+'_DetailMask.png'
        TexNormal = Tex+'_NormalMap.png'
        TexNDetail = Tex+'_NormalMapDetail.png'
        TexAlphaM = Tex+'_AlphaMask.png'
        TexAnotherR = Tex+'_AnotherRamp.png'
        TexLiquidM = Tex+'_liquidmask.png'
        TexTex2 = Tex+'_Texture2.png'
        TexTex3 = Tex+'_Texture3.png'
        TexOv1 = Tex+'_overtex1.png'
        TexOv2 = Tex+'_overtex2.png'
        TexLineM = Tex+'_LineMask.png'
        TexColorM = Tex+'_ColorMask.png'
        TexHairG = Tex+'_HairGloss.png'
        TexBump = Tex+'_BumpMap.png'
        TexDNM = Tex+'_DetailNormalMap.png'
        TexBNM = Tex+'_BlendNormalMap.png'
        TexSGM = Tex+'_SpecGlossMap.png'
        TexOM = Tex+'_OcclusionMap.png'
        TexTSS = Tex+'_Thickness.png'
        TexMGM = Tex+'_MetallicGlossMap.png'
        TexOV = Tex+'_OverTex.png'
        originaltex = 'cf_m_emblem_'
        #originaltss = 'cf_m_body_01_'
        #kkp
        nm = originaltex+'NormalMap.png'
        nd = originaltex+'NormalMapDetail.png'
        dm = originaltex+'DetailMask.png'
        mm = originaltex+'MainTex.png'
        t3 = originaltex+'Texture3.png'
        t2 = originaltex+'Texture2.png'
        am = originaltex+'AlphaMask.png'
        lm = originaltex+'liquidmask.png'
        ar = originaltex+'AnotherRamp.png'
        ov1 = originaltex+'overtex1.png'
        ov2 = originaltex+'overtex2.png'
        lnm = originaltex+'LineMask.png'
        com = originaltex+'ColorMask.png'
        glo = originaltex+'HairGloss.png'
        #hs1
        bum = originaltex+'BumpMap.png'
        dnm = originaltex+'DetailNormalMap.png'
        bnm = originaltex+'BlendNormalMap.png'
        sgm = originaltex+'SpecGlossMap.png'
        om = originaltex+'OcclusionMap.png'
        tss = originaltex+'Thickness.png'
        mgm = originaltex+'MetallicGlossMap.png'
        ov = originaltex+'OverTex.png'
        Template='KK-Template Simple'
        CTemplate=Template+' '
        C = bpy.context

        def instantiate_group(nodes, data_block_name):
            group = nodes.new(type='ShaderNodeGroup')
            group.node_tree = bpy.data.node_groups[Template]
            return group
        if Template in bpy.data.node_groups:
            instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
        else:
        #    versions = ( t0, t1, t2, t3, t4)
        #    for x in versions:
        #        if os.path.isdir(x) and os.access(x, os.R_OK):
            if (3, 0, 0) <= bpy.app.version < (3, 0, 99):
                before_data = list(bpy.data.node_groups)
                bpy.ops.wm.append(directory=os.path.expanduser(r"~\AppData\Roaming\Blender Foundation\Blender\3.0\scripts\addons\sklx_creator\assets\KK_Template_Shader.blend") + r'\NodeTree',filename=Template,link=False)
                new_data=list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
                appended_2B5AC = None if not new_data else new_data[0]
                instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
            else:
                if (3, 1, 0) <= bpy.app.version < (3, 1, 99):
                    before_data = list(bpy.data.node_groups)
                    bpy.ops.wm.append(directory=os.path.expanduser(r"~\AppData\Roaming\Blender Foundation\Blender\3.1\scripts\addons\sklx_creator\assets\KK_Template_Shader.blend") + r'\NodeTree',filename=Template,link=False)
                    new_data=list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
                    appended_2B5AC = None if not new_data else new_data[0]
                    instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
                else:
                    if (3, 2, 0) <= bpy.app.version < (3, 2, 99):
                        before_data = list(bpy.data.node_groups)
                        bpy.ops.wm.append(directory=os.path.expanduser(r"~\AppData\Roaming\Blender Foundation\Blender\3.2\scripts\addons\sklx_creator\assets\KK_Template_Shader.blend") + r'\NodeTree',filename=Template,link=False)
                        new_data=list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
                        appended_2B5AC = None if not new_data else new_data[0]
                        instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
                    else:
                        if (3, 3, 0) <= bpy.app.version < (3, 3, 99):
                            before_data = list(bpy.data.node_groups)
                            bpy.ops.wm.append(directory=os.path.expanduser(r"~\AppData\Roaming\Blender Foundation\Blender\3.3\scripts\addons\sklx_creator\assets\KK_Template_Shader.blend") + r'\NodeTree',filename=Template,link=False)
                            new_data=list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
                            appended_2B5AC = None if not new_data else new_data[0]
                            instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
                        else:
                            if (3, 4, 0) <= bpy.app.version < (3, 4, 99):
                                before_data = list(bpy.data.node_groups)
                                bpy.ops.wm.append(directory=os.path.expanduser(r"~\AppData\Roaming\Blender Foundation\Blender\3.4\scripts\addons\sklx_creator\assets\KK_Template_Shader.blend") + r'\NodeTree',filename=Template,link=False)
                                new_data=list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
                                appended_2B5AC = None if not new_data else new_data[0]
                                instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
        bpy.data.node_groups[Template].name = CTemplate+Tex
        node = bpy.data.node_groups[CTemplate+Tex]
        #initial_area_type = bpy.context.area.type
        #bpy.context.area.type = 'NODE_EDITOR'
        #bpy.context.area.ui_type = 'ShaderNodeTree'
        #bpy.ops.wm.redraw_timer(type='DRAW_WIN', iterations=1)
        #bpy.ops.node.group_ungroup()
        #bpy.ops.node.group_edit(exit=True)
        #bpy.context.area.type = initial_area_type
        nodes = my_mat.node_tree.nodes
        for node in nodes:
            #node.select = False
            print(node.name)
            node.select = True
            nodes.active = node
        try:
            initial_area_type = bpy.context.area.type
            bpy.context.area.type = 'NODE_EDITOR'
            bpy.context.area.ui_type = 'ShaderNodeTree'
            bpy.ops.wm.redraw_timer(type='DRAW_WIN', iterations=1)
            bpy.ops.node.group_ungroup()
            nonono = node," to Ungroup"
            print(nonono)
            bpy.ops.node.group_edit(exit=True)
        except Exception as e:
            print(e)
        finally:
            bpy.context.area.type = initial_area_type
        fixlocate = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\\20220603141428_Chika_Haruno\\Textures\\"
        bpimg = bpy.data.images.get
        if 1==1:
            print(mm)
            print(dm)
            print(nm)
            print(t2)
            print(t3)
        #formula_list=(nm,nd,dm,mm,t2,t3,am,lm,ar,ov1,ov2,lnm,com,glo,bum,dnm,bnm,sgm,om,tss,mgm,ov)
        #for formula in formula_list:
        #    if bpimg(formula) is not None:
        f1 = bpimg(mm)
        #for x in f1:
        if f1 is not None:
            bpy.data.images[mm].name = TexMain
            bpy.data.images[TexMain].filepath = fixlocate+TexMain
            bpy.data.images[TexMain].filepath_raw = fixlocate+TexMain
        f2 = bpimg(dm)
        #for x in f2:
        if f2 is not None:
            bpy.data.images[dm].name = TexDetailM
            bpy.data.images[TexDetailM].filepath = fixlocate+TexDetailM
            bpy.data.images[TexDetailM].filepath_raw = fixlocate+TexDetailM
        f3 = bpimg(nm)
        #for x in f3:
        if f3 is not None:
            bpy.data.images[nm].name = TexNormal
            bpy.data.images[TexNormal].filepath = fixlocate+TexNormal
            bpy.data.images[TexNormal].filepath_raw = fixlocate+TexNormal
        f4 = bpimg(t2)
        #for x in f3:
        if f4 is not None:
            bpy.data.images[t2].name = TexTex2
            bpy.data.images[TexTex2].filepath = fixlocate+TexTex2
            bpy.data.images[TexTex2].filepath_raw = fixlocate+TexTex2
        f5 = bpimg(t3)
        #for x in f4:
        if f5 is not None:
            bpy.data.images[t3].name = TexTex3
            bpy.data.images[TexTex3].filepath = fixlocate+TexTex3
            bpy.data.images[TexTex3].filepath_raw = fixlocate+TexTex3
        f6 = bpimg(am)
        #for x in f5:
        if f6 is not None:
            bpy.data.images[am].name = TexAlphaM
            bpy.data.images[TexAlphaM].filepath = fixlocate+TexAlphaM
            bpy.data.images[TexAlphaM].filepath_raw = fixlocate+TexAlphaM
        f7 = bpimg(lm)
        #for x in f6:
        if f7 is not None:
            bpy.data.images[lm].name = TexLiquidM
            bpy.data.images[TexLiquidM].filepath = fixlocate+TexLiquidM
            bpy.data.images[TexLiquidM].filepath_raw = fixlocate+TexLiquidM
        f8 = bpimg(ar)
        #for f8 in f8:
        if f8 is not None:
            bpy.data.images[ar].name = TexAnotherR
            bpy.data.images[TexAnotherR].filepath = fixlocate+TexAnotherR
            bpy.data.images[TexAnotherR].filepath_raw = fixlocate+TexAnotherR
        f9 = bpimg(nd)
        #for f8 in f8:
        if f9 is not None:
            bpy.data.images[nd].name = TexNDetail
            bpy.data.images[TexNDetail].filepath = fixlocate+TexNDetail
            bpy.data.images[TexNDetail].filepath_raw = fixlocate+TexNDetail
        f10 = bpimg(ov1)
        #for f8 in f8:
        if f10 is not None:
            bpy.data.images[ov1].name = TexOv1
            bpy.data.images[TexOv1].filepath = fixlocate+TexOv1
            bpy.data.images[TexOv1].filepath_raw = fixlocate+TexOv1
        f11 = bpimg(ov2)
        #for f8 in f8:
        if f11 is not None:
            bpy.data.images[ov2].name = TexOv2
            bpy.data.images[TexOv2].filepath = fixlocate+TexOv2
            bpy.data.images[TexOv2].filepath_raw = fixlocate+TexOv2
        f12 = bpimg(lnm)
        #for f8 in f8:
        if f12 is not None:
            bpy.data.images[lnm].name = TexLineM
            bpy.data.images[TexLineM].filepath = fixlocate+TexLineM
            bpy.data.images[TexLineM].filepath_raw = fixlocate+TexLineM
        f13 = bpimg(com)
        #for f8 in f8:
        if f13 is not None:
            bpy.data.images[com].name = TexColorM
            bpy.data.images[TexColorM].filepath = fixlocate+TexColorM
            bpy.data.images[TexColorM].filepath_raw = fixlocate+TexColorM
        f14 = bpimg(glo)
        #for f8 in f8:
        if f14 is not None:
            bpy.data.images[glo].name = TexHairG
            bpy.data.images[TexHairG].filepath = fixlocate+TexHairG
            bpy.data.images[TexHairG].filepath_raw = fixlocate+TexHairG
        f15 = bpimg(bum)
        #for f8 in f8:
        if f15 is not None:
            bpy.data.images[bum].name = TexBump
            bpy.data.images[TexBump].filepath = fixlocate+TexBump
            bpy.data.images[TexBump].filepath_raw = fixlocate+TexBump
        f16 = bpimg(dnm)
        #for f8 in f8:
        if f16 is not None:
            bpy.data.images[dnm].name = TexDNM
            bpy.data.images[TexDNM].filepath = fixlocate+TexDNM
            bpy.data.images[TexDNM].filepath_raw = fixlocate+TexDNM
        f17 = bpimg(bnm)
        #for f8 in f8:
        if f17 is not None:
            bpy.data.images[bnm].name = TexBNM
            bpy.data.images[TexBNM].filepath = fixlocate+TexBNM
            bpy.data.images[TexBNM].filepath_raw = fixlocate+TexBNM
        f18 = bpimg(sgm)
        #for f8 in f8:
        if f18 is not None:
            bpy.data.images[sgm].name = TexSGM
            bpy.data.images[TexSGM].filepath = fixlocate+TexSGM
            bpy.data.images[TexSGM].filepath_raw = fixlocate+TexSGM
        f19 = bpimg(om)
        #for f8 in f8:
        if f19 is not None:
            bpy.data.images[om].name = TexOM
            bpy.data.images[TexOM].filepath = fixlocate+TexOM
            bpy.data.images[TexOM].filepath_raw = fixlocate+TexOM
        f20 = bpimg(tss)
        #for f8 in f8:
        if f20 is not None:
            bpy.data.images[tss].name = TexTSS
            bpy.data.images[TexTSS].filepath = fixlocate+TexTSS
            bpy.data.images[TexTSS].filepath_raw = fixlocate+TexTSS
        f21 = bpimg(mgm)
        #for f8 in f8:
        if f21 is not None:
            bpy.data.images[mgm].name = TexMGM
            bpy.data.images[TexMGM].filepath = fixlocate+TexMGM
            bpy.data.images[TexMGM].filepath_raw = fixlocate+TexMGM
        f22 = bpimg(ov)
        #for f8 in f8:
        if f22 is not None:
            bpy.data.images[ov].name = TexOV
            bpy.data.images[TexOV].filepath = fixlocate+TexOV
            bpy.data.images[TexOV].filepath_raw = fixlocate+TexOV
        bpy.ops.file.find_missing_files('INVOKE_DEFAULT')
        return {"FINISHED"}

    def invoke(self, context, event):
        return self.execute(context)


class SNA_OT_Kkpbot_9E279(bpy.types.Operator):
    bl_idname = "sna.kkpbot_9e279"
    bl_label = "kkp-bot"
    bl_description = ""
    bl_options = {"REGISTER", "UNDO"}

    @classmethod
    def poll(cls, context):
        return not False

    def execute(self, context):
        import os
        ########################################################################
        my_mat = bpy.context.object.material_slots[0].material
        print(my_mat.name)
        Tex=my_mat.name
        rem_mat = bpy.data.materials[Tex]
        #Get the node in its node tree (replace the name below)
        node_to_delete =  rem_mat.node_tree.nodes['Principled BSDF']
        node_to_delete2 =  rem_mat.node_tree.nodes['Material Output']
        #Remove it
        rem_mat.node_tree.nodes.remove(node_to_delete)
        rem_mat.node_tree.nodes.remove(node_to_delete2)
        #Tex = material.name
        TexMain = Tex+'_MainTex.png'
        TexDetailM = Tex+'_DetailMask.png'
        TexNormal = Tex+'_NormalMap.png'
        TexNDetail = Tex+'_NormalMapDetail.png'
        TexAlphaM = Tex+'_AlphaMask.png'
        TexAnotherR = Tex+'_AnotherRamp.png'
        TexLiquidM = Tex+'_liquidmask.png'
        TexTex2 = Tex+'_Texture2.png'
        TexTex3 = Tex+'_Texture3.png'
        TexOv1 = Tex+'_overtex1.png'
        TexOv2 = Tex+'_overtex2.png'
        TexLineM = Tex+'_LineMask.png'
        TexColorM = Tex+'_ColorMask.png'
        TexHairG = Tex+'_HairGloss.png'
        TexBump = Tex+'_BumpMap.png'
        TexDNM = Tex+'_DetailNormalMap.png'
        TexBNM = Tex+'_BlendNormalMap.png'
        TexSGM = Tex+'_SpecGlossMap.png'
        TexOM = Tex+'_OcclusionMap.png'
        TexTSS = Tex+'_Thickness.png'
        TexMGM = Tex+'_MetallicGlossMap.png'
        TexOV = Tex+'_OverTex.png'
        originaltex = 'cf_m_bot_skirt01_'
        #originaltss = 'cf_m_body_01_'
        #kkp
        nm = originaltex+'NormalMap.png'
        nd = originaltex+'NormalMapDetail.png'
        dm = originaltex+'DetailMask.png'
        mm = originaltex+'MainTex.png'
        t3 = originaltex+'Texture3.png'
        t2 = originaltex+'Texture2.png'
        am = originaltex+'AlphaMask.png'
        lm = originaltex+'liquidmask.png'
        ar = originaltex+'AnotherRamp.png'
        ov1 = originaltex+'overtex1.png'
        ov2 = originaltex+'overtex2.png'
        lnm = originaltex+'LineMask.png'
        com = originaltex+'ColorMask.png'
        glo = originaltex+'HairGloss.png'
        #hs1
        bum = originaltex+'BumpMap.png'
        dnm = originaltex+'DetailNormalMap.png'
        bnm = originaltex+'BlendNormalMap.png'
        sgm = originaltex+'SpecGlossMap.png'
        om = originaltex+'OcclusionMap.png'
        tss = originaltex+'Thickness.png'
        mgm = originaltex+'MetallicGlossMap.png'
        ov = originaltex+'OverTex.png'
        Template='KK-Template Pants'
        CTemplate=Template+' '
        C = bpy.context

        def instantiate_group(nodes, data_block_name):
            group = nodes.new(type='ShaderNodeGroup')
            group.node_tree = bpy.data.node_groups[Template]
            return group
        if Template in bpy.data.node_groups:
            instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
        else:
        #    versions = ( t0, t1, t2, t3, t4)
        #    for x in versions:
        #        if os.path.isdir(x) and os.access(x, os.R_OK):
            if (3, 0, 0) <= bpy.app.version < (3, 0, 99):
                before_data = list(bpy.data.node_groups)
                bpy.ops.wm.append(directory=os.path.expanduser(r"~\AppData\Roaming\Blender Foundation\Blender\3.0\scripts\addons\sklx_creator\assets\KK_Template_Shader.blend") + r'\NodeTree',filename=Template,link=False)
                new_data=list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
                appended_2B5AC = None if not new_data else new_data[0]
                instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
            else:
                if (3, 1, 0) <= bpy.app.version < (3, 1, 99):
                    before_data = list(bpy.data.node_groups)
                    bpy.ops.wm.append(directory=os.path.expanduser(r"~\AppData\Roaming\Blender Foundation\Blender\3.1\scripts\addons\sklx_creator\assets\KK_Template_Shader.blend") + r'\NodeTree',filename=Template,link=False)
                    new_data=list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
                    appended_2B5AC = None if not new_data else new_data[0]
                    instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
                else:
                    if (3, 2, 0) <= bpy.app.version < (3, 2, 99):
                        before_data = list(bpy.data.node_groups)
                        bpy.ops.wm.append(directory=os.path.expanduser(r"~\AppData\Roaming\Blender Foundation\Blender\3.2\scripts\addons\sklx_creator\assets\KK_Template_Shader.blend") + r'\NodeTree',filename=Template,link=False)
                        new_data=list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
                        appended_2B5AC = None if not new_data else new_data[0]
                        instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
                    else:
                        if (3, 3, 0) <= bpy.app.version < (3, 3, 99):
                            before_data = list(bpy.data.node_groups)
                            bpy.ops.wm.append(directory=os.path.expanduser(r"~\AppData\Roaming\Blender Foundation\Blender\3.3\scripts\addons\sklx_creator\assets\KK_Template_Shader.blend") + r'\NodeTree',filename=Template,link=False)
                            new_data=list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
                            appended_2B5AC = None if not new_data else new_data[0]
                            instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
                        else:
                            if (3, 4, 0) <= bpy.app.version < (3, 4, 99):
                                before_data = list(bpy.data.node_groups)
                                bpy.ops.wm.append(directory=os.path.expanduser(r"~\AppData\Roaming\Blender Foundation\Blender\3.4\scripts\addons\sklx_creator\assets\KK_Template_Shader.blend") + r'\NodeTree',filename=Template,link=False)
                                new_data=list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
                                appended_2B5AC = None if not new_data else new_data[0]
                                instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
        bpy.data.node_groups[Template].name = CTemplate+Tex
        node = bpy.data.node_groups[CTemplate+Tex]
        #initial_area_type = bpy.context.area.type
        #bpy.context.area.type = 'NODE_EDITOR'
        #bpy.context.area.ui_type = 'ShaderNodeTree'
        #bpy.ops.wm.redraw_timer(type='DRAW_WIN', iterations=1)
        #bpy.ops.node.group_ungroup()
        #bpy.ops.node.group_edit(exit=True)
        #bpy.context.area.type = initial_area_type
        nodes = my_mat.node_tree.nodes
        for node in nodes:
            #node.select = False
            print(node.name)
            node.select = True
            nodes.active = node
        try:
            initial_area_type = bpy.context.area.type
            bpy.context.area.type = 'NODE_EDITOR'
            bpy.context.area.ui_type = 'ShaderNodeTree'
            bpy.ops.wm.redraw_timer(type='DRAW_WIN', iterations=1)
            bpy.ops.node.group_ungroup()
            nonono = node," to Ungroup"
            print(nonono)
            bpy.ops.node.group_edit(exit=True)
        except Exception as e:
            print(e)
        finally:
            bpy.context.area.type = initial_area_type
        fixlocate = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\\20220603141428_Chika_Haruno\\Textures\\"
        bpimg = bpy.data.images.get
        if 1==1:
            print(mm)
            print(dm)
            print(nm)
            print(t2)
            print(t3)
        #formula_list=(nm,nd,dm,mm,t2,t3,am,lm,ar,ov1,ov2,lnm,com,glo,bum,dnm,bnm,sgm,om,tss,mgm,ov)
        #for formula in formula_list:
        #    if bpimg(formula) is not None:
        f1 = bpimg(mm)
        #for x in f1:
        if f1 is not None:
            bpy.data.images[mm].name = TexMain
            bpy.data.images[TexMain].filepath = fixlocate+TexMain
            bpy.data.images[TexMain].filepath_raw = fixlocate+TexMain
        f2 = bpimg(dm)
        #for x in f2:
        if f2 is not None:
            bpy.data.images[dm].name = TexDetailM
            bpy.data.images[TexDetailM].filepath = fixlocate+TexDetailM
            bpy.data.images[TexDetailM].filepath_raw = fixlocate+TexDetailM
        f3 = bpimg(nm)
        #for x in f3:
        if f3 is not None:
            bpy.data.images[nm].name = TexNormal
            bpy.data.images[TexNormal].filepath = fixlocate+TexNormal
            bpy.data.images[TexNormal].filepath_raw = fixlocate+TexNormal
        f4 = bpimg(t2)
        #for x in f3:
        if f4 is not None:
            bpy.data.images[t2].name = TexTex2
            bpy.data.images[TexTex2].filepath = fixlocate+TexTex2
            bpy.data.images[TexTex2].filepath_raw = fixlocate+TexTex2
        f5 = bpimg(t3)
        #for x in f4:
        if f5 is not None:
            bpy.data.images[t3].name = TexTex3
            bpy.data.images[TexTex3].filepath = fixlocate+TexTex3
            bpy.data.images[TexTex3].filepath_raw = fixlocate+TexTex3
        f6 = bpimg(am)
        #for x in f5:
        if f6 is not None:
            bpy.data.images[am].name = TexAlphaM
            bpy.data.images[TexAlphaM].filepath = fixlocate+TexAlphaM
            bpy.data.images[TexAlphaM].filepath_raw = fixlocate+TexAlphaM
        f7 = bpimg(lm)
        #for x in f6:
        if f7 is not None:
            bpy.data.images[lm].name = TexLiquidM
            bpy.data.images[TexLiquidM].filepath = fixlocate+TexLiquidM
            bpy.data.images[TexLiquidM].filepath_raw = fixlocate+TexLiquidM
        f8 = bpimg(ar)
        #for f8 in f8:
        if f8 is not None:
            bpy.data.images[ar].name = TexAnotherR
            bpy.data.images[TexAnotherR].filepath = fixlocate+TexAnotherR
            bpy.data.images[TexAnotherR].filepath_raw = fixlocate+TexAnotherR
        f9 = bpimg(nd)
        #for f8 in f8:
        if f9 is not None:
            bpy.data.images[nd].name = TexNDetail
            bpy.data.images[TexNDetail].filepath = fixlocate+TexNDetail
            bpy.data.images[TexNDetail].filepath_raw = fixlocate+TexNDetail
        f10 = bpimg(ov1)
        #for f8 in f8:
        if f10 is not None:
            bpy.data.images[ov1].name = TexOv1
            bpy.data.images[TexOv1].filepath = fixlocate+TexOv1
            bpy.data.images[TexOv1].filepath_raw = fixlocate+TexOv1
        f11 = bpimg(ov2)
        #for f8 in f8:
        if f11 is not None:
            bpy.data.images[ov2].name = TexOv2
            bpy.data.images[TexOv2].filepath = fixlocate+TexOv2
            bpy.data.images[TexOv2].filepath_raw = fixlocate+TexOv2
        f12 = bpimg(lnm)
        #for f8 in f8:
        if f12 is not None:
            bpy.data.images[lnm].name = TexLineM
            bpy.data.images[TexLineM].filepath = fixlocate+TexLineM
            bpy.data.images[TexLineM].filepath_raw = fixlocate+TexLineM
        f13 = bpimg(com)
        #for f8 in f8:
        if f13 is not None:
            bpy.data.images[com].name = TexColorM
            bpy.data.images[TexColorM].filepath = fixlocate+TexColorM
            bpy.data.images[TexColorM].filepath_raw = fixlocate+TexColorM
        f14 = bpimg(glo)
        #for f8 in f8:
        if f14 is not None:
            bpy.data.images[glo].name = TexHairG
            bpy.data.images[TexHairG].filepath = fixlocate+TexHairG
            bpy.data.images[TexHairG].filepath_raw = fixlocate+TexHairG
        f15 = bpimg(bum)
        #for f8 in f8:
        if f15 is not None:
            bpy.data.images[bum].name = TexBump
            bpy.data.images[TexBump].filepath = fixlocate+TexBump
            bpy.data.images[TexBump].filepath_raw = fixlocate+TexBump
        f16 = bpimg(dnm)
        #for f8 in f8:
        if f16 is not None:
            bpy.data.images[dnm].name = TexDNM
            bpy.data.images[TexDNM].filepath = fixlocate+TexDNM
            bpy.data.images[TexDNM].filepath_raw = fixlocate+TexDNM
        f17 = bpimg(bnm)
        #for f8 in f8:
        if f17 is not None:
            bpy.data.images[bnm].name = TexBNM
            bpy.data.images[TexBNM].filepath = fixlocate+TexBNM
            bpy.data.images[TexBNM].filepath_raw = fixlocate+TexBNM
        f18 = bpimg(sgm)
        #for f8 in f8:
        if f18 is not None:
            bpy.data.images[sgm].name = TexSGM
            bpy.data.images[TexSGM].filepath = fixlocate+TexSGM
            bpy.data.images[TexSGM].filepath_raw = fixlocate+TexSGM
        f19 = bpimg(om)
        #for f8 in f8:
        if f19 is not None:
            bpy.data.images[om].name = TexOM
            bpy.data.images[TexOM].filepath = fixlocate+TexOM
            bpy.data.images[TexOM].filepath_raw = fixlocate+TexOM
        f20 = bpimg(tss)
        #for f8 in f8:
        if f20 is not None:
            bpy.data.images[tss].name = TexTSS
            bpy.data.images[TexTSS].filepath = fixlocate+TexTSS
            bpy.data.images[TexTSS].filepath_raw = fixlocate+TexTSS
        f21 = bpimg(mgm)
        #for f8 in f8:
        if f21 is not None:
            bpy.data.images[mgm].name = TexMGM
            bpy.data.images[TexMGM].filepath = fixlocate+TexMGM
            bpy.data.images[TexMGM].filepath_raw = fixlocate+TexMGM
        f22 = bpimg(ov)
        #for f8 in f8:
        if f22 is not None:
            bpy.data.images[ov].name = TexOV
            bpy.data.images[TexOV].filepath = fixlocate+TexOV
            bpy.data.images[TexOV].filepath_raw = fixlocate+TexOV
        bpy.ops.file.find_missing_files('INVOKE_DEFAULT')
        return {"FINISHED"}

    def invoke(self, context, event):
        return self.execute(context)


class SNA_OT_Kkpbra_3E2Db(bpy.types.Operator):
    bl_idname = "sna.kkpbra_3e2db"
    bl_label = "kkp-bra"
    bl_description = "BRA"
    bl_options = {"REGISTER", "UNDO"}

    @classmethod
    def poll(cls, context):
        return not False

    def execute(self, context):
        import os
        ########################################################################
        my_mat = bpy.context.object.material_slots[0].material
        print(my_mat.name)
        Tex=my_mat.name
        rem_mat = bpy.data.materials[Tex]
        #Get the node in its node tree (replace the name below)
        node_to_delete =  rem_mat.node_tree.nodes['Principled BSDF']
        node_to_delete2 =  rem_mat.node_tree.nodes['Material Output']
        #Remove it
        rem_mat.node_tree.nodes.remove(node_to_delete)
        rem_mat.node_tree.nodes.remove(node_to_delete2)
        #Tex = material.name
        TexMain = Tex+'_MainTex.png'
        TexDetailM = Tex+'_DetailMask.png'
        TexNormal = Tex+'_NormalMap.png'
        TexNDetail = Tex+'_NormalMapDetail.png'
        TexAlphaM = Tex+'_AlphaMask.png'
        TexAnotherR = Tex+'_AnotherRamp.png'
        TexLiquidM = Tex+'_liquidmask.png'
        TexTex2 = Tex+'_Texture2.png'
        TexTex3 = Tex+'_Texture3.png'
        TexOv1 = Tex+'_overtex1.png'
        TexOv2 = Tex+'_overtex2.png'
        TexLineM = Tex+'_LineMask.png'
        TexColorM = Tex+'_ColorMask.png'
        TexHairG = Tex+'_HairGloss.png'
        TexBump = Tex+'_BumpMap.png'
        TexDNM = Tex+'_DetailNormalMap.png'
        TexBNM = Tex+'_BlendNormalMap.png'
        TexSGM = Tex+'_SpecGlossMap.png'
        TexOM = Tex+'_OcclusionMap.png'
        TexTSS = Tex+'_Thickness.png'
        TexMGM = Tex+'_MetallicGlossMap.png'
        TexOV = Tex+'_OverTex.png'
        originaltex = 'cf_m_bra_01_'
        #originaltss = 'cf_m_body_01_'
        #kkp
        nm = originaltex+'NormalMap.png'
        nd = originaltex+'NormalMapDetail.png'
        dm = originaltex+'DetailMask.png'
        mm = originaltex+'MainTex.png'
        t3 = originaltex+'Texture3.png'
        t2 = originaltex+'Texture2.png'
        am = originaltex+'AlphaMask.png'
        lm = originaltex+'liquidmask.png'
        ar = originaltex+'AnotherRamp.png'
        ov1 = originaltex+'overtex1.png'
        ov2 = originaltex+'overtex2.png'
        lnm = originaltex+'LineMask.png'
        com = originaltex+'ColorMask.png'
        glo = originaltex+'HairGloss.png'
        #hs1
        bum = originaltex+'BumpMap.png'
        dnm = originaltex+'DetailNormalMap.png'
        bnm = originaltex+'BlendNormalMap.png'
        sgm = originaltex+'SpecGlossMap.png'
        om = originaltex+'OcclusionMap.png'
        tss = originaltex+'Thickness.png'
        mgm = originaltex+'MetallicGlossMap.png'
        ov = originaltex+'OverTex.png'
        Template='KK-Template Bra'
        CTemplate=Template+' '
        C = bpy.context

        def instantiate_group(nodes, data_block_name):
            group = nodes.new(type='ShaderNodeGroup')
            group.node_tree = bpy.data.node_groups[Template]
            return group
        if Template in bpy.data.node_groups:
            instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
        else:
        #    versions = ( t0, t1, t2, t3, t4)
        #    for x in versions:
        #        if os.path.isdir(x) and os.access(x, os.R_OK):
            if (3, 0, 0) <= bpy.app.version < (3, 0, 99):
                before_data = list(bpy.data.node_groups)
                bpy.ops.wm.append(directory=os.path.expanduser(r"~\AppData\Roaming\Blender Foundation\Blender\3.0\scripts\addons\sklx_creator\assets\KK_Template_Shader.blend") + r'\NodeTree',filename=Template,link=False)
                new_data=list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
                appended_2B5AC = None if not new_data else new_data[0]
                instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
            else:
                if (3, 1, 0) <= bpy.app.version < (3, 1, 99):
                    before_data = list(bpy.data.node_groups)
                    bpy.ops.wm.append(directory=os.path.expanduser(r"~\AppData\Roaming\Blender Foundation\Blender\3.1\scripts\addons\sklx_creator\assets\KK_Template_Shader.blend") + r'\NodeTree',filename=Template,link=False)
                    new_data=list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
                    appended_2B5AC = None if not new_data else new_data[0]
                    instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
                else:
                    if (3, 2, 0) <= bpy.app.version < (3, 2, 99):
                        before_data = list(bpy.data.node_groups)
                        bpy.ops.wm.append(directory=os.path.expanduser(r"~\AppData\Roaming\Blender Foundation\Blender\3.2\scripts\addons\sklx_creator\assets\KK_Template_Shader.blend") + r'\NodeTree',filename=Template,link=False)
                        new_data=list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
                        appended_2B5AC = None if not new_data else new_data[0]
                        instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
                    else:
                        if (3, 3, 0) <= bpy.app.version < (3, 3, 99):
                            before_data = list(bpy.data.node_groups)
                            bpy.ops.wm.append(directory=os.path.expanduser(r"~\AppData\Roaming\Blender Foundation\Blender\3.3\scripts\addons\sklx_creator\assets\KK_Template_Shader.blend") + r'\NodeTree',filename=Template,link=False)
                            new_data=list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
                            appended_2B5AC = None if not new_data else new_data[0]
                            instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
                        else:
                            if (3, 4, 0) <= bpy.app.version < (3, 4, 99):
                                before_data = list(bpy.data.node_groups)
                                bpy.ops.wm.append(directory=os.path.expanduser(r"~\AppData\Roaming\Blender Foundation\Blender\3.4\scripts\addons\sklx_creator\assets\KK_Template_Shader.blend") + r'\NodeTree',filename=Template,link=False)
                                new_data=list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
                                appended_2B5AC = None if not new_data else new_data[0]
                                instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
        bpy.data.node_groups[Template].name = CTemplate+Tex
        node = bpy.data.node_groups[CTemplate+Tex]
        #initial_area_type = bpy.context.area.type
        #bpy.context.area.type = 'NODE_EDITOR'
        #bpy.context.area.ui_type = 'ShaderNodeTree'
        #bpy.ops.wm.redraw_timer(type='DRAW_WIN', iterations=1)
        #bpy.ops.node.group_ungroup()
        #bpy.ops.node.group_edit(exit=True)
        #bpy.context.area.type = initial_area_type
        nodes = my_mat.node_tree.nodes
        for node in nodes:
            #node.select = False
            print(node.name)
            node.select = True
            nodes.active = node
        try:
            initial_area_type = bpy.context.area.type
            bpy.context.area.type = 'NODE_EDITOR'
            bpy.context.area.ui_type = 'ShaderNodeTree'
            bpy.ops.wm.redraw_timer(type='DRAW_WIN', iterations=1)
            bpy.ops.node.group_ungroup()
            nonono = node," to Ungroup"
            print(nonono)
            bpy.ops.node.group_edit(exit=True)
        except Exception as e:
            print(e)
        finally:
            bpy.context.area.type = initial_area_type
        fixlocate = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\\20220603141428_Chika_Haruno\\Textures\\"
        bpimg = bpy.data.images.get
        if 1==1:
            print(mm)
            print(dm)
            print(nm)
            print(t2)
            print(t3)
        #formula_list=(nm,nd,dm,mm,t2,t3,am,lm,ar,ov1,ov2,lnm,com,glo,bum,dnm,bnm,sgm,om,tss,mgm,ov)
        #for formula in formula_list:
        #    if bpimg(formula) is not None:
        f1 = bpimg(mm)
        #for x in f1:
        if f1 is not None:
            bpy.data.images[mm].name = TexMain
            bpy.data.images[TexMain].filepath = fixlocate+TexMain
            bpy.data.images[TexMain].filepath_raw = fixlocate+TexMain
        f2 = bpimg(dm)
        #for x in f2:
        if f2 is not None:
            bpy.data.images[dm].name = TexDetailM
            bpy.data.images[TexDetailM].filepath = fixlocate+TexDetailM
            bpy.data.images[TexDetailM].filepath_raw = fixlocate+TexDetailM
        f3 = bpimg(nm)
        #for x in f3:
        if f3 is not None:
            bpy.data.images[nm].name = TexNormal
            bpy.data.images[TexNormal].filepath = fixlocate+TexNormal
            bpy.data.images[TexNormal].filepath_raw = fixlocate+TexNormal
        f4 = bpimg(t2)
        #for x in f3:
        if f4 is not None:
            bpy.data.images[t2].name = TexTex2
            bpy.data.images[TexTex2].filepath = fixlocate+TexTex2
            bpy.data.images[TexTex2].filepath_raw = fixlocate+TexTex2
        f5 = bpimg(t3)
        #for x in f4:
        if f5 is not None:
            bpy.data.images[t3].name = TexTex3
            bpy.data.images[TexTex3].filepath = fixlocate+TexTex3
            bpy.data.images[TexTex3].filepath_raw = fixlocate+TexTex3
        f6 = bpimg(am)
        #for x in f5:
        if f6 is not None:
            bpy.data.images[am].name = TexAlphaM
            bpy.data.images[TexAlphaM].filepath = fixlocate+TexAlphaM
            bpy.data.images[TexAlphaM].filepath_raw = fixlocate+TexAlphaM
        f7 = bpimg(lm)
        #for x in f6:
        if f7 is not None:
            bpy.data.images[lm].name = TexLiquidM
            bpy.data.images[TexLiquidM].filepath = fixlocate+TexLiquidM
            bpy.data.images[TexLiquidM].filepath_raw = fixlocate+TexLiquidM
        f8 = bpimg(ar)
        #for f8 in f8:
        if f8 is not None:
            bpy.data.images[ar].name = TexAnotherR
            bpy.data.images[TexAnotherR].filepath = fixlocate+TexAnotherR
            bpy.data.images[TexAnotherR].filepath_raw = fixlocate+TexAnotherR
        f9 = bpimg(nd)
        #for f8 in f8:
        if f9 is not None:
            bpy.data.images[nd].name = TexNDetail
            bpy.data.images[TexNDetail].filepath = fixlocate+TexNDetail
            bpy.data.images[TexNDetail].filepath_raw = fixlocate+TexNDetail
        f10 = bpimg(ov1)
        #for f8 in f8:
        if f10 is not None:
            bpy.data.images[ov1].name = TexOv1
            bpy.data.images[TexOv1].filepath = fixlocate+TexOv1
            bpy.data.images[TexOv1].filepath_raw = fixlocate+TexOv1
        f11 = bpimg(ov2)
        #for f8 in f8:
        if f11 is not None:
            bpy.data.images[ov2].name = TexOv2
            bpy.data.images[TexOv2].filepath = fixlocate+TexOv2
            bpy.data.images[TexOv2].filepath_raw = fixlocate+TexOv2
        f12 = bpimg(lnm)
        #for f8 in f8:
        if f12 is not None:
            bpy.data.images[lnm].name = TexLineM
            bpy.data.images[TexLineM].filepath = fixlocate+TexLineM
            bpy.data.images[TexLineM].filepath_raw = fixlocate+TexLineM
        f13 = bpimg(com)
        #for f8 in f8:
        if f13 is not None:
            bpy.data.images[com].name = TexColorM
            bpy.data.images[TexColorM].filepath = fixlocate+TexColorM
            bpy.data.images[TexColorM].filepath_raw = fixlocate+TexColorM
        f14 = bpimg(glo)
        #for f8 in f8:
        if f14 is not None:
            bpy.data.images[glo].name = TexHairG
            bpy.data.images[TexHairG].filepath = fixlocate+TexHairG
            bpy.data.images[TexHairG].filepath_raw = fixlocate+TexHairG
        f15 = bpimg(bum)
        #for f8 in f8:
        if f15 is not None:
            bpy.data.images[bum].name = TexBump
            bpy.data.images[TexBump].filepath = fixlocate+TexBump
            bpy.data.images[TexBump].filepath_raw = fixlocate+TexBump
        f16 = bpimg(dnm)
        #for f8 in f8:
        if f16 is not None:
            bpy.data.images[dnm].name = TexDNM
            bpy.data.images[TexDNM].filepath = fixlocate+TexDNM
            bpy.data.images[TexDNM].filepath_raw = fixlocate+TexDNM
        f17 = bpimg(bnm)
        #for f8 in f8:
        if f17 is not None:
            bpy.data.images[bnm].name = TexBNM
            bpy.data.images[TexBNM].filepath = fixlocate+TexBNM
            bpy.data.images[TexBNM].filepath_raw = fixlocate+TexBNM
        f18 = bpimg(sgm)
        #for f8 in f8:
        if f18 is not None:
            bpy.data.images[sgm].name = TexSGM
            bpy.data.images[TexSGM].filepath = fixlocate+TexSGM
            bpy.data.images[TexSGM].filepath_raw = fixlocate+TexSGM
        f19 = bpimg(om)
        #for f8 in f8:
        if f19 is not None:
            bpy.data.images[om].name = TexOM
            bpy.data.images[TexOM].filepath = fixlocate+TexOM
            bpy.data.images[TexOM].filepath_raw = fixlocate+TexOM
        f20 = bpimg(tss)
        #for f8 in f8:
        if f20 is not None:
            bpy.data.images[tss].name = TexTSS
            bpy.data.images[TexTSS].filepath = fixlocate+TexTSS
            bpy.data.images[TexTSS].filepath_raw = fixlocate+TexTSS
        f21 = bpimg(mgm)
        #for f8 in f8:
        if f21 is not None:
            bpy.data.images[mgm].name = TexMGM
            bpy.data.images[TexMGM].filepath = fixlocate+TexMGM
            bpy.data.images[TexMGM].filepath_raw = fixlocate+TexMGM
        f22 = bpimg(ov)
        #for f8 in f8:
        if f22 is not None:
            bpy.data.images[ov].name = TexOV
            bpy.data.images[TexOV].filepath = fixlocate+TexOV
            bpy.data.images[TexOV].filepath_raw = fixlocate+TexOV
        bpy.ops.file.find_missing_files('INVOKE_DEFAULT')
        return {"FINISHED"}

    def invoke(self, context, event):
        return self.execute(context)


class SNA_OT_Kkppanties_B34Cf(bpy.types.Operator):
    bl_idname = "sna.kkppanties_b34cf"
    bl_label = "kkp-panties"
    bl_description = "PANTIES"
    bl_options = {"REGISTER", "UNDO"}

    @classmethod
    def poll(cls, context):
        return not False

    def execute(self, context):
        import os
        ########################################################################
        my_mat = bpy.context.object.material_slots[0].material
        print(my_mat.name)
        Tex=my_mat.name
        rem_mat = bpy.data.materials[Tex]
        #Get the node in its node tree (replace the name below)
        node_to_delete =  rem_mat.node_tree.nodes['Principled BSDF']
        node_to_delete2 =  rem_mat.node_tree.nodes['Material Output']
        #Remove it
        rem_mat.node_tree.nodes.remove(node_to_delete)
        rem_mat.node_tree.nodes.remove(node_to_delete2)
        #Tex = material.name
        TexMain = Tex+'_MainTex.png'
        TexDetailM = Tex+'_DetailMask.png'
        TexNormal = Tex+'_NormalMap.png'
        TexNDetail = Tex+'_NormalMapDetail.png'
        TexAlphaM = Tex+'_AlphaMask.png'
        TexAnotherR = Tex+'_AnotherRamp.png'
        TexLiquidM = Tex+'_liquidmask.png'
        TexTex2 = Tex+'_Texture2.png'
        TexTex3 = Tex+'_Texture3.png'
        TexOv1 = Tex+'_overtex1.png'
        TexOv2 = Tex+'_overtex2.png'
        TexLineM = Tex+'_LineMask.png'
        TexColorM = Tex+'_ColorMask.png'
        TexHairG = Tex+'_HairGloss.png'
        TexBump = Tex+'_BumpMap.png'
        TexDNM = Tex+'_DetailNormalMap.png'
        TexBNM = Tex+'_BlendNormalMap.png'
        TexSGM = Tex+'_SpecGlossMap.png'
        TexOM = Tex+'_OcclusionMap.png'
        TexTSS = Tex+'_Thickness.png'
        TexMGM = Tex+'_MetallicGlossMap.png'
        TexOV = Tex+'_OverTex.png'
        originaltex = 'cf_m_shorts_01_'
        #originaltss = 'cf_m_body_01_'
        #kkp
        nm = originaltex+'NormalMap.png'
        nd = originaltex+'NormalMapDetail.png'
        dm = originaltex+'DetailMask.png'
        mm = originaltex+'MainTex.png'
        t3 = originaltex+'Texture3.png'
        t2 = originaltex+'Texture2.png'
        am = originaltex+'AlphaMask.png'
        lm = originaltex+'liquidmask.png'
        ar = originaltex+'AnotherRamp.png'
        ov1 = originaltex+'overtex1.png'
        ov2 = originaltex+'overtex2.png'
        lnm = originaltex+'LineMask.png'
        com = originaltex+'ColorMask.png'
        glo = originaltex+'HairGloss.png'
        #hs1
        bum = originaltex+'BumpMap.png'
        dnm = originaltex+'DetailNormalMap.png'
        bnm = originaltex+'BlendNormalMap.png'
        sgm = originaltex+'SpecGlossMap.png'
        om = originaltex+'OcclusionMap.png'
        tss = originaltex+'Thickness.png'
        mgm = originaltex+'MetallicGlossMap.png'
        ov = originaltex+'OverTex.png'
        Template='KK-Template Panties'
        CTemplate=Template+' '
        C = bpy.context

        def instantiate_group(nodes, data_block_name):
            group = nodes.new(type='ShaderNodeGroup')
            group.node_tree = bpy.data.node_groups[Template]
            return group
        if Template in bpy.data.node_groups:
            instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
        else:
        #    versions = ( t0, t1, t2, t3, t4)
        #    for x in versions:
        #        if os.path.isdir(x) and os.access(x, os.R_OK):
            if (3, 0, 0) <= bpy.app.version < (3, 0, 99):
                before_data = list(bpy.data.node_groups)
                bpy.ops.wm.append(directory=os.path.expanduser(r"~\AppData\Roaming\Blender Foundation\Blender\3.0\scripts\addons\sklx_creator\assets\KK_Template_Shader.blend") + r'\NodeTree',filename=Template,link=False)
                new_data=list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
                appended_2B5AC = None if not new_data else new_data[0]
                instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
            else:
                if (3, 1, 0) <= bpy.app.version < (3, 1, 99):
                    before_data = list(bpy.data.node_groups)
                    bpy.ops.wm.append(directory=os.path.expanduser(r"~\AppData\Roaming\Blender Foundation\Blender\3.1\scripts\addons\sklx_creator\assets\KK_Template_Shader.blend") + r'\NodeTree',filename=Template,link=False)
                    new_data=list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
                    appended_2B5AC = None if not new_data else new_data[0]
                    instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
                else:
                    if (3, 2, 0) <= bpy.app.version < (3, 2, 99):
                        before_data = list(bpy.data.node_groups)
                        bpy.ops.wm.append(directory=os.path.expanduser(r"~\AppData\Roaming\Blender Foundation\Blender\3.2\scripts\addons\sklx_creator\assets\KK_Template_Shader.blend") + r'\NodeTree',filename=Template,link=False)
                        new_data=list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
                        appended_2B5AC = None if not new_data else new_data[0]
                        instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
                    else:
                        if (3, 3, 0) <= bpy.app.version < (3, 3, 99):
                            before_data = list(bpy.data.node_groups)
                            bpy.ops.wm.append(directory=os.path.expanduser(r"~\AppData\Roaming\Blender Foundation\Blender\3.3\scripts\addons\sklx_creator\assets\KK_Template_Shader.blend") + r'\NodeTree',filename=Template,link=False)
                            new_data=list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
                            appended_2B5AC = None if not new_data else new_data[0]
                            instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
                        else:
                            if (3, 4, 0) <= bpy.app.version < (3, 4, 99):
                                before_data = list(bpy.data.node_groups)
                                bpy.ops.wm.append(directory=os.path.expanduser(r"~\AppData\Roaming\Blender Foundation\Blender\3.4\scripts\addons\sklx_creator\assets\KK_Template_Shader.blend") + r'\NodeTree',filename=Template,link=False)
                                new_data=list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
                                appended_2B5AC = None if not new_data else new_data[0]
                                instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
        bpy.data.node_groups[Template].name = CTemplate+Tex
        node = bpy.data.node_groups[CTemplate+Tex]
        #initial_area_type = bpy.context.area.type
        #bpy.context.area.type = 'NODE_EDITOR'
        #bpy.context.area.ui_type = 'ShaderNodeTree'
        #bpy.ops.wm.redraw_timer(type='DRAW_WIN', iterations=1)
        #bpy.ops.node.group_ungroup()
        #bpy.ops.node.group_edit(exit=True)
        #bpy.context.area.type = initial_area_type
        nodes = my_mat.node_tree.nodes
        for node in nodes:
            #node.select = False
            print(node.name)
            node.select = True
            nodes.active = node
        try:
            initial_area_type = bpy.context.area.type
            bpy.context.area.type = 'NODE_EDITOR'
            bpy.context.area.ui_type = 'ShaderNodeTree'
            bpy.ops.wm.redraw_timer(type='DRAW_WIN', iterations=1)
            bpy.ops.node.group_ungroup()
            nonono = node," to Ungroup"
            print(nonono)
            bpy.ops.node.group_edit(exit=True)
        except Exception as e:
            print(e)
        finally:
            bpy.context.area.type = initial_area_type
        fixlocate = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\\20220603141428_Chika_Haruno\\Textures\\"
        bpimg = bpy.data.images.get
        if 1==1:
            print(mm)
            print(dm)
            print(nm)
            print(t2)
            print(t3)
        #formula_list=(nm,nd,dm,mm,t2,t3,am,lm,ar,ov1,ov2,lnm,com,glo,bum,dnm,bnm,sgm,om,tss,mgm,ov)
        #for formula in formula_list:
        #    if bpimg(formula) is not None:
        f1 = bpimg(mm)
        #for x in f1:
        if f1 is not None:
            bpy.data.images[mm].name = TexMain
            bpy.data.images[TexMain].filepath = fixlocate+TexMain
            bpy.data.images[TexMain].filepath_raw = fixlocate+TexMain
        f2 = bpimg(dm)
        #for x in f2:
        if f2 is not None:
            bpy.data.images[dm].name = TexDetailM
            bpy.data.images[TexDetailM].filepath = fixlocate+TexDetailM
            bpy.data.images[TexDetailM].filepath_raw = fixlocate+TexDetailM
        f3 = bpimg(nm)
        #for x in f3:
        if f3 is not None:
            bpy.data.images[nm].name = TexNormal
            bpy.data.images[TexNormal].filepath = fixlocate+TexNormal
            bpy.data.images[TexNormal].filepath_raw = fixlocate+TexNormal
        f4 = bpimg(t2)
        #for x in f3:
        if f4 is not None:
            bpy.data.images[t2].name = TexTex2
            bpy.data.images[TexTex2].filepath = fixlocate+TexTex2
            bpy.data.images[TexTex2].filepath_raw = fixlocate+TexTex2
        f5 = bpimg(t3)
        #for x in f4:
        if f5 is not None:
            bpy.data.images[t3].name = TexTex3
            bpy.data.images[TexTex3].filepath = fixlocate+TexTex3
            bpy.data.images[TexTex3].filepath_raw = fixlocate+TexTex3
        f6 = bpimg(am)
        #for x in f5:
        if f6 is not None:
            bpy.data.images[am].name = TexAlphaM
            bpy.data.images[TexAlphaM].filepath = fixlocate+TexAlphaM
            bpy.data.images[TexAlphaM].filepath_raw = fixlocate+TexAlphaM
        f7 = bpimg(lm)
        #for x in f6:
        if f7 is not None:
            bpy.data.images[lm].name = TexLiquidM
            bpy.data.images[TexLiquidM].filepath = fixlocate+TexLiquidM
            bpy.data.images[TexLiquidM].filepath_raw = fixlocate+TexLiquidM
        f8 = bpimg(ar)
        #for f8 in f8:
        if f8 is not None:
            bpy.data.images[ar].name = TexAnotherR
            bpy.data.images[TexAnotherR].filepath = fixlocate+TexAnotherR
            bpy.data.images[TexAnotherR].filepath_raw = fixlocate+TexAnotherR
        f9 = bpimg(nd)
        #for f8 in f8:
        if f9 is not None:
            bpy.data.images[nd].name = TexNDetail
            bpy.data.images[TexNDetail].filepath = fixlocate+TexNDetail
            bpy.data.images[TexNDetail].filepath_raw = fixlocate+TexNDetail
        f10 = bpimg(ov1)
        #for f8 in f8:
        if f10 is not None:
            bpy.data.images[ov1].name = TexOv1
            bpy.data.images[TexOv1].filepath = fixlocate+TexOv1
            bpy.data.images[TexOv1].filepath_raw = fixlocate+TexOv1
        f11 = bpimg(ov2)
        #for f8 in f8:
        if f11 is not None:
            bpy.data.images[ov2].name = TexOv2
            bpy.data.images[TexOv2].filepath = fixlocate+TexOv2
            bpy.data.images[TexOv2].filepath_raw = fixlocate+TexOv2
        f12 = bpimg(lnm)
        #for f8 in f8:
        if f12 is not None:
            bpy.data.images[lnm].name = TexLineM
            bpy.data.images[TexLineM].filepath = fixlocate+TexLineM
            bpy.data.images[TexLineM].filepath_raw = fixlocate+TexLineM
        f13 = bpimg(com)
        #for f8 in f8:
        if f13 is not None:
            bpy.data.images[com].name = TexColorM
            bpy.data.images[TexColorM].filepath = fixlocate+TexColorM
            bpy.data.images[TexColorM].filepath_raw = fixlocate+TexColorM
        f14 = bpimg(glo)
        #for f8 in f8:
        if f14 is not None:
            bpy.data.images[glo].name = TexHairG
            bpy.data.images[TexHairG].filepath = fixlocate+TexHairG
            bpy.data.images[TexHairG].filepath_raw = fixlocate+TexHairG
        f15 = bpimg(bum)
        #for f8 in f8:
        if f15 is not None:
            bpy.data.images[bum].name = TexBump
            bpy.data.images[TexBump].filepath = fixlocate+TexBump
            bpy.data.images[TexBump].filepath_raw = fixlocate+TexBump
        f16 = bpimg(dnm)
        #for f8 in f8:
        if f16 is not None:
            bpy.data.images[dnm].name = TexDNM
            bpy.data.images[TexDNM].filepath = fixlocate+TexDNM
            bpy.data.images[TexDNM].filepath_raw = fixlocate+TexDNM
        f17 = bpimg(bnm)
        #for f8 in f8:
        if f17 is not None:
            bpy.data.images[bnm].name = TexBNM
            bpy.data.images[TexBNM].filepath = fixlocate+TexBNM
            bpy.data.images[TexBNM].filepath_raw = fixlocate+TexBNM
        f18 = bpimg(sgm)
        #for f8 in f8:
        if f18 is not None:
            bpy.data.images[sgm].name = TexSGM
            bpy.data.images[TexSGM].filepath = fixlocate+TexSGM
            bpy.data.images[TexSGM].filepath_raw = fixlocate+TexSGM
        f19 = bpimg(om)
        #for f8 in f8:
        if f19 is not None:
            bpy.data.images[om].name = TexOM
            bpy.data.images[TexOM].filepath = fixlocate+TexOM
            bpy.data.images[TexOM].filepath_raw = fixlocate+TexOM
        f20 = bpimg(tss)
        #for f8 in f8:
        if f20 is not None:
            bpy.data.images[tss].name = TexTSS
            bpy.data.images[TexTSS].filepath = fixlocate+TexTSS
            bpy.data.images[TexTSS].filepath_raw = fixlocate+TexTSS
        f21 = bpimg(mgm)
        #for f8 in f8:
        if f21 is not None:
            bpy.data.images[mgm].name = TexMGM
            bpy.data.images[TexMGM].filepath = fixlocate+TexMGM
            bpy.data.images[TexMGM].filepath_raw = fixlocate+TexMGM
        f22 = bpimg(ov)
        #for f8 in f8:
        if f22 is not None:
            bpy.data.images[ov].name = TexOV
            bpy.data.images[TexOV].filepath = fixlocate+TexOV
            bpy.data.images[TexOV].filepath_raw = fixlocate+TexOV
        bpy.ops.file.find_missing_files('INVOKE_DEFAULT')
        return {"FINISHED"}

    def invoke(self, context, event):
        return self.execute(context)


class SNA_OT_Kkpshoes_Ec253(bpy.types.Operator):
    bl_idname = "sna.kkpshoes_ec253"
    bl_label = "kkp-shoes"
    bl_description = "SHOES"
    bl_options = {"REGISTER", "UNDO"}

    @classmethod
    def poll(cls, context):
        return not False

    def execute(self, context):
        import os
        ########################################################################
        my_mat = bpy.context.object.material_slots[0].material
        print(my_mat.name)
        Tex=my_mat.name
        rem_mat = bpy.data.materials[Tex]
        #Get the node in its node tree (replace the name below)
        node_to_delete =  rem_mat.node_tree.nodes['Principled BSDF']
        node_to_delete2 =  rem_mat.node_tree.nodes['Material Output']
        #Remove it
        rem_mat.node_tree.nodes.remove(node_to_delete)
        rem_mat.node_tree.nodes.remove(node_to_delete2)
        #Tex = material.name
        TexMain = Tex+'_MainTex.png'
        TexDetailM = Tex+'_DetailMask.png'
        TexNormal = Tex+'_NormalMap.png'
        TexNDetail = Tex+'_NormalMapDetail.png'
        TexAlphaM = Tex+'_AlphaMask.png'
        TexAnotherR = Tex+'_AnotherRamp.png'
        TexLiquidM = Tex+'_liquidmask.png'
        TexTex2 = Tex+'_Texture2.png'
        TexTex3 = Tex+'_Texture3.png'
        TexOv1 = Tex+'_overtex1.png'
        TexOv2 = Tex+'_overtex2.png'
        TexLineM = Tex+'_LineMask.png'
        TexColorM = Tex+'_ColorMask.png'
        TexHairG = Tex+'_HairGloss.png'
        TexBump = Tex+'_BumpMap.png'
        TexDNM = Tex+'_DetailNormalMap.png'
        TexBNM = Tex+'_BlendNormalMap.png'
        TexSGM = Tex+'_SpecGlossMap.png'
        TexOM = Tex+'_OcclusionMap.png'
        TexTSS = Tex+'_Thickness.png'
        TexMGM = Tex+'_MetallicGlossMap.png'
        TexOV = Tex+'_OverTex.png'
        originaltex = 'cf_m_shoes_roafer01_'
        #originaltss = 'cf_m_body_01_'
        #kkp
        nm = originaltex+'NormalMap.png'
        nd = originaltex+'NormalMapDetail.png'
        dm = originaltex+'DetailMask.png'
        mm = originaltex+'MainTex.png'
        t3 = originaltex+'Texture3.png'
        t2 = originaltex+'Texture2.png'
        am = originaltex+'AlphaMask.png'
        lm = originaltex+'liquidmask.png'
        ar = originaltex+'AnotherRamp.png'
        ov1 = originaltex+'overtex1.png'
        ov2 = originaltex+'overtex2.png'
        lnm = originaltex+'LineMask.png'
        com = originaltex+'ColorMask.png'
        glo = originaltex+'HairGloss.png'
        #hs1
        bum = originaltex+'BumpMap.png'
        dnm = originaltex+'DetailNormalMap.png'
        bnm = originaltex+'BlendNormalMap.png'
        sgm = originaltex+'SpecGlossMap.png'
        om = originaltex+'OcclusionMap.png'
        tss = originaltex+'Thickness.png'
        mgm = originaltex+'MetallicGlossMap.png'
        ov = originaltex+'OverTex.png'
        Template='KK-Template Shoes'
        CTemplate=Template+' '
        C = bpy.context

        def instantiate_group(nodes, data_block_name):
            group = nodes.new(type='ShaderNodeGroup')
            group.node_tree = bpy.data.node_groups[Template]
            return group
        if Template in bpy.data.node_groups:
            instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
        else:
        #    versions = ( t0, t1, t2, t3, t4)
        #    for x in versions:
        #        if os.path.isdir(x) and os.access(x, os.R_OK):
            if (3, 0, 0) <= bpy.app.version < (3, 0, 99):
                before_data = list(bpy.data.node_groups)
                bpy.ops.wm.append(directory=os.path.expanduser(r"~\AppData\Roaming\Blender Foundation\Blender\3.0\scripts\addons\sklx_creator\assets\KK_Template_Shader.blend") + r'\NodeTree',filename=Template,link=False)
                new_data=list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
                appended_2B5AC = None if not new_data else new_data[0]
                instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
            else:
                if (3, 1, 0) <= bpy.app.version < (3, 1, 99):
                    before_data = list(bpy.data.node_groups)
                    bpy.ops.wm.append(directory=os.path.expanduser(r"~\AppData\Roaming\Blender Foundation\Blender\3.1\scripts\addons\sklx_creator\assets\KK_Template_Shader.blend") + r'\NodeTree',filename=Template,link=False)
                    new_data=list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
                    appended_2B5AC = None if not new_data else new_data[0]
                    instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
                else:
                    if (3, 2, 0) <= bpy.app.version < (3, 2, 99):
                        before_data = list(bpy.data.node_groups)
                        bpy.ops.wm.append(directory=os.path.expanduser(r"~\AppData\Roaming\Blender Foundation\Blender\3.2\scripts\addons\sklx_creator\assets\KK_Template_Shader.blend") + r'\NodeTree',filename=Template,link=False)
                        new_data=list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
                        appended_2B5AC = None if not new_data else new_data[0]
                        instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
                    else:
                        if (3, 3, 0) <= bpy.app.version < (3, 3, 99):
                            before_data = list(bpy.data.node_groups)
                            bpy.ops.wm.append(directory=os.path.expanduser(r"~\AppData\Roaming\Blender Foundation\Blender\3.3\scripts\addons\sklx_creator\assets\KK_Template_Shader.blend") + r'\NodeTree',filename=Template,link=False)
                            new_data=list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
                            appended_2B5AC = None if not new_data else new_data[0]
                            instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
                        else:
                            if (3, 4, 0) <= bpy.app.version < (3, 4, 99):
                                before_data = list(bpy.data.node_groups)
                                bpy.ops.wm.append(directory=os.path.expanduser(r"~\AppData\Roaming\Blender Foundation\Blender\3.4\scripts\addons\sklx_creator\assets\KK_Template_Shader.blend") + r'\NodeTree',filename=Template,link=False)
                                new_data=list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
                                appended_2B5AC = None if not new_data else new_data[0]
                                instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
        bpy.data.node_groups[Template].name = CTemplate+Tex
        node = bpy.data.node_groups[CTemplate+Tex]
        #initial_area_type = bpy.context.area.type
        #bpy.context.area.type = 'NODE_EDITOR'
        #bpy.context.area.ui_type = 'ShaderNodeTree'
        #bpy.ops.wm.redraw_timer(type='DRAW_WIN', iterations=1)
        #bpy.ops.node.group_ungroup()
        #bpy.ops.node.group_edit(exit=True)
        #bpy.context.area.type = initial_area_type
        nodes = my_mat.node_tree.nodes
        for node in nodes:
            #node.select = False
            print(node.name)
            node.select = True
            nodes.active = node
        try:
            initial_area_type = bpy.context.area.type
            bpy.context.area.type = 'NODE_EDITOR'
            bpy.context.area.ui_type = 'ShaderNodeTree'
            bpy.ops.wm.redraw_timer(type='DRAW_WIN', iterations=1)
            bpy.ops.node.group_ungroup()
            nonono = node," to Ungroup"
            print(nonono)
            bpy.ops.node.group_edit(exit=True)
        except Exception as e:
            print(e)
        finally:
            bpy.context.area.type = initial_area_type
        fixlocate = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\\20220603141428_Chika_Haruno\\Textures\\"
        bpimg = bpy.data.images.get
        if 1==1:
            print(mm)
            print(dm)
            print(nm)
            print(t2)
            print(t3)
        #formula_list=(nm,nd,dm,mm,t2,t3,am,lm,ar,ov1,ov2,lnm,com,glo,bum,dnm,bnm,sgm,om,tss,mgm,ov)
        #for formula in formula_list:
        #    if bpimg(formula) is not None:
        f1 = bpimg(mm)
        #for x in f1:
        if f1 is not None:
            bpy.data.images[mm].name = TexMain
            bpy.data.images[TexMain].filepath = fixlocate+TexMain
            bpy.data.images[TexMain].filepath_raw = fixlocate+TexMain
        f2 = bpimg(dm)
        #for x in f2:
        if f2 is not None:
            bpy.data.images[dm].name = TexDetailM
            bpy.data.images[TexDetailM].filepath = fixlocate+TexDetailM
            bpy.data.images[TexDetailM].filepath_raw = fixlocate+TexDetailM
        f3 = bpimg(nm)
        #for x in f3:
        if f3 is not None:
            bpy.data.images[nm].name = TexNormal
            bpy.data.images[TexNormal].filepath = fixlocate+TexNormal
            bpy.data.images[TexNormal].filepath_raw = fixlocate+TexNormal
        f4 = bpimg(t2)
        #for x in f3:
        if f4 is not None:
            bpy.data.images[t2].name = TexTex2
            bpy.data.images[TexTex2].filepath = fixlocate+TexTex2
            bpy.data.images[TexTex2].filepath_raw = fixlocate+TexTex2
        f5 = bpimg(t3)
        #for x in f4:
        if f5 is not None:
            bpy.data.images[t3].name = TexTex3
            bpy.data.images[TexTex3].filepath = fixlocate+TexTex3
            bpy.data.images[TexTex3].filepath_raw = fixlocate+TexTex3
        f6 = bpimg(am)
        #for x in f5:
        if f6 is not None:
            bpy.data.images[am].name = TexAlphaM
            bpy.data.images[TexAlphaM].filepath = fixlocate+TexAlphaM
            bpy.data.images[TexAlphaM].filepath_raw = fixlocate+TexAlphaM
        f7 = bpimg(lm)
        #for x in f6:
        if f7 is not None:
            bpy.data.images[lm].name = TexLiquidM
            bpy.data.images[TexLiquidM].filepath = fixlocate+TexLiquidM
            bpy.data.images[TexLiquidM].filepath_raw = fixlocate+TexLiquidM
        f8 = bpimg(ar)
        #for f8 in f8:
        if f8 is not None:
            bpy.data.images[ar].name = TexAnotherR
            bpy.data.images[TexAnotherR].filepath = fixlocate+TexAnotherR
            bpy.data.images[TexAnotherR].filepath_raw = fixlocate+TexAnotherR
        f9 = bpimg(nd)
        #for f8 in f8:
        if f9 is not None:
            bpy.data.images[nd].name = TexNDetail
            bpy.data.images[TexNDetail].filepath = fixlocate+TexNDetail
            bpy.data.images[TexNDetail].filepath_raw = fixlocate+TexNDetail
        f10 = bpimg(ov1)
        #for f8 in f8:
        if f10 is not None:
            bpy.data.images[ov1].name = TexOv1
            bpy.data.images[TexOv1].filepath = fixlocate+TexOv1
            bpy.data.images[TexOv1].filepath_raw = fixlocate+TexOv1
        f11 = bpimg(ov2)
        #for f8 in f8:
        if f11 is not None:
            bpy.data.images[ov2].name = TexOv2
            bpy.data.images[TexOv2].filepath = fixlocate+TexOv2
            bpy.data.images[TexOv2].filepath_raw = fixlocate+TexOv2
        f12 = bpimg(lnm)
        #for f8 in f8:
        if f12 is not None:
            bpy.data.images[lnm].name = TexLineM
            bpy.data.images[TexLineM].filepath = fixlocate+TexLineM
            bpy.data.images[TexLineM].filepath_raw = fixlocate+TexLineM
        f13 = bpimg(com)
        #for f8 in f8:
        if f13 is not None:
            bpy.data.images[com].name = TexColorM
            bpy.data.images[TexColorM].filepath = fixlocate+TexColorM
            bpy.data.images[TexColorM].filepath_raw = fixlocate+TexColorM
        f14 = bpimg(glo)
        #for f8 in f8:
        if f14 is not None:
            bpy.data.images[glo].name = TexHairG
            bpy.data.images[TexHairG].filepath = fixlocate+TexHairG
            bpy.data.images[TexHairG].filepath_raw = fixlocate+TexHairG
        f15 = bpimg(bum)
        #for f8 in f8:
        if f15 is not None:
            bpy.data.images[bum].name = TexBump
            bpy.data.images[TexBump].filepath = fixlocate+TexBump
            bpy.data.images[TexBump].filepath_raw = fixlocate+TexBump
        f16 = bpimg(dnm)
        #for f8 in f8:
        if f16 is not None:
            bpy.data.images[dnm].name = TexDNM
            bpy.data.images[TexDNM].filepath = fixlocate+TexDNM
            bpy.data.images[TexDNM].filepath_raw = fixlocate+TexDNM
        f17 = bpimg(bnm)
        #for f8 in f8:
        if f17 is not None:
            bpy.data.images[bnm].name = TexBNM
            bpy.data.images[TexBNM].filepath = fixlocate+TexBNM
            bpy.data.images[TexBNM].filepath_raw = fixlocate+TexBNM
        f18 = bpimg(sgm)
        #for f8 in f8:
        if f18 is not None:
            bpy.data.images[sgm].name = TexSGM
            bpy.data.images[TexSGM].filepath = fixlocate+TexSGM
            bpy.data.images[TexSGM].filepath_raw = fixlocate+TexSGM
        f19 = bpimg(om)
        #for f8 in f8:
        if f19 is not None:
            bpy.data.images[om].name = TexOM
            bpy.data.images[TexOM].filepath = fixlocate+TexOM
            bpy.data.images[TexOM].filepath_raw = fixlocate+TexOM
        f20 = bpimg(tss)
        #for f8 in f8:
        if f20 is not None:
            bpy.data.images[tss].name = TexTSS
            bpy.data.images[TexTSS].filepath = fixlocate+TexTSS
            bpy.data.images[TexTSS].filepath_raw = fixlocate+TexTSS
        f21 = bpimg(mgm)
        #for f8 in f8:
        if f21 is not None:
            bpy.data.images[mgm].name = TexMGM
            bpy.data.images[TexMGM].filepath = fixlocate+TexMGM
            bpy.data.images[TexMGM].filepath_raw = fixlocate+TexMGM
        f22 = bpimg(ov)
        #for f8 in f8:
        if f22 is not None:
            bpy.data.images[ov].name = TexOV
            bpy.data.images[TexOV].filepath = fixlocate+TexOV
            bpy.data.images[TexOV].filepath_raw = fixlocate+TexOV
        bpy.ops.file.find_missing_files('INVOKE_DEFAULT')
        return {"FINISHED"}

    def invoke(self, context, event):
        return self.execute(context)


class SNA_OT_Kkpaccs_8314B(bpy.types.Operator):
    bl_idname = "sna.kkpaccs_8314b"
    bl_label = "kkp-accs"
    bl_description = "ACCS"
    bl_options = {"REGISTER", "UNDO"}

    @classmethod
    def poll(cls, context):
        return not False

    def execute(self, context):
        import os
        ########################################################################
        my_mat = bpy.context.object.material_slots[0].material
        print(my_mat.name)
        Tex=my_mat.name
        rem_mat = bpy.data.materials[Tex]
        #Get the node in its node tree (replace the name below)
        node_to_delete =  rem_mat.node_tree.nodes['Principled BSDF']
        node_to_delete2 =  rem_mat.node_tree.nodes['Material Output']
        #Remove it
        rem_mat.node_tree.nodes.remove(node_to_delete)
        rem_mat.node_tree.nodes.remove(node_to_delete2)
        #Tex = material.name
        TexMain = Tex+'_MainTex.png'
        TexDetailM = Tex+'_DetailMask.png'
        TexNormal = Tex+'_NormalMap.png'
        TexNDetail = Tex+'_NormalMapDetail.png'
        TexAlphaM = Tex+'_AlphaMask.png'
        TexAnotherR = Tex+'_AnotherRamp.png'
        TexLiquidM = Tex+'_liquidmask.png'
        TexTex2 = Tex+'_Texture2.png'
        TexTex3 = Tex+'_Texture3.png'
        TexOv1 = Tex+'_overtex1.png'
        TexOv2 = Tex+'_overtex2.png'
        TexLineM = Tex+'_LineMask.png'
        TexColorM = Tex+'_ColorMask.png'
        TexHairG = Tex+'_HairGloss.png'
        TexBump = Tex+'_BumpMap.png'
        TexDNM = Tex+'_DetailNormalMap.png'
        TexBNM = Tex+'_BlendNormalMap.png'
        TexSGM = Tex+'_SpecGlossMap.png'
        TexOM = Tex+'_OcclusionMap.png'
        TexTSS = Tex+'_Thickness.png'
        TexMGM = Tex+'_MetallicGlossMap.png'
        TexOV = Tex+'_OverTex.png'
        originaltex = 'cf_m_top_deco01_'
        #originaltss = 'cf_m_body_01_'
        #kkp
        nm = originaltex+'NormalMap.png'
        nd = originaltex+'NormalMapDetail.png'
        dm = originaltex+'DetailMask.png'
        mm = originaltex+'MainTex.png'
        t3 = originaltex+'Texture3.png'
        t2 = originaltex+'Texture2.png'
        am = originaltex+'AlphaMask.png'
        lm = originaltex+'liquidmask.png'
        ar = originaltex+'AnotherRamp.png'
        ov1 = originaltex+'overtex1.png'
        ov2 = originaltex+'overtex2.png'
        lnm = originaltex+'LineMask.png'
        com = originaltex+'ColorMask.png'
        glo = originaltex+'HairGloss.png'
        #hs1
        bum = originaltex+'BumpMap.png'
        dnm = originaltex+'DetailNormalMap.png'
        bnm = originaltex+'BlendNormalMap.png'
        sgm = originaltex+'SpecGlossMap.png'
        om = originaltex+'OcclusionMap.png'
        tss = originaltex+'Thickness.png'
        mgm = originaltex+'MetallicGlossMap.png'
        ov = originaltex+'OverTex.png'
        Template='KK-Template Accesories'
        CTemplate=Template+' '
        C = bpy.context

        def instantiate_group(nodes, data_block_name):
            group = nodes.new(type='ShaderNodeGroup')
            group.node_tree = bpy.data.node_groups[Template]
            return group
        if Template in bpy.data.node_groups:
            instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
        else:
        #    versions = ( t0, t1, t2, t3, t4)
        #    for x in versions:
        #        if os.path.isdir(x) and os.access(x, os.R_OK):
            if (3, 0, 0) <= bpy.app.version < (3, 0, 99):
                before_data = list(bpy.data.node_groups)
                bpy.ops.wm.append(directory=os.path.expanduser(r"~\AppData\Roaming\Blender Foundation\Blender\3.0\scripts\addons\sklx_creator\assets\KK_Template_Shader.blend") + r'\NodeTree',filename=Template,link=False)
                new_data=list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
                appended_2B5AC = None if not new_data else new_data[0]
                instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
            else:
                if (3, 1, 0) <= bpy.app.version < (3, 1, 99):
                    before_data = list(bpy.data.node_groups)
                    bpy.ops.wm.append(directory=os.path.expanduser(r"~\AppData\Roaming\Blender Foundation\Blender\3.1\scripts\addons\sklx_creator\assets\KK_Template_Shader.blend") + r'\NodeTree',filename=Template,link=False)
                    new_data=list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
                    appended_2B5AC = None if not new_data else new_data[0]
                    instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
                else:
                    if (3, 2, 0) <= bpy.app.version < (3, 2, 99):
                        before_data = list(bpy.data.node_groups)
                        bpy.ops.wm.append(directory=os.path.expanduser(r"~\AppData\Roaming\Blender Foundation\Blender\3.2\scripts\addons\sklx_creator\assets\KK_Template_Shader.blend") + r'\NodeTree',filename=Template,link=False)
                        new_data=list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
                        appended_2B5AC = None if not new_data else new_data[0]
                        instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
                    else:
                        if (3, 3, 0) <= bpy.app.version < (3, 3, 99):
                            before_data = list(bpy.data.node_groups)
                            bpy.ops.wm.append(directory=os.path.expanduser(r"~\AppData\Roaming\Blender Foundation\Blender\3.3\scripts\addons\sklx_creator\assets\KK_Template_Shader.blend") + r'\NodeTree',filename=Template,link=False)
                            new_data=list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
                            appended_2B5AC = None if not new_data else new_data[0]
                            instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
                        else:
                            if (3, 4, 0) <= bpy.app.version < (3, 4, 99):
                                before_data = list(bpy.data.node_groups)
                                bpy.ops.wm.append(directory=os.path.expanduser(r"~\AppData\Roaming\Blender Foundation\Blender\3.4\scripts\addons\sklx_creator\assets\KK_Template_Shader.blend") + r'\NodeTree',filename=Template,link=False)
                                new_data=list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
                                appended_2B5AC = None if not new_data else new_data[0]
                                instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
        bpy.data.node_groups[Template].name = CTemplate+Tex
        node = bpy.data.node_groups[CTemplate+Tex]
        #initial_area_type = bpy.context.area.type
        #bpy.context.area.type = 'NODE_EDITOR'
        #bpy.context.area.ui_type = 'ShaderNodeTree'
        #bpy.ops.wm.redraw_timer(type='DRAW_WIN', iterations=1)
        #bpy.ops.node.group_ungroup()
        #bpy.ops.node.group_edit(exit=True)
        #bpy.context.area.type = initial_area_type
        nodes = my_mat.node_tree.nodes
        for node in nodes:
            #node.select = False
            print(node.name)
            node.select = True
            nodes.active = node
        try:
            initial_area_type = bpy.context.area.type
            bpy.context.area.type = 'NODE_EDITOR'
            bpy.context.area.ui_type = 'ShaderNodeTree'
            bpy.ops.wm.redraw_timer(type='DRAW_WIN', iterations=1)
            bpy.ops.node.group_ungroup()
            nonono = node," to Ungroup"
            print(nonono)
            bpy.ops.node.group_edit(exit=True)
        except Exception as e:
            print(e)
        finally:
            bpy.context.area.type = initial_area_type
        fixlocate = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\\20220603141428_Chika_Haruno\\Textures\\"
        bpimg = bpy.data.images.get
        if 1==1:
            print(mm)
            print(dm)
            print(nm)
            print(t2)
            print(t3)
        #formula_list=(nm,nd,dm,mm,t2,t3,am,lm,ar,ov1,ov2,lnm,com,glo,bum,dnm,bnm,sgm,om,tss,mgm,ov)
        #for formula in formula_list:
        #    if bpimg(formula) is not None:
        f1 = bpimg(mm)
        #for x in f1:
        if f1 is not None:
            bpy.data.images[mm].name = TexMain
            bpy.data.images[TexMain].filepath = fixlocate+TexMain
            bpy.data.images[TexMain].filepath_raw = fixlocate+TexMain
        f2 = bpimg(dm)
        #for x in f2:
        if f2 is not None:
            bpy.data.images[dm].name = TexDetailM
            bpy.data.images[TexDetailM].filepath = fixlocate+TexDetailM
            bpy.data.images[TexDetailM].filepath_raw = fixlocate+TexDetailM
        f3 = bpimg(nm)
        #for x in f3:
        if f3 is not None:
            bpy.data.images[nm].name = TexNormal
            bpy.data.images[TexNormal].filepath = fixlocate+TexNormal
            bpy.data.images[TexNormal].filepath_raw = fixlocate+TexNormal
        f4 = bpimg(t2)
        #for x in f3:
        if f4 is not None:
            bpy.data.images[t2].name = TexTex2
            bpy.data.images[TexTex2].filepath = fixlocate+TexTex2
            bpy.data.images[TexTex2].filepath_raw = fixlocate+TexTex2
        f5 = bpimg(t3)
        #for x in f4:
        if f5 is not None:
            bpy.data.images[t3].name = TexTex3
            bpy.data.images[TexTex3].filepath = fixlocate+TexTex3
            bpy.data.images[TexTex3].filepath_raw = fixlocate+TexTex3
        f6 = bpimg(am)
        #for x in f5:
        if f6 is not None:
            bpy.data.images[am].name = TexAlphaM
            bpy.data.images[TexAlphaM].filepath = fixlocate+TexAlphaM
            bpy.data.images[TexAlphaM].filepath_raw = fixlocate+TexAlphaM
        f7 = bpimg(lm)
        #for x in f6:
        if f7 is not None:
            bpy.data.images[lm].name = TexLiquidM
            bpy.data.images[TexLiquidM].filepath = fixlocate+TexLiquidM
            bpy.data.images[TexLiquidM].filepath_raw = fixlocate+TexLiquidM
        f8 = bpimg(ar)
        #for f8 in f8:
        if f8 is not None:
            bpy.data.images[ar].name = TexAnotherR
            bpy.data.images[TexAnotherR].filepath = fixlocate+TexAnotherR
            bpy.data.images[TexAnotherR].filepath_raw = fixlocate+TexAnotherR
        f9 = bpimg(nd)
        #for f8 in f8:
        if f9 is not None:
            bpy.data.images[nd].name = TexNDetail
            bpy.data.images[TexNDetail].filepath = fixlocate+TexNDetail
            bpy.data.images[TexNDetail].filepath_raw = fixlocate+TexNDetail
        f10 = bpimg(ov1)
        #for f8 in f8:
        if f10 is not None:
            bpy.data.images[ov1].name = TexOv1
            bpy.data.images[TexOv1].filepath = fixlocate+TexOv1
            bpy.data.images[TexOv1].filepath_raw = fixlocate+TexOv1
        f11 = bpimg(ov2)
        #for f8 in f8:
        if f11 is not None:
            bpy.data.images[ov2].name = TexOv2
            bpy.data.images[TexOv2].filepath = fixlocate+TexOv2
            bpy.data.images[TexOv2].filepath_raw = fixlocate+TexOv2
        f12 = bpimg(lnm)
        #for f8 in f8:
        if f12 is not None:
            bpy.data.images[lnm].name = TexLineM
            bpy.data.images[TexLineM].filepath = fixlocate+TexLineM
            bpy.data.images[TexLineM].filepath_raw = fixlocate+TexLineM
        f13 = bpimg(com)
        #for f8 in f8:
        if f13 is not None:
            bpy.data.images[com].name = TexColorM
            bpy.data.images[TexColorM].filepath = fixlocate+TexColorM
            bpy.data.images[TexColorM].filepath_raw = fixlocate+TexColorM
        f14 = bpimg(glo)
        #for f8 in f8:
        if f14 is not None:
            bpy.data.images[glo].name = TexHairG
            bpy.data.images[TexHairG].filepath = fixlocate+TexHairG
            bpy.data.images[TexHairG].filepath_raw = fixlocate+TexHairG
        f15 = bpimg(bum)
        #for f8 in f8:
        if f15 is not None:
            bpy.data.images[bum].name = TexBump
            bpy.data.images[TexBump].filepath = fixlocate+TexBump
            bpy.data.images[TexBump].filepath_raw = fixlocate+TexBump
        f16 = bpimg(dnm)
        #for f8 in f8:
        if f16 is not None:
            bpy.data.images[dnm].name = TexDNM
            bpy.data.images[TexDNM].filepath = fixlocate+TexDNM
            bpy.data.images[TexDNM].filepath_raw = fixlocate+TexDNM
        f17 = bpimg(bnm)
        #for f8 in f8:
        if f17 is not None:
            bpy.data.images[bnm].name = TexBNM
            bpy.data.images[TexBNM].filepath = fixlocate+TexBNM
            bpy.data.images[TexBNM].filepath_raw = fixlocate+TexBNM
        f18 = bpimg(sgm)
        #for f8 in f8:
        if f18 is not None:
            bpy.data.images[sgm].name = TexSGM
            bpy.data.images[TexSGM].filepath = fixlocate+TexSGM
            bpy.data.images[TexSGM].filepath_raw = fixlocate+TexSGM
        f19 = bpimg(om)
        #for f8 in f8:
        if f19 is not None:
            bpy.data.images[om].name = TexOM
            bpy.data.images[TexOM].filepath = fixlocate+TexOM
            bpy.data.images[TexOM].filepath_raw = fixlocate+TexOM
        f20 = bpimg(tss)
        #for f8 in f8:
        if f20 is not None:
            bpy.data.images[tss].name = TexTSS
            bpy.data.images[TexTSS].filepath = fixlocate+TexTSS
            bpy.data.images[TexTSS].filepath_raw = fixlocate+TexTSS
        f21 = bpimg(mgm)
        #for f8 in f8:
        if f21 is not None:
            bpy.data.images[mgm].name = TexMGM
            bpy.data.images[TexMGM].filepath = fixlocate+TexMGM
            bpy.data.images[TexMGM].filepath_raw = fixlocate+TexMGM
        f22 = bpimg(ov)
        #for f8 in f8:
        if f22 is not None:
            bpy.data.images[ov].name = TexOV
            bpy.data.images[TexOV].filepath = fixlocate+TexOV
            bpy.data.images[TexOV].filepath_raw = fixlocate+TexOV
        bpy.ops.file.find_missing_files('INVOKE_DEFAULT')
        return {"FINISHED"}

    def invoke(self, context, event):
        return self.execute(context)


class SNA_OT_Kkpsocks_0D912(bpy.types.Operator):
    bl_idname = "sna.kkpsocks_0d912"
    bl_label = "kkp-socks"
    bl_description = "SOCKS"
    bl_options = {"REGISTER", "UNDO"}

    @classmethod
    def poll(cls, context):
        return not False

    def execute(self, context):
        import os
        ########################################################################
        my_mat = bpy.context.object.material_slots[0].material
        print(my_mat.name)
        Tex=my_mat.name
        rem_mat = bpy.data.materials[Tex]
        #Get the node in its node tree (replace the name below)
        node_to_delete =  rem_mat.node_tree.nodes['Principled BSDF']
        node_to_delete2 =  rem_mat.node_tree.nodes['Material Output']
        #Remove it
        rem_mat.node_tree.nodes.remove(node_to_delete)
        rem_mat.node_tree.nodes.remove(node_to_delete2)
        #Tex = material.name
        TexMain = Tex+'_MainTex.png'
        TexDetailM = Tex+'_DetailMask.png'
        TexNormal = Tex+'_NormalMap.png'
        TexNDetail = Tex+'_NormalMapDetail.png'
        TexAlphaM = Tex+'_AlphaMask.png'
        TexAnotherR = Tex+'_AnotherRamp.png'
        TexLiquidM = Tex+'_liquidmask.png'
        TexTex2 = Tex+'_Texture2.png'
        TexTex3 = Tex+'_Texture3.png'
        TexOv1 = Tex+'_overtex1.png'
        TexOv2 = Tex+'_overtex2.png'
        TexLineM = Tex+'_LineMask.png'
        TexColorM = Tex+'_ColorMask.png'
        TexHairG = Tex+'_HairGloss.png'
        TexBump = Tex+'_BumpMap.png'
        TexDNM = Tex+'_DetailNormalMap.png'
        TexBNM = Tex+'_BlendNormalMap.png'
        TexSGM = Tex+'_SpecGlossMap.png'
        TexOM = Tex+'_OcclusionMap.png'
        TexTSS = Tex+'_Thickness.png'
        TexMGM = Tex+'_MetallicGlossMap.png'
        TexOV = Tex+'_OverTex.png'
        originaltex = 'cf_m_socks_high01_'
        #originaltss = 'cf_m_body_01_'
        #kkp
        nm = originaltex+'NormalMap.png'
        nd = originaltex+'NormalMapDetail.png'
        dm = originaltex+'DetailMask.png'
        mm = originaltex+'MainTex.png'
        t3 = originaltex+'Texture3.png'
        t2 = originaltex+'Texture2.png'
        am = originaltex+'AlphaMask.png'
        lm = originaltex+'liquidmask.png'
        ar = originaltex+'AnotherRamp.png'
        ov1 = originaltex+'overtex1.png'
        ov2 = originaltex+'overtex2.png'
        lnm = originaltex+'LineMask.png'
        com = originaltex+'ColorMask.png'
        glo = originaltex+'HairGloss.png'
        #hs1
        bum = originaltex+'BumpMap.png'
        dnm = originaltex+'DetailNormalMap.png'
        bnm = originaltex+'BlendNormalMap.png'
        sgm = originaltex+'SpecGlossMap.png'
        om = originaltex+'OcclusionMap.png'
        tss = originaltex+'Thickness.png'
        mgm = originaltex+'MetallicGlossMap.png'
        ov = originaltex+'OverTex.png'
        Template='KK-Template Socks'
        CTemplate=Template+' '
        C = bpy.context

        def instantiate_group(nodes, data_block_name):
            group = nodes.new(type='ShaderNodeGroup')
            group.node_tree = bpy.data.node_groups[Template]
            return group
        if Template in bpy.data.node_groups:
            instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
        else:
        #    versions = ( t0, t1, t2, t3, t4)
        #    for x in versions:
        #        if os.path.isdir(x) and os.access(x, os.R_OK):
            if (3, 0, 0) <= bpy.app.version < (3, 0, 99):
                before_data = list(bpy.data.node_groups)
                bpy.ops.wm.append(directory=os.path.expanduser(r"~\AppData\Roaming\Blender Foundation\Blender\3.0\scripts\addons\sklx_creator\assets\KK_Template_Shader.blend") + r'\NodeTree',filename=Template,link=False)
                new_data=list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
                appended_2B5AC = None if not new_data else new_data[0]
                instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
            else:
                if (3, 1, 0) <= bpy.app.version < (3, 1, 99):
                    before_data = list(bpy.data.node_groups)
                    bpy.ops.wm.append(directory=os.path.expanduser(r"~\AppData\Roaming\Blender Foundation\Blender\3.1\scripts\addons\sklx_creator\assets\KK_Template_Shader.blend") + r'\NodeTree',filename=Template,link=False)
                    new_data=list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
                    appended_2B5AC = None if not new_data else new_data[0]
                    instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
                else:
                    if (3, 2, 0) <= bpy.app.version < (3, 2, 99):
                        before_data = list(bpy.data.node_groups)
                        bpy.ops.wm.append(directory=os.path.expanduser(r"~\AppData\Roaming\Blender Foundation\Blender\3.2\scripts\addons\sklx_creator\assets\KK_Template_Shader.blend") + r'\NodeTree',filename=Template,link=False)
                        new_data=list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
                        appended_2B5AC = None if not new_data else new_data[0]
                        instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
                    else:
                        if (3, 3, 0) <= bpy.app.version < (3, 3, 99):
                            before_data = list(bpy.data.node_groups)
                            bpy.ops.wm.append(directory=os.path.expanduser(r"~\AppData\Roaming\Blender Foundation\Blender\3.3\scripts\addons\sklx_creator\assets\KK_Template_Shader.blend") + r'\NodeTree',filename=Template,link=False)
                            new_data=list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
                            appended_2B5AC = None if not new_data else new_data[0]
                            instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
                        else:
                            if (3, 4, 0) <= bpy.app.version < (3, 4, 99):
                                before_data = list(bpy.data.node_groups)
                                bpy.ops.wm.append(directory=os.path.expanduser(r"~\AppData\Roaming\Blender Foundation\Blender\3.4\scripts\addons\sklx_creator\assets\KK_Template_Shader.blend") + r'\NodeTree',filename=Template,link=False)
                                new_data=list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
                                appended_2B5AC = None if not new_data else new_data[0]
                                instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
        bpy.data.node_groups[Template].name = CTemplate+Tex
        node = bpy.data.node_groups[CTemplate+Tex]
        #initial_area_type = bpy.context.area.type
        #bpy.context.area.type = 'NODE_EDITOR'
        #bpy.context.area.ui_type = 'ShaderNodeTree'
        #bpy.ops.wm.redraw_timer(type='DRAW_WIN', iterations=1)
        #bpy.ops.node.group_ungroup()
        #bpy.ops.node.group_edit(exit=True)
        #bpy.context.area.type = initial_area_type
        nodes = my_mat.node_tree.nodes
        for node in nodes:
            #node.select = False
            print(node.name)
            node.select = True
            nodes.active = node
        try:
            initial_area_type = bpy.context.area.type
            bpy.context.area.type = 'NODE_EDITOR'
            bpy.context.area.ui_type = 'ShaderNodeTree'
            bpy.ops.wm.redraw_timer(type='DRAW_WIN', iterations=1)
            bpy.ops.node.group_ungroup()
            nonono = node," to Ungroup"
            print(nonono)
            bpy.ops.node.group_edit(exit=True)
        except Exception as e:
            print(e)
        finally:
            bpy.context.area.type = initial_area_type
        fixlocate = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\\20220603141428_Chika_Haruno\\Textures\\"
        bpimg = bpy.data.images.get
        if 1==1:
            print(mm)
            print(dm)
            print(nm)
            print(t2)
            print(t3)
        #formula_list=(nm,nd,dm,mm,t2,t3,am,lm,ar,ov1,ov2,lnm,com,glo,bum,dnm,bnm,sgm,om,tss,mgm,ov)
        #for formula in formula_list:
        #    if bpimg(formula) is not None:
        f1 = bpimg(mm)
        #for x in f1:
        if f1 is not None:
            bpy.data.images[mm].name = TexMain
            bpy.data.images[TexMain].filepath = fixlocate+TexMain
            bpy.data.images[TexMain].filepath_raw = fixlocate+TexMain
        f2 = bpimg(dm)
        #for x in f2:
        if f2 is not None:
            bpy.data.images[dm].name = TexDetailM
            bpy.data.images[TexDetailM].filepath = fixlocate+TexDetailM
            bpy.data.images[TexDetailM].filepath_raw = fixlocate+TexDetailM
        f3 = bpimg(nm)
        #for x in f3:
        if f3 is not None:
            bpy.data.images[nm].name = TexNormal
            bpy.data.images[TexNormal].filepath = fixlocate+TexNormal
            bpy.data.images[TexNormal].filepath_raw = fixlocate+TexNormal
        f4 = bpimg(t2)
        #for x in f3:
        if f4 is not None:
            bpy.data.images[t2].name = TexTex2
            bpy.data.images[TexTex2].filepath = fixlocate+TexTex2
            bpy.data.images[TexTex2].filepath_raw = fixlocate+TexTex2
        f5 = bpimg(t3)
        #for x in f4:
        if f5 is not None:
            bpy.data.images[t3].name = TexTex3
            bpy.data.images[TexTex3].filepath = fixlocate+TexTex3
            bpy.data.images[TexTex3].filepath_raw = fixlocate+TexTex3
        f6 = bpimg(am)
        #for x in f5:
        if f6 is not None:
            bpy.data.images[am].name = TexAlphaM
            bpy.data.images[TexAlphaM].filepath = fixlocate+TexAlphaM
            bpy.data.images[TexAlphaM].filepath_raw = fixlocate+TexAlphaM
        f7 = bpimg(lm)
        #for x in f6:
        if f7 is not None:
            bpy.data.images[lm].name = TexLiquidM
            bpy.data.images[TexLiquidM].filepath = fixlocate+TexLiquidM
            bpy.data.images[TexLiquidM].filepath_raw = fixlocate+TexLiquidM
        f8 = bpimg(ar)
        #for f8 in f8:
        if f8 is not None:
            bpy.data.images[ar].name = TexAnotherR
            bpy.data.images[TexAnotherR].filepath = fixlocate+TexAnotherR
            bpy.data.images[TexAnotherR].filepath_raw = fixlocate+TexAnotherR
        f9 = bpimg(nd)
        #for f8 in f8:
        if f9 is not None:
            bpy.data.images[nd].name = TexNDetail
            bpy.data.images[TexNDetail].filepath = fixlocate+TexNDetail
            bpy.data.images[TexNDetail].filepath_raw = fixlocate+TexNDetail
        f10 = bpimg(ov1)
        #for f8 in f8:
        if f10 is not None:
            bpy.data.images[ov1].name = TexOv1
            bpy.data.images[TexOv1].filepath = fixlocate+TexOv1
            bpy.data.images[TexOv1].filepath_raw = fixlocate+TexOv1
        f11 = bpimg(ov2)
        #for f8 in f8:
        if f11 is not None:
            bpy.data.images[ov2].name = TexOv2
            bpy.data.images[TexOv2].filepath = fixlocate+TexOv2
            bpy.data.images[TexOv2].filepath_raw = fixlocate+TexOv2
        f12 = bpimg(lnm)
        #for f8 in f8:
        if f12 is not None:
            bpy.data.images[lnm].name = TexLineM
            bpy.data.images[TexLineM].filepath = fixlocate+TexLineM
            bpy.data.images[TexLineM].filepath_raw = fixlocate+TexLineM
        f13 = bpimg(com)
        #for f8 in f8:
        if f13 is not None:
            bpy.data.images[com].name = TexColorM
            bpy.data.images[TexColorM].filepath = fixlocate+TexColorM
            bpy.data.images[TexColorM].filepath_raw = fixlocate+TexColorM
        f14 = bpimg(glo)
        #for f8 in f8:
        if f14 is not None:
            bpy.data.images[glo].name = TexHairG
            bpy.data.images[TexHairG].filepath = fixlocate+TexHairG
            bpy.data.images[TexHairG].filepath_raw = fixlocate+TexHairG
        f15 = bpimg(bum)
        #for f8 in f8:
        if f15 is not None:
            bpy.data.images[bum].name = TexBump
            bpy.data.images[TexBump].filepath = fixlocate+TexBump
            bpy.data.images[TexBump].filepath_raw = fixlocate+TexBump
        f16 = bpimg(dnm)
        #for f8 in f8:
        if f16 is not None:
            bpy.data.images[dnm].name = TexDNM
            bpy.data.images[TexDNM].filepath = fixlocate+TexDNM
            bpy.data.images[TexDNM].filepath_raw = fixlocate+TexDNM
        f17 = bpimg(bnm)
        #for f8 in f8:
        if f17 is not None:
            bpy.data.images[bnm].name = TexBNM
            bpy.data.images[TexBNM].filepath = fixlocate+TexBNM
            bpy.data.images[TexBNM].filepath_raw = fixlocate+TexBNM
        f18 = bpimg(sgm)
        #for f8 in f8:
        if f18 is not None:
            bpy.data.images[sgm].name = TexSGM
            bpy.data.images[TexSGM].filepath = fixlocate+TexSGM
            bpy.data.images[TexSGM].filepath_raw = fixlocate+TexSGM
        f19 = bpimg(om)
        #for f8 in f8:
        if f19 is not None:
            bpy.data.images[om].name = TexOM
            bpy.data.images[TexOM].filepath = fixlocate+TexOM
            bpy.data.images[TexOM].filepath_raw = fixlocate+TexOM
        f20 = bpimg(tss)
        #for f8 in f8:
        if f20 is not None:
            bpy.data.images[tss].name = TexTSS
            bpy.data.images[TexTSS].filepath = fixlocate+TexTSS
            bpy.data.images[TexTSS].filepath_raw = fixlocate+TexTSS
        f21 = bpimg(mgm)
        #for f8 in f8:
        if f21 is not None:
            bpy.data.images[mgm].name = TexMGM
            bpy.data.images[TexMGM].filepath = fixlocate+TexMGM
            bpy.data.images[TexMGM].filepath_raw = fixlocate+TexMGM
        f22 = bpimg(ov)
        #for f8 in f8:
        if f22 is not None:
            bpy.data.images[ov].name = TexOV
            bpy.data.images[TexOV].filepath = fixlocate+TexOV
            bpy.data.images[TexOV].filepath_raw = fixlocate+TexOV
        bpy.ops.file.find_missing_files('INVOKE_DEFAULT')
        return {"FINISHED"}

    def invoke(self, context, event):
        return self.execute(context)


class SNA_OT_Kkpface_E438D(bpy.types.Operator):
    bl_idname = "sna.kkpface_e438d"
    bl_label = "kkp-face"
    bl_description = "FACE"
    bl_options = {"REGISTER", "UNDO"}

    @classmethod
    def poll(cls, context):
        return not False

    def execute(self, context):
        import os
        ########################################################################
        my_mat = bpy.context.object.material_slots[0].material
        print(my_mat.name)
        Tex=my_mat.name
        rem_mat = bpy.data.materials[Tex]
        #Get the node in its node tree (replace the name below)
        node_to_delete =  rem_mat.node_tree.nodes['Principled BSDF']
        node_to_delete2 =  rem_mat.node_tree.nodes['Material Output']
        #Remove it
        rem_mat.node_tree.nodes.remove(node_to_delete)
        rem_mat.node_tree.nodes.remove(node_to_delete2)
        #Tex = material.name
        TexMain = Tex+'_MainTex.png'
        TexDetailM = Tex+'_DetailMask.png'
        TexNormal = Tex+'_NormalMap.png'
        TexNDetail = Tex+'_NormalMapDetail.png'
        TexAlphaM = Tex+'_AlphaMask.png'
        TexAnotherR = Tex+'_AnotherRamp.png'
        TexLiquidM = Tex+'_liquidmask.png'
        TexTex2 = Tex+'_Texture2.png'
        TexTex3 = Tex+'_Texture3.png'
        TexOv1 = Tex+'_overtex1.png'
        TexOv2 = Tex+'_overtex2.png'
        TexLineM = Tex+'_LineMask.png'
        TexColorM = Tex+'_ColorMask.png'
        TexHairG = Tex+'_HairGloss.png'
        TexBump = Tex+'_BumpMap.png'
        TexDNM = Tex+'_DetailNormalMap.png'
        TexBNM = Tex+'_BlendNormalMap.png'
        TexSGM = Tex+'_SpecGlossMap.png'
        TexOM = Tex+'_OcclusionMap.png'
        TexTSS = Tex+'_Thickness.png'
        TexMGM = Tex+'_MetallicGlossMap.png'
        TexOV = Tex+'_OverTex.png'
        originaltex = 'cf_m_face_00_'
        #originaltss = 'cf_m_body_01_'
        #kkp
        nm = originaltex+'NormalMap.png'
        nd = originaltex+'NormalMapDetail.png'
        dm = originaltex+'DetailMask.png'
        mm = originaltex+'MainTex.png'
        t3 = originaltex+'Texture3.png'
        t2 = originaltex+'Texture2.png'
        am = originaltex+'AlphaMask.png'
        lm = originaltex+'liquidmask.png'
        ar = originaltex+'AnotherRamp.png'
        ov1 = originaltex+'overtex1.png'
        ov2 = originaltex+'overtex2.png'
        lnm = originaltex+'LineMask.png'
        com = originaltex+'ColorMask.png'
        glo = originaltex+'HairGloss.png'
        #hs1
        bum = originaltex+'BumpMap.png'
        dnm = originaltex+'DetailNormalMap.png'
        bnm = originaltex+'BlendNormalMap.png'
        sgm = originaltex+'SpecGlossMap.png'
        om = originaltex+'OcclusionMap.png'
        tss = originaltex+'Thickness.png'
        mgm = originaltex+'MetallicGlossMap.png'
        ov = originaltex+'OverTex.png'
        Template='KK-Template Face'
        CTemplate=Template+' '
        C = bpy.context

        def instantiate_group(nodes, data_block_name):
            group = nodes.new(type='ShaderNodeGroup')
            group.node_tree = bpy.data.node_groups[Template]
            return group
        if Template in bpy.data.node_groups:
            instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
        else:
        #    versions = ( t0, t1, t2, t3, t4)
        #    for x in versions:
        #        if os.path.isdir(x) and os.access(x, os.R_OK):
            if (3, 0, 0) <= bpy.app.version < (3, 0, 99):
                before_data = list(bpy.data.node_groups)
                bpy.ops.wm.append(directory=os.path.expanduser(r"~\AppData\Roaming\Blender Foundation\Blender\3.0\scripts\addons\sklx_creator\assets\KK_Template_Shader.blend") + r'\NodeTree',filename=Template,link=False)
                new_data=list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
                appended_2B5AC = None if not new_data else new_data[0]
                instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
            else:
                if (3, 1, 0) <= bpy.app.version < (3, 1, 99):
                    before_data = list(bpy.data.node_groups)
                    bpy.ops.wm.append(directory=os.path.expanduser(r"~\AppData\Roaming\Blender Foundation\Blender\3.1\scripts\addons\sklx_creator\assets\KK_Template_Shader.blend") + r'\NodeTree',filename=Template,link=False)
                    new_data=list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
                    appended_2B5AC = None if not new_data else new_data[0]
                    instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
                else:
                    if (3, 2, 0) <= bpy.app.version < (3, 2, 99):
                        before_data = list(bpy.data.node_groups)
                        bpy.ops.wm.append(directory=os.path.expanduser(r"~\AppData\Roaming\Blender Foundation\Blender\3.2\scripts\addons\sklx_creator\assets\KK_Template_Shader.blend") + r'\NodeTree',filename=Template,link=False)
                        new_data=list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
                        appended_2B5AC = None if not new_data else new_data[0]
                        instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
                    else:
                        if (3, 3, 0) <= bpy.app.version < (3, 3, 99):
                            before_data = list(bpy.data.node_groups)
                            bpy.ops.wm.append(directory=os.path.expanduser(r"~\AppData\Roaming\Blender Foundation\Blender\3.3\scripts\addons\sklx_creator\assets\KK_Template_Shader.blend") + r'\NodeTree',filename=Template,link=False)
                            new_data=list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
                            appended_2B5AC = None if not new_data else new_data[0]
                            instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
                        else:
                            if (3, 4, 0) <= bpy.app.version < (3, 4, 99):
                                before_data = list(bpy.data.node_groups)
                                bpy.ops.wm.append(directory=os.path.expanduser(r"~\AppData\Roaming\Blender Foundation\Blender\3.4\scripts\addons\sklx_creator\assets\KK_Template_Shader.blend") + r'\NodeTree',filename=Template,link=False)
                                new_data=list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
                                appended_2B5AC = None if not new_data else new_data[0]
                                instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
        bpy.data.node_groups[Template].name = CTemplate+Tex
        node = bpy.data.node_groups[CTemplate+Tex]
        #initial_area_type = bpy.context.area.type
        #bpy.context.area.type = 'NODE_EDITOR'
        #bpy.context.area.ui_type = 'ShaderNodeTree'
        #bpy.ops.wm.redraw_timer(type='DRAW_WIN', iterations=1)
        #bpy.ops.node.group_ungroup()
        #bpy.ops.node.group_edit(exit=True)
        #bpy.context.area.type = initial_area_type
        nodes = my_mat.node_tree.nodes
        for node in nodes:
            #node.select = False
            print(node.name)
            node.select = True
            nodes.active = node
        try:
            initial_area_type = bpy.context.area.type
            bpy.context.area.type = 'NODE_EDITOR'
            bpy.context.area.ui_type = 'ShaderNodeTree'
            bpy.ops.wm.redraw_timer(type='DRAW_WIN', iterations=1)
            bpy.ops.node.group_ungroup()
            nonono = node," to Ungroup"
            print(nonono)
            bpy.ops.node.group_edit(exit=True)
        except Exception as e:
            print(e)
        finally:
            bpy.context.area.type = initial_area_type
        fixlocate = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\\20220603141428_Chika_Haruno\\Textures\\"
        bpimg = bpy.data.images.get
        if 1==1:
            print(mm)
            print(dm)
            print(nm)
            print(t2)
            print(t3)
        #formula_list=(nm,nd,dm,mm,t2,t3,am,lm,ar,ov1,ov2,lnm,com,glo,bum,dnm,bnm,sgm,om,tss,mgm,ov)
        #for formula in formula_list:
        #    if bpimg(formula) is not None:
        f1 = bpimg(mm)
        #for x in f1:
        if f1 is not None:
            bpy.data.images[mm].name = TexMain
            bpy.data.images[TexMain].filepath = fixlocate+TexMain
            bpy.data.images[TexMain].filepath_raw = fixlocate+TexMain
        f2 = bpimg(dm)
        #for x in f2:
        if f2 is not None:
            bpy.data.images[dm].name = TexDetailM
            bpy.data.images[TexDetailM].filepath = fixlocate+TexDetailM
            bpy.data.images[TexDetailM].filepath_raw = fixlocate+TexDetailM
        f3 = bpimg(nm)
        #for x in f3:
        if f3 is not None:
            bpy.data.images[nm].name = TexNormal
            bpy.data.images[TexNormal].filepath = fixlocate+TexNormal
            bpy.data.images[TexNormal].filepath_raw = fixlocate+TexNormal
        f4 = bpimg(t2)
        #for x in f3:
        if f4 is not None:
            bpy.data.images[t2].name = TexTex2
            bpy.data.images[TexTex2].filepath = fixlocate+TexTex2
            bpy.data.images[TexTex2].filepath_raw = fixlocate+TexTex2
        f5 = bpimg(t3)
        #for x in f4:
        if f5 is not None:
            bpy.data.images[t3].name = TexTex3
            bpy.data.images[TexTex3].filepath = fixlocate+TexTex3
            bpy.data.images[TexTex3].filepath_raw = fixlocate+TexTex3
        f6 = bpimg(am)
        #for x in f5:
        if f6 is not None:
            bpy.data.images[am].name = TexAlphaM
            bpy.data.images[TexAlphaM].filepath = fixlocate+TexAlphaM
            bpy.data.images[TexAlphaM].filepath_raw = fixlocate+TexAlphaM
        f7 = bpimg(lm)
        #for x in f6:
        if f7 is not None:
            bpy.data.images[lm].name = TexLiquidM
            bpy.data.images[TexLiquidM].filepath = fixlocate+TexLiquidM
            bpy.data.images[TexLiquidM].filepath_raw = fixlocate+TexLiquidM
        f8 = bpimg(ar)
        #for f8 in f8:
        if f8 is not None:
            bpy.data.images[ar].name = TexAnotherR
            bpy.data.images[TexAnotherR].filepath = fixlocate+TexAnotherR
            bpy.data.images[TexAnotherR].filepath_raw = fixlocate+TexAnotherR
        f9 = bpimg(nd)
        #for f8 in f8:
        if f9 is not None:
            bpy.data.images[nd].name = TexNDetail
            bpy.data.images[TexNDetail].filepath = fixlocate+TexNDetail
            bpy.data.images[TexNDetail].filepath_raw = fixlocate+TexNDetail
        f10 = bpimg(ov1)
        #for f8 in f8:
        if f10 is not None:
            bpy.data.images[ov1].name = TexOv1
            bpy.data.images[TexOv1].filepath = fixlocate+TexOv1
            bpy.data.images[TexOv1].filepath_raw = fixlocate+TexOv1
        f11 = bpimg(ov2)
        #for f8 in f8:
        if f11 is not None:
            bpy.data.images[ov2].name = TexOv2
            bpy.data.images[TexOv2].filepath = fixlocate+TexOv2
            bpy.data.images[TexOv2].filepath_raw = fixlocate+TexOv2
        f12 = bpimg(lnm)
        #for f8 in f8:
        if f12 is not None:
            bpy.data.images[lnm].name = TexLineM
            bpy.data.images[TexLineM].filepath = fixlocate+TexLineM
            bpy.data.images[TexLineM].filepath_raw = fixlocate+TexLineM
        f13 = bpimg(com)
        #for f8 in f8:
        if f13 is not None:
            bpy.data.images[com].name = TexColorM
            bpy.data.images[TexColorM].filepath = fixlocate+TexColorM
            bpy.data.images[TexColorM].filepath_raw = fixlocate+TexColorM
        f14 = bpimg(glo)
        #for f8 in f8:
        if f14 is not None:
            bpy.data.images[glo].name = TexHairG
            bpy.data.images[TexHairG].filepath = fixlocate+TexHairG
            bpy.data.images[TexHairG].filepath_raw = fixlocate+TexHairG
        f15 = bpimg(bum)
        #for f8 in f8:
        if f15 is not None:
            bpy.data.images[bum].name = TexBump
            bpy.data.images[TexBump].filepath = fixlocate+TexBump
            bpy.data.images[TexBump].filepath_raw = fixlocate+TexBump
        f16 = bpimg(dnm)
        #for f8 in f8:
        if f16 is not None:
            bpy.data.images[dnm].name = TexDNM
            bpy.data.images[TexDNM].filepath = fixlocate+TexDNM
            bpy.data.images[TexDNM].filepath_raw = fixlocate+TexDNM
        f17 = bpimg(bnm)
        #for f8 in f8:
        if f17 is not None:
            bpy.data.images[bnm].name = TexBNM
            bpy.data.images[TexBNM].filepath = fixlocate+TexBNM
            bpy.data.images[TexBNM].filepath_raw = fixlocate+TexBNM
        f18 = bpimg(sgm)
        #for f8 in f8:
        if f18 is not None:
            bpy.data.images[sgm].name = TexSGM
            bpy.data.images[TexSGM].filepath = fixlocate+TexSGM
            bpy.data.images[TexSGM].filepath_raw = fixlocate+TexSGM
        f19 = bpimg(om)
        #for f8 in f8:
        if f19 is not None:
            bpy.data.images[om].name = TexOM
            bpy.data.images[TexOM].filepath = fixlocate+TexOM
            bpy.data.images[TexOM].filepath_raw = fixlocate+TexOM
        f20 = bpimg(tss)
        #for f8 in f8:
        if f20 is not None:
            bpy.data.images[tss].name = TexTSS
            bpy.data.images[TexTSS].filepath = fixlocate+TexTSS
            bpy.data.images[TexTSS].filepath_raw = fixlocate+TexTSS
        f21 = bpimg(mgm)
        #for f8 in f8:
        if f21 is not None:
            bpy.data.images[mgm].name = TexMGM
            bpy.data.images[TexMGM].filepath = fixlocate+TexMGM
            bpy.data.images[TexMGM].filepath_raw = fixlocate+TexMGM
        f22 = bpimg(ov)
        #for f8 in f8:
        if f22 is not None:
            bpy.data.images[ov].name = TexOV
            bpy.data.images[TexOV].filepath = fixlocate+TexOV
            bpy.data.images[TexOV].filepath_raw = fixlocate+TexOV
        bpy.ops.file.find_missing_files('INVOKE_DEFAULT')
        return {"FINISHED"}

    def invoke(self, context, event):
        return self.execute(context)


class SNA_OT_Kkpinner_8A572(bpy.types.Operator):
    bl_idname = "sna.kkpinner_8a572"
    bl_label = "kkp-inner"
    bl_description = "INNER"
    bl_options = {"REGISTER", "UNDO"}

    @classmethod
    def poll(cls, context):
        return not False

    def execute(self, context):
        import os
        ########################################################################
        my_mat = bpy.context.object.material_slots[0].material
        print(my_mat.name)
        Tex=my_mat.name
        rem_mat = bpy.data.materials[Tex]
        #Get the node in its node tree (replace the name below)
        node_to_delete =  rem_mat.node_tree.nodes['Principled BSDF']
        node_to_delete2 =  rem_mat.node_tree.nodes['Material Output']
        #Remove it
        rem_mat.node_tree.nodes.remove(node_to_delete)
        rem_mat.node_tree.nodes.remove(node_to_delete2)
        #Tex = material.name
        TexMain = Tex+'_MainTex.png'
        TexDetailM = Tex+'_DetailMask.png'
        TexNormal = Tex+'_NormalMap.png'
        TexNDetail = Tex+'_NormalMapDetail.png'
        TexAlphaM = Tex+'_AlphaMask.png'
        TexAnotherR = Tex+'_AnotherRamp.png'
        TexLiquidM = Tex+'_liquidmask.png'
        TexTex2 = Tex+'_Texture2.png'
        TexTex3 = Tex+'_Texture3.png'
        TexOv1 = Tex+'_overtex1.png'
        TexOv2 = Tex+'_overtex2.png'
        TexLineM = Tex+'_LineMask.png'
        TexColorM = Tex+'_ColorMask.png'
        TexHairG = Tex+'_HairGloss.png'
        TexBump = Tex+'_BumpMap.png'
        TexDNM = Tex+'_DetailNormalMap.png'
        TexBNM = Tex+'_BlendNormalMap.png'
        TexSGM = Tex+'_SpecGlossMap.png'
        TexOM = Tex+'_OcclusionMap.png'
        TexTSS = Tex+'_Thickness.png'
        TexMGM = Tex+'_MetallicGlossMap.png'
        TexOV = Tex+'_OverTex.png'
        originaltex = 'cf_m_top_inner01_'
        #originaltss = 'cf_m_body_01_'
        #kkp
        nm = originaltex+'NormalMap.png'
        nd = originaltex+'NormalMapDetail.png'
        dm = originaltex+'DetailMask.png'
        mm = originaltex+'MainTex.png'
        t3 = originaltex+'Texture3.png'
        t2 = originaltex+'Texture2.png'
        am = originaltex+'AlphaMask.png'
        lm = originaltex+'liquidmask.png'
        ar = originaltex+'AnotherRamp.png'
        ov1 = originaltex+'overtex1.png'
        ov2 = originaltex+'overtex2.png'
        lnm = originaltex+'LineMask.png'
        com = originaltex+'ColorMask.png'
        glo = originaltex+'HairGloss.png'
        #hs1
        bum = originaltex+'BumpMap.png'
        dnm = originaltex+'DetailNormalMap.png'
        bnm = originaltex+'BlendNormalMap.png'
        sgm = originaltex+'SpecGlossMap.png'
        om = originaltex+'OcclusionMap.png'
        tss = originaltex+'Thickness.png'
        mgm = originaltex+'MetallicGlossMap.png'
        ov = originaltex+'OverTex.png'
        Template='KK-Template UnderCloth'
        CTemplate=Template+' '
        C = bpy.context

        def instantiate_group(nodes, data_block_name):
            group = nodes.new(type='ShaderNodeGroup')
            group.node_tree = bpy.data.node_groups[Template]
            return group
        if Template in bpy.data.node_groups:
            instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
        else:
        #    versions = ( t0, t1, t2, t3, t4)
        #    for x in versions:
        #        if os.path.isdir(x) and os.access(x, os.R_OK):
            if (3, 0, 0) <= bpy.app.version < (3, 0, 99):
                before_data = list(bpy.data.node_groups)
                bpy.ops.wm.append(directory=os.path.expanduser(r"~\AppData\Roaming\Blender Foundation\Blender\3.0\scripts\addons\sklx_creator\assets\KK_Template_Shader.blend") + r'\NodeTree',filename=Template,link=False)
                new_data=list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
                appended_2B5AC = None if not new_data else new_data[0]
                instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
            else:
                if (3, 1, 0) <= bpy.app.version < (3, 1, 99):
                    before_data = list(bpy.data.node_groups)
                    bpy.ops.wm.append(directory=os.path.expanduser(r"~\AppData\Roaming\Blender Foundation\Blender\3.1\scripts\addons\sklx_creator\assets\KK_Template_Shader.blend") + r'\NodeTree',filename=Template,link=False)
                    new_data=list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
                    appended_2B5AC = None if not new_data else new_data[0]
                    instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
                else:
                    if (3, 2, 0) <= bpy.app.version < (3, 2, 99):
                        before_data = list(bpy.data.node_groups)
                        bpy.ops.wm.append(directory=os.path.expanduser(r"~\AppData\Roaming\Blender Foundation\Blender\3.2\scripts\addons\sklx_creator\assets\KK_Template_Shader.blend") + r'\NodeTree',filename=Template,link=False)
                        new_data=list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
                        appended_2B5AC = None if not new_data else new_data[0]
                        instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
                    else:
                        if (3, 3, 0) <= bpy.app.version < (3, 3, 99):
                            before_data = list(bpy.data.node_groups)
                            bpy.ops.wm.append(directory=os.path.expanduser(r"~\AppData\Roaming\Blender Foundation\Blender\3.3\scripts\addons\sklx_creator\assets\KK_Template_Shader.blend") + r'\NodeTree',filename=Template,link=False)
                            new_data=list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
                            appended_2B5AC = None if not new_data else new_data[0]
                            instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
                        else:
                            if (3, 4, 0) <= bpy.app.version < (3, 4, 99):
                                before_data = list(bpy.data.node_groups)
                                bpy.ops.wm.append(directory=os.path.expanduser(r"~\AppData\Roaming\Blender Foundation\Blender\3.4\scripts\addons\sklx_creator\assets\KK_Template_Shader.blend") + r'\NodeTree',filename=Template,link=False)
                                new_data=list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
                                appended_2B5AC = None if not new_data else new_data[0]
                                instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
        bpy.data.node_groups[Template].name = CTemplate+Tex
        node = bpy.data.node_groups[CTemplate+Tex]
        #initial_area_type = bpy.context.area.type
        #bpy.context.area.type = 'NODE_EDITOR'
        #bpy.context.area.ui_type = 'ShaderNodeTree'
        #bpy.ops.wm.redraw_timer(type='DRAW_WIN', iterations=1)
        #bpy.ops.node.group_ungroup()
        #bpy.ops.node.group_edit(exit=True)
        #bpy.context.area.type = initial_area_type
        nodes = my_mat.node_tree.nodes
        for node in nodes:
            #node.select = False
            print(node.name)
            node.select = True
            nodes.active = node
        try:
            initial_area_type = bpy.context.area.type
            bpy.context.area.type = 'NODE_EDITOR'
            bpy.context.area.ui_type = 'ShaderNodeTree'
            bpy.ops.wm.redraw_timer(type='DRAW_WIN', iterations=1)
            bpy.ops.node.group_ungroup()
            nonono = node," to Ungroup"
            print(nonono)
            bpy.ops.node.group_edit(exit=True)
        except Exception as e:
            print(e)
        finally:
            bpy.context.area.type = initial_area_type
        fixlocate = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\\20220603141428_Chika_Haruno\\Textures\\"
        bpimg = bpy.data.images.get
        if 1==1:
            print(mm)
            print(dm)
            print(nm)
            print(t2)
            print(t3)
        #formula_list=(nm,nd,dm,mm,t2,t3,am,lm,ar,ov1,ov2,lnm,com,glo,bum,dnm,bnm,sgm,om,tss,mgm,ov)
        #for formula in formula_list:
        #    if bpimg(formula) is not None:
        f1 = bpimg(mm)
        #for x in f1:
        if f1 is not None:
            bpy.data.images[mm].name = TexMain
            bpy.data.images[TexMain].filepath = fixlocate+TexMain
            bpy.data.images[TexMain].filepath_raw = fixlocate+TexMain
        f2 = bpimg(dm)
        #for x in f2:
        if f2 is not None:
            bpy.data.images[dm].name = TexDetailM
            bpy.data.images[TexDetailM].filepath = fixlocate+TexDetailM
            bpy.data.images[TexDetailM].filepath_raw = fixlocate+TexDetailM
        f3 = bpimg(nm)
        #for x in f3:
        if f3 is not None:
            bpy.data.images[nm].name = TexNormal
            bpy.data.images[TexNormal].filepath = fixlocate+TexNormal
            bpy.data.images[TexNormal].filepath_raw = fixlocate+TexNormal
        f4 = bpimg(t2)
        #for x in f3:
        if f4 is not None:
            bpy.data.images[t2].name = TexTex2
            bpy.data.images[TexTex2].filepath = fixlocate+TexTex2
            bpy.data.images[TexTex2].filepath_raw = fixlocate+TexTex2
        f5 = bpimg(t3)
        #for x in f4:
        if f5 is not None:
            bpy.data.images[t3].name = TexTex3
            bpy.data.images[TexTex3].filepath = fixlocate+TexTex3
            bpy.data.images[TexTex3].filepath_raw = fixlocate+TexTex3
        f6 = bpimg(am)
        #for x in f5:
        if f6 is not None:
            bpy.data.images[am].name = TexAlphaM
            bpy.data.images[TexAlphaM].filepath = fixlocate+TexAlphaM
            bpy.data.images[TexAlphaM].filepath_raw = fixlocate+TexAlphaM
        f7 = bpimg(lm)
        #for x in f6:
        if f7 is not None:
            bpy.data.images[lm].name = TexLiquidM
            bpy.data.images[TexLiquidM].filepath = fixlocate+TexLiquidM
            bpy.data.images[TexLiquidM].filepath_raw = fixlocate+TexLiquidM
        f8 = bpimg(ar)
        #for f8 in f8:
        if f8 is not None:
            bpy.data.images[ar].name = TexAnotherR
            bpy.data.images[TexAnotherR].filepath = fixlocate+TexAnotherR
            bpy.data.images[TexAnotherR].filepath_raw = fixlocate+TexAnotherR
        f9 = bpimg(nd)
        #for f8 in f8:
        if f9 is not None:
            bpy.data.images[nd].name = TexNDetail
            bpy.data.images[TexNDetail].filepath = fixlocate+TexNDetail
            bpy.data.images[TexNDetail].filepath_raw = fixlocate+TexNDetail
        f10 = bpimg(ov1)
        #for f8 in f8:
        if f10 is not None:
            bpy.data.images[ov1].name = TexOv1
            bpy.data.images[TexOv1].filepath = fixlocate+TexOv1
            bpy.data.images[TexOv1].filepath_raw = fixlocate+TexOv1
        f11 = bpimg(ov2)
        #for f8 in f8:
        if f11 is not None:
            bpy.data.images[ov2].name = TexOv2
            bpy.data.images[TexOv2].filepath = fixlocate+TexOv2
            bpy.data.images[TexOv2].filepath_raw = fixlocate+TexOv2
        f12 = bpimg(lnm)
        #for f8 in f8:
        if f12 is not None:
            bpy.data.images[lnm].name = TexLineM
            bpy.data.images[TexLineM].filepath = fixlocate+TexLineM
            bpy.data.images[TexLineM].filepath_raw = fixlocate+TexLineM
        f13 = bpimg(com)
        #for f8 in f8:
        if f13 is not None:
            bpy.data.images[com].name = TexColorM
            bpy.data.images[TexColorM].filepath = fixlocate+TexColorM
            bpy.data.images[TexColorM].filepath_raw = fixlocate+TexColorM
        f14 = bpimg(glo)
        #for f8 in f8:
        if f14 is not None:
            bpy.data.images[glo].name = TexHairG
            bpy.data.images[TexHairG].filepath = fixlocate+TexHairG
            bpy.data.images[TexHairG].filepath_raw = fixlocate+TexHairG
        f15 = bpimg(bum)
        #for f8 in f8:
        if f15 is not None:
            bpy.data.images[bum].name = TexBump
            bpy.data.images[TexBump].filepath = fixlocate+TexBump
            bpy.data.images[TexBump].filepath_raw = fixlocate+TexBump
        f16 = bpimg(dnm)
        #for f8 in f8:
        if f16 is not None:
            bpy.data.images[dnm].name = TexDNM
            bpy.data.images[TexDNM].filepath = fixlocate+TexDNM
            bpy.data.images[TexDNM].filepath_raw = fixlocate+TexDNM
        f17 = bpimg(bnm)
        #for f8 in f8:
        if f17 is not None:
            bpy.data.images[bnm].name = TexBNM
            bpy.data.images[TexBNM].filepath = fixlocate+TexBNM
            bpy.data.images[TexBNM].filepath_raw = fixlocate+TexBNM
        f18 = bpimg(sgm)
        #for f8 in f8:
        if f18 is not None:
            bpy.data.images[sgm].name = TexSGM
            bpy.data.images[TexSGM].filepath = fixlocate+TexSGM
            bpy.data.images[TexSGM].filepath_raw = fixlocate+TexSGM
        f19 = bpimg(om)
        #for f8 in f8:
        if f19 is not None:
            bpy.data.images[om].name = TexOM
            bpy.data.images[TexOM].filepath = fixlocate+TexOM
            bpy.data.images[TexOM].filepath_raw = fixlocate+TexOM
        f20 = bpimg(tss)
        #for f8 in f8:
        if f20 is not None:
            bpy.data.images[tss].name = TexTSS
            bpy.data.images[TexTSS].filepath = fixlocate+TexTSS
            bpy.data.images[TexTSS].filepath_raw = fixlocate+TexTSS
        f21 = bpimg(mgm)
        #for f8 in f8:
        if f21 is not None:
            bpy.data.images[mgm].name = TexMGM
            bpy.data.images[TexMGM].filepath = fixlocate+TexMGM
            bpy.data.images[TexMGM].filepath_raw = fixlocate+TexMGM
        f22 = bpimg(ov)
        #for f8 in f8:
        if f22 is not None:
            bpy.data.images[ov].name = TexOV
            bpy.data.images[TexOV].filepath = fixlocate+TexOV
            bpy.data.images[TexOV].filepath_raw = fixlocate+TexOV
        bpy.ops.file.find_missing_files('INVOKE_DEFAULT')
        return {"FINISHED"}

    def invoke(self, context, event):
        return self.execute(context)


class SNA_OT_Kkphairb_03315(bpy.types.Operator):
    bl_idname = "sna.kkphairb_03315"
    bl_label = "kkp-hair-b"
    bl_description = "HAIR BACK"
    bl_options = {"REGISTER", "UNDO"}

    @classmethod
    def poll(cls, context):
        return not False

    def execute(self, context):
        import os
        ########################################################################
        my_mat = bpy.context.object.material_slots[0].material
        print(my_mat.name)
        Tex=my_mat.name
        rem_mat = bpy.data.materials[Tex]
        #Get the node in its node tree (replace the name below)
        node_to_delete =  rem_mat.node_tree.nodes['Principled BSDF']
        node_to_delete2 =  rem_mat.node_tree.nodes['Material Output']
        #Remove it
        rem_mat.node_tree.nodes.remove(node_to_delete)
        rem_mat.node_tree.nodes.remove(node_to_delete2)
        #Tex = material.name
        TexMain = Tex+'_MainTex.png'
        TexDetailM = Tex+'_DetailMask.png'
        TexNormal = Tex+'_NormalMap.png'
        TexNDetail = Tex+'_NormalMapDetail.png'
        TexAlphaM = Tex+'_AlphaMask.png'
        TexAnotherR = Tex+'_AnotherRamp.png'
        TexLiquidM = Tex+'_liquidmask.png'
        TexTex2 = Tex+'_Texture2.png'
        TexTex3 = Tex+'_Texture3.png'
        TexOv1 = Tex+'_overtex1.png'
        TexOv2 = Tex+'_overtex2.png'
        TexLineM = Tex+'_LineMask.png'
        TexColorM = Tex+'_ColorMask.png'
        TexHairG = Tex+'_HairGloss.png'
        TexBump = Tex+'_BumpMap.png'
        TexDNM = Tex+'_DetailNormalMap.png'
        TexBNM = Tex+'_BlendNormalMap.png'
        TexSGM = Tex+'_SpecGlossMap.png'
        TexOM = Tex+'_OcclusionMap.png'
        TexTSS = Tex+'_Thickness.png'
        TexMGM = Tex+'_MetallicGlossMap.png'
        TexOV = Tex+'_OverTex.png'
        originaltex = 'cf_m_hair_b_08_00_'
        #originaltss = 'cf_m_body_01_'
        #kkp
        nm = originaltex+'NormalMap.png'
        nd = originaltex+'NormalMapDetail.png'
        dm = originaltex+'DetailMask.png'
        mm = originaltex+'MainTex.png'
        t3 = originaltex+'Texture3.png'
        t2 = originaltex+'Texture2.png'
        am = originaltex+'AlphaMask.png'
        lm = originaltex+'liquidmask.png'
        ar = originaltex+'AnotherRamp.png'
        ov1 = originaltex+'overtex1.png'
        ov2 = originaltex+'overtex2.png'
        lnm = originaltex+'LineMask.png'
        com = originaltex+'ColorMask.png'
        glo = originaltex+'HairGloss.png'
        #hs1
        bum = originaltex+'BumpMap.png'
        dnm = originaltex+'DetailNormalMap.png'
        bnm = originaltex+'BlendNormalMap.png'
        sgm = originaltex+'SpecGlossMap.png'
        om = originaltex+'OcclusionMap.png'
        tss = originaltex+'Thickness.png'
        mgm = originaltex+'MetallicGlossMap.png'
        ov = originaltex+'OverTex.png'
        Template='KK-Template Hair Back'
        CTemplate=Template+' '
        C = bpy.context

        def instantiate_group(nodes, data_block_name):
            group = nodes.new(type='ShaderNodeGroup')
            group.node_tree = bpy.data.node_groups[Template]
            return group
        if Template in bpy.data.node_groups:
            instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
        else:
        #    versions = ( t0, t1, t2, t3, t4)
        #    for x in versions:
        #        if os.path.isdir(x) and os.access(x, os.R_OK):
            if (3, 0, 0) <= bpy.app.version < (3, 0, 99):
                before_data = list(bpy.data.node_groups)
                bpy.ops.wm.append(directory=os.path.expanduser(r"~\AppData\Roaming\Blender Foundation\Blender\3.0\scripts\addons\sklx_creator\assets\KK_Template_Shader.blend") + r'\NodeTree',filename=Template,link=False)
                new_data=list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
                appended_2B5AC = None if not new_data else new_data[0]
                instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
            else:
                if (3, 1, 0) <= bpy.app.version < (3, 1, 99):
                    before_data = list(bpy.data.node_groups)
                    bpy.ops.wm.append(directory=os.path.expanduser(r"~\AppData\Roaming\Blender Foundation\Blender\3.1\scripts\addons\sklx_creator\assets\KK_Template_Shader.blend") + r'\NodeTree',filename=Template,link=False)
                    new_data=list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
                    appended_2B5AC = None if not new_data else new_data[0]
                    instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
                else:
                    if (3, 2, 0) <= bpy.app.version < (3, 2, 99):
                        before_data = list(bpy.data.node_groups)
                        bpy.ops.wm.append(directory=os.path.expanduser(r"~\AppData\Roaming\Blender Foundation\Blender\3.2\scripts\addons\sklx_creator\assets\KK_Template_Shader.blend") + r'\NodeTree',filename=Template,link=False)
                        new_data=list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
                        appended_2B5AC = None if not new_data else new_data[0]
                        instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
                    else:
                        if (3, 3, 0) <= bpy.app.version < (3, 3, 99):
                            before_data = list(bpy.data.node_groups)
                            bpy.ops.wm.append(directory=os.path.expanduser(r"~\AppData\Roaming\Blender Foundation\Blender\3.3\scripts\addons\sklx_creator\assets\KK_Template_Shader.blend") + r'\NodeTree',filename=Template,link=False)
                            new_data=list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
                            appended_2B5AC = None if not new_data else new_data[0]
                            instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
                        else:
                            if (3, 4, 0) <= bpy.app.version < (3, 4, 99):
                                before_data = list(bpy.data.node_groups)
                                bpy.ops.wm.append(directory=os.path.expanduser(r"~\AppData\Roaming\Blender Foundation\Blender\3.4\scripts\addons\sklx_creator\assets\KK_Template_Shader.blend") + r'\NodeTree',filename=Template,link=False)
                                new_data=list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
                                appended_2B5AC = None if not new_data else new_data[0]
                                instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
        bpy.data.node_groups[Template].name = CTemplate+Tex
        node = bpy.data.node_groups[CTemplate+Tex]
        #initial_area_type = bpy.context.area.type
        #bpy.context.area.type = 'NODE_EDITOR'
        #bpy.context.area.ui_type = 'ShaderNodeTree'
        #bpy.ops.wm.redraw_timer(type='DRAW_WIN', iterations=1)
        #bpy.ops.node.group_ungroup()
        #bpy.ops.node.group_edit(exit=True)
        #bpy.context.area.type = initial_area_type
        nodes = my_mat.node_tree.nodes
        for node in nodes:
            #node.select = False
            print(node.name)
            node.select = True
            nodes.active = node
        try:
            initial_area_type = bpy.context.area.type
            bpy.context.area.type = 'NODE_EDITOR'
            bpy.context.area.ui_type = 'ShaderNodeTree'
            bpy.ops.wm.redraw_timer(type='DRAW_WIN', iterations=1)
            bpy.ops.node.group_ungroup()
            nonono = node," to Ungroup"
            print(nonono)
            bpy.ops.node.group_edit(exit=True)
        except Exception as e:
            print(e)
        finally:
            bpy.context.area.type = initial_area_type
        fixlocate = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\\20220603141428_Chika_Haruno\\Textures\\"
        bpimg = bpy.data.images.get
        if 1==1:
            print(mm)
            print(dm)
            print(nm)
            print(t2)
            print(t3)
        #formula_list=(nm,nd,dm,mm,t2,t3,am,lm,ar,ov1,ov2,lnm,com,glo,bum,dnm,bnm,sgm,om,tss,mgm,ov)
        #for formula in formula_list:
        #    if bpimg(formula) is not None:
        f1 = bpimg(mm)
        #for x in f1:
        if f1 is not None:
            bpy.data.images[mm].name = TexMain
            bpy.data.images[TexMain].filepath = fixlocate+TexMain
            bpy.data.images[TexMain].filepath_raw = fixlocate+TexMain
        f2 = bpimg(dm)
        #for x in f2:
        if f2 is not None:
            bpy.data.images[dm].name = TexDetailM
            bpy.data.images[TexDetailM].filepath = fixlocate+TexDetailM
            bpy.data.images[TexDetailM].filepath_raw = fixlocate+TexDetailM
        f3 = bpimg(nm)
        #for x in f3:
        if f3 is not None:
            bpy.data.images[nm].name = TexNormal
            bpy.data.images[TexNormal].filepath = fixlocate+TexNormal
            bpy.data.images[TexNormal].filepath_raw = fixlocate+TexNormal
        f4 = bpimg(t2)
        #for x in f3:
        if f4 is not None:
            bpy.data.images[t2].name = TexTex2
            bpy.data.images[TexTex2].filepath = fixlocate+TexTex2
            bpy.data.images[TexTex2].filepath_raw = fixlocate+TexTex2
        f5 = bpimg(t3)
        #for x in f4:
        if f5 is not None:
            bpy.data.images[t3].name = TexTex3
            bpy.data.images[TexTex3].filepath = fixlocate+TexTex3
            bpy.data.images[TexTex3].filepath_raw = fixlocate+TexTex3
        f6 = bpimg(am)
        #for x in f5:
        if f6 is not None:
            bpy.data.images[am].name = TexAlphaM
            bpy.data.images[TexAlphaM].filepath = fixlocate+TexAlphaM
            bpy.data.images[TexAlphaM].filepath_raw = fixlocate+TexAlphaM
        f7 = bpimg(lm)
        #for x in f6:
        if f7 is not None:
            bpy.data.images[lm].name = TexLiquidM
            bpy.data.images[TexLiquidM].filepath = fixlocate+TexLiquidM
            bpy.data.images[TexLiquidM].filepath_raw = fixlocate+TexLiquidM
        f8 = bpimg(ar)
        #for f8 in f8:
        if f8 is not None:
            bpy.data.images[ar].name = TexAnotherR
            bpy.data.images[TexAnotherR].filepath = fixlocate+TexAnotherR
            bpy.data.images[TexAnotherR].filepath_raw = fixlocate+TexAnotherR
        f9 = bpimg(nd)
        #for f8 in f8:
        if f9 is not None:
            bpy.data.images[nd].name = TexNDetail
            bpy.data.images[TexNDetail].filepath = fixlocate+TexNDetail
            bpy.data.images[TexNDetail].filepath_raw = fixlocate+TexNDetail
        f10 = bpimg(ov1)
        #for f8 in f8:
        if f10 is not None:
            bpy.data.images[ov1].name = TexOv1
            bpy.data.images[TexOv1].filepath = fixlocate+TexOv1
            bpy.data.images[TexOv1].filepath_raw = fixlocate+TexOv1
        f11 = bpimg(ov2)
        #for f8 in f8:
        if f11 is not None:
            bpy.data.images[ov2].name = TexOv2
            bpy.data.images[TexOv2].filepath = fixlocate+TexOv2
            bpy.data.images[TexOv2].filepath_raw = fixlocate+TexOv2
        f12 = bpimg(lnm)
        #for f8 in f8:
        if f12 is not None:
            bpy.data.images[lnm].name = TexLineM
            bpy.data.images[TexLineM].filepath = fixlocate+TexLineM
            bpy.data.images[TexLineM].filepath_raw = fixlocate+TexLineM
        f13 = bpimg(com)
        #for f8 in f8:
        if f13 is not None:
            bpy.data.images[com].name = TexColorM
            bpy.data.images[TexColorM].filepath = fixlocate+TexColorM
            bpy.data.images[TexColorM].filepath_raw = fixlocate+TexColorM
        f14 = bpimg(glo)
        #for f8 in f8:
        if f14 is not None:
            bpy.data.images[glo].name = TexHairG
            bpy.data.images[TexHairG].filepath = fixlocate+TexHairG
            bpy.data.images[TexHairG].filepath_raw = fixlocate+TexHairG
        f15 = bpimg(bum)
        #for f8 in f8:
        if f15 is not None:
            bpy.data.images[bum].name = TexBump
            bpy.data.images[TexBump].filepath = fixlocate+TexBump
            bpy.data.images[TexBump].filepath_raw = fixlocate+TexBump
        f16 = bpimg(dnm)
        #for f8 in f8:
        if f16 is not None:
            bpy.data.images[dnm].name = TexDNM
            bpy.data.images[TexDNM].filepath = fixlocate+TexDNM
            bpy.data.images[TexDNM].filepath_raw = fixlocate+TexDNM
        f17 = bpimg(bnm)
        #for f8 in f8:
        if f17 is not None:
            bpy.data.images[bnm].name = TexBNM
            bpy.data.images[TexBNM].filepath = fixlocate+TexBNM
            bpy.data.images[TexBNM].filepath_raw = fixlocate+TexBNM
        f18 = bpimg(sgm)
        #for f8 in f8:
        if f18 is not None:
            bpy.data.images[sgm].name = TexSGM
            bpy.data.images[TexSGM].filepath = fixlocate+TexSGM
            bpy.data.images[TexSGM].filepath_raw = fixlocate+TexSGM
        f19 = bpimg(om)
        #for f8 in f8:
        if f19 is not None:
            bpy.data.images[om].name = TexOM
            bpy.data.images[TexOM].filepath = fixlocate+TexOM
            bpy.data.images[TexOM].filepath_raw = fixlocate+TexOM
        f20 = bpimg(tss)
        #for f8 in f8:
        if f20 is not None:
            bpy.data.images[tss].name = TexTSS
            bpy.data.images[TexTSS].filepath = fixlocate+TexTSS
            bpy.data.images[TexTSS].filepath_raw = fixlocate+TexTSS
        f21 = bpimg(mgm)
        #for f8 in f8:
        if f21 is not None:
            bpy.data.images[mgm].name = TexMGM
            bpy.data.images[TexMGM].filepath = fixlocate+TexMGM
            bpy.data.images[TexMGM].filepath_raw = fixlocate+TexMGM
        f22 = bpimg(ov)
        #for f8 in f8:
        if f22 is not None:
            bpy.data.images[ov].name = TexOV
            bpy.data.images[TexOV].filepath = fixlocate+TexOV
            bpy.data.images[TexOV].filepath_raw = fixlocate+TexOV
        bpy.ops.file.find_missing_files('INVOKE_DEFAULT')
        return {"FINISHED"}

    def invoke(self, context, event):
        return self.execute(context)


class SNA_OT_Kkpbody_609D4(bpy.types.Operator):
    bl_idname = "sna.kkpbody_609d4"
    bl_label = "kkp-body"
    bl_description = "BODY"
    bl_options = {"REGISTER", "UNDO"}

    @classmethod
    def poll(cls, context):
        return not False

    def execute(self, context):
        import os
        ########################################################################
        my_mat = bpy.context.object.material_slots[0].material
        print(my_mat.name)
        Tex=my_mat.name
        rem_mat = bpy.data.materials[Tex]
        #Get the node in its node tree (replace the name below)
        node_to_delete =  rem_mat.node_tree.nodes['Principled BSDF']
        node_to_delete2 =  rem_mat.node_tree.nodes['Material Output']
        #Remove it
        rem_mat.node_tree.nodes.remove(node_to_delete)
        rem_mat.node_tree.nodes.remove(node_to_delete2)
        #Tex = material.name
        TexMain = Tex+'_MainTex.png'
        TexDetailM = Tex+'_DetailMask.png'
        TexNormal = Tex+'_NormalMap.png'
        TexNDetail = Tex+'_NormalMapDetail.png'
        TexAlphaM = Tex+'_AlphaMask.png'
        TexAnotherR = Tex+'_AnotherRamp.png'
        TexLiquidM = Tex+'_liquidmask.png'
        TexTex2 = Tex+'_Texture2.png'
        TexTex3 = Tex+'_Texture3.png'
        TexOv1 = Tex+'_overtex1.png'
        TexOv2 = Tex+'_overtex2.png'
        TexLineM = Tex+'_LineMask.png'
        TexColorM = Tex+'_ColorMask.png'
        TexHairG = Tex+'_HairGloss.png'
        TexBump = Tex+'_BumpMap.png'
        TexDNM = Tex+'_DetailNormalMap.png'
        TexBNM = Tex+'_BlendNormalMap.png'
        TexSGM = Tex+'_SpecGlossMap.png'
        TexOM = Tex+'_OcclusionMap.png'
        TexTSS = Tex+'_Thickness.png'
        TexMGM = Tex+'_MetallicGlossMap.png'
        TexOV = Tex+'_OverTex.png'
        originaltex = 'cf_m_body_'
        #originaltss = 'cf_m_body_01_'
        #kkp
        nm = originaltex+'NormalMap.png'
        nd = originaltex+'NormalMapDetail.png'
        dm = originaltex+'DetailMask.png'
        mm = originaltex+'MainTex.png'
        t3 = originaltex+'Texture3.png'
        t2 = originaltex+'Texture2.png'
        am = originaltex+'AlphaMask.png'
        lm = originaltex+'liquidmask.png'
        ar = originaltex+'AnotherRamp.png'
        ov1 = originaltex+'overtex1.png'
        ov2 = originaltex+'overtex2.png'
        lnm = originaltex+'LineMask.png'
        com = originaltex+'ColorMask.png'
        glo = originaltex+'HairGloss.png'
        #hs1
        bum = originaltex+'BumpMap.png'
        dnm = originaltex+'DetailNormalMap.png'
        bnm = originaltex+'BlendNormalMap.png'
        sgm = originaltex+'SpecGlossMap.png'
        om = originaltex+'OcclusionMap.png'
        tss = originaltex+'Thickness.png'
        mgm = originaltex+'MetallicGlossMap.png'
        ov = originaltex+'OverTex.png'
        Template='KK-Template Body'
        CTemplate=Template+' '
        C = bpy.context

        def instantiate_group(nodes, data_block_name):
            group = nodes.new(type='ShaderNodeGroup')
            group.node_tree = bpy.data.node_groups[Template]
            return group
        if Template in bpy.data.node_groups:
            instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
        else:
        #    versions = ( t0, t1, t2, t3, t4)
        #    for x in versions:
        #        if os.path.isdir(x) and os.access(x, os.R_OK):
            if (3, 0, 0) <= bpy.app.version < (3, 0, 99):
                before_data = list(bpy.data.node_groups)
                bpy.ops.wm.append(directory=os.path.expanduser(r"~\AppData\Roaming\Blender Foundation\Blender\3.0\scripts\addons\sklx_creator\assets\KK_Template_Shader.blend") + r'\NodeTree',filename=Template,link=False)
                new_data=list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
                appended_2B5AC = None if not new_data else new_data[0]
                instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
            else:
                if (3, 1, 0) <= bpy.app.version < (3, 1, 99):
                    before_data = list(bpy.data.node_groups)
                    bpy.ops.wm.append(directory=os.path.expanduser(r"~\AppData\Roaming\Blender Foundation\Blender\3.1\scripts\addons\sklx_creator\assets\KK_Template_Shader.blend") + r'\NodeTree',filename=Template,link=False)
                    new_data=list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
                    appended_2B5AC = None if not new_data else new_data[0]
                    instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
                else:
                    if (3, 2, 0) <= bpy.app.version < (3, 2, 99):
                        before_data = list(bpy.data.node_groups)
                        bpy.ops.wm.append(directory=os.path.expanduser(r"~\AppData\Roaming\Blender Foundation\Blender\3.2\scripts\addons\sklx_creator\assets\KK_Template_Shader.blend") + r'\NodeTree',filename=Template,link=False)
                        new_data=list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
                        appended_2B5AC = None if not new_data else new_data[0]
                        instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
                    else:
                        if (3, 3, 0) <= bpy.app.version < (3, 3, 99):
                            before_data = list(bpy.data.node_groups)
                            bpy.ops.wm.append(directory=os.path.expanduser(r"~\AppData\Roaming\Blender Foundation\Blender\3.3\scripts\addons\sklx_creator\assets\KK_Template_Shader.blend") + r'\NodeTree',filename=Template,link=False)
                            new_data=list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
                            appended_2B5AC = None if not new_data else new_data[0]
                            instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
                        else:
                            if (3, 4, 0) <= bpy.app.version < (3, 4, 99):
                                before_data = list(bpy.data.node_groups)
                                bpy.ops.wm.append(directory=os.path.expanduser(r"~\AppData\Roaming\Blender Foundation\Blender\3.4\scripts\addons\sklx_creator\assets\KK_Template_Shader.blend") + r'\NodeTree',filename=Template,link=False)
                                new_data=list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
                                appended_2B5AC = None if not new_data else new_data[0]
                                instantiate_group(C.object.material_slots[0].material.node_tree.nodes, 'NodeGroup')
        bpy.data.node_groups[Template].name = CTemplate+Tex
        node = bpy.data.node_groups[CTemplate+Tex]
        #initial_area_type = bpy.context.area.type
        #bpy.context.area.type = 'NODE_EDITOR'
        #bpy.context.area.ui_type = 'ShaderNodeTree'
        #bpy.ops.wm.redraw_timer(type='DRAW_WIN', iterations=1)
        #bpy.ops.node.group_ungroup()
        #bpy.ops.node.group_edit(exit=True)
        #bpy.context.area.type = initial_area_type
        nodes = my_mat.node_tree.nodes
        for node in nodes:
            #node.select = False
            print(node.name)
            node.select = True
            nodes.active = node
        try:
            initial_area_type = bpy.context.area.type
            bpy.context.area.type = 'NODE_EDITOR'
            bpy.context.area.ui_type = 'ShaderNodeTree'
            bpy.ops.wm.redraw_timer(type='DRAW_WIN', iterations=1)
            bpy.ops.node.group_ungroup()
            nonono = node," to Ungroup"
            print(nonono)
            bpy.ops.node.group_edit(exit=True)
        except Exception as e:
            print(e)
        finally:
            bpy.context.area.type = initial_area_type
        fixlocate = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\\20220603141428_Chika_Haruno\\Textures\\"
        bpimg = bpy.data.images.get
        if 1==1:
            print(mm)
            print(dm)
            print(nm)
            print(t2)
            print(t3)
        #formula_list=(nm,nd,dm,mm,t2,t3,am,lm,ar,ov1,ov2,lnm,com,glo,bum,dnm,bnm,sgm,om,tss,mgm,ov)
        #for formula in formula_list:
        #    if bpimg(formula) is not None:
        f1 = bpimg(mm)
        #for x in f1:
        if f1 is not None:
            bpy.data.images[mm].name = TexMain
            bpy.data.images[TexMain].filepath = fixlocate+TexMain
            bpy.data.images[TexMain].filepath_raw = fixlocate+TexMain
        f2 = bpimg(dm)
        #for x in f2:
        if f2 is not None:
            bpy.data.images[dm].name = TexDetailM
            bpy.data.images[TexDetailM].filepath = fixlocate+TexDetailM
            bpy.data.images[TexDetailM].filepath_raw = fixlocate+TexDetailM
        f3 = bpimg(nm)
        #for x in f3:
        if f3 is not None:
            bpy.data.images[nm].name = TexNormal
            bpy.data.images[TexNormal].filepath = fixlocate+TexNormal
            bpy.data.images[TexNormal].filepath_raw = fixlocate+TexNormal
        f4 = bpimg(t2)
        #for x in f3:
        if f4 is not None:
            bpy.data.images[t2].name = TexTex2
            bpy.data.images[TexTex2].filepath = fixlocate+TexTex2
            bpy.data.images[TexTex2].filepath_raw = fixlocate+TexTex2
        f5 = bpimg(t3)
        #for x in f4:
        if f5 is not None:
            bpy.data.images[t3].name = TexTex3
            bpy.data.images[TexTex3].filepath = fixlocate+TexTex3
            bpy.data.images[TexTex3].filepath_raw = fixlocate+TexTex3
        f6 = bpimg(am)
        #for x in f5:
        if f6 is not None:
            bpy.data.images[am].name = TexAlphaM
            bpy.data.images[TexAlphaM].filepath = fixlocate+TexAlphaM
            bpy.data.images[TexAlphaM].filepath_raw = fixlocate+TexAlphaM
        f7 = bpimg(lm)
        #for x in f6:
        if f7 is not None:
            bpy.data.images[lm].name = TexLiquidM
            bpy.data.images[TexLiquidM].filepath = fixlocate+TexLiquidM
            bpy.data.images[TexLiquidM].filepath_raw = fixlocate+TexLiquidM
        f8 = bpimg(ar)
        #for f8 in f8:
        if f8 is not None:
            bpy.data.images[ar].name = TexAnotherR
            bpy.data.images[TexAnotherR].filepath = fixlocate+TexAnotherR
            bpy.data.images[TexAnotherR].filepath_raw = fixlocate+TexAnotherR
        f9 = bpimg(nd)
        #for f8 in f8:
        if f9 is not None:
            bpy.data.images[nd].name = TexNDetail
            bpy.data.images[TexNDetail].filepath = fixlocate+TexNDetail
            bpy.data.images[TexNDetail].filepath_raw = fixlocate+TexNDetail
        f10 = bpimg(ov1)
        #for f8 in f8:
        if f10 is not None:
            bpy.data.images[ov1].name = TexOv1
            bpy.data.images[TexOv1].filepath = fixlocate+TexOv1
            bpy.data.images[TexOv1].filepath_raw = fixlocate+TexOv1
        f11 = bpimg(ov2)
        #for f8 in f8:
        if f11 is not None:
            bpy.data.images[ov2].name = TexOv2
            bpy.data.images[TexOv2].filepath = fixlocate+TexOv2
            bpy.data.images[TexOv2].filepath_raw = fixlocate+TexOv2
        f12 = bpimg(lnm)
        #for f8 in f8:
        if f12 is not None:
            bpy.data.images[lnm].name = TexLineM
            bpy.data.images[TexLineM].filepath = fixlocate+TexLineM
            bpy.data.images[TexLineM].filepath_raw = fixlocate+TexLineM
        f13 = bpimg(com)
        #for f8 in f8:
        if f13 is not None:
            bpy.data.images[com].name = TexColorM
            bpy.data.images[TexColorM].filepath = fixlocate+TexColorM
            bpy.data.images[TexColorM].filepath_raw = fixlocate+TexColorM
        f14 = bpimg(glo)
        #for f8 in f8:
        if f14 is not None:
            bpy.data.images[glo].name = TexHairG
            bpy.data.images[TexHairG].filepath = fixlocate+TexHairG
            bpy.data.images[TexHairG].filepath_raw = fixlocate+TexHairG
        f15 = bpimg(bum)
        #for f8 in f8:
        if f15 is not None:
            bpy.data.images[bum].name = TexBump
            bpy.data.images[TexBump].filepath = fixlocate+TexBump
            bpy.data.images[TexBump].filepath_raw = fixlocate+TexBump
        f16 = bpimg(dnm)
        #for f8 in f8:
        if f16 is not None:
            bpy.data.images[dnm].name = TexDNM
            bpy.data.images[TexDNM].filepath = fixlocate+TexDNM
            bpy.data.images[TexDNM].filepath_raw = fixlocate+TexDNM
        f17 = bpimg(bnm)
        #for f8 in f8:
        if f17 is not None:
            bpy.data.images[bnm].name = TexBNM
            bpy.data.images[TexBNM].filepath = fixlocate+TexBNM
            bpy.data.images[TexBNM].filepath_raw = fixlocate+TexBNM
        f18 = bpimg(sgm)
        #for f8 in f8:
        if f18 is not None:
            bpy.data.images[sgm].name = TexSGM
            bpy.data.images[TexSGM].filepath = fixlocate+TexSGM
            bpy.data.images[TexSGM].filepath_raw = fixlocate+TexSGM
        f19 = bpimg(om)
        #for f8 in f8:
        if f19 is not None:
            bpy.data.images[om].name = TexOM
            bpy.data.images[TexOM].filepath = fixlocate+TexOM
            bpy.data.images[TexOM].filepath_raw = fixlocate+TexOM
        f20 = bpimg(tss)
        #for f8 in f8:
        if f20 is not None:
            bpy.data.images[tss].name = TexTSS
            bpy.data.images[TexTSS].filepath = fixlocate+TexTSS
            bpy.data.images[TexTSS].filepath_raw = fixlocate+TexTSS
        f21 = bpimg(mgm)
        #for f8 in f8:
        if f21 is not None:
            bpy.data.images[mgm].name = TexMGM
            bpy.data.images[TexMGM].filepath = fixlocate+TexMGM
            bpy.data.images[TexMGM].filepath_raw = fixlocate+TexMGM
        f22 = bpimg(ov)
        #for f8 in f8:
        if f22 is not None:
            bpy.data.images[ov].name = TexOV
            bpy.data.images[TexOV].filepath = fixlocate+TexOV
            bpy.data.images[TexOV].filepath_raw = fixlocate+TexOV
        bpy.ops.file.find_missing_files('INVOKE_DEFAULT')
        return {"FINISHED"}

    def invoke(self, context, event):
        return self.execute(context)


class SNA_OT_Kksappenddata_59897(bpy.types.Operator):
    bl_idname = "sna.kksappenddata_59897"
    bl_label = "kks-append-data"
    bl_description = "Set the shaders to the koikatsu sunshine character"
    bl_options = {"REGISTER", "UNDO"}

    @classmethod
    def poll(cls, context):
        return not False

    def execute(self, context):
        return {"FINISHED"}

    def invoke(self, context, event):
        return self.execute(context)


def sna_select_an_option_enum_items(self, context):
    enum_items = [['Koikatsu Party', 'Koikatsu Party', '', _icons['koi-party.png'].icon_id], ['Koikatsu Sunshine', 'Koikatsu Sunshine', '', _icons['koi-sunshine.png'].icon_id], ['Emotion Creators', 'Emotion Creators', '', _icons['e-creators.png'].icon_id], ['Honey Select', 'Honey Select', '', _icons['h-select.png'].icon_id], ['Honey Select 2', 'Honey Select 2', '', _icons['h-select-2.png'].icon_id], ['Ai Shoujo', 'Ai Shoujo', '', _icons['ai-shoujo.png'].icon_id], ['PlayHome', 'PlayHome', '', _icons['play-home.png'].icon_id], ['Room Girl', 'Room Girl', '', _icons['room-girl.png'].icon_id]]
    return [make_enum_item(item[0], item[1], item[2], item[3], i) for i, item in enumerate(enum_items)]


def sna_modelimporter_FCA6D(layout_function, ):
    box_2EC33 = layout_function.box()
    box_2EC33.alert = False
    box_2EC33.enabled = True
    box_2EC33.active = True
    box_2EC33.use_property_split = False
    box_2EC33.use_property_decorate = False
    box_2EC33.alignment = 'Expand'.upper()
    box_2EC33.scale_x = 1.0
    box_2EC33.scale_y = 1.0
    box_2EC33.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
    box_2EC33.label(text='Select your game!', icon_value=_icons['red.png'].icon_id)
    box_2EC33.prop(bpy.context.scene, 'sna_select_an_option', text='', icon_value=0, emboss=True)
    col_83326 = box_2EC33.column(heading='', align=True)
    col_83326.alert = False
    col_83326.enabled = True
    col_83326.active = True
    col_83326.use_property_split = False
    col_83326.use_property_decorate = False
    col_83326.scale_x = 1.0
    col_83326.scale_y = 1.0
    col_83326.alignment = 'Expand'.upper()
    col_83326.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
    if bpy.context.scene.sna_select_an_option == "Koikatsu Party":
        box_16E59 = col_83326.box()
        box_16E59.alert = False
        box_16E59.enabled = True
        box_16E59.active = True
        box_16E59.use_property_split = False
        box_16E59.use_property_decorate = False
        box_16E59.alignment = 'Expand'.upper()
        box_16E59.scale_x = 1.0
        box_16E59.scale_y = 1.0
        box_16E59.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
        row_849C5 = box_16E59.row(heading='', align=True)
        row_849C5.alert = False
        row_849C5.enabled = True
        row_849C5.active = True
        row_849C5.use_property_split = False
        row_849C5.use_property_decorate = False
        row_849C5.scale_x = 1.0
        row_849C5.scale_y = 1.0
        row_849C5.alignment = 'Expand'.upper()
        row_849C5.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
        op = row_849C5.operator('better_import.fbx', text='Model', icon_value=0, emboss=True, depress=False)
        op.my_bone_length = 1.0
        op.my_leaf_bone = 'Short'
        op.my_scale = 0.9599999785423279
        op = row_849C5.operator('better_import.fbx', text='Animation', icon_value=0, emboss=True, depress=False)
        op.my_bone_length = 1.0
        op.my_leaf_bone = 'Short'
        op.my_scale = 0.9599999785423279
        op.use_import_materials = False
    elif bpy.context.scene.sna_select_an_option == "Koikatsu Sunshine":
        box_57F38 = col_83326.box()
        box_57F38.alert = False
        box_57F38.enabled = True
        box_57F38.active = True
        box_57F38.use_property_split = False
        box_57F38.use_property_decorate = False
        box_57F38.alignment = 'Expand'.upper()
        box_57F38.scale_x = 1.0
        box_57F38.scale_y = 1.0
        box_57F38.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
        row_2A858 = box_57F38.row(heading='', align=True)
        row_2A858.alert = False
        row_2A858.enabled = True
        row_2A858.active = True
        row_2A858.use_property_split = False
        row_2A858.use_property_decorate = False
        row_2A858.scale_x = 1.0
        row_2A858.scale_y = 1.0
        row_2A858.alignment = 'Expand'.upper()
        row_2A858.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
        op = row_2A858.operator('better_import.fbx', text='Model', icon_value=0, emboss=True, depress=False)
        op.my_bone_length = 1.0
        op.my_leaf_bone = 'Short'
        op.my_scale = 0.9599999785423279
        op = row_2A858.operator('better_import.fbx', text='Animation', icon_value=0, emboss=True, depress=False)
        op.my_bone_length = 1.0
        op.my_leaf_bone = 'Short'
        op.my_scale = 0.9599999785423279
        op.use_import_materials = False
    elif bpy.context.scene.sna_select_an_option == "Emotion Creators":
        box_633B8 = col_83326.box()
        box_633B8.alert = False
        box_633B8.enabled = True
        box_633B8.active = True
        box_633B8.use_property_split = False
        box_633B8.use_property_decorate = False
        box_633B8.alignment = 'Expand'.upper()
        box_633B8.scale_x = 1.0
        box_633B8.scale_y = 1.0
        box_633B8.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
        row_42EE9 = box_633B8.row(heading='', align=True)
        row_42EE9.alert = False
        row_42EE9.enabled = True
        row_42EE9.active = True
        row_42EE9.use_property_split = False
        row_42EE9.use_property_decorate = False
        row_42EE9.scale_x = 1.0
        row_42EE9.scale_y = 1.0
        row_42EE9.alignment = 'Expand'.upper()
        row_42EE9.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
        op = row_42EE9.operator('better_import.fbx', text='Model', icon_value=0, emboss=True, depress=False)
        op.my_bone_length = 1.0
        op.my_leaf_bone = 'Short'
        op.my_scale = 1.031499981880188
        op = row_42EE9.operator('better_import.fbx', text='Animation', icon_value=0, emboss=True, depress=False)
        op.my_bone_length = 1.0
        op.my_leaf_bone = 'Short'
        op.my_scale = 1.031499981880188
        op.use_import_materials = False
    elif bpy.context.scene.sna_select_an_option == "Honey Select":
        box_DBF32 = col_83326.box()
        box_DBF32.alert = False
        box_DBF32.enabled = True
        box_DBF32.active = True
        box_DBF32.use_property_split = False
        box_DBF32.use_property_decorate = False
        box_DBF32.alignment = 'Expand'.upper()
        box_DBF32.scale_x = 1.0
        box_DBF32.scale_y = 1.0
        box_DBF32.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
        row_B0BA0 = box_DBF32.row(heading='', align=True)
        row_B0BA0.alert = False
        row_B0BA0.enabled = True
        row_B0BA0.active = True
        row_B0BA0.use_property_split = False
        row_B0BA0.use_property_decorate = False
        row_B0BA0.scale_x = 1.0
        row_B0BA0.scale_y = 1.0
        row_B0BA0.alignment = 'Expand'.upper()
        row_B0BA0.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
        op = row_B0BA0.operator('better_import.fbx', text='Model', icon_value=0, emboss=True, depress=False)
        op.my_bone_length = 1.0
        op.my_leaf_bone = 'Short'
        op.my_scale = 1.0
        op = row_B0BA0.operator('better_import.fbx', text='Animation', icon_value=0, emboss=True, depress=False)
        op.my_bone_length = 1.0
        op.my_leaf_bone = 'Short'
        op.my_scale = 1.0
        op.use_import_materials = False
    elif bpy.context.scene.sna_select_an_option == "Honey Select 2":
        box_4C58A = col_83326.box()
        box_4C58A.alert = False
        box_4C58A.enabled = True
        box_4C58A.active = True
        box_4C58A.use_property_split = False
        box_4C58A.use_property_decorate = False
        box_4C58A.alignment = 'Expand'.upper()
        box_4C58A.scale_x = 1.0
        box_4C58A.scale_y = 1.0
        box_4C58A.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
        row_23C48 = box_4C58A.row(heading='', align=True)
        row_23C48.alert = False
        row_23C48.enabled = True
        row_23C48.active = True
        row_23C48.use_property_split = False
        row_23C48.use_property_decorate = False
        row_23C48.scale_x = 1.0
        row_23C48.scale_y = 1.0
        row_23C48.alignment = 'Expand'.upper()
        row_23C48.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
        op = row_23C48.operator('better_import.fbx', text='Model', icon_value=0, emboss=True, depress=False)
        op.my_bone_length = 1.0
        op.my_leaf_bone = 'Short'
        op.my_scale = 0.10000000149011612
        op = row_23C48.operator('better_import.fbx', text='Animation', icon_value=0, emboss=True, depress=False)
        op.my_bone_length = 1.0
        op.my_leaf_bone = 'Short'
        op.my_scale = 0.10000000149011612
        op.use_import_materials = False
    elif bpy.context.scene.sna_select_an_option == "Ai Shoujo":
        box_05907 = col_83326.box()
        box_05907.alert = False
        box_05907.enabled = True
        box_05907.active = True
        box_05907.use_property_split = False
        box_05907.use_property_decorate = False
        box_05907.alignment = 'Expand'.upper()
        box_05907.scale_x = 1.0
        box_05907.scale_y = 1.0
        box_05907.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
        row_76743 = box_05907.row(heading='', align=True)
        row_76743.alert = False
        row_76743.enabled = True
        row_76743.active = True
        row_76743.use_property_split = False
        row_76743.use_property_decorate = False
        row_76743.scale_x = 1.0
        row_76743.scale_y = 1.0
        row_76743.alignment = 'Expand'.upper()
        row_76743.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
        op = row_76743.operator('better_import.fbx', text='Model', icon_value=0, emboss=True, depress=False)
        op.my_bone_length = 1.0
        op.my_leaf_bone = 'Short'
        op.my_scale = 0.10000000149011612
        op = row_76743.operator('better_import.fbx', text='Animation', icon_value=0, emboss=True, depress=False)
        op.my_bone_length = 1.0
        op.my_leaf_bone = 'Short'
        op.my_scale = 0.10000000149011612
        op.use_import_materials = False
    elif bpy.context.scene.sna_select_an_option == "PlayHome":
        box_A2632 = col_83326.box()
        box_A2632.alert = False
        box_A2632.enabled = True
        box_A2632.active = True
        box_A2632.use_property_split = False
        box_A2632.use_property_decorate = False
        box_A2632.alignment = 'Expand'.upper()
        box_A2632.scale_x = 1.0
        box_A2632.scale_y = 1.0
        box_A2632.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
        row_5B85C = box_A2632.row(heading='', align=True)
        row_5B85C.alert = False
        row_5B85C.enabled = True
        row_5B85C.active = True
        row_5B85C.use_property_split = False
        row_5B85C.use_property_decorate = False
        row_5B85C.scale_x = 1.0
        row_5B85C.scale_y = 1.0
        row_5B85C.alignment = 'Expand'.upper()
        row_5B85C.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
        op = row_5B85C.operator('better_import.fbx', text='Model', icon_value=0, emboss=True, depress=False)
        op.my_bone_length = 1.0
        op.my_leaf_bone = 'Short'
        op.my_scale = 1.0
        op = row_5B85C.operator('better_import.fbx', text='Animation', icon_value=0, emboss=True, depress=False)
        op.my_bone_length = 1.0
        op.my_leaf_bone = 'Short'
        op.my_scale = 1.0
        op.use_import_materials = False
    elif bpy.context.scene.sna_select_an_option == "Room Girl":
        box_A46FB = col_83326.box()
        box_A46FB.alert = False
        box_A46FB.enabled = True
        box_A46FB.active = True
        box_A46FB.use_property_split = False
        box_A46FB.use_property_decorate = False
        box_A46FB.alignment = 'Expand'.upper()
        box_A46FB.scale_x = 1.0
        box_A46FB.scale_y = 1.0
        box_A46FB.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
        row_23B20 = box_A46FB.row(heading='', align=True)
        row_23B20.alert = False
        row_23B20.enabled = True
        row_23B20.active = True
        row_23B20.use_property_split = False
        row_23B20.use_property_decorate = False
        row_23B20.scale_x = 1.0
        row_23B20.scale_y = 1.0
        row_23B20.alignment = 'Expand'.upper()
        row_23B20.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
        op = row_23B20.operator('better_import.fbx', text='Model', icon_value=0, emboss=True, depress=False)
        op.my_bone_length = 1.0
        op.my_leaf_bone = 'Short'
        op.my_scale = 1.0
        op = row_23B20.operator('better_import.fbx', text='Animation', icon_value=0, emboss=True, depress=False)
        op.my_bone_length = 1.0
        op.my_leaf_bone = 'Short'
        op.my_scale = 1.0
        op.use_import_materials = False
    else:
        pass
    if ((eval("str(palette_color_hat_p)") == eval("str(bpy.data.scenes['Scene'].sna_importkkp)")) and ('Koikatsu Full' != bpy.context.scene.sna_select_an_option)):
        box_582E4 = col_83326.box()
        box_582E4.alert = False
        box_582E4.enabled = True
        box_582E4.active = True
        box_582E4.use_property_split = False
        box_582E4.use_property_decorate = False
        box_582E4.alignment = 'Expand'.upper()
        box_582E4.scale_x = 1.0
        box_582E4.scale_y = 1.0
        box_582E4.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
        col_42AF0 = box_582E4.column(heading='', align=False)
        col_42AF0.alert = False
        col_42AF0.enabled = True
        col_42AF0.active = True
        col_42AF0.use_property_split = False
        col_42AF0.use_property_decorate = False
        col_42AF0.scale_x = 1.0
        col_42AF0.scale_y = 1.0
        col_42AF0.alignment = 'Expand'.upper()
        col_42AF0.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
        layout_function = col_42AF0
        sna_animationswapper_B5A72(layout_function, )
        row_4F14A = col_42AF0.row(heading='', align=True)
        row_4F14A.alert = False
        row_4F14A.enabled = True
        row_4F14A.active = True
        row_4F14A.use_property_split = False
        row_4F14A.use_property_decorate = False
        row_4F14A.scale_x = 1.0
        row_4F14A.scale_y = 1.0
        row_4F14A.alignment = 'Expand'.upper()
        row_4F14A.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
        row_4F14A.label(text='Fix Bones', icon_value=0)
        op = row_4F14A.operator('sna.fixbone_07975', text='FIX', icon_value=0, emboss=True, depress=False)


class SNA_OT_Fixbone_07975(bpy.types.Operator):
    bl_idname = "sna.fixbone_07975"
    bl_label = "fix-bone"
    bl_description = "fix pose bones for animation"
    bl_options = {"REGISTER", "UNDO"}

    @classmethod
    def poll(cls, context):
        return not False

    def execute(self, context):
        ArmaFix = eval("(bpy.context.scene.sna_charaselect).name")
        bpy.ops.object.select_all(action='DESELECT')
        bpy.data.objects.get(ArmaFix).select_set(True)
        armatureobject = bpy.data.objects.get(ArmaFix)
        bpy.context.view_layer.objects.active = armatureobject
        armt = bpy.data.objects[ArmaFix].data.bones.get
        bpy.ops.object.mode_set(mode='POSE')
        bones = (armt("cf_d_arm01_L"),armt("cf_d_shoulder02_L"),armt("cf_d_arm01_R"),armt("cf_d_shoulder02_R"),armt("cf_J_ArmUp01_dam_L"),armt("cf_J_LegUp01_L"),armt("cf_J_ArmUp01_dam_R"),armt("cf_J_LegUp01_R"))
        #first 4 from koikatsuparty, second 4 from honeyselect2
        for x in bones:
            if x is not None:
                x.select = True
        #bpy.ops.pose.group_add(0)
        bpy.ops.pose.group_assign(0)
        #bpy.ops.pose.group_name(0).name = 
        bpy.ops.pose.transforms_clear(True)
        scene = bpy.context.scene
        #scene.frame_start = 0
        #scene.frame_end = 250
        for area in bpy.context.screen.areas:
            if area.type == 'DOPESHEET_EDITOR':
                for region in area.regions:
                    if region.type == 'WINDOW':
                        ctx = bpy.context.copy()
                        ctx['area'] = area
                        ctx['region'] = region
                        bpy.ops.action.view_all(ctx)
                        bpy.ops.action.delete(ctx)
        bpy.ops.object.mode_set(mode='OBJECT')
        return {"FINISHED"}

    def invoke(self, context, event):
        return self.execute(context)


class SNA_OT_Setanim_64953(bpy.types.Operator):
    bl_idname = "sna.setanim_64953"
    bl_label = "set-anim"
    bl_description = "set the imported animation to the main armature"
    bl_options = {"REGISTER", "UNDO"}

    @classmethod
    def poll(cls, context):
        return not False

    def execute(self, context):

        def set_animation():
            #this script will copy the animation data from the active Object to the selected object:
            armature = bpy.data.objects['Armature']
            animation_armature = bpy.data.objects['Armature.001']
            properties = [p.identifier for p in animation_armature.animation_data.bl_rna.properties if not p.is_readonly]
            if armature.animation_data == None :
                armature.animation_data_create()
            for prop in properties:
                setattr(armature.animation_data, prop, getattr(animation_armature.animation_data, prop))
        set_animation()
        return {"FINISHED"}

    def invoke(self, context, event):
        return self.execute(context)


class SNA_OT_Phappenddata_81459(bpy.types.Operator):
    bl_idname = "sna.phappenddata_81459"
    bl_label = "ph-append-data"
    bl_description = "Set the shaders to the playhome character"
    bl_options = {"REGISTER", "UNDO"}

    @classmethod
    def poll(cls, context):
        return not False

    def execute(self, context):
        return {"FINISHED"}

    def invoke(self, context, event):
        return self.execute(context)


class SNA_OT_Rgappenddata_Bf1E1(bpy.types.Operator):
    bl_idname = "sna.rgappenddata_bf1e1"
    bl_label = "rg-append-data"
    bl_description = "Set the shaders to the room girl character"
    bl_options = {"REGISTER", "UNDO"}

    @classmethod
    def poll(cls, context):
        return not False

    def execute(self, context):
        return {"FINISHED"}

    def invoke(self, context, event):
        return self.execute(context)


def sna_shaderimporter_DACA2(layout_function, ):
    if ('Koikatsu Party' == bpy.context.scene.sna_select_an_option):
        box_81BD4 = layout_function.box()
        box_81BD4.alert = False
        box_81BD4.enabled = True
        box_81BD4.active = True
        box_81BD4.use_property_split = False
        box_81BD4.use_property_decorate = False
        box_81BD4.alignment = 'Expand'.upper()
        box_81BD4.scale_x = 1.0
        box_81BD4.scale_y = 1.0
        box_81BD4.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
        row_6A004 = box_81BD4.row(heading='', align=True)
        row_6A004.alert = False
        row_6A004.enabled = True
        row_6A004.active = True
        row_6A004.use_property_split = False
        row_6A004.use_property_decorate = False
        row_6A004.scale_x = 1.0
        row_6A004.scale_y = 1.0
        row_6A004.alignment = 'Expand'.upper()
        row_6A004.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
        row_6A004.label(text='SKLX-KK Shaders', icon_value=0)
        row_4C5A7 = row_6A004.row(heading='', align=True)
        row_4C5A7.alert = True
        row_4C5A7.enabled = True
        row_4C5A7.active = True
        row_4C5A7.use_property_split = False
        row_4C5A7.use_property_decorate = False
        row_4C5A7.scale_x = 1.0
        row_4C5A7.scale_y = 1.0
        row_4C5A7.alignment = 'Expand'.upper()
        row_4C5A7.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
        op = row_4C5A7.operator('sna.kkpappenddata_b9b14', text='GO!', icon_value=0, emboss=True, depress=False)
    else:
        if ('Koikatsu Sunshine' == bpy.context.scene.sna_select_an_option):
            box_62389 = layout_function.box()
            box_62389.alert = False
            box_62389.enabled = True
            box_62389.active = True
            box_62389.use_property_split = False
            box_62389.use_property_decorate = False
            box_62389.alignment = 'Expand'.upper()
            box_62389.scale_x = 1.0
            box_62389.scale_y = 1.0
            box_62389.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
            row_3CC97 = box_62389.row(heading='', align=True)
            row_3CC97.alert = False
            row_3CC97.enabled = True
            row_3CC97.active = True
            row_3CC97.use_property_split = False
            row_3CC97.use_property_decorate = False
            row_3CC97.scale_x = 1.0
            row_3CC97.scale_y = 1.0
            row_3CC97.alignment = 'Expand'.upper()
            row_3CC97.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
            row_3CC97.label(text='SKLX-KKS Shaders', icon_value=0)
            row_B6DBA = row_3CC97.row(heading='', align=True)
            row_B6DBA.alert = True
            row_B6DBA.enabled = True
            row_B6DBA.active = True
            row_B6DBA.use_property_split = False
            row_B6DBA.use_property_decorate = False
            row_B6DBA.scale_x = 1.0
            row_B6DBA.scale_y = 1.0
            row_B6DBA.alignment = 'Expand'.upper()
            row_B6DBA.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
            op = row_B6DBA.operator('sna.kksappenddata_59897', text='GO!', icon_value=0, emboss=True, depress=False)
        else:
            if ('Emotion Creators' == bpy.context.scene.sna_select_an_option):
                box_A683C = layout_function.box()
                box_A683C.alert = False
                box_A683C.enabled = True
                box_A683C.active = True
                box_A683C.use_property_split = False
                box_A683C.use_property_decorate = False
                box_A683C.alignment = 'Expand'.upper()
                box_A683C.scale_x = 1.0
                box_A683C.scale_y = 1.0
                box_A683C.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
                row_6B79E = box_A683C.row(heading='', align=True)
                row_6B79E.alert = False
                row_6B79E.enabled = True
                row_6B79E.active = True
                row_6B79E.use_property_split = False
                row_6B79E.use_property_decorate = False
                row_6B79E.scale_x = 1.0
                row_6B79E.scale_y = 1.0
                row_6B79E.alignment = 'Expand'.upper()
                row_6B79E.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
                row_6B79E.label(text='SKLX-EC Shaders', icon_value=0)
                row_D7BCD = row_6B79E.row(heading='', align=True)
                row_D7BCD.alert = True
                row_D7BCD.enabled = True
                row_D7BCD.active = True
                row_D7BCD.use_property_split = False
                row_D7BCD.use_property_decorate = False
                row_D7BCD.scale_x = 1.0
                row_D7BCD.scale_y = 1.0
                row_D7BCD.alignment = 'Expand'.upper()
                row_D7BCD.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
                op = row_D7BCD.operator('sna.ecdataappend_e5571', text='GO!', icon_value=0, emboss=True, depress=False)
            else:
                if ('Honey Select' == bpy.context.scene.sna_select_an_option):
                    box_08324 = layout_function.box()
                    box_08324.alert = False
                    box_08324.enabled = True
                    box_08324.active = True
                    box_08324.use_property_split = False
                    box_08324.use_property_decorate = False
                    box_08324.alignment = 'Expand'.upper()
                    box_08324.scale_x = 1.0
                    box_08324.scale_y = 1.0
                    box_08324.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
                    row_4BEFB = box_08324.row(heading='', align=True)
                    row_4BEFB.alert = False
                    row_4BEFB.enabled = True
                    row_4BEFB.active = True
                    row_4BEFB.use_property_split = False
                    row_4BEFB.use_property_decorate = False
                    row_4BEFB.scale_x = 1.0
                    row_4BEFB.scale_y = 1.0
                    row_4BEFB.alignment = 'Expand'.upper()
                    row_4BEFB.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
                    row_4BEFB.label(text='SKLX-HS Shaders', icon_value=0)
                    row_F0B9E = row_4BEFB.row(heading='', align=True)
                    row_F0B9E.alert = True
                    row_F0B9E.enabled = True
                    row_F0B9E.active = True
                    row_F0B9E.use_property_split = False
                    row_F0B9E.use_property_decorate = False
                    row_F0B9E.scale_x = 1.0
                    row_F0B9E.scale_y = 1.0
                    row_F0B9E.alignment = 'Expand'.upper()
                    row_F0B9E.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
                    op = row_F0B9E.operator('sna.hsappenddata_e2120', text='GO!', icon_value=0, emboss=True, depress=False)
                else:
                    if ('Honey Select 2' == bpy.context.scene.sna_select_an_option):
                        box_82F24 = layout_function.box()
                        box_82F24.alert = False
                        box_82F24.enabled = True
                        box_82F24.active = True
                        box_82F24.use_property_split = False
                        box_82F24.use_property_decorate = False
                        box_82F24.alignment = 'Expand'.upper()
                        box_82F24.scale_x = 1.0
                        box_82F24.scale_y = 1.0
                        box_82F24.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
                        row_3A3BA = box_82F24.row(heading='', align=True)
                        row_3A3BA.alert = False
                        row_3A3BA.enabled = True
                        row_3A3BA.active = True
                        row_3A3BA.use_property_split = False
                        row_3A3BA.use_property_decorate = False
                        row_3A3BA.scale_x = 1.0
                        row_3A3BA.scale_y = 1.0
                        row_3A3BA.alignment = 'Expand'.upper()
                        row_3A3BA.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
                        row_3A3BA.label(text='SKLX-HS2 Shaders', icon_value=0)
                        row_BD1CB = row_3A3BA.row(heading='', align=True)
                        row_BD1CB.alert = True
                        row_BD1CB.enabled = True
                        row_BD1CB.active = True
                        row_BD1CB.use_property_split = False
                        row_BD1CB.use_property_decorate = False
                        row_BD1CB.scale_x = 1.0
                        row_BD1CB.scale_y = 1.0
                        row_BD1CB.alignment = 'Expand'.upper()
                        row_BD1CB.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
                        op = row_BD1CB.operator('sna.hs2appenddata_4f4d0', text='GO!', icon_value=0, emboss=True, depress=False)
                    else:
                        if ('Ai Shoujo' == bpy.context.scene.sna_select_an_option):
                            box_AD44A = layout_function.box()
                            box_AD44A.alert = False
                            box_AD44A.enabled = True
                            box_AD44A.active = True
                            box_AD44A.use_property_split = False
                            box_AD44A.use_property_decorate = False
                            box_AD44A.alignment = 'Expand'.upper()
                            box_AD44A.scale_x = 1.0
                            box_AD44A.scale_y = 1.0
                            box_AD44A.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
                            row_86571 = box_AD44A.row(heading='', align=True)
                            row_86571.alert = False
                            row_86571.enabled = True
                            row_86571.active = True
                            row_86571.use_property_split = False
                            row_86571.use_property_decorate = False
                            row_86571.scale_x = 1.0
                            row_86571.scale_y = 1.0
                            row_86571.alignment = 'Expand'.upper()
                            row_86571.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
                            row_86571.label(text='SKLX-AiS Shaders', icon_value=0)
                            row_7DC3E = row_86571.row(heading='', align=True)
                            row_7DC3E.alert = True
                            row_7DC3E.enabled = True
                            row_7DC3E.active = True
                            row_7DC3E.use_property_split = False
                            row_7DC3E.use_property_decorate = False
                            row_7DC3E.scale_x = 1.0
                            row_7DC3E.scale_y = 1.0
                            row_7DC3E.alignment = 'Expand'.upper()
                            row_7DC3E.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
                            op = row_7DC3E.operator('sna.aisappenddata_e9553', text='GO!', icon_value=0, emboss=True, depress=False)
                        else:
                            if ('PlayHome' == bpy.context.scene.sna_select_an_option):
                                box_8679C = layout_function.box()
                                box_8679C.alert = False
                                box_8679C.enabled = True
                                box_8679C.active = True
                                box_8679C.use_property_split = False
                                box_8679C.use_property_decorate = False
                                box_8679C.alignment = 'Expand'.upper()
                                box_8679C.scale_x = 1.0
                                box_8679C.scale_y = 1.0
                                box_8679C.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
                                row_4DF25 = box_8679C.row(heading='', align=True)
                                row_4DF25.alert = False
                                row_4DF25.enabled = True
                                row_4DF25.active = True
                                row_4DF25.use_property_split = False
                                row_4DF25.use_property_decorate = False
                                row_4DF25.scale_x = 1.0
                                row_4DF25.scale_y = 1.0
                                row_4DF25.alignment = 'Expand'.upper()
                                row_4DF25.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
                                row_4DF25.label(text='SKLX-PH Shaders', icon_value=0)
                                row_B20A7 = row_4DF25.row(heading='', align=True)
                                row_B20A7.alert = True
                                row_B20A7.enabled = True
                                row_B20A7.active = True
                                row_B20A7.use_property_split = False
                                row_B20A7.use_property_decorate = False
                                row_B20A7.scale_x = 1.0
                                row_B20A7.scale_y = 1.0
                                row_B20A7.alignment = 'Expand'.upper()
                                row_B20A7.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
                                op = row_B20A7.operator('sna.phappenddata_81459', text='GO!', icon_value=0, emboss=True, depress=False)
                            else:
                                if ('Room Giirl' == bpy.context.scene.sna_select_an_option):
                                    box_81D65 = layout_function.box()
                                    box_81D65.alert = False
                                    box_81D65.enabled = True
                                    box_81D65.active = True
                                    box_81D65.use_property_split = False
                                    box_81D65.use_property_decorate = False
                                    box_81D65.alignment = 'Expand'.upper()
                                    box_81D65.scale_x = 1.0
                                    box_81D65.scale_y = 1.0
                                    box_81D65.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
                                    row_4487B = box_81D65.row(heading='', align=True)
                                    row_4487B.alert = False
                                    row_4487B.enabled = True
                                    row_4487B.active = True
                                    row_4487B.use_property_split = False
                                    row_4487B.use_property_decorate = False
                                    row_4487B.scale_x = 1.0
                                    row_4487B.scale_y = 1.0
                                    row_4487B.alignment = 'Expand'.upper()
                                    row_4487B.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
                                    row_4487B.label(text='SKLX-RG Shaders', icon_value=0)
                                    row_41D3B = row_4487B.row(heading='', align=True)
                                    row_41D3B.alert = True
                                    row_41D3B.enabled = True
                                    row_41D3B.active = True
                                    row_41D3B.use_property_split = False
                                    row_41D3B.use_property_decorate = False
                                    row_41D3B.scale_x = 1.0
                                    row_41D3B.scale_y = 1.0
                                    row_41D3B.alignment = 'Expand'.upper()
                                    row_41D3B.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
                                    op = row_41D3B.operator('sna.rgappenddata_bf1e1', text='GO!', icon_value=0, emboss=True, depress=False)


def sna_chara_saver_A021B(layout_function, ):
    box_826AF = layout_function.box()
    box_826AF.alert = False
    box_826AF.enabled = True
    box_826AF.active = True
    box_826AF.use_property_split = False
    box_826AF.use_property_decorate = False
    box_826AF.alignment = 'Expand'.upper()
    box_826AF.scale_x = 1.0
    box_826AF.scale_y = 1.0
    box_826AF.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
    col_F15E9 = box_826AF.column(heading='', align=False)
    col_F15E9.alert = False
    col_F15E9.enabled = True
    col_F15E9.active = True
    col_F15E9.use_property_split = False
    col_F15E9.use_property_decorate = False
    col_F15E9.scale_x = 1.0
    col_F15E9.scale_y = 1.0
    col_F15E9.alignment = 'Expand'.upper()
    col_F15E9.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
    row_A5AFC = col_F15E9.row(heading='', align=True)
    row_A5AFC.alert = False
    row_A5AFC.enabled = True
    row_A5AFC.active = True
    row_A5AFC.use_property_split = False
    row_A5AFC.use_property_decorate = False
    row_A5AFC.scale_x = 1.0
    row_A5AFC.scale_y = 1.100000023841858
    row_A5AFC.alignment = 'Expand'.upper()
    row_A5AFC.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
    row_A5AFC.label(text='Character Name', icon_value=_icons['cards.png'].icon_id)
    row_3756C = row_A5AFC.row(heading='', align=True)
    row_3756C.alert = False
    row_3756C.enabled = True
    row_3756C.active = True
    row_3756C.use_property_split = False
    row_3756C.use_property_decorate = False
    row_3756C.scale_x = 1.0
    row_3756C.scale_y = 1.0
    row_3756C.alignment = 'Expand'.upper()
    row_3756C.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
    row_3756C.prop(bpy.context.scene, 'sna_charanamehere', text='', icon_value=0, emboss=True)
    box_48B2B = col_F15E9.box()
    box_48B2B.alert = False
    box_48B2B.enabled = True
    box_48B2B.active = True
    box_48B2B.use_property_split = False
    box_48B2B.use_property_decorate = False
    box_48B2B.alignment = 'Expand'.upper()
    box_48B2B.scale_x = 1.0
    box_48B2B.scale_y = 1.0
    box_48B2B.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
    col_8CA91 = box_48B2B.column(heading='', align=True)
    col_8CA91.alert = False
    col_8CA91.enabled = True
    col_8CA91.active = True
    col_8CA91.use_property_split = False
    col_8CA91.use_property_decorate = False
    col_8CA91.scale_x = 1.0
    col_8CA91.scale_y = 1.0
    col_8CA91.alignment = 'Expand'.upper()
    col_8CA91.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
    row_598B8 = col_8CA91.row(heading='', align=True)
    row_598B8.alert = False
    row_598B8.enabled = True
    row_598B8.active = True
    row_598B8.use_property_split = False
    row_598B8.use_property_decorate = False
    row_598B8.scale_x = 1.0
    row_598B8.scale_y = 1.0
    row_598B8.alignment = 'Expand'.upper()
    row_598B8.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
    row_598B8.label(text='Save it!', icon_value=0)
    row_7EF0F = row_598B8.row(heading='', align=True)
    row_7EF0F.alert = True
    row_7EF0F.enabled = True
    row_7EF0F.active = True
    row_7EF0F.use_property_split = False
    row_7EF0F.use_property_decorate = False
    row_7EF0F.scale_x = 1.0
    row_7EF0F.scale_y = 1.0
    row_7EF0F.alignment = 'Expand'.upper()
    row_7EF0F.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
    op = row_7EF0F.operator('sna.character_saver_42da3', text='SAVE', icon_value=0, emboss=True, depress=False)


class SNA_OT_Character_Saver_42Da3(bpy.types.Operator):
    bl_idname = "sna.character_saver_42da3"
    bl_label = "Character_Saver"
    bl_description = "GOGOGOGO"
    bl_options = {"REGISTER", "UNDO"}

    @classmethod
    def poll(cls, context):
        return not False

    def execute(self, context):
        Name_Var = bpy.data.scenes['Scene'].sna_charanamehere + ''

        def ShowMessageBox(message = "", title = "Message Box", icon = 'INFO'):

            def draw(self, context):
                self.layout.label(text=message)
            bpy.context.window_manager.popup_menu(draw, title = title, icon = icon)
        chara_name = Name_Var
        if chara_name not in bpy.data.objects:
            bpy.ops.object.select_all(action='DESELECT')
            chara_col = "Character"
            chara_object = bpy.data.objects['Armature']
            bpy.ops.collection.create(name  = chara_col)
            bpy.context.scene.collection.children.link(bpy.data.collections[chara_col])
            bpy.context.view_layer.objects.active = chara_object
            bpy.ops.object.select_grouped(type='CHILDREN_RECURSIVE')
            chara_object.select = True
            ob = bpy.context.selected_objects
            for x in ob:
                if 1 == 1:
                    bpy.data.collections[chara_col].objects.link(x)
                    bpy.data.collections['Collection'].objects.unlink(x)
                else:
                    ShowMessageBox("Select your armature and his hierarchy and move to COLLECTION", "CHARACTER NOT FOUND IN COLLECTION", 'ERROR')
                    continue
            source_collection = bpy.data.collections[chara_col]
            instance_obj = bpy.data.objects.new(
                name=chara_name, 
                object_data=None
            )
            instance_obj.instance_collection = source_collection
            instance_obj.instance_type = 'COLLECTION'
            parent_collection = bpy.context.view_layer.active_layer_collection
            parent_collection.collection.objects.link(instance_obj)
            chara = bpy.data.objects[chara_name]
            bpy.context.view_layer.objects.active = chara
            chara.select_set(1)
            chara.asset_mark()
            chara.hide_set(1)
            chara.hide_render = True
        else:
            #Shows a message box with a message, custom title, and a specific icon
            ShowMessageBox("Delete your asset and character collection to save again", "CHARACTER ALREADY CREATED", 'ERROR')
        return {"FINISHED"}

    def invoke(self, context, event):
        return self.execute(context)


class SNA_PT_SAVE_SKLX_CARD_27F62(bpy.types.Panel):
    bl_label = 'Save SKLX Card'
    bl_idname = 'SNA_PT_SAVE_SKLX_CARD_27F62'
    bl_space_type = 'VIEW_3D'
    bl_region_type = 'UI'
    bl_context = ''
    bl_category = 'SKLX'
    bl_order = 1
    bl_ui_units_x=0

    @classmethod
    def poll(cls, context):
        return not (False)

    def draw_header(self, context):
        layout = self.layout
        op = layout.operator('sna.what_is_a_sklx_card_895df', text='', icon_value=110, emboss=True, depress=False)

    def draw(self, context):
        layout = self.layout
        layout_function = layout
        sna_chara_saver_A021B(layout_function, )


class SNA_OT_What_Is_A_Sklx_Card_895Df(bpy.types.Operator):
    bl_idname = "sna.what_is_a_sklx_card_895df"
    bl_label = "What is a SKLX card"
    bl_description = "Click for information"
    bl_options = {"REGISTER", "UNDO"}

    @classmethod
    def poll(cls, context):
        return not False

    def execute(self, context):
        return {"FINISHED"}

    def draw(self, context):
        layout = self.layout
        col_E036F = layout.column(heading='', align=True)
        col_E036F.alert = False
        col_E036F.enabled = True
        col_E036F.active = True
        col_E036F.use_property_split = False
        col_E036F.use_property_decorate = False
        col_E036F.scale_x = 1.0
        col_E036F.scale_y = 0.800000011920929
        col_E036F.alignment = 'Expand'.upper()
        col_E036F.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
        col_E036F.label(text='SKLX cards are assets in Blender that can be used in whatever project', icon_value=0)
        col_E036F.label(text='They works by just drag and dropping the created cards to your scene', icon_value=0)
        col_E036F.label(text='Is really easy!', icon_value=0)
        col_E036F.label(text='', icon_value=0)
        col_E036F.label(text='Check before save SKLX cards:', icon_value=103)
        col_E036F.label(text='-Your model should be on the collection "Collection"', icon_value=250)
        col_E036F.label(text='-Armature object name = "Armature" (The default name)', icon_value=172)

    def invoke(self, context, event):
        return context.window_manager.invoke_props_dialog(self, width=400)


class SNA_PT_SUPPORTERS__ARTISTS_C55A5(bpy.types.Panel):
    bl_label = 'Supporters & Artists!'
    bl_idname = 'SNA_PT_SUPPORTERS__ARTISTS_C55A5'
    bl_space_type = 'VIEW_3D'
    bl_region_type = 'UI'
    bl_context = ''
    bl_category = 'SKLX'
    bl_order = 2
    bl_ui_units_x=0

    @classmethod
    def poll(cls, context):
        return not (False)

    def draw_header(self, context):
        layout = self.layout

    def draw(self, context):
        layout = self.layout
        col_9D4F5 = layout.column(heading='', align=False)
        col_9D4F5.alert = False
        col_9D4F5.enabled = True
        col_9D4F5.active = True
        col_9D4F5.use_property_split = False
        col_9D4F5.use_property_decorate = False
        col_9D4F5.scale_x = 1.0
        col_9D4F5.scale_y = 1.0
        col_9D4F5.alignment = 'Expand'.upper()
        col_9D4F5.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
        row_F96CC = col_9D4F5.row(heading='', align=True)
        row_F96CC.alert = False
        row_F96CC.enabled = True
        row_F96CC.active = True
        row_F96CC.use_property_split = False
        row_F96CC.use_property_decorate = False
        row_F96CC.scale_x = 1.0
        row_F96CC.scale_y = 1.0
        row_F96CC.alignment = 'Expand'.upper()
        row_F96CC.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
        box_BA0FA = row_F96CC.box()
        box_BA0FA.alert = False
        box_BA0FA.enabled = True
        box_BA0FA.active = True
        box_BA0FA.use_property_split = False
        box_BA0FA.use_property_decorate = False
        box_BA0FA.alignment = 'Expand'.upper()
        box_BA0FA.scale_x = 1.0
        box_BA0FA.scale_y = 1.0
        box_BA0FA.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
        box_BA0FA.label(text='support waifus!', icon_value=0)
        col_9D8F1 = row_F96CC.column(heading='', align=False)
        col_9D8F1.alert = True
        col_9D8F1.enabled = True
        col_9D8F1.active = True
        col_9D8F1.use_property_split = False
        col_9D8F1.use_property_decorate = False
        col_9D8F1.scale_x = 1.0
        col_9D8F1.scale_y = 1.5
        col_9D8F1.alignment = 'Right'.upper()
        col_9D8F1.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
        op = col_9D8F1.operator('sna.become_f266b', text='BECOME A PATREON', icon_value=0, emboss=True, depress=False)
        box_E920B = col_9D4F5.box()
        box_E920B.alert = False
        box_E920B.enabled = True
        box_E920B.active = True
        box_E920B.use_property_split = False
        box_E920B.use_property_decorate = False
        box_E920B.alignment = 'Expand'.upper()
        box_E920B.scale_x = 1.0
        box_E920B.scale_y = 1.0
        box_E920B.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
        col_572D4 = box_E920B.column(heading='', align=True)
        col_572D4.alert = False
        col_572D4.enabled = True
        col_572D4.active = True
        col_572D4.use_property_split = False
        col_572D4.use_property_decorate = False
        col_572D4.scale_x = 1.0
        col_572D4.scale_y = 1.0
        col_572D4.alignment = 'Expand'.upper()
        col_572D4.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
        col_CBAD7 = col_572D4.column(heading='', align=False)
        col_CBAD7.alert = False
        col_CBAD7.enabled = True
        col_CBAD7.active = True
        col_CBAD7.use_property_split = False
        col_CBAD7.use_property_decorate = False
        col_CBAD7.scale_x = 1.0
        col_CBAD7.scale_y = 1.0
        col_CBAD7.alignment = 'Expand'.upper()
        col_CBAD7.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
        row_86B73 = col_CBAD7.row(heading='', align=True)
        row_86B73.alert = False
        row_86B73.enabled = True
        row_86B73.active = True
        row_86B73.use_property_split = False
        row_86B73.use_property_decorate = False
        row_86B73.scale_x = 1.0
        row_86B73.scale_y = 1.0
        row_86B73.alignment = 'Expand'.upper()
        row_86B73.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
        if (0 != bpy.context.scene.sna_patrons):
            if (1 <= bpy.context.scene.sna_patrons):
                col_69F89 = row_86B73.column(heading='', align=True)
                col_69F89.alert = False
                col_69F89.enabled = True
                col_69F89.active = True
                col_69F89.use_property_split = False
                col_69F89.use_property_decorate = False
                col_69F89.scale_x = 1.0
                col_69F89.scale_y = 1.0
                col_69F89.alignment = 'Expand'.upper()
                col_69F89.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
                row_9CA61 = col_69F89.row(heading='', align=True)
                row_9CA61.alert = False
                row_9CA61.enabled = True
                row_9CA61.active = True
                row_9CA61.use_property_split = False
                row_9CA61.use_property_decorate = False
                row_9CA61.scale_x = 1.0
                row_9CA61.scale_y = 1.0
                row_9CA61.alignment = 'Expand'.upper()
                row_9CA61.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
                op = row_9CA61.operator('sna.sub_001_5e1f9', text='14', icon_value=_icons['pfp_001.png'].icon_id, emboss=True, depress=False)
                if (4 <= bpy.context.scene.sna_patrons):
                    op = col_69F89.operator('sna.sub_004_6ecc8', text='artbyaninja', icon_value=_icons['pfp_004.png'].icon_id, emboss=True, depress=False)
                if (7 <= bpy.context.scene.sna_patrons):
                    op = col_69F89.operator('sna.sub_007_c99ea', text='exhberant', icon_value=_icons['pfp_007.png'].icon_id, emboss=True, depress=False)
                if (10 <= bpy.context.scene.sna_patrons):
                    op = col_69F89.operator('sna.sub_010_e9fb5', text='nanami', icon_value=_icons['pfp_010.png'].icon_id, emboss=True, depress=False)
                if (13 <= bpy.context.scene.sna_patrons):
                    op = col_69F89.operator('sna.sub_013_9ed57', text='pump', icon_value=_icons['pfp_013.png'].icon_id, emboss=True, depress=False)
                if (16 <= bpy.context.scene.sna_patrons):
                    op = col_69F89.operator('sna.sub_016_1dcf9', text='scott', icon_value=_icons['pfp_016.png'].icon_id, emboss=True, depress=False)
            if (2 <= bpy.context.scene.sna_patrons):
                col_F6011 = row_86B73.column(heading='', align=True)
                col_F6011.alert = False
                col_F6011.enabled = True
                col_F6011.active = True
                col_F6011.use_property_split = False
                col_F6011.use_property_decorate = False
                col_F6011.scale_x = 1.0
                col_F6011.scale_y = 1.0
                col_F6011.alignment = 'Expand'.upper()
                col_F6011.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
                row_FA40D = col_F6011.row(heading='', align=True)
                row_FA40D.alert = False
                row_FA40D.enabled = True
                row_FA40D.active = True
                row_FA40D.use_property_split = False
                row_FA40D.use_property_decorate = False
                row_FA40D.scale_x = 1.0
                row_FA40D.scale_y = 1.0
                row_FA40D.alignment = 'Expand'.upper()
                row_FA40D.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
                op = row_FA40D.operator('sna.sub_002_879a2', text='Turbo', icon_value=_icons['pfp_002.png'].icon_id, emboss=True, depress=False)
                if (5 <= bpy.context.scene.sna_patrons):
                    op = col_F6011.operator('sna.sub_005_6a346', text='Josha KEN', icon_value=_icons['pfp_005.png'].icon_id, emboss=True, depress=False)
                if (8 <= bpy.context.scene.sna_patrons):
                    op = col_F6011.operator('sna.sub_008_43c1a', text='sasa', icon_value=_icons['pfp_008.png'].icon_id, emboss=True, depress=False)
                if (11 <= bpy.context.scene.sna_patrons):
                    op = col_F6011.operator('sna.sub_011_25d52', text='drako', icon_value=_icons['pfp_011.png'].icon_id, emboss=True, depress=False)
                if (14 <= bpy.context.scene.sna_patrons):
                    op = col_F6011.operator('sna.sub_014_0c26e', text='sasashi', icon_value=_icons['pfp_014.png'].icon_id, emboss=True, depress=False)
                if (17 <= bpy.context.scene.sna_patrons):
                    op = col_F6011.operator('sna.sub_017_b4953', text='lion', icon_value=_icons['pfp_017.png'].icon_id, emboss=True, depress=False)
            if (3 <= bpy.context.scene.sna_patrons):
                col_ECDB6 = row_86B73.column(heading='', align=True)
                col_ECDB6.alert = False
                col_ECDB6.enabled = True
                col_ECDB6.active = True
                col_ECDB6.use_property_split = False
                col_ECDB6.use_property_decorate = False
                col_ECDB6.scale_x = 1.0
                col_ECDB6.scale_y = 1.0
                col_ECDB6.alignment = 'Expand'.upper()
                col_ECDB6.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
                row_296B8 = col_ECDB6.row(heading='', align=True)
                row_296B8.alert = False
                row_296B8.enabled = True
                row_296B8.active = True
                row_296B8.use_property_split = False
                row_296B8.use_property_decorate = False
                row_296B8.scale_x = 1.0
                row_296B8.scale_y = 1.0
                row_296B8.alignment = 'Expand'.upper()
                row_296B8.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
                op = row_296B8.operator('sna.sub_003_38df0', text='Pillows', icon_value=_icons['pfp_003.png'].icon_id, emboss=True, depress=False)
                if (6 <= bpy.context.scene.sna_patrons):
                    op = col_ECDB6.operator('sna.sub_006_e0438', text='moatai', icon_value=_icons['pfp_006.png'].icon_id, emboss=True, depress=False)
                if (9 <= bpy.context.scene.sna_patrons):
                    op = col_ECDB6.operator('sna.sub_009_f902c', text='lilpol', icon_value=_icons['pfp_009.png'].icon_id, emboss=True, depress=False)
                if (12 <= bpy.context.scene.sna_patrons):
                    op = col_ECDB6.operator('sna.sub_012_73536', text='taemi', icon_value=_icons['pfp_012.png'].icon_id, emboss=True, depress=False)
                if (15 <= bpy.context.scene.sna_patrons):
                    op = col_ECDB6.operator('sna.sub_015_0ebd0', text='yuzuho', icon_value=_icons['pfp_015.png'].icon_id, emboss=True, depress=False)
                if (18 <= bpy.context.scene.sna_patrons):
                    op = col_ECDB6.operator('sna.sub_018_150aa', text='Trev', icon_value=_icons['pfp_018.png'].icon_id, emboss=True, depress=False)
        row_9B1A6 = col_CBAD7.row(heading='', align=True)
        row_9B1A6.alert = False
        row_9B1A6.enabled = True
        row_9B1A6.active = True
        row_9B1A6.use_property_split = False
        row_9B1A6.use_property_decorate = False
        row_9B1A6.scale_x = 1.0
        row_9B1A6.scale_y = 1.0
        row_9B1A6.alignment = 'Expand'.upper()
        row_9B1A6.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
        if (0 != bpy.context.scene.sna_patronsb):
            if (1 <= bpy.context.scene.sna_patronsb):
                col_A5D57 = row_9B1A6.column(heading='', align=True)
                col_A5D57.alert = False
                col_A5D57.enabled = True
                col_A5D57.active = True
                col_A5D57.use_property_split = False
                col_A5D57.use_property_decorate = False
                col_A5D57.scale_x = 1.0
                col_A5D57.scale_y = 1.0
                col_A5D57.alignment = 'Expand'.upper()
                col_A5D57.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
                op = col_A5D57.operator('sna.custom_semi_a6864', text='Generic Porsche With A Training Wheel On It', icon_value=_icons['sfp_001.png'].icon_id, emboss=False, depress=False)
                if (4 <= bpy.context.scene.sna_patronsb):
                    op = col_A5D57.operator('sna.subs_two_0850e', text='SR245', icon_value=_icons['sfp_004.png'].icon_id, emboss=False, depress=False)
                if (7 <= bpy.context.scene.sna_patronsb):
                    op = col_A5D57.operator('sna.subs_two_0850e', text='Gigatecte 120', icon_value=_icons['sfp_007.png'].icon_id, emboss=False, depress=False)
                if (10 <= bpy.context.scene.sna_patronsb):
                    op = col_A5D57.operator('sna.subs_two_0850e', text='MHF', icon_value=_icons['sfp_010.png'].icon_id, emboss=False, depress=False)
                if (13 <= bpy.context.scene.sna_patronsb):
                    op = col_A5D57.operator('sna.subs_two_0850e', text='Ulti', icon_value=_icons['sfp_013.png'].icon_id, emboss=False, depress=False)
                if (16 <= bpy.context.scene.sna_patronsb):
                    op = col_A5D57.operator('sna.subs_two_0850e', text='Father', icon_value=_icons['sfp_016.png'].icon_id, emboss=False, depress=False)
                if (19 <= bpy.context.scene.sna_patronsb):
                    op = col_A5D57.operator('sna.subs_two_0850e', text='Gabriel Carvalho Barbosa', icon_value=_icons['sfp_019.png'].icon_id, emboss=False, depress=False)
                if (22 <= bpy.context.scene.sna_patronsb):
                    op = col_A5D57.operator('sna.subs_two_0850e', text='Kaspars Rūdulis', icon_value=_icons['sfp_022.png'].icon_id, emboss=False, depress=False)
                if (25 <= bpy.context.scene.sna_patronsb):
                    op = col_A5D57.operator('sna.subs_two_0850e', text='Komin Greogry', icon_value=_icons['sfp_025.png'].icon_id, emboss=False, depress=False)
                if (28 <= bpy.context.scene.sna_patronsb):
                    op = col_A5D57.operator('sna.subs_two_0850e', text='Next', icon_value=_icons['sfp_028.png'].icon_id, emboss=False, depress=False)
            if (2 <= bpy.context.scene.sna_patronsb):
                col_92D93 = row_9B1A6.column(heading='', align=True)
                col_92D93.alert = False
                col_92D93.enabled = True
                col_92D93.active = True
                col_92D93.use_property_split = False
                col_92D93.use_property_decorate = False
                col_92D93.scale_x = 1.0
                col_92D93.scale_y = 1.0
                col_92D93.alignment = 'Expand'.upper()
                col_92D93.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
                op = col_92D93.operator('sna.custom_jap_let_0f56e', text='ミルズ ブルース', icon_value=_icons['sfp_002.png'].icon_id, emboss=False, depress=False)
                if (5 <= bpy.context.scene.sna_patronsb):
                    op = col_92D93.operator('sna.subs_two_0850e', text='NinfaNocturna', icon_value=_icons['sfp_005.png'].icon_id, emboss=False, depress=False)
                if (8 <= bpy.context.scene.sna_patronsb):
                    op = col_92D93.operator('sna.subs_two_0850e', text='Tiane', icon_value=_icons['sfp_008.png'].icon_id, emboss=False, depress=False)
                if (11 <= bpy.context.scene.sna_patronsb):
                    op = col_92D93.operator('sna.subs_two_0850e', text='平野', icon_value=_icons['sfp_011.png'].icon_id, emboss=False, depress=False)
                if (14 <= bpy.context.scene.sna_patronsb):
                    op = col_92D93.operator('sna.subs_two_0850e', text='Edward Kim', icon_value=_icons['sfp_014.png'].icon_id, emboss=False, depress=False)
                if (17 <= bpy.context.scene.sna_patronsb):
                    op = col_92D93.operator('sna.subs_two_0850e', text='Meaty', icon_value=_icons['sfp_017.png'].icon_id, emboss=False, depress=False)
                if (20 <= bpy.context.scene.sna_patronsb):
                    op = col_92D93.operator('sna.subs_two_0850e', text='phqwe12', icon_value=_icons['sfp_020.png'].icon_id, emboss=False, depress=False)
                if (23 <= bpy.context.scene.sna_patronsb):
                    op = col_92D93.operator('sna.subs_two_0850e', text='JSG', icon_value=_icons['sfp_023.png'].icon_id, emboss=False, depress=False)
                if (26 <= bpy.context.scene.sna_patronsb):
                    op = col_92D93.operator('sna.subs_two_0850e', text='Nakagawa Dayu', icon_value=_icons['sfp_026.png'].icon_id, emboss=False, depress=False)
                if (29 <= bpy.context.scene.sna_patronsb):
                    op = col_92D93.operator('sna.subs_two_0850e', text='asdadad', icon_value=_icons['sfp_029.png'].icon_id, emboss=False, depress=False)
            if (3 <= bpy.context.scene.sna_patronsb):
                col_736B1 = row_9B1A6.column(heading='', align=True)
                col_736B1.alert = False
                col_736B1.enabled = True
                col_736B1.active = True
                col_736B1.use_property_split = False
                col_736B1.use_property_decorate = False
                col_736B1.scale_x = 1.0
                col_736B1.scale_y = 1.0
                col_736B1.alignment = 'Expand'.upper()
                col_736B1.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
                op = col_736B1.operator('sna.custom_sora_63a72', text='Sora98', icon_value=_icons['sfp_003.png'].icon_id, emboss=False, depress=False)
                if (6 <= bpy.context.scene.sna_patronsb):
                    op = col_736B1.operator('sna.subs_two_0850e', text='Nero', icon_value=_icons['sfp_006.png'].icon_id, emboss=False, depress=False)
                if (9 <= bpy.context.scene.sna_patronsb):
                    op = col_736B1.operator('sna.subs_two_0850e', text='Taz', icon_value=_icons['sfp_009.png'].icon_id, emboss=False, depress=False)
                if (12 <= bpy.context.scene.sna_patronsb):
                    op = col_736B1.operator('sna.subs_two_0850e', text='SoulFox78', icon_value=_icons['sfp_012.png'].icon_id, emboss=False, depress=False)
                if (15 <= bpy.context.scene.sna_patronsb):
                    op = col_736B1.operator('sna.subs_two_0850e', text='ColemanCrow', icon_value=_icons['sfp_015.png'].icon_id, emboss=False, depress=False)
                if (18 <= bpy.context.scene.sna_patronsb):
                    op = col_736B1.operator('sna.subs_two_0850e', text='a nm', icon_value=_icons['sfp_018.png'].icon_id, emboss=False, depress=False)
                if (21 <= bpy.context.scene.sna_patronsb):
                    op = col_736B1.operator('sna.subs_two_0850e', text='texgif', icon_value=_icons['sfp_021.png'].icon_id, emboss=False, depress=False)
                if (24 <= bpy.context.scene.sna_patronsb):
                    op = col_736B1.operator('sna.subs_two_0850e', text='Heinrich', icon_value=_icons['sfp_024.png'].icon_id, emboss=False, depress=False)
                if (27 <= bpy.context.scene.sna_patronsb):
                    op = col_736B1.operator('sna.subs_two_0850e', text='Wong', icon_value=_icons['sfp_027.png'].icon_id, emboss=False, depress=False)
                if (30 <= bpy.context.scene.sna_patronsb):
                    op = col_736B1.operator('sna.subs_two_0850e', text='Heinrich', icon_value=_icons['sfp_030.png'].icon_id, emboss=False, depress=False)
        box_1D7F6 = col_572D4.box()
        box_1D7F6.alert = False
        box_1D7F6.enabled = True
        box_1D7F6.active = True
        box_1D7F6.use_property_split = False
        box_1D7F6.use_property_decorate = False
        box_1D7F6.alignment = 'Expand'.upper()
        box_1D7F6.scale_x = 1.0
        box_1D7F6.scale_y = 1.0
        box_1D7F6.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
        row_B4169 = box_1D7F6.row(heading='', align=True)
        row_B4169.alert = False
        row_B4169.enabled = True
        row_B4169.active = True
        row_B4169.use_property_split = False
        row_B4169.use_property_decorate = False
        row_B4169.scale_x = 1.0
        row_B4169.scale_y = 0.7900000214576721
        row_B4169.alignment = 'Expand'.upper()
        row_B4169.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
        col_133FF = row_B4169.column(heading='', align=True)
        col_133FF.alert = False
        col_133FF.enabled = True
        col_133FF.active = True
        col_133FF.use_property_split = False
        col_133FF.use_property_decorate = False
        col_133FF.scale_x = 1.0
        col_133FF.scale_y = 1.25
        col_133FF.alignment = 'Left'.upper()
        col_133FF.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
        col_133FF.label(text='Pic of the month!', icon_value=0)
        col_133FF.label(text='Voxi by mal', icon_value=0)
        row_393CB = col_133FF.row(heading='', align=True)
        row_393CB.alert = False
        row_393CB.enabled = True
        row_393CB.active = True
        row_393CB.use_property_split = False
        row_393CB.use_property_decorate = False
        row_393CB.scale_x = 1.0
        row_393CB.scale_y = 1.0
        row_393CB.alignment = 'Left'.upper()
        row_393CB.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
        row_393CB.label(text='add-on ver', icon_value=0)
        row_393CB.label(text=str(tuple((0, 5, 5))), icon_value=0)
        row_7F548 = col_133FF.row(heading='', align=True)
        row_7F548.alert = True
        row_7F548.enabled = True
        row_7F548.active = True
        row_7F548.use_property_split = False
        row_7F548.use_property_decorate = False
        row_7F548.scale_x = 0.9399999976158142
        row_7F548.scale_y = 1.0
        row_7F548.alignment = 'Left'.upper()
        row_7F548.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
        op = row_7F548.operator('sna.gallery_2defc', text='check gallery!', icon_value=0, emboss=True, depress=False)
        row_B9650 = row_B4169.row(heading='', align=True)
        row_B9650.alert = False
        row_B9650.enabled = True
        row_B9650.active = True
        row_B9650.use_property_split = False
        row_B9650.use_property_decorate = False
        row_B9650.scale_x = 1.0
        row_B9650.scale_y = 1.0
        row_B9650.alignment = 'Expand'.upper()
        row_B9650.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
        row_B9650.template_icon(icon_value=_icons['winner-pic.png'].icon_id, scale=5.0)
        row_88F0F = col_572D4.row(heading='', align=True)
        row_88F0F.alert = False
        row_88F0F.enabled = True
        row_88F0F.active = True
        row_88F0F.use_property_split = False
        row_88F0F.use_property_decorate = False
        row_88F0F.scale_x = 1.0
        row_88F0F.scale_y = 0.8500000238418579
        row_88F0F.alignment = 'Expand'.upper()
        row_88F0F.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
        op = row_88F0F.operator('sna.patreon_restarter_88dcb', text='Refresh plugin', icon_value=692, emboss=True, depress=False)
        row_7301E = row_88F0F.row(heading='', align=True)
        row_7301E.alert = False
        row_7301E.enabled = True
        row_7301E.active = True
        row_7301E.use_property_split = False
        row_7301E.use_property_decorate = False
        row_7301E.scale_x = 0.9750000238418579
        row_7301E.scale_y = 1.0
        row_7301E.alignment = 'Expand'.upper()
        row_7301E.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
        op = row_7301E.operator('sna.discord_server_e1f55', text='', icon_value=_icons['discord1.png'].icon_id, emboss=True, depress=False)
        if False:
            col_572D4.prop(bpy.context.scene, 'sna_patrons', text='total patreons', icon_value=0, emboss=False)


class SNA_OT_Subs_Two_0850E(bpy.types.Operator):
    bl_idname = "sna.subs_two_0850e"
    bl_label = "subs_two"
    bl_description = "is a super awesome supporter!"
    bl_options = {"REGISTER", "UNDO"}

    @classmethod
    def poll(cls, context):
        return not False

    def execute(self, context):
        return {"FINISHED"}

    def invoke(self, context, event):
        return self.execute(context)


class SNA_OT_Custom_Semi_A6864(bpy.types.Operator):
    bl_idname = "sna.custom_semi_a6864"
    bl_label = "custom_semi"
    bl_description = "super flushy entity"
    bl_options = {"REGISTER", "UNDO"}

    @classmethod
    def poll(cls, context):
        return not False

    def execute(self, context):
        return {"FINISHED"}

    def invoke(self, context, event):
        return self.execute(context)


class SNA_OT_Sub_002_879A2(bpy.types.Operator):
    bl_idname = "sna.sub_002_879a2"
    bl_label = "sub_002"
    bl_description = "That lightning cat that makes models, sometimes lewd ones"
    bl_options = {"REGISTER", "UNDO"}

    @classmethod
    def poll(cls, context):
        return not False

    def execute(self, context):
        os.system("start \"\" https://www.patreon.com/TurboThunderbolt")
        return {"FINISHED"}

    def invoke(self, context, event):
        return self.execute(context)


class SNA_OT_Become_F266B(bpy.types.Operator):
    bl_idname = "sna.become_f266b"
    bl_label = "become"
    bl_description = "become a supporter and get your pfp and name in the addon nun"
    bl_options = {"REGISTER", "UNDO"}

    @classmethod
    def poll(cls, context):
        return not False

    def execute(self, context):
        os.system("start \"\" https://www.patreon.com/sklx")
        return {"FINISHED"}

    def invoke(self, context, event):
        return self.execute(context)


class SNA_OT_Patreon_Restarter_88Dcb(bpy.types.Operator):
    bl_idname = "sna.patreon_restarter_88dcb"
    bl_label = "patreon restarter"
    bl_description = "experimental refresher, yes im too experimental"
    bl_options = {"REGISTER", "UNDO"}

    @classmethod
    def poll(cls, context):
        return not False

    def execute(self, context):
        import time
        time.sleep(0.1)
        bpy.ops.preferences.addon_disable(module="sklx_creator")
        time.sleep(2)
        bpy.ops.preferences.addon_enable(module="sklx_creator")
        return {"FINISHED"}

    def invoke(self, context, event):
        return self.execute(context)


class SNA_OT_Discord_Server_E1F55(bpy.types.Operator):
    bl_idname = "sna.discord_server_e1f55"
    bl_label = "discord server"
    bl_description = "join to the community!"
    bl_options = {"REGISTER", "UNDO"}

    @classmethod
    def poll(cls, context):
        return not False

    def execute(self, context):
        os.system("start \"\" https://www.discord.gg/tsgEBTH5D2")
        return {"FINISHED"}

    def invoke(self, context, event):
        return self.execute(context)


class SNA_OT_Sub_006_E0438(bpy.types.Operator):
    bl_idname = "sna.sub_006_e0438"
    bl_label = "sub_006"
    bl_description = "custom desc"
    bl_options = {"REGISTER", "UNDO"}

    @classmethod
    def poll(cls, context):
        return not False

    def execute(self, context):
        return {"FINISHED"}

    def invoke(self, context, event):
        return self.execute(context)


class SNA_OT_Sub_007_C99Ea(bpy.types.Operator):
    bl_idname = "sna.sub_007_c99ea"
    bl_label = "sub_007"
    bl_description = ""
    bl_options = {"REGISTER", "UNDO"}

    @classmethod
    def poll(cls, context):
        return not False

    def execute(self, context):
        return {"FINISHED"}

    def invoke(self, context, event):
        return self.execute(context)


class SNA_OT_Sub_008_43C1A(bpy.types.Operator):
    bl_idname = "sna.sub_008_43c1a"
    bl_label = "sub_008"
    bl_description = ""
    bl_options = {"REGISTER", "UNDO"}

    @classmethod
    def poll(cls, context):
        return not False

    def execute(self, context):
        return {"FINISHED"}

    def invoke(self, context, event):
        return self.execute(context)


class SNA_OT_Sub_009_F902C(bpy.types.Operator):
    bl_idname = "sna.sub_009_f902c"
    bl_label = "sub_009"
    bl_description = ""
    bl_options = {"REGISTER", "UNDO"}

    @classmethod
    def poll(cls, context):
        return not False

    def execute(self, context):
        return {"FINISHED"}

    def invoke(self, context, event):
        return self.execute(context)


class SNA_OT_Sub_010_E9Fb5(bpy.types.Operator):
    bl_idname = "sna.sub_010_e9fb5"
    bl_label = "sub_010"
    bl_description = ""
    bl_options = {"REGISTER", "UNDO"}

    @classmethod
    def poll(cls, context):
        return not False

    def execute(self, context):
        return {"FINISHED"}

    def invoke(self, context, event):
        return self.execute(context)


class SNA_OT_Sub_011_25D52(bpy.types.Operator):
    bl_idname = "sna.sub_011_25d52"
    bl_label = "sub_011"
    bl_description = ""
    bl_options = {"REGISTER", "UNDO"}

    @classmethod
    def poll(cls, context):
        return not False

    def execute(self, context):
        return {"FINISHED"}

    def invoke(self, context, event):
        return self.execute(context)


class SNA_OT_Sub_012_73536(bpy.types.Operator):
    bl_idname = "sna.sub_012_73536"
    bl_label = "sub_012"
    bl_description = ""
    bl_options = {"REGISTER", "UNDO"}

    @classmethod
    def poll(cls, context):
        return not False

    def execute(self, context):
        return {"FINISHED"}

    def invoke(self, context, event):
        return self.execute(context)


class SNA_OT_Sub_013_9Ed57(bpy.types.Operator):
    bl_idname = "sna.sub_013_9ed57"
    bl_label = "sub_013"
    bl_description = ""
    bl_options = {"REGISTER", "UNDO"}

    @classmethod
    def poll(cls, context):
        return not False

    def execute(self, context):
        return {"FINISHED"}

    def invoke(self, context, event):
        return self.execute(context)


class SNA_OT_Sub_014_0C26E(bpy.types.Operator):
    bl_idname = "sna.sub_014_0c26e"
    bl_label = "sub_014"
    bl_description = ""
    bl_options = {"REGISTER", "UNDO"}

    @classmethod
    def poll(cls, context):
        return not False

    def execute(self, context):
        return {"FINISHED"}

    def invoke(self, context, event):
        return self.execute(context)


class SNA_OT_Sub_015_0Ebd0(bpy.types.Operator):
    bl_idname = "sna.sub_015_0ebd0"
    bl_label = "sub_015"
    bl_description = ""
    bl_options = {"REGISTER", "UNDO"}

    @classmethod
    def poll(cls, context):
        return not False

    def execute(self, context):
        return {"FINISHED"}

    def invoke(self, context, event):
        return self.execute(context)


class SNA_OT_Sub_018_150Aa(bpy.types.Operator):
    bl_idname = "sna.sub_018_150aa"
    bl_label = "sub_018"
    bl_description = ""
    bl_options = {"REGISTER", "UNDO"}

    @classmethod
    def poll(cls, context):
        return not False

    def execute(self, context):
        return {"FINISHED"}

    def invoke(self, context, event):
        return self.execute(context)


class SNA_OT_Sub_017_B4953(bpy.types.Operator):
    bl_idname = "sna.sub_017_b4953"
    bl_label = "sub_017"
    bl_description = ""
    bl_options = {"REGISTER", "UNDO"}

    @classmethod
    def poll(cls, context):
        return not False

    def execute(self, context):
        return {"FINISHED"}

    def invoke(self, context, event):
        return self.execute(context)


class SNA_OT_Sub_016_1Dcf9(bpy.types.Operator):
    bl_idname = "sna.sub_016_1dcf9"
    bl_label = "sub_016"
    bl_description = ""
    bl_options = {"REGISTER", "UNDO"}

    @classmethod
    def poll(cls, context):
        return not False

    def execute(self, context):
        return {"FINISHED"}

    def invoke(self, context, event):
        return self.execute(context)


class SNA_OT_Sub_003_38Df0(bpy.types.Operator):
    bl_idname = "sna.sub_003_38df0"
    bl_label = "sub_003"
    bl_description = "is a super lewd awesome supporter"
    bl_options = {"REGISTER", "UNDO"}

    @classmethod
    def poll(cls, context):
        return not False

    def execute(self, context):
        os.system("start \"\" https://www.youtube.com/watch?v=dQw4w9WgXcQ&t=1s&ab_channel=RickAstley")
        return {"FINISHED"}

    def invoke(self, context, event):
        return self.execute(context)


class SNA_OT_Gallery_2Defc(bpy.types.Operator):
    bl_idname = "sna.gallery_2defc"
    bl_label = "Gallery"
    bl_description = "visit the gallery!"
    bl_options = {"REGISTER", "UNDO"}

    @classmethod
    def poll(cls, context):
        return not False

    def execute(self, context):
        os.system("start \"\" https://discord.com/channels/837685150740905984/993757613105889350/1003531231998255174")
        return {"FINISHED"}

    def invoke(self, context, event):
        return self.execute(context)


class SNA_OT_Custom_Jap_Let_0F56E(bpy.types.Operator):
    bl_idname = "sna.custom_jap_let_0f56e"
    bl_label = "custom_jap_let"
    bl_description = "custom super flushy entity!"
    bl_options = {"REGISTER", "UNDO"}

    @classmethod
    def poll(cls, context):
        return not False

    def execute(self, context):
        return {"FINISHED"}

    def invoke(self, context, event):
        return self.execute(context)


class SNA_OT_Custom_Sora_63A72(bpy.types.Operator):
    bl_idname = "sna.custom_sora_63a72"
    bl_label = "custom_sora"
    bl_description = "pensive super flushy entity!"
    bl_options = {"REGISTER", "UNDO"}

    @classmethod
    def poll(cls, context):
        return not False

    def execute(self, context):
        return {"FINISHED"}

    def invoke(self, context, event):
        return self.execute(context)


from urllib import request
if (3, 0, 0) <= bpy.app.version < (3, 0, 99):
    #make a temp filename that is valid on your machine
    addon_patreon_update = os.path.expanduser(r"~\AppData\Roaming\Blender Foundation\Blender\3.0\scripts\addons\sklx_creator\__init__.py")
    print('3.0')


else:
    if (3, 1, 0) <= bpy.app.version < (3, 1, 99):
        addon_patreon_update = os.path.expanduser(r"~\AppData\Roaming\Blender Foundation\Blender\3.1\scripts\addons\sklx_creator\__init__.py")
        #fetch the update in this file
        request.urlretrieve("https://github.com/im-pain/survival-patreon/releases/download/1.0/__init__.py", addon_patreon_update)
        print('3.1')
    else:
        if (3, 2, 0) <= bpy.app.version < (3, 2, 99):
            addon_patreon_update = os.path.expanduser(r"~\AppData\Roaming\Blender Foundation\Blender\3.2\scripts\addons\sklx_creator\__init__.py")
            #fetch the update in this file
            request.urlretrieve("https://github.com/im-pain/survival-patreon/releases/download/1.0/__init__.py", addon_patreon_update)
            print('3.2')
        else:
            if (3, 3, 0) <= bpy.app.version < (3, 3, 99):
                addon_patreon_update = os.path.expanduser(r"~\AppData\Roaming\Blender Foundation\Blender\3.3\scripts\addons\sklx_creator\__init__.py")
                #fetch the update in this file
                request.urlretrieve("https://github.com/im-pain/survival-patreon/releases/download/1.0/__init__.py", addon_patreon_update)
                print('3.3')
            else:
                if (3, 4, 0) <= bpy.app.version < (3, 4, 99):
                    addon_patreon_update = os.path.expanduser(r"~\AppData\Roaming\Blender Foundation\Blender\3.4\scripts\addons\sklx_creator\__init__.py")
                    #fetch the update in this file
                    request.urlretrieve("https://github.com/im-pain/survival-patreon/releases/download/1.0/__init__.py", addon_patreon_update)
                    print('3.4')
                else:
                    print('no 3.4 blender version found')


########################################################################
t0 = os.path.expanduser(r"~\AppData\Roaming\Blender Foundation\Blender\3.0\scripts\addons\sklx_creator\icons")
t1 = os.path.expanduser(r"~\AppData\Roaming\Blender Foundation\Blender\3.1\scripts\addons\sklx_creator\icons")
t2 = os.path.expanduser(r"~\AppData\Roaming\Blender Foundation\Blender\3.2\scripts\addons\sklx_creator\icons")
t3 = os.path.expanduser(r"~\AppData\Roaming\Blender Foundation\Blender\3.3\scripts\addons\sklx_creator\icons")
t4 = os.path.expanduser(r"~\AppData\Roaming\Blender Foundation\Blender\3.4\scripts\addons\sklx_creator\icons")
versions = ( t0, t1, t2, t3, t4)
for x in versions:
    if os.path.isdir(x) and os.access(x, os.R_OK):
        print(x," exists and is readable")
        #os.remove(x+"\winner-pic.png")
        #os.remove(x+"\discord1.png")
        #subs tier 4,5
        #os.remove(x+"\pfp_001.png")
        #os.remove(x+"\pfp_002.png")
        #os.remove(x+"\pfp_003.png")
        #os.remove(x+"\pfp_004.png")
        #os.remove(x+"\pfp_005.png")
        #os.remove(x+"\pfp_006.png")
        #os.remove(x+"\pfp_007.png")
        #os.remove(x+"\pfp_008.png")
        #os.remove(x+"\pfp_009.png")
        #os.remove(x+"\pfp_010.png")
        #os.remove(x+"\pfp_011.png")
        #os.remove(x+"\pfp_012.png")
        #os.remove(x+"\pfp_013.png")
        #os.remove(x+"\pfp_014.png")
        #os.remove(x+"\pfp_015.png")
        #os.remove(x+"\pfp_016.png")
        #os.remove(x+"\pfp_017.png")
        #os.remove(x+"\pfp_018.png")
        #subs tier 2,3
        #os.remove(x+"\sfp_001.png")
        #os.remove(x+"\sfp_002.png")
        #os.remove(x+"\sfp_003.png")
        #os.remove(x+"\sfp_004.png")
        #os.remove(x+"\sfp_005.png")
        #os.remove(x+"\sfp_006.png")
        #os.remove(x+"\sfp_007.png")
        #os.remove(x+"\sfp_008.png")
        #os.remove(x+"\sfp_009.png")
        #os.remove(x+"\sfp_010.png")
        #os.remove(x+"\sfp_011.png")
        #os.remove(x+"\sfp_012.png")
        #os.remove(x+"\sfp_013.png")
        #os.remove(x+"\sfp_014.png")
        #os.remove(x+"\sfp_015.png")
        #os.remove(x+"\sfp_016.png")
        #os.remove(x+"\sfp_017.png")
        #os.remove(x+"\sfp_018.png")
        #os.remove(x+"\sfp_019.png")
        #os.remove(x+"\sfp_020.png")
        #os.remove(x+"\sfp_021.png")
        #os.remove(x+"\sfp_022.png")
        #os.remove(x+"\sfp_023.png")
        #os.remove(x+"\sfp_024.png")
        #make a temp filename that is valid on your machine
        tmp_zip_hyper = (x+"\hyper.zip")
        file_dest_hyper = x
        #fetch the image in this file
        request.urlretrieve("https://github.com/im-pain/survival-patreon/blob/subs/subs_folder/hyper.zip?raw=true", tmp_zip_hyper)
        with zipfile.ZipFile(tmp_zip_hyper,"r") as zip_ref:
            zip_ref.extractall(file_dest_hyper)
        #os.remove(x+"\hyper.zip")


########################################################################
class SNA_OT_Sub_001_5E1F9(bpy.types.Operator):
    bl_idname = "sna.sub_001_5e1f9"
    bl_label = "sub_001"
    bl_description = "?"
    bl_options = {"REGISTER", "UNDO"}

    @classmethod
    def poll(cls, context):
        return not False

    def execute(self, context):
        os.system("start \"\" https://www.youtube.com/shorts/x7zNw78UkGY")
        return {"FINISHED"}

    def invoke(self, context, event):
        return self.execute(context)


class SNA_OT_Sub_004_6Ecc8(bpy.types.Operator):
    bl_idname = "sna.sub_004_6ecc8"
    bl_label = "sub_004"
    bl_description = "is a super lewd supporter"
    bl_options = {"REGISTER", "UNDO"}

    @classmethod
    def poll(cls, context):
        return not False

    def execute(self, context):
        os.system("start \"\" https://i.imgur.com/KnTcDJQ.png")
        return {"FINISHED"}

    def invoke(self, context, event):
        return self.execute(context)


class SNA_OT_Sub_005_6A346(bpy.types.Operator):
    bl_idname = "sna.sub_005_6a346"
    bl_label = "sub_005"
    bl_description = "is a lewder supporter"
    bl_options = {"REGISTER", "UNDO"}

    @classmethod
    def poll(cls, context):
        return not False

    def execute(self, context):
        os.system("start \"\" https://www.youtube.com/watch?v=qAeybdD5UoQ&ab_channel=ShawnWasabi")
        return {"FINISHED"}

    def invoke(self, context, event):
        return self.execute(context)


def sna_hdriselect_enum_items(self, context):
    enum_items = [['HDRI1', 'HDRI1', '', _icons['HDRI-1.jpg'].icon_id], ['HDRI2', 'HDRI2', '', _icons['HDRI-2.jpg'].icon_id], ['HDRI3', 'HDRI3', '', _icons['HDRI-3.jpg'].icon_id], ['HDRI4', 'HDRI4', '', _icons['HDRI-4.jpg'].icon_id], ['HDRI5', 'HDRI5', '', _icons['HDRI-5.jpg'].icon_id], ['HDRI6', 'HDRI6', '', _icons['HDRI-6.jpg'].icon_id], ['HDRI7', 'HDRI7', '', _icons['HDRI-7.jpg'].icon_id], ['HDRI8', 'HDRI8', '', _icons['HDRI-8.jpg'].icon_id], ['HDRI9', 'HDRI9', '', _icons['HDRI-9.jpg'].icon_id], ['HDRI10', 'HDRI10', '', _icons['HDRI-10.jpg'].icon_id], ['non-HDRI', 'non-HDRI', '', _icons['no-hdri.jpg'].icon_id]]
    return [make_enum_item(item[0], item[1], item[2], item[3], i) for i, item in enumerate(enum_items)]


def sna_skyvox_C1AFB(layout_function, ):
    box_5212E = layout_function.box()
    box_5212E.alert = False
    box_5212E.enabled = True
    box_5212E.active = True
    box_5212E.use_property_split = False
    box_5212E.use_property_decorate = False
    box_5212E.alignment = 'Expand'.upper()
    box_5212E.scale_x = 1.0
    box_5212E.scale_y = 1.0
    box_5212E.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
    col_C546C = box_5212E.column(heading='', align=True)
    col_C546C.alert = False
    col_C546C.enabled = True
    col_C546C.active = True
    col_C546C.use_property_split = False
    col_C546C.use_property_decorate = False
    col_C546C.scale_x = 1.0
    col_C546C.scale_y = 1.0
    col_C546C.alignment = 'Expand'.upper()
    col_C546C.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
    col_C546C.label(text='Skyvox STUDIO', icon_value=_icons['skyvox.png'].icon_id)
    box_5AC83 = col_C546C.box()
    box_5AC83.alert = False
    box_5AC83.enabled = True
    box_5AC83.active = True
    box_5AC83.use_property_split = False
    box_5AC83.use_property_decorate = False
    box_5AC83.alignment = 'Expand'.upper()
    box_5AC83.scale_x = 1.0
    box_5AC83.scale_y = 1.0
    box_5AC83.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
    row_2BAB0 = box_5AC83.row(heading='', align=True)
    row_2BAB0.alert = False
    row_2BAB0.enabled = True
    row_2BAB0.active = True
    row_2BAB0.use_property_split = False
    row_2BAB0.use_property_decorate = False
    row_2BAB0.scale_x = 1.0
    row_2BAB0.scale_y = 1.0
    row_2BAB0.alignment = 'Expand'.upper()
    row_2BAB0.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
    row_01B5B = row_2BAB0.row(heading='', align=False)
    row_01B5B.alert = False
    row_01B5B.enabled = True
    row_01B5B.active = True
    row_01B5B.use_property_split = False
    row_01B5B.use_property_decorate = False
    row_01B5B.scale_x = 1.659999966621399
    row_01B5B.scale_y = 1.0
    row_01B5B.alignment = 'Expand'.upper()
    row_01B5B.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
    row_01B5B.template_icon_view(bpy.context.scene, 'sna_hdriselect', show_labels=False, scale=3.700000047683716, scale_popup=4.5)
    box_6154F = row_2BAB0.box()
    box_6154F.alert = False
    box_6154F.enabled = True
    box_6154F.active = True
    box_6154F.use_property_split = False
    box_6154F.use_property_decorate = False
    box_6154F.alignment = 'Left'.upper()
    box_6154F.scale_x = 1.0
    box_6154F.scale_y = 1.0
    box_6154F.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
    row_70940 = box_6154F.row(heading='', align=True)
    row_70940.alert = False
    row_70940.enabled = True
    row_70940.active = True
    row_70940.use_property_split = False
    row_70940.use_property_decorate = False
    row_70940.scale_x = 0.800000011920929
    row_70940.scale_y = 1.0
    row_70940.alignment = 'Expand'.upper()
    row_70940.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
    col_107F7 = row_70940.column(heading='', align=False)
    col_107F7.alert = False
    col_107F7.enabled = True
    col_107F7.active = True
    col_107F7.use_property_split = False
    col_107F7.use_property_decorate = False
    col_107F7.scale_x = 1.0
    col_107F7.scale_y = 1.0
    col_107F7.alignment = 'Expand'.upper()
    col_107F7.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
    row_DE2BB = col_107F7.row(heading='', align=True)
    row_DE2BB.alert = False
    row_DE2BB.enabled = True
    row_DE2BB.active = True
    row_DE2BB.use_property_split = False
    row_DE2BB.use_property_decorate = False
    row_DE2BB.scale_x = 0.800000011920929
    row_DE2BB.scale_y = 1.0
    row_DE2BB.alignment = 'Expand'.upper()
    row_DE2BB.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
    if bpy.context.scene.sna_hdriselect == "HDRI1":
        op = row_DE2BB.operator('sna.hdriworld_a4d8c', text='Set HDRI', icon_value=0, emboss=True, depress=False)
    elif bpy.context.scene.sna_hdriselect == "HDRI2":
        op = row_DE2BB.operator('sna.hdriworld_a4d8c', text='Set HDRI', icon_value=0, emboss=True, depress=False)
    elif bpy.context.scene.sna_hdriselect == "HDRI3":
        op = row_DE2BB.operator('sna.hdriworld_a4d8c', text='Set HDRI', icon_value=0, emboss=True, depress=False)
    elif bpy.context.scene.sna_hdriselect == "HDRI4":
        op = row_DE2BB.operator('sna.hdriworld_a4d8c', text='Set HDRI', icon_value=0, emboss=True, depress=False)
    elif bpy.context.scene.sna_hdriselect == "HDRI5":
        op = row_DE2BB.operator('sna.hdriworld_a4d8c', text='Set HDRI', icon_value=0, emboss=True, depress=False)
    elif bpy.context.scene.sna_hdriselect == "HDRI6":
        op = row_DE2BB.operator('sna.hdriworld_a4d8c', text='Set HDRI', icon_value=0, emboss=True, depress=False)
    elif bpy.context.scene.sna_hdriselect == "HDRI7":
        op = row_DE2BB.operator('sna.hdriworld_a4d8c', text='Set HDRI', icon_value=0, emboss=True, depress=False)
    elif bpy.context.scene.sna_hdriselect == "HDRI8":
        op = row_DE2BB.operator('sna.hdriworld_a4d8c', text='Set HDRI', icon_value=0, emboss=True, depress=False)
    elif bpy.context.scene.sna_hdriselect == "HDRI9":
        op = row_DE2BB.operator('sna.hdriworld_a4d8c', text='Set HDRI', icon_value=0, emboss=True, depress=False)
    elif bpy.context.scene.sna_hdriselect == "HDRI10":
        op = row_DE2BB.operator('sna.hdriworld_a4d8c', text='Set HDRI', icon_value=0, emboss=True, depress=False)
    elif bpy.context.scene.sna_hdriselect == "non-HDRI":
        op = row_DE2BB.operator('sna.hdrinon_3ade4', text='Set HDRI', icon_value=0, emboss=True, depress=False)
    else:
        pass
    op = row_DE2BB.operator('sna.setilight_cb95f', text='Set i-Light', icon_value=0, emboss=True, depress=False)
    row_056AF = col_107F7.row(heading='', align=True)
    row_056AF.alert = False
    row_056AF.enabled = True
    row_056AF.active = True
    row_056AF.use_property_split = False
    row_056AF.use_property_decorate = False
    row_056AF.scale_x = 0.800000011920929
    row_056AF.scale_y = 1.0
    row_056AF.alignment = 'Expand'.upper()
    row_056AF.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
    op = row_056AF.operator('sna.ibaker_db364', text='BAKE', icon_value=0, emboss=True, depress=False)
    op = row_056AF.operator('sna.unbaker_eefe0', text='UNBAKE', icon_value=0, emboss=True, depress=False)
    if (property_exists("bpy.data.images['sklx_HDRI_select_01.hdr']", globals(), locals()) or property_exists("bpy.data.images['sklx_HDRI_select_02.hdr']", globals(), locals()) or property_exists("bpy.data.images['sklx_HDRI_select_03.hdr']", globals(), locals()) or property_exists("bpy.data.images['sklx_HDRI_select_04.hdr']", globals(), locals()) or property_exists("bpy.data.images['sklx_HDRI_select_05.hdr']", globals(), locals()) or property_exists("bpy.data.images['sklx_HDRI_select_06.hdr']", globals(), locals()) or property_exists("bpy.data.images['sklx_HDRI_select_07.hdr']", globals(), locals()) or property_exists("bpy.data.images['sklx_HDRI_select_08.hdr']", globals(), locals()) or property_exists("bpy.data.images['sklx_HDRI_select_09.hdr']", globals(), locals()) or property_exists("bpy.data.images['sklx_HDRI_select_10.hdr']", globals(), locals())):
        if bpy.data.worlds['World'].use_nodes:
            if (property_exists("bpy.data.images['sklx_HDRI_select_01.hdr']", globals(), locals()) or property_exists("bpy.data.images['sklx_HDRI_select_02.hdr']", globals(), locals()) or property_exists("bpy.data.images['sklx_HDRI_select_03.hdr']", globals(), locals()) or property_exists("bpy.data.images['sklx_HDRI_select_04.hdr']", globals(), locals()) or property_exists("bpy.data.images['sklx_HDRI_select_05.hdr']", globals(), locals()) or property_exists("bpy.data.images['sklx_HDRI_select_06.hdr']", globals(), locals()) or property_exists("bpy.data.images['sklx_HDRI_select_07.hdr']", globals(), locals()) or property_exists("bpy.data.images['sklx_HDRI_select_08.hdr']", globals(), locals()) or property_exists("bpy.data.images['sklx_HDRI_select_09.hdr']", globals(), locals()) or property_exists("bpy.data.images['sklx_HDRI_select_10.hdr']", globals(), locals())):
                col_107F7.prop(bpy.data.worlds['World'].node_tree.nodes['Map Range'].inputs[4], 'default_value', text='Angle', icon_value=0, emboss=True)
        else:
            col_107F7.prop(bpy.data.worlds['World'], 'color', text='', icon_value=0, emboss=True)
    else:
        if (not bpy.data.worlds['World'].use_nodes):
            col_107F7.prop(bpy.data.worlds['World'], 'color', text='', icon_value=0, emboss=True)
        else:
            if property_exists("bpy.data.worlds['World'].node_tree.nodes['Background'].inputs[0].default_value", globals(), locals()):
                col_107F7.prop(bpy.data.worlds['World'].node_tree.nodes['Background'].inputs[0], 'default_value', text='', icon_value=0, emboss=True)
    row_FC4C3 = col_C546C.row(heading='', align=True)
    row_FC4C3.alert = False
    row_FC4C3.enabled = True
    row_FC4C3.active = True
    row_FC4C3.use_property_split = False
    row_FC4C3.use_property_decorate = False
    row_FC4C3.scale_x = 1.0
    row_FC4C3.scale_y = 1.0
    row_FC4C3.alignment = 'Expand'.upper()
    row_FC4C3.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
    row_FC4C3.prop(bpy.context.scene, 'sna_render_select', text='eevee', icon_value=0, emboss=True, toggle=True, invert_checkbox=(None == bpy.context.scene.sna_render_select))
    row_FC4C3.prop(bpy.context.scene, 'sna_render_select', text='cycles', icon_value=0, emboss=True, toggle=True, invert_checkbox=(None != bpy.context.scene.sna_render_select))


def sna_select_mode_enum_items(self, context):
    enum_items = [['Auto', 'Auto', '', 0], ['Manual', 'Manual', '', 0]]
    return [make_enum_item(item[0], item[1], item[2], item[3], i) for i, item in enumerate(enum_items)]


class SNA_OT_Cleaner_3B364(bpy.types.Operator):
    bl_idname = "sna.cleaner_3b364"
    bl_label = "cleaner"
    bl_description = "clean all unused data"
    bl_options = {"REGISTER", "UNDO"}

    @classmethod
    def poll(cls, context):
        return not False

    def execute(self, context):
        for i_EE521 in range(2):
            bpy.ops.outliner.orphans_purge(do_local_ids=True, do_linked_ids=True, do_recursive=True)

            def main():
                print("\nEliminate Node Group Duplicates:")
                #--- Search for duplicates in actual node groups
                node_groups = bpy.data.node_groups
                for group in node_groups:
                    for node in group.nodes:
                        if node.type == 'GROUP':
                            eliminate(node)
                #--- Search for duplicates in materials
                mats = list(bpy.data.materials)
                worlds = list(bpy.data.worlds)
                for mat in mats + worlds:
                    if mat.use_nodes:
                        for node in mat.node_tree.nodes:
                            if node.type == 'GROUP':
                                eliminate(node)
            #--- Eliminate the node group duplicate with the original group if found

            def eliminate(node):
                node_groups = bpy.data.node_groups
                # Get the node group name as 3-tuple (base, separator, extension)
                (base, sep, ext) = node.node_tree.name.rpartition('.')
                # Replace the numeric duplicate
                if ext.isnumeric():
                    if base in node_groups:
                        print("  Replace '%s' with '%s'" % (node.node_tree.name, base))
                        node.node_tree.use_fake_user = False
                        node.node_tree = node_groups.get(base)
            #--- Execute main
            main()
        return {"FINISHED"}

    def invoke(self, context, event):
        return self.execute(context)


class SNA_OT_Fixtex_58Db1(bpy.types.Operator):
    bl_idname = "sna.fixtex_58db1"
    bl_label = "fix-tex"
    bl_description = "fix .001 textures (deprecated)"
    bl_options = {"REGISTER", "UNDO"}

    @classmethod
    def poll(cls, context):
        return not False

    def execute(self, context):
        bpimg = bpy.data.images.get
        cls = lambda: system('cls')
        cls() #this function call will clear the console
        material_set = set()
        for object in bpy.context.selected_objects:
            for material in object.material_slots:
                material_set.add(material)
        for material in material_set:
            Tex = material.name
            TexMain = Tex+'_MainTex.png'
            TexDetailM = Tex+'_DetailMask.png'
            TexNormal = Tex+'_NormalMap.png'
            TexNDetail = Tex+'_NormalMapDetail.png'
            TexAlphaM = Tex+'_AlphaMask.png'
            TexAnotherR = Tex+'_AnotherRamp.png'
            TexLiquidM = Tex+'_liquidmask.png'
            TexTex2 = Tex+'_Texture2.png'
            TexTex3 = Tex+'_Texture3.png'
            TexOv1 = Tex+'_overtex1.png'
            TexOv2 = Tex+'_overtex2.png'
            TexLineM = Tex+'_LineMask.png'
            TexColorM = Tex+'_ColorMask.png'
            TexHairG = Tex+'_HairGloss.png'
            TexBump = Tex+'_BumpMap.png'
            TexBump2 = Tex+'_BumpMap2.png'
            TexDNM = Tex+'_DetailNormalMap.png'
            TexBNM = Tex+'_BlendNormalMap.png'
            TexSGM = Tex+'_SpecGlossMap.png'
            TexOM = Tex+'_OcclusionMap.png'
            TexOC = Tex+'_Occlusion.png'
            TexTSS = Tex+'_Thickness.png'
            TexMGM = Tex+'_MetallicGlossMap.png'
            TexOV = Tex+'_OverTex.png'
            TexDMT = Tex+'_DetailMainTex.png'
            TexDGM = Tex+'_DetailGlossMap.png'
            TexDGM2 = Tex+'_DetailGlossMap2.png'
            TexNailM = Tex+'_NailMask.png'
            TexWetMK = Tex+'_WeatheringMask.png'
            TexWetMP = Tex+'_WeatheringMap.png'
        texture_list = []
        operationimg =  bpy.data.images
        for obj in bpy.context.selected_objects:
            for s in obj.material_slots:
                if s.material and s.material.use_nodes:
                    for n in s.material.node_tree.nodes:
                        if n.type == 'TEX_IMAGE':
                            #print(n.image.name)
                            bro = (n.image.name)
                            #print(bro+'aaaa')
                            #print(bro.split('_')[-1])
                            widw = (bro.split('_')[-1])
                            #print (bro.replace(widw,""))
                            originaltex = (bro.replace(widw,""))
                            #kkp
                            nm = originaltex+'NormalMap.png.001'
                            nd = originaltex+'NormalMapDetail.png.001'
                            dm = originaltex+'DetailMask.png.001'
                            mm = originaltex+'MainTex.png.001'
                            t3 = originaltex+'Texture3.png.001'
                            t2 = originaltex+'Texture2.png.001'
                            am = originaltex+'AlphaMask.png.001'
                            lm = originaltex+'liquidmask.png.001'
                            ar = originaltex+'AnotherRamp.png.001'
                            ov1 = originaltex+'overtex1.png.001'
                            ov2 = originaltex+'overtex2.png.001'
                            lnm = originaltex+'LineMask.png.001'
                            com = originaltex+'ColorMask.png.001'
                            glo = originaltex+'HairGloss.png.001'
                            #hs1
                            bum = originaltex+'BumpMap.png.001'
                            dnm = originaltex+'DetailNormalMap.png.001'
                            bnm = originaltex+'BlendNormalMap.png.001'
                            sgm = originaltex+'SpecGlossMap.png.001'
                            om = originaltex+'OcclusionMap.png.001'
                            tss = originaltex+'Thickness.png.001'
                            mgm = originaltex+'MetallicGlossMap.png.001'
                            ov = originaltex+'OverTex.png.001'
                            #hs2
                            bum2 = originaltex+'BumpMap2.png.001'
                            dmt = originaltex+'DetailMainTex.png.001'
                            dgm = originaltex+'DetailGlossMap.png.001'
                            dgm2 = originaltex+'DetailGlossMap2.png.001'
                            nail = originaltex+'NailMask.png.001'
                            wetmk = originaltex+'WeatheringMask.png.001'
                            wetmp = originaltex+'WeatheringMap.png.001'
                            oc = originaltex+'Occlusion.png.001'
                            #print(nm)

                            def unique_list(l):
                                ulist = []
                                [ulist.append(m) for m in l if m not in ulist]
                                return ulist
                            final = 'bpy.data.images'+'["'+bro
                            finalmente = final+'"].name'
                            #print(finalmente)
                            #print(widw)
                            osea = "'"+Tex+"_"+widw+"'"
                            #print(osea)
                            #finalmente = osea
                            #print(finalmente+'='+osea)
                            rocket = finalmente, '=' , osea
                            tanzan = (bro.replace(bro,osea))
        fixlocate = "//..\\..\\AppData\\Roaming\\Blender Foundation\\Blender\\3.0\\Program Files (x86)\\Steam\\steamapps\\common\\Koikatsu Party\\Export\\\20220603141428_Chika_Haruno\\Textures\\"#correct file location
        if 1 is 1:
            print(mm)
            print(dm)
            print(nm)
            print(t2)
            print(t3)
        f1 = bpimg(mm)
        #for x in f1:
        if f1 is not None:
            bpy.data.images[mm].name = TexMain
            bpy.data.images[TexMain].filepath = fixlocate+TexMain
            bpy.data.images[TexMain].filepath_raw = fixlocate+TexMain
        f2 = bpimg(dm)
        #for x in f2:
        if f2 is not None:
            bpy.data.images[dm].name = TexDetailM
            bpy.data.images[TexDetailM].filepath = fixlocate+TexDetailM
            bpy.data.images[TexDetailM].filepath_raw = fixlocate+TexDetailM
        f3 = bpimg(nm)
        #for x in f3:
        if f3 is not None:
            bpy.data.images[nm].name = TexNormal
            bpy.data.images[TexNormal].filepath = fixlocate+TexNormal
            bpy.data.images[TexNormal].filepath_raw = fixlocate+TexNormal
        f4 = bpimg(t2)
        #for x in f3:
        if f4 is not None:
            bpy.data.images[t2].name = TexTex2
            bpy.data.images[TexTex2].filepath = fixlocate+TexTex2
            bpy.data.images[TexTex2].filepath_raw = fixlocate+TexTex2
        f5 = bpimg(t3)
        #for x in f4:
        if f5 is not None:
            bpy.data.images[t3].name = TexTex3
            bpy.data.images[TexTex3].filepath = fixlocate+TexTex3
            bpy.data.images[TexTex3].filepath_raw = fixlocate+TexTex3
        f6 = bpimg(am)
        #for x in f5:
        if f6 is not None:
            bpy.data.images[am].name = TexAlphaM
            bpy.data.images[TexAlphaM].filepath = fixlocate+TexAlphaM
            bpy.data.images[TexAlphaM].filepath_raw = fixlocate+TexAlphaM
        f7 = bpimg(lm)
        #for x in f6:
        if f7 is not None:
            bpy.data.images[lm].name = TexLiquidM
            bpy.data.images[TexLiquidM].filepath = fixlocate+TexLiquidM
            bpy.data.images[TexLiquidM].filepath_raw = fixlocate+TexLiquidM
        f8 = bpimg(ar)
        #for f8 in f8:
        if f8 is not None:
            bpy.data.images[ar].name = TexAnotherR
            bpy.data.images[TexAnotherR].filepath = fixlocate+TexAnotherR
            bpy.data.images[TexAnotherR].filepath_raw = fixlocate+TexAnotherR
        f9 = bpimg(nd)
        #for f8 in f8:
        if f9 is not None:
            bpy.data.images[nd].name = TexNDetail
            bpy.data.images[TexNDetail].filepath = fixlocate+TexNDetail
            bpy.data.images[TexNDetail].filepath_raw = fixlocate+TexNDetail
        f10 = bpimg(ov1)
        #for f8 in f8:
        if f10 is not None:
            bpy.data.images[ov1].name = TexOv1
            bpy.data.images[TexOv1].filepath = fixlocate+TexOv1
            bpy.data.images[TexOv1].filepath_raw = fixlocate+TexOv1
        f11 = bpimg(ov2)
        #for f8 in f8:
        if f11 is not None:
            bpy.data.images[ov2].name = TexOv2
            bpy.data.images[TexOv2].filepath = fixlocate+TexOv2
            bpy.data.images[TexOv2].filepath_raw = fixlocate+TexOv2
        f12 = bpimg(lnm)
        #for f8 in f8:
        if f12 is not None:
            bpy.data.images[lnm].name = TexLineM
            bpy.data.images[TexLineM].filepath = fixlocate+TexLineM
            bpy.data.images[TexLineM].filepath_raw = fixlocate+TexLineM
        f13 = bpimg(com)
        #for f8 in f8:
        if f13 is not None:
            bpy.data.images[com].name = TexColorM
            bpy.data.images[TexColorM].filepath = fixlocate+TexColorM
            bpy.data.images[TexColorM].filepath_raw = fixlocate+TexColorM
        f14 = bpimg(glo)
        #for f8 in f8:
        if f14 is not None:
            bpy.data.images[glo].name = TexHairG
            bpy.data.images[TexHairG].filepath = fixlocate+TexHairG
            bpy.data.images[TexHairG].filepath_raw = fixlocate+TexHairG
        f15 = bpimg(bum)
        #for f8 in f8:
        if f15 is not None:
            bpy.data.images[bum].name = TexBump
            bpy.data.images[TexBump].filepath = fixlocate+TexBump
            bpy.data.images[TexBump].filepath_raw = fixlocate+TexBump
        f16 = bpimg(dnm)
        #for f8 in f8:
        if f16 is not None:
            bpy.data.images[dnm].name = TexDNM
            bpy.data.images[TexDNM].filepath = fixlocate+TexDNM
            bpy.data.images[TexDNM].filepath_raw = fixlocate+TexDNM
        f17 = bpimg(bnm)
        #for f8 in f8:
        if f17 is not None:
            bpy.data.images[bnm].name = TexBNM
            bpy.data.images[TexBNM].filepath = fixlocate+TexBNM
            bpy.data.images[TexBNM].filepath_raw = fixlocate+TexBNM
        f18 = bpimg(sgm)
        #for f8 in f8:
        if f18 is not None:
            bpy.data.images[sgm].name = TexSGM
            bpy.data.images[TexSGM].filepath = fixlocate+TexSGM
            bpy.data.images[TexSGM].filepath_raw = fixlocate+TexSGM
        f19 = bpimg(om)
        #for f8 in f8:
        if f19 is not None:
            bpy.data.images[om].name = TexOM
            bpy.data.images[TexOM].filepath = fixlocate+TexOM
            bpy.data.images[TexOM].filepath_raw = fixlocate+TexOM
        f20 = bpimg(tss)
        #for f8 in f8:
        if f20 is not None:
            bpy.data.images[tss].name = TexTSS
            bpy.data.images[TexTSS].filepath = fixlocate+TexTSS
            bpy.data.images[TexTSS].filepath_raw = fixlocate+TexTSS
        f21 = bpimg(mgm)
        #for f8 in f8:
        if f21 is not None:
            bpy.data.images[mgm].name = TexMGM
            bpy.data.images[TexMGM].filepath = fixlocate+TexMGM
            bpy.data.images[TexMGM].filepath_raw = fixlocate+TexMGM
        f22 = bpimg(ov)
        #for f8 in f8:
        if f22 is not None:
            bpy.data.images[ov].name = TexOV
            bpy.data.images[TexOV].filepath = fixlocate+TexOV
            bpy.data.images[TexOV].filepath_raw = fixlocate+TexOV
        f23 = bpimg(bum2)
        #for f8 in f8:
        if f23 is not None:
            bpy.data.images[bum2].name = TexBump2
            bpy.data.images[TexBump2].filepath = fixlocate+TexBump2
            bpy.data.images[TexBump2].filepath_raw = fixlocate+TexBump2
        f24 = bpimg(dmt)
        if f24 is not None:
            bpy.data.images[dmt].name = TexDMT
            bpy.data.images[TexDMT].filepath = fixlocate+TexDMT
            bpy.data.images[TexDMT].filepath_raw = fixlocate+TexDMT
        f25 = bpimg(dgm)
        if f25 is not None:
            bpy.data.images[dgm].name = TexDGM
            bpy.data.images[TexDGM].filepath = fixlocate+TexDGM
            bpy.data.images[TexDGM].filepath_raw = fixlocate+TexDGM
        f26 = bpimg(dgm2)
        if f26 is not None:
            bpy.data.images[dgm2].name = TexDGM2
            bpy.data.images[TexDGM2].filepath = fixlocate+TexDGM2
            bpy.data.images[TexDGM2].filepath_raw = fixlocate+TexDGM2
        f27 = bpimg(nail)
        if f27 is not None:
            bpy.data.images[nail].name = TexNailM
            bpy.data.images[TexNailM].filepath = fixlocate+TexNailM
            bpy.data.images[TexNailM].filepath_raw = fixlocate+TexNailM
        f28 = bpimg(wetmk)
        if f28 is not None:
            bpy.data.images[wetmk].name = TexWetMK
            bpy.data.images[TexWetMK].filepath = fixlocate+TexWetMK
            bpy.data.images[TexWetMK].filepath_raw = fixlocate+TexWetMK
        f29 = bpimg(wetmp)
        if f29 is not None:
            bpy.data.images[wetmp].name = TexWetMP
            bpy.data.images[TexWetMP].filepath = fixlocate+TexWetMP
            bpy.data.images[TexWetMP].filepath_raw = fixlocate+TexWetMP
        f30 = bpimg(oc)
        if f30 is not None:
            bpy.data.images[oc].name = TexOC
            bpy.data.images[TexOC].filepath = fixlocate+TexOC
            bpy.data.images[TexOC].filepath_raw = fixlocate+TexOC
        return {"FINISHED"}

    def invoke(self, context, event):
        return self.execute(context)


class SNA_OT_Multiple_Char_01511(bpy.types.Operator):
    bl_idname = "sna.multiple_char_01511"
    bl_label = "multiple_char"
    bl_description = "Set materials to same objects"
    bl_options = {"REGISTER", "UNDO"}

    @classmethod
    def poll(cls, context):
        return not False

    def execute(self, context):
        #--- Eliminate Material Duplicates

        def eliminate_materials():
            print("\nEliminate Material Duplicates:")
            #--- Search for mat. slots in all objects
            mats = bpy.data.materials
            for obj in bpy.data.objects:
                for slot in obj.material_slots:
                    # Get the material name as 3-tuple (base, separator, extension)
                    (base, sep, ext) = slot.name.rpartition('.')
                    # Replace the numbered duplicate with the original if found
                    if ext.isnumeric():
                        if base in mats:
                            print("  For object '%s' replace '%s' with '%s'" % (obj.name, slot.name, base))
                            slot.material = mats.get(base)
        #--- Execute
        eliminate_materials()
        return {"FINISHED"}

    def invoke(self, context, event):
        return self.execute(context)


class SNA_OT_Lofi_1065C(bpy.types.Operator):
    bl_idname = "sna.lofi_1065c"
    bl_label = "LOFI"
    bl_description = "in development"
    bl_options = {"REGISTER", "UNDO"}

    @classmethod
    def poll(cls, context):
        return not False

    def execute(self, context):
        return {"FINISHED"}

    def invoke(self, context, event):
        return self.execute(context)


palette_color_hat_p = None
palette_color_knee_s = None
palette_color_escort_chain = None
palette_color_high_seal = None
palette_color_high_skin_lloid = None
palette_color_ass = None
palette_color_pandora_hallroom = None
palette_color_right_gamma = None


import hashlib
today = datetime.datetime.now()
sklx = 'lib'
daysy = today
mandy = today.month
yuri = today.year
palette = str((mandy,yuri))
mate = hashlib
rgba_bridge = bytes.fromhex('28 31 32 2c 20 32 30 32 32 29').decode('utf-8')
palette_color_hat_p = rgba_bridge
palette_color_knee_s = rgba_bridge
palette_color_escort_chain = rgba_bridge
palette_color_high_seal = rgba_bridge
palette_color_high_skin_lloid = rgba_bridge
palette_color_ass = rgba_bridge
palette_color_pandora_hallroom = rgba_bridge
palette_color_right_gamma = rgba_bridge
############################################################
if palette == palette_color_hat_p:
    palette_color_hat_p = bytes.fromhex('6b 59 70 33 73 36 76 39 79 24 42 3f 45 28 48 2b 4d 62 51 65 54 68 57 6d 5a 71 34 74 37 77 21 7a 25 43 2a 46 29 4a 40 4e 63 52 66 55 6a 58 6e 32 72 35 75 38 78 2f 41 3f 44 28 47 2b 4b 61 50 64').decode('utf-8')


else:
    palette_color_hat_p = mate.md5(palette_color_knee_s.encode()),mate.md5(palette.encode())


if palette == palette_color_knee_s:
    palette_color_knee_s = bytes.fromhex('55 6b 58 70 32 73 35 76 38 79 2f 42 3f 45 28 47 2b 4b 62 50 65 53 68 56 6d 59 71 33 74 36 77 39 7a 24 43 26 46 29 4a 40 4d 63 51 66 54 6a 57 6e 5a 72 34 75 37 78 21 41 25 44 2a 47 2d 4b 61 50').decode('utf-8')


else:
    palette_color_knee_s = mate.md5(palette_color_knee_s.encode()),mate.md5(palette.encode())


if palette == palette_color_escort_chain:
    palette_color_escort_chain = bytes.fromhex('48 40 4d 63 51 66 54 6a 57 6e 5a 72 34 75 37 78 21 41 25 44 2a 47 2d 4a 61 4e 64 52 67 55 6b 58 70 32 73 35 76 38 79 2f 42 3f 45 28 48 2b 4d 62 50 65 53 68 56 6d 59 71 33 74 36 77 39 7a 24 43').decode('utf-8')


else:
    palette_color_escort_chain = mate.md5(palette_color_escort_chain.encode()),mate.md5(palette.encode())


if palette == palette_color_high_seal:
    palette_color_high_seal = bytes.fromhex('40 4d 63 51 66 54 6a 57 6e 5a 72 34 75 37 78 21 41 25 44 2a 47 2d 4a 61 4e 64 52 67 55 6b 58 70 32 73 35 76 38 79 2f 42 3f 45 28 48 2b 4d 62 50 65 53 68 56 6d 59 71 33 74 36 77 39 7a 24 43 26').decode('utf-8')


else:
    palette_color_high_seal = mate.md5(palette_color_high_seal.encode()),mate.md5(palette.encode())


if palette == palette_color_high_skin_lloid:
    palette_color_high_skin_lloid = bytes.fromhex('35 75 38 78 2f 41 3f 44 2a 47 2d 4b 61 50 64 53 67 56 6b 59 70 33 73 36 76 39 79 24 42 26 45 29 48 2b 4d 62 51 65 54 68 57 6d 5a 71 34 74 37 77 21 7a 25 43 2a 46 2d 4a 61 4e 63 52 66 55 6a 58').decode('utf-8')


else:
    palette_color_high_skin_lloid = mate.md5(palette_color_high_skin_lloid.encode()),mate.md5(palette.encode())


if palette == palette_color_ass:
    palette_color_ass = bytes.fromhex('62 50 65 53 68 56 6d 59 71 33 74 36 77 39 7a 24 43 26 46 29 48 40 4d 63 51 66 54 6a 57 6e 5a 72 34 75 37 78 21 41 25 44 2a 47 2d 4b 61 4e 64 52 67 55 6b 58 70 32 73 35 76 38 79 2f 42 3f 45 28').decode('utf-8')


else:
    palette_color_ass = mate.md5(palette_color_ass.encode()),mate.md5(palette.encode())


if palette == palette_color_pandora_hallroom:
    palette_color_pandora_hallroom = bytes.fromhex('4b 62 50 65 53 68 56 6d 59 71 33 74 36 77 39 7a 24 43 26 46 29 4a 40 4e 63 51 66 54 6a 57 6e 5a 72 34 75 37 78 21 41 25 44 2a 47 2d 4b 61 50 64 53 67 55 6b 58 70 32 73 35 76 38 79 2f 42 3f 45').decode('utf-8')


else:
    palette_color_pandora_hallroom = mate.md5(palette_color_pandora_hallroom.encode()),mate.md5(palette.encode())


if palette == palette_color_right_gamma:
    palette_color_right_gamma = bytes.fromhex('37 77 21 7a 25 43 2a 46 2d 4a 40 4e 63 52 66 55 6a 58 6e 32 72 35 75 38 78 2f 41 3f 44 28 47 2b 4b 62 50 65 53 67 56 6b 59 70 33 73 36 76 39 79 24 42 26 45 29 48 40 4d 63 51 66 54 6a 57 6d 5a').decode('utf-8')


else:
    palette_color_right_gamma = mate.md5(palette_color_right_gamma.encode()),mate.md5(palette.encode())


class SNA_PT_SKLXCREATOR_EF7CA(bpy.types.Panel):
    bl_label = 'SKLX-creator'
    bl_idname = 'SNA_PT_SKLXCREATOR_EF7CA'
    bl_space_type = 'VIEW_3D'
    bl_region_type = 'UI'
    bl_context = ''
    bl_category = 'SKLX'
    bl_order = 0
    bl_ui_units_x=0

    @classmethod
    def poll(cls, context):
        return not (False)

    def draw_header(self, context):
        layout = self.layout

    def draw(self, context):
        layout = self.layout
        col_5AC37 = layout.column(heading='', align=False)
        col_5AC37.alert = False
        col_5AC37.enabled = True
        col_5AC37.active = True
        col_5AC37.use_property_split = False
        col_5AC37.use_property_decorate = False
        col_5AC37.scale_x = 1.0
        col_5AC37.scale_y = 1.0
        col_5AC37.alignment = 'Expand'.upper()
        col_5AC37.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
        if False:
            box_F11AF = col_5AC37.box()
            box_F11AF.alert = True
            box_F11AF.enabled = True
            box_F11AF.active = True
            box_F11AF.use_property_split = False
            box_F11AF.use_property_decorate = False
            box_F11AF.alignment = 'Expand'.upper()
            box_F11AF.scale_x = 1.0
            box_F11AF.scale_y = 0.6000000238418579
            box_F11AF.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
            row_A23B5 = box_F11AF.row(heading='', align=True)
            row_A23B5.alert = True
            row_A23B5.enabled = True
            row_A23B5.active = True
            row_A23B5.use_property_split = False
            row_A23B5.use_property_decorate = False
            row_A23B5.scale_x = 1.0
            row_A23B5.scale_y = 1.0
            row_A23B5.alignment = 'Center'.upper()
            row_A23B5.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
            row_A23B5.label(text='//', icon_value=229)
            row_A23B5.label(text='SKLX PRO', icon_value=227)
            row_A23B5.label(text='//', icon_value=230)
            row_A23B5.label(text='', icon_value=227)
        layout_function = col_5AC37
        sna_modelimporter_FCA6D(layout_function, )
        if ((bpy.context.scene.sna_select_an_option == 'Emotion Creators') or ((bpy.context.scene.sna_select_an_option == 'Honey Select 2') and (not (bpy.data.scenes['Scene'].sna_importkkp == eval("bytes.fromhex('6b 59 70 33 73 36 76 39 79 24 42 3f 45 28 48 2b 4d 62 51 65 54 68 57 6d 5a 71 34 74 37 77 21 7a 25 43 2a 46 29 4a 40 4e 63 52 66 55 6a 58 6e 32 72 35 75 38 78 2f 41 3f 44 28 47 2b 4b 61 50 64').decode('utf-8')")))) or (bpy.context.scene.sna_select_an_option == 'Ai Shoujo') or (bpy.context.scene.sna_select_an_option == 'Koikatsu Sunshine') or (bpy.context.scene.sna_select_an_option == 'PlayHome') or (bpy.context.scene.sna_select_an_option == 'Room Girl')):
            box_FA7C4 = col_5AC37.box()
            box_FA7C4.alert = True
            box_FA7C4.enabled = True
            box_FA7C4.active = True
            box_FA7C4.use_property_split = False
            box_FA7C4.use_property_decorate = False
            box_FA7C4.alignment = 'Expand'.upper()
            box_FA7C4.scale_x = 1.0
            box_FA7C4.scale_y = 1.0
            box_FA7C4.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
            row_D19D6 = box_FA7C4.row(heading='', align=True)
            row_D19D6.alert = True
            row_D19D6.enabled = True
            row_D19D6.active = True
            row_D19D6.use_property_split = False
            row_D19D6.use_property_decorate = False
            row_D19D6.scale_x = 1.0
            row_D19D6.scale_y = 1.0
            row_D19D6.alignment = 'Center'.upper()
            row_D19D6.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
            row_D19D6.label(text='IN DEVELOPMENT', icon_value=0)
        if ((bpy.context.scene.sna_select_an_option == 'Emotion Creators') or ((bpy.context.scene.sna_select_an_option == 'Honey Select 2') and (not (bpy.data.scenes['Scene'].sna_importkkp == eval("bytes.fromhex('6b 59 70 33 73 36 76 39 79 24 42 3f 45 28 48 2b 4d 62 51 65 54 68 57 6d 5a 71 34 74 37 77 21 7a 25 43 2a 46 29 4a 40 4e 63 52 66 55 6a 58 6e 32 72 35 75 38 78 2f 41 3f 44 28 47 2b 4b 61 50 64').decode('utf-8')")))) or (bpy.context.scene.sna_select_an_option == 'Ai Shoujo') or (bpy.context.scene.sna_select_an_option == 'Koikatsu Sunshine') or (bpy.context.scene.sna_select_an_option == 'PlayHome') or (bpy.context.scene.sna_select_an_option == 'Room Girl')):
            box_0DDF0 = col_5AC37.box()
            box_0DDF0.alert = False
            box_0DDF0.enabled = True
            box_0DDF0.active = True
            box_0DDF0.use_property_split = False
            box_0DDF0.use_property_decorate = False
            box_0DDF0.alignment = 'Expand'.upper()
            box_0DDF0.scale_x = 1.0
            box_0DDF0.scale_y = 1.0
            box_0DDF0.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
            box_CC2DF = box_0DDF0.box()
            box_CC2DF.alert = False
            box_CC2DF.enabled = True
            box_CC2DF.active = True
            box_CC2DF.use_property_split = False
            box_CC2DF.use_property_decorate = False
            box_CC2DF.alignment = 'Expand'.upper()
            box_CC2DF.scale_x = 1.0
            box_CC2DF.scale_y = 1.0
            box_CC2DF.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
            row_D60BB = box_CC2DF.row(heading='', align=True)
            row_D60BB.alert = False
            row_D60BB.enabled = True
            row_D60BB.active = True
            row_D60BB.use_property_split = False
            row_D60BB.use_property_decorate = False
            row_D60BB.scale_x = 1.0
            row_D60BB.scale_y = 1.0
            row_D60BB.alignment = 'Center'.upper()
            row_D60BB.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
            row_D60BB.label(text='Meanwhile enjoy this pic...', icon_value=0)
            box_CC2DF.template_icon(icon_value=_icons['togax256.png'].icon_id, scale=6.0)
            row_E40E4 = box_CC2DF.row(heading='', align=True)
            row_E40E4.alert = False
            row_E40E4.enabled = True
            row_E40E4.active = True
            row_E40E4.use_property_split = False
            row_E40E4.use_property_decorate = False
            row_E40E4.scale_x = 1.0
            row_E40E4.scale_y = 1.0
            row_E40E4.alignment = 'Center'.upper()
            row_E40E4.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
            row_E40E4.label(text='or support to help the addon grown up', icon_value=0)
            row_CE699 = box_CC2DF.row(heading='', align=True)
            row_CE699.alert = True
            row_CE699.enabled = True
            row_CE699.active = True
            row_CE699.use_property_split = False
            row_CE699.use_property_decorate = False
            row_CE699.scale_x = 1.0
            row_CE699.scale_y = 1.100000023841858
            row_CE699.alignment = 'Expand'.upper()
            row_CE699.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
            op = row_CE699.operator('sna.become_f266b', text='SUPPORT', icon_value=0, emboss=True, depress=False)
        else:
            col_A7317 = col_5AC37.column(heading='', align=True)
            col_A7317.alert = False
            col_A7317.enabled = True
            col_A7317.active = True
            col_A7317.use_property_split = False
            col_A7317.use_property_decorate = False
            col_A7317.scale_x = 1.0
            col_A7317.scale_y = 1.0
            col_A7317.alignment = 'Expand'.upper()
            col_A7317.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
            if property_exists("bpy.data.materials['cf_m_body'].node_tree.nodes['KKP-BS'].inputs[4].default_value", globals(), locals()):
                box_C0929 = col_A7317.box()
                box_C0929.alert = False
                box_C0929.enabled = True
                box_C0929.active = True
                box_C0929.use_property_split = False
                box_C0929.use_property_decorate = False
                box_C0929.alignment = 'Expand'.upper()
                box_C0929.scale_x = 1.0
                box_C0929.scale_y = 1.0
                box_C0929.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
                box_A7A66 = box_C0929.box()
                box_A7A66.alert = False
                box_A7A66.enabled = True
                box_A7A66.active = True
                box_A7A66.use_property_split = False
                box_A7A66.use_property_decorate = False
                box_A7A66.alignment = 'Expand'.upper()
                box_A7A66.scale_x = 1.0
                box_A7A66.scale_y = 1.0
                box_A7A66.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
                row_41293 = box_A7A66.row(heading='', align=True)
                row_41293.alert = True
                row_41293.enabled = True
                row_41293.active = True
                row_41293.use_property_split = False
                row_41293.use_property_decorate = False
                row_41293.scale_x = 1.0
                row_41293.scale_y = 1.0
                row_41293.alignment = 'Expand'.upper()
                row_41293.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
                row_41293.label(text='NSFW FILTER', icon_value=0)
                row_41293.prop(bpy.data.materials['cf_m_body'].node_tree.nodes['KKP-BS'].inputs[4], 'default_value', text='', icon_value=0, emboss=True)
            if True:
                box_C4066 = col_A7317.box()
                box_C4066.alert = False
                box_C4066.enabled = True
                box_C4066.active = True
                box_C4066.use_property_split = False
                box_C4066.use_property_decorate = False
                box_C4066.alignment = 'Expand'.upper()
                box_C4066.scale_x = 1.0
                box_C4066.scale_y = 1.0
                box_C4066.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
                col_CB26A = box_C4066.column(heading='', align=False)
                col_CB26A.alert = False
                col_CB26A.enabled = True
                col_CB26A.active = True
                col_CB26A.use_property_split = False
                col_CB26A.use_property_decorate = False
                col_CB26A.scale_x = 1.0
                col_CB26A.scale_y = 1.0
                col_CB26A.alignment = 'Expand'.upper()
                col_CB26A.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
                col_CB26A.label(text='Now set the shaders!', icon_value=_icons['blue.png'].icon_id)
                col_CB26A.prop(bpy.context.scene, 'sna_select_mode', text='', icon_value=0, emboss=True)
                if bpy.context.scene.sna_select_mode == "Auto":
                    layout_function = col_CB26A
                    sna_shaderimporter_DACA2(layout_function, )
                elif bpy.context.scene.sna_select_mode == "Manual":
                    if (bpy.context.scene.sna_select_an_option == 'Koikatsu Party'):
                        box_9C7D4 = col_CB26A.box()
                        box_9C7D4.alert = False
                        box_9C7D4.enabled = True
                        box_9C7D4.active = True
                        box_9C7D4.use_property_split = False
                        box_9C7D4.use_property_decorate = False
                        box_9C7D4.alignment = 'Expand'.upper()
                        box_9C7D4.scale_x = 1.0
                        box_9C7D4.scale_y = 1.0
                        box_9C7D4.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
                        col_81F5A = box_9C7D4.column(heading='', align=True)
                        col_81F5A.alert = False
                        col_81F5A.enabled = True
                        col_81F5A.active = True
                        col_81F5A.use_property_split = False
                        col_81F5A.use_property_decorate = False
                        col_81F5A.scale_x = 1.0
                        col_81F5A.scale_y = 1.0
                        col_81F5A.alignment = 'Expand'.upper()
                        col_81F5A.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
                        row_B3BBA = col_81F5A.row(heading='', align=True)
                        row_B3BBA.alert = False
                        row_B3BBA.enabled = True
                        row_B3BBA.active = True
                        row_B3BBA.use_property_split = False
                        row_B3BBA.use_property_decorate = False
                        row_B3BBA.scale_x = 1.0
                        row_B3BBA.scale_y = 1.0
                        row_B3BBA.alignment = 'Expand'.upper()
                        row_B3BBA.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
                        op = row_B3BBA.operator('sna.kkpface_e438d', text='Face', icon_value=0, emboss=True, depress=False)
                        op = row_B3BBA.operator('sna.kkpbody_609d4', text='Body', icon_value=0, emboss=True, depress=False)
                        op = row_B3BBA.operator('sna.kkphairb_03315', text='Hair', icon_value=0, emboss=True, depress=False)
                        row_71883 = col_81F5A.row(heading='', align=True)
                        row_71883.alert = False
                        row_71883.enabled = True
                        row_71883.active = True
                        row_71883.use_property_split = False
                        row_71883.use_property_decorate = False
                        row_71883.scale_x = 1.0
                        row_71883.scale_y = 1.0
                        row_71883.alignment = 'Expand'.upper()
                        row_71883.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
                        op = row_71883.operator('sna.kkptop_08379', text='Top', icon_value=0, emboss=True, depress=False)
                        op = row_71883.operator('sna.kkpbot_9e279', text='Bot', icon_value=0, emboss=True, depress=False)
                        op = row_71883.operator('sna.kkpinner_8a572', text='Inner', icon_value=0, emboss=True, depress=False)
                        row_FBAD5 = col_81F5A.row(heading='', align=True)
                        row_FBAD5.alert = False
                        row_FBAD5.enabled = True
                        row_FBAD5.active = True
                        row_FBAD5.use_property_split = False
                        row_FBAD5.use_property_decorate = False
                        row_FBAD5.scale_x = 1.0
                        row_FBAD5.scale_y = 1.0
                        row_FBAD5.alignment = 'Expand'.upper()
                        row_FBAD5.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
                        op = row_FBAD5.operator('sna.kkpbra_3e2db', text='Bra', icon_value=0, emboss=True, depress=False)
                        op = row_FBAD5.operator('sna.kkppanties_b34cf', text='Panties', icon_value=0, emboss=True, depress=False)
                        op = row_FBAD5.operator('sna.kkpsocks_0d912', text='Socks', icon_value=0, emboss=True, depress=False)
                        row_AD173 = col_81F5A.row(heading='', align=True)
                        row_AD173.alert = False
                        row_AD173.enabled = True
                        row_AD173.active = True
                        row_AD173.use_property_split = False
                        row_AD173.use_property_decorate = False
                        row_AD173.scale_x = 1.0
                        row_AD173.scale_y = 1.0
                        row_AD173.alignment = 'Expand'.upper()
                        row_AD173.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
                        op = row_AD173.operator('sna.kkpshoes_ec253', text='Shoes', icon_value=0, emboss=True, depress=False)
                        op = row_AD173.operator('sna.kkpaccs_8314b', text='Accs', icon_value=0, emboss=True, depress=False)
                        op = row_AD173.operator('sna.kkpsimple_c0011', text='Simple', icon_value=0, emboss=True, depress=False)
                        row_ABAC6 = box_9C7D4.row(heading='', align=True)
                        row_ABAC6.alert = True
                        row_ABAC6.enabled = True
                        row_ABAC6.active = True
                        row_ABAC6.use_property_split = False
                        row_ABAC6.use_property_decorate = False
                        row_ABAC6.scale_x = 1.0
                        row_ABAC6.scale_y = 1.0
                        row_ABAC6.alignment = 'Expand'.upper()
                        row_ABAC6.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
                        op = row_ABAC6.operator('sna.animeoutline_d89c9', text='Anime Outline', icon_value=0, emboss=True, depress=False)
                    else:
                        if (bpy.context.scene.sna_select_an_option == 'Koikatsu Sunshine'):
                            pass
                        else:
                            if (bpy.context.scene.sna_select_an_option == 'Emotion Creators'):
                                pass
                            else:
                                if (bpy.context.scene.sna_select_an_option == 'Honey Select'):
                                    box_B2740 = col_CB26A.box()
                                    box_B2740.alert = False
                                    box_B2740.enabled = True
                                    box_B2740.active = True
                                    box_B2740.use_property_split = False
                                    box_B2740.use_property_decorate = False
                                    box_B2740.alignment = 'Expand'.upper()
                                    box_B2740.scale_x = 1.0
                                    box_B2740.scale_y = 1.0
                                    box_B2740.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
                                    col_3D856 = box_B2740.column(heading='', align=False)
                                    col_3D856.alert = False
                                    col_3D856.enabled = True
                                    col_3D856.active = True
                                    col_3D856.use_property_split = False
                                    col_3D856.use_property_decorate = False
                                    col_3D856.scale_x = 1.0
                                    col_3D856.scale_y = 1.2000000476837158
                                    col_3D856.alignment = 'Expand'.upper()
                                    col_3D856.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
                                    row_15DCF = col_3D856.row(heading='', align=True)
                                    row_15DCF.alert = False
                                    row_15DCF.enabled = True
                                    row_15DCF.active = True
                                    row_15DCF.use_property_split = False
                                    row_15DCF.use_property_decorate = False
                                    row_15DCF.scale_x = 1.0
                                    row_15DCF.scale_y = 1.0
                                    row_15DCF.alignment = 'Expand'.upper()
                                    row_15DCF.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
                                    op = row_15DCF.operator('sna.hs1face_091b8', text='Face', icon_value=0, emboss=True, depress=False)
                                    op = row_15DCF.operator('sna.hs1body_8befd', text='Body', icon_value=0, emboss=True, depress=False)
                                    op = row_15DCF.operator('sna.hs1hair_9d604', text='Hair', icon_value=0, emboss=True, depress=False)
                                    row_C216B = col_3D856.row(heading='', align=True)
                                    row_C216B.alert = False
                                    row_C216B.enabled = True
                                    row_C216B.active = True
                                    row_C216B.use_property_split = False
                                    row_C216B.use_property_decorate = False
                                    row_C216B.scale_x = 1.0
                                    row_C216B.scale_y = 1.0
                                    row_C216B.alignment = 'Expand'.upper()
                                    row_C216B.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
                                    op = row_C216B.operator('sna.hs1top_cd510', text='Top', icon_value=0, emboss=True, depress=False)
                                    op = row_C216B.operator('sna.hs1bot_a2c63', text='Bot', icon_value=0, emboss=True, depress=False)
                                    op = row_C216B.operator('sna.hs1fit_bb512', text='Fit', icon_value=0, emboss=True, depress=False)
                                    row_28C81 = col_3D856.row(heading='', align=True)
                                    row_28C81.alert = False
                                    row_28C81.enabled = True
                                    row_28C81.active = True
                                    row_28C81.use_property_split = False
                                    row_28C81.use_property_decorate = False
                                    row_28C81.scale_x = 1.0
                                    row_28C81.scale_y = 1.0
                                    row_28C81.alignment = 'Expand'.upper()
                                    row_28C81.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
                                    op = row_28C81.operator('sna.hs1bra_dafef', text='Bra', icon_value=0, emboss=True, depress=False)
                                    op = row_28C81.operator('sna.hs1panties_f51b5', text='Panties', icon_value=0, emboss=True, depress=False)
                                    op = row_28C81.operator('sna.hs1socks_a2f22', text='Socks', icon_value=0, emboss=True, depress=False)
                                    row_D2B89 = col_3D856.row(heading='', align=True)
                                    row_D2B89.alert = False
                                    row_D2B89.enabled = True
                                    row_D2B89.active = True
                                    row_D2B89.use_property_split = False
                                    row_D2B89.use_property_decorate = False
                                    row_D2B89.scale_x = 1.0
                                    row_D2B89.scale_y = 1.0
                                    row_D2B89.alignment = 'Expand'.upper()
                                    row_D2B89.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
                                    op = row_D2B89.operator('sna.hs1shoes_1c954', text='Shoes', icon_value=0, emboss=True, depress=False)
                                    op = row_D2B89.operator('sna.hs1accs_81340', text='Accs', icon_value=0, emboss=True, depress=False)
                                    op = row_D2B89.operator('sna.hs1simple_d9f66', text='Simple', icon_value=0, emboss=True, depress=False)
                                else:
                                    if (bpy.context.scene.sna_select_an_option == 'Honey Select 2'):
                                        box_9B85F = col_CB26A.box()
                                        box_9B85F.alert = False
                                        box_9B85F.enabled = True
                                        box_9B85F.active = True
                                        box_9B85F.use_property_split = False
                                        box_9B85F.use_property_decorate = False
                                        box_9B85F.alignment = 'Expand'.upper()
                                        box_9B85F.scale_x = 1.0
                                        box_9B85F.scale_y = 1.0
                                        box_9B85F.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
                                        col_E2DC2 = box_9B85F.column(heading='', align=False)
                                        col_E2DC2.alert = False
                                        col_E2DC2.enabled = True
                                        col_E2DC2.active = True
                                        col_E2DC2.use_property_split = False
                                        col_E2DC2.use_property_decorate = False
                                        col_E2DC2.scale_x = 1.0
                                        col_E2DC2.scale_y = 1.2000000476837158
                                        col_E2DC2.alignment = 'Expand'.upper()
                                        col_E2DC2.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
                                        row_EF082 = col_E2DC2.row(heading='', align=True)
                                        row_EF082.alert = False
                                        row_EF082.enabled = True
                                        row_EF082.active = True
                                        row_EF082.use_property_split = False
                                        row_EF082.use_property_decorate = False
                                        row_EF082.scale_x = 1.0
                                        row_EF082.scale_y = 1.0
                                        row_EF082.alignment = 'Expand'.upper()
                                        row_EF082.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
                                        op = row_EF082.operator('sna.hs2facemanual_6429f', text='Face', icon_value=0, emboss=True, depress=False)
                                        op = row_EF082.operator('sna.hs2bodymanual_232ed', text='Body', icon_value=0, emboss=True, depress=False)
                                        op = row_EF082.operator('sna.hs2hairmanual_c5c88', text='Hair', icon_value=0, emboss=True, depress=False)
                                        row_6F1FF = col_E2DC2.row(heading='', align=True)
                                        row_6F1FF.alert = False
                                        row_6F1FF.enabled = True
                                        row_6F1FF.active = True
                                        row_6F1FF.use_property_split = False
                                        row_6F1FF.use_property_decorate = False
                                        row_6F1FF.scale_x = 1.0
                                        row_6F1FF.scale_y = 1.0
                                        row_6F1FF.alignment = 'Expand'.upper()
                                        row_6F1FF.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
                                        op = row_6F1FF.operator('sna.hs2topmanual_e0f0e', text='Top', icon_value=0, emboss=True, depress=False)
                                        op = row_6F1FF.operator('sna.hs2botmanual_d9f93', text='Bot', icon_value=0, emboss=True, depress=False)
                                        op = row_6F1FF.operator('sna.hs2innermanual_665d4', text='Inner', icon_value=0, emboss=True, depress=False)
                                        row_38040 = col_E2DC2.row(heading='', align=True)
                                        row_38040.alert = False
                                        row_38040.enabled = True
                                        row_38040.active = True
                                        row_38040.use_property_split = False
                                        row_38040.use_property_decorate = False
                                        row_38040.scale_x = 1.0
                                        row_38040.scale_y = 1.0
                                        row_38040.alignment = 'Expand'.upper()
                                        row_38040.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
                                        op = row_38040.operator('sna.hs2bramanual_129df', text='Bra', icon_value=0, emboss=True, depress=False)
                                        op = row_38040.operator('sna.hs2pantiesmanual_dab9c', text='Panties', icon_value=0, emboss=True, depress=False)
                                        op = row_38040.operator('sna.hs2socksmanual_85526', text='Socks', icon_value=0, emboss=True, depress=False)
                                        row_16F0F = col_E2DC2.row(heading='', align=True)
                                        row_16F0F.alert = False
                                        row_16F0F.enabled = True
                                        row_16F0F.active = True
                                        row_16F0F.use_property_split = False
                                        row_16F0F.use_property_decorate = False
                                        row_16F0F.scale_x = 1.0
                                        row_16F0F.scale_y = 1.0
                                        row_16F0F.alignment = 'Expand'.upper()
                                        row_16F0F.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
                                        op = row_16F0F.operator('sna.hs2shoesmanual_8b32c', text='Shoes', icon_value=0, emboss=True, depress=False)
                                        row_550EA = row_16F0F.row(heading='', align=True)
                                        row_550EA.alert = False
                                        row_550EA.enabled = False
                                        row_550EA.active = False
                                        row_550EA.use_property_split = False
                                        row_550EA.use_property_decorate = False
                                        row_550EA.scale_x = 1.0
                                        row_550EA.scale_y = 1.0
                                        row_550EA.alignment = 'Expand'.upper()
                                        row_550EA.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
                                        op = row_550EA.operator('sna.hs2accsmanual_07554', text='Accs', icon_value=0, emboss=True, depress=False)
                                        op = row_550EA.operator('sna.hs2simplemanual_425f7', text='Simple', icon_value=0, emboss=True, depress=False)
                                    else:
                                        if (bpy.context.scene.sna_select_an_option == 'Ai Shoujo'):
                                            pass
                                        else:
                                            if (bpy.context.scene.sna_select_an_option == 'PlayHome'):
                                                pass
                                            else:
                                                if (bpy.context.scene.sna_select_an_option == 'Room Girl'):
                                                    pass
                else:
                    pass
                col_16709 = box_C4066.column(heading='', align=False)
                col_16709.alert = False
                col_16709.enabled = True
                col_16709.active = True
                col_16709.use_property_split = False
                col_16709.use_property_decorate = False
                col_16709.scale_x = 1.0
                col_16709.scale_y = 1.0
                col_16709.alignment = 'Expand'.upper()
                col_16709.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
                col_16709.label(text='Check the colors!', icon_value=_icons['yellow.png'].icon_id)
                box_BE038 = col_16709.box()
                box_BE038.alert = False
                box_BE038.enabled = True
                box_BE038.active = True
                box_BE038.use_property_split = False
                box_BE038.use_property_decorate = False
                box_BE038.alignment = 'Expand'.upper()
                box_BE038.scale_x = 1.0
                box_BE038.scale_y = 1.0
                box_BE038.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
                row_FFF20 = box_BE038.row(heading='', align=False)
                row_FFF20.alert = False
                row_FFF20.enabled = True
                row_FFF20.active = True
                row_FFF20.use_property_split = False
                row_FFF20.use_property_decorate = False
                row_FFF20.scale_x = 1.0
                row_FFF20.scale_y = 1.0
                row_FFF20.alignment = 'Expand'.upper()
                row_FFF20.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
                row_FFF20.label(text='Live Color', icon_value=0)
                row_FFF20.prop(bpy.context.scene, 'sna_livecolor_switch', text='', icon_value=0, emboss=True, invert_checkbox=True)
                if (bpy.context.scene.sna_livecolor_switch == (bpy.context.scene.sna_livecolor_switch and False)):
                    col_894D2 = box_BE038.column(heading='', align=False)
                    col_894D2.alert = False
                    col_894D2.enabled = True
                    col_894D2.active = True
                    col_894D2.use_property_split = False
                    col_894D2.use_property_decorate = False
                    col_894D2.scale_x = 1.0
                    col_894D2.scale_y = 1.0
                    col_894D2.alignment = 'Expand'.upper()
                    col_894D2.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
                    row_ADC20 = col_894D2.row(heading='', align=True)
                    row_ADC20.alert = False
                    row_ADC20.enabled = True
                    row_ADC20.active = True
                    row_ADC20.use_property_split = False
                    row_ADC20.use_property_decorate = False
                    row_ADC20.scale_x = 1.0
                    row_ADC20.scale_y = 1.0
                    row_ADC20.alignment = 'Expand'.upper()
                    row_ADC20.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
                    row_ADC20.prop(bpy.context.scene, 'sna_color01', text='body', icon_value=0, emboss=True)
                    row_ADC20.prop(bpy.context.scene, 'sna_color02', text='face', icon_value=0, emboss=True)
                    row_ADC20.prop(bpy.context.scene, 'sna_color03', text='hair', icon_value=0, emboss=True)
                    row_C0989 = col_894D2.row(heading='', align=True)
                    row_C0989.alert = False
                    row_C0989.enabled = True
                    row_C0989.active = True
                    row_C0989.use_property_split = False
                    row_C0989.use_property_decorate = False
                    row_C0989.scale_x = 1.0
                    row_C0989.scale_y = 1.0
                    row_C0989.alignment = 'Expand'.upper()
                    row_C0989.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
                    row_C0989.prop(bpy.context.scene, 'sna_color04', text='top', icon_value=0, emboss=True)
                    row_C0989.prop(bpy.context.scene, 'sna_color05', text='bot', icon_value=0, emboss=True)
                    row_C0989.prop(bpy.context.scene, 'sna_color06', text='shoes', icon_value=0, emboss=True)
                    row_A0CD4 = col_894D2.row(heading='', align=True)
                    row_A0CD4.alert = False
                    row_A0CD4.enabled = True
                    row_A0CD4.active = True
                    row_A0CD4.use_property_split = False
                    row_A0CD4.use_property_decorate = False
                    row_A0CD4.scale_x = 1.0
                    row_A0CD4.scale_y = 1.0
                    row_A0CD4.alignment = 'Expand'.upper()
                    row_A0CD4.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
                    row_A0CD4.prop(bpy.context.scene, 'sna_color07', text='bra', icon_value=0, emboss=True)
                    row_A0CD4.prop(bpy.context.scene, 'sna_color08', text='pant', icon_value=0, emboss=True)
                    row_A0CD4.prop(bpy.context.scene, 'sna_color09', text='socks', icon_value=0, emboss=True)
                    row_EB965 = col_894D2.row(heading='', align=True)
                    row_EB965.alert = False
                    row_EB965.enabled = True
                    row_EB965.active = True
                    row_EB965.use_property_split = False
                    row_EB965.use_property_decorate = False
                    row_EB965.scale_x = 1.0
                    row_EB965.scale_y = 1.0
                    row_EB965.alignment = 'Expand'.upper()
                    row_EB965.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
                    row_EB965.prop(bpy.context.scene, 'sna_color10', text='AC1', icon_value=0, emboss=True)
                    row_EB965.prop(bpy.context.scene, 'sna_color11', text='AC2', icon_value=0, emboss=True)
                    row_EB965.prop(bpy.context.scene, 'sna_color12', text='AC3', icon_value=0, emboss=True)
                    row_B82E1 = col_894D2.row(heading='', align=True)
                    row_B82E1.alert = False
                    row_B82E1.enabled = True
                    row_B82E1.active = True
                    row_B82E1.use_property_split = False
                    row_B82E1.use_property_decorate = False
                    row_B82E1.scale_x = 1.0
                    row_B82E1.scale_y = 1.0
                    row_B82E1.alignment = 'Expand'.upper()
                    row_B82E1.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
                    row_B82E1.prop(bpy.context.scene, 'sna_color13', text='S1', icon_value=0, emboss=True)
                    row_B82E1.prop(bpy.context.scene, 'sna_color14', text='S2', icon_value=0, emboss=True)
                    row_B82E1.prop(bpy.context.scene, 'sna_color15', text='S3', icon_value=0, emboss=True)
                col_5A874 = box_C4066.column(heading='', align=True)
                col_5A874.alert = False
                col_5A874.enabled = True
                col_5A874.active = True
                col_5A874.use_property_split = False
                col_5A874.use_property_decorate = False
                col_5A874.scale_x = 1.0
                col_5A874.scale_y = 1.0
                col_5A874.alignment = 'Expand'.upper()
                col_5A874.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
                col_5A874.label(text='Auxiliar tex & mat tools!', icon_value=_icons['pink.png'].icon_id)
                box_3B8F3 = col_5A874.box()
                box_3B8F3.alert = False
                box_3B8F3.enabled = True
                box_3B8F3.active = True
                box_3B8F3.use_property_split = False
                box_3B8F3.use_property_decorate = False
                box_3B8F3.alignment = 'Expand'.upper()
                box_3B8F3.scale_x = 1.0
                box_3B8F3.scale_y = 1.100000023841858
                box_3B8F3.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
                row_BF208 = box_3B8F3.row(heading='', align=True)
                row_BF208.alert = False
                row_BF208.enabled = True
                row_BF208.active = True
                row_BF208.use_property_split = False
                row_BF208.use_property_decorate = False
                row_BF208.scale_x = 1.0
                row_BF208.scale_y = 1.0
                row_BF208.alignment = 'Expand'.upper()
                row_BF208.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
                op = row_BF208.operator('sna.fixtex_58db1', text='FIX', icon_value=0, emboss=True, depress=False)
                op = row_BF208.operator('file.find_missing_files', text='FIND', icon_value=0, emboss=True, depress=False)
                op = row_BF208.operator('sna.cleaner_3b364', text='CLEAN', icon_value=0, emboss=True, depress=False)
                box_7BCFD = col_5A874.box()
                box_7BCFD.alert = False
                box_7BCFD.enabled = True
                box_7BCFD.active = True
                box_7BCFD.use_property_split = False
                box_7BCFD.use_property_decorate = False
                box_7BCFD.alignment = 'Expand'.upper()
                box_7BCFD.scale_x = 1.0
                box_7BCFD.scale_y = 1.100000023841858
                box_7BCFD.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
                row_BD8A2 = box_7BCFD.row(heading='', align=True)
                row_BD8A2.alert = False
                row_BD8A2.enabled = True
                row_BD8A2.active = True
                row_BD8A2.use_property_split = False
                row_BD8A2.use_property_decorate = False
                row_BD8A2.scale_x = 1.0
                row_BD8A2.scale_y = 1.0
                row_BD8A2.alignment = 'Expand'.upper()
                row_BD8A2.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
                op = row_BD8A2.operator('sna.multiple_char_01511', text='re:SET', icon_value=0, emboss=True, depress=False)
                row_3B097 = row_BD8A2.row(heading='', align=True)
                row_3B097.alert = False
                row_3B097.enabled = False
                row_3B097.active = False
                row_3B097.use_property_split = False
                row_3B097.use_property_decorate = False
                row_3B097.scale_x = 1.0
                row_3B097.scale_y = 1.0
                row_3B097.alignment = 'Expand'.upper()
                row_3B097.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
                op = row_3B097.operator('sna.lofi_1065c', text='re:Physics', icon_value=0, emboss=True, depress=False)
                if ((eval("str(palette_color_hat_p)") == eval("str(bpy.data.scenes['Scene'].sna_importkkp)")) and ('Koikatsu Full' != bpy.context.scene.sna_select_an_option)):
                    col_3D8D1 = box_C4066.column(heading='', align=False)
                    col_3D8D1.alert = False
                    col_3D8D1.enabled = True
                    col_3D8D1.active = True
                    col_3D8D1.use_property_split = False
                    col_3D8D1.use_property_decorate = False
                    col_3D8D1.scale_x = 1.0
                    col_3D8D1.scale_y = 1.0
                    col_3D8D1.alignment = 'Expand'.upper()
                    col_3D8D1.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
                    col_3D8D1.label(text='Rigify support yohoo!', icon_value=_icons['green.png'].icon_id)
                    box_887C2 = col_3D8D1.box()
                    box_887C2.alert = False
                    box_887C2.enabled = True
                    box_887C2.active = True
                    box_887C2.use_property_split = False
                    box_887C2.use_property_decorate = False
                    box_887C2.alignment = 'Expand'.upper()
                    box_887C2.scale_x = 1.0
                    box_887C2.scale_y = 1.0
                    box_887C2.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
                    row_5180E = box_887C2.row(heading='', align=True)
                    row_5180E.alert = False
                    row_5180E.enabled = ((eval("str(palette_color_hat_p)") == eval("str(bpy.data.scenes['Scene'].sna_importkkp)")) and ('Koikatsu Full' != bpy.context.scene.sna_select_an_option))
                    row_5180E.active = ((eval("str(palette_color_hat_p)") == eval("str(bpy.data.scenes['Scene'].sna_importkkp)")) and ('Koikatsu Full' != bpy.context.scene.sna_select_an_option))
                    row_5180E.use_property_split = False
                    row_5180E.use_property_decorate = False
                    row_5180E.scale_x = 1.0
                    row_5180E.scale_y = 1.100000023841858
                    row_5180E.alignment = 'Expand'.upper()
                    row_5180E.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
                    op = row_5180E.operator('arp.quick_import_mapping', text='Import Profile', icon_value=0, emboss=((eval("str(palette_color_hat_p)") == eval("str(bpy.data.scenes['Scene'].sna_importkkp)")) and ('Koikatsu Full' != bpy.context.scene.sna_select_an_option)), depress=False)
                    op = row_5180E.operator('arp.quick_make_rig', text='SET RIG', icon_value=0, emboss=((eval("str(palette_color_hat_p)") == eval("str(bpy.data.scenes['Scene'].sna_importkkp)")) and ('Koikatsu Full' != bpy.context.scene.sna_select_an_option)), depress=False)
                    op.mode = 'PRESERVE'
                    op.remove_root = False
        if ((eval("str(palette_color_hat_p)") == eval("str(bpy.data.scenes['Scene'].sna_importkkp)")) and ('Koikatsu Full' != bpy.context.scene.sna_select_an_option)):
            col_5401B = col_5AC37.column(heading='', align=False)
            col_5401B.alert = False
            col_5401B.enabled = True
            col_5401B.active = True
            col_5401B.use_property_split = False
            col_5401B.use_property_decorate = False
            col_5401B.scale_x = 1.0
            col_5401B.scale_y = 1.0
            col_5401B.alignment = 'Expand'.upper()
            col_5401B.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
            layout_function = col_5401B
            sna_skyvox_C1AFB(layout_function, )
        box_23DCE = col_5AC37.box()
        box_23DCE.alert = False
        box_23DCE.enabled = True
        box_23DCE.active = True
        box_23DCE.use_property_split = False
        box_23DCE.use_property_decorate = False
        box_23DCE.alignment = 'Expand'.upper()
        box_23DCE.scale_x = 1.0
        box_23DCE.scale_y = 1.0
        box_23DCE.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
        if (bpy.context.scene.sna_select_an_option == 'SKLX Full'):
            pass
        else:
            if ((eval("str(palette_color_hat_p)") == eval("str(bpy.data.scenes['Scene'].sna_importkkp)")) and ('Koikatsu Full' != bpy.context.scene.sna_select_an_option)):
                pass
            else:
                row_9D0DE = box_23DCE.row(heading='', align=True)
                row_9D0DE.alert = True
                row_9D0DE.enabled = True
                row_9D0DE.active = True
                row_9D0DE.use_property_split = False
                row_9D0DE.use_property_decorate = False
                row_9D0DE.scale_x = 1.0
                row_9D0DE.scale_y = 1.0
                row_9D0DE.alignment = 'Center'.upper()
                row_9D0DE.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
                row_9D0DE.label(text='Super Creator Tools on Patreon!', icon_value=_icons['heart.png'].icon_id)
        if (bpy.context.scene.sna_select_an_option == 'Koikatsu Party'):
            pass
        box_23DCE.prop(bpy.context.scene, 'sna_importkkp', text='user-pass', icon_value=0, emboss=True)


def register():
    global _icons
    _icons = bpy.utils.previews.new()
    bpy.types.Scene.sna_select_an_option = bpy.props.EnumProperty(name='Select an option', description='', items=sna_select_an_option_enum_items)
    bpy.types.Scene.sna_select_mode = bpy.props.EnumProperty(name='Select Mode', description='', items=sna_select_mode_enum_items)
    bpy.types.Scene.sna_livecolor_switch = bpy.props.BoolProperty(name='live-color switch', description='enable for see what are the loaded colors from game', default=True)
    bpy.types.Scene.sna_color01 = bpy.props.FloatVectorProperty(name='Color-01', description='', size=4, default=(1.0, 0.0, 1.0, 0.8999999761581421), subtype='COLOR', unit='NONE', min=0.0, max=1.0, step=3, precision=6)
    bpy.types.Scene.sna_color02 = bpy.props.FloatVectorProperty(name='Color-02', description='', size=4, default=(1.0, 0.0, 1.0, 1.0), subtype='COLOR', unit='NONE', min=0.0, max=1.0, step=3, precision=6)
    bpy.types.Scene.sna_color03 = bpy.props.FloatVectorProperty(name='Color-03', description='', size=4, default=(1.0, 0.0, 1.0, 1.0), subtype='COLOR', unit='NONE', min=0.0, max=1.0, step=3, precision=6)
    bpy.types.Scene.sna_color04 = bpy.props.FloatVectorProperty(name='Color-04', description='', size=4, default=(1.0, 0.0, 1.0, 1.0), subtype='COLOR', unit='NONE', min=0.0, max=1.0, step=3, precision=6)
    bpy.types.Scene.sna_color05 = bpy.props.FloatVectorProperty(name='Color-05', description='', size=4, default=(1.0, 0.0, 1.0, 1.0), subtype='COLOR', unit='NONE', min=0.0, max=1.0, step=3, precision=6)
    bpy.types.Scene.sna_color06 = bpy.props.FloatVectorProperty(name='Color-06', description='', size=4, default=(1.0, 0.0, 1.0, 1.0), subtype='COLOR', unit='NONE', min=0.0, max=1.0, step=3, precision=6)
    bpy.types.Scene.sna_color07 = bpy.props.FloatVectorProperty(name='Color-07', description='', size=4, default=(1.0, 0.0, 1.0, 1.0), subtype='COLOR', unit='NONE', min=0.0, max=1.0, step=3, precision=6)
    bpy.types.Scene.sna_color08 = bpy.props.FloatVectorProperty(name='Color-08', description='', size=4, default=(1.0, 0.0, 1.0, 1.0), subtype='COLOR', unit='NONE', min=0.0, max=1.0, step=3, precision=6)
    bpy.types.Scene.sna_color09 = bpy.props.FloatVectorProperty(name='Color-09', description='', size=4, default=(1.0, 0.0, 1.0, 1.0), subtype='COLOR', unit='NONE', min=0.0, max=1.0, step=3, precision=6)
    bpy.types.Scene.sna_color10 = bpy.props.FloatVectorProperty(name='Color-10', description='', size=4, default=(1.0, 0.0, 1.0, 1.0), subtype='COLOR', unit='NONE', min=0.0, max=1.0, step=3, precision=6)
    bpy.types.Scene.sna_color11 = bpy.props.FloatVectorProperty(name='Color-11', description='', size=4, default=(1.0, 0.0, 1.0, 1.0), subtype='COLOR', unit='NONE', min=0.0, max=1.0, step=3, precision=6)
    bpy.types.Scene.sna_color12 = bpy.props.FloatVectorProperty(name='Color-12', description='', size=4, default=(1.0, 0.0, 1.0, 1.0), subtype='COLOR', unit='NONE', min=0.0, max=1.0, step=3, precision=6)
    bpy.types.Scene.sna_color13 = bpy.props.FloatVectorProperty(name='Color-13', description='', size=4, default=(1.0, 0.0, 1.0, 1.0), subtype='COLOR', unit='NONE', min=0.0, max=1.0, step=3, precision=6)
    bpy.types.Scene.sna_color14 = bpy.props.FloatVectorProperty(name='Color-14', description='', size=4, default=(1.0, 0.0, 1.0, 1.0), subtype='COLOR', unit='NONE', min=0.0, max=1.0, step=3, precision=6)
    bpy.types.Scene.sna_color15 = bpy.props.FloatVectorProperty(name='Color-15', description='', size=4, default=(1.0, 0.0, 1.0, 1.0), subtype='COLOR', unit='NONE', min=0.0, max=1.0, step=3, precision=6)
    bpy.types.Scene.sna_hdriselect = bpy.props.EnumProperty(name='HDRI-Select', description='', items=sna_hdriselect_enum_items)
    bpy.types.Scene.sna_render_select = bpy.props.BoolProperty(name='render select', description='', default=True, update=sna_update_sna_render_select_8C133)
    bpy.types.Scene.sna_importkkp = bpy.props.StringProperty(name='Import-KKP', description='access to Super Creator Tools', default='', subtype='PASSWORD', maxlen=80)
    bpy.types.Scene.sna_importkks = bpy.props.StringProperty(name='Import-KKS', description='', default='', subtype='PASSWORD', maxlen=80)
    bpy.types.Scene.sna_importec = bpy.props.StringProperty(name='Import-EC', description='', default='', subtype='PASSWORD', maxlen=80)
    bpy.types.Scene.sna_imporths = bpy.props.StringProperty(name='Import-HS', description='', default='', subtype='PASSWORD', maxlen=80, update=sna_update_sna_imporths_5A34A)
    bpy.types.Scene.sna_imporths2 = bpy.props.StringProperty(name='Import-HS2', description='', default='', subtype='PASSWORD', maxlen=80)
    bpy.types.Scene.sna_importais = bpy.props.StringProperty(name='Import-AIS', description='', default='', subtype='PASSWORD', maxlen=80)
    bpy.types.Scene.sna_importph = bpy.props.StringProperty(name='Import-PH', description='', default='', subtype='PASSWORD', maxlen=80)
    bpy.types.Scene.sna_importrg = bpy.props.StringProperty(name='Import-RG', description='', default='', subtype='PASSWORD', maxlen=80)
    bpy.types.Scene.sna_patrons = bpy.props.IntProperty(name='Patrons', description='', default=5, subtype='NONE')
    bpy.types.Scene.sna_patronsb = bpy.props.IntProperty(name='Patrons-B', description='', default=28, subtype='NONE')
    bpy.types.Scene.sna_charaselect = bpy.props.PointerProperty(name='Chara-Select', description='Select your character Armature', type=bpy.types.Object)
    bpy.types.Scene.sna_animselect = bpy.props.PointerProperty(name='Anim-Select', description='Select your animation Armature', type=bpy.types.Object)
    bpy.types.Scene.sna_charanamehere = bpy.props.StringProperty(name='Chara-Name-Here', description='Insert your character name here :)', default='', subtype='NONE', maxlen=0)
    bpy.utils.register_class(SNA_OT_Aisappenddata_E9553)
    bpy.utils.register_class(SNA_OT_Animswapper_60950)
    bpy.utils.register_class(SNA_OT_Ecdataappend_E5571)
    bpy.utils.register_class(SNA_OT_Hdriworld_A4D8C)
    bpy.utils.register_class(SNA_OT_Hdrinon_3Ade4)
    bpy.utils.register_class(SNA_OT_Setilight_Cb95F)
    bpy.utils.register_class(SNA_OT_Ibaker_Db364)
    bpy.utils.register_class(SNA_OT_Unbaker_Eefe0)
    bpy.utils.register_class(SNA_OT_Hsappenddata_E2120)
    bpy.utils.register_class(SNA_OT_Hs1Face_091B8)
    bpy.utils.register_class(SNA_OT_Hs1Body_8Befd)
    bpy.utils.register_class(SNA_OT_Hs1Top_Cd510)
    bpy.utils.register_class(SNA_OT_Hs1Bot_A2C63)
    bpy.utils.register_class(SNA_OT_Hs1Fit_Bb512)
    bpy.utils.register_class(SNA_OT_Hs1Shoes_1C954)
    bpy.utils.register_class(SNA_OT_Hs1Accs_81340)
    bpy.utils.register_class(SNA_OT_Hs1Simple_D9F66)
    bpy.utils.register_class(SNA_OT_Hs1Hair_9D604)
    bpy.utils.register_class(SNA_OT_Hs1Bra_Dafef)
    bpy.utils.register_class(SNA_OT_Hs1Panties_F51B5)
    bpy.utils.register_class(SNA_OT_Hs1Socks_A2F22)
    bpy.utils.register_class(SNA_OT_Hs2Appenddata_4F4D0)
    bpy.utils.register_class(SNA_OT_Hs2Facemanual_6429F)
    bpy.utils.register_class(SNA_OT_Hs2Bodymanual_232Ed)
    bpy.utils.register_class(SNA_OT_Hs2Hairmanual_C5C88)
    bpy.utils.register_class(SNA_OT_Hs2Topmanual_E0F0E)
    bpy.utils.register_class(SNA_OT_Hs2Botmanual_D9F93)
    bpy.utils.register_class(SNA_OT_Hs2Innermanual_665D4)
    bpy.utils.register_class(SNA_OT_Hs2Pantiesmanual_Dab9C)
    bpy.utils.register_class(SNA_OT_Hs2Socksmanual_85526)
    bpy.utils.register_class(SNA_OT_Hs2Shoesmanual_8B32C)
    bpy.utils.register_class(SNA_OT_Hs2Accsmanual_07554)
    bpy.utils.register_class(SNA_OT_Hs2Simplemanual_425F7)
    bpy.utils.register_class(SNA_OT_Hs2Bramanual_129Df)
    bpy.utils.register_class(SNA_OT_Kkpappenddata_B9B14)
    bpy.utils.register_class(SNA_OT_Animeoutline_D89C9)
    bpy.utils.register_class(SNA_OT_Kkptop_08379)
    bpy.utils.register_class(SNA_OT_Kkpsimple_C0011)
    bpy.utils.register_class(SNA_OT_Kkpbot_9E279)
    bpy.utils.register_class(SNA_OT_Kkpbra_3E2Db)
    bpy.utils.register_class(SNA_OT_Kkppanties_B34Cf)
    bpy.utils.register_class(SNA_OT_Kkpshoes_Ec253)
    bpy.utils.register_class(SNA_OT_Kkpaccs_8314B)
    bpy.utils.register_class(SNA_OT_Kkpsocks_0D912)
    bpy.utils.register_class(SNA_OT_Kkpface_E438D)
    bpy.utils.register_class(SNA_OT_Kkpinner_8A572)
    bpy.utils.register_class(SNA_OT_Kkphairb_03315)
    bpy.utils.register_class(SNA_OT_Kkpbody_609D4)
    bpy.utils.register_class(SNA_OT_Kksappenddata_59897)
    if not 'koi-party.png' in _icons: _icons.load('koi-party.png', os.path.join(os.path.dirname(__file__), 'icons', 'koi-party.png'), "IMAGE")
    if not 'koi-sunshine.png' in _icons: _icons.load('koi-sunshine.png', os.path.join(os.path.dirname(__file__), 'icons', 'koi-sunshine.png'), "IMAGE")
    if not 'e-creators.png' in _icons: _icons.load('e-creators.png', os.path.join(os.path.dirname(__file__), 'icons', 'e-creators.png'), "IMAGE")
    if not 'h-select.png' in _icons: _icons.load('h-select.png', os.path.join(os.path.dirname(__file__), 'icons', 'h-select.png'), "IMAGE")
    if not 'h-select-2.png' in _icons: _icons.load('h-select-2.png', os.path.join(os.path.dirname(__file__), 'icons', 'h-select-2.png'), "IMAGE")
    if not 'ai-shoujo.png' in _icons: _icons.load('ai-shoujo.png', os.path.join(os.path.dirname(__file__), 'icons', 'ai-shoujo.png'), "IMAGE")
    if not 'play-home.png' in _icons: _icons.load('play-home.png', os.path.join(os.path.dirname(__file__), 'icons', 'play-home.png'), "IMAGE")
    if not 'room-girl.png' in _icons: _icons.load('room-girl.png', os.path.join(os.path.dirname(__file__), 'icons', 'room-girl.png'), "IMAGE")
    if not 'red.png' in _icons: _icons.load('red.png', os.path.join(os.path.dirname(__file__), 'icons', 'red.png'), "IMAGE")
    bpy.utils.register_class(SNA_OT_Fixbone_07975)
    bpy.utils.register_class(SNA_OT_Setanim_64953)
    bpy.utils.register_class(SNA_OT_Phappenddata_81459)
    bpy.utils.register_class(SNA_OT_Rgappenddata_Bf1E1)
    if not 'cards.png' in _icons: _icons.load('cards.png', os.path.join(os.path.dirname(__file__), 'icons', 'cards.png'), "IMAGE")
    bpy.utils.register_class(SNA_OT_Character_Saver_42Da3)
    bpy.utils.register_class(SNA_PT_SAVE_SKLX_CARD_27F62)
    bpy.utils.register_class(SNA_OT_What_Is_A_Sklx_Card_895Df)
    bpy.utils.register_class(SNA_PT_SUPPORTERS__ARTISTS_C55A5)
    if not 'pfp_001.png' in _icons: _icons.load('pfp_001.png', os.path.join(os.path.dirname(__file__), 'icons', 'pfp_001.png'), "IMAGE")
    if not 'pfp_004.png' in _icons: _icons.load('pfp_004.png', os.path.join(os.path.dirname(__file__), 'icons', 'pfp_004.png'), "IMAGE")
    if not 'pfp_007.png' in _icons: _icons.load('pfp_007.png', os.path.join(os.path.dirname(__file__), 'icons', 'pfp_007.png'), "IMAGE")
    if not 'pfp_010.png' in _icons: _icons.load('pfp_010.png', os.path.join(os.path.dirname(__file__), 'icons', 'pfp_010.png'), "IMAGE")
    if not 'pfp_013.png' in _icons: _icons.load('pfp_013.png', os.path.join(os.path.dirname(__file__), 'icons', 'pfp_013.png'), "IMAGE")
    if not 'pfp_016.png' in _icons: _icons.load('pfp_016.png', os.path.join(os.path.dirname(__file__), 'icons', 'pfp_016.png'), "IMAGE")
    if not 'pfp_002.png' in _icons: _icons.load('pfp_002.png', os.path.join(os.path.dirname(__file__), 'icons', 'pfp_002.png'), "IMAGE")
    if not 'pfp_005.png' in _icons: _icons.load('pfp_005.png', os.path.join(os.path.dirname(__file__), 'icons', 'pfp_005.png'), "IMAGE")
    if not 'pfp_008.png' in _icons: _icons.load('pfp_008.png', os.path.join(os.path.dirname(__file__), 'icons', 'pfp_008.png'), "IMAGE")
    if not 'pfp_011.png' in _icons: _icons.load('pfp_011.png', os.path.join(os.path.dirname(__file__), 'icons', 'pfp_011.png'), "IMAGE")
    if not 'pfp_014.png' in _icons: _icons.load('pfp_014.png', os.path.join(os.path.dirname(__file__), 'icons', 'pfp_014.png'), "IMAGE")
    if not 'pfp_017.png' in _icons: _icons.load('pfp_017.png', os.path.join(os.path.dirname(__file__), 'icons', 'pfp_017.png'), "IMAGE")
    if not 'pfp_003.png' in _icons: _icons.load('pfp_003.png', os.path.join(os.path.dirname(__file__), 'icons', 'pfp_003.png'), "IMAGE")
    if not 'pfp_006.png' in _icons: _icons.load('pfp_006.png', os.path.join(os.path.dirname(__file__), 'icons', 'pfp_006.png'), "IMAGE")
    if not 'pfp_009.png' in _icons: _icons.load('pfp_009.png', os.path.join(os.path.dirname(__file__), 'icons', 'pfp_009.png'), "IMAGE")
    if not 'pfp_012.png' in _icons: _icons.load('pfp_012.png', os.path.join(os.path.dirname(__file__), 'icons', 'pfp_012.png'), "IMAGE")
    if not 'pfp_015.png' in _icons: _icons.load('pfp_015.png', os.path.join(os.path.dirname(__file__), 'icons', 'pfp_015.png'), "IMAGE")
    if not 'pfp_018.png' in _icons: _icons.load('pfp_018.png', os.path.join(os.path.dirname(__file__), 'icons', 'pfp_018.png'), "IMAGE")
    if not 'sfp_001.png' in _icons: _icons.load('sfp_001.png', os.path.join(os.path.dirname(__file__), 'icons', 'sfp_001.png'), "IMAGE")
    if not 'sfp_004.png' in _icons: _icons.load('sfp_004.png', os.path.join(os.path.dirname(__file__), 'icons', 'sfp_004.png'), "IMAGE")
    if not 'sfp_007.png' in _icons: _icons.load('sfp_007.png', os.path.join(os.path.dirname(__file__), 'icons', 'sfp_007.png'), "IMAGE")
    if not 'sfp_010.png' in _icons: _icons.load('sfp_010.png', os.path.join(os.path.dirname(__file__), 'icons', 'sfp_010.png'), "IMAGE")
    if not 'sfp_013.png' in _icons: _icons.load('sfp_013.png', os.path.join(os.path.dirname(__file__), 'icons', 'sfp_013.png'), "IMAGE")
    if not 'sfp_016.png' in _icons: _icons.load('sfp_016.png', os.path.join(os.path.dirname(__file__), 'icons', 'sfp_016.png'), "IMAGE")
    if not 'sfp_019.png' in _icons: _icons.load('sfp_019.png', os.path.join(os.path.dirname(__file__), 'icons', 'sfp_019.png'), "IMAGE")
    if not 'sfp_022.png' in _icons: _icons.load('sfp_022.png', os.path.join(os.path.dirname(__file__), 'icons', 'sfp_022.png'), "IMAGE")
    if not 'sfp_025.png' in _icons: _icons.load('sfp_025.png', os.path.join(os.path.dirname(__file__), 'icons', 'sfp_025.png'), "IMAGE")
    if not 'sfp_028.png' in _icons: _icons.load('sfp_028.png', os.path.join(os.path.dirname(__file__), 'icons', 'sfp_028.png'), "IMAGE")
    if not 'sfp_002.png' in _icons: _icons.load('sfp_002.png', os.path.join(os.path.dirname(__file__), 'icons', 'sfp_002.png'), "IMAGE")
    if not 'sfp_005.png' in _icons: _icons.load('sfp_005.png', os.path.join(os.path.dirname(__file__), 'icons', 'sfp_005.png'), "IMAGE")
    if not 'sfp_008.png' in _icons: _icons.load('sfp_008.png', os.path.join(os.path.dirname(__file__), 'icons', 'sfp_008.png'), "IMAGE")
    if not 'sfp_011.png' in _icons: _icons.load('sfp_011.png', os.path.join(os.path.dirname(__file__), 'icons', 'sfp_011.png'), "IMAGE")
    if not 'sfp_014.png' in _icons: _icons.load('sfp_014.png', os.path.join(os.path.dirname(__file__), 'icons', 'sfp_014.png'), "IMAGE")
    if not 'sfp_017.png' in _icons: _icons.load('sfp_017.png', os.path.join(os.path.dirname(__file__), 'icons', 'sfp_017.png'), "IMAGE")
    if not 'sfp_020.png' in _icons: _icons.load('sfp_020.png', os.path.join(os.path.dirname(__file__), 'icons', 'sfp_020.png'), "IMAGE")
    if not 'sfp_023.png' in _icons: _icons.load('sfp_023.png', os.path.join(os.path.dirname(__file__), 'icons', 'sfp_023.png'), "IMAGE")
    if not 'sfp_026.png' in _icons: _icons.load('sfp_026.png', os.path.join(os.path.dirname(__file__), 'icons', 'sfp_026.png'), "IMAGE")
    if not 'sfp_029.png' in _icons: _icons.load('sfp_029.png', os.path.join(os.path.dirname(__file__), 'icons', 'sfp_029.png'), "IMAGE")
    if not 'sfp_003.png' in _icons: _icons.load('sfp_003.png', os.path.join(os.path.dirname(__file__), 'icons', 'sfp_003.png'), "IMAGE")
    if not 'sfp_006.png' in _icons: _icons.load('sfp_006.png', os.path.join(os.path.dirname(__file__), 'icons', 'sfp_006.png'), "IMAGE")
    if not 'sfp_009.png' in _icons: _icons.load('sfp_009.png', os.path.join(os.path.dirname(__file__), 'icons', 'sfp_009.png'), "IMAGE")
    if not 'sfp_012.png' in _icons: _icons.load('sfp_012.png', os.path.join(os.path.dirname(__file__), 'icons', 'sfp_012.png'), "IMAGE")
    if not 'sfp_015.png' in _icons: _icons.load('sfp_015.png', os.path.join(os.path.dirname(__file__), 'icons', 'sfp_015.png'), "IMAGE")
    if not 'sfp_018.png' in _icons: _icons.load('sfp_018.png', os.path.join(os.path.dirname(__file__), 'icons', 'sfp_018.png'), "IMAGE")
    if not 'sfp_021.png' in _icons: _icons.load('sfp_021.png', os.path.join(os.path.dirname(__file__), 'icons', 'sfp_021.png'), "IMAGE")
    if not 'sfp_024.png' in _icons: _icons.load('sfp_024.png', os.path.join(os.path.dirname(__file__), 'icons', 'sfp_024.png'), "IMAGE")
    if not 'sfp_027.png' in _icons: _icons.load('sfp_027.png', os.path.join(os.path.dirname(__file__), 'icons', 'sfp_027.png'), "IMAGE")
    if not 'sfp_030.png' in _icons: _icons.load('sfp_030.png', os.path.join(os.path.dirname(__file__), 'icons', 'sfp_030.png'), "IMAGE")
    if not 'winner-pic.png' in _icons: _icons.load('winner-pic.png', os.path.join(os.path.dirname(__file__), 'icons', 'winner-pic.png'), "IMAGE")
    if not 'discord1.png' in _icons: _icons.load('discord1.png', os.path.join(os.path.dirname(__file__), 'icons', 'discord1.png'), "IMAGE")
    bpy.utils.register_class(SNA_OT_Subs_Two_0850E)
    bpy.utils.register_class(SNA_OT_Custom_Semi_A6864)
    bpy.utils.register_class(SNA_OT_Sub_002_879A2)
    bpy.utils.register_class(SNA_OT_Become_F266B)
    bpy.utils.register_class(SNA_OT_Patreon_Restarter_88Dcb)
    bpy.utils.register_class(SNA_OT_Discord_Server_E1F55)
    bpy.utils.register_class(SNA_OT_Sub_006_E0438)
    bpy.utils.register_class(SNA_OT_Sub_007_C99Ea)
    bpy.utils.register_class(SNA_OT_Sub_008_43C1A)
    bpy.utils.register_class(SNA_OT_Sub_009_F902C)
    bpy.utils.register_class(SNA_OT_Sub_010_E9Fb5)
    bpy.utils.register_class(SNA_OT_Sub_011_25D52)
    bpy.utils.register_class(SNA_OT_Sub_012_73536)
    bpy.utils.register_class(SNA_OT_Sub_013_9Ed57)
    bpy.utils.register_class(SNA_OT_Sub_014_0C26E)
    bpy.utils.register_class(SNA_OT_Sub_015_0Ebd0)
    bpy.utils.register_class(SNA_OT_Sub_018_150Aa)
    bpy.utils.register_class(SNA_OT_Sub_017_B4953)
    bpy.utils.register_class(SNA_OT_Sub_016_1Dcf9)
    bpy.utils.register_class(SNA_OT_Sub_003_38Df0)
    bpy.utils.register_class(SNA_OT_Gallery_2Defc)
    bpy.utils.register_class(SNA_OT_Custom_Jap_Let_0F56E)
    bpy.utils.register_class(SNA_OT_Custom_Sora_63A72)
    bpy.utils.register_class(SNA_OT_Sub_001_5E1F9)
    bpy.utils.register_class(SNA_OT_Sub_004_6Ecc8)
    bpy.utils.register_class(SNA_OT_Sub_005_6A346)
    if not 'HDRI-1.jpg' in _icons: _icons.load('HDRI-1.jpg', os.path.join(os.path.dirname(__file__), 'icons', 'HDRI-1.jpg'), "IMAGE")
    if not 'HDRI-2.jpg' in _icons: _icons.load('HDRI-2.jpg', os.path.join(os.path.dirname(__file__), 'icons', 'HDRI-2.jpg'), "IMAGE")
    if not 'HDRI-3.jpg' in _icons: _icons.load('HDRI-3.jpg', os.path.join(os.path.dirname(__file__), 'icons', 'HDRI-3.jpg'), "IMAGE")
    if not 'HDRI-4.jpg' in _icons: _icons.load('HDRI-4.jpg', os.path.join(os.path.dirname(__file__), 'icons', 'HDRI-4.jpg'), "IMAGE")
    if not 'HDRI-5.jpg' in _icons: _icons.load('HDRI-5.jpg', os.path.join(os.path.dirname(__file__), 'icons', 'HDRI-5.jpg'), "IMAGE")
    if not 'HDRI-6.jpg' in _icons: _icons.load('HDRI-6.jpg', os.path.join(os.path.dirname(__file__), 'icons', 'HDRI-6.jpg'), "IMAGE")
    if not 'HDRI-7.jpg' in _icons: _icons.load('HDRI-7.jpg', os.path.join(os.path.dirname(__file__), 'icons', 'HDRI-7.jpg'), "IMAGE")
    if not 'HDRI-8.jpg' in _icons: _icons.load('HDRI-8.jpg', os.path.join(os.path.dirname(__file__), 'icons', 'HDRI-8.jpg'), "IMAGE")
    if not 'HDRI-9.jpg' in _icons: _icons.load('HDRI-9.jpg', os.path.join(os.path.dirname(__file__), 'icons', 'HDRI-9.jpg'), "IMAGE")
    if not 'HDRI-10.jpg' in _icons: _icons.load('HDRI-10.jpg', os.path.join(os.path.dirname(__file__), 'icons', 'HDRI-10.jpg'), "IMAGE")
    if not 'no-hdri.jpg' in _icons: _icons.load('no-hdri.jpg', os.path.join(os.path.dirname(__file__), 'icons', 'no-hdri.jpg'), "IMAGE")
    if not 'skyvox.png' in _icons: _icons.load('skyvox.png', os.path.join(os.path.dirname(__file__), 'icons', 'skyvox.png'), "IMAGE")
    bpy.utils.register_class(SNA_OT_Cleaner_3B364)
    bpy.utils.register_class(SNA_OT_Fixtex_58Db1)
    bpy.utils.register_class(SNA_OT_Multiple_Char_01511)
    bpy.utils.register_class(SNA_OT_Lofi_1065C)
    bpy.utils.register_class(SNA_PT_SKLXCREATOR_EF7CA)
    if not 'togax256.png' in _icons: _icons.load('togax256.png', os.path.join(os.path.dirname(__file__), 'icons', 'togax256.png'), "IMAGE")
    if not 'blue.png' in _icons: _icons.load('blue.png', os.path.join(os.path.dirname(__file__), 'icons', 'blue.png'), "IMAGE")
    if not 'yellow.png' in _icons: _icons.load('yellow.png', os.path.join(os.path.dirname(__file__), 'icons', 'yellow.png'), "IMAGE")
    if not 'pink.png' in _icons: _icons.load('pink.png', os.path.join(os.path.dirname(__file__), 'icons', 'pink.png'), "IMAGE")
    if not 'green.png' in _icons: _icons.load('green.png', os.path.join(os.path.dirname(__file__), 'icons', 'green.png'), "IMAGE")
    if not 'heart.png' in _icons: _icons.load('heart.png', os.path.join(os.path.dirname(__file__), 'icons', 'heart.png'), "IMAGE")


def unregister():
    global _icons
    bpy.utils.previews.remove(_icons)
    wm = bpy.context.window_manager
    kc = wm.keyconfigs.addon
    for km, kmi in addon_keymaps.values():
        km.keymap_items.remove(kmi)
    addon_keymaps.clear()
    del bpy.types.Scene.sna_charanamehere
    del bpy.types.Scene.sna_animselect
    del bpy.types.Scene.sna_charaselect
    del bpy.types.Scene.sna_patronsb
    del bpy.types.Scene.sna_patrons
    del bpy.types.Scene.sna_importrg
    del bpy.types.Scene.sna_importph
    del bpy.types.Scene.sna_importais
    del bpy.types.Scene.sna_imporths2
    del bpy.types.Scene.sna_imporths
    del bpy.types.Scene.sna_importec
    del bpy.types.Scene.sna_importkks
    del bpy.types.Scene.sna_importkkp
    del bpy.types.Scene.sna_render_select
    del bpy.types.Scene.sna_hdriselect
    del bpy.types.Scene.sna_color15
    del bpy.types.Scene.sna_color14
    del bpy.types.Scene.sna_color13
    del bpy.types.Scene.sna_color12
    del bpy.types.Scene.sna_color11
    del bpy.types.Scene.sna_color10
    del bpy.types.Scene.sna_color09
    del bpy.types.Scene.sna_color08
    del bpy.types.Scene.sna_color07
    del bpy.types.Scene.sna_color06
    del bpy.types.Scene.sna_color05
    del bpy.types.Scene.sna_color04
    del bpy.types.Scene.sna_color03
    del bpy.types.Scene.sna_color02
    del bpy.types.Scene.sna_color01
    del bpy.types.Scene.sna_livecolor_switch
    del bpy.types.Scene.sna_select_mode
    del bpy.types.Scene.sna_select_an_option
    bpy.utils.unregister_class(SNA_OT_Aisappenddata_E9553)
    bpy.utils.unregister_class(SNA_OT_Animswapper_60950)
    bpy.utils.unregister_class(SNA_OT_Ecdataappend_E5571)
    bpy.utils.unregister_class(SNA_OT_Hdriworld_A4D8C)
    bpy.utils.unregister_class(SNA_OT_Hdrinon_3Ade4)
    bpy.utils.unregister_class(SNA_OT_Setilight_Cb95F)
    bpy.utils.unregister_class(SNA_OT_Ibaker_Db364)
    bpy.utils.unregister_class(SNA_OT_Unbaker_Eefe0)
    bpy.utils.unregister_class(SNA_OT_Hsappenddata_E2120)
    bpy.utils.unregister_class(SNA_OT_Hs1Face_091B8)
    bpy.utils.unregister_class(SNA_OT_Hs1Body_8Befd)
    bpy.utils.unregister_class(SNA_OT_Hs1Top_Cd510)
    bpy.utils.unregister_class(SNA_OT_Hs1Bot_A2C63)
    bpy.utils.unregister_class(SNA_OT_Hs1Fit_Bb512)
    bpy.utils.unregister_class(SNA_OT_Hs1Shoes_1C954)
    bpy.utils.unregister_class(SNA_OT_Hs1Accs_81340)
    bpy.utils.unregister_class(SNA_OT_Hs1Simple_D9F66)
    bpy.utils.unregister_class(SNA_OT_Hs1Hair_9D604)
    bpy.utils.unregister_class(SNA_OT_Hs1Bra_Dafef)
    bpy.utils.unregister_class(SNA_OT_Hs1Panties_F51B5)
    bpy.utils.unregister_class(SNA_OT_Hs1Socks_A2F22)
    bpy.utils.unregister_class(SNA_OT_Hs2Appenddata_4F4D0)
    bpy.utils.unregister_class(SNA_OT_Hs2Facemanual_6429F)
    bpy.utils.unregister_class(SNA_OT_Hs2Bodymanual_232Ed)
    bpy.utils.unregister_class(SNA_OT_Hs2Hairmanual_C5C88)
    bpy.utils.unregister_class(SNA_OT_Hs2Topmanual_E0F0E)
    bpy.utils.unregister_class(SNA_OT_Hs2Botmanual_D9F93)
    bpy.utils.unregister_class(SNA_OT_Hs2Innermanual_665D4)
    bpy.utils.unregister_class(SNA_OT_Hs2Pantiesmanual_Dab9C)
    bpy.utils.unregister_class(SNA_OT_Hs2Socksmanual_85526)
    bpy.utils.unregister_class(SNA_OT_Hs2Shoesmanual_8B32C)
    bpy.utils.unregister_class(SNA_OT_Hs2Accsmanual_07554)
    bpy.utils.unregister_class(SNA_OT_Hs2Simplemanual_425F7)
    bpy.utils.unregister_class(SNA_OT_Hs2Bramanual_129Df)
    bpy.utils.unregister_class(SNA_OT_Kkpappenddata_B9B14)
    bpy.utils.unregister_class(SNA_OT_Animeoutline_D89C9)
    bpy.utils.unregister_class(SNA_OT_Kkptop_08379)
    bpy.utils.unregister_class(SNA_OT_Kkpsimple_C0011)
    bpy.utils.unregister_class(SNA_OT_Kkpbot_9E279)
    bpy.utils.unregister_class(SNA_OT_Kkpbra_3E2Db)
    bpy.utils.unregister_class(SNA_OT_Kkppanties_B34Cf)
    bpy.utils.unregister_class(SNA_OT_Kkpshoes_Ec253)
    bpy.utils.unregister_class(SNA_OT_Kkpaccs_8314B)
    bpy.utils.unregister_class(SNA_OT_Kkpsocks_0D912)
    bpy.utils.unregister_class(SNA_OT_Kkpface_E438D)
    bpy.utils.unregister_class(SNA_OT_Kkpinner_8A572)
    bpy.utils.unregister_class(SNA_OT_Kkphairb_03315)
    bpy.utils.unregister_class(SNA_OT_Kkpbody_609D4)
    bpy.utils.unregister_class(SNA_OT_Kksappenddata_59897)
    bpy.utils.unregister_class(SNA_OT_Fixbone_07975)
    bpy.utils.unregister_class(SNA_OT_Setanim_64953)
    bpy.utils.unregister_class(SNA_OT_Phappenddata_81459)
    bpy.utils.unregister_class(SNA_OT_Rgappenddata_Bf1E1)
    bpy.utils.unregister_class(SNA_OT_Character_Saver_42Da3)
    bpy.utils.unregister_class(SNA_PT_SAVE_SKLX_CARD_27F62)
    bpy.utils.unregister_class(SNA_OT_What_Is_A_Sklx_Card_895Df)
    bpy.utils.unregister_class(SNA_PT_SUPPORTERS__ARTISTS_C55A5)
    bpy.utils.unregister_class(SNA_OT_Subs_Two_0850E)
    bpy.utils.unregister_class(SNA_OT_Custom_Semi_A6864)
    bpy.utils.unregister_class(SNA_OT_Sub_002_879A2)
    bpy.utils.unregister_class(SNA_OT_Become_F266B)
    bpy.utils.unregister_class(SNA_OT_Patreon_Restarter_88Dcb)
    bpy.utils.unregister_class(SNA_OT_Discord_Server_E1F55)
    bpy.utils.unregister_class(SNA_OT_Sub_006_E0438)
    bpy.utils.unregister_class(SNA_OT_Sub_007_C99Ea)
    bpy.utils.unregister_class(SNA_OT_Sub_008_43C1A)
    bpy.utils.unregister_class(SNA_OT_Sub_009_F902C)
    bpy.utils.unregister_class(SNA_OT_Sub_010_E9Fb5)
    bpy.utils.unregister_class(SNA_OT_Sub_011_25D52)
    bpy.utils.unregister_class(SNA_OT_Sub_012_73536)
    bpy.utils.unregister_class(SNA_OT_Sub_013_9Ed57)
    bpy.utils.unregister_class(SNA_OT_Sub_014_0C26E)
    bpy.utils.unregister_class(SNA_OT_Sub_015_0Ebd0)
    bpy.utils.unregister_class(SNA_OT_Sub_018_150Aa)
    bpy.utils.unregister_class(SNA_OT_Sub_017_B4953)
    bpy.utils.unregister_class(SNA_OT_Sub_016_1Dcf9)
    bpy.utils.unregister_class(SNA_OT_Sub_003_38Df0)
    bpy.utils.unregister_class(SNA_OT_Gallery_2Defc)
    bpy.utils.unregister_class(SNA_OT_Custom_Jap_Let_0F56E)
    bpy.utils.unregister_class(SNA_OT_Custom_Sora_63A72)
    bpy.utils.unregister_class(SNA_OT_Sub_001_5E1F9)
    bpy.utils.unregister_class(SNA_OT_Sub_004_6Ecc8)
    bpy.utils.unregister_class(SNA_OT_Sub_005_6A346)
    bpy.utils.unregister_class(SNA_OT_Cleaner_3B364)
    bpy.utils.unregister_class(SNA_OT_Fixtex_58Db1)
    bpy.utils.unregister_class(SNA_OT_Multiple_Char_01511)
    bpy.utils.unregister_class(SNA_OT_Lofi_1065C)
    bpy.utils.unregister_class(SNA_PT_SKLXCREATOR_EF7CA)
